/* Device.c generated by valac 0.41.91, the Vala compiler
 * generated from Device.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gee.h>


#define NOISE_TYPE_DEVICE (noise_device_get_type ())
#define NOISE_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE, NoiseDevice))
#define NOISE_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE))
#define NOISE_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NOISE_TYPE_DEVICE, NoiseDeviceIface))

typedef struct _NoiseDevice NoiseDevice;
typedef struct _NoiseDeviceIface NoiseDeviceIface;

#define NOISE_TYPE_LIBRARY (noise_library_get_type ())
#define NOISE_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY, NoiseLibrary))
#define NOISE_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY, NoiseLibraryClass))
#define NOISE_IS_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY))
#define NOISE_IS_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY))
#define NOISE_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY, NoiseLibraryClass))

typedef struct _NoiseLibrary NoiseLibrary;
typedef struct _NoiseLibraryClass NoiseLibraryClass;

#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	NOISE_DEVICE_INITIALIZED_SIGNAL,
	NOISE_DEVICE_DEVICE_UNMOUNTED_SIGNAL,
	NOISE_DEVICE_INFOBAR_MESSAGE_SIGNAL,
	NOISE_DEVICE_NUM_SIGNALS
};
static guint noise_device_signals[NOISE_DEVICE_NUM_SIGNALS] = {0};

struct _NoiseDeviceIface {
	GTypeInterface parent_iface;
	gboolean (*start_initialization) (NoiseDevice* self);
	void (*finish_initialization) (NoiseDevice* self);
	gchar* (*get_content_type) (NoiseDevice* self);
	gchar* (*get_display_name) (NoiseDevice* self);
	gchar* (*get_empty_device_title) (NoiseDevice* self);
	gchar* (*get_empty_device_description) (NoiseDevice* self);
	void (*set_display_name) (NoiseDevice* self, const gchar* name);
	gchar* (*get_fancy_description) (NoiseDevice* self);
	void (*set_mount) (NoiseDevice* self, GMount* mount);
	GMount* (*get_mount) (NoiseDevice* self);
	gchar* (*get_uri) (NoiseDevice* self);
	void (*set_icon) (NoiseDevice* self, GIcon* icon);
	GIcon* (*get_icon) (NoiseDevice* self);
	guint64 (*get_capacity) (NoiseDevice* self);
	gchar* (*get_fancy_capacity) (NoiseDevice* self);
	guint64 (*get_used_space) (NoiseDevice* self);
	guint64 (*get_free_space) (NoiseDevice* self);
	void (*unmount) (NoiseDevice* self);
	void (*eject) (NoiseDevice* self);
	void (*synchronize) (NoiseDevice* self);
	gboolean (*only_use_custom_view) (NoiseDevice* self);
	GtkWidget* (*get_custom_view) (NoiseDevice* self);
	gboolean (*read_only) (NoiseDevice* self);
	NoiseLibrary* (*get_library) (NoiseDevice* self);
	gchar* (*get_unique_identifier) (NoiseDevice* self);
};



GType noise_library_get_type (void) G_GNUC_CONST;
GType noise_device_get_type (void) G_GNUC_CONST;
gboolean noise_device_start_initialization (NoiseDevice* self);
void noise_device_finish_initialization (NoiseDevice* self);
gchar* noise_device_get_content_type (NoiseDevice* self);
gchar* noise_device_get_display_name (NoiseDevice* self);
gchar* noise_device_get_empty_device_title (NoiseDevice* self);
gchar* noise_device_get_empty_device_description (NoiseDevice* self);
void noise_device_set_display_name (NoiseDevice* self,
                                    const gchar* name);
gchar* noise_device_get_fancy_description (NoiseDevice* self);
void noise_device_set_mount (NoiseDevice* self,
                             GMount* mount);
GMount* noise_device_get_mount (NoiseDevice* self);
gchar* noise_device_get_uri (NoiseDevice* self);
void noise_device_set_icon (NoiseDevice* self,
                            GIcon* icon);
GIcon* noise_device_get_icon (NoiseDevice* self);
guint64 noise_device_get_capacity (NoiseDevice* self);
gchar* noise_device_get_fancy_capacity (NoiseDevice* self);
guint64 noise_device_get_used_space (NoiseDevice* self);
guint64 noise_device_get_free_space (NoiseDevice* self);
void noise_device_unmount (NoiseDevice* self);
void noise_device_eject (NoiseDevice* self);
void noise_device_synchronize (NoiseDevice* self);
gboolean noise_device_only_use_custom_view (NoiseDevice* self);
GtkWidget* noise_device_get_custom_view (NoiseDevice* self);
gboolean noise_device_read_only (NoiseDevice* self);
NoiseLibrary* noise_device_get_library (NoiseDevice* self);
GType noise_media_get_type (void) G_GNUC_CONST;
GeeCollection* noise_device_delete_doubles (NoiseDevice* self,
                                            GeeCollection* source_list,
                                            GeeCollection* to_remove);
const gchar* noise_media_get_title (NoiseMedia* self);
const gchar* noise_media_get_album (NoiseMedia* self);
const gchar* noise_media_get_artist (NoiseMedia* self);
gboolean noise_device_will_fit (NoiseDevice* self,
                                GeeCollection* list);
guint64 noise_media_get_file_size (NoiseMedia* self);
gchar* noise_device_get_unique_identifier (NoiseDevice* self);
static gchar* noise_device_real_get_unique_identifier (NoiseDevice* self);
static void g_cclosure_user_marshal_VOID__STRING_ENUM (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);


gboolean
noise_device_start_initialization (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return NOISE_DEVICE_GET_INTERFACE (self)->start_initialization (self);
}


void
noise_device_finish_initialization (NoiseDevice* self)
{
	g_return_if_fail (self != NULL);
	NOISE_DEVICE_GET_INTERFACE (self)->finish_initialization (self);
}


gchar*
noise_device_get_content_type (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_DEVICE_GET_INTERFACE (self)->get_content_type (self);
}


gchar*
noise_device_get_display_name (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_DEVICE_GET_INTERFACE (self)->get_display_name (self);
}


gchar*
noise_device_get_empty_device_title (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_DEVICE_GET_INTERFACE (self)->get_empty_device_title (self);
}


gchar*
noise_device_get_empty_device_description (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_DEVICE_GET_INTERFACE (self)->get_empty_device_description (self);
}


void
noise_device_set_display_name (NoiseDevice* self,
                               const gchar* name)
{
	g_return_if_fail (self != NULL);
	NOISE_DEVICE_GET_INTERFACE (self)->set_display_name (self, name);
}


gchar*
noise_device_get_fancy_description (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_DEVICE_GET_INTERFACE (self)->get_fancy_description (self);
}


void
noise_device_set_mount (NoiseDevice* self,
                        GMount* mount)
{
	g_return_if_fail (self != NULL);
	NOISE_DEVICE_GET_INTERFACE (self)->set_mount (self, mount);
}


GMount*
noise_device_get_mount (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_DEVICE_GET_INTERFACE (self)->get_mount (self);
}


gchar*
noise_device_get_uri (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_DEVICE_GET_INTERFACE (self)->get_uri (self);
}


void
noise_device_set_icon (NoiseDevice* self,
                       GIcon* icon)
{
	g_return_if_fail (self != NULL);
	NOISE_DEVICE_GET_INTERFACE (self)->set_icon (self, icon);
}


GIcon*
noise_device_get_icon (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_DEVICE_GET_INTERFACE (self)->get_icon (self);
}


guint64
noise_device_get_capacity (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, 0ULL);
	return NOISE_DEVICE_GET_INTERFACE (self)->get_capacity (self);
}


gchar*
noise_device_get_fancy_capacity (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_DEVICE_GET_INTERFACE (self)->get_fancy_capacity (self);
}


guint64
noise_device_get_used_space (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, 0ULL);
	return NOISE_DEVICE_GET_INTERFACE (self)->get_used_space (self);
}


guint64
noise_device_get_free_space (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, 0ULL);
	return NOISE_DEVICE_GET_INTERFACE (self)->get_free_space (self);
}


void
noise_device_unmount (NoiseDevice* self)
{
	g_return_if_fail (self != NULL);
	NOISE_DEVICE_GET_INTERFACE (self)->unmount (self);
}


void
noise_device_eject (NoiseDevice* self)
{
	g_return_if_fail (self != NULL);
	NOISE_DEVICE_GET_INTERFACE (self)->eject (self);
}


void
noise_device_synchronize (NoiseDevice* self)
{
	g_return_if_fail (self != NULL);
	NOISE_DEVICE_GET_INTERFACE (self)->synchronize (self);
}


gboolean
noise_device_only_use_custom_view (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return NOISE_DEVICE_GET_INTERFACE (self)->only_use_custom_view (self);
}


GtkWidget*
noise_device_get_custom_view (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_DEVICE_GET_INTERFACE (self)->get_custom_view (self);
}


gboolean
noise_device_read_only (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return NOISE_DEVICE_GET_INTERFACE (self)->read_only (self);
}


NoiseLibrary*
noise_device_get_library (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_DEVICE_GET_INTERFACE (self)->get_library (self);
}


GeeCollection*
noise_device_delete_doubles (NoiseDevice* self,
                             GeeCollection* source_list,
                             GeeCollection* to_remove)
{
	GeeCollection* result = NULL;
	GeeLinkedList* new_list = NULL;
	GeeLinkedList* _tmp0_;
	g_return_val_if_fail (source_list != NULL, NULL);
	g_return_val_if_fail (to_remove != NULL, NULL);
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	new_list = _tmp0_;
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp1_;
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) source_list);
		_m_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			NoiseMedia* _tmp5_;
			_tmp2_ = _m_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _m_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			m = (NoiseMedia*) _tmp4_;
			_tmp5_ = m;
			if (_tmp5_ != NULL) {
				gboolean needed = FALSE;
				gboolean _tmp77_;
				needed = TRUE;
				{
					GeeIterator* _med_it = NULL;
					GeeIterator* _tmp6_;
					_tmp6_ = gee_iterable_iterator ((GeeIterable*) to_remove);
					_med_it = _tmp6_;
					while (TRUE) {
						GeeIterator* _tmp7_;
						NoiseMedia* med = NULL;
						GeeIterator* _tmp8_;
						gpointer _tmp9_;
						gboolean _tmp10_ = FALSE;
						NoiseMedia* _tmp11_;
						_tmp7_ = _med_it;
						if (!gee_iterator_next (_tmp7_)) {
							break;
						}
						_tmp8_ = _med_it;
						_tmp9_ = gee_iterator_get (_tmp8_);
						med = (NoiseMedia*) _tmp9_;
						_tmp11_ = med;
						if (_tmp11_ != NULL) {
							NoiseMedia* _tmp12_;
							const gchar* _tmp13_;
							const gchar* _tmp14_;
							_tmp12_ = med;
							_tmp13_ = noise_media_get_title (_tmp12_);
							_tmp14_ = _tmp13_;
							_tmp10_ = _tmp14_ != NULL;
						} else {
							_tmp10_ = FALSE;
						}
						if (_tmp10_) {
							gboolean _tmp15_ = FALSE;
							NoiseMedia* _tmp16_;
							const gchar* _tmp17_;
							const gchar* _tmp18_;
							_tmp16_ = med;
							_tmp17_ = noise_media_get_album (_tmp16_);
							_tmp18_ = _tmp17_;
							if (_tmp18_ != NULL) {
								NoiseMedia* _tmp19_;
								const gchar* _tmp20_;
								const gchar* _tmp21_;
								_tmp19_ = m;
								_tmp20_ = noise_media_get_album (_tmp19_);
								_tmp21_ = _tmp20_;
								_tmp15_ = _tmp21_ != NULL;
							} else {
								_tmp15_ = FALSE;
							}
							if (_tmp15_) {
								gboolean _tmp22_ = FALSE;
								gboolean _tmp23_ = FALSE;
								NoiseMedia* _tmp24_;
								const gchar* _tmp25_;
								const gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
								NoiseMedia* _tmp29_;
								const gchar* _tmp30_;
								const gchar* _tmp31_;
								gchar* _tmp32_;
								gchar* _tmp33_;
								gboolean _tmp34_;
								_tmp24_ = med;
								_tmp25_ = noise_media_get_title (_tmp24_);
								_tmp26_ = _tmp25_;
								_tmp27_ = g_utf8_strdown (_tmp26_, (gssize) -1);
								_tmp28_ = _tmp27_;
								_tmp29_ = m;
								_tmp30_ = noise_media_get_title (_tmp29_);
								_tmp31_ = _tmp30_;
								_tmp32_ = g_utf8_strdown (_tmp31_, (gssize) -1);
								_tmp33_ = _tmp32_;
								_tmp34_ = g_strcmp0 (_tmp28_, _tmp33_) == 0;
								_g_free0 (_tmp33_);
								_g_free0 (_tmp28_);
								if (_tmp34_) {
									NoiseMedia* _tmp35_;
									const gchar* _tmp36_;
									const gchar* _tmp37_;
									gchar* _tmp38_;
									gchar* _tmp39_;
									NoiseMedia* _tmp40_;
									const gchar* _tmp41_;
									const gchar* _tmp42_;
									gchar* _tmp43_;
									gchar* _tmp44_;
									_tmp35_ = med;
									_tmp36_ = noise_media_get_artist (_tmp35_);
									_tmp37_ = _tmp36_;
									_tmp38_ = g_utf8_strdown (_tmp37_, (gssize) -1);
									_tmp39_ = _tmp38_;
									_tmp40_ = m;
									_tmp41_ = noise_media_get_artist (_tmp40_);
									_tmp42_ = _tmp41_;
									_tmp43_ = g_utf8_strdown (_tmp42_, (gssize) -1);
									_tmp44_ = _tmp43_;
									_tmp23_ = g_strcmp0 (_tmp39_, _tmp44_) == 0;
									_g_free0 (_tmp44_);
									_g_free0 (_tmp39_);
								} else {
									_tmp23_ = FALSE;
								}
								if (_tmp23_) {
									NoiseMedia* _tmp45_;
									const gchar* _tmp46_;
									const gchar* _tmp47_;
									gchar* _tmp48_;
									gchar* _tmp49_;
									NoiseMedia* _tmp50_;
									const gchar* _tmp51_;
									const gchar* _tmp52_;
									gchar* _tmp53_;
									gchar* _tmp54_;
									_tmp45_ = med;
									_tmp46_ = noise_media_get_album (_tmp45_);
									_tmp47_ = _tmp46_;
									_tmp48_ = g_utf8_strdown (_tmp47_, (gssize) -1);
									_tmp49_ = _tmp48_;
									_tmp50_ = m;
									_tmp51_ = noise_media_get_album (_tmp50_);
									_tmp52_ = _tmp51_;
									_tmp53_ = g_utf8_strdown (_tmp52_, (gssize) -1);
									_tmp54_ = _tmp53_;
									_tmp22_ = g_strcmp0 (_tmp49_, _tmp54_) == 0;
									_g_free0 (_tmp54_);
									_g_free0 (_tmp49_);
								} else {
									_tmp22_ = FALSE;
								}
								if (_tmp22_) {
									needed = FALSE;
									_g_object_unref0 (med);
									break;
								}
							} else {
								gboolean _tmp55_ = FALSE;
								NoiseMedia* _tmp56_;
								const gchar* _tmp57_;
								const gchar* _tmp58_;
								gchar* _tmp59_;
								gchar* _tmp60_;
								NoiseMedia* _tmp61_;
								const gchar* _tmp62_;
								const gchar* _tmp63_;
								gchar* _tmp64_;
								gchar* _tmp65_;
								gboolean _tmp66_;
								_tmp56_ = med;
								_tmp57_ = noise_media_get_title (_tmp56_);
								_tmp58_ = _tmp57_;
								_tmp59_ = g_utf8_strdown (_tmp58_, (gssize) -1);
								_tmp60_ = _tmp59_;
								_tmp61_ = m;
								_tmp62_ = noise_media_get_title (_tmp61_);
								_tmp63_ = _tmp62_;
								_tmp64_ = g_utf8_strdown (_tmp63_, (gssize) -1);
								_tmp65_ = _tmp64_;
								_tmp66_ = g_strcmp0 (_tmp60_, _tmp65_) == 0;
								_g_free0 (_tmp65_);
								_g_free0 (_tmp60_);
								if (_tmp66_) {
									NoiseMedia* _tmp67_;
									const gchar* _tmp68_;
									const gchar* _tmp69_;
									gchar* _tmp70_;
									gchar* _tmp71_;
									NoiseMedia* _tmp72_;
									const gchar* _tmp73_;
									const gchar* _tmp74_;
									gchar* _tmp75_;
									gchar* _tmp76_;
									_tmp67_ = med;
									_tmp68_ = noise_media_get_artist (_tmp67_);
									_tmp69_ = _tmp68_;
									_tmp70_ = g_utf8_strdown (_tmp69_, (gssize) -1);
									_tmp71_ = _tmp70_;
									_tmp72_ = m;
									_tmp73_ = noise_media_get_artist (_tmp72_);
									_tmp74_ = _tmp73_;
									_tmp75_ = g_utf8_strdown (_tmp74_, (gssize) -1);
									_tmp76_ = _tmp75_;
									_tmp55_ = g_strcmp0 (_tmp71_, _tmp76_) == 0;
									_g_free0 (_tmp76_);
									_g_free0 (_tmp71_);
								} else {
									_tmp55_ = FALSE;
								}
								if (_tmp55_) {
									needed = FALSE;
									_g_object_unref0 (med);
									break;
								}
							}
						}
						_g_object_unref0 (med);
					}
					_g_object_unref0 (_med_it);
				}
				_tmp77_ = needed;
				if (_tmp77_ == TRUE) {
					GeeLinkedList* _tmp78_;
					NoiseMedia* _tmp79_;
					_tmp78_ = new_list;
					_tmp79_ = m;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp78_, _tmp79_);
				}
			}
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	result = (GeeCollection*) new_list;
	return result;
}


gboolean
noise_device_will_fit (NoiseDevice* self,
                       GeeCollection* list)
{
	gboolean result = FALSE;
	guint64 list_size = 0ULL;
	guint64 _tmp8_;
	g_return_val_if_fail (list != NULL, FALSE);
	list_size = (guint64) 0;
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp0_;
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) list);
		_m_it = _tmp0_;
		while (TRUE) {
			GeeIterator* _tmp1_;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			guint64 _tmp4_;
			NoiseMedia* _tmp5_;
			guint64 _tmp6_;
			guint64 _tmp7_;
			_tmp1_ = _m_it;
			if (!gee_iterator_next (_tmp1_)) {
				break;
			}
			_tmp2_ = _m_it;
			_tmp3_ = gee_iterator_get (_tmp2_);
			m = (NoiseMedia*) _tmp3_;
			_tmp4_ = list_size;
			_tmp5_ = m;
			_tmp6_ = noise_media_get_file_size (_tmp5_);
			_tmp7_ = _tmp6_;
			list_size = _tmp4_ + _tmp7_;
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	_tmp8_ = list_size;
	result = noise_device_get_capacity (self) > _tmp8_;
	return result;
}


static gchar*
noise_device_real_get_unique_identifier (NoiseDevice* self)
{
	gchar* result = NULL;
	GMount* m = NULL;
	GMount* _tmp0_;
	GMount* _tmp1_;
	_tmp0_ = noise_device_get_mount (self);
	m = _tmp0_;
	_tmp1_ = m;
	if (_tmp1_ != NULL) {
		gchar* uuid = NULL;
		GMount* _tmp2_;
		gchar* _tmp3_;
		GFile* root = NULL;
		GMount* _tmp4_;
		GFile* _tmp5_;
		gchar* rv = NULL;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gboolean _tmp8_ = FALSE;
		GFile* _tmp9_;
		gboolean _tmp18_ = FALSE;
		const gchar* _tmp19_;
		_tmp2_ = m;
		_tmp3_ = g_mount_get_uuid (_tmp2_);
		uuid = _tmp3_;
		_tmp4_ = m;
		_tmp5_ = g_mount_get_root (_tmp4_);
		root = _tmp5_;
		_tmp6_ = g_strdup ("");
		rv = _tmp6_;
		_tmp7_ = uuid;
		g_debug ("Device.vala:105: uuid: %s\n", _tmp7_);
		_tmp9_ = root;
		if (_tmp9_ != NULL) {
			GFile* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			_tmp10_ = root;
			_tmp11_ = g_file_get_uri (_tmp10_);
			_tmp12_ = _tmp11_;
			_tmp8_ = _tmp12_ != NULL;
			_g_free0 (_tmp12_);
		} else {
			_tmp8_ = FALSE;
		}
		if (_tmp8_) {
			const gchar* _tmp13_;
			GFile* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			_tmp13_ = rv;
			_tmp14_ = root;
			_tmp15_ = g_file_get_uri (_tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = g_strconcat (_tmp13_, _tmp16_, NULL);
			_g_free0 (rv);
			rv = _tmp17_;
			_g_free0 (_tmp16_);
		}
		_tmp19_ = uuid;
		if (_tmp19_ != NULL) {
			const gchar* _tmp20_;
			_tmp20_ = uuid;
			_tmp18_ = g_strcmp0 (_tmp20_, "") != 0;
		} else {
			_tmp18_ = FALSE;
		}
		if (_tmp18_) {
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			_tmp21_ = rv;
			_tmp22_ = uuid;
			_tmp23_ = g_strconcat ("/", _tmp22_, NULL);
			_tmp24_ = _tmp23_;
			_tmp25_ = g_strconcat (_tmp21_, _tmp24_, NULL);
			_g_free0 (rv);
			rv = _tmp25_;
			_g_free0 (_tmp24_);
		}
		result = rv;
		_g_object_unref0 (root);
		_g_free0 (uuid);
		_g_object_unref0 (m);
		return result;
	} else {
		gchar* _tmp26_;
		_tmp26_ = noise_device_get_uri (self);
		result = _tmp26_;
		_g_object_unref0 (m);
		return result;
	}
	_g_object_unref0 (m);
}


gchar*
noise_device_get_unique_identifier (NoiseDevice* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_DEVICE_GET_INTERFACE (self)->get_unique_identifier (self);
}


static void
g_cclosure_user_marshal_VOID__STRING_ENUM (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_ENUM) (gpointer data1, const char* arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_ENUM) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_enum (param_values + 2), data2);
}


static void
noise_device_default_init (NoiseDeviceIface * iface)
{
	noise_device_signals[NOISE_DEVICE_INITIALIZED_SIGNAL] = g_signal_new ("initialized", NOISE_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_DEVICE);
	noise_device_signals[NOISE_DEVICE_DEVICE_UNMOUNTED_SIGNAL] = g_signal_new ("device-unmounted", NOISE_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	noise_device_signals[NOISE_DEVICE_INFOBAR_MESSAGE_SIGNAL] = g_signal_new ("infobar-message", NOISE_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_ENUM, G_TYPE_NONE, 2, G_TYPE_STRING, gtk_message_type_get_type ());
	iface->get_unique_identifier = noise_device_real_get_unique_identifier;
}


GType
noise_device_get_type (void)
{
	static volatile gsize noise_device_type_id__volatile = 0;
	if (g_once_init_enter (&noise_device_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseDeviceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_device_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType noise_device_type_id;
		noise_device_type_id = g_type_register_static (G_TYPE_INTERFACE, "NoiseDevice", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (noise_device_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&noise_device_type_id__volatile, noise_device_type_id);
	}
	return noise_device_type_id__volatile;
}



