/* Pipeline.c generated by valac 0.41.91, the Vala compiler
 * generated from Pipeline.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include <gst/gst.h>


#define NOISE_TYPE_PIPELINE (noise_pipeline_get_type ())
#define NOISE_PIPELINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PIPELINE, NoisePipeline))
#define NOISE_PIPELINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PIPELINE, NoisePipelineClass))
#define NOISE_IS_PIPELINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PIPELINE))
#define NOISE_IS_PIPELINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PIPELINE))
#define NOISE_PIPELINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PIPELINE, NoisePipelineClass))

typedef struct _NoisePipeline NoisePipeline;
typedef struct _NoisePipelineClass NoisePipelineClass;
typedef struct _NoisePipelinePrivate NoisePipelinePrivate;

#define NOISE_TYPE_EQUALIZER (noise_equalizer_get_type ())
#define NOISE_EQUALIZER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_EQUALIZER, NoiseEqualizer))
#define NOISE_EQUALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_EQUALIZER, NoiseEqualizerClass))
#define NOISE_IS_EQUALIZER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_EQUALIZER))
#define NOISE_IS_EQUALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_EQUALIZER))
#define NOISE_EQUALIZER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_EQUALIZER, NoiseEqualizerClass))

typedef struct _NoiseEqualizer NoiseEqualizer;
typedef struct _NoiseEqualizerClass NoiseEqualizerClass;
enum  {
	NOISE_PIPELINE_0_PROPERTY,
	NOISE_PIPELINE_NUM_PROPERTIES
};
static GParamSpec* noise_pipeline_properties[NOISE_PIPELINE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _NoiseEqualizerPrivate NoiseEqualizerPrivate;

struct _NoisePipeline {
	GObject parent_instance;
	NoisePipelinePrivate * priv;
	GstPipeline* pipe;
	NoiseEqualizer* eq;
	GstBus* bus;
	GstPad* pad;
	GstElement* audiosink;
	GstElement* audiosinkqueue;
	GstElement* eq_audioconvert;
	GstElement* eq_audioconvert2;
	GstElement* playbin;
	GstElement* audiotee;
	GstElement* audiobin;
	GstElement* preamp;
};

struct _NoisePipelineClass {
	GObjectClass parent_class;
};

struct _NoiseEqualizer {
	GObject parent_instance;
	NoiseEqualizerPrivate * priv;
	GstElement* element;
};

struct _NoiseEqualizerClass {
	GObjectClass parent_class;
};


static gpointer noise_pipeline_parent_class = NULL;

GType noise_pipeline_get_type (void) G_GNUC_CONST;
GType noise_equalizer_get_type (void) G_GNUC_CONST;
NoisePipeline* noise_pipeline_new (void);
NoisePipeline* noise_pipeline_construct (GType object_type);
NoiseEqualizer* noise_equalizer_new (void);
NoiseEqualizer* noise_equalizer_construct (GType object_type);
void noise_pipeline_enableEqualizer (NoisePipeline* self);
void noise_pipeline_disableEqualizer (NoisePipeline* self);
static void noise_pipeline_finalize (GObject * obj);


NoisePipeline*
noise_pipeline_construct (GType object_type)
{
	NoisePipeline * self = NULL;
	GstPipeline* _tmp0_;
	GstElement* _tmp1_;
	GstElement* _tmp2_;
	GstBin* _tmp3_;
	GstElement* _tmp4_;
	GstElement* _tmp5_;
	NoiseEqualizer* _tmp6_;
	NoiseEqualizer* _tmp7_;
	GstElement* _tmp8_;
	GstElement* _tmp18_;
	GstElement* _tmp19_;
	GstElement* _tmp20_;
	GstElement* _tmp21_;
	GstElement* _tmp22_;
	GstElement* _tmp23_;
	GstPad* _tmp24_;
	GstPad* _tmp25_;
	GstGhostPad* _tmp26_;
	GstGhostPad* _tmp27_;
	NoiseEqualizer* _tmp28_;
	GstElement* _tmp29_;
	GstElement* _tmp39_;
	GstElement* _tmp40_;
	GstElement* _tmp41_;
	GstBus* _tmp42_;
	GstPad* sinkpad = NULL;
	GstElement* _tmp43_;
	GstPad* _tmp44_;
	GstElement* _tmp45_;
	GstPad* _tmp46_;
	GstElement* _tmp47_;
	GstPad* _tmp48_;
	GstPad* _tmp49_;
	self = (NoisePipeline*) g_object_new (object_type, NULL);
	_tmp0_ = (GstPipeline*) gst_pipeline_new ("pipeline");
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->pipe);
	self->pipe = _tmp0_;
	_tmp1_ = gst_element_factory_make ("playbin", "play");
	if (_tmp1_ != NULL) {
		g_object_ref_sink (_tmp1_);
	}
	_g_object_unref0 (self->playbin);
	self->playbin = _tmp1_;
	_tmp2_ = gst_element_factory_make ("autoaudiosink", "audio-sink");
	if (_tmp2_ != NULL) {
		g_object_ref_sink (_tmp2_);
	}
	_g_object_unref0 (self->audiosink);
	self->audiosink = _tmp2_;
	_tmp3_ = (GstBin*) gst_bin_new ("audiobin");
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->audiobin);
	self->audiobin = (GstElement*) _tmp3_;
	_tmp4_ = gst_element_factory_make ("tee", NULL);
	if (_tmp4_ != NULL) {
		g_object_ref_sink (_tmp4_);
	}
	_g_object_unref0 (self->audiotee);
	self->audiotee = _tmp4_;
	_tmp5_ = gst_element_factory_make ("queue", NULL);
	if (_tmp5_ != NULL) {
		g_object_ref_sink (_tmp5_);
	}
	_g_object_unref0 (self->audiosinkqueue);
	self->audiosinkqueue = _tmp5_;
	_tmp6_ = noise_equalizer_new ();
	_g_object_unref0 (self->eq);
	self->eq = _tmp6_;
	_tmp7_ = self->eq;
	_tmp8_ = _tmp7_->element;
	if (_tmp8_ != NULL) {
		GstElement* _tmp9_;
		GstElement* _tmp10_;
		GstElement* _tmp11_;
		GstElement* _tmp12_;
		NoiseEqualizer* _tmp13_;
		GstElement* _tmp14_;
		GstElement* _tmp15_;
		GstElement* _tmp16_;
		GstElement* _tmp17_;
		_tmp9_ = gst_element_factory_make ("audioconvert", NULL);
		if (_tmp9_ != NULL) {
			g_object_ref_sink (_tmp9_);
		}
		_g_object_unref0 (self->eq_audioconvert);
		self->eq_audioconvert = _tmp9_;
		_tmp10_ = gst_element_factory_make ("audioconvert", NULL);
		if (_tmp10_ != NULL) {
			g_object_ref_sink (_tmp10_);
		}
		_g_object_unref0 (self->eq_audioconvert2);
		self->eq_audioconvert2 = _tmp10_;
		_tmp11_ = gst_element_factory_make ("volume", "preamp");
		if (_tmp11_ != NULL) {
			g_object_ref_sink (_tmp11_);
		}
		_g_object_unref0 (self->preamp);
		self->preamp = _tmp11_;
		_tmp12_ = self->audiobin;
		_tmp13_ = self->eq;
		_tmp14_ = _tmp13_->element;
		_tmp15_ = self->eq_audioconvert;
		_tmp16_ = self->eq_audioconvert2;
		_tmp17_ = self->preamp;
		gst_bin_add_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gst_bin_get_type (), GstBin), _tmp14_, _tmp15_, _tmp16_, _tmp17_, NULL);
	}
	_tmp18_ = self->audiobin;
	_tmp19_ = self->audiotee;
	_tmp20_ = self->audiosinkqueue;
	_tmp21_ = self->audiosink;
	gst_bin_add_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gst_bin_get_type (), GstBin), _tmp19_, _tmp20_, _tmp21_, NULL);
	_tmp22_ = self->audiobin;
	_tmp23_ = self->audiotee;
	_tmp24_ = gst_element_get_static_pad (_tmp23_, "sink");
	_tmp25_ = _tmp24_;
	_tmp26_ = (GstGhostPad*) gst_ghost_pad_new ("sink", _tmp25_);
	g_object_ref_sink (_tmp26_);
	_tmp27_ = _tmp26_;
	gst_element_add_pad (_tmp22_, (GstPad*) _tmp27_);
	_g_object_unref0 (_tmp27_);
	_g_object_unref0 (_tmp25_);
	_tmp28_ = self->eq;
	_tmp29_ = _tmp28_->element;
	if (_tmp29_ != NULL) {
		GstElement* _tmp30_;
		GstElement* _tmp31_;
		GstElement* _tmp32_;
		NoiseEqualizer* _tmp33_;
		GstElement* _tmp34_;
		GstElement* _tmp35_;
		GstElement* _tmp36_;
		_tmp30_ = self->audiosinkqueue;
		_tmp31_ = self->eq_audioconvert;
		_tmp32_ = self->preamp;
		_tmp33_ = self->eq;
		_tmp34_ = _tmp33_->element;
		_tmp35_ = self->eq_audioconvert2;
		_tmp36_ = self->audiosink;
		gst_element_link_many (_tmp30_, _tmp31_, _tmp32_, _tmp34_, _tmp35_, _tmp36_, NULL);
	} else {
		GstElement* _tmp37_;
		GstElement* _tmp38_;
		_tmp37_ = self->audiosinkqueue;
		_tmp38_ = self->audiosink;
		gst_element_link_many (_tmp37_, _tmp38_, NULL);
	}
	_tmp39_ = self->playbin;
	_tmp40_ = self->audiobin;
	g_object_set ((GObject*) _tmp39_, "audio-sink", _tmp40_, NULL);
	_tmp41_ = self->playbin;
	_tmp42_ = gst_element_get_bus (_tmp41_);
	_g_object_unref0 (self->bus);
	self->bus = _tmp42_;
	_tmp43_ = self->audiosinkqueue;
	_tmp44_ = gst_element_get_static_pad (_tmp43_, "sink");
	sinkpad = _tmp44_;
	_tmp45_ = self->audiotee;
	_tmp46_ = gst_element_get_request_pad (_tmp45_, "src_%u");
	_g_object_unref0 (self->pad);
	self->pad = _tmp46_;
	_tmp47_ = self->audiotee;
	_tmp48_ = self->pad;
	g_object_set ((GObject*) _tmp47_, "alloc-pad", _tmp48_, NULL);
	_tmp49_ = self->pad;
	gst_pad_link_full (_tmp49_, sinkpad, GST_PAD_LINK_CHECK_DEFAULT);
	_g_object_unref0 (sinkpad);
	return self;
}


NoisePipeline*
noise_pipeline_new (void)
{
	return noise_pipeline_construct (NOISE_TYPE_PIPELINE);
}


void
noise_pipeline_enableEqualizer (NoisePipeline* self)
{
	NoiseEqualizer* _tmp0_;
	GstElement* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->eq;
	_tmp1_ = _tmp0_->element;
	if (_tmp1_ != NULL) {
		GstElement* _tmp2_;
		GstElement* _tmp3_;
		GstElement* _tmp4_;
		GstElement* _tmp5_;
		GstElement* _tmp6_;
		NoiseEqualizer* _tmp7_;
		GstElement* _tmp8_;
		GstElement* _tmp9_;
		GstElement* _tmp10_;
		_tmp2_ = self->audiosinkqueue;
		_tmp3_ = self->audiosink;
		gst_element_unlink (_tmp2_, _tmp3_);
		_tmp4_ = self->audiosinkqueue;
		_tmp5_ = self->eq_audioconvert;
		_tmp6_ = self->preamp;
		_tmp7_ = self->eq;
		_tmp8_ = _tmp7_->element;
		_tmp9_ = self->eq_audioconvert2;
		_tmp10_ = self->audiosink;
		gst_element_link_many (_tmp4_, _tmp5_, _tmp6_, _tmp8_, _tmp9_, _tmp10_, NULL);
	}
}


void
noise_pipeline_disableEqualizer (NoisePipeline* self)
{
	NoiseEqualizer* _tmp0_;
	GstElement* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->eq;
	_tmp1_ = _tmp0_->element;
	if (_tmp1_ != NULL) {
		GstElement* _tmp2_;
		GstElement* _tmp3_;
		GstElement* _tmp4_;
		GstElement* _tmp5_;
		GstElement* _tmp6_;
		NoiseEqualizer* _tmp7_;
		GstElement* _tmp8_;
		GstElement* _tmp9_;
		GstElement* _tmp10_;
		GstElement* _tmp11_;
		GstElement* _tmp12_;
		GstElement* _tmp13_;
		GstElement* _tmp14_;
		_tmp2_ = self->audiosinkqueue;
		_tmp3_ = self->eq_audioconvert;
		gst_element_unlink (_tmp2_, _tmp3_);
		_tmp4_ = self->audiosinkqueue;
		_tmp5_ = self->preamp;
		gst_element_unlink (_tmp4_, _tmp5_);
		_tmp6_ = self->audiosinkqueue;
		_tmp7_ = self->eq;
		_tmp8_ = _tmp7_->element;
		gst_element_unlink (_tmp6_, _tmp8_);
		_tmp9_ = self->audiosinkqueue;
		_tmp10_ = self->eq_audioconvert2;
		gst_element_unlink (_tmp9_, _tmp10_);
		_tmp11_ = self->audiosinkqueue;
		_tmp12_ = self->audiosink;
		gst_element_unlink (_tmp11_, _tmp12_);
		_tmp13_ = self->audiosinkqueue;
		_tmp14_ = self->audiosink;
		gst_element_link_many (_tmp13_, _tmp14_, NULL);
	}
}


static void
noise_pipeline_class_init (NoisePipelineClass * klass)
{
	noise_pipeline_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = noise_pipeline_finalize;
}


static void
noise_pipeline_instance_init (NoisePipeline * self)
{
}


static void
noise_pipeline_finalize (GObject * obj)
{
	NoisePipeline * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PIPELINE, NoisePipeline);
	_g_object_unref0 (self->pipe);
	_g_object_unref0 (self->eq);
	_g_object_unref0 (self->bus);
	_g_object_unref0 (self->pad);
	_g_object_unref0 (self->audiosink);
	_g_object_unref0 (self->audiosinkqueue);
	_g_object_unref0 (self->eq_audioconvert);
	_g_object_unref0 (self->eq_audioconvert2);
	_g_object_unref0 (self->playbin);
	_g_object_unref0 (self->audiotee);
	_g_object_unref0 (self->audiobin);
	_g_object_unref0 (self->preamp);
	G_OBJECT_CLASS (noise_pipeline_parent_class)->finalize (obj);
}


GType
noise_pipeline_get_type (void)
{
	static volatile gsize noise_pipeline_type_id__volatile = 0;
	if (g_once_init_enter (&noise_pipeline_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePipelineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_pipeline_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePipeline), 0, (GInstanceInitFunc) noise_pipeline_instance_init, NULL };
		GType noise_pipeline_type_id;
		noise_pipeline_type_id = g_type_register_static (G_TYPE_OBJECT, "NoisePipeline", &g_define_type_info, 0);
		g_once_init_leave (&noise_pipeline_type_id__volatile, noise_pipeline_type_id);
	}
	return noise_pipeline_type_id__volatile;
}



