/* Playback.c generated by valac 0.41.91, the Vala compiler
 * generated from Playback.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <float.h>
#include <math.h>


#define NOISE_TYPE_PLAYBACK (noise_playback_get_type ())
#define NOISE_PLAYBACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYBACK, NoisePlayback))
#define NOISE_IS_PLAYBACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYBACK))
#define NOISE_PLAYBACK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NOISE_TYPE_PLAYBACK, NoisePlaybackIface))

typedef struct _NoisePlayback NoisePlayback;
typedef struct _NoisePlaybackIface NoisePlaybackIface;

#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;
enum  {
	NOISE_PLAYBACK_END_OF_STREAM_SIGNAL,
	NOISE_PLAYBACK_CURRENT_POSITION_UPDATE_SIGNAL,
	NOISE_PLAYBACK_MEDIA_NOT_FOUND_SIGNAL,
	NOISE_PLAYBACK_ERROR_OCCURED_SIGNAL,
	NOISE_PLAYBACK_NUM_SIGNALS
};
static guint noise_playback_signals[NOISE_PLAYBACK_NUM_SIGNALS] = {0};

struct _NoisePlaybackIface {
	GTypeInterface parent_iface;
	GeeCollection* (*get_supported_uri) (NoisePlayback* self);
	void (*play) (NoisePlayback* self);
	void (*pause) (NoisePlayback* self);
	void (*set_state) (NoisePlayback* self, GstState s);
	void (*set_media) (NoisePlayback* self, NoiseMedia* media);
	void (*set_position) (NoisePlayback* self, gint64 pos);
	gint64 (*get_position) (NoisePlayback* self);
	gint64 (*get_duration) (NoisePlayback* self);
	void (*set_volume) (NoisePlayback* self, gdouble val);
	gdouble (*get_volume) (NoisePlayback* self);
	gboolean (*update_position) (NoisePlayback* self);
	void (*enable_equalizer) (NoisePlayback* self);
	void (*disable_equalizer) (NoisePlayback* self);
	void (*set_equalizer_gain) (NoisePlayback* self, gint index, gint val);
};



GType noise_media_get_type (void) G_GNUC_CONST;
GType noise_playback_get_type (void) G_GNUC_CONST;
GeeCollection* noise_playback_get_supported_uri (NoisePlayback* self);
void noise_playback_play (NoisePlayback* self);
void noise_playback_pause (NoisePlayback* self);
void noise_playback_set_state (NoisePlayback* self,
                               GstState s);
void noise_playback_set_media (NoisePlayback* self,
                               NoiseMedia* media);
void noise_playback_set_position (NoisePlayback* self,
                                  gint64 pos);
gint64 noise_playback_get_position (NoisePlayback* self);
gint64 noise_playback_get_duration (NoisePlayback* self);
void noise_playback_set_volume (NoisePlayback* self,
                                gdouble val);
gdouble noise_playback_get_volume (NoisePlayback* self);
gboolean noise_playback_update_position (NoisePlayback* self);
void noise_playback_enable_equalizer (NoisePlayback* self);
void noise_playback_disable_equalizer (NoisePlayback* self);
void noise_playback_set_equalizer_gain (NoisePlayback* self,
                                        gint index,
                                        gint val);
static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data);


GeeCollection*
noise_playback_get_supported_uri (NoisePlayback* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_PLAYBACK_GET_INTERFACE (self)->get_supported_uri (self);
}


void
noise_playback_play (NoisePlayback* self)
{
	g_return_if_fail (self != NULL);
	NOISE_PLAYBACK_GET_INTERFACE (self)->play (self);
}


void
noise_playback_pause (NoisePlayback* self)
{
	g_return_if_fail (self != NULL);
	NOISE_PLAYBACK_GET_INTERFACE (self)->pause (self);
}


void
noise_playback_set_state (NoisePlayback* self,
                          GstState s)
{
	g_return_if_fail (self != NULL);
	NOISE_PLAYBACK_GET_INTERFACE (self)->set_state (self, s);
}


void
noise_playback_set_media (NoisePlayback* self,
                          NoiseMedia* media)
{
	g_return_if_fail (self != NULL);
	NOISE_PLAYBACK_GET_INTERFACE (self)->set_media (self, media);
}


void
noise_playback_set_position (NoisePlayback* self,
                             gint64 pos)
{
	g_return_if_fail (self != NULL);
	NOISE_PLAYBACK_GET_INTERFACE (self)->set_position (self, pos);
}


gint64
noise_playback_get_position (NoisePlayback* self)
{
	g_return_val_if_fail (self != NULL, 0LL);
	return NOISE_PLAYBACK_GET_INTERFACE (self)->get_position (self);
}


gint64
noise_playback_get_duration (NoisePlayback* self)
{
	g_return_val_if_fail (self != NULL, 0LL);
	return NOISE_PLAYBACK_GET_INTERFACE (self)->get_duration (self);
}


void
noise_playback_set_volume (NoisePlayback* self,
                           gdouble val)
{
	g_return_if_fail (self != NULL);
	NOISE_PLAYBACK_GET_INTERFACE (self)->set_volume (self, val);
}


gdouble
noise_playback_get_volume (NoisePlayback* self)
{
	g_return_val_if_fail (self != NULL, 0.0);
	return NOISE_PLAYBACK_GET_INTERFACE (self)->get_volume (self);
}


gboolean
noise_playback_update_position (NoisePlayback* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return NOISE_PLAYBACK_GET_INTERFACE (self)->update_position (self);
}


void
noise_playback_enable_equalizer (NoisePlayback* self)
{
	g_return_if_fail (self != NULL);
	NOISE_PLAYBACK_GET_INTERFACE (self)->enable_equalizer (self);
}


void
noise_playback_disable_equalizer (NoisePlayback* self)
{
	g_return_if_fail (self != NULL);
	NOISE_PLAYBACK_GET_INTERFACE (self)->disable_equalizer (self);
}


void
noise_playback_set_equalizer_gain (NoisePlayback* self,
                                   gint index,
                                   gint val)
{
	g_return_if_fail (self != NULL);
	NOISE_PLAYBACK_GET_INTERFACE (self)->set_equalizer_gain (self, index, val);
}


static void
g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                     GValue * return_value,
                                     guint n_param_values,
                                     const GValue * param_values,
                                     gpointer invocation_hint,
                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int64 (param_values + 1), data2);
}


static void
noise_playback_default_init (NoisePlaybackIface * iface)
{
	noise_playback_signals[NOISE_PLAYBACK_END_OF_STREAM_SIGNAL] = g_signal_new ("end-of-stream", NOISE_TYPE_PLAYBACK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	noise_playback_signals[NOISE_PLAYBACK_CURRENT_POSITION_UPDATE_SIGNAL] = g_signal_new ("current-position-update", NOISE_TYPE_PLAYBACK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
	noise_playback_signals[NOISE_PLAYBACK_MEDIA_NOT_FOUND_SIGNAL] = g_signal_new ("media-not-found", NOISE_TYPE_PLAYBACK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	noise_playback_signals[NOISE_PLAYBACK_ERROR_OCCURED_SIGNAL] = g_signal_new ("error-occured", NOISE_TYPE_PLAYBACK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


GType
noise_playback_get_type (void)
{
	static volatile gsize noise_playback_type_id__volatile = 0;
	if (g_once_init_enter (&noise_playback_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePlaybackIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_playback_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType noise_playback_type_id;
		noise_playback_type_id = g_type_register_static (G_TYPE_INTERFACE, "NoisePlayback", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (noise_playback_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&noise_playback_type_id__volatile, noise_playback_type_id);
	}
	return noise_playback_type_id__volatile;
}



