/* Media.c generated by valac 0.41.91, the Vala compiler
 * generated from Media.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>


#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;
typedef struct _NoiseMediaPrivate NoiseMediaPrivate;

#define NOISE_TYPE_ALBUM (noise_album_get_type ())
#define NOISE_ALBUM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_ALBUM, NoiseAlbum))
#define NOISE_ALBUM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_ALBUM, NoiseAlbumClass))
#define NOISE_IS_ALBUM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_ALBUM))
#define NOISE_IS_ALBUM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_ALBUM))
#define NOISE_ALBUM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_ALBUM, NoiseAlbumClass))

typedef struct _NoiseAlbum NoiseAlbum;
typedef struct _NoiseAlbumClass NoiseAlbumClass;
enum  {
	NOISE_MEDIA_0_PROPERTY,
	NOISE_MEDIA_ROWID_PROPERTY,
	NOISE_MEDIA_URI_PROPERTY,
	NOISE_MEDIA_FILE_SIZE_PROPERTY,
	NOISE_MEDIA_FILE_EXISTS_PROPERTY,
	NOISE_MEDIA_FILE_PROPERTY,
	NOISE_MEDIA_IS_PREVIEW_PROPERTY,
	NOISE_MEDIA_IS_TEMPORARY_PROPERTY,
	NOISE_MEDIA_LOCATION_UNKNOWN_PROPERTY,
	NOISE_MEDIA_HAS_EMBEDDED_PROPERTY,
	NOISE_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY,
	NOISE_MEDIA_SHOW_INDICATOR_PROPERTY,
	NOISE_MEDIA_TITLE_PROPERTY,
	NOISE_MEDIA_TRACK_PROPERTY,
	NOISE_MEDIA_TRACK_COUNT_PROPERTY,
	NOISE_MEDIA_COMPOSER_PROPERTY,
	NOISE_MEDIA_ARTIST_PROPERTY,
	NOISE_MEDIA_ALBUM_ARTIST_PROPERTY,
	NOISE_MEDIA_ALBUM_PROPERTY,
	NOISE_MEDIA_ALBUM_NUMBER_PROPERTY,
	NOISE_MEDIA_ALBUM_COUNT_PROPERTY,
	NOISE_MEDIA_ALBUM_INFO_PROPERTY,
	NOISE_MEDIA_GROUPING_PROPERTY,
	NOISE_MEDIA_GENRE_PROPERTY,
	NOISE_MEDIA_COMMENT_PROPERTY,
	NOISE_MEDIA_LYRICS_PROPERTY,
	NOISE_MEDIA_YEAR_PROPERTY,
	NOISE_MEDIA_BITRATE_PROPERTY,
	NOISE_MEDIA_BPM_PROPERTY,
	NOISE_MEDIA_SAMPLERATE_PROPERTY,
	NOISE_MEDIA_LENGTH_PROPERTY,
	NOISE_MEDIA_RATING_PROPERTY,
	NOISE_MEDIA_PLAY_COUNT_PROPERTY,
	NOISE_MEDIA_SKIP_COUNT_PROPERTY,
	NOISE_MEDIA_DATE_ADDED_PROPERTY,
	NOISE_MEDIA_LAST_PLAYED_PROPERTY,
	NOISE_MEDIA_LAST_MODIFIED_PROPERTY,
	NOISE_MEDIA_RESUME_POS_PROPERTY,
	NOISE_MEDIA_SHOW_PROPERTY,
	NOISE_MEDIA_NUM_PROPERTIES
};
static GParamSpec* noise_media_properties[NOISE_MEDIA_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NoiseMedia {
	GObject parent_instance;
	NoiseMediaPrivate * priv;
	guint _rating;
};

struct _NoiseMediaClass {
	GObjectClass parent_class;
	gchar* (*get_uri) (NoiseMedia* self);
	void (*set_uri) (NoiseMedia* self, const gchar* value);
	guint64 (*get_file_size) (NoiseMedia* self);
	void (*set_file_size) (NoiseMedia* self, guint64 value);
	gboolean (*get_file_exists) (NoiseMedia* self);
	GFile* (*get_file) (NoiseMedia* self);
	void (*set_file) (NoiseMedia* self, GFile* value);
	gboolean (*get_isPreview) (NoiseMedia* self);
	void (*set_isPreview) (NoiseMedia* self, gboolean value);
	gboolean (*get_isTemporary) (NoiseMedia* self);
	void (*set_isTemporary) (NoiseMedia* self, gboolean value);
	gboolean (*get_location_unknown) (NoiseMedia* self);
	void (*set_location_unknown) (NoiseMedia* self, gboolean value);
	gboolean (*get_has_embedded) (NoiseMedia* self);
	void (*set_has_embedded) (NoiseMedia* self, gboolean value);
	GIcon* (*get_unique_status_image) (NoiseMedia* self);
	void (*set_unique_status_image) (NoiseMedia* self, GIcon* value);
	gboolean (*get_showIndicator) (NoiseMedia* self);
	void (*set_showIndicator) (NoiseMedia* self, gboolean value);
	const gchar* (*get_title) (NoiseMedia* self);
	void (*set_title) (NoiseMedia* self, const gchar* value);
	guint (*get_track) (NoiseMedia* self);
	void (*set_track) (NoiseMedia* self, guint value);
	guint (*get_track_count) (NoiseMedia* self);
	void (*set_track_count) (NoiseMedia* self, guint value);
	const gchar* (*get_composer) (NoiseMedia* self);
	void (*set_composer) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_artist) (NoiseMedia* self);
	void (*set_artist) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_album_artist) (NoiseMedia* self);
	void (*set_album_artist) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_album) (NoiseMedia* self);
	void (*set_album) (NoiseMedia* self, const gchar* value);
	guint (*get_album_number) (NoiseMedia* self);
	void (*set_album_number) (NoiseMedia* self, guint value);
	guint (*get_album_count) (NoiseMedia* self);
	void (*set_album_count) (NoiseMedia* self, guint value);
	NoiseAlbum* (*get_album_info) (NoiseMedia* self);
	void (*set_album_info) (NoiseMedia* self, NoiseAlbum* value);
	const gchar* (*get_grouping) (NoiseMedia* self);
	void (*set_grouping) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_genre) (NoiseMedia* self);
	void (*set_genre) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_comment) (NoiseMedia* self);
	void (*set_comment) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_lyrics) (NoiseMedia* self);
	void (*set_lyrics) (NoiseMedia* self, const gchar* value);
	guint (*get_year) (NoiseMedia* self);
	void (*set_year) (NoiseMedia* self, guint value);
	guint (*get_bitrate) (NoiseMedia* self);
	void (*set_bitrate) (NoiseMedia* self, guint value);
	guint (*get_bpm) (NoiseMedia* self);
	void (*set_bpm) (NoiseMedia* self, guint value);
	guint (*get_samplerate) (NoiseMedia* self);
	void (*set_samplerate) (NoiseMedia* self, guint value);
	guint (*get_length) (NoiseMedia* self);
	void (*set_length) (NoiseMedia* self, guint value);
	guint (*get_rating) (NoiseMedia* self);
	void (*set_rating) (NoiseMedia* self, guint value);
	guint (*get_play_count) (NoiseMedia* self);
	void (*set_play_count) (NoiseMedia* self, guint value);
	guint (*get_skip_count) (NoiseMedia* self);
	void (*set_skip_count) (NoiseMedia* self, guint value);
	guint (*get_date_added) (NoiseMedia* self);
	void (*set_date_added) (NoiseMedia* self, guint value);
	guint (*get_last_played) (NoiseMedia* self);
	void (*set_last_played) (NoiseMedia* self, guint value);
	guint (*get_last_modified) (NoiseMedia* self);
	void (*set_last_modified) (NoiseMedia* self, guint value);
	gint (*get_resume_pos) (NoiseMedia* self);
	void (*set_resume_pos) (NoiseMedia* self, gint value);
	gboolean (*get_show) (NoiseMedia* self);
	void (*set_show) (NoiseMedia* self, gboolean value);
};

struct _NoiseMediaPrivate {
	gint64 _rowid;
	guint64 _file_size;
	GFile* _file;
	gboolean _isPreview;
	gboolean _isTemporary;
	gboolean _location_unknown;
	gboolean _has_embedded;
	GIcon* _unique_status_image;
	gboolean _showIndicator;
	gchar* _title;
	guint _track;
	guint _track_count;
	gchar* _composer;
	gchar* _artist;
	gchar* _album_artist;
	gchar* _album;
	guint _album_number;
	guint _album_count;
	NoiseAlbum* _album_info;
	gchar* _grouping;
	gchar* _genre;
	gchar* _comment;
	gchar* _lyrics;
	guint _year;
	guint _bitrate;
	guint _bpm;
	guint _samplerate;
	guint _length;
	guint _play_count;
	guint _skip_count;
	guint _date_added;
	guint _last_played;
	guint _last_modified;
	gint _resume_pos;
	gboolean _show;
};


static gint NoiseMedia_private_offset;
static gpointer noise_media_parent_class = NULL;
extern gchar* noise_media_UNKNOWN;
gchar* noise_media_UNKNOWN = NULL;

GType noise_media_get_type (void) G_GNUC_CONST;
GType noise_album_get_type (void) G_GNUC_CONST;
gchar* noise_media_get_display_filename (NoiseMedia* self);
GFile* noise_media_get_file (NoiseMedia* self);
gchar* noise_string_locale_to_utf8 (const gchar* string_locale);
gboolean noise_media_is_valid_string_field (const gchar* text);
gchar* noise_media_get_display_location (NoiseMedia* self);
gboolean noise_media_get_isTemporary (NoiseMedia* self);
gchar* noise_media_get_display_title (NoiseMedia* self);
const gchar* noise_media_get_title (NoiseMedia* self);
gchar* noise_media_get_display_composer (NoiseMedia* self);
gchar* noise_media_get_simple_display_text (const gchar* text);
const gchar* noise_media_get_composer (NoiseMedia* self);
gchar* noise_media_get_display_artist (NoiseMedia* self);
const gchar* noise_media_get_artist (NoiseMedia* self);
gchar* noise_media_get_display_album_artist (NoiseMedia* self,
                                             gboolean use_artist_fallback);
const gchar* noise_media_get_album_artist (NoiseMedia* self);
gchar* noise_media_get_display_album (NoiseMedia* self);
const gchar* noise_media_get_album (NoiseMedia* self);
gchar* noise_media_get_display_genre (NoiseMedia* self);
const gchar* noise_media_get_genre (NoiseMedia* self);
gboolean noise_string_is_empty (const gchar* text,
                                gboolean check_white_space);
guint noise_media_get_album_hashkey (NoiseMedia* self);
gchar* noise_media_get_title_markup (NoiseMedia* self);
NoiseMedia* noise_media_new (const gchar* uri);
NoiseMedia* noise_media_construct (GType object_type,
                                   const gchar* uri);
void noise_media_set_uri (NoiseMedia* self,
                          const gchar* value);
NoiseMedia* noise_media_new_from_file (GFile* file);
NoiseMedia* noise_media_construct_from_file (GType object_type,
                                             GFile* file);
void noise_media_set_file (NoiseMedia* self,
                           GFile* value);
NoiseMedia* noise_media_copy (NoiseMedia* self);
gchar* noise_media_get_uri (NoiseMedia* self);
guint64 noise_media_get_file_size (NoiseMedia* self);
void noise_media_set_file_size (NoiseMedia* self,
                                guint64 value);
guint noise_media_get_track (NoiseMedia* self);
void noise_media_set_track (NoiseMedia* self,
                            guint value);
guint noise_media_get_track_count (NoiseMedia* self);
void noise_media_set_track_count (NoiseMedia* self,
                                  guint value);
guint noise_media_get_album_number (NoiseMedia* self);
void noise_media_set_album_number (NoiseMedia* self,
                                   guint value);
guint noise_media_get_album_count (NoiseMedia* self);
void noise_media_set_album_count (NoiseMedia* self,
                                  guint value);
void noise_media_set_title (NoiseMedia* self,
                            const gchar* value);
void noise_media_set_artist (NoiseMedia* self,
                             const gchar* value);
void noise_media_set_composer (NoiseMedia* self,
                               const gchar* value);
void noise_media_set_album_artist (NoiseMedia* self,
                                   const gchar* value);
void noise_media_set_album (NoiseMedia* self,
                            const gchar* value);
void noise_media_set_genre (NoiseMedia* self,
                            const gchar* value);
const gchar* noise_media_get_grouping (NoiseMedia* self);
void noise_media_set_grouping (NoiseMedia* self,
                               const gchar* value);
const gchar* noise_media_get_comment (NoiseMedia* self);
void noise_media_set_comment (NoiseMedia* self,
                              const gchar* value);
guint noise_media_get_year (NoiseMedia* self);
void noise_media_set_year (NoiseMedia* self,
                           guint value);
guint noise_media_get_bitrate (NoiseMedia* self);
void noise_media_set_bitrate (NoiseMedia* self,
                              guint value);
guint noise_media_get_length (NoiseMedia* self);
void noise_media_set_length (NoiseMedia* self,
                             guint value);
guint noise_media_get_samplerate (NoiseMedia* self);
void noise_media_set_samplerate (NoiseMedia* self,
                                 guint value);
guint noise_media_get_bpm (NoiseMedia* self);
void noise_media_set_bpm (NoiseMedia* self,
                          guint value);
guint noise_media_get_rating (NoiseMedia* self);
void noise_media_set_rating (NoiseMedia* self,
                             guint value);
guint noise_media_get_play_count (NoiseMedia* self);
void noise_media_set_play_count (NoiseMedia* self,
                                 guint value);
guint noise_media_get_skip_count (NoiseMedia* self);
void noise_media_set_skip_count (NoiseMedia* self,
                                 guint value);
guint noise_media_get_date_added (NoiseMedia* self);
void noise_media_set_date_added (NoiseMedia* self,
                                 guint value);
guint noise_media_get_last_played (NoiseMedia* self);
void noise_media_set_last_played (NoiseMedia* self,
                                  guint value);
const gchar* noise_media_get_lyrics (NoiseMedia* self);
void noise_media_set_lyrics (NoiseMedia* self,
                             const gchar* value);
gboolean noise_media_get_isPreview (NoiseMedia* self);
void noise_media_set_isPreview (NoiseMedia* self,
                                gboolean value);
void noise_media_set_isTemporary (NoiseMedia* self,
                                  gboolean value);
guint noise_media_get_last_modified (NoiseMedia* self);
void noise_media_set_last_modified (NoiseMedia* self,
                                    guint value);
gboolean noise_media_get_show (NoiseMedia* self);
void noise_media_set_show (NoiseMedia* self,
                           gboolean value);
gboolean noise_media_get_showIndicator (NoiseMedia* self);
void noise_media_set_showIndicator (NoiseMedia* self,
                                    gboolean value);
GIcon* noise_media_get_unique_status_image (NoiseMedia* self);
void noise_media_set_unique_status_image (NoiseMedia* self,
                                          GIcon* value);
gboolean noise_media_get_location_unknown (NoiseMedia* self);
void noise_media_set_location_unknown (NoiseMedia* self,
                                       gboolean value);
gint64 noise_media_get_rowid (NoiseMedia* self);
void noise_media_set_rowid (NoiseMedia* self,
                            gint64 value);
gboolean noise_media_get_file_exists (NoiseMedia* self);
gboolean noise_media_get_has_embedded (NoiseMedia* self);
void noise_media_set_has_embedded (NoiseMedia* self,
                                   gboolean value);
NoiseAlbum* noise_media_get_album_info (NoiseMedia* self);
void noise_media_set_album_info (NoiseMedia* self,
                                 NoiseAlbum* value);
gint noise_media_get_resume_pos (NoiseMedia* self);
void noise_media_set_resume_pos (NoiseMedia* self,
                                 gint value);
static void noise_media_finalize (GObject * obj);
static void _vala_noise_media_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_noise_media_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);


static inline gpointer
noise_media_get_instance_private (NoiseMedia* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseMedia_private_offset);
}


inline gchar*
noise_media_get_display_filename (NoiseMedia* self)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* filename = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_;
	gchar* _tmp11_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = noise_media_get_file (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_file_get_basename (_tmp2_);
	_tmp0_ = _tmp3_;
	if (_tmp0_ == NULL) {
		const gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp4_ = noise_media_UNKNOWN;
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp5_;
	}
	_tmp6_ = noise_string_locale_to_utf8 (_tmp0_);
	filename = _tmp6_;
	_tmp8_ = filename;
	if (noise_media_is_valid_string_field (_tmp8_)) {
		const gchar* _tmp9_;
		_tmp9_ = filename;
		_tmp7_ = _tmp9_;
	} else {
		const gchar* _tmp10_;
		_tmp10_ = noise_media_UNKNOWN;
		_tmp7_ = _tmp10_;
	}
	_tmp11_ = g_strdup (_tmp7_);
	result = _tmp11_;
	_g_free0 (filename);
	_g_free0 (_tmp0_);
	return result;
}


inline gchar*
noise_media_get_display_location (NoiseMedia* self)
{
	gchar* result = NULL;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gchar* filename = NULL;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_media_get_isTemporary (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup ("");
		result = _tmp2_;
		return result;
	}
	_tmp3_ = noise_media_get_file (self);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_file_get_path (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = noise_string_locale_to_utf8 (_tmp6_);
	_tmp8_ = _tmp7_;
	_g_free0 (_tmp6_);
	filename = _tmp8_;
	_tmp9_ = filename;
	if (noise_media_is_valid_string_field (_tmp9_)) {
		GFile* _tmp10_;
		GFile* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		_tmp10_ = noise_media_get_file (self);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_file_get_uri_scheme (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = filename;
		_tmp15_ = g_strdup_printf ("%s:/%s", _tmp13_, _tmp14_);
		_tmp16_ = _tmp15_;
		_g_free0 (_tmp13_);
		result = _tmp16_;
		_g_free0 (filename);
		return result;
	}
	_tmp17_ = noise_media_UNKNOWN;
	_tmp18_ = g_strdup (_tmp17_);
	result = _tmp18_;
	_g_free0 (filename);
	return result;
}


inline gchar*
noise_media_get_display_title (NoiseMedia* self)
{
	gchar* result = NULL;
	gchar* title = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_media_get_title (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup (_tmp1_);
	title = _tmp2_;
	_tmp4_ = title;
	if (noise_media_is_valid_string_field (_tmp4_)) {
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = title;
		_tmp6_ = g_strdup (_tmp5_);
		_g_free0 (_tmp3_);
		_tmp3_ = _tmp6_;
	} else {
		gchar* _tmp7_;
		_tmp7_ = noise_media_get_display_filename (self);
		_g_free0 (_tmp3_);
		_tmp3_ = _tmp7_;
	}
	result = _tmp3_;
	_g_free0 (title);
	return result;
}


inline gchar*
noise_media_get_display_composer (NoiseMedia* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_media_get_composer (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = noise_media_get_simple_display_text (_tmp1_);
	result = _tmp2_;
	return result;
}


inline gchar*
noise_media_get_display_artist (NoiseMedia* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_media_get_artist (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = noise_media_get_simple_display_text (_tmp1_);
	result = _tmp2_;
	return result;
}


inline gchar*
noise_media_get_display_album_artist (NoiseMedia* self,
                                      gboolean use_artist_fallback)
{
	gchar* result = NULL;
	gchar* album_artist = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_media_get_album_artist (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup (_tmp1_);
	album_artist = _tmp2_;
	_tmp3_ = album_artist;
	if (noise_media_is_valid_string_field (_tmp3_)) {
		result = album_artist;
		return result;
	}
	if (use_artist_fallback) {
		gchar* _tmp4_;
		_tmp4_ = noise_media_get_display_artist (self);
		result = _tmp4_;
		_g_free0 (album_artist);
		return result;
	}
	_tmp5_ = noise_media_UNKNOWN;
	_tmp6_ = g_strdup (_tmp5_);
	result = _tmp6_;
	_g_free0 (album_artist);
	return result;
}


inline gchar*
noise_media_get_display_album (NoiseMedia* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_media_get_album (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = noise_media_get_simple_display_text (_tmp1_);
	result = _tmp2_;
	return result;
}


inline gchar*
noise_media_get_display_genre (NoiseMedia* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_media_get_genre (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = noise_media_get_simple_display_text (_tmp1_);
	result = _tmp2_;
	return result;
}


inline gboolean
noise_media_is_valid_string_field (const gchar* text)
{
	gboolean result = FALSE;
	result = !noise_string_is_empty (text, TRUE);
	return result;
}


guint
noise_media_get_album_hashkey (NoiseMedia* self)
{
	guint result = 0U;
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GString* _tmp12_;
	const gchar* _tmp13_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = g_string_new ("");
	builder = _tmp0_;
	_tmp1_ = builder;
	_tmp2_ = noise_media_get_album (self);
	_tmp3_ = _tmp2_;
	g_string_append (_tmp1_, _tmp3_);
	_tmp4_ = noise_media_get_album_artist (self);
	_tmp5_ = _tmp4_;
	if (noise_media_is_valid_string_field (_tmp5_)) {
		GString* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		_tmp6_ = builder;
		_tmp7_ = noise_media_get_album_artist (self);
		_tmp8_ = _tmp7_;
		g_string_append (_tmp6_, _tmp8_);
	} else {
		GString* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		_tmp9_ = builder;
		_tmp10_ = noise_media_get_artist (self);
		_tmp11_ = _tmp10_;
		g_string_append (_tmp9_, _tmp11_);
	}
	_tmp12_ = builder;
	_tmp13_ = _tmp12_->str;
	result = g_str_hash (_tmp13_);
	_g_string_free0 (builder);
	return result;
}


/**
     * It's called simple because it simply checks if the string is empty,
     * and returns UNKNOWN if it is.
     */
inline gchar*
noise_media_get_simple_display_text (const gchar* text)
{
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp2_;
	if (noise_media_is_valid_string_field (text)) {
		_tmp0_ = text;
	} else {
		const gchar* _tmp1_;
		_tmp1_ = noise_media_UNKNOWN;
		_tmp0_ = _tmp1_;
	}
	_tmp2_ = g_strdup (_tmp0_);
	result = _tmp2_;
	return result;
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch6_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch6_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally6;
	__catch6_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally6:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar*
noise_media_get_title_markup (NoiseMedia* self)
{
	gchar* result = NULL;
	gboolean is_valid_artist = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean is_valid_album = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_media_get_artist (self);
	_tmp1_ = _tmp0_;
	is_valid_artist = noise_media_is_valid_string_field (_tmp1_);
	_tmp2_ = noise_media_get_album (self);
	_tmp3_ = _tmp2_;
	is_valid_album = noise_media_is_valid_string_field (_tmp3_);
	_tmp5_ = is_valid_artist;
	if (!_tmp5_) {
		gboolean _tmp6_;
		_tmp6_ = is_valid_album;
		_tmp4_ = _tmp6_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		_tmp7_ = noise_media_get_album (self);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_markup_escape_text (_tmp8_, (gssize) -1);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strconcat ("<b>", _tmp10_, NULL);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_strconcat (_tmp12_, "</b>", NULL);
		_tmp14_ = _tmp13_;
		_tmp15_ = string_replace (_ ("$NAME on $ALBUM"), "$ALBUM", _tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = noise_media_get_display_title (self);
		_tmp18_ = _tmp17_;
		_tmp19_ = g_markup_escape_text (_tmp18_, (gssize) -1);
		_tmp20_ = _tmp19_;
		_tmp21_ = g_strconcat ("<b>", _tmp20_, NULL);
		_tmp22_ = _tmp21_;
		_tmp23_ = g_strconcat (_tmp22_, "</b>", NULL);
		_tmp24_ = _tmp23_;
		_tmp25_ = string_replace (_tmp16_, "$NAME", _tmp24_);
		_tmp26_ = _tmp25_;
		_g_free0 (_tmp24_);
		_g_free0 (_tmp22_);
		_g_free0 (_tmp20_);
		_g_free0 (_tmp18_);
		_g_free0 (_tmp16_);
		_g_free0 (_tmp14_);
		_g_free0 (_tmp12_);
		_g_free0 (_tmp10_);
		result = _tmp26_;
		return result;
	} else {
		gboolean _tmp27_ = FALSE;
		gboolean _tmp28_;
		_tmp28_ = is_valid_artist;
		if (_tmp28_) {
			gboolean _tmp29_;
			_tmp29_ = is_valid_album;
			_tmp27_ = !_tmp29_;
		} else {
			_tmp27_ = FALSE;
		}
		if (_tmp27_) {
			const gchar* _tmp30_;
			const gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			_tmp30_ = noise_media_get_artist (self);
			_tmp31_ = _tmp30_;
			_tmp32_ = g_markup_escape_text (_tmp31_, (gssize) -1);
			_tmp33_ = _tmp32_;
			_tmp34_ = g_strconcat ("<b>", _tmp33_, NULL);
			_tmp35_ = _tmp34_;
			_tmp36_ = g_strconcat (_tmp35_, "</b>", NULL);
			_tmp37_ = _tmp36_;
			_tmp38_ = string_replace (_ ("$NAME by $ARTIST"), "$ARTIST", _tmp37_);
			_tmp39_ = _tmp38_;
			_tmp40_ = noise_media_get_display_title (self);
			_tmp41_ = _tmp40_;
			_tmp42_ = g_markup_escape_text (_tmp41_, (gssize) -1);
			_tmp43_ = _tmp42_;
			_tmp44_ = g_strconcat ("<b>", _tmp43_, NULL);
			_tmp45_ = _tmp44_;
			_tmp46_ = g_strconcat (_tmp45_, "</b>", NULL);
			_tmp47_ = _tmp46_;
			_tmp48_ = string_replace (_tmp39_, "$NAME", _tmp47_);
			_tmp49_ = _tmp48_;
			_g_free0 (_tmp47_);
			_g_free0 (_tmp45_);
			_g_free0 (_tmp43_);
			_g_free0 (_tmp41_);
			_g_free0 (_tmp39_);
			_g_free0 (_tmp37_);
			_g_free0 (_tmp35_);
			_g_free0 (_tmp33_);
			result = _tmp49_;
			return result;
		} else {
			gboolean _tmp50_ = FALSE;
			gboolean _tmp51_;
			_tmp51_ = is_valid_artist;
			if (!_tmp51_) {
				gboolean _tmp52_;
				_tmp52_ = is_valid_album;
				_tmp50_ = !_tmp52_;
			} else {
				_tmp50_ = FALSE;
			}
			if (_tmp50_) {
				gchar* _tmp53_;
				gchar* _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
				gchar* _tmp57_;
				gchar* _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
				_tmp53_ = noise_media_get_display_title (self);
				_tmp54_ = _tmp53_;
				_tmp55_ = g_markup_escape_text (_tmp54_, (gssize) -1);
				_tmp56_ = _tmp55_;
				_tmp57_ = g_strconcat ("<b>", _tmp56_, NULL);
				_tmp58_ = _tmp57_;
				_tmp59_ = g_strconcat (_tmp58_, "</b>", NULL);
				_tmp60_ = _tmp59_;
				_g_free0 (_tmp58_);
				_g_free0 (_tmp56_);
				_g_free0 (_tmp54_);
				result = _tmp60_;
				return result;
			} else {
				const gchar* _tmp61_;
				const gchar* _tmp62_;
				gchar* _tmp63_;
				gchar* _tmp64_;
				gchar* _tmp65_;
				gchar* _tmp66_;
				gchar* _tmp67_;
				gchar* _tmp68_;
				gchar* _tmp69_;
				gchar* _tmp70_;
				gchar* _tmp71_;
				gchar* _tmp72_;
				gchar* _tmp73_;
				gchar* _tmp74_;
				gchar* _tmp75_;
				gchar* _tmp76_;
				gchar* _tmp77_;
				gchar* _tmp78_;
				gchar* _tmp79_;
				gchar* _tmp80_;
				const gchar* _tmp81_;
				const gchar* _tmp82_;
				gchar* _tmp83_;
				gchar* _tmp84_;
				gchar* _tmp85_;
				gchar* _tmp86_;
				gchar* _tmp87_;
				gchar* _tmp88_;
				gchar* _tmp89_;
				gchar* _tmp90_;
				_tmp61_ = noise_media_get_artist (self);
				_tmp62_ = _tmp61_;
				_tmp63_ = g_markup_escape_text (_tmp62_, (gssize) -1);
				_tmp64_ = _tmp63_;
				_tmp65_ = g_strconcat ("<b>", _tmp64_, NULL);
				_tmp66_ = _tmp65_;
				_tmp67_ = g_strconcat (_tmp66_, "</b>", NULL);
				_tmp68_ = _tmp67_;
				_tmp69_ = string_replace (_ ("$NAME by $ARTIST on $ALBUM"), "$ARTIST", _tmp68_);
				_tmp70_ = _tmp69_;
				_tmp71_ = noise_media_get_display_title (self);
				_tmp72_ = _tmp71_;
				_tmp73_ = g_markup_escape_text (_tmp72_, (gssize) -1);
				_tmp74_ = _tmp73_;
				_tmp75_ = g_strconcat ("<b>", _tmp74_, NULL);
				_tmp76_ = _tmp75_;
				_tmp77_ = g_strconcat (_tmp76_, "</b>", NULL);
				_tmp78_ = _tmp77_;
				_tmp79_ = string_replace (_tmp70_, "$NAME", _tmp78_);
				_tmp80_ = _tmp79_;
				_tmp81_ = noise_media_get_album (self);
				_tmp82_ = _tmp81_;
				_tmp83_ = g_markup_escape_text (_tmp82_, (gssize) -1);
				_tmp84_ = _tmp83_;
				_tmp85_ = g_strconcat ("<b>", _tmp84_, NULL);
				_tmp86_ = _tmp85_;
				_tmp87_ = g_strconcat (_tmp86_, "</b>", NULL);
				_tmp88_ = _tmp87_;
				_tmp89_ = string_replace (_tmp80_, "$ALBUM", _tmp88_);
				_tmp90_ = _tmp89_;
				_g_free0 (_tmp88_);
				_g_free0 (_tmp86_);
				_g_free0 (_tmp84_);
				_g_free0 (_tmp80_);
				_g_free0 (_tmp78_);
				_g_free0 (_tmp76_);
				_g_free0 (_tmp74_);
				_g_free0 (_tmp72_);
				_g_free0 (_tmp70_);
				_g_free0 (_tmp68_);
				_g_free0 (_tmp66_);
				_g_free0 (_tmp64_);
				result = _tmp90_;
				return result;
			}
		}
	}
}


NoiseMedia*
noise_media_construct (GType object_type,
                       const gchar* uri)
{
	NoiseMedia * self = NULL;
	g_return_val_if_fail (uri != NULL, NULL);
	self = (NoiseMedia*) g_object_new (object_type, NULL);
	noise_media_set_uri (self, uri);
	return self;
}


NoiseMedia*
noise_media_new (const gchar* uri)
{
	return noise_media_construct (NOISE_TYPE_MEDIA, uri);
}


NoiseMedia*
noise_media_construct_from_file (GType object_type,
                                 GFile* file)
{
	NoiseMedia * self = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	self = (NoiseMedia*) g_object_new (object_type, NULL);
	noise_media_set_file (self, file);
	return self;
}


NoiseMedia*
noise_media_new_from_file (GFile* file)
{
	return noise_media_construct_from_file (NOISE_TYPE_MEDIA, file);
}


NoiseMedia*
noise_media_copy (NoiseMedia* self)
{
	NoiseMedia* result = NULL;
	NoiseMedia* rv = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	NoiseMedia* _tmp3_;
	NoiseMedia* _tmp4_;
	guint64 _tmp5_;
	guint64 _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
	guint _tmp11_;
	guint _tmp12_;
	guint _tmp13_;
	guint _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	guint _tmp31_;
	guint _tmp32_;
	guint _tmp33_;
	guint _tmp34_;
	guint _tmp35_;
	guint _tmp36_;
	guint _tmp37_;
	guint _tmp38_;
	guint _tmp39_;
	guint _tmp40_;
	guint _tmp41_;
	guint _tmp42_;
	guint _tmp43_;
	guint _tmp44_;
	guint _tmp45_;
	guint _tmp46_;
	guint _tmp47_;
	guint _tmp48_;
	guint _tmp49_;
	guint _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	gboolean _tmp53_;
	gboolean _tmp54_;
	gboolean _tmp55_;
	gboolean _tmp56_;
	guint _tmp57_;
	guint _tmp58_;
	gboolean _tmp59_;
	gboolean _tmp60_;
	gboolean _tmp61_;
	gboolean _tmp62_;
	GIcon* _tmp63_;
	GIcon* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_media_get_uri (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp3_ = noise_media_new (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	rv = _tmp4_;
	_tmp5_ = noise_media_get_file_size (self);
	_tmp6_ = _tmp5_;
	noise_media_set_file_size (rv, _tmp6_);
	_tmp7_ = noise_media_get_track (self);
	_tmp8_ = _tmp7_;
	noise_media_set_track (rv, _tmp8_);
	_tmp9_ = noise_media_get_track_count (self);
	_tmp10_ = _tmp9_;
	noise_media_set_track_count (rv, _tmp10_);
	_tmp11_ = noise_media_get_album_number (self);
	_tmp12_ = _tmp11_;
	noise_media_set_album_number (rv, _tmp12_);
	_tmp13_ = noise_media_get_album_count (self);
	_tmp14_ = _tmp13_;
	noise_media_set_album_count (rv, _tmp14_);
	_tmp15_ = noise_media_get_title (self);
	_tmp16_ = _tmp15_;
	noise_media_set_title (rv, _tmp16_);
	_tmp17_ = noise_media_get_artist (self);
	_tmp18_ = _tmp17_;
	noise_media_set_artist (rv, _tmp18_);
	_tmp19_ = noise_media_get_composer (self);
	_tmp20_ = _tmp19_;
	noise_media_set_composer (rv, _tmp20_);
	_tmp21_ = noise_media_get_album_artist (self);
	_tmp22_ = _tmp21_;
	noise_media_set_album_artist (rv, _tmp22_);
	_tmp23_ = noise_media_get_album (self);
	_tmp24_ = _tmp23_;
	noise_media_set_album (rv, _tmp24_);
	_tmp25_ = noise_media_get_genre (self);
	_tmp26_ = _tmp25_;
	noise_media_set_genre (rv, _tmp26_);
	_tmp27_ = noise_media_get_grouping (self);
	_tmp28_ = _tmp27_;
	noise_media_set_grouping (rv, _tmp28_);
	_tmp29_ = noise_media_get_comment (self);
	_tmp30_ = _tmp29_;
	noise_media_set_comment (rv, _tmp30_);
	_tmp31_ = noise_media_get_year (self);
	_tmp32_ = _tmp31_;
	noise_media_set_year (rv, _tmp32_);
	_tmp33_ = noise_media_get_bitrate (self);
	_tmp34_ = _tmp33_;
	noise_media_set_bitrate (rv, _tmp34_);
	_tmp35_ = noise_media_get_length (self);
	_tmp36_ = _tmp35_;
	noise_media_set_length (rv, _tmp36_);
	_tmp37_ = noise_media_get_samplerate (self);
	_tmp38_ = _tmp37_;
	noise_media_set_samplerate (rv, _tmp38_);
	_tmp39_ = noise_media_get_bpm (self);
	_tmp40_ = _tmp39_;
	noise_media_set_bpm (rv, _tmp40_);
	_tmp41_ = noise_media_get_rating (self);
	_tmp42_ = _tmp41_;
	noise_media_set_rating (rv, _tmp42_);
	_tmp43_ = noise_media_get_play_count (self);
	_tmp44_ = _tmp43_;
	noise_media_set_play_count (rv, _tmp44_);
	_tmp45_ = noise_media_get_skip_count (self);
	_tmp46_ = _tmp45_;
	noise_media_set_skip_count (rv, _tmp46_);
	_tmp47_ = noise_media_get_date_added (self);
	_tmp48_ = _tmp47_;
	noise_media_set_date_added (rv, _tmp48_);
	_tmp49_ = noise_media_get_last_played (self);
	_tmp50_ = _tmp49_;
	noise_media_set_last_played (rv, _tmp50_);
	_tmp51_ = noise_media_get_lyrics (self);
	_tmp52_ = _tmp51_;
	noise_media_set_lyrics (rv, _tmp52_);
	_tmp53_ = noise_media_get_isPreview (self);
	_tmp54_ = _tmp53_;
	noise_media_set_isPreview (rv, _tmp54_);
	_tmp55_ = noise_media_get_isTemporary (self);
	_tmp56_ = _tmp55_;
	noise_media_set_isTemporary (rv, _tmp56_);
	_tmp57_ = noise_media_get_last_modified (self);
	_tmp58_ = _tmp57_;
	noise_media_set_last_modified (rv, _tmp58_);
	_tmp59_ = noise_media_get_show (self);
	_tmp60_ = _tmp59_;
	noise_media_set_show (rv, _tmp60_);
	_tmp61_ = noise_media_get_showIndicator (self);
	_tmp62_ = _tmp61_;
	noise_media_set_showIndicator (rv, _tmp62_);
	_tmp63_ = noise_media_get_unique_status_image (self);
	_tmp64_ = _tmp63_;
	noise_media_set_unique_status_image (rv, _tmp64_);
	_tmp65_ = noise_media_get_location_unknown (self);
	_tmp66_ = _tmp65_;
	noise_media_set_location_unknown (rv, _tmp66_);
	result = rv;
	return result;
}


gint64
noise_media_get_rowid (NoiseMedia* self)
{
	gint64 result;
	gint64 _tmp0_;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_rowid;
	result = _tmp0_;
	return result;
}


void
noise_media_set_rowid (NoiseMedia* self,
                       gint64 value)
{
	g_return_if_fail (self != NULL);
	if (noise_media_get_rowid (self) != value) {
		self->priv->_rowid = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_ROWID_PROPERTY]);
	}
}


gchar*
noise_media_get_uri (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_MEDIA_GET_CLASS (self)->get_uri (self);
}


static gchar*
noise_media_real_get_uri (NoiseMedia* base)
{
	gchar* result;
	NoiseMedia* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	self = base;
	_tmp0_ = noise_media_get_file (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_get_uri (_tmp1_);
	result = _tmp2_;
	return result;
}


void
noise_media_set_uri (NoiseMedia* self,
                     const gchar* value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_uri (self, value);
}


static void
noise_media_real_set_uri (NoiseMedia* base,
                          const gchar* value)
{
	NoiseMedia* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	self = base;
	_tmp0_ = g_file_new_for_uri (value);
	_tmp1_ = _tmp0_;
	noise_media_set_file (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_URI_PROPERTY]);
}


guint64
noise_media_get_file_size (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0ULL);
	return NOISE_MEDIA_GET_CLASS (self)->get_file_size (self);
}


static guint64
noise_media_real_get_file_size (NoiseMedia* base)
{
	guint64 result;
	NoiseMedia* self;
	guint64 _tmp0_;
	self = base;
	_tmp0_ = self->priv->_file_size;
	result = _tmp0_;
	return result;
}


void
noise_media_set_file_size (NoiseMedia* self,
                           guint64 value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_file_size (self, value);
}


static void
noise_media_real_set_file_size (NoiseMedia* base,
                                guint64 value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_file_size (base) != value) {
		self->priv->_file_size = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_FILE_SIZE_PROPERTY]);
	}
}


gboolean
noise_media_get_file_exists (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return NOISE_MEDIA_GET_CLASS (self)->get_file_exists (self);
}


static gboolean
noise_media_real_get_file_exists (NoiseMedia* base)
{
	gboolean result;
	NoiseMedia* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	self = base;
	_tmp0_ = noise_media_get_file (self);
	_tmp1_ = _tmp0_;
	result = g_file_query_exists (_tmp1_, NULL);
	return result;
}


GFile*
noise_media_get_file (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_MEDIA_GET_CLASS (self)->get_file (self);
}


static GFile*
noise_media_real_get_file (NoiseMedia* base)
{
	GFile* result;
	NoiseMedia* self;
	GFile* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_file;
	result = _tmp0_;
	return result;
}


void
noise_media_set_file (NoiseMedia* self,
                      GFile* value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_file (self, value);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
noise_media_real_set_file (NoiseMedia* base,
                           GFile* value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_file (base) != value) {
		GFile* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_file);
		self->priv->_file = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_FILE_PROPERTY]);
	}
}


gboolean
noise_media_get_isPreview (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return NOISE_MEDIA_GET_CLASS (self)->get_isPreview (self);
}


static gboolean
noise_media_real_get_isPreview (NoiseMedia* base)
{
	gboolean result;
	NoiseMedia* self;
	gboolean _tmp0_;
	self = base;
	_tmp0_ = self->priv->_isPreview;
	result = _tmp0_;
	return result;
}


void
noise_media_set_isPreview (NoiseMedia* self,
                           gboolean value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_isPreview (self, value);
}


static void
noise_media_real_set_isPreview (NoiseMedia* base,
                                gboolean value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_isPreview (base) != value) {
		self->priv->_isPreview = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_IS_PREVIEW_PROPERTY]);
	}
}


gboolean
noise_media_get_isTemporary (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return NOISE_MEDIA_GET_CLASS (self)->get_isTemporary (self);
}


static gboolean
noise_media_real_get_isTemporary (NoiseMedia* base)
{
	gboolean result;
	NoiseMedia* self;
	gboolean _tmp0_;
	self = base;
	_tmp0_ = self->priv->_isTemporary;
	result = _tmp0_;
	return result;
}


void
noise_media_set_isTemporary (NoiseMedia* self,
                             gboolean value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_isTemporary (self, value);
}


static void
noise_media_real_set_isTemporary (NoiseMedia* base,
                                  gboolean value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_isTemporary (base) != value) {
		self->priv->_isTemporary = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_IS_TEMPORARY_PROPERTY]);
	}
}


gboolean
noise_media_get_location_unknown (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return NOISE_MEDIA_GET_CLASS (self)->get_location_unknown (self);
}


static gboolean
noise_media_real_get_location_unknown (NoiseMedia* base)
{
	gboolean result;
	NoiseMedia* self;
	gboolean _tmp0_;
	self = base;
	_tmp0_ = self->priv->_location_unknown;
	result = _tmp0_;
	return result;
}


void
noise_media_set_location_unknown (NoiseMedia* self,
                                  gboolean value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_location_unknown (self, value);
}


static void
noise_media_real_set_location_unknown (NoiseMedia* base,
                                       gboolean value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_location_unknown (base) != value) {
		self->priv->_location_unknown = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_LOCATION_UNKNOWN_PROPERTY]);
	}
}


gboolean
noise_media_get_has_embedded (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return NOISE_MEDIA_GET_CLASS (self)->get_has_embedded (self);
}


static gboolean
noise_media_real_get_has_embedded (NoiseMedia* base)
{
	gboolean result;
	NoiseMedia* self;
	gboolean _tmp0_;
	self = base;
	_tmp0_ = self->priv->_has_embedded;
	result = _tmp0_;
	return result;
}


void
noise_media_set_has_embedded (NoiseMedia* self,
                              gboolean value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_has_embedded (self, value);
}


static void
noise_media_real_set_has_embedded (NoiseMedia* base,
                                   gboolean value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_has_embedded (base) != value) {
		self->priv->_has_embedded = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_HAS_EMBEDDED_PROPERTY]);
	}
}


GIcon*
noise_media_get_unique_status_image (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_MEDIA_GET_CLASS (self)->get_unique_status_image (self);
}


static GIcon*
noise_media_real_get_unique_status_image (NoiseMedia* base)
{
	GIcon* result;
	NoiseMedia* self;
	GIcon* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_unique_status_image;
	result = _tmp0_;
	return result;
}


void
noise_media_set_unique_status_image (NoiseMedia* self,
                                     GIcon* value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_unique_status_image (self, value);
}


static void
noise_media_real_set_unique_status_image (NoiseMedia* base,
                                          GIcon* value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_unique_status_image (base) != value) {
		GIcon* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_unique_status_image);
		self->priv->_unique_status_image = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY]);
	}
}


gboolean
noise_media_get_showIndicator (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return NOISE_MEDIA_GET_CLASS (self)->get_showIndicator (self);
}


static gboolean
noise_media_real_get_showIndicator (NoiseMedia* base)
{
	gboolean result;
	NoiseMedia* self;
	gboolean _tmp0_;
	self = base;
	_tmp0_ = self->priv->_showIndicator;
	result = _tmp0_;
	return result;
}


void
noise_media_set_showIndicator (NoiseMedia* self,
                               gboolean value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_showIndicator (self, value);
}


static void
noise_media_real_set_showIndicator (NoiseMedia* base,
                                    gboolean value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_showIndicator (base) != value) {
		self->priv->_showIndicator = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_SHOW_INDICATOR_PROPERTY]);
	}
}


const gchar*
noise_media_get_title (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_MEDIA_GET_CLASS (self)->get_title (self);
}


static const gchar*
noise_media_real_get_title (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_title;
	result = _tmp0_;
	return result;
}


void
noise_media_set_title (NoiseMedia* self,
                       const gchar* value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_title (self, value);
}


static void
noise_media_real_set_title (NoiseMedia* base,
                            const gchar* value)
{
	NoiseMedia* self;
	self = base;
	if (g_strcmp0 (value, noise_media_real_get_title (base)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_title);
		self->priv->_title = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_TITLE_PROPERTY]);
	}
}


guint
noise_media_get_track (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0U);
	return NOISE_MEDIA_GET_CLASS (self)->get_track (self);
}


static guint
noise_media_real_get_track (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
	guint _tmp0_;
	self = base;
	_tmp0_ = self->priv->_track;
	result = _tmp0_;
	return result;
}


void
noise_media_set_track (NoiseMedia* self,
                       guint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_track (self, value);
}


static void
noise_media_real_set_track (NoiseMedia* base,
                            guint value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_track (base) != value) {
		self->priv->_track = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_TRACK_PROPERTY]);
	}
}


guint
noise_media_get_track_count (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0U);
	return NOISE_MEDIA_GET_CLASS (self)->get_track_count (self);
}


static guint
noise_media_real_get_track_count (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
	guint _tmp0_;
	self = base;
	_tmp0_ = self->priv->_track_count;
	result = _tmp0_;
	return result;
}


void
noise_media_set_track_count (NoiseMedia* self,
                             guint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_track_count (self, value);
}


static void
noise_media_real_set_track_count (NoiseMedia* base,
                                  guint value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_track_count (base) != value) {
		self->priv->_track_count = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_TRACK_COUNT_PROPERTY]);
	}
}


const gchar*
noise_media_get_composer (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_MEDIA_GET_CLASS (self)->get_composer (self);
}


static const gchar*
noise_media_real_get_composer (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_composer;
	result = _tmp0_;
	return result;
}


void
noise_media_set_composer (NoiseMedia* self,
                          const gchar* value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_composer (self, value);
}


static void
noise_media_real_set_composer (NoiseMedia* base,
                               const gchar* value)
{
	NoiseMedia* self;
	self = base;
	if (g_strcmp0 (value, noise_media_real_get_composer (base)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_composer);
		self->priv->_composer = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_COMPOSER_PROPERTY]);
	}
}


const gchar*
noise_media_get_artist (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_MEDIA_GET_CLASS (self)->get_artist (self);
}


static const gchar*
noise_media_real_get_artist (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_artist;
	result = _tmp0_;
	return result;
}


void
noise_media_set_artist (NoiseMedia* self,
                        const gchar* value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_artist (self, value);
}


static void
noise_media_real_set_artist (NoiseMedia* base,
                             const gchar* value)
{
	NoiseMedia* self;
	self = base;
	if (g_strcmp0 (value, noise_media_real_get_artist (base)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_artist);
		self->priv->_artist = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_ARTIST_PROPERTY]);
	}
}


const gchar*
noise_media_get_album_artist (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_MEDIA_GET_CLASS (self)->get_album_artist (self);
}


static const gchar*
noise_media_real_get_album_artist (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_album_artist;
	result = _tmp0_;
	return result;
}


void
noise_media_set_album_artist (NoiseMedia* self,
                              const gchar* value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_album_artist (self, value);
}


static void
noise_media_real_set_album_artist (NoiseMedia* base,
                                   const gchar* value)
{
	NoiseMedia* self;
	self = base;
	if (g_strcmp0 (value, noise_media_real_get_album_artist (base)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_album_artist);
		self->priv->_album_artist = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_ALBUM_ARTIST_PROPERTY]);
	}
}


const gchar*
noise_media_get_album (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_MEDIA_GET_CLASS (self)->get_album (self);
}


static const gchar*
noise_media_real_get_album (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_album;
	result = _tmp0_;
	return result;
}


void
noise_media_set_album (NoiseMedia* self,
                       const gchar* value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_album (self, value);
}


static void
noise_media_real_set_album (NoiseMedia* base,
                            const gchar* value)
{
	NoiseMedia* self;
	self = base;
	if (g_strcmp0 (value, noise_media_real_get_album (base)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_album);
		self->priv->_album = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_ALBUM_PROPERTY]);
	}
}


guint
noise_media_get_album_number (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0U);
	return NOISE_MEDIA_GET_CLASS (self)->get_album_number (self);
}


static guint
noise_media_real_get_album_number (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
	guint _tmp0_;
	self = base;
	_tmp0_ = self->priv->_album_number;
	result = _tmp0_;
	return result;
}


void
noise_media_set_album_number (NoiseMedia* self,
                              guint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_album_number (self, value);
}


static void
noise_media_real_set_album_number (NoiseMedia* base,
                                   guint value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_album_number (base) != value) {
		self->priv->_album_number = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_ALBUM_NUMBER_PROPERTY]);
	}
}


guint
noise_media_get_album_count (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0U);
	return NOISE_MEDIA_GET_CLASS (self)->get_album_count (self);
}


static guint
noise_media_real_get_album_count (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
	guint _tmp0_;
	self = base;
	_tmp0_ = self->priv->_album_count;
	result = _tmp0_;
	return result;
}


void
noise_media_set_album_count (NoiseMedia* self,
                             guint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_album_count (self, value);
}


static void
noise_media_real_set_album_count (NoiseMedia* base,
                                  guint value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_album_count (base) != value) {
		self->priv->_album_count = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_ALBUM_COUNT_PROPERTY]);
	}
}


NoiseAlbum*
noise_media_get_album_info (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_MEDIA_GET_CLASS (self)->get_album_info (self);
}


static NoiseAlbum*
noise_media_real_get_album_info (NoiseMedia* base)
{
	NoiseAlbum* result;
	NoiseMedia* self;
	NoiseAlbum* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_album_info;
	result = _tmp0_;
	return result;
}


void
noise_media_set_album_info (NoiseMedia* self,
                            NoiseAlbum* value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_album_info (self, value);
}


static void
noise_media_real_set_album_info (NoiseMedia* base,
                                 NoiseAlbum* value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_album_info (base) != value) {
		self->priv->_album_info = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_ALBUM_INFO_PROPERTY]);
	}
}


const gchar*
noise_media_get_grouping (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_MEDIA_GET_CLASS (self)->get_grouping (self);
}


static const gchar*
noise_media_real_get_grouping (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_grouping;
	result = _tmp0_;
	return result;
}


void
noise_media_set_grouping (NoiseMedia* self,
                          const gchar* value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_grouping (self, value);
}


static void
noise_media_real_set_grouping (NoiseMedia* base,
                               const gchar* value)
{
	NoiseMedia* self;
	self = base;
	if (g_strcmp0 (value, noise_media_real_get_grouping (base)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_grouping);
		self->priv->_grouping = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_GROUPING_PROPERTY]);
	}
}


const gchar*
noise_media_get_genre (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_MEDIA_GET_CLASS (self)->get_genre (self);
}


static const gchar*
noise_media_real_get_genre (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_genre;
	result = _tmp0_;
	return result;
}


void
noise_media_set_genre (NoiseMedia* self,
                       const gchar* value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_genre (self, value);
}


static void
noise_media_real_set_genre (NoiseMedia* base,
                            const gchar* value)
{
	NoiseMedia* self;
	self = base;
	if (g_strcmp0 (value, noise_media_real_get_genre (base)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_genre);
		self->priv->_genre = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_GENRE_PROPERTY]);
	}
}


const gchar*
noise_media_get_comment (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_MEDIA_GET_CLASS (self)->get_comment (self);
}


static const gchar*
noise_media_real_get_comment (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_comment;
	result = _tmp0_;
	return result;
}


void
noise_media_set_comment (NoiseMedia* self,
                         const gchar* value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_comment (self, value);
}


static void
noise_media_real_set_comment (NoiseMedia* base,
                              const gchar* value)
{
	NoiseMedia* self;
	self = base;
	if (g_strcmp0 (value, noise_media_real_get_comment (base)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_comment);
		self->priv->_comment = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_COMMENT_PROPERTY]);
	}
}


const gchar*
noise_media_get_lyrics (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NOISE_MEDIA_GET_CLASS (self)->get_lyrics (self);
}


static const gchar*
noise_media_real_get_lyrics (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_lyrics;
	result = _tmp0_;
	return result;
}


void
noise_media_set_lyrics (NoiseMedia* self,
                        const gchar* value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_lyrics (self, value);
}


static void
noise_media_real_set_lyrics (NoiseMedia* base,
                             const gchar* value)
{
	NoiseMedia* self;
	self = base;
	if (g_strcmp0 (value, noise_media_real_get_lyrics (base)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_lyrics);
		self->priv->_lyrics = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_LYRICS_PROPERTY]);
	}
}


guint
noise_media_get_year (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0U);
	return NOISE_MEDIA_GET_CLASS (self)->get_year (self);
}


static guint
noise_media_real_get_year (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
	guint _tmp0_;
	self = base;
	_tmp0_ = self->priv->_year;
	result = _tmp0_;
	return result;
}


void
noise_media_set_year (NoiseMedia* self,
                      guint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_year (self, value);
}


static void
noise_media_real_set_year (NoiseMedia* base,
                           guint value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_year (base) != value) {
		self->priv->_year = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_YEAR_PROPERTY]);
	}
}


guint
noise_media_get_bitrate (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0U);
	return NOISE_MEDIA_GET_CLASS (self)->get_bitrate (self);
}


static guint
noise_media_real_get_bitrate (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
	guint _tmp0_;
	self = base;
	_tmp0_ = self->priv->_bitrate;
	result = _tmp0_;
	return result;
}


void
noise_media_set_bitrate (NoiseMedia* self,
                         guint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_bitrate (self, value);
}


static void
noise_media_real_set_bitrate (NoiseMedia* base,
                              guint value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_bitrate (base) != value) {
		self->priv->_bitrate = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_BITRATE_PROPERTY]);
	}
}


guint
noise_media_get_bpm (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0U);
	return NOISE_MEDIA_GET_CLASS (self)->get_bpm (self);
}


static guint
noise_media_real_get_bpm (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
	guint _tmp0_;
	self = base;
	_tmp0_ = self->priv->_bpm;
	result = _tmp0_;
	return result;
}


void
noise_media_set_bpm (NoiseMedia* self,
                     guint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_bpm (self, value);
}


static void
noise_media_real_set_bpm (NoiseMedia* base,
                          guint value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_bpm (base) != value) {
		self->priv->_bpm = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_BPM_PROPERTY]);
	}
}


guint
noise_media_get_samplerate (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0U);
	return NOISE_MEDIA_GET_CLASS (self)->get_samplerate (self);
}


static guint
noise_media_real_get_samplerate (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
	guint _tmp0_;
	self = base;
	_tmp0_ = self->priv->_samplerate;
	result = _tmp0_;
	return result;
}


void
noise_media_set_samplerate (NoiseMedia* self,
                            guint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_samplerate (self, value);
}


static void
noise_media_real_set_samplerate (NoiseMedia* base,
                                 guint value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_samplerate (base) != value) {
		self->priv->_samplerate = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_SAMPLERATE_PROPERTY]);
	}
}


guint
noise_media_get_length (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0U);
	return NOISE_MEDIA_GET_CLASS (self)->get_length (self);
}


static guint
noise_media_real_get_length (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
	guint _tmp0_;
	self = base;
	_tmp0_ = self->priv->_length;
	result = _tmp0_;
	return result;
}


void
noise_media_set_length (NoiseMedia* self,
                        guint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_length (self, value);
}


static void
noise_media_real_set_length (NoiseMedia* base,
                             guint value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_length (base) != value) {
		self->priv->_length = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_LENGTH_PROPERTY]);
	}
}


guint
noise_media_get_rating (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0U);
	return NOISE_MEDIA_GET_CLASS (self)->get_rating (self);
}


static guint
noise_media_real_get_rating (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
	guint _tmp0_;
	self = base;
	_tmp0_ = self->_rating;
	result = _tmp0_;
	return result;
}


void
noise_media_set_rating (NoiseMedia* self,
                        guint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_rating (self, value);
}


static void
noise_media_real_set_rating (NoiseMedia* base,
                             guint value)
{
	NoiseMedia* self;
	self = base;
	self->_rating = CLAMP (value, (guint) 0, (guint) 5);
	g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_RATING_PROPERTY]);
}


guint
noise_media_get_play_count (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0U);
	return NOISE_MEDIA_GET_CLASS (self)->get_play_count (self);
}


static guint
noise_media_real_get_play_count (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
	guint _tmp0_;
	self = base;
	_tmp0_ = self->priv->_play_count;
	result = _tmp0_;
	return result;
}


void
noise_media_set_play_count (NoiseMedia* self,
                            guint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_play_count (self, value);
}


static void
noise_media_real_set_play_count (NoiseMedia* base,
                                 guint value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_play_count (base) != value) {
		self->priv->_play_count = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_PLAY_COUNT_PROPERTY]);
	}
}


guint
noise_media_get_skip_count (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0U);
	return NOISE_MEDIA_GET_CLASS (self)->get_skip_count (self);
}


static guint
noise_media_real_get_skip_count (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
	guint _tmp0_;
	self = base;
	_tmp0_ = self->priv->_skip_count;
	result = _tmp0_;
	return result;
}


void
noise_media_set_skip_count (NoiseMedia* self,
                            guint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_skip_count (self, value);
}


static void
noise_media_real_set_skip_count (NoiseMedia* base,
                                 guint value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_skip_count (base) != value) {
		self->priv->_skip_count = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_SKIP_COUNT_PROPERTY]);
	}
}


guint
noise_media_get_date_added (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0U);
	return NOISE_MEDIA_GET_CLASS (self)->get_date_added (self);
}


static guint
noise_media_real_get_date_added (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
	guint _tmp0_;
	self = base;
	_tmp0_ = self->priv->_date_added;
	result = _tmp0_;
	return result;
}


void
noise_media_set_date_added (NoiseMedia* self,
                            guint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_date_added (self, value);
}


static void
noise_media_real_set_date_added (NoiseMedia* base,
                                 guint value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_date_added (base) != value) {
		self->priv->_date_added = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_DATE_ADDED_PROPERTY]);
	}
}


guint
noise_media_get_last_played (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0U);
	return NOISE_MEDIA_GET_CLASS (self)->get_last_played (self);
}


static guint
noise_media_real_get_last_played (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
	guint _tmp0_;
	self = base;
	_tmp0_ = self->priv->_last_played;
	result = _tmp0_;
	return result;
}


void
noise_media_set_last_played (NoiseMedia* self,
                             guint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_last_played (self, value);
}


static void
noise_media_real_set_last_played (NoiseMedia* base,
                                  guint value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_last_played (base) != value) {
		self->priv->_last_played = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_LAST_PLAYED_PROPERTY]);
	}
}


guint
noise_media_get_last_modified (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0U);
	return NOISE_MEDIA_GET_CLASS (self)->get_last_modified (self);
}


static guint
noise_media_real_get_last_modified (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
	guint _tmp0_;
	self = base;
	_tmp0_ = self->priv->_last_modified;
	result = _tmp0_;
	return result;
}


void
noise_media_set_last_modified (NoiseMedia* self,
                               guint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_last_modified (self, value);
}


static void
noise_media_real_set_last_modified (NoiseMedia* base,
                                    guint value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_last_modified (base) != value) {
		self->priv->_last_modified = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_LAST_MODIFIED_PROPERTY]);
	}
}


gint
noise_media_get_resume_pos (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, 0);
	return NOISE_MEDIA_GET_CLASS (self)->get_resume_pos (self);
}


static gint
noise_media_real_get_resume_pos (NoiseMedia* base)
{
	gint result;
	NoiseMedia* self;
	gint _tmp0_;
	self = base;
	_tmp0_ = self->priv->_resume_pos;
	result = _tmp0_;
	return result;
}


void
noise_media_set_resume_pos (NoiseMedia* self,
                            gint value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_resume_pos (self, value);
}


static void
noise_media_real_set_resume_pos (NoiseMedia* base,
                                 gint value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_resume_pos (base) != value) {
		self->priv->_resume_pos = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_RESUME_POS_PROPERTY]);
	}
}


gboolean
noise_media_get_show (NoiseMedia* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return NOISE_MEDIA_GET_CLASS (self)->get_show (self);
}


static gboolean
noise_media_real_get_show (NoiseMedia* base)
{
	gboolean result;
	NoiseMedia* self;
	gboolean _tmp0_;
	self = base;
	_tmp0_ = self->priv->_show;
	result = _tmp0_;
	return result;
}


void
noise_media_set_show (NoiseMedia* self,
                      gboolean value)
{
	g_return_if_fail (self != NULL);
	NOISE_MEDIA_GET_CLASS (self)->set_show (self, value);
}


static void
noise_media_real_set_show (NoiseMedia* base,
                           gboolean value)
{
	NoiseMedia* self;
	self = base;
	if (noise_media_real_get_show (base) != value) {
		self->priv->_show = value;
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_SHOW_PROPERTY]);
	}
}


static void
noise_media_class_init (NoiseMediaClass * klass)
{
	gchar* _tmp0_;
	noise_media_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseMedia_private_offset);
	NOISE_MEDIA_CLASS (klass)->get_uri = noise_media_real_get_uri;
	NOISE_MEDIA_CLASS (klass)->set_uri = noise_media_real_set_uri;
	NOISE_MEDIA_CLASS (klass)->get_file_size = noise_media_real_get_file_size;
	NOISE_MEDIA_CLASS (klass)->set_file_size = noise_media_real_set_file_size;
	NOISE_MEDIA_CLASS (klass)->get_file_exists = noise_media_real_get_file_exists;
	NOISE_MEDIA_CLASS (klass)->get_file = noise_media_real_get_file;
	NOISE_MEDIA_CLASS (klass)->set_file = noise_media_real_set_file;
	NOISE_MEDIA_CLASS (klass)->get_isPreview = noise_media_real_get_isPreview;
	NOISE_MEDIA_CLASS (klass)->set_isPreview = noise_media_real_set_isPreview;
	NOISE_MEDIA_CLASS (klass)->get_isTemporary = noise_media_real_get_isTemporary;
	NOISE_MEDIA_CLASS (klass)->set_isTemporary = noise_media_real_set_isTemporary;
	NOISE_MEDIA_CLASS (klass)->get_location_unknown = noise_media_real_get_location_unknown;
	NOISE_MEDIA_CLASS (klass)->set_location_unknown = noise_media_real_set_location_unknown;
	NOISE_MEDIA_CLASS (klass)->get_has_embedded = noise_media_real_get_has_embedded;
	NOISE_MEDIA_CLASS (klass)->set_has_embedded = noise_media_real_set_has_embedded;
	NOISE_MEDIA_CLASS (klass)->get_unique_status_image = noise_media_real_get_unique_status_image;
	NOISE_MEDIA_CLASS (klass)->set_unique_status_image = noise_media_real_set_unique_status_image;
	NOISE_MEDIA_CLASS (klass)->get_showIndicator = noise_media_real_get_showIndicator;
	NOISE_MEDIA_CLASS (klass)->set_showIndicator = noise_media_real_set_showIndicator;
	NOISE_MEDIA_CLASS (klass)->get_title = noise_media_real_get_title;
	NOISE_MEDIA_CLASS (klass)->set_title = noise_media_real_set_title;
	NOISE_MEDIA_CLASS (klass)->get_track = noise_media_real_get_track;
	NOISE_MEDIA_CLASS (klass)->set_track = noise_media_real_set_track;
	NOISE_MEDIA_CLASS (klass)->get_track_count = noise_media_real_get_track_count;
	NOISE_MEDIA_CLASS (klass)->set_track_count = noise_media_real_set_track_count;
	NOISE_MEDIA_CLASS (klass)->get_composer = noise_media_real_get_composer;
	NOISE_MEDIA_CLASS (klass)->set_composer = noise_media_real_set_composer;
	NOISE_MEDIA_CLASS (klass)->get_artist = noise_media_real_get_artist;
	NOISE_MEDIA_CLASS (klass)->set_artist = noise_media_real_set_artist;
	NOISE_MEDIA_CLASS (klass)->get_album_artist = noise_media_real_get_album_artist;
	NOISE_MEDIA_CLASS (klass)->set_album_artist = noise_media_real_set_album_artist;
	NOISE_MEDIA_CLASS (klass)->get_album = noise_media_real_get_album;
	NOISE_MEDIA_CLASS (klass)->set_album = noise_media_real_set_album;
	NOISE_MEDIA_CLASS (klass)->get_album_number = noise_media_real_get_album_number;
	NOISE_MEDIA_CLASS (klass)->set_album_number = noise_media_real_set_album_number;
	NOISE_MEDIA_CLASS (klass)->get_album_count = noise_media_real_get_album_count;
	NOISE_MEDIA_CLASS (klass)->set_album_count = noise_media_real_set_album_count;
	NOISE_MEDIA_CLASS (klass)->get_album_info = noise_media_real_get_album_info;
	NOISE_MEDIA_CLASS (klass)->set_album_info = noise_media_real_set_album_info;
	NOISE_MEDIA_CLASS (klass)->get_grouping = noise_media_real_get_grouping;
	NOISE_MEDIA_CLASS (klass)->set_grouping = noise_media_real_set_grouping;
	NOISE_MEDIA_CLASS (klass)->get_genre = noise_media_real_get_genre;
	NOISE_MEDIA_CLASS (klass)->set_genre = noise_media_real_set_genre;
	NOISE_MEDIA_CLASS (klass)->get_comment = noise_media_real_get_comment;
	NOISE_MEDIA_CLASS (klass)->set_comment = noise_media_real_set_comment;
	NOISE_MEDIA_CLASS (klass)->get_lyrics = noise_media_real_get_lyrics;
	NOISE_MEDIA_CLASS (klass)->set_lyrics = noise_media_real_set_lyrics;
	NOISE_MEDIA_CLASS (klass)->get_year = noise_media_real_get_year;
	NOISE_MEDIA_CLASS (klass)->set_year = noise_media_real_set_year;
	NOISE_MEDIA_CLASS (klass)->get_bitrate = noise_media_real_get_bitrate;
	NOISE_MEDIA_CLASS (klass)->set_bitrate = noise_media_real_set_bitrate;
	NOISE_MEDIA_CLASS (klass)->get_bpm = noise_media_real_get_bpm;
	NOISE_MEDIA_CLASS (klass)->set_bpm = noise_media_real_set_bpm;
	NOISE_MEDIA_CLASS (klass)->get_samplerate = noise_media_real_get_samplerate;
	NOISE_MEDIA_CLASS (klass)->set_samplerate = noise_media_real_set_samplerate;
	NOISE_MEDIA_CLASS (klass)->get_length = noise_media_real_get_length;
	NOISE_MEDIA_CLASS (klass)->set_length = noise_media_real_set_length;
	NOISE_MEDIA_CLASS (klass)->get_rating = noise_media_real_get_rating;
	NOISE_MEDIA_CLASS (klass)->set_rating = noise_media_real_set_rating;
	NOISE_MEDIA_CLASS (klass)->get_play_count = noise_media_real_get_play_count;
	NOISE_MEDIA_CLASS (klass)->set_play_count = noise_media_real_set_play_count;
	NOISE_MEDIA_CLASS (klass)->get_skip_count = noise_media_real_get_skip_count;
	NOISE_MEDIA_CLASS (klass)->set_skip_count = noise_media_real_set_skip_count;
	NOISE_MEDIA_CLASS (klass)->get_date_added = noise_media_real_get_date_added;
	NOISE_MEDIA_CLASS (klass)->set_date_added = noise_media_real_set_date_added;
	NOISE_MEDIA_CLASS (klass)->get_last_played = noise_media_real_get_last_played;
	NOISE_MEDIA_CLASS (klass)->set_last_played = noise_media_real_set_last_played;
	NOISE_MEDIA_CLASS (klass)->get_last_modified = noise_media_real_get_last_modified;
	NOISE_MEDIA_CLASS (klass)->set_last_modified = noise_media_real_set_last_modified;
	NOISE_MEDIA_CLASS (klass)->get_resume_pos = noise_media_real_get_resume_pos;
	NOISE_MEDIA_CLASS (klass)->set_resume_pos = noise_media_real_set_resume_pos;
	NOISE_MEDIA_CLASS (klass)->get_show = noise_media_real_get_show;
	NOISE_MEDIA_CLASS (klass)->set_show = noise_media_real_set_show;
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_media_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_media_set_property;
	G_OBJECT_CLASS (klass)->finalize = noise_media_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ROWID_PROPERTY, noise_media_properties[NOISE_MEDIA_ROWID_PROPERTY] = g_param_spec_int64 ("rowid", "rowid", "rowid", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_URI_PROPERTY, noise_media_properties[NOISE_MEDIA_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_FILE_SIZE_PROPERTY, noise_media_properties[NOISE_MEDIA_FILE_SIZE_PROPERTY] = g_param_spec_uint64 ("file-size", "file-size", "file-size", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_FILE_EXISTS_PROPERTY, noise_media_properties[NOISE_MEDIA_FILE_EXISTS_PROPERTY] = g_param_spec_boolean ("file-exists", "file-exists", "file-exists", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_FILE_PROPERTY, noise_media_properties[NOISE_MEDIA_FILE_PROPERTY] = g_param_spec_object ("file", "file", "file", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_IS_PREVIEW_PROPERTY, noise_media_properties[NOISE_MEDIA_IS_PREVIEW_PROPERTY] = g_param_spec_boolean ("isPreview", "isPreview", "isPreview", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_IS_TEMPORARY_PROPERTY, noise_media_properties[NOISE_MEDIA_IS_TEMPORARY_PROPERTY] = g_param_spec_boolean ("isTemporary", "isTemporary", "isTemporary", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_LOCATION_UNKNOWN_PROPERTY, noise_media_properties[NOISE_MEDIA_LOCATION_UNKNOWN_PROPERTY] = g_param_spec_boolean ("location-unknown", "location-unknown", "location-unknown", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_HAS_EMBEDDED_PROPERTY, noise_media_properties[NOISE_MEDIA_HAS_EMBEDDED_PROPERTY] = g_param_spec_boolean ("has-embedded", "has-embedded", "has-embedded", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY, noise_media_properties[NOISE_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY] = g_param_spec_object ("unique-status-image", "unique-status-image", "unique-status-image", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_SHOW_INDICATOR_PROPERTY, noise_media_properties[NOISE_MEDIA_SHOW_INDICATOR_PROPERTY] = g_param_spec_boolean ("showIndicator", "showIndicator", "showIndicator", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Metadata Fields
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_TITLE_PROPERTY, noise_media_properties[NOISE_MEDIA_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_TRACK_PROPERTY, noise_media_properties[NOISE_MEDIA_TRACK_PROPERTY] = g_param_spec_uint ("track", "track", "track", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_TRACK_COUNT_PROPERTY, noise_media_properties[NOISE_MEDIA_TRACK_COUNT_PROPERTY] = g_param_spec_uint ("track-count", "track-count", "track-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_COMPOSER_PROPERTY, noise_media_properties[NOISE_MEDIA_COMPOSER_PROPERTY] = g_param_spec_string ("composer", "composer", "composer", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ARTIST_PROPERTY, noise_media_properties[NOISE_MEDIA_ARTIST_PROPERTY] = g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ALBUM_ARTIST_PROPERTY, noise_media_properties[NOISE_MEDIA_ALBUM_ARTIST_PROPERTY] = g_param_spec_string ("album-artist", "album-artist", "album-artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ALBUM_PROPERTY, noise_media_properties[NOISE_MEDIA_ALBUM_PROPERTY] = g_param_spec_string ("album", "album", "album", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ALBUM_NUMBER_PROPERTY, noise_media_properties[NOISE_MEDIA_ALBUM_NUMBER_PROPERTY] = g_param_spec_uint ("album-number", "album-number", "album-number", 0, G_MAXUINT, (guint) 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ALBUM_COUNT_PROPERTY, noise_media_properties[NOISE_MEDIA_ALBUM_COUNT_PROPERTY] = g_param_spec_uint ("album-count", "album-count", "album-count", 0, G_MAXUINT, (guint) 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ALBUM_INFO_PROPERTY, noise_media_properties[NOISE_MEDIA_ALBUM_INFO_PROPERTY] = g_param_spec_object ("album-info", "album-info", "album-info", NOISE_TYPE_ALBUM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_GROUPING_PROPERTY, noise_media_properties[NOISE_MEDIA_GROUPING_PROPERTY] = g_param_spec_string ("grouping", "grouping", "grouping", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_GENRE_PROPERTY, noise_media_properties[NOISE_MEDIA_GENRE_PROPERTY] = g_param_spec_string ("genre", "genre", "genre", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_COMMENT_PROPERTY, noise_media_properties[NOISE_MEDIA_COMMENT_PROPERTY] = g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_LYRICS_PROPERTY, noise_media_properties[NOISE_MEDIA_LYRICS_PROPERTY] = g_param_spec_string ("lyrics", "lyrics", "lyrics", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_YEAR_PROPERTY, noise_media_properties[NOISE_MEDIA_YEAR_PROPERTY] = g_param_spec_uint ("year", "year", "year", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_BITRATE_PROPERTY, noise_media_properties[NOISE_MEDIA_BITRATE_PROPERTY] = g_param_spec_uint ("bitrate", "bitrate", "bitrate", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_BPM_PROPERTY, noise_media_properties[NOISE_MEDIA_BPM_PROPERTY] = g_param_spec_uint ("bpm", "bpm", "bpm", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_SAMPLERATE_PROPERTY, noise_media_properties[NOISE_MEDIA_SAMPLERATE_PROPERTY] = g_param_spec_uint ("samplerate", "samplerate", "samplerate", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_LENGTH_PROPERTY, noise_media_properties[NOISE_MEDIA_LENGTH_PROPERTY] = g_param_spec_uint ("length", "length", "length", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_RATING_PROPERTY, noise_media_properties[NOISE_MEDIA_RATING_PROPERTY] = g_param_spec_uint ("rating", "rating", "rating", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Internal stats
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_PLAY_COUNT_PROPERTY, noise_media_properties[NOISE_MEDIA_PLAY_COUNT_PROPERTY] = g_param_spec_uint ("play-count", "play-count", "play-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_SKIP_COUNT_PROPERTY, noise_media_properties[NOISE_MEDIA_SKIP_COUNT_PROPERTY] = g_param_spec_uint ("skip-count", "skip-count", "skip-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_DATE_ADDED_PROPERTY, noise_media_properties[NOISE_MEDIA_DATE_ADDED_PROPERTY] = g_param_spec_uint ("date-added", "date-added", "date-added", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_LAST_PLAYED_PROPERTY, noise_media_properties[NOISE_MEDIA_LAST_PLAYED_PROPERTY] = g_param_spec_uint ("last-played", "last-played", "last-played", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_LAST_MODIFIED_PROPERTY, noise_media_properties[NOISE_MEDIA_LAST_MODIFIED_PROPERTY] = g_param_spec_uint ("last-modified", "last-modified", "last-modified", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_RESUME_POS_PROPERTY, noise_media_properties[NOISE_MEDIA_RESUME_POS_PROPERTY] = g_param_spec_int ("resume-pos", "resume-pos", "resume-pos", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_SHOW_PROPERTY, noise_media_properties[NOISE_MEDIA_SHOW_PROPERTY] = g_param_spec_boolean ("show", "show", "show", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	_tmp0_ = g_strdup (_ ("Unknown"));
	noise_media_UNKNOWN = _tmp0_;
}


static void
noise_media_instance_init (NoiseMedia * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	self->priv = noise_media_get_instance_private (self);
	self->priv->_file_size = (guint64) 0;
	self->priv->_isPreview = FALSE;
	self->priv->_isTemporary = FALSE;
	self->priv->_location_unknown = FALSE;
	self->priv->_has_embedded = FALSE;
	self->priv->_showIndicator = FALSE;
	_tmp0_ = g_strdup ("");
	self->priv->_title = _tmp0_;
	self->priv->_track = (guint) 0;
	self->priv->_track_count = (guint) 0;
	_tmp1_ = g_strdup ("");
	self->priv->_composer = _tmp1_;
	_tmp2_ = g_strdup ("");
	self->priv->_artist = _tmp2_;
	_tmp3_ = g_strdup ("");
	self->priv->_album_artist = _tmp3_;
	_tmp4_ = g_strdup ("");
	self->priv->_album = _tmp4_;
	self->priv->_album_number = (guint) 1;
	self->priv->_album_count = (guint) 1;
	self->priv->_album_info = NULL;
	_tmp5_ = g_strdup ("");
	self->priv->_grouping = _tmp5_;
	_tmp6_ = g_strdup ("");
	self->priv->_genre = _tmp6_;
	_tmp7_ = g_strdup ("");
	self->priv->_comment = _tmp7_;
	_tmp8_ = g_strdup ("");
	self->priv->_lyrics = _tmp8_;
	self->priv->_year = (guint) 0;
	self->priv->_bitrate = (guint) 0;
	self->priv->_bpm = (guint) 0;
	self->priv->_samplerate = (guint) 0;
	self->priv->_length = (guint) 0;
	self->priv->_play_count = (guint) 0;
	self->priv->_skip_count = (guint) 0;
	self->priv->_date_added = (guint) 0;
	self->priv->_last_played = (guint) 0;
	self->priv->_last_modified = (guint) 0;
	self->priv->_resume_pos = 0;
	self->priv->_show = TRUE;
}


static void
noise_media_finalize (GObject * obj)
{
	NoiseMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_MEDIA, NoiseMedia);
	_g_object_unref0 (self->priv->_file);
	_g_object_unref0 (self->priv->_unique_status_image);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->_composer);
	_g_free0 (self->priv->_artist);
	_g_free0 (self->priv->_album_artist);
	_g_free0 (self->priv->_album);
	_g_free0 (self->priv->_grouping);
	_g_free0 (self->priv->_genre);
	_g_free0 (self->priv->_comment);
	_g_free0 (self->priv->_lyrics);
	G_OBJECT_CLASS (noise_media_parent_class)->finalize (obj);
}


GType
noise_media_get_type (void)
{
	static volatile gsize noise_media_type_id__volatile = 0;
	if (g_once_init_enter (&noise_media_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseMediaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_media_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseMedia), 0, (GInstanceInitFunc) noise_media_instance_init, NULL };
		GType noise_media_type_id;
		noise_media_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseMedia", &g_define_type_info, 0);
		NoiseMedia_private_offset = g_type_add_instance_private (noise_media_type_id, sizeof (NoiseMediaPrivate));
		g_once_init_leave (&noise_media_type_id__volatile, noise_media_type_id);
	}
	return noise_media_type_id__volatile;
}


static void
_vala_noise_media_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	NoiseMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_MEDIA, NoiseMedia);
	switch (property_id) {
		case NOISE_MEDIA_ROWID_PROPERTY:
		g_value_set_int64 (value, noise_media_get_rowid (self));
		break;
		case NOISE_MEDIA_URI_PROPERTY:
		g_value_take_string (value, noise_media_get_uri (self));
		break;
		case NOISE_MEDIA_FILE_SIZE_PROPERTY:
		g_value_set_uint64 (value, noise_media_get_file_size (self));
		break;
		case NOISE_MEDIA_FILE_EXISTS_PROPERTY:
		g_value_set_boolean (value, noise_media_get_file_exists (self));
		break;
		case NOISE_MEDIA_FILE_PROPERTY:
		g_value_set_object (value, noise_media_get_file (self));
		break;
		case NOISE_MEDIA_IS_PREVIEW_PROPERTY:
		g_value_set_boolean (value, noise_media_get_isPreview (self));
		break;
		case NOISE_MEDIA_IS_TEMPORARY_PROPERTY:
		g_value_set_boolean (value, noise_media_get_isTemporary (self));
		break;
		case NOISE_MEDIA_LOCATION_UNKNOWN_PROPERTY:
		g_value_set_boolean (value, noise_media_get_location_unknown (self));
		break;
		case NOISE_MEDIA_HAS_EMBEDDED_PROPERTY:
		g_value_set_boolean (value, noise_media_get_has_embedded (self));
		break;
		case NOISE_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY:
		g_value_set_object (value, noise_media_get_unique_status_image (self));
		break;
		case NOISE_MEDIA_SHOW_INDICATOR_PROPERTY:
		g_value_set_boolean (value, noise_media_get_showIndicator (self));
		break;
		case NOISE_MEDIA_TITLE_PROPERTY:
		g_value_set_string (value, noise_media_get_title (self));
		break;
		case NOISE_MEDIA_TRACK_PROPERTY:
		g_value_set_uint (value, noise_media_get_track (self));
		break;
		case NOISE_MEDIA_TRACK_COUNT_PROPERTY:
		g_value_set_uint (value, noise_media_get_track_count (self));
		break;
		case NOISE_MEDIA_COMPOSER_PROPERTY:
		g_value_set_string (value, noise_media_get_composer (self));
		break;
		case NOISE_MEDIA_ARTIST_PROPERTY:
		g_value_set_string (value, noise_media_get_artist (self));
		break;
		case NOISE_MEDIA_ALBUM_ARTIST_PROPERTY:
		g_value_set_string (value, noise_media_get_album_artist (self));
		break;
		case NOISE_MEDIA_ALBUM_PROPERTY:
		g_value_set_string (value, noise_media_get_album (self));
		break;
		case NOISE_MEDIA_ALBUM_NUMBER_PROPERTY:
		g_value_set_uint (value, noise_media_get_album_number (self));
		break;
		case NOISE_MEDIA_ALBUM_COUNT_PROPERTY:
		g_value_set_uint (value, noise_media_get_album_count (self));
		break;
		case NOISE_MEDIA_ALBUM_INFO_PROPERTY:
		g_value_set_object (value, noise_media_get_album_info (self));
		break;
		case NOISE_MEDIA_GROUPING_PROPERTY:
		g_value_set_string (value, noise_media_get_grouping (self));
		break;
		case NOISE_MEDIA_GENRE_PROPERTY:
		g_value_set_string (value, noise_media_get_genre (self));
		break;
		case NOISE_MEDIA_COMMENT_PROPERTY:
		g_value_set_string (value, noise_media_get_comment (self));
		break;
		case NOISE_MEDIA_LYRICS_PROPERTY:
		g_value_set_string (value, noise_media_get_lyrics (self));
		break;
		case NOISE_MEDIA_YEAR_PROPERTY:
		g_value_set_uint (value, noise_media_get_year (self));
		break;
		case NOISE_MEDIA_BITRATE_PROPERTY:
		g_value_set_uint (value, noise_media_get_bitrate (self));
		break;
		case NOISE_MEDIA_BPM_PROPERTY:
		g_value_set_uint (value, noise_media_get_bpm (self));
		break;
		case NOISE_MEDIA_SAMPLERATE_PROPERTY:
		g_value_set_uint (value, noise_media_get_samplerate (self));
		break;
		case NOISE_MEDIA_LENGTH_PROPERTY:
		g_value_set_uint (value, noise_media_get_length (self));
		break;
		case NOISE_MEDIA_RATING_PROPERTY:
		g_value_set_uint (value, noise_media_get_rating (self));
		break;
		case NOISE_MEDIA_PLAY_COUNT_PROPERTY:
		g_value_set_uint (value, noise_media_get_play_count (self));
		break;
		case NOISE_MEDIA_SKIP_COUNT_PROPERTY:
		g_value_set_uint (value, noise_media_get_skip_count (self));
		break;
		case NOISE_MEDIA_DATE_ADDED_PROPERTY:
		g_value_set_uint (value, noise_media_get_date_added (self));
		break;
		case NOISE_MEDIA_LAST_PLAYED_PROPERTY:
		g_value_set_uint (value, noise_media_get_last_played (self));
		break;
		case NOISE_MEDIA_LAST_MODIFIED_PROPERTY:
		g_value_set_uint (value, noise_media_get_last_modified (self));
		break;
		case NOISE_MEDIA_RESUME_POS_PROPERTY:
		g_value_set_int (value, noise_media_get_resume_pos (self));
		break;
		case NOISE_MEDIA_SHOW_PROPERTY:
		g_value_set_boolean (value, noise_media_get_show (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_media_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	NoiseMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_MEDIA, NoiseMedia);
	switch (property_id) {
		case NOISE_MEDIA_ROWID_PROPERTY:
		noise_media_set_rowid (self, g_value_get_int64 (value));
		break;
		case NOISE_MEDIA_URI_PROPERTY:
		noise_media_set_uri (self, g_value_get_string (value));
		break;
		case NOISE_MEDIA_FILE_SIZE_PROPERTY:
		noise_media_set_file_size (self, g_value_get_uint64 (value));
		break;
		case NOISE_MEDIA_FILE_PROPERTY:
		noise_media_set_file (self, g_value_get_object (value));
		break;
		case NOISE_MEDIA_IS_PREVIEW_PROPERTY:
		noise_media_set_isPreview (self, g_value_get_boolean (value));
		break;
		case NOISE_MEDIA_IS_TEMPORARY_PROPERTY:
		noise_media_set_isTemporary (self, g_value_get_boolean (value));
		break;
		case NOISE_MEDIA_LOCATION_UNKNOWN_PROPERTY:
		noise_media_set_location_unknown (self, g_value_get_boolean (value));
		break;
		case NOISE_MEDIA_HAS_EMBEDDED_PROPERTY:
		noise_media_set_has_embedded (self, g_value_get_boolean (value));
		break;
		case NOISE_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY:
		noise_media_set_unique_status_image (self, g_value_get_object (value));
		break;
		case NOISE_MEDIA_SHOW_INDICATOR_PROPERTY:
		noise_media_set_showIndicator (self, g_value_get_boolean (value));
		break;
		case NOISE_MEDIA_TITLE_PROPERTY:
		noise_media_set_title (self, g_value_get_string (value));
		break;
		case NOISE_MEDIA_TRACK_PROPERTY:
		noise_media_set_track (self, g_value_get_uint (value));
		break;
		case NOISE_MEDIA_TRACK_COUNT_PROPERTY:
		noise_media_set_track_count (self, g_value_get_uint (value));
		break;
		case NOISE_MEDIA_COMPOSER_PROPERTY:
		noise_media_set_composer (self, g_value_get_string (value));
		break;
		case NOISE_MEDIA_ARTIST_PROPERTY:
		noise_media_set_artist (self, g_value_get_string (value));
		break;
		case NOISE_MEDIA_ALBUM_ARTIST_PROPERTY:
		noise_media_set_album_artist (self, g_value_get_string (value));
		break;
		case NOISE_MEDIA_ALBUM_PROPERTY:
		noise_media_set_album (self, g_value_get_string (value));
		break;
		case NOISE_MEDIA_ALBUM_NUMBER_PROPERTY:
		noise_media_set_album_number (self, g_value_get_uint (value));
		break;
		case NOISE_MEDIA_ALBUM_COUNT_PROPERTY:
		noise_media_set_album_count (self, g_value_get_uint (value));
		break;
		case NOISE_MEDIA_ALBUM_INFO_PROPERTY:
		noise_media_set_album_info (self, g_value_get_object (value));
		break;
		case NOISE_MEDIA_GROUPING_PROPERTY:
		noise_media_set_grouping (self, g_value_get_string (value));
		break;
		case NOISE_MEDIA_GENRE_PROPERTY:
		noise_media_set_genre (self, g_value_get_string (value));
		break;
		case NOISE_MEDIA_COMMENT_PROPERTY:
		noise_media_set_comment (self, g_value_get_string (value));
		break;
		case NOISE_MEDIA_LYRICS_PROPERTY:
		noise_media_set_lyrics (self, g_value_get_string (value));
		break;
		case NOISE_MEDIA_YEAR_PROPERTY:
		noise_media_set_year (self, g_value_get_uint (value));
		break;
		case NOISE_MEDIA_BITRATE_PROPERTY:
		noise_media_set_bitrate (self, g_value_get_uint (value));
		break;
		case NOISE_MEDIA_BPM_PROPERTY:
		noise_media_set_bpm (self, g_value_get_uint (value));
		break;
		case NOISE_MEDIA_SAMPLERATE_PROPERTY:
		noise_media_set_samplerate (self, g_value_get_uint (value));
		break;
		case NOISE_MEDIA_LENGTH_PROPERTY:
		noise_media_set_length (self, g_value_get_uint (value));
		break;
		case NOISE_MEDIA_RATING_PROPERTY:
		noise_media_set_rating (self, g_value_get_uint (value));
		break;
		case NOISE_MEDIA_PLAY_COUNT_PROPERTY:
		noise_media_set_play_count (self, g_value_get_uint (value));
		break;
		case NOISE_MEDIA_SKIP_COUNT_PROPERTY:
		noise_media_set_skip_count (self, g_value_get_uint (value));
		break;
		case NOISE_MEDIA_DATE_ADDED_PROPERTY:
		noise_media_set_date_added (self, g_value_get_uint (value));
		break;
		case NOISE_MEDIA_LAST_PLAYED_PROPERTY:
		noise_media_set_last_played (self, g_value_get_uint (value));
		break;
		case NOISE_MEDIA_LAST_MODIFIED_PROPERTY:
		noise_media_set_last_modified (self, g_value_get_uint (value));
		break;
		case NOISE_MEDIA_RESUME_POS_PROPERTY:
		noise_media_set_resume_pos (self, g_value_get_int (value));
		break;
		case NOISE_MEDIA_SHOW_PROPERTY:
		noise_media_set_show (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



