/* SmartQuery.c generated by valac 0.41.91, the Vala compiler
 * generated from SmartQuery.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>


#define NOISE_TYPE_SMART_QUERY (noise_smart_query_get_type ())
#define NOISE_SMART_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SMART_QUERY, NoiseSmartQuery))
#define NOISE_SMART_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SMART_QUERY, NoiseSmartQueryClass))
#define NOISE_IS_SMART_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SMART_QUERY))
#define NOISE_IS_SMART_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SMART_QUERY))
#define NOISE_SMART_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SMART_QUERY, NoiseSmartQueryClass))

typedef struct _NoiseSmartQuery NoiseSmartQuery;
typedef struct _NoiseSmartQueryClass NoiseSmartQueryClass;
typedef struct _NoiseSmartQueryPrivate NoiseSmartQueryPrivate;

#define NOISE_SMART_QUERY_TYPE_FIELD_TYPE (noise_smart_query_field_type_get_type ())

#define NOISE_SMART_QUERY_TYPE_COMPARATOR_TYPE (noise_smart_query_comparator_type_get_type ())
enum  {
	NOISE_SMART_QUERY_0_PROPERTY,
	NOISE_SMART_QUERY_ROWID_PROPERTY,
	NOISE_SMART_QUERY_FIELD_PROPERTY,
	NOISE_SMART_QUERY_COMPARATOR_PROPERTY,
	NOISE_SMART_QUERY_VALUE_PROPERTY,
	NOISE_SMART_QUERY_NUM_PROPERTIES
};
static GParamSpec* noise_smart_query_properties[NOISE_SMART_QUERY_NUM_PROPERTIES];

struct _NoiseSmartQuery {
	GObject parent_instance;
	NoiseSmartQueryPrivate * priv;
};

struct _NoiseSmartQueryClass {
	GObjectClass parent_class;
};

typedef enum  {
	NOISE_SMART_QUERY_FIELD_TYPE_ALBUM,
	NOISE_SMART_QUERY_FIELD_TYPE_ARTIST,
	NOISE_SMART_QUERY_FIELD_TYPE_BITRATE,
	NOISE_SMART_QUERY_FIELD_TYPE_COMMENT,
	NOISE_SMART_QUERY_FIELD_TYPE_COMPOSER,
	NOISE_SMART_QUERY_FIELD_TYPE_DATE_ADDED,
	NOISE_SMART_QUERY_FIELD_TYPE_GENRE,
	NOISE_SMART_QUERY_FIELD_TYPE_GROUPING,
	NOISE_SMART_QUERY_FIELD_TYPE_LAST_PLAYED,
	NOISE_SMART_QUERY_FIELD_TYPE_LENGTH,
	NOISE_SMART_QUERY_FIELD_TYPE_PLAYCOUNT,
	NOISE_SMART_QUERY_FIELD_TYPE_RATING,
	NOISE_SMART_QUERY_FIELD_TYPE_SKIPCOUNT,
	NOISE_SMART_QUERY_FIELD_TYPE_TITLE,
	NOISE_SMART_QUERY_FIELD_TYPE_YEAR,
	NOISE_SMART_QUERY_FIELD_TYPE_URI
} NoiseSmartQueryFieldType;

typedef enum  {
	NOISE_SMART_QUERY_COMPARATOR_TYPE_IS,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_NOT,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_CONTAINS,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_WITHIN,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_BEFORE
} NoiseSmartQueryComparatorType;

struct _NoiseSmartQueryPrivate {
	gint _rowid;
	NoiseSmartQueryFieldType _field;
	NoiseSmartQueryComparatorType _comparator;
	GValue _value;
};


static gint NoiseSmartQuery_private_offset;
static gpointer noise_smart_query_parent_class = NULL;

GType noise_smart_query_get_type (void) G_GNUC_CONST;
GType noise_smart_query_field_type_get_type (void) G_GNUC_CONST;
GType noise_smart_query_comparator_type_get_type (void) G_GNUC_CONST;
NoiseSmartQuery* noise_smart_query_new (void);
NoiseSmartQuery* noise_smart_query_construct (GType object_type);
NoiseSmartQuery* noise_smart_query_new_with_info (NoiseSmartQueryFieldType field,
                                                  NoiseSmartQueryComparatorType comparator,
                                                  GValue* value);
NoiseSmartQuery* noise_smart_query_construct_with_info (GType object_type,
                                                        NoiseSmartQueryFieldType field,
                                                        NoiseSmartQueryComparatorType comparator,
                                                        GValue* value);
void noise_smart_query_set_field (NoiseSmartQuery* self,
                                  NoiseSmartQueryFieldType value);
void noise_smart_query_set_comparator (NoiseSmartQuery* self,
                                       NoiseSmartQueryComparatorType value);
void noise_smart_query_set_value (NoiseSmartQuery* self,
                                  GValue * value);
gint noise_smart_query_get_rowid (NoiseSmartQuery* self);
void noise_smart_query_set_rowid (NoiseSmartQuery* self,
                                  gint value);
NoiseSmartQueryFieldType noise_smart_query_get_field (NoiseSmartQuery* self);
NoiseSmartQueryComparatorType noise_smart_query_get_comparator (NoiseSmartQuery* self);
void noise_smart_query_get_value (NoiseSmartQuery* self,
                                  GValue * result);
static gboolean _g_value_equal (const GValue * s1,
                         const GValue * s2);
static void noise_smart_query_finalize (GObject * obj);
static void _vala_noise_smart_query_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_noise_smart_query_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);


static inline gpointer
noise_smart_query_get_instance_private (NoiseSmartQuery* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseSmartQuery_private_offset);
}


GType
noise_smart_query_comparator_type_get_type (void)
{
	static volatile gsize noise_smart_query_comparator_type_type_id__volatile = 0;
	if (g_once_init_enter (&noise_smart_query_comparator_type_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_SMART_QUERY_COMPARATOR_TYPE_IS, "NOISE_SMART_QUERY_COMPARATOR_TYPE_IS", "is"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_NOT, "NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_NOT", "is-not"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_CONTAINS, "NOISE_SMART_QUERY_COMPARATOR_TYPE_CONTAINS", "contains"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS, "NOISE_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS", "not-contains"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY, "NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY", "is-exactly"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST, "NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST", "is-at-most"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST, "NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST", "is-at-least"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_WITHIN, "NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_WITHIN", "is-within"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_BEFORE, "NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_BEFORE", "is-before"}, {0, NULL, NULL}};
		GType noise_smart_query_comparator_type_type_id;
		noise_smart_query_comparator_type_type_id = g_enum_register_static ("NoiseSmartQueryComparatorType", values);
		g_once_init_leave (&noise_smart_query_comparator_type_type_id__volatile, noise_smart_query_comparator_type_type_id);
	}
	return noise_smart_query_comparator_type_type_id__volatile;
}


GType
noise_smart_query_field_type_get_type (void)
{
	static volatile gsize noise_smart_query_field_type_type_id__volatile = 0;
	if (g_once_init_enter (&noise_smart_query_field_type_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_SMART_QUERY_FIELD_TYPE_ALBUM, "NOISE_SMART_QUERY_FIELD_TYPE_ALBUM", "album"}, {NOISE_SMART_QUERY_FIELD_TYPE_ARTIST, "NOISE_SMART_QUERY_FIELD_TYPE_ARTIST", "artist"}, {NOISE_SMART_QUERY_FIELD_TYPE_BITRATE, "NOISE_SMART_QUERY_FIELD_TYPE_BITRATE", "bitrate"}, {NOISE_SMART_QUERY_FIELD_TYPE_COMMENT, "NOISE_SMART_QUERY_FIELD_TYPE_COMMENT", "comment"}, {NOISE_SMART_QUERY_FIELD_TYPE_COMPOSER, "NOISE_SMART_QUERY_FIELD_TYPE_COMPOSER", "composer"}, {NOISE_SMART_QUERY_FIELD_TYPE_DATE_ADDED, "NOISE_SMART_QUERY_FIELD_TYPE_DATE_ADDED", "date-added"}, {NOISE_SMART_QUERY_FIELD_TYPE_GENRE, "NOISE_SMART_QUERY_FIELD_TYPE_GENRE", "genre"}, {NOISE_SMART_QUERY_FIELD_TYPE_GROUPING, "NOISE_SMART_QUERY_FIELD_TYPE_GROUPING", "grouping"}, {NOISE_SMART_QUERY_FIELD_TYPE_LAST_PLAYED, "NOISE_SMART_QUERY_FIELD_TYPE_LAST_PLAYED", "last-played"}, {NOISE_SMART_QUERY_FIELD_TYPE_LENGTH, "NOISE_SMART_QUERY_FIELD_TYPE_LENGTH", "length"}, {NOISE_SMART_QUERY_FIELD_TYPE_PLAYCOUNT, "NOISE_SMART_QUERY_FIELD_TYPE_PLAYCOUNT", "playcount"}, {NOISE_SMART_QUERY_FIELD_TYPE_RATING, "NOISE_SMART_QUERY_FIELD_TYPE_RATING", "rating"}, {NOISE_SMART_QUERY_FIELD_TYPE_SKIPCOUNT, "NOISE_SMART_QUERY_FIELD_TYPE_SKIPCOUNT", "skipcount"}, {NOISE_SMART_QUERY_FIELD_TYPE_TITLE, "NOISE_SMART_QUERY_FIELD_TYPE_TITLE", "title"}, {NOISE_SMART_QUERY_FIELD_TYPE_YEAR, "NOISE_SMART_QUERY_FIELD_TYPE_YEAR", "year"}, {NOISE_SMART_QUERY_FIELD_TYPE_URI, "NOISE_SMART_QUERY_FIELD_TYPE_URI", "uri"}, {0, NULL, NULL}};
		GType noise_smart_query_field_type_type_id;
		noise_smart_query_field_type_type_id = g_enum_register_static ("NoiseSmartQueryFieldType", values);
		g_once_init_leave (&noise_smart_query_field_type_type_id__volatile, noise_smart_query_field_type_type_id);
	}
	return noise_smart_query_field_type_type_id__volatile;
}


NoiseSmartQuery*
noise_smart_query_construct (GType object_type)
{
	NoiseSmartQuery * self = NULL;
	self = (NoiseSmartQuery*) g_object_new (object_type, NULL);
	return self;
}


NoiseSmartQuery*
noise_smart_query_new (void)
{
	return noise_smart_query_construct (NOISE_TYPE_SMART_QUERY);
}


NoiseSmartQuery*
noise_smart_query_construct_with_info (GType object_type,
                                       NoiseSmartQueryFieldType field,
                                       NoiseSmartQueryComparatorType comparator,
                                       GValue* value)
{
	NoiseSmartQuery * self = NULL;
	GValue _tmp0_;
	g_return_val_if_fail (value != NULL, NULL);
	self = (NoiseSmartQuery*) g_object_new (object_type, NULL);
	noise_smart_query_set_field (self, field);
	noise_smart_query_set_comparator (self, comparator);
	_tmp0_ = *value;
	noise_smart_query_set_value (self, &_tmp0_);
	return self;
}


NoiseSmartQuery*
noise_smart_query_new_with_info (NoiseSmartQueryFieldType field,
                                 NoiseSmartQueryComparatorType comparator,
                                 GValue* value)
{
	return noise_smart_query_construct_with_info (NOISE_TYPE_SMART_QUERY, field, comparator, value);
}


gint
noise_smart_query_get_rowid (NoiseSmartQuery* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_rowid;
	result = _tmp0_;
	return result;
}


void
noise_smart_query_set_rowid (NoiseSmartQuery* self,
                             gint value)
{
	g_return_if_fail (self != NULL);
	if (noise_smart_query_get_rowid (self) != value) {
		self->priv->_rowid = value;
		g_object_notify_by_pspec ((GObject *) self, noise_smart_query_properties[NOISE_SMART_QUERY_ROWID_PROPERTY]);
	}
}


NoiseSmartQueryFieldType
noise_smart_query_get_field (NoiseSmartQuery* self)
{
	NoiseSmartQueryFieldType result;
	NoiseSmartQueryFieldType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_field;
	result = _tmp0_;
	return result;
}


void
noise_smart_query_set_field (NoiseSmartQuery* self,
                             NoiseSmartQueryFieldType value)
{
	g_return_if_fail (self != NULL);
	if (noise_smart_query_get_field (self) != value) {
		self->priv->_field = value;
		g_object_notify_by_pspec ((GObject *) self, noise_smart_query_properties[NOISE_SMART_QUERY_FIELD_PROPERTY]);
	}
}


NoiseSmartQueryComparatorType
noise_smart_query_get_comparator (NoiseSmartQuery* self)
{
	NoiseSmartQueryComparatorType result;
	NoiseSmartQueryComparatorType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_comparator;
	result = _tmp0_;
	return result;
}


void
noise_smart_query_set_comparator (NoiseSmartQuery* self,
                                  NoiseSmartQueryComparatorType value)
{
	g_return_if_fail (self != NULL);
	if (noise_smart_query_get_comparator (self) != value) {
		self->priv->_comparator = value;
		g_object_notify_by_pspec ((GObject *) self, noise_smart_query_properties[NOISE_SMART_QUERY_COMPARATOR_PROPERTY]);
	}
}


void
noise_smart_query_get_value (NoiseSmartQuery* self,
                             GValue * result)
{
	GValue _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_value;
	*result = _tmp0_;
	return;
}


static gboolean
_g_value_equal (const GValue * s1,
                const GValue * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	return FALSE;
}


void
noise_smart_query_set_value (NoiseSmartQuery* self,
                             GValue * value)
{
	GValue old_value;
	g_return_if_fail (self != NULL);
	if (_g_value_equal (value, (noise_smart_query_get_value (self, &old_value), &old_value)) != TRUE) {
		GValue _tmp0_;
		GValue _tmp1_ = {0};
		_tmp0_ = *value;
		if (G_IS_VALUE (&_tmp0_)) {
			g_value_init (&_tmp1_, G_VALUE_TYPE (&_tmp0_));
			g_value_copy (&_tmp0_, &_tmp1_);
		} else {
			_tmp1_ = _tmp0_;
		}
		G_IS_VALUE (&self->priv->_value) ? (g_value_unset (&self->priv->_value), NULL) : NULL;
		self->priv->_value = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, noise_smart_query_properties[NOISE_SMART_QUERY_VALUE_PROPERTY]);
	}
}


static void
noise_smart_query_class_init (NoiseSmartQueryClass * klass)
{
	noise_smart_query_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseSmartQuery_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_smart_query_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_smart_query_set_property;
	G_OBJECT_CLASS (klass)->finalize = noise_smart_query_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SMART_QUERY_ROWID_PROPERTY, noise_smart_query_properties[NOISE_SMART_QUERY_ROWID_PROPERTY] = g_param_spec_int ("rowid", "rowid", "rowid", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SMART_QUERY_FIELD_PROPERTY, noise_smart_query_properties[NOISE_SMART_QUERY_FIELD_PROPERTY] = g_param_spec_enum ("field", "field", "field", NOISE_SMART_QUERY_TYPE_FIELD_TYPE, NOISE_SMART_QUERY_FIELD_TYPE_ALBUM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SMART_QUERY_COMPARATOR_PROPERTY, noise_smart_query_properties[NOISE_SMART_QUERY_COMPARATOR_PROPERTY] = g_param_spec_enum ("comparator", "comparator", "comparator", NOISE_SMART_QUERY_TYPE_COMPARATOR_TYPE, NOISE_SMART_QUERY_COMPARATOR_TYPE_IS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SMART_QUERY_VALUE_PROPERTY, noise_smart_query_properties[NOISE_SMART_QUERY_VALUE_PROPERTY] = g_param_spec_boxed ("value", "value", "value", G_TYPE_VALUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void
noise_smart_query_instance_init (NoiseSmartQuery * self)
{
	GValue _tmp0_ = {0};
	self->priv = noise_smart_query_get_instance_private (self);
	self->priv->_rowid = 0;
	self->priv->_field = NOISE_SMART_QUERY_FIELD_TYPE_ALBUM;
	self->priv->_comparator = NOISE_SMART_QUERY_COMPARATOR_TYPE_IS;
	g_value_init (&_tmp0_, G_TYPE_INT);
	self->priv->_value = _tmp0_;
}


static void
noise_smart_query_finalize (GObject * obj)
{
	NoiseSmartQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SMART_QUERY, NoiseSmartQuery);
	G_IS_VALUE (&self->priv->_value) ? (g_value_unset (&self->priv->_value), NULL) : NULL;
	G_OBJECT_CLASS (noise_smart_query_parent_class)->finalize (obj);
}


GType
noise_smart_query_get_type (void)
{
	static volatile gsize noise_smart_query_type_id__volatile = 0;
	if (g_once_init_enter (&noise_smart_query_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSmartQueryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_smart_query_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSmartQuery), 0, (GInstanceInitFunc) noise_smart_query_instance_init, NULL };
		GType noise_smart_query_type_id;
		noise_smart_query_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseSmartQuery", &g_define_type_info, 0);
		NoiseSmartQuery_private_offset = g_type_add_instance_private (noise_smart_query_type_id, sizeof (NoiseSmartQueryPrivate));
		g_once_init_leave (&noise_smart_query_type_id__volatile, noise_smart_query_type_id);
	}
	return noise_smart_query_type_id__volatile;
}


static void
_vala_noise_smart_query_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	NoiseSmartQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SMART_QUERY, NoiseSmartQuery);
	switch (property_id) {
		case NOISE_SMART_QUERY_ROWID_PROPERTY:
		g_value_set_int (value, noise_smart_query_get_rowid (self));
		break;
		case NOISE_SMART_QUERY_FIELD_PROPERTY:
		g_value_set_enum (value, noise_smart_query_get_field (self));
		break;
		case NOISE_SMART_QUERY_COMPARATOR_PROPERTY:
		g_value_set_enum (value, noise_smart_query_get_comparator (self));
		break;
		case NOISE_SMART_QUERY_VALUE_PROPERTY:
		{
			GValue boxed;
			noise_smart_query_get_value (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_smart_query_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	NoiseSmartQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SMART_QUERY, NoiseSmartQuery);
	switch (property_id) {
		case NOISE_SMART_QUERY_ROWID_PROPERTY:
		noise_smart_query_set_rowid (self, g_value_get_int (value));
		break;
		case NOISE_SMART_QUERY_FIELD_PROPERTY:
		noise_smart_query_set_field (self, g_value_get_enum (value));
		break;
		case NOISE_SMART_QUERY_COMPARATOR_PROPERTY:
		noise_smart_query_set_comparator (self, g_value_get_enum (value));
		break;
		case NOISE_SMART_QUERY_VALUE_PROPERTY:
		noise_smart_query_set_value (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



