/* Icon.c generated by valac 0.41.91, the Vala compiler
 * generated from Icon.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define NOISE_TYPE_ICON (noise_icon_get_type ())
#define NOISE_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_ICON, NoiseIcon))
#define NOISE_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_ICON, NoiseIconClass))
#define NOISE_IS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_ICON))
#define NOISE_IS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_ICON))
#define NOISE_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_ICON, NoiseIconClass))

typedef struct _NoiseIcon NoiseIcon;
typedef struct _NoiseIconClass NoiseIconClass;
typedef struct _NoiseIconPrivate NoiseIconPrivate;
enum  {
	NOISE_ICON_0_PROPERTY,
	NOISE_ICON_NAME_PROPERTY,
	NOISE_ICON_GICON_PROPERTY,
	NOISE_ICON_NUM_PROPERTIES
};
static GParamSpec* noise_icon_properties[NOISE_ICON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gtk_icon_info_free0(var) ((var == NULL) ? NULL : (var = (gtk_icon_info_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NoiseIcon {
	GObject parent_instance;
	NoiseIconPrivate * priv;
};

struct _NoiseIconClass {
	GObjectClass parent_class;
};

struct _NoiseIconPrivate {
	gchar* _name;
	GIcon* _gicon;
};


static gint NoiseIcon_private_offset;
static gpointer noise_icon_parent_class = NULL;
static GtkIconTheme* noise_icon__theme;
static GtkIconTheme* noise_icon__theme = NULL;

GType noise_icon_get_type (void) G_GNUC_CONST;
NoiseIcon* noise_icon_new (const gchar* name);
NoiseIcon* noise_icon_construct (GType object_type,
                                 const gchar* name);
static void noise_icon_set_name (NoiseIcon* self,
                          const gchar* value);
const gchar* noise_icon_get_name (NoiseIcon* self);
static void noise_icon_set_gicon (NoiseIcon* self,
                           GIcon* value);
GtkIconInfo* noise_icon_get_icon_info (NoiseIcon* self,
                                       gint size);
GtkIconTheme* noise_icon_get_theme (void);
GIcon* noise_icon_get_gicon (NoiseIcon* self);
GFile* noise_icon_get_file (NoiseIcon* self,
                            gint size);
GdkPixbuf* noise_icon_render (NoiseIcon* self,
                              GtkIconSize size,
                              GtkStyleContext* style_context);
static void noise_icon_finalize (GObject * obj);
static void _vala_noise_icon_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_noise_icon_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);


static inline gpointer
noise_icon_get_instance_private (NoiseIcon* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseIcon_private_offset);
}


/**
     * Creates a new icon object.
     *
     * @param name The icon name (without filename extension), to be loaded from
     * the available icon themes.
     */
NoiseIcon*
noise_icon_construct (GType object_type,
                      const gchar* name)
{
	NoiseIcon * self = NULL;
	const gchar* _tmp0_;
	GThemedIcon* _tmp1_;
	GThemedIcon* _tmp2_;
	g_return_val_if_fail (name != NULL, NULL);
	self = (NoiseIcon*) g_object_new (object_type, NULL);
	noise_icon_set_name (self, name);
	_tmp0_ = self->priv->_name;
	_tmp1_ = (GThemedIcon*) g_themed_icon_new (_tmp0_);
	_tmp2_ = _tmp1_;
	noise_icon_set_gicon (self, (GIcon*) _tmp2_);
	_g_object_unref0 (_tmp2_);
	return self;
}


NoiseIcon*
noise_icon_new (const gchar* name)
{
	return noise_icon_construct (NOISE_TYPE_ICON, name);
}


GtkIconInfo*
noise_icon_get_icon_info (NoiseIcon* self,
                          gint size)
{
	GtkIconInfo* result = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
	GIcon* _tmp2_;
	GtkIconInfo* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_icon_get_theme ();
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->_gicon;
	_tmp3_ = gtk_icon_theme_lookup_by_gicon (_tmp1_, _tmp2_, size, GTK_ICON_LOOKUP_USE_BUILTIN);
	result = _tmp3_;
	return result;
}


/**
     * Returns a file representing the icon in the filesystem.
     * @param size Icon size to query.
     * @return A {@link GLib.File} representing the icon, or //null// if none is found.
     */
GFile*
noise_icon_get_file (NoiseIcon* self,
                     gint size)
{
	GFile* result = NULL;
	GtkIconInfo* info = NULL;
	GtkIconInfo* _tmp0_;
	GFile* _tmp1_ = NULL;
	GtkIconInfo* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_icon_get_icon_info (self, size);
	info = _tmp0_;
	_tmp2_ = info;
	if (_tmp2_ != NULL) {
		GtkIconInfo* _tmp3_;
		const gchar* _tmp4_;
		GFile* _tmp5_;
		_tmp3_ = info;
		_tmp4_ = gtk_icon_info_get_filename (_tmp3_);
		_tmp5_ = g_file_new_for_path (_tmp4_);
		_g_object_unref0 (_tmp1_);
		_tmp1_ = _tmp5_;
	} else {
		_g_object_unref0 (_tmp1_);
		_tmp1_ = NULL;
	}
	result = _tmp1_;
	_gtk_icon_info_free0 (info);
	return result;
}


/**
     * Creates a new {@link Gdk.Pixbuf} from the icon at the specified icon size.
     *
     * @param size The pixbuf's icon size.
     * @param style_context The style context used to render the icon, or null to use none.
     * @return a newly-created Gdk.Pixbuf displaying the icon (or a "missing-image" icon)
     */
GdkPixbuf*
noise_icon_render (NoiseIcon* self,
                   GtkIconSize size,
                   GtkStyleContext* style_context)
{
	GdkPixbuf* result = NULL;
	gint width = 0;
	gint height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint pixel_size = 0;
	gint _tmp2_;
	gint _tmp3_;
	GdkPixbuf* rv = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	gtk_icon_size_lookup (size, &_tmp0_, &_tmp1_);
	width = _tmp0_;
	height = _tmp1_;
	_tmp2_ = width;
	_tmp3_ = height;
	pixel_size = MAX (_tmp2_, _tmp3_);
	rv = NULL;
	{
		GtkIconInfo* icon_info = NULL;
		gint _tmp4_;
		GtkIconInfo* _tmp5_;
		GtkIconInfo* _tmp6_;
		GdkPixbuf* _tmp15_;
		_tmp4_ = pixel_size;
		_tmp5_ = noise_icon_get_icon_info (self, _tmp4_);
		icon_info = _tmp5_;
		_tmp6_ = icon_info;
		if (_tmp6_ != NULL) {
			if (style_context != NULL) {
				GdkPixbuf* _tmp7_ = NULL;
				GtkIconInfo* _tmp8_;
				GdkPixbuf* _tmp9_;
				GdkPixbuf* _tmp10_;
				_tmp8_ = icon_info;
				_tmp9_ = gtk_icon_info_load_symbolic_for_context (_tmp8_, style_context, NULL, &_inner_error_);
				_tmp7_ = _tmp9_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_gtk_icon_info_free0 (icon_info);
					goto __catch13_g_error;
				}
				_tmp10_ = _tmp7_;
				_tmp7_ = NULL;
				_g_object_unref0 (rv);
				rv = _tmp10_;
				_g_object_unref0 (_tmp7_);
			} else {
				GdkPixbuf* _tmp11_ = NULL;
				GtkIconInfo* _tmp12_;
				GdkPixbuf* _tmp13_;
				GdkPixbuf* _tmp14_;
				_tmp12_ = icon_info;
				_tmp13_ = gtk_icon_info_load_icon (_tmp12_, &_inner_error_);
				_tmp11_ = _tmp13_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_gtk_icon_info_free0 (icon_info);
					goto __catch13_g_error;
				}
				_tmp14_ = _tmp11_;
				_tmp11_ = NULL;
				_g_object_unref0 (rv);
				rv = _tmp14_;
				_g_object_unref0 (_tmp11_);
			}
		}
		_tmp15_ = rv;
		if (_tmp15_ == NULL) {
			const gchar* _tmp16_;
			GdkPixbuf* _tmp17_ = NULL;
			GtkIconTheme* _tmp18_;
			GtkIconTheme* _tmp19_;
			gint _tmp20_;
			GdkPixbuf* _tmp21_;
			GdkPixbuf* _tmp22_;
			_tmp16_ = self->priv->_name;
			g_warning ("Icon.vala:103: Icon not found: %s", _tmp16_);
			_tmp18_ = noise_icon_get_theme ();
			_tmp19_ = _tmp18_;
			_tmp20_ = pixel_size;
			_tmp21_ = gtk_icon_theme_load_icon (_tmp19_, "image-missing", _tmp20_, GTK_ICON_LOOKUP_GENERIC_FALLBACK, &_inner_error_);
			_tmp17_ = _tmp21_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_gtk_icon_info_free0 (icon_info);
				goto __catch13_g_error;
			}
			_tmp22_ = _tmp17_;
			_tmp17_ = NULL;
			_g_object_unref0 (rv);
			rv = _tmp22_;
			_g_object_unref0 (_tmp17_);
		}
		_gtk_icon_info_free0 (icon_info);
	}
	goto __finally13;
	__catch13_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp23_;
		GError* _tmp24_;
		const gchar* _tmp25_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp23_ = self->priv->_name;
		_tmp24_ = err;
		_tmp25_ = _tmp24_->message;
		g_warning ("Icon.vala:107: Could not load icon [%s]: %s", _tmp23_, _tmp25_);
		_g_error_free0 (err);
	}
	__finally13:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (rv);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = rv;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


GtkIconTheme*
noise_icon_get_theme (void)
{
	GtkIconTheme* result;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp3_;
	_tmp0_ = noise_icon__theme;
	if (_tmp0_ == NULL) {
		GtkIconTheme* _tmp1_;
		GtkIconTheme* _tmp2_;
		_tmp1_ = gtk_icon_theme_get_default ();
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_g_object_unref0 (noise_icon__theme);
		noise_icon__theme = _tmp2_;
	}
	_tmp3_ = noise_icon__theme;
	result = _tmp3_;
	return result;
}


const gchar*
noise_icon_get_name (NoiseIcon* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


static void
noise_icon_set_name (NoiseIcon* self,
                     const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, noise_icon_get_name (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_icon_properties[NOISE_ICON_NAME_PROPERTY]);
	}
}


GIcon*
noise_icon_get_gicon (NoiseIcon* self)
{
	GIcon* result;
	GIcon* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_gicon;
	result = _tmp0_;
	return result;
}


static void
noise_icon_set_gicon (NoiseIcon* self,
                      GIcon* value)
{
	g_return_if_fail (self != NULL);
	if (noise_icon_get_gicon (self) != value) {
		GIcon* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_gicon);
		self->priv->_gicon = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_icon_properties[NOISE_ICON_GICON_PROPERTY]);
	}
}


static void
noise_icon_class_init (NoiseIconClass * klass)
{
	noise_icon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseIcon_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_icon_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_icon_set_property;
	G_OBJECT_CLASS (klass)->finalize = noise_icon_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ICON_NAME_PROPERTY, noise_icon_properties[NOISE_ICON_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ICON_GICON_PROPERTY, noise_icon_properties[NOISE_ICON_GICON_PROPERTY] = g_param_spec_object ("gicon", "gicon", "gicon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
noise_icon_instance_init (NoiseIcon * self)
{
	self->priv = noise_icon_get_instance_private (self);
}


static void
noise_icon_finalize (GObject * obj)
{
	NoiseIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_ICON, NoiseIcon);
	_g_free0 (self->priv->_name);
	_g_object_unref0 (self->priv->_gicon);
	G_OBJECT_CLASS (noise_icon_parent_class)->finalize (obj);
}


/**
 * An Icon Object
 *
 * Icon objects point to icon files or generic icon names. The API provides convenience
 * methods for rendering the icon to a {@link Gdk.Pixbuf} image or {@link Gtk.Image} widgets.
 *
 * The icon is searched in the available icon themes.
 */
GType
noise_icon_get_type (void)
{
	static volatile gsize noise_icon_type_id__volatile = 0;
	if (g_once_init_enter (&noise_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseIcon), 0, (GInstanceInitFunc) noise_icon_instance_init, NULL };
		GType noise_icon_type_id;
		noise_icon_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseIcon", &g_define_type_info, 0);
		NoiseIcon_private_offset = g_type_add_instance_private (noise_icon_type_id, sizeof (NoiseIconPrivate));
		g_once_init_leave (&noise_icon_type_id__volatile, noise_icon_type_id);
	}
	return noise_icon_type_id__volatile;
}


static void
_vala_noise_icon_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	NoiseIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_ICON, NoiseIcon);
	switch (property_id) {
		case NOISE_ICON_NAME_PROPERTY:
		g_value_set_string (value, noise_icon_get_name (self));
		break;
		case NOISE_ICON_GICON_PROPERTY:
		g_value_set_object (value, noise_icon_get_gicon (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_icon_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	NoiseIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_ICON, NoiseIcon);
	switch (property_id) {
		case NOISE_ICON_NAME_PROPERTY:
		noise_icon_set_name (self, g_value_get_string (value));
		break;
		case NOISE_ICON_GICON_PROPERTY:
		noise_icon_set_gicon (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



