/* String.c generated by valac 0.41.91, the Vala compiler
 * generated from String.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gboolean noise_string_is_empty (const gchar* text,
                                gboolean check_white_space);
gboolean noise_string_is_white_space (const gchar* text);
gint noise_string_compare (const gchar* a,
                           const gchar* b);
gchar* noise_string_canonicalize_for_search (const gchar* str);
gunichar noise_string_strip_char (gunichar ch);
gchar* noise_string_to_title_case (const gchar* text);
gchar* noise_string_locale_to_utf8 (const gchar* string_locale);
void noise_string_base_search_method (const gchar* search,
                                      guint* parsed_rating,
                                      gchar* * parsed_search_string);
guint* noise_search_get_rating_from_string (const gchar* rating_string);
gchar* noise_search_get_valid_search_string (const gchar* s);
guint64 noise_string_uint_from_string (const gchar* str);


inline gboolean
noise_string_is_empty (const gchar* text,
                       gboolean check_white_space)
{
	gboolean result = FALSE;
	if (text != NULL) {
		gboolean _tmp0_ = FALSE;
		if (check_white_space) {
			_tmp0_ = noise_string_is_white_space (text);
		} else {
			_tmp0_ = g_strcmp0 (text, "") == 0;
		}
		result = _tmp0_;
		return result;
	}
	result = TRUE;
	return result;
}


/**
     * Compares two strings encoded in UTF-8. Used extensively in the views for sorting.
     *
     * It takes into account the current locale's sorting rules and is faster
     * than normal string comparison.
     *
     * /!\ DON'T USE THIS METHOD WITH STRINGS NOT ENCODED IN UTF-8.
     *
     * @param a first string.
     * @param b second string.
     * @return 0 if a == b, a positive number if a > b, or a negative number if a < b.
     */
inline gint
noise_string_compare (const gchar* a,
                      const gchar* b)
{
	gint result = 0;
	gchar* _tmp0_ = NULL;
	gchar* _tmp3_ = NULL;
	GCompareFunc _tmp6_;
	if (a != NULL) {
		gchar* _tmp1_;
		_tmp1_ = g_utf8_collate_key (a, (gssize) -1);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		gchar* _tmp2_;
		_tmp2_ = g_strdup ((const gchar*) NULL);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	}
	if (b != NULL) {
		gchar* _tmp4_;
		_tmp4_ = g_utf8_collate_key (b, (gssize) -1);
		_g_free0 (_tmp3_);
		_tmp3_ = _tmp4_;
	} else {
		gchar* _tmp5_;
		_tmp5_ = g_strdup ((const gchar*) NULL);
		_g_free0 (_tmp3_);
		_tmp3_ = _tmp5_;
	}
	_tmp6_ = g_strcmp0;
	result = _tmp6_ (_tmp0_, _tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp0_);
	return result;
}


/**
     * Checks whether a string contains only whitespace.
     *
     * @return //true// if text consists enterely of white space.
     */
static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


inline gboolean
noise_string_is_white_space (const gchar* text)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
	g_return_val_if_fail (text != NULL, FALSE);
	_tmp0_ = string_strip (text);
	_tmp1_ = _tmp0_;
	_tmp2_ = strlen (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_ == 0;
	_g_free0 (_tmp1_);
	result = _tmp4_;
	return result;
}


/**
     * Removes irrelevant and meaningless characters from a string. Useful for search operations.
     * (Taken from gnome-contacts' contacts-utils.vala)
     */
static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gunichar _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
	_tmp0_ = _vala_c;
	if (_tmp0_ != ((gunichar) 0)) {
		gchar* _tmp1_;
		_tmp1_ = g_utf8_next_char (((gchar*) self) + (*index));
		*index = (gint) (_tmp1_ - ((gchar*) self));
		result = TRUE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	} else {
		result = FALSE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	}
	if (c) {
		*c = _vala_c;
	}
}


inline gchar*
noise_string_canonicalize_for_search (const gchar* str)
{
	gchar* result = NULL;
	gunichar* buf = NULL;
	gunichar* _tmp0_;
	gint buf_length1;
	gint _buf_size_;
	GString* res = NULL;
	GString* _tmp1_;
	gunichar c = 0U;
	GString* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	g_return_val_if_fail (str != NULL, NULL);
	_tmp0_ = g_new0 (gunichar, G_UNICHAR_MAX_DECOMPOSITION_LENGTH);
	buf = _tmp0_;
	buf_length1 = G_UNICHAR_MAX_DECOMPOSITION_LENGTH;
	_buf_size_ = buf_length1;
	_tmp1_ = g_string_new ("");
	res = _tmp1_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gunichar _tmp3_ = 0U;
				gboolean _tmp4_;
				gunichar sc = 0U;
				gunichar _tmp5_;
				gunichar _tmp6_;
				if (!_tmp2_) {
				}
				_tmp2_ = FALSE;
				_tmp4_ = string_get_next_char (str, &i, &_tmp3_);
				c = _tmp3_;
				if (!_tmp4_) {
					break;
				}
				_tmp5_ = c;
				sc = noise_string_strip_char (_tmp5_);
				_tmp6_ = sc;
				if (_tmp6_ != ((gunichar) 0)) {
					gsize size = 0UL;
					gunichar _tmp7_;
					gunichar* _tmp8_;
					gint _tmp8__length1;
					gsize _tmp9_;
					_tmp7_ = sc;
					_tmp8_ = buf;
					_tmp8__length1 = buf_length1;
					size = g_unichar_fully_decompose (_tmp7_, FALSE, _tmp8_, _tmp8__length1);
					_tmp9_ = size;
					if (_tmp9_ > ((gsize) 0)) {
						GString* _tmp10_;
						gunichar* _tmp11_;
						gint _tmp11__length1;
						gunichar _tmp12_;
						_tmp10_ = res;
						_tmp11_ = buf;
						_tmp11__length1 = buf_length1;
						_tmp12_ = _tmp11_[0];
						g_string_append_unichar (_tmp10_, _tmp12_);
					}
				}
			}
		}
	}
	_tmp13_ = res;
	_tmp14_ = _tmp13_->str;
	_tmp15_ = g_strdup (_tmp14_);
	result = _tmp15_;
	_g_string_free0 (res);
	buf = (g_free (buf), NULL);
	return result;
}


inline gunichar
noise_string_strip_char (gunichar ch)
{
	gunichar result = 0U;
	switch (g_unichar_type (ch)) {
		case G_UNICODE_CONTROL:
		case G_UNICODE_FORMAT:
		case G_UNICODE_UNASSIGNED:
		case G_UNICODE_NON_SPACING_MARK:
		case G_UNICODE_COMBINING_MARK:
		case G_UNICODE_ENCLOSING_MARK:
		case G_UNICODE_LINE_SEPARATOR:
		case G_UNICODE_SPACE_SEPARATOR:
		case G_UNICODE_PARAGRAPH_SEPARATOR:
		case G_UNICODE_DASH_PUNCTUATION:
		case G_UNICODE_OPEN_PUNCTUATION:
		case G_UNICODE_OTHER_PUNCTUATION:
		{
			result = (gunichar) 0;
			return result;
		}
		default:
		{
			result = g_unichar_tolower (ch);
			return result;
		}
	}
}


/**
     * Capitalizes the initial letters of a UTF-8 string (Title Case).
     *
     * The implementation is guaranteed to be efficient.
     *
     * For example:
     * "This is an input string" => "This Is An Input String"
     * "example string/text"     => "Example String/Text"
     */
inline gchar*
noise_string_to_title_case (const gchar* text)
{
	gchar* result = NULL;
	gboolean capitalize_next = FALSE;
	GString* _result_ = NULL;
	GString* _tmp0_;
	gunichar c = 0U;
	GString* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	g_return_val_if_fail (text != NULL, NULL);
	capitalize_next = TRUE;
	_tmp0_ = g_string_new ("");
	_result_ = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gunichar _tmp2_ = 0U;
				gboolean _tmp3_;
				gboolean _tmp4_;
				if (!_tmp1_) {
				}
				_tmp1_ = FALSE;
				_tmp3_ = string_get_next_char (text, &i, &_tmp2_);
				c = _tmp2_;
				if (!_tmp3_) {
					break;
				}
				_tmp4_ = capitalize_next;
				if (_tmp4_) {
					GString* _tmp5_;
					gunichar _tmp6_;
					_tmp5_ = _result_;
					_tmp6_ = c;
					g_string_append_unichar (_tmp5_, g_unichar_totitle (_tmp6_));
					capitalize_next = FALSE;
				} else {
					GString* _tmp7_;
					gunichar _tmp8_;
					gboolean _tmp9_ = FALSE;
					gunichar _tmp10_;
					_tmp7_ = _result_;
					_tmp8_ = c;
					g_string_append_unichar (_tmp7_, g_unichar_tolower (_tmp8_));
					_tmp10_ = c;
					if (g_unichar_isspace (_tmp10_)) {
						_tmp9_ = TRUE;
					} else {
						gunichar _tmp11_;
						_tmp11_ = c;
						_tmp9_ = g_unichar_iscntrl (_tmp11_);
					}
					capitalize_next = _tmp9_;
				}
			}
		}
	}
	_tmp12_ = _result_;
	_tmp13_ = _tmp12_->str;
	_tmp14_ = g_strdup (_tmp13_);
	result = _tmp14_;
	_g_string_free0 (_result_);
	return result;
}


/**
     * Converts a string encoded in the native operating system encoding to UTF-8.
     *
     * @param string_locale String in locale encoding.
     * @return String encoded in UTF-8, or //null// if the string could not be converted.
     */
gchar*
noise_string_locale_to_utf8 (const gchar* string_locale)
{
	gchar* result = NULL;
	GError* _error_ = NULL;
	gsize bytes_read = 0UL;
	gsize bytes_written = 0UL;
	gchar* string_utf8 = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gsize _tmp2_ = 0UL;
	gsize _tmp3_ = 0UL;
	GError* _tmp4_ = NULL;
	gchar* _tmp5_;
	GError* _tmp6_;
	g_return_val_if_fail (string_locale != NULL, NULL);
	_tmp0_ = strlen (string_locale);
	_tmp1_ = _tmp0_;
	_tmp5_ = g_locale_to_utf8 (string_locale, (gssize) _tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
	bytes_read = _tmp2_;
	bytes_written = _tmp3_;
	_g_error_free0 (_error_);
	_error_ = _tmp4_;
	string_utf8 = _tmp5_;
	_tmp6_ = _error_;
	if (_tmp6_ != NULL) {
		_g_free0 (string_utf8);
		string_utf8 = NULL;
	}
	result = string_utf8;
	_g_error_free0 (_error_);
	return result;
}


/**
     * Base method used for searches. It does a previous parsing on the search string.
     *
     * If the output value of parsed_rating is greater than 0, then the view should
     * only display the media with that rating in the search results, and ignore
     * the value of parsed_search_string.
     *
     * @param search Non-parsed version of the search string.
     * @param parsed_rating location where the parsed rating it stored, or 0 if the
     * string didn't represent a valid rating.
     * @param parsed_search_string location where the canonicalized version of the
     * search string is stored. Should be passed to the methods in Noise.Search.
     */
void
noise_string_base_search_method (const gchar* search,
                                 guint* parsed_rating,
                                 gchar* * parsed_search_string)
{
	guint _vala_parsed_rating = 0U;
	gchar* _vala_parsed_search_string = NULL;
	guint* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	guint* _tmp2_;
	guint* _tmp3_;
	guint* _tmp4_;
	gchar* _tmp6_;
	g_return_if_fail (search != NULL);
	_vala_parsed_rating = (guint) 0;
	_tmp0_ = string_strip (search);
	_tmp1_ = _tmp0_;
	_tmp2_ = noise_search_get_rating_from_string (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	_result_ = _tmp3_;
	_tmp4_ = _result_;
	if (_tmp4_ != NULL) {
		guint* _tmp5_;
		_tmp5_ = _result_;
		_vala_parsed_rating = CLAMP (*_tmp5_, (guint) 1, (guint) 5);
	}
	_tmp6_ = noise_search_get_valid_search_string (search);
	_g_free0 (_vala_parsed_search_string);
	_vala_parsed_search_string = _tmp6_;
	_g_free0 (_result_);
	if (parsed_rating) {
		*parsed_rating = _vala_parsed_rating;
	}
	if (parsed_search_string) {
		*parsed_search_string = _vala_parsed_search_string;
	} else {
		_g_free0 (_vala_parsed_search_string);
	}
}


/**
     * A method for extracting integers from strings.
     *
     * The method does its best to extract a number from a string by cleaning up
     * non-numeric characters before parsing the string with uint64.parse(). The
     * purpose of this method is to provide a safe way of extracting numbers
     * from strings without making everything crash when passing a weird localized
     * string that would normally lead uint64.parse, int64.parse or int.parse
     * to a segmentation fault. This happens due to encoding incompatibilities:
     * Remember that the standard C library doesn't know how to deal with variable-
     * length UTF-8 characters!
     *
     * If no number is found in the string, zero is returned.
     *
     * Examples:
     * "a23oe ew2" => 232
     " "32 text"   => 32
     * "ins1 32"   => 132
     * "a word"    => 0
     *
     * @param str string known to contain a valid integer
     * @return Result of parsing the string.
     */
static guint64
uint64_parse (const gchar* str)
{
	guint64 result = 0ULL;
	guint64 _tmp0_;
	g_return_val_if_fail (str != NULL, 0ULL);
	_tmp0_ = g_ascii_strtoull (str, NULL, (guint) 0);
	result = _tmp0_;
	return result;
}


inline guint64
noise_string_uint_from_string (const gchar* str)
{
	guint64 result = 0ULL;
	static const gushort MAX_DIGITS = (gushort) 18;
	gushort ndigits = 0U;
	GString* _result_ = NULL;
	GString* _tmp0_;
	gunichar c = 0U;
	guint64 _tmp10_ = 0ULL;
	gushort _tmp11_;
	g_return_val_if_fail (str != NULL, 0ULL);
	ndigits = (gushort) 0;
	_tmp0_ = g_string_new ("");
	_result_ = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gboolean _tmp2_ = FALSE;
				gunichar _tmp3_ = 0U;
				gboolean _tmp4_;
				gunichar _tmp6_;
				if (!_tmp1_) {
				}
				_tmp1_ = FALSE;
				_tmp4_ = string_get_next_char (str, &i, &_tmp3_);
				c = _tmp3_;
				if (_tmp4_) {
					gushort _tmp5_;
					_tmp5_ = ndigits;
					_tmp2_ = _tmp5_ < MAX_DIGITS;
				} else {
					_tmp2_ = FALSE;
				}
				if (!_tmp2_) {
					break;
				}
				_tmp6_ = c;
				if (g_unichar_isdigit (_tmp6_)) {
					GString* _tmp7_;
					gunichar _tmp8_;
					gushort _tmp9_;
					_tmp7_ = _result_;
					_tmp8_ = c;
					g_string_append_unichar (_tmp7_, _tmp8_);
					_tmp9_ = ndigits;
					ndigits = _tmp9_ + 1;
				}
			}
		}
	}
	_tmp11_ = ndigits;
	if (((gint) _tmp11_) == 0) {
		_tmp10_ = (guint64) 0;
	} else {
		GString* _tmp12_;
		const gchar* _tmp13_;
		_tmp12_ = _result_;
		_tmp13_ = _tmp12_->str;
		_tmp10_ = uint64_parse (_tmp13_);
	}
	result = _tmp10_;
	_g_string_free0 (_result_);
	return result;
}



