/* CoverImport.c generated by valac 0.41.91, the Vala compiler
 * generated from CoverImport.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <gst/pbutils/pbutils.h>
#include "io.elementary.music-core.h"
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gst/gst.h>
#include <gst/tag/tag.h>


#define NOISE_TYPE_COVER_IMPORT (noise_cover_import_get_type ())
#define NOISE_COVER_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_COVER_IMPORT, NoiseCoverImport))
#define NOISE_COVER_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_COVER_IMPORT, NoiseCoverImportClass))
#define NOISE_IS_COVER_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_COVER_IMPORT))
#define NOISE_IS_COVER_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_COVER_IMPORT))
#define NOISE_COVER_IMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_COVER_IMPORT, NoiseCoverImportClass))

typedef struct _NoiseCoverImport NoiseCoverImport;
typedef struct _NoiseCoverImportClass NoiseCoverImportClass;
typedef struct _NoiseCoverImportPrivate NoiseCoverImportPrivate;
enum  {
	NOISE_COVER_IMPORT_0_PROPERTY,
	NOISE_COVER_IMPORT_NUM_PROPERTIES
};
static GParamSpec* noise_cover_import_properties[NOISE_COVER_IMPORT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block16Data Block16Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _gst_sample_unref0(var) ((var == NULL) ? NULL : (var = (gst_sample_unref (var), NULL)))
#define _gst_buffer_unref0(var) ((var == NULL) ? NULL : (var = (gst_buffer_unref (var), NULL)))
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))
#define _gst_caps_unref0(var) ((var == NULL) ? NULL : (var = (gst_caps_unref (var), NULL)))

struct _NoiseCoverImport {
	GObject parent_instance;
	NoiseCoverImportPrivate * priv;
};

struct _NoiseCoverImportClass {
	GObjectClass parent_class;
};

struct _NoiseCoverImportPrivate {
	GstDiscoverer* discoverer;
	NoiseAlbum* album;
	GRecMutex __lock_album;
};

struct _Block16Data {
	int _ref_count_;
	NoiseCoverImport* self;
	NoiseAlbum* album;
};


static gint NoiseCoverImport_private_offset;
static gpointer noise_cover_import_parent_class = NULL;

GType noise_cover_import_get_type (void) G_GNUC_CONST;
#define NOISE_COVER_IMPORT_DISCOVERER_TIMEOUT 5
NoiseCoverImport* noise_cover_import_new (NoiseAlbum* album);
NoiseCoverImport* noise_cover_import_construct (GType object_type,
                                                NoiseAlbum* album);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static void* __lambda32_ (Block16Data* _data16_);
static void noise_cover_import_read_info (NoiseCoverImport* self,
                                   GstDiscovererInfo* info);
static gpointer ___lambda32__gthread_func (gpointer self);
static GstSample* noise_cover_import_get_cover_sample (GstTagList* tag_list);
static GdkPixbuf* noise_cover_import_get_pixbuf_from_buffer (GstBuffer* buffer);
static GObject * noise_cover_import_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void noise_cover_import_finalize (GObject * obj);


static inline gpointer
noise_cover_import_get_instance_private (NoiseCoverImport* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseCoverImport_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
	g_atomic_int_inc (&_data16_->_ref_count_);
	return _data16_;
}


static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
		NoiseCoverImport* self;
		self = _data16_->self;
		_g_object_unref0 (_data16_->album);
		_g_object_unref0 (self);
		g_slice_free (Block16Data, _data16_);
	}
}


static void*
__lambda32_ (Block16Data* _data16_)
{
	NoiseCoverImport* self;
	void* result = NULL;
	GError * _inner_error_ = NULL;
	self = _data16_->self;
	{
		NoiseAlbum* _tmp0_;
		_tmp0_ = self->priv->album;
		g_rec_mutex_lock (&self->priv->__lock_album);
		{
			{
				GeeIterator* _media_it = NULL;
				GeeCollection* _tmp1_;
				GeeCollection* _tmp2_;
				GeeIterator* _tmp3_;
				GeeIterator* _tmp4_;
				_tmp1_ = noise_album_get_media (_data16_->album, (guint) 1);
				_tmp2_ = _tmp1_;
				_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
				_tmp4_ = _tmp3_;
				_g_object_unref0 (_tmp2_);
				_media_it = _tmp4_;
				while (TRUE) {
					GeeIterator* _tmp5_;
					NoiseMedia* media = NULL;
					GeeIterator* _tmp6_;
					gpointer _tmp7_;
					_tmp5_ = _media_it;
					if (!gee_iterator_next (_tmp5_)) {
						break;
					}
					_tmp6_ = _media_it;
					_tmp7_ = gee_iterator_get (_tmp6_);
					media = (NoiseMedia*) _tmp7_;
					{
						GstDiscovererInfo* info = NULL;
						GstDiscoverer* _tmp8_;
						NoiseMedia* _tmp9_;
						gchar* _tmp10_;
						gchar* _tmp11_;
						gchar* _tmp12_;
						GstDiscovererInfo* _tmp13_;
						GstDiscovererInfo* _tmp14_;
						GstDiscovererInfo* _tmp15_;
						_tmp8_ = self->priv->discoverer;
						_tmp9_ = media;
						_tmp10_ = noise_media_get_uri (_tmp9_);
						_tmp11_ = _tmp10_;
						_tmp12_ = _tmp11_;
						_tmp13_ = gst_discoverer_discover_uri (_tmp8_, _tmp12_, &_inner_error_);
						_tmp14_ = _tmp13_;
						_g_free0 (_tmp12_);
						info = _tmp14_;
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							goto __catch24_g_error;
						}
						_tmp15_ = info;
						noise_cover_import_read_info (self, _tmp15_);
						_g_object_unref0 (info);
					}
					goto __finally24;
					__catch24_g_error:
					{
						GError* err = NULL;
						const gchar* _tmp16_;
						const gchar* _tmp17_;
						GError* _tmp18_;
						const gchar* _tmp19_;
						err = _inner_error_;
						_inner_error_ = NULL;
						_tmp16_ = noise_album_get_name (_data16_->album);
						_tmp17_ = _tmp16_;
						_tmp18_ = err;
						_tmp19_ = _tmp18_->message;
						g_critical ("CoverImport.vala:52: Error while importing cover for %s: %s", _tmp17_, _tmp19_);
						_g_error_free0 (err);
					}
					__finally24:
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_object_unref0 (media);
						_g_object_unref0 (_media_it);
						_g_object_unref0 (media);
						_g_object_unref0 (_media_it);
						{
							NoiseAlbum* _tmp20_;
							_tmp20_ = self->priv->album;
							g_rec_mutex_unlock (&self->priv->__lock_album);
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
					_g_object_unref0 (media);
				}
				_g_object_unref0 (_media_it);
			}
		}
		__finally23:
		{
			NoiseAlbum* _tmp21_;
			_tmp21_ = self->priv->album;
			g_rec_mutex_unlock (&self->priv->__lock_album);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = NULL;
	return result;
}


static gpointer
___lambda32__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda32_ (self);
	block16_data_unref (self);
	return result;
}


NoiseCoverImport*
noise_cover_import_construct (GType object_type,
                              NoiseAlbum* album)
{
	NoiseCoverImport * self = NULL;
	Block16Data* _data16_;
	NoiseAlbum* _tmp0_;
	NoiseAlbum* _tmp1_;
	GThread* _tmp2_;
	GThread* _tmp3_;
	g_return_val_if_fail (album != NULL, NULL);
	_data16_ = g_slice_new0 (Block16Data);
	_data16_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (album);
	_g_object_unref0 (_data16_->album);
	_data16_->album = _tmp0_;
	self = (NoiseCoverImport*) g_object_new (object_type, NULL);
	_data16_->self = g_object_ref (self);
	_tmp1_ = _g_object_ref0 (_data16_->album);
	_g_object_unref0 (self->priv->album);
	self->priv->album = _tmp1_;
	_tmp2_ = g_thread_new (NULL, ___lambda32__gthread_func, block16_data_ref (_data16_));
	_tmp3_ = _tmp2_;
	_g_thread_unref0 (_tmp3_);
	block16_data_unref (_data16_);
	_data16_ = NULL;
	return self;
}


NoiseCoverImport*
noise_cover_import_new (NoiseAlbum* album)
{
	return noise_cover_import_construct (NOISE_TYPE_COVER_IMPORT, album);
}


static gpointer
_gst_tag_list_ref0 (gpointer self)
{
	return self ? gst_tag_list_ref (self) : NULL;
}


static gpointer
_gst_buffer_ref0 (gpointer self)
{
	return self ? gst_buffer_ref (self) : NULL;
}


static void
noise_cover_import_read_info (NoiseCoverImport* self,
                              GstDiscovererInfo* info)
{
	gchar* uri = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean gstreamer_discovery_successful = FALSE;
	gboolean _tmp7_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (info != NULL);
	_tmp0_ = gst_discoverer_info_get_uri (info);
	_tmp1_ = g_strdup (_tmp0_);
	uri = _tmp1_;
	gstreamer_discovery_successful = FALSE;
	switch (gst_discoverer_info_get_result (info)) {
		case GST_DISCOVERER_OK:
		{
			gstreamer_discovery_successful = TRUE;
			break;
		}
		case GST_DISCOVERER_URI_INVALID:
		{
			const gchar* _tmp2_;
			_tmp2_ = uri;
			g_warning ("CoverImport.vala:69: GStreamer could not import '%s': invalid URI.", _tmp2_);
			break;
		}
		case GST_DISCOVERER_ERROR:
		{
			const gchar* _tmp3_;
			_tmp3_ = uri;
			g_warning ("CoverImport.vala:73: GStreamer could not import '%s'", _tmp3_);
			break;
		}
		case GST_DISCOVERER_TIMEOUT:
		{
			const gchar* _tmp4_;
			_tmp4_ = uri;
			g_warning ("CoverImport.vala:77: GStreamer could not import '%s': Discovery timed " \
"out.", _tmp4_);
			break;
		}
		case GST_DISCOVERER_BUSY:
		{
			const gchar* _tmp5_;
			_tmp5_ = uri;
			g_warning ("CoverImport.vala:81: GStreamer could not import '%s': Already discover" \
"ing a file.", _tmp5_);
			break;
		}
		case GST_DISCOVERER_MISSING_PLUGINS:
		{
			const gchar* _tmp6_;
			_tmp6_ = uri;
			g_warning ("CoverImport.vala:85: GStreamer could not import '%s': Missing plugins.", _tmp6_);
			break;
		}
		default:
		break;
	}
	_tmp7_ = gstreamer_discovery_successful;
	if (_tmp7_) {
		GdkPixbuf* pixbuf = NULL;
		GstTagList* tag_list = NULL;
		GstTagList* _tmp8_;
		GstTagList* _tmp9_;
		GstSample* sample = NULL;
		GstTagList* _tmp10_;
		GstSample* _tmp11_;
		GstSample* _tmp12_;
		GstSample* _tmp15_;
		pixbuf = NULL;
		_tmp8_ = gst_discoverer_info_get_tags (info);
		_tmp9_ = _gst_tag_list_ref0 (_tmp8_);
		tag_list = _tmp9_;
		_tmp10_ = tag_list;
		_tmp11_ = noise_cover_import_get_cover_sample (_tmp10_);
		sample = _tmp11_;
		_tmp12_ = sample;
		if (_tmp12_ == NULL) {
			GstTagList* _tmp13_;
			GstSample* _tmp14_ = NULL;
			_tmp13_ = tag_list;
			gst_tag_list_get_sample_index (_tmp13_, GST_TAG_PREVIEW_IMAGE, (guint) 0, &_tmp14_);
			_gst_sample_unref0 (sample);
			sample = _tmp14_;
		}
		_tmp15_ = sample;
		if (_tmp15_ != NULL) {
			GstBuffer* buffer = NULL;
			GstSample* _tmp16_;
			GstBuffer* _tmp17_;
			GstBuffer* _tmp18_;
			GstBuffer* _tmp19_;
			const gchar* _tmp27_;
			_tmp16_ = sample;
			_tmp17_ = gst_sample_get_buffer (_tmp16_);
			_tmp18_ = _gst_buffer_ref0 (_tmp17_);
			buffer = _tmp18_;
			_tmp19_ = buffer;
			if (_tmp19_ != NULL) {
				GstBuffer* _tmp20_;
				GdkPixbuf* _tmp21_;
				GdkPixbuf* _tmp22_;
				_tmp20_ = buffer;
				_tmp21_ = noise_cover_import_get_pixbuf_from_buffer (_tmp20_);
				_g_object_unref0 (pixbuf);
				pixbuf = _tmp21_;
				_tmp22_ = pixbuf;
				if (_tmp22_ != NULL) {
					{
						NoiseAlbum* _tmp23_;
						_tmp23_ = self->priv->album;
						g_rec_mutex_lock (&self->priv->__lock_album);
						{
							NoiseAlbum* _tmp24_;
							GdkPixbuf* _tmp25_;
							_tmp24_ = self->priv->album;
							_tmp25_ = pixbuf;
							noise_album_save_cover_pixbuf (_tmp24_, _tmp25_);
						}
						__finally25:
						{
							NoiseAlbum* _tmp26_;
							_tmp26_ = self->priv->album;
							g_rec_mutex_unlock (&self->priv->__lock_album);
						}
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							_gst_buffer_unref0 (buffer);
							_gst_sample_unref0 (sample);
							_gst_tag_list_unref0 (tag_list);
							_g_object_unref0 (pixbuf);
							_g_free0 (uri);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
					}
				}
			}
			_tmp27_ = gst_discoverer_info_get_uri (info);
			g_debug ("CoverImport.vala:116: Final image buffer is NULL for '%s'", _tmp27_);
			_gst_buffer_unref0 (buffer);
		} else {
			const gchar* _tmp28_;
			_tmp28_ = gst_discoverer_info_get_uri (info);
			g_debug ("CoverImport.vala:118: Image sample is NULL for '%s'", _tmp28_);
		}
		_gst_sample_unref0 (sample);
		_gst_tag_list_unref0 (tag_list);
		_g_object_unref0 (pixbuf);
	}
	_g_free0 (uri);
}


static gpointer
_gst_caps_ref0 (gpointer self)
{
	return self ? gst_caps_ref (self) : NULL;
}


static gpointer
_gst_sample_ref0 (gpointer self)
{
	return self ? gst_sample_ref (self) : NULL;
}


static GstSample*
noise_cover_import_get_cover_sample (GstTagList* tag_list)
{
	GstSample* result = NULL;
	GstSample* cover_sample = NULL;
	GstSample* sample = NULL;
	g_return_val_if_fail (tag_list != NULL, NULL);
	cover_sample = NULL;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				GstSample* _tmp3_ = NULL;
				gboolean _tmp4_;
				GstCaps* caps = NULL;
				GstSample* _tmp5_;
				GstCaps* _tmp6_;
				GstCaps* _tmp7_;
				GstStructure* caps_struct = NULL;
				GstCaps* _tmp8_;
				GstStructure* _tmp9_;
				gint image_type = 0;
				GstStructure* _tmp10_;
				gint _tmp11_ = 0;
				gboolean _tmp12_ = FALSE;
				gint _tmp13_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp4_ = gst_tag_list_get_sample_index (tag_list, GST_TAG_IMAGE, (guint) _tmp2_, &_tmp3_);
				_gst_sample_unref0 (sample);
				sample = _tmp3_;
				if (!_tmp4_) {
					break;
				}
				_tmp5_ = sample;
				_tmp6_ = gst_sample_get_caps (_tmp5_);
				_tmp7_ = _gst_caps_ref0 (_tmp6_);
				caps = _tmp7_;
				_tmp8_ = caps;
				_tmp9_ = gst_caps_get_structure (_tmp8_, (guint) 0);
				caps_struct = _tmp9_;
				image_type = (gint) GST_TAG_IMAGE_TYPE_UNDEFINED;
				_tmp10_ = caps_struct;
				gst_structure_get_enum (_tmp10_, "image-type", gst_tag_image_type_get_type (), &_tmp11_);
				image_type = _tmp11_;
				_tmp13_ = image_type;
				if (_tmp13_ == ((gint) GST_TAG_IMAGE_TYPE_UNDEFINED)) {
					GstSample* _tmp14_;
					_tmp14_ = cover_sample;
					_tmp12_ = _tmp14_ == NULL;
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					GstSample* _tmp15_;
					GstSample* _tmp16_;
					_tmp15_ = sample;
					_tmp16_ = _gst_sample_ref0 (_tmp15_);
					_gst_sample_unref0 (cover_sample);
					cover_sample = _tmp16_;
				} else {
					gint _tmp17_;
					_tmp17_ = image_type;
					if (_tmp17_ == ((gint) GST_TAG_IMAGE_TYPE_FRONT_COVER)) {
						result = sample;
						_gst_caps_unref0 (caps);
						_gst_sample_unref0 (cover_sample);
						return result;
					}
				}
				_gst_caps_unref0 (caps);
			}
		}
	}
	result = cover_sample;
	_gst_sample_unref0 (sample);
	return result;
}


static GdkPixbuf*
noise_cover_import_get_pixbuf_from_buffer (GstBuffer* buffer)
{
	GdkPixbuf* result = NULL;
	GstMapInfo map_info = {0};
	GstMapInfo _tmp0_ = {0};
	gboolean _tmp1_;
	GdkPixbuf* pix = NULL;
	GstMapInfo _tmp15_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (buffer != NULL, NULL);
	_tmp1_ = gst_buffer_map (buffer, &_tmp0_, GST_MAP_READ);
	map_info = _tmp0_;
	if (!_tmp1_) {
		g_warning ("CoverImport.vala:145: Could not map memory buffer");
		result = NULL;
		return result;
	}
	pix = NULL;
	{
		GdkPixbufLoader* loader = NULL;
		GdkPixbufLoader* _tmp2_;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		GdkPixbufLoader* _tmp5_;
		GstMapInfo _tmp6_;
		guint8* _tmp7_;
		gint _tmp7__length1;
		_tmp2_ = gdk_pixbuf_loader_new ();
		loader = _tmp2_;
		_tmp5_ = loader;
		_tmp6_ = map_info;
		_tmp7_ = _tmp6_.data;
		_tmp7__length1 = (gint) _tmp6_.size;
		_tmp4_ = gdk_pixbuf_loader_write (_tmp5_, _tmp7_, (gsize) _tmp7__length1, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (loader);
			goto __catch26_g_error;
		}
		if (_tmp4_) {
			gboolean _tmp8_ = FALSE;
			GdkPixbufLoader* _tmp9_;
			_tmp9_ = loader;
			_tmp8_ = gdk_pixbuf_loader_close (_tmp9_, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (loader);
				goto __catch26_g_error;
			}
			_tmp3_ = _tmp8_;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			GdkPixbufLoader* _tmp10_;
			GdkPixbuf* _tmp11_;
			GdkPixbuf* _tmp12_;
			_tmp10_ = loader;
			_tmp11_ = gdk_pixbuf_loader_get_pixbuf (_tmp10_);
			_tmp12_ = _g_object_ref0 (_tmp11_);
			_g_object_unref0 (pix);
			pix = _tmp12_;
		}
		_g_object_unref0 (loader);
	}
	goto __finally26;
	__catch26_g_error:
	{
		GError* err = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp13_ = err;
		_tmp14_ = _tmp13_->message;
		g_warning ("CoverImport.vala:157: Error processing image data: %s", _tmp14_);
		_g_error_free0 (err);
	}
	__finally26:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (pix);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp15_ = map_info;
	gst_buffer_unmap (buffer, &_tmp15_);
	result = pix;
	return result;
}


static GObject *
noise_cover_import_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseCoverImport * self;
	GError * _inner_error_ = NULL;
	parent_class = G_OBJECT_CLASS (noise_cover_import_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_COVER_IMPORT, NoiseCoverImport);
	{
		GstDiscoverer* _tmp0_ = NULL;
		GstDiscoverer* _tmp1_;
		GstDiscoverer* _tmp2_;
		_tmp1_ = gst_discoverer_new ((GstClockTime) (NOISE_COVER_IMPORT_DISCOVERER_TIMEOUT * GST_SECOND), &_inner_error_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch27_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->discoverer);
		self->priv->discoverer = _tmp2_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally27;
	__catch27_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = err;
		_tmp4_ = _tmp3_->message;
		g_critical ("CoverImport.vala:39: Could not create Gst discoverer object: %s", _tmp4_);
		_g_error_free0 (err);
	}
	__finally27:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	return obj;
}


static void
noise_cover_import_class_init (NoiseCoverImportClass * klass)
{
	noise_cover_import_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseCoverImport_private_offset);
	G_OBJECT_CLASS (klass)->constructor = noise_cover_import_constructor;
	G_OBJECT_CLASS (klass)->finalize = noise_cover_import_finalize;
}


static void
noise_cover_import_instance_init (NoiseCoverImport * self)
{
	self->priv = noise_cover_import_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_album);
}


static void
noise_cover_import_finalize (GObject * obj)
{
	NoiseCoverImport * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_COVER_IMPORT, NoiseCoverImport);
	_g_object_unref0 (self->priv->discoverer);
	g_rec_mutex_clear (&self->priv->__lock_album);
	_g_object_unref0 (self->priv->album);
	G_OBJECT_CLASS (noise_cover_import_parent_class)->finalize (obj);
}


GType
noise_cover_import_get_type (void)
{
	static volatile gsize noise_cover_import_type_id__volatile = 0;
	if (g_once_init_enter (&noise_cover_import_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseCoverImportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_cover_import_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseCoverImport), 0, (GInstanceInitFunc) noise_cover_import_instance_init, NULL };
		GType noise_cover_import_type_id;
		noise_cover_import_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseCoverImport", &g_define_type_info, 0);
		NoiseCoverImport_private_offset = g_type_add_instance_private (noise_cover_import_type_id, sizeof (NoiseCoverImportPrivate));
		g_once_init_leave (&noise_cover_import_type_id__volatile, noise_cover_import_type_id);
	}
	return noise_cover_import_type_id__volatile;
}



