/* GStreamerTagger.c generated by valac 0.41.91, the Vala compiler
 * generated from GStreamerTagger.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gst/pbutils/pbutils.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gst/gst.h>
#include "io.elementary.music-core.h"
#include <float.h>
#include <math.h>
#include <time.h>


#define NOISE_TYPE_GSTREAMER_TAGGER (noise_gstreamer_tagger_get_type ())
#define NOISE_GSTREAMER_TAGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTagger))
#define NOISE_GSTREAMER_TAGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTaggerClass))
#define NOISE_IS_GSTREAMER_TAGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_GSTREAMER_TAGGER))
#define NOISE_IS_GSTREAMER_TAGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_GSTREAMER_TAGGER))
#define NOISE_GSTREAMER_TAGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTaggerClass))

typedef struct _NoiseGStreamerTagger NoiseGStreamerTagger;
typedef struct _NoiseGStreamerTaggerClass NoiseGStreamerTaggerClass;
typedef struct _NoiseGStreamerTaggerPrivate NoiseGStreamerTaggerPrivate;
enum  {
	NOISE_GSTREAMER_TAGGER_0_PROPERTY,
	NOISE_GSTREAMER_TAGGER_NUM_PROPERTIES
};
static GParamSpec* noise_gstreamer_tagger_properties[NOISE_GSTREAMER_TAGGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _gst_date_time_unref0(var) ((var == NULL) ? NULL : (var = (gst_date_time_unref (var), NULL)))
enum  {
	NOISE_GSTREAMER_TAGGER_MEDIA_IMPORTED_SIGNAL,
	NOISE_GSTREAMER_TAGGER_IMPORT_ERROR_SIGNAL,
	NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL,
	NOISE_GSTREAMER_TAGGER_NUM_SIGNALS
};
static guint noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_NUM_SIGNALS] = {0};

struct _NoiseGStreamerTagger {
	GObject parent_instance;
	NoiseGStreamerTaggerPrivate * priv;
};

struct _NoiseGStreamerTaggerClass {
	GObjectClass parent_class;
};

struct _NoiseGStreamerTaggerPrivate {
	GstDiscoverer* d;
	GeeLinkedList* uri_queue;
	GRecMutex __lock_uri_queue;
	GCancellable* cancellable;
};


static gint NoiseGStreamerTagger_private_offset;
static gpointer noise_gstreamer_tagger_parent_class = NULL;

GType noise_gstreamer_tagger_get_type (void) G_GNUC_CONST;
#define NOISE_GSTREAMER_TAGGER_DISCOVERER_TIMEOUT 5
NoiseGStreamerTagger* noise_gstreamer_tagger_new (GCancellable* cancellable);
NoiseGStreamerTagger* noise_gstreamer_tagger_construct (GType object_type,
                                                        GCancellable* cancellable);
static void noise_gstreamer_tagger_import_media (NoiseGStreamerTagger* self,
                                          GstDiscovererInfo* info,
                                          GError* err);
static void _noise_gstreamer_tagger_import_media_gst_discoverer_discovered (GstDiscoverer* _sender,
                                                                     GstDiscovererInfo* info,
                                                                     GError* err,
                                                                     gpointer self);
static void noise_gstreamer_tagger_file_set_finished (NoiseGStreamerTagger* self);
static void _noise_gstreamer_tagger_file_set_finished_gst_discoverer_finished (GstDiscoverer* _sender,
                                                                        gpointer self);
static void noise_gstreamer_tagger_import_next_file_set (NoiseGStreamerTagger* self);
void noise_gstreamer_tagger_discoverer_import_media (NoiseGStreamerTagger* self,
                                                     GeeCollection* uris);
static void* __lambda12_ (NoiseGStreamerTagger* self);
static gpointer ___lambda12__gthread_func (gpointer self);
static GDate* _g_date_dup (GDate* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void noise_gstreamer_tagger_finalize (GObject * obj);


static inline gpointer
noise_gstreamer_tagger_get_instance_private (NoiseGStreamerTagger* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseGStreamerTagger_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
_noise_gstreamer_tagger_import_media_gst_discoverer_discovered (GstDiscoverer* _sender,
                                                                GstDiscovererInfo* info,
                                                                GError* err,
                                                                gpointer self)
{
	noise_gstreamer_tagger_import_media ((NoiseGStreamerTagger*) self, info, err);
}


static void
_noise_gstreamer_tagger_file_set_finished_gst_discoverer_finished (GstDiscoverer* _sender,
                                                                   gpointer self)
{
	noise_gstreamer_tagger_file_set_finished ((NoiseGStreamerTagger*) self);
}


NoiseGStreamerTagger*
noise_gstreamer_tagger_construct (GType object_type,
                                  GCancellable* cancellable)
{
	NoiseGStreamerTagger * self = NULL;
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	GError * _inner_error_ = NULL;
	self = (NoiseGStreamerTagger*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (self->priv->cancellable);
	self->priv->cancellable = _tmp0_;
	_tmp1_ = self->priv->cancellable;
	if (_tmp1_ == NULL) {
		GCancellable* _tmp2_;
		_tmp2_ = g_cancellable_new ();
		_g_object_unref0 (self->priv->cancellable);
		self->priv->cancellable = _tmp2_;
	}
	{
		GstDiscoverer* _tmp3_ = NULL;
		GstDiscoverer* _tmp4_;
		GstDiscoverer* _tmp5_;
		GstDiscoverer* _tmp6_;
		GstDiscoverer* _tmp7_;
		_tmp4_ = gst_discoverer_new ((GstClockTime) (NOISE_GSTREAMER_TAGGER_DISCOVERER_TIMEOUT * GST_SECOND), &_inner_error_);
		_tmp3_ = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch28_g_error;
		}
		_tmp5_ = _tmp3_;
		_tmp3_ = NULL;
		_g_object_unref0 (self->priv->d);
		self->priv->d = _tmp5_;
		_tmp6_ = self->priv->d;
		g_signal_connect_object (_tmp6_, "discovered", (GCallback) _noise_gstreamer_tagger_import_media_gst_discoverer_discovered, self, 0);
		_tmp7_ = self->priv->d;
		g_signal_connect_object (_tmp7_, "finished", (GCallback) _noise_gstreamer_tagger_file_set_finished_gst_discoverer_finished, self, 0);
		_g_object_unref0 (_tmp3_);
	}
	goto __finally28;
	__catch28_g_error:
	{
		GError* err = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp8_ = err;
		_tmp9_ = _tmp8_->message;
		g_critical ("GStreamerTagger.vala:51: Could not create Gst discoverer object: %s", _tmp9_);
		_g_error_free0 (err);
	}
	__finally28:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	return self;
}


NoiseGStreamerTagger*
noise_gstreamer_tagger_new (GCancellable* cancellable)
{
	return noise_gstreamer_tagger_construct (NOISE_TYPE_GSTREAMER_TAGGER, cancellable);
}


static void
noise_gstreamer_tagger_file_set_finished (NoiseGStreamerTagger* self)
{
	GCancellable* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->cancellable;
	if (g_cancellable_is_cancelled (_tmp0_)) {
		GstDiscoverer* _tmp1_;
		g_debug ("GStreamerTagger.vala:57: import cancelled");
		_tmp1_ = self->priv->d;
		gst_discoverer_stop (_tmp1_);
		g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL], 0);
	} else {
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		_tmp2_ = self->priv->uri_queue;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		if (_tmp4_ == 0) {
			GstDiscoverer* _tmp5_;
			g_debug ("GStreamerTagger.vala:61: queue finished");
			_tmp5_ = self->priv->d;
			gst_discoverer_stop (_tmp5_);
			g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL], 0);
		} else {
			noise_gstreamer_tagger_import_next_file_set (self);
		}
	}
}


static void
noise_gstreamer_tagger_import_next_file_set (NoiseGStreamerTagger* self)
{
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->uri_queue;
		g_rec_mutex_lock (&self->priv->__lock_uri_queue);
		{
			{
				gchar* uri = NULL;
				GeeLinkedList* _tmp1_;
				gpointer _tmp2_;
				_tmp1_ = self->priv->uri_queue;
				_tmp2_ = gee_deque_poll_head ((GeeDeque*) _tmp1_);
				uri = (gchar*) _tmp2_;
				{
					gboolean _tmp3_ = FALSE;
					_tmp3_ = TRUE;
					while (TRUE) {
						const gchar* _tmp6_;
						GstDiscoverer* _tmp7_;
						const gchar* _tmp8_;
						if (!_tmp3_) {
							GeeLinkedList* _tmp4_;
							gpointer _tmp5_;
							_tmp4_ = self->priv->uri_queue;
							_tmp5_ = gee_deque_poll_head ((GeeDeque*) _tmp4_);
							_g_free0 (uri);
							uri = (gchar*) _tmp5_;
						}
						_tmp3_ = FALSE;
						_tmp6_ = uri;
						if (!(_tmp6_ != NULL)) {
							break;
						}
						_tmp7_ = self->priv->d;
						_tmp8_ = uri;
						gst_discoverer_discover_uri_async (_tmp7_, _tmp8_);
					}
				}
				_g_free0 (uri);
			}
		}
		__finally29:
		{
			GeeLinkedList* _tmp9_;
			_tmp9_ = self->priv->uri_queue;
			g_rec_mutex_unlock (&self->priv->__lock_uri_queue);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void*
__lambda12_ (NoiseGStreamerTagger* self)
{
	void* result = NULL;
	noise_gstreamer_tagger_import_next_file_set (self);
	result = NULL;
	return result;
}


static gpointer
___lambda12__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda12_ ((NoiseGStreamerTagger*) self);
	g_object_unref (self);
	return result;
}


void
noise_gstreamer_tagger_discoverer_import_media (NoiseGStreamerTagger* self,
                                                GeeCollection* uris)
{
	GstDiscoverer* _tmp3_;
	GThread* _tmp4_;
	GThread* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (uris != NULL);
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->uri_queue;
		g_rec_mutex_lock (&self->priv->__lock_uri_queue);
		{
			GeeLinkedList* _tmp1_;
			_tmp1_ = self->priv->uri_queue;
			gee_collection_add_all ((GeeCollection*) _tmp1_, uris);
		}
		__finally30:
		{
			GeeLinkedList* _tmp2_;
			_tmp2_ = self->priv->uri_queue;
			g_rec_mutex_unlock (&self->priv->__lock_uri_queue);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp3_ = self->priv->d;
	gst_discoverer_start (_tmp3_);
	_tmp4_ = g_thread_new (NULL, ___lambda12__gthread_func, g_object_ref (self));
	_tmp5_ = _tmp4_;
	_g_thread_unref0 (_tmp5_);
}


static GDate*
_g_date_dup (GDate* self)
{
	GDate* dup;
	dup = g_new0 (GDate, 1);
	memcpy (dup, self, sizeof (GDate));
	return dup;
}


static gpointer
__g_date_dup0 (gpointer self)
{
	return self ? _g_date_dup (self) : NULL;
}


static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}


static void
noise_gstreamer_tagger_import_media (NoiseGStreamerTagger* self,
                                     GstDiscovererInfo* info,
                                     GError* err)
{
	GCancellable* _tmp0_;
	gchar* uri = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean gstreamer_discovery_successful = FALSE;
	gboolean _tmp13_;
	NoiseMedia* m = NULL;
	const gchar* _tmp15_;
	NoiseMedia* _tmp16_;
	guint64 duration = 0ULL;
	GstTagList* tags = NULL;
	GstTagList* _tmp17_;
	GstTagList* _tmp18_;
	NoiseMedia* _tmp118_;
	guint64 _tmp119_;
	GList* _tmp120_;
	NoiseMedia* _tmp145_;
	NoiseMedia* _tmp146_;
	GFile* _tmp147_;
	GFile* _tmp148_;
	NoiseMedia* _tmp149_;
	time_t _tmp150_;
	NoiseMedia* _tmp151_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (info != NULL);
	_tmp0_ = self->priv->cancellable;
	if (g_cancellable_is_cancelled (_tmp0_)) {
		GstDiscoverer* _tmp1_;
		_tmp1_ = self->priv->d;
		gst_discoverer_stop (_tmp1_);
		{
			GeeLinkedList* _tmp2_;
			_tmp2_ = self->priv->uri_queue;
			g_rec_mutex_lock (&self->priv->__lock_uri_queue);
			{
				GeeLinkedList* _tmp3_;
				_tmp3_ = self->priv->uri_queue;
				gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp3_);
			}
			__finally31:
			{
				GeeLinkedList* _tmp4_;
				_tmp4_ = self->priv->uri_queue;
				g_rec_mutex_unlock (&self->priv->__lock_uri_queue);
			}
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL], 0);
		return;
	}
	_tmp5_ = gst_discoverer_info_get_uri (info);
	_tmp6_ = g_strdup (_tmp5_);
	uri = _tmp6_;
	gstreamer_discovery_successful = FALSE;
	switch (gst_discoverer_info_get_result (info)) {
		case GST_DISCOVERER_OK:
		{
			gstreamer_discovery_successful = TRUE;
			break;
		}
		case GST_DISCOVERER_URI_INVALID:
		{
			const gchar* _tmp7_;
			_tmp7_ = uri;
			g_warning ("GStreamerTagger.vala:109: GStreamer could not import '%s': invalid URI" \
".", _tmp7_);
			break;
		}
		case GST_DISCOVERER_ERROR:
		{
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			_tmp8_ = uri;
			_tmp9_ = err->message;
			g_warning ("GStreamerTagger.vala:113: GStreamer could not import '%s': %s", _tmp8_, _tmp9_);
			break;
		}
		case GST_DISCOVERER_TIMEOUT:
		{
			const gchar* _tmp10_;
			_tmp10_ = uri;
			g_warning ("GStreamerTagger.vala:117: GStreamer could not import '%s': Discovery t" \
"imed out.", _tmp10_);
			break;
		}
		case GST_DISCOVERER_BUSY:
		{
			const gchar* _tmp11_;
			_tmp11_ = uri;
			g_warning ("GStreamerTagger.vala:121: GStreamer could not import '%s': Already dis" \
"covering a file.", _tmp11_);
			break;
		}
		case GST_DISCOVERER_MISSING_PLUGINS:
		{
			const gchar* _tmp12_;
			_tmp12_ = uri;
			g_warning ("GStreamerTagger.vala:125: GStreamer could not import '%s': Missing plu" \
"gins.", _tmp12_);
			break;
		}
		default:
		break;
	}
	_tmp13_ = gstreamer_discovery_successful;
	if (!_tmp13_) {
		const gchar* _tmp14_;
		_tmp14_ = uri;
		g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_IMPORT_ERROR_SIGNAL], 0, _tmp14_, err);
		_g_free0 (uri);
		return;
	}
	_tmp15_ = uri;
	_tmp16_ = noise_media_new (_tmp15_);
	m = _tmp16_;
	duration = (guint64) gst_discoverer_info_get_duration (info);
	_tmp17_ = gst_discoverer_info_get_tags (info);
	tags = _tmp17_;
	_tmp18_ = tags;
	if (_tmp18_ != NULL) {
		gchar* title = NULL;
		GstTagList* _tmp19_;
		gchar* _tmp20_ = NULL;
		gboolean _tmp21_;
		gchar* artist = NULL;
		GstTagList* _tmp24_;
		gchar* _tmp25_ = NULL;
		gboolean _tmp26_;
		gchar* composer = NULL;
		GstTagList* _tmp29_;
		gchar* _tmp30_ = NULL;
		gboolean _tmp31_;
		gchar* album_artist = NULL;
		GstTagList* _tmp34_;
		gchar* _tmp35_ = NULL;
		gboolean _tmp36_;
		gchar* album = NULL;
		GstTagList* _tmp39_;
		gchar* _tmp40_ = NULL;
		gboolean _tmp41_;
		gchar* grouping = NULL;
		GstTagList* _tmp44_;
		gchar* _tmp45_ = NULL;
		gboolean _tmp46_;
		gchar* genre = NULL;
		GstTagList* _tmp49_;
		gchar* _tmp50_ = NULL;
		gboolean _tmp51_;
		gchar* comment = NULL;
		GstTagList* _tmp54_;
		gchar* _tmp55_ = NULL;
		gboolean _tmp56_;
		gchar* lyrics = NULL;
		GstTagList* _tmp59_;
		gchar* _tmp60_ = NULL;
		gboolean _tmp61_;
		guint track_number = 0U;
		GstTagList* _tmp64_;
		guint _tmp65_ = 0U;
		gboolean _tmp66_;
		guint track_count = 0U;
		GstTagList* _tmp69_;
		guint _tmp70_ = 0U;
		gboolean _tmp71_;
		guint album_number = 0U;
		GstTagList* _tmp74_;
		guint _tmp75_ = 0U;
		gboolean _tmp76_;
		guint album_count = 0U;
		GstTagList* _tmp79_;
		guint _tmp80_ = 0U;
		gboolean _tmp81_;
		guint bitrate = 0U;
		GstTagList* _tmp84_;
		guint _tmp85_ = 0U;
		gboolean _tmp86_;
		guint rating = 0U;
		GstTagList* _tmp89_;
		guint _tmp90_ = 0U;
		gboolean _tmp91_;
		GstDateTime* datetime = NULL;
		GstTagList* _tmp94_;
		GstDateTime* _tmp95_ = NULL;
		gboolean _tmp96_;
		gdouble bpm = 0.0;
		GstTagList* _tmp108_;
		gdouble _tmp109_ = 0.0;
		gboolean _tmp110_;
		guint64 _tmp114_;
		_tmp19_ = tags;
		_tmp21_ = gst_tag_list_get_string (_tmp19_, GST_TAG_TITLE, &_tmp20_);
		_g_free0 (title);
		title = _tmp20_;
		if (_tmp21_) {
			NoiseMedia* _tmp22_;
			const gchar* _tmp23_;
			_tmp22_ = m;
			_tmp23_ = title;
			noise_media_set_title (_tmp22_, _tmp23_);
		}
		_tmp24_ = tags;
		_tmp26_ = gst_tag_list_get_string (_tmp24_, GST_TAG_ARTIST, &_tmp25_);
		_g_free0 (artist);
		artist = _tmp25_;
		if (_tmp26_) {
			NoiseMedia* _tmp27_;
			const gchar* _tmp28_;
			_tmp27_ = m;
			_tmp28_ = artist;
			noise_media_set_artist (_tmp27_, _tmp28_);
		}
		_tmp29_ = tags;
		_tmp31_ = gst_tag_list_get_string (_tmp29_, GST_TAG_COMPOSER, &_tmp30_);
		_g_free0 (composer);
		composer = _tmp30_;
		if (_tmp31_) {
			NoiseMedia* _tmp32_;
			const gchar* _tmp33_;
			_tmp32_ = m;
			_tmp33_ = composer;
			noise_media_set_composer (_tmp32_, _tmp33_);
		}
		_tmp34_ = tags;
		_tmp36_ = gst_tag_list_get_string (_tmp34_, GST_TAG_ALBUM_ARTIST, &_tmp35_);
		_g_free0 (album_artist);
		album_artist = _tmp35_;
		if (_tmp36_) {
			NoiseMedia* _tmp37_;
			const gchar* _tmp38_;
			_tmp37_ = m;
			_tmp38_ = album_artist;
			noise_media_set_album_artist (_tmp37_, _tmp38_);
		}
		_tmp39_ = tags;
		_tmp41_ = gst_tag_list_get_string (_tmp39_, GST_TAG_ALBUM, &_tmp40_);
		_g_free0 (album);
		album = _tmp40_;
		if (_tmp41_) {
			NoiseMedia* _tmp42_;
			const gchar* _tmp43_;
			_tmp42_ = m;
			_tmp43_ = album;
			noise_media_set_album (_tmp42_, _tmp43_);
		}
		_tmp44_ = tags;
		_tmp46_ = gst_tag_list_get_string (_tmp44_, GST_TAG_GROUPING, &_tmp45_);
		_g_free0 (grouping);
		grouping = _tmp45_;
		if (_tmp46_) {
			NoiseMedia* _tmp47_;
			const gchar* _tmp48_;
			_tmp47_ = m;
			_tmp48_ = grouping;
			noise_media_set_grouping (_tmp47_, _tmp48_);
		}
		_tmp49_ = tags;
		_tmp51_ = gst_tag_list_get_string (_tmp49_, GST_TAG_GENRE, &_tmp50_);
		_g_free0 (genre);
		genre = _tmp50_;
		if (_tmp51_) {
			NoiseMedia* _tmp52_;
			const gchar* _tmp53_;
			_tmp52_ = m;
			_tmp53_ = genre;
			noise_media_set_genre (_tmp52_, _tmp53_);
		}
		_tmp54_ = tags;
		_tmp56_ = gst_tag_list_get_string (_tmp54_, GST_TAG_COMMENT, &_tmp55_);
		_g_free0 (comment);
		comment = _tmp55_;
		if (_tmp56_) {
			NoiseMedia* _tmp57_;
			const gchar* _tmp58_;
			_tmp57_ = m;
			_tmp58_ = comment;
			noise_media_set_comment (_tmp57_, _tmp58_);
		}
		_tmp59_ = tags;
		_tmp61_ = gst_tag_list_get_string (_tmp59_, GST_TAG_LYRICS, &_tmp60_);
		_g_free0 (lyrics);
		lyrics = _tmp60_;
		if (_tmp61_) {
			NoiseMedia* _tmp62_;
			const gchar* _tmp63_;
			_tmp62_ = m;
			_tmp63_ = lyrics;
			noise_media_set_lyrics (_tmp62_, _tmp63_);
		}
		_tmp64_ = tags;
		_tmp66_ = gst_tag_list_get_uint (_tmp64_, GST_TAG_TRACK_NUMBER, &_tmp65_);
		track_number = _tmp65_;
		if (_tmp66_) {
			NoiseMedia* _tmp67_;
			guint _tmp68_;
			_tmp67_ = m;
			_tmp68_ = track_number;
			noise_media_set_track (_tmp67_, _tmp68_);
		}
		_tmp69_ = tags;
		_tmp71_ = gst_tag_list_get_uint (_tmp69_, GST_TAG_TRACK_COUNT, &_tmp70_);
		track_count = _tmp70_;
		if (_tmp71_) {
			NoiseMedia* _tmp72_;
			guint _tmp73_;
			_tmp72_ = m;
			_tmp73_ = track_count;
			noise_media_set_track_count (_tmp72_, _tmp73_);
		}
		_tmp74_ = tags;
		_tmp76_ = gst_tag_list_get_uint (_tmp74_, GST_TAG_ALBUM_VOLUME_NUMBER, &_tmp75_);
		album_number = _tmp75_;
		if (_tmp76_) {
			NoiseMedia* _tmp77_;
			guint _tmp78_;
			_tmp77_ = m;
			_tmp78_ = album_number;
			noise_media_set_album_number (_tmp77_, _tmp78_);
		}
		_tmp79_ = tags;
		_tmp81_ = gst_tag_list_get_uint (_tmp79_, GST_TAG_ALBUM_VOLUME_COUNT, &_tmp80_);
		album_count = _tmp80_;
		if (_tmp81_) {
			NoiseMedia* _tmp82_;
			guint _tmp83_;
			_tmp82_ = m;
			_tmp83_ = album_count;
			noise_media_set_album_count (_tmp82_, _tmp83_);
		}
		_tmp84_ = tags;
		_tmp86_ = gst_tag_list_get_uint (_tmp84_, GST_TAG_BITRATE, &_tmp85_);
		bitrate = _tmp85_;
		if (_tmp86_) {
			NoiseMedia* _tmp87_;
			guint _tmp88_;
			_tmp87_ = m;
			_tmp88_ = bitrate;
			noise_media_set_bitrate (_tmp87_, _tmp88_ / 1000);
		}
		_tmp89_ = tags;
		_tmp91_ = gst_tag_list_get_uint (_tmp89_, GST_TAG_USER_RATING, &_tmp90_);
		rating = _tmp90_;
		if (_tmp91_) {
			NoiseMedia* _tmp92_;
			guint _tmp93_;
			_tmp92_ = m;
			_tmp93_ = rating;
			noise_media_set_rating (_tmp92_, _tmp93_);
		}
		_tmp94_ = tags;
		_tmp96_ = gst_tag_list_get_date_time (_tmp94_, GST_TAG_DATE_TIME, &_tmp95_);
		_gst_date_time_unref0 (datetime);
		datetime = _tmp95_;
		if (_tmp96_) {
			GstDateTime* _tmp97_;
			_tmp97_ = datetime;
			if (_tmp97_ != NULL) {
				NoiseMedia* _tmp98_;
				GstDateTime* _tmp99_;
				_tmp98_ = m;
				_tmp99_ = datetime;
				noise_media_set_year (_tmp98_, (guint) gst_date_time_get_year (_tmp99_));
			} else {
				GDate* date = NULL;
				GstTagList* _tmp100_;
				GDate _tmp101_ = {0};
				gboolean _tmp102_;
				GDate _tmp103_;
				GDate* _tmp104_;
				_tmp100_ = tags;
				_tmp102_ = gst_tag_list_get_date (_tmp100_, GST_TAG_DATE, &_tmp101_);
				_g_free0 (date);
				_tmp103_ = _tmp101_;
				_tmp104_ = __g_date_dup0 (&_tmp103_);
				date = _tmp104_;
				if (_tmp102_) {
					GDate* _tmp105_;
					_tmp105_ = date;
					if (_tmp105_ != NULL) {
						NoiseMedia* _tmp106_;
						GDate* _tmp107_;
						_tmp106_ = m;
						_tmp107_ = date;
						noise_media_set_year (_tmp106_, (guint) g_date_get_year (_tmp107_));
					}
				}
				_g_free0 (date);
			}
		}
		_tmp108_ = tags;
		_tmp110_ = gst_tag_list_get_double (_tmp108_, GST_TAG_BEATS_PER_MINUTE, &_tmp109_);
		bpm = _tmp109_;
		if (_tmp110_) {
			NoiseMedia* _tmp111_;
			gdouble _tmp112_;
			gdouble _tmp113_;
			_tmp111_ = m;
			_tmp112_ = bpm;
			_tmp113_ = bpm;
			noise_media_set_bpm (_tmp111_, (guint) CLAMP (_tmp112_, (gdouble) 0, _tmp113_));
		}
		_tmp114_ = duration;
		if (_tmp114_ == ((guint64) 0)) {
			GstTagList* _tmp115_;
			guint64 _tmp116_ = 0ULL;
			gboolean _tmp117_;
			_tmp115_ = tags;
			_tmp117_ = gst_tag_list_get_uint64 (_tmp115_, GST_TAG_DURATION, &_tmp116_);
			duration = _tmp116_;
			if (!_tmp117_) {
				duration = (guint64) 0;
			}
		}
		_gst_date_time_unref0 (datetime);
		_g_free0 (lyrics);
		_g_free0 (comment);
		_g_free0 (genre);
		_g_free0 (grouping);
		_g_free0 (album);
		_g_free0 (album_artist);
		_g_free0 (composer);
		_g_free0 (artist);
		_g_free0 (title);
	}
	_tmp118_ = m;
	_tmp119_ = duration;
	noise_media_set_length (_tmp118_, noise_time_utils_nanoseconds_to_miliseconds (_tmp119_));
	_tmp120_ = gst_discoverer_info_get_audio_streams (info);
	{
		GList* stream_info_collection = NULL;
		GList* stream_info_it = NULL;
		stream_info_collection = _tmp120_;
		for (stream_info_it = stream_info_collection; stream_info_it != NULL; stream_info_it = stream_info_it->next) {
			GstDiscovererStreamInfo* _tmp121_;
			GstDiscovererStreamInfo* stream_info = NULL;
			_tmp121_ = _g_object_ref0 ((GstDiscovererStreamInfo*) stream_info_it->data);
			stream_info = _tmp121_;
			{
				GstDiscovererAudioInfo* audio_stream = NULL;
				GstDiscovererStreamInfo* _tmp122_;
				GstDiscovererAudioInfo* _tmp123_;
				GstDiscovererAudioInfo* _tmp124_;
				NoiseMedia* _tmp125_;
				guint _tmp126_;
				guint _tmp127_;
				NoiseMedia* _tmp135_;
				guint _tmp136_;
				guint _tmp137_;
				_tmp122_ = stream_info;
				_tmp123_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp122_, gst_discoverer_audio_info_get_type ()) ? ((GstDiscovererAudioInfo*) _tmp122_) : NULL);
				audio_stream = _tmp123_;
				_tmp124_ = audio_stream;
				if (_tmp124_ == NULL) {
					_g_object_unref0 (audio_stream);
					_g_object_unref0 (stream_info);
					continue;
				}
				_tmp125_ = m;
				_tmp126_ = noise_media_get_samplerate (_tmp125_);
				_tmp127_ = _tmp126_;
				if (_tmp127_ == ((guint) 0)) {
					NoiseMedia* _tmp128_;
					GstDiscovererAudioInfo* _tmp129_;
					NoiseMedia* _tmp130_;
					guint _tmp131_;
					guint _tmp132_;
					gchar* _tmp133_;
					gchar* _tmp134_;
					g_debug ("GStreamerTagger.vala:247: Getting sample rate from stream info");
					_tmp128_ = m;
					_tmp129_ = audio_stream;
					noise_media_set_samplerate (_tmp128_, gst_discoverer_audio_info_get_sample_rate (_tmp129_));
					_tmp130_ = m;
					_tmp131_ = noise_media_get_samplerate (_tmp130_);
					_tmp132_ = _tmp131_;
					_tmp133_ = g_strdup_printf ("%u", _tmp132_);
					_tmp134_ = _tmp133_;
					g_debug ("GStreamerTagger.vala:249: Sample rate = %s", _tmp134_);
					_g_free0 (_tmp134_);
				}
				_tmp135_ = m;
				_tmp136_ = noise_media_get_bitrate (_tmp135_);
				_tmp137_ = _tmp136_;
				if (_tmp137_ == ((guint) 0)) {
					NoiseMedia* _tmp138_;
					GstDiscovererAudioInfo* _tmp139_;
					NoiseMedia* _tmp140_;
					guint _tmp141_;
					guint _tmp142_;
					gchar* _tmp143_;
					gchar* _tmp144_;
					g_debug ("GStreamerTagger.vala:253: Getting bitrate from stream info");
					_tmp138_ = m;
					_tmp139_ = audio_stream;
					noise_media_set_bitrate (_tmp138_, gst_discoverer_audio_info_get_bitrate (_tmp139_));
					_tmp140_ = m;
					_tmp141_ = noise_media_get_bitrate (_tmp140_);
					_tmp142_ = _tmp141_;
					_tmp143_ = g_strdup_printf ("%u", _tmp142_);
					_tmp144_ = _tmp143_;
					g_debug ("GStreamerTagger.vala:255: Bitrate = %s", _tmp144_);
					_g_free0 (_tmp144_);
				}
				_g_object_unref0 (audio_stream);
				_g_object_unref0 (stream_info);
				break;
			}
		}
		(stream_info_collection == NULL) ? NULL : (stream_info_collection = (_g_list_free__g_object_unref0_ (stream_info_collection), NULL));
	}
	_tmp145_ = m;
	_tmp146_ = m;
	_tmp147_ = noise_media_get_file (_tmp146_);
	_tmp148_ = _tmp147_;
	noise_media_set_file_size (_tmp145_, noise_file_utils_get_size (_tmp148_, NULL));
	_tmp149_ = m;
	_tmp150_ = time (NULL);
	noise_media_set_date_added (_tmp149_, (guint) ((gint) _tmp150_));
	_tmp151_ = m;
	g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_MEDIA_IMPORTED_SIGNAL], 0, _tmp151_);
	_g_object_unref0 (m);
	_g_free0 (uri);
}


static void
g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_POINTER) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_POINTER) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_pointer (param_values + 2), data2);
}


static void
noise_gstreamer_tagger_class_init (NoiseGStreamerTaggerClass * klass)
{
	noise_gstreamer_tagger_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseGStreamerTagger_private_offset);
	G_OBJECT_CLASS (klass)->finalize = noise_gstreamer_tagger_finalize;
	noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_MEDIA_IMPORTED_SIGNAL] = g_signal_new ("media-imported", NOISE_TYPE_GSTREAMER_TAGGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_MEDIA);
	noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_IMPORT_ERROR_SIGNAL] = g_signal_new ("import-error", NOISE_TYPE_GSTREAMER_TAGGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_POINTER, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_POINTER);
	noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL] = g_signal_new ("queue-finished", NOISE_TYPE_GSTREAMER_TAGGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
noise_gstreamer_tagger_instance_init (NoiseGStreamerTagger * self)
{
	GeeLinkedList* _tmp0_;
	GCancellable* _tmp1_;
	self->priv = noise_gstreamer_tagger_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_uri_queue);
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	self->priv->uri_queue = _tmp0_;
	_tmp1_ = g_cancellable_new ();
	self->priv->cancellable = _tmp1_;
}


static void
noise_gstreamer_tagger_finalize (GObject * obj)
{
	NoiseGStreamerTagger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTagger);
	_g_object_unref0 (self->priv->d);
	g_rec_mutex_clear (&self->priv->__lock_uri_queue);
	_g_object_unref0 (self->priv->uri_queue);
	_g_object_unref0 (self->priv->cancellable);
	G_OBJECT_CLASS (noise_gstreamer_tagger_parent_class)->finalize (obj);
}


GType
noise_gstreamer_tagger_get_type (void)
{
	static volatile gsize noise_gstreamer_tagger_type_id__volatile = 0;
	if (g_once_init_enter (&noise_gstreamer_tagger_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseGStreamerTaggerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_gstreamer_tagger_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseGStreamerTagger), 0, (GInstanceInitFunc) noise_gstreamer_tagger_instance_init, NULL };
		GType noise_gstreamer_tagger_type_id;
		noise_gstreamer_tagger_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseGStreamerTagger", &g_define_type_info, 0);
		NoiseGStreamerTagger_private_offset = g_type_add_instance_private (noise_gstreamer_tagger_type_id, sizeof (NoiseGStreamerTaggerPrivate));
		g_once_init_leave (&noise_gstreamer_tagger_type_id__volatile, noise_gstreamer_tagger_type_id);
	}
	return noise_gstreamer_tagger_type_id__volatile;
}



