/* Streamer.c generated by valac 0.41.91, the Vala compiler
 * generated from Streamer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gst/gst.h>
#include <granite.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gst/pbutils/pbutils.h>
#include <gtk/gtk.h>


#define NOISE_TYPE_STREAMER (noise_streamer_get_type ())
#define NOISE_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_STREAMER, NoiseStreamer))
#define NOISE_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_STREAMER, NoiseStreamerClass))
#define NOISE_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_STREAMER))
#define NOISE_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_STREAMER))
#define NOISE_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_STREAMER, NoiseStreamerClass))

typedef struct _NoiseStreamer NoiseStreamer;
typedef struct _NoiseStreamerClass NoiseStreamerClass;
typedef struct _NoiseStreamerPrivate NoiseStreamerPrivate;

#define NOISE_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG (noise_install_gstreamer_plugins_dialog_get_type ())
#define NOISE_INSTALL_GSTREAMER_PLUGINS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG, NoiseInstallGstreamerPluginsDialog))
#define NOISE_INSTALL_GSTREAMER_PLUGINS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG, NoiseInstallGstreamerPluginsDialogClass))
#define NOISE_IS_INSTALL_GSTREAMER_PLUGINS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG))
#define NOISE_IS_INSTALL_GSTREAMER_PLUGINS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG))
#define NOISE_INSTALL_GSTREAMER_PLUGINS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG, NoiseInstallGstreamerPluginsDialogClass))

typedef struct _NoiseInstallGstreamerPluginsDialog NoiseInstallGstreamerPluginsDialog;
typedef struct _NoiseInstallGstreamerPluginsDialogClass NoiseInstallGstreamerPluginsDialogClass;
enum  {
	NOISE_STREAMER_0_PROPERTY,
	NOISE_STREAMER_NUM_PROPERTIES
};
static GParamSpec* noise_streamer_properties[NOISE_STREAMER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NOISE_TYPE_PLAYBACK_MANAGER (noise_playback_manager_get_type ())
#define NOISE_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager))
#define NOISE_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))
#define NOISE_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))

typedef struct _NoisePlaybackManager NoisePlaybackManager;
typedef struct _NoisePlaybackManagerClass NoisePlaybackManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))

struct _NoiseStreamer {
	GObject parent_instance;
	NoiseStreamerPrivate * priv;
	GstElement* cdda;
	gboolean set_resume_pos;
};

struct _NoiseStreamerClass {
	GObjectClass parent_class;
};

struct _NoiseStreamerPrivate {
	NoisePipeline* pipe;
	NoiseInstallGstreamerPluginsDialog* dialog;
};


static gint NoiseStreamer_private_offset;
static gpointer noise_streamer_parent_class = NULL;
static NoisePlaybackIface * noise_streamer_noise_playback_parent_iface = NULL;

GType noise_streamer_get_type (void) G_GNUC_CONST;
GType noise_install_gstreamer_plugins_dialog_get_type (void) G_GNUC_CONST;
NoiseStreamer* noise_streamer_new (void);
NoiseStreamer* noise_streamer_construct (GType object_type);
static gboolean noise_streamer_bus_callback (NoiseStreamer* self,
                                      GstBus* bus,
                                      GstMessage* message);
static gboolean _noise_streamer_bus_callback_gst_bus_func (GstBus* bus,
                                                    GstMessage* message,
                                                    gpointer self);
static gboolean _noise_playback_update_position_gsource_func (gpointer self);
static GeeCollection* noise_streamer_real_get_supported_uri (NoisePlayback* base);
static gboolean noise_streamer_real_update_position (NoisePlayback* base);
GType noise_playback_manager_get_type (void) G_GNUC_CONST;
NoisePlaybackManager* noise_app_get_player (void);
NoiseMedia* noise_playback_manager_get_current_media (NoisePlaybackManager* self);
static void noise_streamer_real_play (NoisePlayback* base);
static void noise_streamer_real_pause (NoisePlayback* base);
static void noise_streamer_real_set_state (NoisePlayback* base,
                                    GstState s);
static void noise_streamer_real_set_media (NoisePlayback* base,
                                    NoiseMedia* media);
static void noise_streamer_real_set_position (NoisePlayback* base,
                                       gint64 pos);
static gint64 noise_streamer_real_get_position (NoisePlayback* base);
static gint64 noise_streamer_real_get_duration (NoisePlayback* base);
static void noise_streamer_real_set_volume (NoisePlayback* base,
                                     gdouble val);
static gdouble noise_streamer_real_get_volume (NoisePlayback* base);
static void noise_streamer_real_enable_equalizer (NoisePlayback* base);
static void noise_streamer_real_disable_equalizer (NoisePlayback* base);
static void noise_streamer_real_set_equalizer_gain (NoisePlayback* base,
                                             gint index,
                                             gint val);
NoiseInstallGstreamerPluginsDialog* noise_install_gstreamer_plugins_dialog_new (GstMessage* message);
NoiseInstallGstreamerPluginsDialog* noise_install_gstreamer_plugins_dialog_construct (GType object_type,
                                                                                      GstMessage* message);
static void noise_streamer_finalize (GObject * obj);


static inline gpointer
noise_streamer_get_instance_private (NoiseStreamer* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseStreamer_private_offset);
}


static gboolean
_noise_streamer_bus_callback_gst_bus_func (GstBus* bus,
                                           GstMessage* message,
                                           gpointer self)
{
	gboolean result;
	result = noise_streamer_bus_callback ((NoiseStreamer*) self, bus, message);
	return result;
}


static gboolean
_noise_playback_update_position_gsource_func (gpointer self)
{
	gboolean result;
	result = noise_playback_update_position ((NoisePlayback*) self);
	return result;
}


NoiseStreamer*
noise_streamer_construct (GType object_type)
{
	NoiseStreamer * self = NULL;
	NoisePipeline* _tmp0_;
	NoisePipeline* _tmp1_;
	GstBus* _tmp2_;
	self = (NoiseStreamer*) g_object_new (object_type, NULL);
	_tmp0_ = noise_pipeline_new ();
	_g_object_unref0 (self->priv->pipe);
	self->priv->pipe = _tmp0_;
	_tmp1_ = self->priv->pipe;
	_tmp2_ = _tmp1_->bus;
	gst_bus_add_watch_full (_tmp2_, G_PRIORITY_DEFAULT, _noise_streamer_bus_callback_gst_bus_func, g_object_ref (self), g_object_unref);
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _noise_playback_update_position_gsource_func, g_object_ref ((NoisePlayback*) self), g_object_unref);
	return self;
}


NoiseStreamer*
noise_streamer_new (void)
{
	return noise_streamer_construct (NOISE_TYPE_STREAMER);
}


static GeeCollection*
noise_streamer_real_get_supported_uri (NoisePlayback* base)
{
	NoiseStreamer * self;
	GeeCollection* result = NULL;
	GeeLinkedList* uris = NULL;
	GeeLinkedList* _tmp0_;
	self = (NoiseStreamer*) base;
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	uris = _tmp0_;
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "file://");
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "http://");
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "smb://");
	result = (GeeCollection*) uris;
	return result;
}


static gboolean
noise_streamer_real_update_position (NoisePlayback* base)
{
	NoiseStreamer * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	self = (NoiseStreamer*) base;
	_tmp1_ = self->set_resume_pos;
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_ = FALSE;
		NoisePlaybackManager* _tmp3_;
		NoisePlaybackManager* _tmp4_;
		NoiseMedia* _tmp5_;
		NoiseMedia* _tmp6_;
		_tmp3_ = noise_app_get_player ();
		_tmp4_ = _tmp3_;
		_tmp5_ = noise_playback_manager_get_current_media (_tmp4_);
		_tmp6_ = _tmp5_;
		if (_tmp6_ != NULL) {
			NoisePlaybackManager* _tmp7_;
			NoisePlaybackManager* _tmp8_;
			NoiseMedia* _tmp9_;
			NoiseMedia* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			_tmp7_ = noise_app_get_player ();
			_tmp8_ = _tmp7_;
			_tmp9_ = noise_playback_manager_get_current_media (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = noise_media_get_resume_pos (_tmp10_);
			_tmp12_ = _tmp11_;
			_tmp2_ = noise_playback_get_position ((NoisePlayback*) self) >= (((gint64) (_tmp12_ - 1)) * 1000000000);
		} else {
			_tmp2_ = FALSE;
		}
		_tmp0_ = _tmp2_;
	}
	if (_tmp0_) {
		self->set_resume_pos = TRUE;
		g_signal_emit_by_name ((NoisePlayback*) self, "current-position-update", noise_playback_get_position ((NoisePlayback*) self));
	} else {
		NoisePlaybackManager* _tmp13_;
		NoisePlaybackManager* _tmp14_;
		NoiseMedia* _tmp15_;
		NoiseMedia* _tmp16_;
		_tmp13_ = noise_app_get_player ();
		_tmp14_ = _tmp13_;
		_tmp15_ = noise_playback_manager_get_current_media (_tmp14_);
		_tmp16_ = _tmp15_;
		if (_tmp16_ != NULL) {
			NoisePipeline* _tmp17_;
			GstElement* _tmp18_;
			NoisePlaybackManager* _tmp19_;
			NoisePlaybackManager* _tmp20_;
			NoiseMedia* _tmp21_;
			NoiseMedia* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			_tmp17_ = self->priv->pipe;
			_tmp18_ = _tmp17_->playbin;
			_tmp19_ = noise_app_get_player ();
			_tmp20_ = _tmp19_;
			_tmp21_ = noise_playback_manager_get_current_media (_tmp20_);
			_tmp22_ = _tmp21_;
			_tmp23_ = noise_media_get_resume_pos (_tmp22_);
			_tmp24_ = _tmp23_;
			gst_element_seek_simple (_tmp18_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp24_) * 1000000000);
		}
	}
	result = TRUE;
	return result;
}


static void
noise_streamer_real_play (NoisePlayback* base)
{
	NoiseStreamer * self;
	self = (NoiseStreamer*) base;
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_PLAYING);
}


static void
noise_streamer_real_pause (NoisePlayback* base)
{
	NoiseStreamer * self;
	self = (NoiseStreamer*) base;
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_PAUSED);
}


static void
noise_streamer_real_set_state (NoisePlayback* base,
                               GstState s)
{
	NoiseStreamer * self;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	self = (NoiseStreamer*) base;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_set_state (_tmp1_, s);
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch32_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch32_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally32;
	__catch32_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally32:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static void
noise_streamer_real_set_media (NoisePlayback* base,
                               NoiseMedia* media)
{
	NoiseStreamer * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	NoisePipeline* _tmp3_;
	GstElement* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GValue _tmp9_ = {0};
	NoisePlaybackManager* _tmp10_;
	NoisePlaybackManager* _tmp11_;
	NoiseMedia* _tmp12_;
	NoiseMedia* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	NoisePipeline* _tmp16_;
	GstElement* _tmp17_;
	NoisePlaybackManager* _tmp18_;
	NoisePlaybackManager* _tmp19_;
	NoiseMedia* _tmp20_;
	NoiseMedia* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	self = (NoiseStreamer*) base;
	g_return_if_fail (media != NULL);
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_READY);
	_tmp0_ = noise_media_get_uri (media);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	g_debug ("Streamer.vala:87: set uri to %s\n", _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = self->priv->pipe;
	_tmp4_ = _tmp3_->playbin;
	_tmp5_ = noise_media_get_uri (media);
	_tmp6_ = _tmp5_;
	_tmp7_ = _tmp6_;
	_tmp8_ = string_replace (_tmp7_, "#", "%23");
	g_value_init (&_tmp9_, G_TYPE_STRING);
	g_value_take_string (&_tmp9_, _tmp8_);
	g_object_set_property ((GObject*) _tmp4_, "uri", &_tmp9_);
	G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
	_g_free0 (_tmp7_);
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_PLAYING);
	_tmp10_ = noise_app_get_player ();
	_tmp11_ = _tmp10_;
	_tmp12_ = noise_playback_manager_get_current_media (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = noise_media_get_resume_pos (_tmp13_);
	_tmp15_ = _tmp14_;
	g_debug ("Streamer.vala:93: setURI seeking to %d\n", _tmp15_);
	_tmp16_ = self->priv->pipe;
	_tmp17_ = _tmp16_->playbin;
	_tmp18_ = noise_app_get_player ();
	_tmp19_ = _tmp18_;
	_tmp20_ = noise_playback_manager_get_current_media (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = noise_media_get_resume_pos (_tmp21_);
	_tmp23_ = _tmp22_;
	gst_element_seek_simple (_tmp17_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp23_) * 1000000000);
	noise_playback_play ((NoisePlayback*) self);
}


static void
noise_streamer_real_set_position (NoisePlayback* base,
                                  gint64 pos)
{
	NoiseStreamer * self;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	self = (NoiseStreamer*) base;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_seek (_tmp1_, 1.0, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, GST_SEEK_TYPE_SET, pos, GST_SEEK_TYPE_NONE, noise_playback_get_duration ((NoisePlayback*) self));
}


static gint64
noise_streamer_real_get_position (NoisePlayback* base)
{
	NoiseStreamer * self;
	gint64 result = 0LL;
	gint64 rv = 0LL;
	GstFormat f = 0;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
	self = (NoiseStreamer*) base;
	rv = (gint64) 0;
	f = GST_FORMAT_TIME;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_query_position (_tmp1_, f, &_tmp2_);
	rv = _tmp2_;
	result = rv;
	return result;
}


static gint64
noise_streamer_real_get_duration (NoisePlayback* base)
{
	NoiseStreamer * self;
	gint64 result = 0LL;
	gint64 rv = 0LL;
	GstFormat f = 0;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
	self = (NoiseStreamer*) base;
	rv = (gint64) 0;
	f = GST_FORMAT_TIME;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_query_duration (_tmp1_, f, &_tmp2_);
	rv = _tmp2_;
	result = rv;
	return result;
}


static void
noise_streamer_real_set_volume (NoisePlayback* base,
                                gdouble val)
{
	NoiseStreamer * self;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	GValue _tmp2_ = {0};
	self = (NoiseStreamer*) base;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->playbin;
	g_value_init (&_tmp2_, G_TYPE_DOUBLE);
	g_value_set_double (&_tmp2_, val);
	g_object_set_property ((GObject*) _tmp1_, "volume", &_tmp2_);
	G_IS_VALUE (&_tmp2_) ? (g_value_unset (&_tmp2_), NULL) : NULL;
}


static gdouble
noise_streamer_real_get_volume (NoisePlayback* base)
{
	NoiseStreamer * self;
	gdouble result = 0.0;
	GValue val = {0};
	GValue _tmp0_ = {0};
	NoisePipeline* _tmp1_;
	GstElement* _tmp2_;
	GValue _tmp3_;
	self = (NoiseStreamer*) base;
	g_value_init (&_tmp0_, G_TYPE_DOUBLE);
	val = _tmp0_;
	_tmp1_ = self->priv->pipe;
	_tmp2_ = _tmp1_->playbin;
	g_object_get_property ((GObject*) _tmp2_, "volume", &val);
	_tmp3_ = val;
	result = g_value_get_double (&_tmp3_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	return result;
}


static void
noise_streamer_real_enable_equalizer (NoisePlayback* base)
{
	NoiseStreamer * self;
	NoisePipeline* _tmp0_;
	self = (NoiseStreamer*) base;
	_tmp0_ = self->priv->pipe;
	noise_pipeline_enableEqualizer (_tmp0_);
}


static void
noise_streamer_real_disable_equalizer (NoisePlayback* base)
{
	NoiseStreamer * self;
	NoisePipeline* _tmp0_;
	self = (NoiseStreamer*) base;
	_tmp0_ = self->priv->pipe;
	noise_pipeline_disableEqualizer (_tmp0_);
}


static void
noise_streamer_real_set_equalizer_gain (NoisePlayback* base,
                                        gint index,
                                        gint val)
{
	NoiseStreamer * self;
	NoisePipeline* _tmp0_;
	NoiseEqualizer* _tmp1_;
	self = (NoiseStreamer*) base;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->eq;
	noise_equalizer_setGain (_tmp1_, index, (gdouble) val);
}


static gboolean
noise_streamer_bus_callback (NoiseStreamer* self,
                             GstBus* bus,
                             GstMessage* message)
{
	gboolean result = FALSE;
	GstMessageType _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (bus != NULL, FALSE);
	g_return_val_if_fail (message != NULL, FALSE);
	_tmp0_ = message->type;
	switch (_tmp0_) {
		case GST_MESSAGE_ERROR:
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GError* _tmp1_ = NULL;
			gchar* _tmp2_ = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
			gst_message_parse_error (message, &_tmp1_, &_tmp2_);
			_g_error_free0 (err);
			err = _tmp1_;
			_g_free0 (debug);
			debug = _tmp2_;
			_tmp3_ = err;
			_tmp4_ = _tmp3_->message;
			g_warning ("Streamer.vala:154: Error: %s\n", _tmp4_);
			g_signal_emit_by_name ((NoisePlayback*) self, "error-occured");
			_g_free0 (debug);
			_g_error_free0 (err);
			break;
		}
		case GST_MESSAGE_ELEMENT:
		{
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_ = FALSE;
			GstStructure* _tmp7_;
			_tmp7_ = gst_message_get_structure (message);
			if (_tmp7_ != NULL) {
				_tmp6_ = gst_is_missing_plugin_message (message);
			} else {
				_tmp6_ = FALSE;
			}
			if (_tmp6_) {
				gboolean _tmp8_ = FALSE;
				NoiseInstallGstreamerPluginsDialog* _tmp9_;
				_tmp9_ = self->priv->dialog;
				if (_tmp9_ == NULL) {
					_tmp8_ = TRUE;
				} else {
					NoiseInstallGstreamerPluginsDialog* _tmp10_;
					gboolean _tmp11_;
					gboolean _tmp12_;
					_tmp10_ = self->priv->dialog;
					_tmp11_ = gtk_widget_get_visible ((GtkWidget*) _tmp10_);
					_tmp12_ = _tmp11_;
					_tmp8_ = !_tmp12_;
				}
				_tmp5_ = _tmp8_;
			} else {
				_tmp5_ = FALSE;
			}
			if (_tmp5_) {
				NoiseInstallGstreamerPluginsDialog* _tmp13_;
				_tmp13_ = noise_install_gstreamer_plugins_dialog_new (message);
				g_object_ref_sink (_tmp13_);
				_g_object_unref0 (self->priv->dialog);
				self->priv->dialog = _tmp13_;
			}
			break;
		}
		case GST_MESSAGE_EOS:
		{
			g_signal_emit_by_name ((NoisePlayback*) self, "end-of-stream");
			break;
		}
		case GST_MESSAGE_STATE_CHANGED:
		{
			GstState oldstate = 0;
			GstState newstate = 0;
			GstState pending = 0;
			GstState _tmp14_ = 0;
			GstState _tmp15_ = 0;
			GstState _tmp16_ = 0;
			GstState _tmp17_;
			gst_message_parse_state_changed (message, &_tmp14_, &_tmp15_, &_tmp16_);
			oldstate = _tmp14_;
			newstate = _tmp15_;
			pending = _tmp16_;
			_tmp17_ = newstate;
			if (_tmp17_ != GST_STATE_PLAYING) {
				break;
			}
			break;
		}
		case GST_MESSAGE_TAG:
		{
			GstTagList* tag_list = NULL;
			GstTagList* _tmp18_ = NULL;
			GstTagList* _tmp19_;
			gst_message_parse_tag (message, &_tmp18_);
			_gst_tag_list_unref0 (tag_list);
			tag_list = _tmp18_;
			_tmp19_ = tag_list;
			if (_tmp19_ != NULL) {
				GstTagList* _tmp20_;
				_tmp20_ = tag_list;
				if (gst_tag_list_get_tag_size (_tmp20_, GST_TAG_TITLE) > ((guint) 0)) {
					gchar* title = NULL;
					gchar* _tmp21_;
					GstTagList* _tmp22_;
					gchar* _tmp23_ = NULL;
					_tmp21_ = g_strdup ("");
					title = _tmp21_;
					_tmp22_ = tag_list;
					gst_tag_list_get_string (_tmp22_, GST_TAG_TITLE, &_tmp23_);
					_g_free0 (title);
					title = _tmp23_;
					_g_free0 (title);
				}
			}
			_gst_tag_list_unref0 (tag_list);
			break;
		}
		default:
		{
			break;
		}
	}
	result = TRUE;
	return result;
}


static void
noise_streamer_class_init (NoiseStreamerClass * klass)
{
	noise_streamer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseStreamer_private_offset);
	G_OBJECT_CLASS (klass)->finalize = noise_streamer_finalize;
}


static void
noise_streamer_noise_playback_interface_init (NoisePlaybackIface * iface)
{
	noise_streamer_noise_playback_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_supported_uri = (GeeCollection* (*) (NoisePlayback *)) noise_streamer_real_get_supported_uri;
	iface->update_position = (gboolean (*) (NoisePlayback *)) noise_streamer_real_update_position;
	iface->play = (void (*) (NoisePlayback *)) noise_streamer_real_play;
	iface->pause = (void (*) (NoisePlayback *)) noise_streamer_real_pause;
	iface->set_state = (void (*) (NoisePlayback *, GstState)) noise_streamer_real_set_state;
	iface->set_media = (void (*) (NoisePlayback *, NoiseMedia*)) noise_streamer_real_set_media;
	iface->set_position = (void (*) (NoisePlayback *, gint64)) noise_streamer_real_set_position;
	iface->get_position = (gint64 (*) (NoisePlayback *)) noise_streamer_real_get_position;
	iface->get_duration = (gint64 (*) (NoisePlayback *)) noise_streamer_real_get_duration;
	iface->set_volume = (void (*) (NoisePlayback *, gdouble)) noise_streamer_real_set_volume;
	iface->get_volume = (gdouble (*) (NoisePlayback *)) noise_streamer_real_get_volume;
	iface->enable_equalizer = (void (*) (NoisePlayback *)) noise_streamer_real_enable_equalizer;
	iface->disable_equalizer = (void (*) (NoisePlayback *)) noise_streamer_real_disable_equalizer;
	iface->set_equalizer_gain = (void (*) (NoisePlayback *, gint, gint)) noise_streamer_real_set_equalizer_gain;
}


static void
noise_streamer_instance_init (NoiseStreamer * self)
{
	self->priv = noise_streamer_get_instance_private (self);
}


static void
noise_streamer_finalize (GObject * obj)
{
	NoiseStreamer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_STREAMER, NoiseStreamer);
	_g_object_unref0 (self->priv->pipe);
	_g_object_unref0 (self->priv->dialog);
	_g_object_unref0 (self->cdda);
	G_OBJECT_CLASS (noise_streamer_parent_class)->finalize (obj);
}


GType
noise_streamer_get_type (void)
{
	static volatile gsize noise_streamer_type_id__volatile = 0;
	if (g_once_init_enter (&noise_streamer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseStreamerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_streamer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseStreamer), 0, (GInstanceInitFunc) noise_streamer_instance_init, NULL };
		static const GInterfaceInfo noise_playback_info = { (GInterfaceInitFunc) noise_streamer_noise_playback_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_streamer_type_id;
		noise_streamer_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseStreamer", &g_define_type_info, 0);
		g_type_add_interface_static (noise_streamer_type_id, NOISE_TYPE_PLAYBACK, &noise_playback_info);
		NoiseStreamer_private_offset = g_type_add_instance_private (noise_streamer_type_id, sizeof (NoiseStreamerPrivate));
		g_once_init_leave (&noise_streamer_type_id__volatile, noise_streamer_type_id);
	}
	return noise_streamer_type_id__volatile;
}



