/* PlaybackManager.c generated by valac 0.41.91, the Vala compiler
 * generated from PlaybackManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>


#define NOISE_TYPE_PLAYBACK_MANAGER (noise_playback_manager_get_type ())
#define NOISE_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager))
#define NOISE_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))
#define NOISE_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))

typedef struct _NoisePlaybackManager NoisePlaybackManager;
typedef struct _NoisePlaybackManagerClass NoisePlaybackManagerClass;
typedef struct _NoisePlaybackManagerPrivate NoisePlaybackManagerPrivate;

#define NOISE_TYPE_HISTORY_PLAYLIST (noise_history_playlist_get_type ())
#define NOISE_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylist))
#define NOISE_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))
#define NOISE_IS_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_IS_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_HISTORY_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))

typedef struct _NoiseHistoryPlaylist NoiseHistoryPlaylist;
typedef struct _NoiseHistoryPlaylistClass NoiseHistoryPlaylistClass;

#define NOISE_TYPE_STREAMER (noise_streamer_get_type ())
#define NOISE_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_STREAMER, NoiseStreamer))
#define NOISE_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_STREAMER, NoiseStreamerClass))
#define NOISE_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_STREAMER))
#define NOISE_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_STREAMER))
#define NOISE_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_STREAMER, NoiseStreamerClass))

typedef struct _NoiseStreamer NoiseStreamer;
typedef struct _NoiseStreamerClass NoiseStreamerClass;
enum  {
	NOISE_PLAYBACK_MANAGER_0_PROPERTY,
	NOISE_PLAYBACK_MANAGER_QUEUE_PLAYLIST_PROPERTY,
	NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY,
	NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY,
	NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY,
	NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY,
	NOISE_PLAYBACK_MANAGER_NUM_PROPERTIES
};
static GParamSpec* noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_NUM_PROPERTIES];

#define NOISE_PLAYBACK_MANAGER_TYPE_SHUFFLE (noise_playback_manager_shuffle_get_type ())

#define NOISE_PLAYBACK_MANAGER_TYPE_REPEAT (noise_playback_manager_repeat_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block10Data Block10Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL,
	NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_NUM_SIGNALS
};
static guint noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_NUM_SIGNALS] = {0};

struct _NoisePlaybackManager {
	GObject parent_instance;
	NoisePlaybackManagerPrivate * priv;
	NoiseHistoryPlaylist* history_playlist;
	NoiseStreamer* file_player;
	NoisePlayback* player;
};

struct _NoisePlaybackManagerClass {
	GObjectClass parent_class;
};

struct _NoisePlaybackManagerPrivate {
	GeeTreeSet* playbacks;
	GRecMutex __lock_playbacks;
	NoiseStaticPlaylist* ordered_queue;
	NoiseStaticPlaylist* _queue_playlist;
	gint _ci;
	gboolean _playing;
	gdouble saved_volume;
	NoiseMedia* _current_media;
};

typedef enum  {
	NOISE_PLAYBACK_MANAGER_SHUFFLE_OFF,
	NOISE_PLAYBACK_MANAGER_SHUFFLE_ALL
} NoisePlaybackManagerShuffle;

typedef enum  {
	NOISE_PLAYBACK_MANAGER_REPEAT_OFF,
	NOISE_PLAYBACK_MANAGER_REPEAT_MEDIA,
	NOISE_PLAYBACK_MANAGER_REPEAT_ALL
} NoisePlaybackManagerRepeat;

struct _Block10Data {
	int _ref_count_;
	NoisePlaybackManager* self;
	NoiseMedia* m;
};


static gint NoisePlaybackManager_private_offset;
static gpointer noise_playback_manager_parent_class = NULL;

GType noise_playback_manager_get_type (void) G_GNUC_CONST;
GType noise_history_playlist_get_type (void) G_GNUC_CONST;
GType noise_streamer_get_type (void) G_GNUC_CONST;
GType noise_playback_manager_shuffle_get_type (void) G_GNUC_CONST;
GType noise_playback_manager_repeat_get_type (void) G_GNUC_CONST;
void noise_playback_manager_add_playback (NoisePlaybackManager* self,
                                          NoisePlayback* playback);
void noise_playback_manager_queue_medias (NoisePlaybackManager* self,
                                          GeeCollection* to_queue);
static void noise_playback_manager_reshuffle (NoisePlaybackManager* self);
NoiseStaticPlaylist* noise_playback_manager_get_queue_playlist (NoisePlaybackManager* self);
void noise_playback_manager_unqueue_medias (NoisePlaybackManager* self,
                                            GeeCollection* to_unqueue);
void noise_playback_manager_clear_queue (NoisePlaybackManager* self);
void noise_playback_manager_set_current_index (NoisePlaybackManager* self,
                                               gint value);
NoiseMedia* noise_playback_manager_media_from_current_index (NoisePlaybackManager* self,
                                                             gint index_in_current);
GeeCollection* noise_playback_manager_get_current_media_list (NoisePlaybackManager* self);
void noise_playback_manager_set_repeat_mode (NoisePlaybackManager* self,
                                             NoiseSettingsRepeat mode);
void noise_playback_manager_set_shuffle_mode (NoisePlaybackManager* self,
                                              NoiseSettingsShuffle mode);
NoiseMedia* noise_playback_manager_get_current_media (NoisePlaybackManager* self);
static NoiseMedia* noise_playback_manager_get_media_at (NoisePlaybackManager* self,
                                                 gint position,
                                                 gint* media_index);
gint noise_playback_manager_get_current_index (NoisePlaybackManager* self);
static gint noise_playback_manager_fix_index (NoisePlaybackManager* self,
                                       gint index);
static void noise_playback_manager_set_current_media (NoisePlaybackManager* self,
                                               NoiseMedia* value);
NoiseMedia* noise_playback_manager_get_next (NoisePlaybackManager* self,
                                             gboolean play);
void noise_playback_manager_stop_playback (NoisePlaybackManager* self);
void noise_playback_manager_play_media (NoisePlaybackManager* self,
                                        NoiseMedia* m);
NoiseMedia* noise_playback_manager_get_previous (NoisePlaybackManager* self,
                                                 gboolean play);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void noise_playback_manager_set_volume (NoisePlaybackManager* self,
                                        gdouble value);
void noise_playback_manager_change_gains_thread (NoisePlaybackManager* self);
gboolean noise_playback_manager_get_playing (NoisePlaybackManager* self);
GSettings* noise_app_get_settings (void);
static gboolean __lambda33_ (Block10Data* _data10_);
static NoiseLibrary* noise_playback_manager_get_library (NoisePlaybackManager* self);
static gboolean ___lambda33__gsource_func (gpointer self);
static void noise_playback_manager_set_playing (NoisePlaybackManager* self,
                                         gboolean value);
void noise_playback_manager_start_playback (NoisePlaybackManager* self);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
GSimpleActionGroup* noise_library_window_get_actions (NoiseLibraryWindow* self);
#define NOISE_LIBRARY_WINDOW_ACTION_PLAY "action_play"
static GVariant* _variant_new4 (gboolean value);
void noise_playback_manager_pause_playback (NoisePlaybackManager* self);
static GVariant* _variant_new5 (gboolean value);
NoisePlaybackManager* noise_playback_manager_new (void);
NoisePlaybackManager* noise_playback_manager_construct (GType object_type);
void noise_playback_manager_set_queue_playlist (NoisePlaybackManager* self,
                                                NoiseStaticPlaylist* value);
gdouble noise_playback_manager_get_volume (NoisePlaybackManager* self);
static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data);
static GObject * noise_playback_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
NoiseHistoryPlaylist* noise_history_playlist_new (void);
NoiseHistoryPlaylist* noise_history_playlist_construct (GType object_type);
NoiseStreamer* noise_streamer_new (void);
NoiseStreamer* noise_streamer_construct (GType object_type);
static void noise_playback_manager_finalize (GObject * obj);
static void _vala_noise_playback_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_noise_playback_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);


static inline gpointer
noise_playback_manager_get_instance_private (NoisePlaybackManager* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePlaybackManager_private_offset);
}


GType
noise_playback_manager_shuffle_get_type (void)
{
	static volatile gsize noise_playback_manager_shuffle_type_id__volatile = 0;
	if (g_once_init_enter (&noise_playback_manager_shuffle_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_PLAYBACK_MANAGER_SHUFFLE_OFF, "NOISE_PLAYBACK_MANAGER_SHUFFLE_OFF", "off"}, {NOISE_PLAYBACK_MANAGER_SHUFFLE_ALL, "NOISE_PLAYBACK_MANAGER_SHUFFLE_ALL", "all"}, {0, NULL, NULL}};
		GType noise_playback_manager_shuffle_type_id;
		noise_playback_manager_shuffle_type_id = g_enum_register_static ("NoisePlaybackManagerShuffle", values);
		g_once_init_leave (&noise_playback_manager_shuffle_type_id__volatile, noise_playback_manager_shuffle_type_id);
	}
	return noise_playback_manager_shuffle_type_id__volatile;
}


GType
noise_playback_manager_repeat_get_type (void)
{
	static volatile gsize noise_playback_manager_repeat_type_id__volatile = 0;
	if (g_once_init_enter (&noise_playback_manager_repeat_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_PLAYBACK_MANAGER_REPEAT_OFF, "NOISE_PLAYBACK_MANAGER_REPEAT_OFF", "off"}, {NOISE_PLAYBACK_MANAGER_REPEAT_MEDIA, "NOISE_PLAYBACK_MANAGER_REPEAT_MEDIA", "media"}, {NOISE_PLAYBACK_MANAGER_REPEAT_ALL, "NOISE_PLAYBACK_MANAGER_REPEAT_ALL", "all"}, {0, NULL, NULL}};
		GType noise_playback_manager_repeat_type_id;
		noise_playback_manager_repeat_type_id = g_enum_register_static ("NoisePlaybackManagerRepeat", values);
		g_once_init_leave (&noise_playback_manager_repeat_type_id__volatile, noise_playback_manager_repeat_type_id);
	}
	return noise_playback_manager_repeat_type_id__volatile;
}


void
noise_playback_manager_add_playback (NoisePlaybackManager* self,
                                     NoisePlayback* playback)
{
	GeeTreeSet* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (playback != NULL);
	_tmp0_ = self->priv->playbacks;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, playback);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void
noise_playback_manager_queue_medias (NoisePlaybackManager* self,
                                     GeeCollection* to_queue)
{
	gint _tmp0_;
	gint _tmp1_;
	NoiseStaticPlaylist* _tmp9_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_queue != NULL);
	_tmp0_ = gee_collection_get_size (to_queue);
	_tmp1_ = _tmp0_;
	if (_tmp1_ < 1) {
		return;
	}
	{
		GeeIterator* _q_it = NULL;
		GeeIterator* _tmp2_;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) to_queue);
		_q_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			NoiseMedia* q = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			NoiseMedia* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			_tmp3_ = _q_it;
			if (!gee_iterator_next (_tmp3_)) {
				break;
			}
			_tmp4_ = _q_it;
			_tmp5_ = gee_iterator_get (_tmp4_);
			q = (NoiseMedia*) _tmp5_;
			_tmp6_ = q;
			_tmp7_ = noise_media_get_title (_tmp6_);
			_tmp8_ = _tmp7_;
			g_debug ("PlaybackManager.vala:138: QUEUED: %s", _tmp8_);
			_g_object_unref0 (q);
		}
		_g_object_unref0 (_q_it);
	}
	_tmp9_ = self->priv->ordered_queue;
	noise_playlist_add_medias ((NoisePlaylist*) _tmp9_, to_queue);
	noise_playback_manager_reshuffle (self);
	{
		GeeArrayList* _q_list = NULL;
		NoiseStaticPlaylist* _tmp10_;
		NoiseStaticPlaylist* _tmp11_;
		GeeArrayList* _tmp12_;
		GeeArrayList* _tmp13_;
		GeeArrayList* _tmp14_;
		gint _q_size = 0;
		GeeArrayList* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gint _q_index = 0;
		_tmp10_ = noise_playback_manager_get_queue_playlist (self);
		_tmp11_ = _tmp10_;
		_tmp12_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = _g_object_ref0 (_tmp13_);
		_q_list = _tmp14_;
		_tmp15_ = _q_list;
		_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
		_tmp17_ = _tmp16_;
		_q_size = _tmp17_;
		_q_index = -1;
		while (TRUE) {
			gint _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			NoiseMedia* q = NULL;
			GeeArrayList* _tmp21_;
			gint _tmp22_;
			gpointer _tmp23_;
			NoiseMedia* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			_tmp18_ = _q_index;
			_q_index = _tmp18_ + 1;
			_tmp19_ = _q_index;
			_tmp20_ = _q_size;
			if (!(_tmp19_ < _tmp20_)) {
				break;
			}
			_tmp21_ = _q_list;
			_tmp22_ = _q_index;
			_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp21_, _tmp22_);
			q = (NoiseMedia*) _tmp23_;
			_tmp24_ = q;
			_tmp25_ = noise_media_get_title (_tmp24_);
			_tmp26_ = _tmp25_;
			g_debug ("PlaybackManager.vala:145: NEUE QUEUE: %s", _tmp26_);
			_g_object_unref0 (q);
		}
		_g_object_unref0 (_q_list);
	}
}


void
noise_playback_manager_unqueue_medias (NoisePlaybackManager* self,
                                       GeeCollection* to_unqueue)
{
	NoiseStaticPlaylist* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	NoiseStaticPlaylist* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_unqueue != NULL);
	_tmp0_ = self->priv->ordered_queue;
	noise_playlist_remove_medias ((NoisePlaylist*) _tmp0_, to_unqueue);
	noise_playback_manager_reshuffle (self);
	_tmp1_ = noise_playback_manager_get_queue_playlist (self);
	_tmp2_ = _tmp1_;
	g_signal_emit_by_name ((NoisePlaylist*) _tmp2_, "media-removed", to_unqueue);
}


void
noise_playback_manager_clear_queue (NoisePlaybackManager* self)
{
	NoiseStaticPlaylist* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	NoiseStaticPlaylist* _tmp2_;
	g_return_if_fail (self != NULL);
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL], 0);
	_tmp0_ = noise_playback_manager_get_queue_playlist (self);
	_tmp1_ = _tmp0_;
	noise_playlist_clear ((NoisePlaylist*) _tmp1_);
	_tmp2_ = self->priv->ordered_queue;
	noise_playlist_clear ((NoisePlaylist*) _tmp2_);
	noise_playback_manager_set_current_index (self, 0);
	noise_playback_manager_reshuffle (self);
}


NoiseMedia*
noise_playback_manager_media_from_current_index (NoisePlaybackManager* self,
                                                 gint index_in_current)
{
	NoiseMedia* result = NULL;
	NoiseStaticPlaylist* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	NoiseMedia* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_playback_manager_get_queue_playlist (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = noise_playlist_get ((NoisePlaylist*) _tmp1_, index_in_current);
	result = _tmp2_;
	return result;
}


GeeCollection*
noise_playback_manager_get_current_media_list (NoisePlaybackManager* self)
{
	GeeCollection* result = NULL;
	NoiseStaticPlaylist* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeCollection* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_playback_manager_get_queue_playlist (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _g_object_ref0 ((GeeCollection*) _tmp3_);
	result = _tmp4_;
	return result;
}


void
noise_playback_manager_set_repeat_mode (NoisePlaybackManager* self,
                                        NoiseSettingsRepeat mode)
{
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsRepeat _tmp2_;
	NoiseSettingsRepeat _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = noise_settings_main_get_default ();
	main_settings = _tmp0_;
	_tmp1_ = main_settings;
	_tmp2_ = noise_settings_main_get_repeat_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != mode) {
		NoiseSettingsMain* _tmp4_;
		_tmp4_ = main_settings;
		noise_settings_main_set_repeat_mode (_tmp4_, mode);
	}
	_g_object_unref0 (main_settings);
}


void
noise_playback_manager_set_shuffle_mode (NoisePlaybackManager* self,
                                         NoiseSettingsShuffle mode)
{
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = noise_settings_main_get_default ();
	main_settings = _tmp0_;
	_tmp1_ = main_settings;
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != mode) {
		NoiseSettingsMain* _tmp4_;
		_tmp4_ = main_settings;
		noise_settings_main_set_shuffle_mode (_tmp4_, mode);
		noise_playback_manager_reshuffle (self);
	}
	_g_object_unref0 (main_settings);
}


/**
    * Regenerate the shuffled queue if needed
    */
static void
noise_playback_manager_reshuffle (NoisePlaybackManager* self)
{
	NoiseStaticPlaylist* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	NoiseSettingsMain* _tmp2_;
	NoiseSettingsMain* _tmp3_;
	NoiseSettingsShuffle _tmp4_;
	NoiseSettingsShuffle _tmp5_;
	gboolean _tmp6_;
	g_return_if_fail (self != NULL);
	g_debug ("PlaybackManager.vala:191: Reshuffling");
	_tmp0_ = noise_playback_manager_get_queue_playlist (self);
	_tmp1_ = _tmp0_;
	noise_playlist_clear ((NoisePlaylist*) _tmp1_);
	_tmp2_ = noise_settings_main_get_default ();
	_tmp3_ = _tmp2_;
	_tmp4_ = noise_settings_main_get_shuffle_mode (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_ == NOISE_SETTINGS_SHUFFLE_ALL;
	_g_object_unref0 (_tmp3_);
	if (_tmp6_) {
		NoiseStaticPlaylist* _tmp7_;
		NoiseStaticPlaylist* _tmp8_;
		GeeArrayList* _tmp9_;
		GeeArrayList* _tmp10_;
		NoiseStaticPlaylist* _tmp11_;
		GeeArrayList* _tmp12_;
		GeeArrayList* _tmp13_;
		GeeArrayList* temp = NULL;
		GeeArrayList* _tmp14_;
		GeeArrayList* _tmp15_;
		NoiseStaticPlaylist* _tmp16_;
		GeeArrayList* _tmp17_;
		GeeArrayList* _tmp18_;
		NoiseStaticPlaylist* _tmp57_;
		NoiseStaticPlaylist* _tmp58_;
		NoiseStaticPlaylist* _tmp59_;
		NoiseStaticPlaylist* _tmp60_;
		GeeArrayList* _tmp61_;
		GeeArrayList* _tmp62_;
		g_debug ("PlaybackManager.vala:194: Shuffled");
		_tmp7_ = noise_playback_manager_get_queue_playlist (self);
		_tmp8_ = _tmp7_;
		_tmp9_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = self->priv->ordered_queue;
		_tmp12_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp11_);
		_tmp13_ = _tmp12_;
		gee_array_list_add_all (_tmp10_, (GeeCollection*) _tmp13_);
		_tmp14_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
		temp = _tmp14_;
		_tmp15_ = temp;
		_tmp16_ = self->priv->ordered_queue;
		_tmp17_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp16_);
		_tmp18_ = _tmp17_;
		gee_array_list_add_all (_tmp15_, (GeeCollection*) _tmp18_);
		{
			gint i = 0;
			i = 1;
			{
				gboolean _tmp19_ = FALSE;
				_tmp19_ = TRUE;
				while (TRUE) {
					gint _tmp21_;
					NoiseStaticPlaylist* _tmp22_;
					GeeArrayList* _tmp23_;
					GeeArrayList* _tmp24_;
					gint _tmp25_;
					gint _tmp26_;
					gint n_media = 0;
					GeeArrayList* _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
					gint _tmp30_;
					gint _tmp31_ = 0;
					gint _tmp32_;
					gint random = 0;
					gboolean _tmp34_ = FALSE;
					NoiseMedia* _tmp35_;
					GeeArrayList* _tmp52_;
					GeeArrayList* _tmp53_;
					gint _tmp54_;
					gpointer _tmp55_;
					NoiseMedia* _tmp56_;
					if (!_tmp19_) {
						gint _tmp20_;
						_tmp20_ = i;
						i = _tmp20_ + 1;
					}
					_tmp19_ = FALSE;
					_tmp21_ = i;
					_tmp22_ = self->priv->ordered_queue;
					_tmp23_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp22_);
					_tmp24_ = _tmp23_;
					_tmp25_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp24_);
					_tmp26_ = _tmp25_;
					if (!(_tmp21_ < _tmp26_)) {
						break;
					}
					_tmp27_ = temp;
					_tmp28_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp27_);
					_tmp29_ = _tmp28_;
					n_media = _tmp29_;
					_tmp30_ = n_media;
					if (_tmp30_ == 0) {
						break;
					}
					_tmp32_ = n_media;
					if (_tmp32_ <= 1) {
						_tmp31_ = 0;
					} else {
						gint _tmp33_;
						_tmp33_ = n_media;
						_tmp31_ = (gint) g_random_int_range ((gint32) 0, (gint32) (_tmp33_ - 1));
					}
					random = _tmp31_;
					_tmp35_ = self->priv->_current_media;
					if (_tmp35_ != NULL) {
						GeeArrayList* _tmp36_;
						gint _tmp37_;
						gpointer _tmp38_;
						NoiseMedia* _tmp39_;
						NoiseMedia* _tmp40_;
						_tmp36_ = temp;
						_tmp37_ = random;
						_tmp38_ = gee_abstract_list_get ((GeeAbstractList*) _tmp36_, _tmp37_);
						_tmp39_ = (NoiseMedia*) _tmp38_;
						_tmp40_ = self->priv->_current_media;
						_tmp34_ = _tmp39_ == _tmp40_;
						_g_object_unref0 (_tmp39_);
					} else {
						_tmp34_ = FALSE;
					}
					if (_tmp34_) {
						NoiseStaticPlaylist* _tmp41_;
						NoiseStaticPlaylist* _tmp42_;
						NoiseMedia* _tmp43_;
						gint _tmp44_;
						_tmp41_ = noise_playback_manager_get_queue_playlist (self);
						_tmp42_ = _tmp41_;
						_tmp43_ = self->priv->_current_media;
						noise_playlist_set ((NoisePlaylist*) _tmp42_, 0, _tmp43_);
						_tmp44_ = i;
						i = _tmp44_ - 1;
					} else {
						NoiseStaticPlaylist* _tmp45_;
						NoiseStaticPlaylist* _tmp46_;
						gint _tmp47_;
						GeeArrayList* _tmp48_;
						gint _tmp49_;
						gpointer _tmp50_;
						NoiseMedia* _tmp51_;
						_tmp45_ = noise_playback_manager_get_queue_playlist (self);
						_tmp46_ = _tmp45_;
						_tmp47_ = i;
						_tmp48_ = temp;
						_tmp49_ = random;
						_tmp50_ = gee_abstract_list_get ((GeeAbstractList*) _tmp48_, _tmp49_);
						_tmp51_ = (NoiseMedia*) _tmp50_;
						noise_playlist_set ((NoisePlaylist*) _tmp46_, _tmp47_, _tmp51_);
						_g_object_unref0 (_tmp51_);
					}
					_tmp52_ = temp;
					_tmp53_ = temp;
					_tmp54_ = random;
					_tmp55_ = gee_abstract_list_get ((GeeAbstractList*) _tmp53_, _tmp54_);
					_tmp56_ = (NoiseMedia*) _tmp55_;
					gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp52_, _tmp56_);
					_g_object_unref0 (_tmp56_);
				}
			}
		}
		_tmp57_ = noise_playback_manager_get_queue_playlist (self);
		_tmp58_ = _tmp57_;
		_tmp59_ = noise_playback_manager_get_queue_playlist (self);
		_tmp60_ = _tmp59_;
		_tmp61_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp60_);
		_tmp62_ = _tmp61_;
		g_signal_emit_by_name ((NoisePlaylist*) _tmp58_, "media-added", (GeeCollection*) _tmp62_);
		_g_object_unref0 (temp);
	} else {
		NoiseMedia* _tmp63_;
		NoiseStaticPlaylist* _tmp68_;
		NoiseStaticPlaylist* _tmp69_;
		NoiseStaticPlaylist* _tmp70_;
		GeeArrayList* _tmp71_;
		GeeArrayList* _tmp72_;
		g_debug ("PlaybackManager.vala:222: Not shuffled");
		_tmp63_ = self->priv->_current_media;
		if (_tmp63_ != NULL) {
			NoiseStaticPlaylist* _tmp64_;
			GeeArrayList* _tmp65_;
			GeeArrayList* _tmp66_;
			NoiseMedia* _tmp67_;
			_tmp64_ = self->priv->ordered_queue;
			_tmp65_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp64_);
			_tmp66_ = _tmp65_;
			_tmp67_ = self->priv->_current_media;
			noise_playback_manager_set_current_index (self, gee_abstract_list_index_of ((GeeAbstractList*) _tmp66_, _tmp67_));
		} else {
			noise_playback_manager_set_current_index (self, 0);
		}
		_tmp68_ = noise_playback_manager_get_queue_playlist (self);
		_tmp69_ = _tmp68_;
		_tmp70_ = self->priv->ordered_queue;
		_tmp71_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp70_);
		_tmp72_ = _tmp71_;
		noise_playlist_add_medias ((NoisePlaylist*) _tmp69_, (GeeCollection*) _tmp72_);
	}
}


/**
    * Gets the media of the queue at a certain position, relatively to the current one.
    *
    * For instance, calling this method with position = -1 will return the media just before the current one.
    */
static NoiseMedia*
noise_playback_manager_get_media_at (NoisePlaybackManager* self,
                                     gint position,
                                     gint* media_index)
{
	gint _vala_media_index = 0;
	NoiseMedia* result = NULL;
	gint index = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	NoiseMedia* _tmp3_ = NULL;
	NoiseStaticPlaylist* _tmp4_;
	NoiseStaticPlaylist* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeArrayList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	NoiseMedia* res = NULL;
	NoiseMedia* _tmp16_;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp17_;
	NoiseSettingsMain* _tmp18_;
	NoiseSettingsRepeat _tmp19_;
	NoiseSettingsRepeat _tmp20_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_playback_manager_get_current_index (self);
	_tmp1_ = _tmp0_;
	index = _tmp1_ + position;
	_tmp2_ = index;
	_vala_media_index = noise_playback_manager_fix_index (self, _tmp2_);
	_tmp4_ = noise_playback_manager_get_queue_playlist (self);
	_tmp5_ = _tmp4_;
	_tmp6_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = index;
	_tmp11_ = _tmp10_;
	if ((_tmp9_ > _tmp11_) && (_tmp11_ > 0)) {
		NoiseStaticPlaylist* _tmp12_;
		NoiseStaticPlaylist* _tmp13_;
		gint _tmp14_;
		NoiseMedia* _tmp15_;
		_tmp12_ = noise_playback_manager_get_queue_playlist (self);
		_tmp13_ = _tmp12_;
		_tmp14_ = index;
		_tmp15_ = noise_playlist_get ((NoisePlaylist*) _tmp13_, _tmp14_);
		_g_object_unref0 (_tmp3_);
		_tmp3_ = _tmp15_;
	} else {
		_g_object_unref0 (_tmp3_);
		_tmp3_ = NULL;
	}
	_tmp16_ = _g_object_ref0 (_tmp3_);
	res = _tmp16_;
	_tmp17_ = noise_settings_main_get_default ();
	main_settings = _tmp17_;
	_tmp18_ = main_settings;
	_tmp19_ = noise_settings_main_get_repeat_mode (_tmp18_);
	_tmp20_ = _tmp19_;
	switch (_tmp20_) {
		case NOISE_SETTINGS_REPEAT_MEDIA:
		{
			NoiseMedia* _tmp21_;
			NoiseMedia* _tmp22_;
			_tmp21_ = self->priv->_current_media;
			_tmp22_ = _g_object_ref0 (_tmp21_);
			result = _tmp22_;
			_g_object_unref0 (main_settings);
			_g_object_unref0 (res);
			_g_object_unref0 (_tmp3_);
			if (media_index) {
				*media_index = _vala_media_index;
			}
			return result;
		}
		case NOISE_SETTINGS_REPEAT_ALL:
		{
			NoiseMedia* _tmp23_ = NULL;
			NoiseMedia* _tmp24_;
			_tmp24_ = res;
			if (_tmp24_ == NULL) {
				NoiseStaticPlaylist* _tmp25_;
				NoiseStaticPlaylist* _tmp26_;
				gint _tmp27_;
				NoiseMedia* _tmp28_;
				_tmp25_ = noise_playback_manager_get_queue_playlist (self);
				_tmp26_ = _tmp25_;
				_tmp27_ = index;
				_tmp28_ = noise_playlist_get ((NoisePlaylist*) _tmp26_, noise_playback_manager_fix_index (self, _tmp27_));
				_g_object_unref0 (_tmp23_);
				_tmp23_ = _tmp28_;
			} else {
				NoiseMedia* _tmp29_;
				NoiseMedia* _tmp30_;
				_tmp29_ = res;
				_tmp30_ = _g_object_ref0 (_tmp29_);
				_g_object_unref0 (_tmp23_);
				_tmp23_ = _tmp30_;
			}
			result = _tmp23_;
			_g_object_unref0 (main_settings);
			_g_object_unref0 (res);
			_g_object_unref0 (_tmp3_);
			if (media_index) {
				*media_index = _vala_media_index;
			}
			return result;
		}
		case NOISE_SETTINGS_REPEAT_OFF:
		{
			NoiseMedia* _tmp31_;
			_tmp31_ = res;
			if (_tmp31_ == NULL) {
				NoiseStaticPlaylist* _tmp32_;
				NoiseStaticPlaylist* _tmp33_;
				NoiseStaticPlaylist* _tmp34_;
				noise_playback_manager_set_current_media (self, NULL);
				_tmp32_ = self->priv->ordered_queue;
				noise_playlist_clear ((NoisePlaylist*) _tmp32_);
				_tmp33_ = noise_playback_manager_get_queue_playlist (self);
				_tmp34_ = _tmp33_;
				noise_playlist_clear ((NoisePlaylist*) _tmp34_);
			}
			result = res;
			_g_object_unref0 (main_settings);
			_g_object_unref0 (_tmp3_);
			if (media_index) {
				*media_index = _vala_media_index;
			}
			return result;
		}
		case NOISE_SETTINGS_REPEAT_ALBUM:
		{
			{
				gint i = 0;
				gint _tmp35_;
				gint _tmp36_;
				_tmp35_ = noise_playback_manager_get_current_index (self);
				_tmp36_ = _tmp35_;
				i = _tmp36_ + 1;
				{
					gboolean _tmp37_ = FALSE;
					_tmp37_ = TRUE;
					while (TRUE) {
						gint _tmp39_;
						gint _tmp40_;
						gint _tmp41_;
						gint _tmp42_;
						NoiseStaticPlaylist* _tmp43_;
						NoiseStaticPlaylist* _tmp44_;
						gint _tmp45_;
						NoiseMedia* _tmp46_;
						NoiseMedia* _tmp47_;
						const gchar* _tmp48_;
						const gchar* _tmp49_;
						NoiseMedia* _tmp50_;
						const gchar* _tmp51_;
						const gchar* _tmp52_;
						gboolean _tmp53_;
						if (!_tmp37_) {
							gint _tmp38_;
							_tmp38_ = i;
							i = _tmp38_ + position;
						}
						_tmp37_ = FALSE;
						_tmp39_ = i;
						_tmp40_ = noise_playback_manager_get_current_index (self);
						_tmp41_ = _tmp40_;
						if (!(_tmp39_ != _tmp41_)) {
							break;
						}
						_tmp42_ = i;
						i = noise_playback_manager_fix_index (self, _tmp42_);
						_tmp43_ = noise_playback_manager_get_queue_playlist (self);
						_tmp44_ = _tmp43_;
						_tmp45_ = i;
						_tmp46_ = noise_playlist_get ((NoisePlaylist*) _tmp44_, _tmp45_);
						_tmp47_ = _tmp46_;
						_tmp48_ = noise_media_get_album (_tmp47_);
						_tmp49_ = _tmp48_;
						_tmp50_ = self->priv->_current_media;
						_tmp51_ = noise_media_get_album (_tmp50_);
						_tmp52_ = _tmp51_;
						_tmp53_ = g_strcmp0 (_tmp49_, _tmp52_) == 0;
						_g_object_unref0 (_tmp47_);
						if (_tmp53_) {
							NoiseStaticPlaylist* _tmp54_;
							NoiseStaticPlaylist* _tmp55_;
							gint _tmp56_;
							NoiseMedia* _tmp57_;
							_tmp54_ = noise_playback_manager_get_queue_playlist (self);
							_tmp55_ = _tmp54_;
							_tmp56_ = i;
							_tmp57_ = noise_playlist_get ((NoisePlaylist*) _tmp55_, _tmp56_);
							result = _tmp57_;
							_g_object_unref0 (main_settings);
							_g_object_unref0 (res);
							_g_object_unref0 (_tmp3_);
							if (media_index) {
								*media_index = _vala_media_index;
							}
							return result;
						}
					}
				}
			}
			break;
		}
		case NOISE_SETTINGS_REPEAT_ARTIST:
		{
			{
				gint i = 0;
				gint _tmp58_;
				gint _tmp59_;
				_tmp58_ = noise_playback_manager_get_current_index (self);
				_tmp59_ = _tmp58_;
				i = _tmp59_ + 1;
				{
					gboolean _tmp60_ = FALSE;
					_tmp60_ = TRUE;
					while (TRUE) {
						gint _tmp62_;
						gint _tmp63_;
						gint _tmp64_;
						gint _tmp65_;
						NoiseStaticPlaylist* _tmp66_;
						NoiseStaticPlaylist* _tmp67_;
						gint _tmp68_;
						NoiseMedia* _tmp69_;
						NoiseMedia* _tmp70_;
						const gchar* _tmp71_;
						const gchar* _tmp72_;
						NoiseMedia* _tmp73_;
						const gchar* _tmp74_;
						const gchar* _tmp75_;
						gboolean _tmp76_;
						if (!_tmp60_) {
							gint _tmp61_;
							_tmp61_ = i;
							i = _tmp61_ + position;
						}
						_tmp60_ = FALSE;
						_tmp62_ = i;
						_tmp63_ = noise_playback_manager_get_current_index (self);
						_tmp64_ = _tmp63_;
						if (!(_tmp62_ != _tmp64_)) {
							break;
						}
						_tmp65_ = i;
						i = noise_playback_manager_fix_index (self, _tmp65_);
						_tmp66_ = noise_playback_manager_get_queue_playlist (self);
						_tmp67_ = _tmp66_;
						_tmp68_ = i;
						_tmp69_ = noise_playlist_get ((NoisePlaylist*) _tmp67_, _tmp68_);
						_tmp70_ = _tmp69_;
						_tmp71_ = noise_media_get_artist (_tmp70_);
						_tmp72_ = _tmp71_;
						_tmp73_ = self->priv->_current_media;
						_tmp74_ = noise_media_get_artist (_tmp73_);
						_tmp75_ = _tmp74_;
						_tmp76_ = g_strcmp0 (_tmp72_, _tmp75_) == 0;
						_g_object_unref0 (_tmp70_);
						if (_tmp76_) {
							NoiseStaticPlaylist* _tmp77_;
							NoiseStaticPlaylist* _tmp78_;
							gint _tmp79_;
							NoiseMedia* _tmp80_;
							_tmp77_ = noise_playback_manager_get_queue_playlist (self);
							_tmp78_ = _tmp77_;
							_tmp79_ = i;
							_tmp80_ = noise_playlist_get ((NoisePlaylist*) _tmp78_, _tmp79_);
							result = _tmp80_;
							_g_object_unref0 (main_settings);
							_g_object_unref0 (res);
							_g_object_unref0 (_tmp3_);
							if (media_index) {
								*media_index = _vala_media_index;
							}
							return result;
						}
					}
				}
			}
			break;
		}
		default:
		break;
	}
	result = res;
	_g_object_unref0 (main_settings);
	_g_object_unref0 (_tmp3_);
	if (media_index) {
		*media_index = _vala_media_index;
	}
	return result;
}


/**
    * Make sure index of media is never out of the queue.
    */
static gint
noise_playback_manager_fix_index (NoisePlaybackManager* self,
                                  gint index)
{
	gint result = 0;
	NoiseStaticPlaylist* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	NoiseStaticPlaylist* _tmp6_;
	NoiseStaticPlaylist* _tmp7_;
	GeeArrayList* _tmp8_;
	GeeArrayList* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = noise_playback_manager_get_queue_playlist (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = noise_playback_manager_get_queue_playlist (self);
	_tmp7_ = _tmp6_;
	_tmp8_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
	_tmp11_ = _tmp10_;
	result = (_tmp5_ + index) % _tmp11_;
	return result;
}


NoiseMedia*
noise_playback_manager_get_next (NoisePlaybackManager* self,
                                 gboolean play)
{
	NoiseMedia* result = NULL;
	gint index = 0;
	NoiseMedia* next = NULL;
	gint _tmp0_ = 0;
	NoiseMedia* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = noise_playback_manager_get_media_at (self, 1, &_tmp0_);
	index = _tmp0_;
	next = _tmp1_;
	if (play) {
		NoiseMedia* _tmp2_;
		_tmp2_ = next;
		if (_tmp2_ == NULL) {
			noise_playback_manager_stop_playback (self);
		} else {
			gint _tmp3_;
			NoiseMedia* _tmp4_;
			_tmp3_ = index;
			noise_playback_manager_set_current_index (self, _tmp3_);
			_tmp4_ = next;
			noise_playback_manager_play_media (self, _tmp4_);
		}
	}
	result = next;
	return result;
}


NoiseMedia*
noise_playback_manager_get_previous (NoisePlaybackManager* self,
                                     gboolean play)
{
	NoiseMedia* result = NULL;
	gint index = 0;
	NoiseMedia* prev = NULL;
	gint _tmp0_ = 0;
	NoiseMedia* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = noise_playback_manager_get_media_at (self, -1, &_tmp0_);
	index = _tmp0_;
	prev = _tmp1_;
	if (play) {
		NoiseMedia* _tmp2_;
		_tmp2_ = prev;
		if (_tmp2_ == NULL) {
			noise_playback_manager_stop_playback (self);
		} else {
			gint _tmp3_;
			NoiseMedia* _tmp4_;
			_tmp3_ = index;
			noise_playback_manager_set_current_index (self, _tmp3_);
			_tmp4_ = prev;
			noise_playback_manager_play_media (self, _tmp4_);
		}
	}
	result = prev;
	return result;
}


static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}


static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		NoisePlaybackManager* self;
		self = _data10_->self;
		_g_object_unref0 (_data10_->m);
		_g_object_unref0 (self);
		g_slice_free (Block10Data, _data10_);
	}
}


static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}


static gboolean
__lambda33_ (Block10Data* _data10_)
{
	NoisePlaybackManager* self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	self = _data10_->self;
	if (_data10_->m != NULL) {
		NoiseMedia* _tmp1_;
		_tmp1_ = self->priv->_current_media;
		_tmp0_ = _tmp1_ == _data10_->m;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		NoiseHistoryPlaylist* _tmp2_;
		guint player_duration_s = 0U;
		NoisePlayback* _tmp3_;
		guint _tmp4_;
		_tmp2_ = self->history_playlist;
		noise_playlist_add_media ((NoisePlaylist*) _tmp2_, _data10_->m);
		_tmp3_ = self->player;
		player_duration_s = (guint) (noise_playback_get_duration (_tmp3_) / NOISE_TIME_UTILS_NANO_INV);
		_tmp4_ = player_duration_s;
		if (_tmp4_ > ((guint) 1)) {
			gint delta_s = 0;
			guint _tmp5_;
			guint _tmp6_;
			guint _tmp7_;
			gint _tmp8_;
			_tmp5_ = player_duration_s;
			_tmp6_ = noise_media_get_length (_data10_->m);
			_tmp7_ = _tmp6_;
			delta_s = ((gint) _tmp5_) - ((gint) (_tmp7_ / NOISE_TIME_UTILS_MILI_INV));
			_tmp8_ = delta_s;
			if (fabs ((gdouble) _tmp8_) > ((gdouble) 3)) {
				guint _tmp9_;
				NoiseLibrary* _tmp10_;
				NoiseLibrary* _tmp11_;
				_tmp9_ = player_duration_s;
				noise_media_set_length (_data10_->m, (guint) (_tmp9_ * NOISE_TIME_UTILS_MILI_INV));
				_tmp10_ = noise_playback_manager_get_library (self);
				_tmp11_ = _tmp10_;
				noise_library_update_media (_tmp11_, _data10_->m, FALSE, FALSE);
			}
		}
	}
	result = FALSE;
	return result;
}


static gboolean
___lambda33__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda33_ (self);
	return result;
}


void
noise_playback_manager_play_media (NoisePlaybackManager* self,
                                   NoiseMedia* m)
{
	Block10Data* _data10_;
	NoiseMedia* _tmp0_;
	GFile* media_file = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gboolean found = FALSE;
	gboolean _tmp52_;
	GFile* _tmp57_;
	GFile* _tmp58_;
	NoisePlayback* _tmp68_;
	gboolean _tmp69_;
	gboolean _tmp71_ = FALSE;
	gint64 _tmp72_;
	gint64 _tmp73_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	_data10_ = g_slice_new0 (Block10Data);
	_data10_->_ref_count_ = 1;
	_data10_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (m);
	_g_object_unref0 (_data10_->m);
	_data10_->m = _tmp0_;
	noise_playback_manager_set_current_media (self, _data10_->m);
	_tmp1_ = noise_media_get_uri (_data10_->m);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp4_ = g_file_new_for_uri (_tmp3_);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	media_file = _tmp5_;
	_tmp6_ = noise_media_get_location_unknown (_data10_->m);
	_tmp7_ = _tmp6_;
	if (_tmp7_) {
		GFile* _tmp8_;
		_tmp8_ = media_file;
		if (g_file_query_exists (_tmp8_, NULL)) {
			noise_media_set_location_unknown (_data10_->m, FALSE);
			noise_media_set_unique_status_image (_data10_->m, NULL);
		} else {
			noise_playback_manager_stop_playback (self);
			_g_object_unref0 (media_file);
			block10_data_unref (_data10_);
			_data10_ = NULL;
			return;
		}
	}
	{
		GFileInfo* info = NULL;
		GFile* _tmp9_;
		GFileInfo* _tmp10_;
		GFileInfo* _tmp11_;
		const gchar* _tmp12_;
		_tmp9_ = media_file;
		_tmp10_ = g_file_query_info (_tmp9_, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
		info = _tmp10_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch19_g_error;
		}
		_tmp11_ = info;
		_tmp12_ = g_file_info_get_content_type (_tmp11_);
		if (!noise_file_utils_is_valid_content_type (_tmp12_, NULL, 0)) {
			NoiseMedia* _tmp13_;
			NoiseMedia** _tmp14_;
			GeeArrayList* _tmp15_;
			GeeArrayList* _tmp16_;
			GAppInfo* app = NULL;
			GFileInfo* _tmp17_;
			const gchar* _tmp18_;
			GAppInfo* _tmp19_;
			GList* files = NULL;
			GFile* _tmp20_;
			GFile* _tmp21_;
			GAppInfo* _tmp22_;
			GList* _tmp23_;
			g_debug ("PlaybackManager.vala:347: Launching default app");
			_tmp13_ = _g_object_ref0 (_data10_->m);
			_tmp14_ = g_new0 (NoiseMedia*, 1 + 1);
			_tmp14_[0] = _tmp13_;
			_tmp15_ = gee_array_list_new_wrap (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp14_, 1, NULL, NULL, NULL);
			_tmp16_ = _tmp15_;
			noise_playback_manager_unqueue_medias (self, (GeeCollection*) _tmp16_);
			_g_object_unref0 (_tmp16_);
			_tmp17_ = info;
			_tmp18_ = g_file_info_get_content_type (_tmp17_);
			_tmp19_ = g_app_info_get_default_for_type (_tmp18_, TRUE);
			app = _tmp19_;
			files = NULL;
			_tmp20_ = media_file;
			_tmp21_ = _g_object_ref0 (_tmp20_);
			files = g_list_append (files, _tmp21_);
			_tmp22_ = app;
			_tmp23_ = files;
			g_app_info_launch (_tmp22_, _tmp23_, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
				_g_object_unref0 (app);
				_g_object_unref0 (info);
				goto __catch19_g_error;
			}
			(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
			_g_object_unref0 (app);
			_g_object_unref0 (info);
			_g_object_unref0 (media_file);
			block10_data_unref (_data10_);
			_data10_ = NULL;
			return;
		}
		_g_object_unref0 (info);
	}
	goto __finally19;
	__catch19_g_error:
	{
		GError* err = NULL;
		GError* _tmp24_;
		const gchar* _tmp25_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp24_ = err;
		_tmp25_ = _tmp24_->message;
		g_warning ("PlaybackManager.vala:358: Can't open unsupported file with another app" \
"lication: %s\n", _tmp25_);
		_g_error_free0 (err);
	}
	__finally19:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (media_file);
		block10_data_unref (_data10_);
		_data10_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	found = FALSE;
	{
		GeeTreeSet* _tmp26_;
		_tmp26_ = self->priv->playbacks;
		g_rec_mutex_lock (&self->priv->__lock_playbacks);
		{
			{
				GeeIterator* _playback_it = NULL;
				GeeTreeSet* _tmp27_;
				GeeIterator* _tmp28_;
				_tmp27_ = self->priv->playbacks;
				_tmp28_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp27_);
				_playback_it = _tmp28_;
				while (TRUE) {
					GeeIterator* _tmp29_;
					NoisePlayback* playback = NULL;
					GeeIterator* _tmp30_;
					gpointer _tmp31_;
					gboolean _tmp50_;
					_tmp29_ = _playback_it;
					if (!gee_iterator_next (_tmp29_)) {
						break;
					}
					_tmp30_ = _playback_it;
					_tmp31_ = gee_iterator_get (_tmp30_);
					playback = (NoisePlayback*) _tmp31_;
					{
						GeeIterator* _supported_uri_it = NULL;
						NoisePlayback* _tmp32_;
						GeeCollection* _tmp33_;
						GeeCollection* _tmp34_;
						GeeIterator* _tmp35_;
						GeeIterator* _tmp36_;
						_tmp32_ = playback;
						_tmp33_ = noise_playback_get_supported_uri (_tmp32_);
						_tmp34_ = _tmp33_;
						_tmp35_ = gee_iterable_iterator ((GeeIterable*) _tmp34_);
						_tmp36_ = _tmp35_;
						_g_object_unref0 (_tmp34_);
						_supported_uri_it = _tmp36_;
						while (TRUE) {
							GeeIterator* _tmp37_;
							gchar* supported_uri = NULL;
							GeeIterator* _tmp38_;
							gpointer _tmp39_;
							gchar* _tmp40_;
							gchar* _tmp41_;
							gchar* _tmp42_;
							const gchar* _tmp43_;
							gboolean _tmp44_;
							_tmp37_ = _supported_uri_it;
							if (!gee_iterator_next (_tmp37_)) {
								break;
							}
							_tmp38_ = _supported_uri_it;
							_tmp39_ = gee_iterator_get (_tmp38_);
							supported_uri = (gchar*) _tmp39_;
							_tmp40_ = noise_media_get_uri (_data10_->m);
							_tmp41_ = _tmp40_;
							_tmp42_ = _tmp41_;
							_tmp43_ = supported_uri;
							_tmp44_ = g_str_has_prefix (_tmp42_, _tmp43_);
							_g_free0 (_tmp42_);
							if (_tmp44_) {
								NoisePlayback* _tmp45_;
								NoisePlayback* _tmp46_;
								NoisePlayback* _tmp47_;
								NoisePlayback* _tmp48_;
								gdouble _tmp49_;
								_tmp45_ = self->player;
								self->priv->saved_volume = noise_playback_get_volume (_tmp45_);
								g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL], 0);
								_tmp46_ = self->player;
								noise_playback_set_state (_tmp46_, GST_STATE_NULL);
								found = TRUE;
								_tmp47_ = playback;
								_tmp48_ = _g_object_ref0 (_tmp47_);
								_g_object_unref0 (self->player);
								self->player = _tmp48_;
								_tmp49_ = self->priv->saved_volume;
								noise_playback_manager_set_volume (self, _tmp49_);
								g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL], 0);
								_g_free0 (supported_uri);
								break;
							}
							_g_free0 (supported_uri);
						}
						_g_object_unref0 (_supported_uri_it);
					}
					_tmp50_ = found;
					if (_tmp50_ == TRUE) {
						break;
					}
				}
				_g_object_unref0 (_playback_it);
			}
		}
		__finally20:
		{
			GeeTreeSet* _tmp51_;
			_tmp51_ = self->priv->playbacks;
			g_rec_mutex_unlock (&self->priv->__lock_playbacks);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (media_file);
			block10_data_unref (_data10_);
			_data10_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp52_ = found;
	if (!_tmp52_) {
		GThemedIcon* _tmp53_;
		GThemedIcon* _tmp54_;
		NoiseMedia* _tmp55_;
		NoiseMedia* _tmp56_;
		_tmp53_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
		_tmp54_ = _tmp53_;
		noise_media_set_unique_status_image (_data10_->m, (GIcon*) _tmp54_);
		_g_object_unref0 (_tmp54_);
		_tmp55_ = noise_playback_manager_get_next (self, TRUE);
		_tmp56_ = _tmp55_;
		_g_object_unref0 (_tmp56_);
		_g_object_unref0 (media_file);
		block10_data_unref (_data10_);
		_data10_ = NULL;
		return;
	}
	_tmp57_ = noise_media_get_file (_data10_->m);
	_tmp58_ = _tmp57_;
	if (!g_file_query_exists (_tmp58_, NULL)) {
		GThemedIcon* _tmp59_;
		GThemedIcon* _tmp60_;
		NoiseMedia* _tmp61_;
		NoiseMedia* _tmp62_;
		_tmp59_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
		_tmp60_ = _tmp59_;
		noise_media_set_unique_status_image (_data10_->m, (GIcon*) _tmp60_);
		_g_object_unref0 (_tmp60_);
		noise_media_set_location_unknown (_data10_->m, TRUE);
		_tmp61_ = noise_playback_manager_get_next (self, TRUE);
		_tmp62_ = _tmp61_;
		_g_object_unref0 (_tmp62_);
		_g_object_unref0 (media_file);
		block10_data_unref (_data10_);
		_data10_ = NULL;
		return;
	} else {
		gboolean _tmp63_ = FALSE;
		gboolean _tmp64_;
		gboolean _tmp65_;
		_tmp64_ = noise_media_get_location_unknown (_data10_->m);
		_tmp65_ = _tmp64_;
		if (_tmp65_) {
			GIcon* _tmp66_;
			GIcon* _tmp67_;
			_tmp66_ = noise_media_get_unique_status_image (_data10_->m);
			_tmp67_ = _tmp66_;
			_tmp63_ = _tmp67_ != NULL;
		} else {
			_tmp63_ = FALSE;
		}
		if (_tmp63_) {
			noise_media_set_unique_status_image (_data10_->m, NULL);
			noise_media_set_location_unknown (_data10_->m, FALSE);
		}
	}
	noise_playback_manager_change_gains_thread (self);
	_tmp68_ = self->player;
	noise_playback_set_media (_tmp68_, _data10_->m);
	_tmp69_ = self->priv->_playing;
	if (!_tmp69_) {
		NoisePlayback* _tmp70_;
		_tmp70_ = self->player;
		noise_playback_pause (_tmp70_);
	}
	_tmp72_ = noise_media_get_rowid (_data10_->m);
	_tmp73_ = _tmp72_;
	if (_tmp73_ >= ((gint64) 0)) {
		NoiseSettingsMain* _tmp74_;
		NoiseSettingsMain* _tmp75_;
		_tmp74_ = noise_settings_main_get_default ();
		_tmp75_ = _tmp74_;
		_tmp71_ = !noise_settings_main_privacy_mode_enabled (_tmp75_);
		_g_object_unref0 (_tmp75_);
	} else {
		_tmp71_ = FALSE;
	}
	if (_tmp71_) {
		GSettings* _tmp76_;
		GSettings* _tmp77_;
		gint64 _tmp78_;
		gint64 _tmp79_;
		_tmp76_ = noise_app_get_settings ();
		_tmp77_ = _tmp76_;
		_tmp78_ = noise_media_get_rowid (_data10_->m);
		_tmp79_ = _tmp78_;
		g_settings_set_int64 (_tmp77_, "last-media-playing", _tmp79_);
	}
	if (_data10_->m != NULL) {
		g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL], 0, _data10_->m);
	}
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ___lambda33__gsource_func, block10_data_ref (_data10_), block10_data_unref);
	_g_object_unref0 (media_file);
	block10_data_unref (_data10_);
	_data10_ = NULL;
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}


void
noise_playback_manager_change_gains_thread (NoisePlaybackManager* self)
{
	NoiseSettingsEqualizer* equalizer_settings = NULL;
	NoiseSettingsEqualizer* _tmp0_;
	NoiseSettingsEqualizer* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = noise_settings_equalizer_get_default ();
	equalizer_settings = _tmp0_;
	_tmp1_ = equalizer_settings;
	_tmp2_ = noise_settings_equalizer_get_equalizer_enabled (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		gboolean automatic_enabled = FALSE;
		NoiseSettingsEqualizer* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		gchar* selected_preset = NULL;
		NoiseSettingsEqualizer* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp4_ = equalizer_settings;
		_tmp5_ = noise_settings_equalizer_get_auto_switch_preset (_tmp4_);
		_tmp6_ = _tmp5_;
		automatic_enabled = _tmp6_;
		_tmp7_ = equalizer_settings;
		_tmp8_ = noise_settings_equalizer_get_selected_preset (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_strdup (_tmp9_);
		selected_preset = _tmp10_;
		{
			GeeIterator* _p_it = NULL;
			NoiseSettingsEqualizer* _tmp11_;
			GeeCollection* _tmp12_;
			GeeCollection* _tmp13_;
			GeeIterator* _tmp14_;
			GeeIterator* _tmp15_;
			_tmp11_ = equalizer_settings;
			_tmp12_ = noise_settings_equalizer_get_presets (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp14_ = gee_iterable_iterator ((GeeIterable*) _tmp13_);
			_tmp15_ = _tmp14_;
			_g_object_unref0 (_tmp13_);
			_p_it = _tmp15_;
			while (TRUE) {
				GeeIterator* _tmp16_;
				NoiseEqualizerPreset* p = NULL;
				GeeIterator* _tmp17_;
				gpointer _tmp18_;
				gboolean _tmp19_ = FALSE;
				NoiseEqualizerPreset* _tmp20_;
				_tmp16_ = _p_it;
				if (!gee_iterator_next (_tmp16_)) {
					break;
				}
				_tmp17_ = _p_it;
				_tmp18_ = gee_iterator_get (_tmp17_);
				p = (NoiseEqualizerPreset*) _tmp18_;
				_tmp20_ = p;
				if (_tmp20_ != NULL) {
					NoiseMedia* _tmp21_;
					_tmp21_ = self->priv->_current_media;
					_tmp19_ = _tmp21_ != NULL;
				} else {
					_tmp19_ = FALSE;
				}
				if (_tmp19_) {
					gchar* preset_name = NULL;
					NoiseEqualizerPreset* _tmp22_;
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* media_genre = NULL;
					NoiseMedia* _tmp26_;
					const gchar* _tmp27_;
					const gchar* _tmp28_;
					gchar* _tmp29_;
					gboolean _tmp30_ = FALSE;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
					gboolean match_genre = FALSE;
					gboolean _tmp35_ = FALSE;
					gboolean _tmp36_ = FALSE;
					gboolean _tmp37_;
					_tmp22_ = p;
					_tmp23_ = noise_equalizer_preset_get_name (_tmp22_);
					_tmp24_ = _tmp23_;
					_tmp25_ = g_utf8_strdown (_tmp24_, (gssize) -1);
					preset_name = _tmp25_;
					_tmp26_ = self->priv->_current_media;
					_tmp27_ = noise_media_get_genre (_tmp26_);
					_tmp28_ = _tmp27_;
					_tmp29_ = g_utf8_strdown (_tmp28_, (gssize) -1);
					media_genre = _tmp29_;
					_tmp31_ = media_genre;
					_tmp32_ = preset_name;
					if (string_contains (_tmp31_, _tmp32_)) {
						_tmp30_ = TRUE;
					} else {
						const gchar* _tmp33_;
						const gchar* _tmp34_;
						_tmp33_ = preset_name;
						_tmp34_ = media_genre;
						_tmp30_ = string_contains (_tmp33_, _tmp34_);
					}
					match_genre = _tmp30_;
					_tmp37_ = automatic_enabled;
					if (_tmp37_) {
						gboolean _tmp38_;
						_tmp38_ = match_genre;
						_tmp36_ = _tmp38_;
					} else {
						_tmp36_ = FALSE;
					}
					if (_tmp36_) {
						_tmp35_ = TRUE;
					} else {
						gboolean _tmp39_ = FALSE;
						gboolean _tmp40_;
						_tmp40_ = automatic_enabled;
						if (!_tmp40_) {
							NoiseEqualizerPreset* _tmp41_;
							const gchar* _tmp42_;
							const gchar* _tmp43_;
							const gchar* _tmp44_;
							_tmp41_ = p;
							_tmp42_ = noise_equalizer_preset_get_name (_tmp41_);
							_tmp43_ = _tmp42_;
							_tmp44_ = selected_preset;
							_tmp39_ = g_strcmp0 (_tmp43_, _tmp44_) == 0;
						} else {
							_tmp39_ = FALSE;
						}
						_tmp35_ = _tmp39_;
					}
					if (_tmp35_) {
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp45_ = FALSE;
								_tmp45_ = TRUE;
								while (TRUE) {
									gint _tmp47_;
									NoisePlayback* _tmp48_;
									gint _tmp49_;
									NoiseEqualizerPreset* _tmp50_;
									gint _tmp51_;
									if (!_tmp45_) {
										gint _tmp46_;
										_tmp46_ = i;
										i = _tmp46_ + 1;
									}
									_tmp45_ = FALSE;
									_tmp47_ = i;
									if (!(_tmp47_ < 10)) {
										break;
									}
									_tmp48_ = self->player;
									_tmp49_ = i;
									_tmp50_ = p;
									_tmp51_ = i;
									noise_playback_set_equalizer_gain (_tmp48_, _tmp49_, noise_equalizer_preset_get_gain (_tmp50_, _tmp51_));
								}
							}
						}
						_g_free0 (media_genre);
						_g_free0 (preset_name);
						_g_object_unref0 (p);
						_g_object_unref0 (_p_it);
						_g_free0 (selected_preset);
						_g_object_unref0 (equalizer_settings);
						return;
					}
					_g_free0 (media_genre);
					_g_free0 (preset_name);
				}
				_g_object_unref0 (p);
			}
			_g_object_unref0 (_p_it);
		}
		{
			GeeIterator* _p_it = NULL;
			GeeCollection* _tmp52_;
			GeeCollection* _tmp53_;
			GeeIterator* _tmp54_;
			GeeIterator* _tmp55_;
			_tmp52_ = noise_equalizer_get_default_presets ();
			_tmp53_ = _tmp52_;
			_tmp54_ = gee_iterable_iterator ((GeeIterable*) _tmp53_);
			_tmp55_ = _tmp54_;
			_g_object_unref0 (_tmp53_);
			_p_it = _tmp55_;
			while (TRUE) {
				GeeIterator* _tmp56_;
				NoiseEqualizerPreset* p = NULL;
				GeeIterator* _tmp57_;
				gpointer _tmp58_;
				gboolean _tmp59_ = FALSE;
				NoiseEqualizerPreset* _tmp60_;
				_tmp56_ = _p_it;
				if (!gee_iterator_next (_tmp56_)) {
					break;
				}
				_tmp57_ = _p_it;
				_tmp58_ = gee_iterator_get (_tmp57_);
				p = (NoiseEqualizerPreset*) _tmp58_;
				_tmp60_ = p;
				if (_tmp60_ != NULL) {
					NoiseMedia* _tmp61_;
					_tmp61_ = self->priv->_current_media;
					_tmp59_ = _tmp61_ != NULL;
				} else {
					_tmp59_ = FALSE;
				}
				if (_tmp59_) {
					gchar* preset_name = NULL;
					NoiseEqualizerPreset* _tmp62_;
					const gchar* _tmp63_;
					const gchar* _tmp64_;
					gchar* _tmp65_;
					gchar* media_genre = NULL;
					NoiseMedia* _tmp66_;
					const gchar* _tmp67_;
					const gchar* _tmp68_;
					gchar* _tmp69_;
					gboolean _tmp70_ = FALSE;
					const gchar* _tmp71_;
					const gchar* _tmp72_;
					gboolean match_genre = FALSE;
					gboolean _tmp75_ = FALSE;
					gboolean _tmp76_ = FALSE;
					gboolean _tmp77_;
					_tmp62_ = p;
					_tmp63_ = noise_equalizer_preset_get_name (_tmp62_);
					_tmp64_ = _tmp63_;
					_tmp65_ = g_utf8_strdown (_tmp64_, (gssize) -1);
					preset_name = _tmp65_;
					_tmp66_ = self->priv->_current_media;
					_tmp67_ = noise_media_get_genre (_tmp66_);
					_tmp68_ = _tmp67_;
					_tmp69_ = g_utf8_strdown (_tmp68_, (gssize) -1);
					media_genre = _tmp69_;
					_tmp71_ = media_genre;
					_tmp72_ = preset_name;
					if (string_contains (_tmp71_, _tmp72_)) {
						_tmp70_ = TRUE;
					} else {
						const gchar* _tmp73_;
						const gchar* _tmp74_;
						_tmp73_ = preset_name;
						_tmp74_ = media_genre;
						_tmp70_ = string_contains (_tmp73_, _tmp74_);
					}
					match_genre = _tmp70_;
					_tmp77_ = automatic_enabled;
					if (_tmp77_) {
						gboolean _tmp78_;
						_tmp78_ = match_genre;
						_tmp76_ = _tmp78_;
					} else {
						_tmp76_ = FALSE;
					}
					if (_tmp76_) {
						_tmp75_ = TRUE;
					} else {
						gboolean _tmp79_ = FALSE;
						gboolean _tmp80_;
						_tmp80_ = automatic_enabled;
						if (!_tmp80_) {
							NoiseEqualizerPreset* _tmp81_;
							const gchar* _tmp82_;
							const gchar* _tmp83_;
							const gchar* _tmp84_;
							_tmp81_ = p;
							_tmp82_ = noise_equalizer_preset_get_name (_tmp81_);
							_tmp83_ = _tmp82_;
							_tmp84_ = selected_preset;
							_tmp79_ = g_strcmp0 (_tmp83_, _tmp84_) == 0;
						} else {
							_tmp79_ = FALSE;
						}
						_tmp75_ = _tmp79_;
					}
					if (_tmp75_) {
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp85_ = FALSE;
								_tmp85_ = TRUE;
								while (TRUE) {
									gint _tmp87_;
									NoisePlayback* _tmp88_;
									gint _tmp89_;
									NoiseEqualizerPreset* _tmp90_;
									gint _tmp91_;
									if (!_tmp85_) {
										gint _tmp86_;
										_tmp86_ = i;
										i = _tmp86_ + 1;
									}
									_tmp85_ = FALSE;
									_tmp87_ = i;
									if (!(_tmp87_ < 10)) {
										break;
									}
									_tmp88_ = self->player;
									_tmp89_ = i;
									_tmp90_ = p;
									_tmp91_ = i;
									noise_playback_set_equalizer_gain (_tmp88_, _tmp89_, noise_equalizer_preset_get_gain (_tmp90_, _tmp91_));
								}
							}
						}
						_g_free0 (media_genre);
						_g_free0 (preset_name);
						_g_object_unref0 (p);
						_g_object_unref0 (_p_it);
						_g_free0 (selected_preset);
						_g_object_unref0 (equalizer_settings);
						return;
					}
					_g_free0 (media_genre);
					_g_free0 (preset_name);
				}
				_g_object_unref0 (p);
			}
			_g_object_unref0 (_p_it);
		}
		_g_free0 (selected_preset);
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp92_ = FALSE;
			_tmp92_ = TRUE;
			while (TRUE) {
				gint _tmp94_;
				NoisePlayback* _tmp95_;
				gint _tmp96_;
				if (!_tmp92_) {
					gint _tmp93_;
					_tmp93_ = i;
					i = _tmp93_ + 1;
				}
				_tmp92_ = FALSE;
				_tmp94_ = i;
				if (!(_tmp94_ < 10)) {
					break;
				}
				_tmp95_ = self->player;
				_tmp96_ = i;
				noise_playback_set_equalizer_gain (_tmp95_, _tmp96_, 0);
			}
		}
	}
	_g_object_unref0 (equalizer_settings);
}


void
noise_playback_manager_stop_playback (NoisePlaybackManager* self)
{
	NoisePlayback* _tmp0_;
	gint64 was_playing = 0LL;
	NoiseMedia* _tmp1_;
	NoiseSettingsMain* _tmp5_;
	NoiseSettingsMain* _tmp6_;
	gboolean _tmp7_;
	gint64 _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->player;
	noise_playback_pause (_tmp0_);
	noise_playback_manager_set_playing (self, FALSE);
	was_playing = (gint64) 0;
	_tmp1_ = self->priv->_current_media;
	if (_tmp1_ != NULL) {
		NoiseMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
		_tmp2_ = self->priv->_current_media;
		_tmp3_ = noise_media_get_rowid (_tmp2_);
		_tmp4_ = _tmp3_;
		was_playing = _tmp4_;
	}
	_tmp5_ = noise_settings_main_get_default ();
	_tmp6_ = _tmp5_;
	_tmp7_ = !noise_settings_main_privacy_mode_enabled (_tmp6_);
	_g_object_unref0 (_tmp6_);
	if (_tmp7_) {
		GSettings* _tmp8_;
		GSettings* _tmp9_;
		_tmp8_ = noise_app_get_settings ();
		_tmp9_ = _tmp8_;
		g_settings_set_int64 (_tmp9_, "last-media-playing", (gint64) 0);
	}
	noise_playback_manager_set_current_media (self, NULL);
	_tmp10_ = was_playing;
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL], 0, _tmp10_);
}


static GVariant*
_variant_new4 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


void
noise_playback_manager_start_playback (NoisePlaybackManager* self)
{
	NoisePlayback* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GAction* _tmp5_;
	GVariant* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->player;
	noise_playback_play (_tmp0_);
	noise_playback_manager_set_playing (self, TRUE);
	_tmp1_ = noise_app_get_main_window ();
	_tmp2_ = _tmp1_;
	_tmp3_ = noise_library_window_get_actions (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, NOISE_LIBRARY_WINDOW_ACTION_PLAY);
	_tmp6_ = _variant_new4 (TRUE);
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction), _tmp6_);
	_g_variant_unref0 (_tmp6_);
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL], 0);
}


static GVariant*
_variant_new5 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


void
noise_playback_manager_pause_playback (NoisePlaybackManager* self)
{
	NoisePlayback* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GAction* _tmp5_;
	GVariant* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->player;
	noise_playback_pause (_tmp0_);
	noise_playback_manager_set_playing (self, FALSE);
	_tmp1_ = noise_app_get_main_window ();
	_tmp2_ = _tmp1_;
	_tmp3_ = noise_library_window_get_actions (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, NOISE_LIBRARY_WINDOW_ACTION_PLAY);
	_tmp6_ = _variant_new5 (FALSE);
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction), _tmp6_);
	_g_variant_unref0 (_tmp6_);
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL], 0);
}


NoisePlaybackManager*
noise_playback_manager_construct (GType object_type)
{
	NoisePlaybackManager * self = NULL;
	self = (NoisePlaybackManager*) g_object_new (object_type, NULL);
	return self;
}


NoisePlaybackManager*
noise_playback_manager_new (void)
{
	return noise_playback_manager_construct (NOISE_TYPE_PLAYBACK_MANAGER);
}


NoiseStaticPlaylist*
noise_playback_manager_get_queue_playlist (NoisePlaybackManager* self)
{
	NoiseStaticPlaylist* result;
	NoiseStaticPlaylist* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_queue_playlist;
	result = _tmp0_;
	return result;
}


void
noise_playback_manager_set_queue_playlist (NoisePlaybackManager* self,
                                           NoiseStaticPlaylist* value)
{
	NoiseStaticPlaylist* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->ordered_queue);
	self->priv->ordered_queue = _tmp0_;
	noise_playback_manager_reshuffle (self);
	g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_QUEUE_PLAYLIST_PROPERTY]);
}


static NoiseLibrary*
noise_playback_manager_get_library (NoisePlaybackManager* self)
{
	NoiseLibrary* result;
	NoiseLibrariesManager* _tmp0_;
	NoiseLibrary* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_libraries_manager;
	_tmp1_ = _tmp0_->local_library;
	result = _tmp1_;
	return result;
}


gint
noise_playback_manager_get_current_index (NoisePlaybackManager* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_ci;
	result = _tmp0_;
	return result;
}


void
noise_playback_manager_set_current_index (NoisePlaybackManager* self,
                                          gint value)
{
	g_return_if_fail (self != NULL);
	g_debug ("PlaybackManager.vala:91: Current index: %d", value);
	self->priv->_ci = value;
	g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY]);
}


gboolean
noise_playback_manager_get_playing (NoisePlaybackManager* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_playing;
	result = _tmp0_;
	return result;
}


static void
noise_playback_manager_set_playing (NoisePlaybackManager* self,
                                    gboolean value)
{
	g_return_if_fail (self != NULL);
	if (noise_playback_manager_get_playing (self) != value) {
		self->priv->_playing = value;
		g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY]);
	}
}


gdouble
noise_playback_manager_get_volume (NoisePlaybackManager* self)
{
	gdouble result;
	NoisePlayback* _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->player;
	result = noise_playback_get_volume (_tmp0_);
	return result;
}


void
noise_playback_manager_set_volume (NoisePlaybackManager* self,
                                   gdouble value)
{
	NoisePlayback* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->saved_volume = value;
	_tmp0_ = self->player;
	noise_playback_set_volume (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY]);
}


NoiseMedia*
noise_playback_manager_get_current_media (NoisePlaybackManager* self)
{
	NoiseMedia* result;
	NoiseMedia* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_current_media;
	result = _tmp0_;
	return result;
}


static void
noise_playback_manager_set_current_media (NoisePlaybackManager* self,
                                          NoiseMedia* value)
{
	g_return_if_fail (self != NULL);
	if (noise_playback_manager_get_current_media (self) != value) {
		NoiseMedia* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_current_media);
		self->priv->_current_media = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY]);
	}
}


static void
g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                     GValue * return_value,
                                     guint n_param_values,
                                     const GValue * param_values,
                                     gpointer invocation_hint,
                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int64 (param_values + 1), data2);
}


static GObject *
noise_playback_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoisePlaybackManager * self;
	NoiseHistoryPlaylist* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	NoiseStaticPlaylist* _tmp2_;
	NoiseStaticPlaylist* _tmp3_;
	NoiseStaticPlaylist* _tmp4_;
	NoiseStaticPlaylist* _tmp5_;
	NoiseStaticPlaylist* _tmp6_;
	NoiseStaticPlaylist* _tmp7_;
	NoiseStaticPlaylist* _tmp8_;
	NoiseStaticPlaylist* _tmp9_;
	NoiseStaticPlaylist* _tmp10_;
	NoiseStaticPlaylist* _tmp11_;
	GThemedIcon* _tmp12_;
	NoiseStreamer* _tmp13_;
	GeeTreeSet* _tmp14_;
	NoiseStreamer* _tmp15_;
	NoiseStreamer* _tmp16_;
	NoisePlayback* _tmp17_;
	parent_class = G_OBJECT_CLASS (noise_playback_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
	_tmp0_ = noise_history_playlist_new ();
	_g_object_unref0 (self->history_playlist);
	self->history_playlist = _tmp0_;
	_tmp1_ = noise_static_playlist_new ();
	_g_object_unref0 (self->priv->ordered_queue);
	self->priv->ordered_queue = _tmp1_;
	_tmp2_ = noise_playback_manager_get_queue_playlist (self);
	_tmp3_ = _tmp2_;
	noise_playlist_set_name ((NoisePlaylist*) _tmp3_, C_ ("Name of the playlist", "Queue"));
	_tmp4_ = noise_playback_manager_get_queue_playlist (self);
	_tmp5_ = _tmp4_;
	noise_static_playlist_set_read_only (_tmp5_, TRUE);
	_tmp6_ = noise_playback_manager_get_queue_playlist (self);
	_tmp7_ = _tmp6_;
	noise_static_playlist_set_allow_duplicate (_tmp7_, TRUE);
	_tmp8_ = noise_playback_manager_get_queue_playlist (self);
	_tmp9_ = _tmp8_;
	noise_static_playlist_set_show_badge (_tmp9_, TRUE);
	_tmp10_ = noise_playback_manager_get_queue_playlist (self);
	_tmp11_ = _tmp10_;
	_tmp12_ = (GThemedIcon*) g_themed_icon_new ("playlist-queue");
	_g_object_unref0 (((NoisePlaylist*) _tmp11_)->icon);
	((NoisePlaylist*) _tmp11_)->icon = (GIcon*) _tmp12_;
	_tmp13_ = noise_streamer_new ();
	_g_object_unref0 (self->file_player);
	self->file_player = _tmp13_;
	_tmp14_ = self->priv->playbacks;
	_tmp15_ = self->file_player;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, (NoisePlayback*) _tmp15_);
	_tmp16_ = self->file_player;
	_tmp17_ = _g_object_ref0 ((NoisePlayback*) _tmp16_);
	_g_object_unref0 (self->player);
	self->player = _tmp17_;
	return obj;
}


static void
noise_playback_manager_class_init (NoisePlaybackManagerClass * klass)
{
	noise_playback_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoisePlaybackManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_playback_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_playback_manager_set_property;
	G_OBJECT_CLASS (klass)->constructor = noise_playback_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = noise_playback_manager_finalize;
	/**
	    * Either contains the ordered or the shuffled queue
	    *
	    * When giving it a value, be sure it is ordered.
	    */
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_QUEUE_PLAYLIST_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_QUEUE_PLAYLIST_PROPERTY] = g_param_spec_object ("queue-playlist", "queue-playlist", "queue-playlist", NOISE_TYPE_STATIC_PLAYLIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY] = g_param_spec_int ("current-index", "current-index", "current-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY] = g_param_spec_boolean ("playing", "playing", "playing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY] = g_param_spec_object ("current-media", "current-media", "current-media", NOISE_TYPE_MEDIA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL] = g_signal_new ("changing-player", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL] = g_signal_new ("media-played", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_MEDIA);
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL] = g_signal_new ("playback-stopped", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL] = g_signal_new ("playback-started", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL] = g_signal_new ("playback-paused", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL] = g_signal_new ("player-changed", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL] = g_signal_new ("queue-cleared", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
noise_playback_manager_instance_init (NoisePlaybackManager * self)
{
	GeeTreeSet* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	self->priv = noise_playback_manager_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_playbacks);
	_tmp0_ = gee_tree_set_new (NOISE_TYPE_PLAYBACK, NULL, NULL, NULL, NULL, NULL);
	self->priv->playbacks = _tmp0_;
	_tmp1_ = noise_static_playlist_new ();
	self->priv->_queue_playlist = _tmp1_;
	self->priv->_playing = FALSE;
	self->priv->saved_volume = (gdouble) 1;
}


static void
noise_playback_manager_finalize (GObject * obj)
{
	NoisePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
	g_rec_mutex_clear (&self->priv->__lock_playbacks);
	_g_object_unref0 (self->priv->playbacks);
	_g_object_unref0 (self->priv->ordered_queue);
	_g_object_unref0 (self->priv->_queue_playlist);
	_g_object_unref0 (self->history_playlist);
	_g_object_unref0 (self->file_player);
	_g_object_unref0 (self->player);
	_g_object_unref0 (self->priv->_current_media);
	G_OBJECT_CLASS (noise_playback_manager_parent_class)->finalize (obj);
}


/**
* Manages song playback, queue, repeating and shuffling
*
* Finds the appropriate {@link Noise.Playback} to play a media
*/
GType
noise_playback_manager_get_type (void)
{
	static volatile gsize noise_playback_manager_type_id__volatile = 0;
	if (g_once_init_enter (&noise_playback_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePlaybackManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_playback_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePlaybackManager), 0, (GInstanceInitFunc) noise_playback_manager_instance_init, NULL };
		GType noise_playback_manager_type_id;
		noise_playback_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "NoisePlaybackManager", &g_define_type_info, 0);
		NoisePlaybackManager_private_offset = g_type_add_instance_private (noise_playback_manager_type_id, sizeof (NoisePlaybackManagerPrivate));
		g_once_init_leave (&noise_playback_manager_type_id__volatile, noise_playback_manager_type_id);
	}
	return noise_playback_manager_type_id__volatile;
}


static void
_vala_noise_playback_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NoisePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
	switch (property_id) {
		case NOISE_PLAYBACK_MANAGER_QUEUE_PLAYLIST_PROPERTY:
		g_value_set_object (value, noise_playback_manager_get_queue_playlist (self));
		break;
		case NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
		g_value_set_int (value, noise_playback_manager_get_current_index (self));
		break;
		case NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY:
		g_value_set_boolean (value, noise_playback_manager_get_playing (self));
		break;
		case NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY:
		g_value_set_double (value, noise_playback_manager_get_volume (self));
		break;
		case NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
		g_value_set_object (value, noise_playback_manager_get_current_media (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_playback_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NoisePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
	switch (property_id) {
		case NOISE_PLAYBACK_MANAGER_QUEUE_PLAYLIST_PROPERTY:
		noise_playback_manager_set_queue_playlist (self, g_value_get_object (value));
		break;
		case NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
		noise_playback_manager_set_current_index (self, g_value_get_int (value));
		break;
		case NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY:
		noise_playback_manager_set_playing (self, g_value_get_boolean (value));
		break;
		case NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY:
		noise_playback_manager_set_volume (self, g_value_get_double (value));
		break;
		case NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
		noise_playback_manager_set_current_media (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



