/* FastListModel.c generated by valac 0.41.91, the Vala compiler
 * generated from FastListModel.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */
/* Since this class is not publicly facing (the FastView is public part),
 * this model is low level and optimized. We are not worried about stupid
 * users here.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <string.h>


#define NOISE_TYPE_FAST_MODEL (noise_fast_model_get_type ())
#define NOISE_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_FAST_MODEL, NoiseFastModel))
#define NOISE_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_FAST_MODEL, NoiseFastModelClass))
#define NOISE_IS_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_FAST_MODEL))
#define NOISE_IS_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_FAST_MODEL))
#define NOISE_FAST_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_FAST_MODEL, NoiseFastModelClass))

typedef struct _NoiseFastModel NoiseFastModel;
typedef struct _NoiseFastModelClass NoiseFastModelClass;
typedef struct _NoiseFastModelPrivate NoiseFastModelPrivate;
enum  {
	NOISE_FAST_MODEL_0_PROPERTY,
	NOISE_FAST_MODEL_COLUMNS_PROPERTY,
	NOISE_FAST_MODEL_NUM_PROPERTIES
};
static GParamSpec* noise_fast_model_properties[NOISE_FAST_MODEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
enum  {
	NOISE_FAST_MODEL_REORDER_REQUESTED_SIGNAL,
	NOISE_FAST_MODEL_NUM_SIGNALS
};
static guint noise_fast_model_signals[NOISE_FAST_MODEL_NUM_SIGNALS] = {0};

struct _NoiseFastModel {
	GObject parent_instance;
	NoiseFastModelPrivate * priv;
};

struct _NoiseFastModelClass {
	GObjectClass parent_class;
};

typedef GValue* (*NoiseFastModelValueReturnFunc) (gint row, gint column, GObject* o, gpointer user_data);
struct _NoiseFastModelPrivate {
	gint stamp;
	GeeArrayList* rows;
	GeeList* _columns;
	gint sort_column_id;
	GtkSortType sort_direction;
	NoiseFastModelValueReturnFunc value_func;
	gpointer value_func_target;
};


static gint NoiseFastModel_private_offset;
static gpointer noise_fast_model_parent_class = NULL;
static GtkTreeModelIface * noise_fast_model_gtk_tree_model_parent_iface = NULL;
static GtkTreeSortableIface * noise_fast_model_gtk_tree_sortable_parent_iface = NULL;

GType noise_fast_model_get_type (void) G_GNUC_CONST;
NoiseFastModel* noise_fast_model_new (GeeList* column_types);
NoiseFastModel* noise_fast_model_construct (GType object_type,
                                            GeeList* column_types);
static GType noise_fast_model_real_get_column_type (GtkTreeModel* base,
                                             gint col);
GeeList* noise_fast_model_get_columns (NoiseFastModel* self);
static GtkTreeModelFlags noise_fast_model_real_get_flags (GtkTreeModel* base);
static gboolean noise_fast_model_real_get_iter (GtkTreeModel* base,
                                         GtkTreeIter* iter,
                                         GtkTreePath* path);
static gint noise_fast_model_real_get_n_columns (GtkTreeModel* base);
static GtkTreePath* noise_fast_model_real_get_path (GtkTreeModel* base,
                                             GtkTreeIter* iter);
static void noise_fast_model_real_get_value (GtkTreeModel* base,
                                      GtkTreeIter* iter,
                                      gint column,
                                      GValue* val);
static void _vala_GValue_free (GValue* self);
GObject* noise_fast_model_get_object (NoiseFastModel* self,
                                      GtkTreeIter* iter);
static gboolean noise_fast_model_real_iter_children (GtkTreeModel* base,
                                              GtkTreeIter* iter,
                                              GtkTreeIter* parent);
static gboolean noise_fast_model_real_iter_has_child (GtkTreeModel* base,
                                               GtkTreeIter* iter);
static gint noise_fast_model_real_iter_n_children (GtkTreeModel* base,
                                            GtkTreeIter* iter);
static gboolean noise_fast_model_real_iter_next (GtkTreeModel* base,
                                          GtkTreeIter* iter);
static gboolean noise_fast_model_real_iter_nth_child (GtkTreeModel* base,
                                               GtkTreeIter* iter,
                                               GtkTreeIter* parent,
                                               gint n);
static gboolean noise_fast_model_real_iter_parent (GtkTreeModel* base,
                                            GtkTreeIter* iter,
                                            GtkTreeIter* child);
void noise_fast_model_append (NoiseFastModel* self,
                              GtkTreeIter* iter);
static void _vala_GtkTreePath_free (GtkTreePath* self);
void noise_fast_model_remove (NoiseFastModel* self,
                              GtkTreeIter* iter);
void noise_fast_model_set (NoiseFastModel* self,
                           GtkTreeIter* iter,
                           ...);
static void noise_fast_model_real_ref_node (GtkTreeModel* base,
                                     GtkTreeIter* iter);
static void noise_fast_model_real_unref_node (GtkTreeModel* base,
                                       GtkTreeIter* iter);
void noise_fast_model_set_table (NoiseFastModel* self,
                                 GeeArrayList* table);
void noise_fast_model_set_value_func (NoiseFastModel* self,
                                      NoiseFastModelValueReturnFunc func,
                                      gpointer func_target);
void noise_fast_model_update_row (NoiseFastModel* self,
                                  gint index);
static gboolean noise_fast_model_real_get_sort_column_id (GtkTreeSortable* base,
                                                   gint* column_id,
                                                   GtkSortType* order);
static void noise_fast_model_real_set_sort_column_id (GtkTreeSortable* base,
                                               gint column,
                                               GtkSortType order);
static gboolean noise_fast_model_real_has_default_sort_func (GtkTreeSortable* base);
static void noise_fast_model_real_set_sort_func (GtkTreeSortable* base,
                                          gint sort_column_id,
                                          GtkTreeIterCompareFunc sort_func,
                                          gpointer sort_func_target,
                                          GDestroyNotify sort_func_target_destroy_notify);
static void noise_fast_model_real_set_default_sort_func (GtkTreeSortable* base,
                                                  GtkTreeIterCompareFunc sort_func,
                                                  gpointer sort_func_target,
                                                  GDestroyNotify sort_func_target_destroy_notify);
void noise_fast_model_set_columns (NoiseFastModel* self,
                                   GeeList* value);
static void g_cclosure_user_marshal_VOID__INT_ENUM (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data);
static GObject * noise_fast_model_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static void noise_fast_model_finalize (GObject * obj);
static void _vala_noise_fast_model_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_noise_fast_model_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);


static inline gpointer
noise_fast_model_get_instance_private (NoiseFastModel* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseFastModel_private_offset);
}


/** Initialize data storage, columns, etc. **/
NoiseFastModel*
noise_fast_model_construct (GType object_type,
                            GeeList* column_types)
{
	NoiseFastModel * self = NULL;
	g_return_val_if_fail (column_types != NULL, NULL);
	self = (NoiseFastModel*) g_object_new (object_type, "columns", column_types, NULL);
	return self;
}


NoiseFastModel*
noise_fast_model_new (GeeList* column_types)
{
	return noise_fast_model_construct (NOISE_TYPE_FAST_MODEL, column_types);
}


static GType
noise_fast_model_real_get_column_type (GtkTreeModel* base,
                                       gint col)
{
	NoiseFastModel * self;
	GType result = 0UL;
	GeeList* _tmp0_;
	gpointer _tmp1_;
	self = (NoiseFastModel*) base;
	_tmp0_ = self->priv->_columns;
	_tmp1_ = gee_list_get (_tmp0_, col);
	result = (GType) ((gintptr) _tmp1_);
	return result;
}


static GtkTreeModelFlags
noise_fast_model_real_get_flags (GtkTreeModel* base)
{
	NoiseFastModel * self;
	GtkTreeModelFlags result = 0;
	self = (NoiseFastModel*) base;
	result = GTK_TREE_MODEL_LIST_ONLY;
	return result;
}


static gboolean
noise_fast_model_real_get_iter (GtkTreeModel* base,
                                GtkTreeIter* iter,
                                GtkTreePath* path)
{
	NoiseFastModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	gint path_index = 0;
	gint _tmp0_;
	gint* _tmp1_;
	gint _tmp2_;
	guint size = 0U;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	guint _tmp9_;
	gint _tmp17_;
	gint _tmp18_;
	self = (NoiseFastModel*) base;
	g_return_val_if_fail (path != NULL, FALSE);
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	_tmp1_ = gtk_tree_path_get_indices_with_depth (path, &_tmp0_);
	_tmp2_ = _tmp1_[0];
	path_index = _tmp2_;
	_tmp3_ = self->priv->rows;
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
	_tmp5_ = _tmp4_;
	size = (guint) _tmp5_;
	_tmp9_ = size;
	if (_tmp9_ == ((guint) 0)) {
		_tmp8_ = TRUE;
	} else {
		gint _tmp10_;
		_tmp10_ = path_index;
		_tmp8_ = _tmp10_ < 0;
	}
	if (_tmp8_) {
		_tmp7_ = TRUE;
	} else {
		gint _tmp11_;
		guint _tmp12_;
		_tmp11_ = path_index;
		_tmp12_ = size;
		_tmp7_ = ((guint) _tmp11_) >= _tmp12_;
	}
	if (_tmp7_) {
		_tmp6_ = TRUE;
	} else {
		GeeArrayList* _tmp13_;
		gint _tmp14_;
		gpointer _tmp15_;
		GObject* _tmp16_;
		_tmp13_ = self->priv->rows;
		_tmp14_ = path_index;
		_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, _tmp14_);
		_tmp16_ = (GObject*) _tmp15_;
		_tmp6_ = _tmp16_ == NULL;
		_g_object_unref0 (_tmp16_);
	}
	if (_tmp6_) {
		result = FALSE;
		if (iter) {
			*iter = _vala_iter;
		}
		return result;
	}
	_tmp17_ = self->priv->stamp;
	_vala_iter.stamp = _tmp17_;
	_tmp18_ = path_index;
	_vala_iter.user_data = (void*) _tmp18_;
	result = TRUE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}


static gint
noise_fast_model_real_get_n_columns (GtkTreeModel* base)
{
	NoiseFastModel * self;
	gint result = 0;
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	self = (NoiseFastModel*) base;
	_tmp0_ = self->priv->_columns;
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static GtkTreePath*
noise_fast_model_real_get_path (GtkTreeModel* base,
                                GtkTreeIter* iter)
{
	NoiseFastModel * self;
	GtkTreePath* result = NULL;
	GtkTreeIter _tmp0_;
	void* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkTreePath* _tmp4_;
	GtkTreePath* _tmp5_;
	self = (NoiseFastModel*) base;
	g_return_val_if_fail (iter != NULL, NULL);
	_tmp0_ = *iter;
	_tmp1_ = _tmp0_.user_data;
	_tmp2_ = g_strdup_printf ("%i", (gint) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gtk_tree_path_new_from_string (_tmp3_);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	result = _tmp5_;
	return result;
}


static void
_vala_GValue_free (GValue* self)
{
	g_value_unset (self);
	g_free (self);
}


static void
noise_fast_model_real_get_value (GtkTreeModel* base,
                                 GtkTreeIter* iter,
                                 gint column,
                                 GValue* val)
{
	NoiseFastModel * self;
	GValue _vala_val = {0};
	GValue _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GtkTreeIter _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GValue _tmp6_ = {0};
	GValue _tmp7_;
	gint row = 0;
	GtkTreeIter _tmp8_;
	void* _tmp9_;
	GObject* object = NULL;
	GeeArrayList* _tmp10_;
	gint _tmp11_;
	gpointer _tmp12_;
	GObject* _tmp13_;
	self = (NoiseFastModel*) base;
	g_return_if_fail (iter != NULL);
	G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
	_vala_val = _tmp0_;
	_tmp3_ = *iter;
	_tmp4_ = _tmp3_.stamp;
	_tmp5_ = self->priv->stamp;
	if (_tmp4_ != _tmp5_) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = column < 0;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = column >= gtk_tree_model_get_n_columns ((GtkTreeModel*) self);
	}
	if (_tmp1_) {
		if (val) {
			*val = _vala_val;
		} else {
			G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
		}
		return;
	}
	g_value_init (&_tmp6_, gtk_tree_model_get_column_type ((GtkTreeModel*) self, column));
	G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
	_vala_val = _tmp6_;
	_tmp7_ = _vala_val;
	_tmp8_ = *iter;
	_tmp9_ = _tmp8_.user_data;
	row = (gint) _tmp9_;
	_tmp10_ = self->priv->rows;
	_tmp11_ = row;
	_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _tmp11_);
	object = (GObject*) _tmp12_;
	_tmp13_ = object;
	if (_tmp13_ != NULL) {
		NoiseFastModelValueReturnFunc _tmp14_;
		void* _tmp14__target;
		gint _tmp15_;
		GObject* _tmp16_;
		GValue* _tmp17_;
		GValue* _tmp18_;
		GValue _tmp19_ = {0};
		_tmp14_ = self->priv->value_func;
		_tmp14__target = self->priv->value_func_target;
		_tmp15_ = row;
		_tmp16_ = object;
		_tmp17_ = _tmp14_ (_tmp15_, column, _tmp16_, _tmp14__target);
		_tmp18_ = _tmp17_;
		if (G_IS_VALUE (_tmp18_)) {
			g_value_init (&_tmp19_, G_VALUE_TYPE (_tmp18_));
			g_value_copy (_tmp18_, &_tmp19_);
		} else {
			_tmp19_ = *_tmp18_;
		}
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
		_vala_val = _tmp19_;
		__vala_GValue_free0 (_tmp18_);
	}
	_g_object_unref0 (object);
	if (val) {
		*val = _vala_val;
	} else {
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
	}
}


GObject*
noise_fast_model_get_object (NoiseFastModel* self,
                             GtkTreeIter* iter)
{
	GObject* result = NULL;
	GeeArrayList* _tmp0_;
	GtkTreeIter _tmp1_;
	void* _tmp2_;
	gpointer _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (iter != NULL, NULL);
	_tmp0_ = self->priv->rows;
	_tmp1_ = *iter;
	_tmp2_ = _tmp1_.user_data;
	_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, (gint) _tmp2_);
	result = (GObject*) _tmp3_;
	return result;
}


static gboolean
noise_fast_model_real_iter_children (GtkTreeModel* base,
                                     GtkTreeIter* iter,
                                     GtkTreeIter* parent)
{
	NoiseFastModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	self = (NoiseFastModel*) base;
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	result = FALSE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}


static gboolean
noise_fast_model_real_iter_has_child (GtkTreeModel* base,
                                      GtkTreeIter* iter)
{
	NoiseFastModel * self;
	gboolean result = FALSE;
	self = (NoiseFastModel*) base;
	g_return_val_if_fail (iter != NULL, FALSE);
	result = FALSE;
	return result;
}


static gint
noise_fast_model_real_iter_n_children (GtkTreeModel* base,
                                       GtkTreeIter* iter)
{
	NoiseFastModel * self;
	gint result = 0;
	gint _tmp0_ = 0;
	self = (NoiseFastModel*) base;
	if (iter == NULL) {
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		_tmp1_ = self->priv->rows;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_tmp0_ = (gint) _tmp3_;
	} else {
		_tmp0_ = 0;
	}
	result = _tmp0_;
	return result;
}


static gboolean
noise_fast_model_real_iter_next (GtkTreeModel* base,
                                 GtkTreeIter* iter)
{
	NoiseFastModel * self;
	gboolean result = FALSE;
	GtkTreeIter _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint index = 0;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GeeArrayList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	self = (NoiseFastModel*) base;
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = *iter;
	_tmp1_ = _tmp0_.stamp;
	_tmp2_ = self->priv->stamp;
	if (_tmp1_ != _tmp2_) {
		result = FALSE;
		return result;
	}
	_tmp3_ = *iter;
	_tmp4_ = _tmp3_.user_data;
	index = (gint) _tmp4_;
	_tmp5_ = index;
	index = _tmp5_ + 1;
	_tmp6_ = index;
	(*iter).user_data = (void*) _tmp6_;
	_tmp7_ = index;
	_tmp8_ = self->priv->rows;
	_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
	_tmp10_ = _tmp9_;
	result = _tmp7_ < _tmp10_;
	return result;
}


static gboolean
noise_fast_model_real_iter_nth_child (GtkTreeModel* base,
                                      GtkTreeIter* iter,
                                      GtkTreeIter* parent,
                                      gint n)
{
	NoiseFastModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _tmp5_;
	self = (NoiseFastModel*) base;
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	if (n < 0) {
		_tmp1_ = TRUE;
	} else {
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		_tmp2_ = self->priv->rows;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp1_ = n >= _tmp4_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = parent != NULL;
	}
	if (_tmp0_) {
		result = FALSE;
		if (iter) {
			*iter = _vala_iter;
		}
		return result;
	}
	_tmp5_ = self->priv->stamp;
	_vala_iter.stamp = _tmp5_;
	_vala_iter.user_data = (void*) n;
	result = TRUE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}


static gboolean
noise_fast_model_real_iter_parent (GtkTreeModel* base,
                                   GtkTreeIter* iter,
                                   GtkTreeIter* child)
{
	NoiseFastModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	self = (NoiseFastModel*) base;
	g_return_val_if_fail (child != NULL, FALSE);
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	result = FALSE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}


static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}


void
noise_fast_model_append (NoiseFastModel* self,
                         GtkTreeIter* iter)
{
	GtkTreeIter _vala_iter = {0};
	gint index = 0;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp3_;
	GeeArrayList* _tmp4_;
	GObject* _tmp5_;
	GObject* _tmp6_;
	gint _tmp7_;
	GeeArrayList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GtkTreeIter _tmp11_;
	g_return_if_fail (self != NULL);
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	_tmp0_ = self->priv->rows;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	index = (gint) _tmp2_;
	_tmp3_ = gtk_tree_path_new_from_indices (index, -1, -1);
	path = _tmp3_;
	_tmp4_ = self->priv->rows;
	_tmp5_ = g_object_new (G_TYPE_OBJECT, NULL);
	_tmp6_ = _tmp5_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, _tmp6_);
	_g_object_unref0 (_tmp6_);
	_tmp7_ = self->priv->stamp;
	_vala_iter.stamp = _tmp7_;
	_tmp8_ = self->priv->rows;
	_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
	_tmp10_ = _tmp9_;
	_vala_iter.user_data = (void*) _tmp10_;
	_tmp11_ = _vala_iter;
	gtk_tree_model_row_inserted ((GtkTreeModel*) self, path, &_tmp11_);
	__vala_GtkTreePath_free0 (path);
	if (iter) {
		*iter = _vala_iter;
	}
}


void
noise_fast_model_remove (NoiseFastModel* self,
                         GtkTreeIter* iter)
{
	GtkTreeIter _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint index = 0;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	GtkTreePath* path = NULL;
	gint _tmp5_;
	GtkTreePath* _tmp6_;
	GeeArrayList* _tmp7_;
	gint _tmp8_;
	gpointer _tmp9_;
	GObject* _tmp10_;
	GtkTreePath* _tmp11_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = *iter;
	_tmp1_ = _tmp0_.stamp;
	_tmp2_ = self->priv->stamp;
	if (_tmp1_ != _tmp2_) {
		return;
	}
	_tmp3_ = *iter;
	_tmp4_ = _tmp3_.user_data;
	index = (gint) _tmp4_;
	_tmp5_ = index;
	_tmp6_ = gtk_tree_path_new_from_indices (_tmp5_, -1, -1);
	path = _tmp6_;
	_tmp7_ = self->priv->rows;
	_tmp8_ = index;
	_tmp9_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp7_, _tmp8_);
	_tmp10_ = (GObject*) _tmp9_;
	_g_object_unref0 (_tmp10_);
	_tmp11_ = path;
	gtk_tree_model_row_deleted ((GtkTreeModel*) self, _tmp11_);
	__vala_GtkTreePath_free0 (path);
}


void
noise_fast_model_set (NoiseFastModel* self,
                      GtkTreeIter* iter,
                      ...)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (iter != NULL);
	return;
}


static void
noise_fast_model_real_ref_node (GtkTreeModel* base,
                                GtkTreeIter* iter)
{
	NoiseFastModel * self;
	self = (NoiseFastModel*) base;
	g_return_if_fail (iter != NULL);
}


static void
noise_fast_model_real_unref_node (GtkTreeModel* base,
                                  GtkTreeIter* iter)
{
	NoiseFastModel * self;
	self = (NoiseFastModel*) base;
	g_return_if_fail (iter != NULL);
}


void
noise_fast_model_set_table (NoiseFastModel* self,
                            GeeArrayList* table)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GtkTreeIter iter = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (table != NULL);
	_tmp0_ = self->priv->rows;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	_tmp1_ = self->priv->rows;
	gee_array_list_add_all (_tmp1_, (GeeCollection*) table);
	{
		gboolean valid = FALSE;
		GtkTreeIter _tmp2_ = {0};
		gboolean _tmp3_;
		_tmp3_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) self, &_tmp2_);
		iter = _tmp2_;
		valid = _tmp3_;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_;
				GtkTreeIter _tmp7_;
				GtkTreePath* _tmp8_;
				GtkTreePath* _tmp9_;
				GtkTreeIter _tmp10_;
				if (!_tmp4_) {
					gboolean _tmp5_;
					_tmp5_ = gtk_tree_model_iter_next ((GtkTreeModel*) self, &iter);
					valid = _tmp5_;
				}
				_tmp4_ = FALSE;
				_tmp6_ = valid;
				if (!_tmp6_) {
					break;
				}
				_tmp7_ = iter;
				_tmp8_ = gtk_tree_model_get_path ((GtkTreeModel*) self, &_tmp7_);
				_tmp9_ = _tmp8_;
				_tmp10_ = iter;
				gtk_tree_model_row_changed ((GtkTreeModel*) self, _tmp9_, &_tmp10_);
				__vala_GtkTreePath_free0 (_tmp9_);
			}
		}
	}
}


void
noise_fast_model_set_value_func (NoiseFastModel* self,
                                 NoiseFastModelValueReturnFunc func,
                                 gpointer func_target)
{
	g_return_if_fail (self != NULL);
	self->priv->value_func = func;
	self->priv->value_func_target = func_target;
}


void
noise_fast_model_update_row (NoiseFastModel* self,
                             gint index)
{
	GtkTreePath* path = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreePath* _tmp3_;
	GtkTreeIter iter = {0};
	gint _tmp4_;
	GtkTreeIter _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup_printf ("%i", index);
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_tree_path_new_from_string (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	path = _tmp3_;
	memset (&iter, 0, sizeof (GtkTreeIter));
	_tmp4_ = self->priv->stamp;
	iter.stamp = _tmp4_;
	iter.user_data = (void*) index;
	_tmp5_ = iter;
	gtk_tree_model_row_changed ((GtkTreeModel*) self, path, &_tmp5_);
	__vala_GtkTreePath_free0 (path);
}


static gboolean
noise_fast_model_real_get_sort_column_id (GtkTreeSortable* base,
                                          gint* column_id,
                                          GtkSortType* order)
{
	NoiseFastModel * self;
	gint _vala_column_id = 0;
	GtkSortType _vala_order = 0;
	gboolean result = FALSE;
	gint _tmp0_;
	GtkSortType _tmp1_;
	self = (NoiseFastModel*) base;
	_tmp0_ = self->priv->sort_column_id;
	_vala_column_id = _tmp0_;
	_tmp1_ = self->priv->sort_direction;
	_vala_order = _tmp1_;
	result = TRUE;
	if (column_id) {
		*column_id = _vala_column_id;
	}
	if (order) {
		*order = _vala_order;
	}
	return result;
}


static void
noise_fast_model_real_set_sort_column_id (GtkTreeSortable* base,
                                          gint column,
                                          GtkSortType order)
{
	NoiseFastModel * self;
	self = (NoiseFastModel*) base;
	self->priv->sort_column_id = column;
	self->priv->sort_direction = order;
	if (column != -1) {
		g_signal_emit (self, noise_fast_model_signals[NOISE_FAST_MODEL_REORDER_REQUESTED_SIGNAL], 0, column, order);
		gtk_tree_sortable_sort_column_changed ((GtkTreeSortable*) self);
	}
}


/** The following functions are only here to implement TreeSortable **/
static gboolean
noise_fast_model_real_has_default_sort_func (GtkTreeSortable* base)
{
	NoiseFastModel * self;
	gboolean result = FALSE;
	self = (NoiseFastModel*) base;
	result = TRUE;
	return result;
}


static void
noise_fast_model_real_set_sort_func (GtkTreeSortable* base,
                                     gint sort_column_id,
                                     GtkTreeIterCompareFunc sort_func,
                                     gpointer sort_func_target,
                                     GDestroyNotify sort_func_target_destroy_notify)
{
	NoiseFastModel * self;
	self = (NoiseFastModel*) base;
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
	sort_func = NULL;
	sort_func_target = NULL;
	sort_func_target_destroy_notify = NULL;
}


static void
noise_fast_model_real_set_default_sort_func (GtkTreeSortable* base,
                                             GtkTreeIterCompareFunc sort_func,
                                             gpointer sort_func_target,
                                             GDestroyNotify sort_func_target_destroy_notify)
{
	NoiseFastModel * self;
	self = (NoiseFastModel*) base;
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
	sort_func = NULL;
	sort_func_target = NULL;
	sort_func_target_destroy_notify = NULL;
}


GeeList*
noise_fast_model_get_columns (NoiseFastModel* self)
{
	GeeList* result;
	GeeList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_columns;
	result = _tmp0_;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void
noise_fast_model_set_columns (NoiseFastModel* self,
                              GeeList* value)
{
	g_return_if_fail (self != NULL);
	if (noise_fast_model_get_columns (self) != value) {
		GeeList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_columns);
		self->priv->_columns = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_fast_model_properties[NOISE_FAST_MODEL_COLUMNS_PROPERTY]);
	}
}


static void
g_cclosure_user_marshal_VOID__INT_ENUM (GClosure * closure,
                                        GValue * return_value,
                                        guint n_param_values,
                                        const GValue * param_values,
                                        gpointer invocation_hint,
                                        gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_ENUM) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_ENUM) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_enum (param_values + 2), data2);
}


static GObject *
noise_fast_model_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseFastModel * self;
	parent_class = G_OBJECT_CLASS (noise_fast_model_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_FAST_MODEL, NoiseFastModel);
	self->priv->sort_column_id = -2;
	self->priv->sort_direction = GTK_SORT_ASCENDING;
	self->priv->stamp = (gint) g_random_int ();
	return obj;
}


static void
noise_fast_model_class_init (NoiseFastModelClass * klass)
{
	noise_fast_model_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseFastModel_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_fast_model_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_fast_model_set_property;
	G_OBJECT_CLASS (klass)->constructor = noise_fast_model_constructor;
	G_OBJECT_CLASS (klass)->finalize = noise_fast_model_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_FAST_MODEL_COLUMNS_PROPERTY, noise_fast_model_properties[NOISE_FAST_MODEL_COLUMNS_PROPERTY] = g_param_spec_object ("columns", "columns", "columns", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	noise_fast_model_signals[NOISE_FAST_MODEL_REORDER_REQUESTED_SIGNAL] = g_signal_new ("reorder-requested", NOISE_TYPE_FAST_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_ENUM, G_TYPE_NONE, 2, G_TYPE_INT, gtk_sort_type_get_type ());
}


static void
noise_fast_model_gtk_tree_model_interface_init (GtkTreeModelIface * iface)
{
	noise_fast_model_gtk_tree_model_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_column_type = (GType (*) (GtkTreeModel *, gint)) noise_fast_model_real_get_column_type;
	iface->get_flags = (GtkTreeModelFlags (*) (GtkTreeModel *)) noise_fast_model_real_get_flags;
	iface->get_iter = (gboolean (*) (GtkTreeModel *, GtkTreeIter*, GtkTreePath*)) noise_fast_model_real_get_iter;
	iface->get_n_columns = (gint (*) (GtkTreeModel *)) noise_fast_model_real_get_n_columns;
	iface->get_path = (GtkTreePath* (*) (GtkTreeModel *, GtkTreeIter*)) noise_fast_model_real_get_path;
	iface->get_value = (void (*) (GtkTreeModel *, GtkTreeIter*, gint, GValue*)) noise_fast_model_real_get_value;
	iface->iter_children = (gboolean (*) (GtkTreeModel *, GtkTreeIter*, GtkTreeIter*)) noise_fast_model_real_iter_children;
	iface->iter_has_child = (gboolean (*) (GtkTreeModel *, GtkTreeIter*)) noise_fast_model_real_iter_has_child;
	iface->iter_n_children = (gint (*) (GtkTreeModel *, GtkTreeIter*)) noise_fast_model_real_iter_n_children;
	iface->iter_next = (gboolean (*) (GtkTreeModel *, GtkTreeIter*)) noise_fast_model_real_iter_next;
	iface->iter_nth_child = (gboolean (*) (GtkTreeModel *, GtkTreeIter*, GtkTreeIter*, gint)) noise_fast_model_real_iter_nth_child;
	iface->iter_parent = (gboolean (*) (GtkTreeModel *, GtkTreeIter*, GtkTreeIter*)) noise_fast_model_real_iter_parent;
	iface->ref_node = (void (*) (GtkTreeModel *, GtkTreeIter*)) noise_fast_model_real_ref_node;
	iface->unref_node = (void (*) (GtkTreeModel *, GtkTreeIter*)) noise_fast_model_real_unref_node;
}


static void
noise_fast_model_gtk_tree_sortable_interface_init (GtkTreeSortableIface * iface)
{
	noise_fast_model_gtk_tree_sortable_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_sort_column_id = (gboolean (*) (GtkTreeSortable *, gint*, GtkSortType*)) noise_fast_model_real_get_sort_column_id;
	iface->set_sort_column_id = (void (*) (GtkTreeSortable *, gint, GtkSortType)) noise_fast_model_real_set_sort_column_id;
	iface->has_default_sort_func = (gboolean (*) (GtkTreeSortable *)) noise_fast_model_real_has_default_sort_func;
	iface->set_sort_func = (void (*) (GtkTreeSortable *, gint, GtkTreeIterCompareFunc, gpointer, GDestroyNotify)) noise_fast_model_real_set_sort_func;
	iface->set_default_sort_func = (void (*) (GtkTreeSortable *, GtkTreeIterCompareFunc, gpointer, GDestroyNotify)) noise_fast_model_real_set_default_sort_func;
}


static void
noise_fast_model_instance_init (NoiseFastModel * self)
{
	GeeArrayList* _tmp0_;
	self->priv = noise_fast_model_get_instance_private (self);
	_tmp0_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->priv->rows = _tmp0_;
}


static void
noise_fast_model_finalize (GObject * obj)
{
	NoiseFastModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_FAST_MODEL, NoiseFastModel);
	_g_object_unref0 (self->priv->rows);
	_g_object_unref0 (self->priv->_columns);
	G_OBJECT_CLASS (noise_fast_model_parent_class)->finalize (obj);
}


GType
noise_fast_model_get_type (void)
{
	static volatile gsize noise_fast_model_type_id__volatile = 0;
	if (g_once_init_enter (&noise_fast_model_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseFastModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_fast_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseFastModel), 0, (GInstanceInitFunc) noise_fast_model_instance_init, NULL };
		static const GInterfaceInfo gtk_tree_model_info = { (GInterfaceInitFunc) noise_fast_model_gtk_tree_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gtk_tree_sortable_info = { (GInterfaceInitFunc) noise_fast_model_gtk_tree_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_fast_model_type_id;
		noise_fast_model_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseFastModel", &g_define_type_info, 0);
		g_type_add_interface_static (noise_fast_model_type_id, gtk_tree_model_get_type (), &gtk_tree_model_info);
		g_type_add_interface_static (noise_fast_model_type_id, gtk_tree_sortable_get_type (), &gtk_tree_sortable_info);
		NoiseFastModel_private_offset = g_type_add_instance_private (noise_fast_model_type_id, sizeof (NoiseFastModelPrivate));
		g_once_init_leave (&noise_fast_model_type_id__volatile, noise_fast_model_type_id);
	}
	return noise_fast_model_type_id__volatile;
}


static void
_vala_noise_fast_model_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	NoiseFastModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_FAST_MODEL, NoiseFastModel);
	switch (property_id) {
		case NOISE_FAST_MODEL_COLUMNS_PROPERTY:
		g_value_set_object (value, noise_fast_model_get_columns (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_fast_model_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	NoiseFastModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_FAST_MODEL, NoiseFastModel);
	switch (property_id) {
		case NOISE_FAST_MODEL_COLUMNS_PROPERTY:
		noise_fast_model_set_columns (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



