/* PresetList.c generated by valac 0.41.91, the Vala compiler
 * generated from PresetList.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <gee.h>


#define NOISE_TYPE_PRESET_LIST (noise_preset_list_get_type ())
#define NOISE_PRESET_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PRESET_LIST, NoisePresetList))
#define NOISE_PRESET_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PRESET_LIST, NoisePresetListClass))
#define NOISE_IS_PRESET_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PRESET_LIST))
#define NOISE_IS_PRESET_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PRESET_LIST))
#define NOISE_PRESET_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PRESET_LIST, NoisePresetListClass))

typedef struct _NoisePresetList NoisePresetList;
typedef struct _NoisePresetListClass NoisePresetListClass;
typedef struct _NoisePresetListPrivate NoisePresetListPrivate;
enum  {
	NOISE_PRESET_LIST_0_PROPERTY,
	NOISE_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY,
	NOISE_PRESET_LIST_NUM_PROPERTIES
};
static GParamSpec* noise_preset_list_properties[NOISE_PRESET_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NOISE_PRESET_LIST_PRESET_SELECTED_SIGNAL,
	NOISE_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL,
	NOISE_PRESET_LIST_DELETE_PRESET_CHOSEN_SIGNAL,
	NOISE_PRESET_LIST_NUM_SIGNALS
};
static guint noise_preset_list_signals[NOISE_PRESET_LIST_NUM_SIGNALS] = {0};

struct _NoisePresetList {
	GtkComboBox parent_instance;
	NoisePresetListPrivate * priv;
	NoiseEqualizerPreset* last_selected_preset;
};

struct _NoisePresetListClass {
	GtkComboBoxClass parent_class;
	void (*list_selection_change) (NoisePresetList* self);
};

struct _NoisePresetListPrivate {
	gint _ncustompresets;
	gboolean modifying_list;
	gboolean automatic_selected;
	GtkListStore* store;
};


static gint NoisePresetList_private_offset;
static gpointer noise_preset_list_parent_class = NULL;
static gchar* noise_preset_list_AUTOMATIC_MODE;
static gchar* noise_preset_list_AUTOMATIC_MODE = NULL;
static gchar* noise_preset_list_DELETE_PRESET;
static gchar* noise_preset_list_DELETE_PRESET = NULL;

GType noise_preset_list_get_type (void) G_GNUC_CONST;
#define NOISE_PRESET_LIST_SEPARATOR_NAME "<separator_item_unique_name>"
NoisePresetList* noise_preset_list_new (void);
NoisePresetList* noise_preset_list_construct (GType object_type);
static void noise_preset_list_set_ncustompresets (NoisePresetList* self,
                                           gint value);
static gboolean __lambda20_ (NoisePresetList* self,
                      GtkTreeModel* model,
                      GtkTreeIter* iter);
static gboolean ___lambda20__gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                                        GtkTreeIter* iter,
                                                        gpointer self);
void noise_preset_list_list_selection_change (NoisePresetList* self);
static void _noise_preset_list_list_selection_change_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self);
void noise_preset_list_add_separator (NoisePresetList* self);
void noise_preset_list_add_preset (NoisePresetList* self,
                                   NoiseEqualizerPreset* ep);
static gint noise_preset_list_get_ncustompresets (NoisePresetList* self);
void noise_preset_list_remove_current_preset (NoisePresetList* self);
static void noise_preset_list_remove_separator_item (NoisePresetList* self,
                                              gint index);
void noise_preset_list_select_automatic_preset (NoisePresetList* self);
static void noise_preset_list_real_list_selection_change (NoisePresetList* self);
static void noise_preset_list_add_delete_preset_option (NoisePresetList* self);
static void noise_preset_list_remove_delete_option (NoisePresetList* self);
void noise_preset_list_select_preset (NoisePresetList* self,
                                      const gchar* preset_name);
NoiseEqualizerPreset* noise_preset_list_get_selected_preset (NoisePresetList* self);
GeeCollection* noise_preset_list_get_presets (NoisePresetList* self);
gboolean noise_preset_list_get_automatic_chosen (NoisePresetList* self);
static void noise_preset_list_finalize (GObject * obj);
static void _vala_noise_preset_list_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_noise_preset_list_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);


static inline gpointer
noise_preset_list_get_instance_private (NoisePresetList* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePresetList_private_offset);
}


static gboolean
__lambda20_ (NoisePresetList* self,
             GtkTreeModel* model,
             GtkTreeIter* iter)
{
	gboolean result = FALSE;
	gchar* content = NULL;
	gchar* _tmp0_;
	GtkTreeIter _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = g_strdup ("");
	content = _tmp0_;
	_tmp1_ = *iter;
	gtk_tree_model_get (model, &_tmp1_, 1, &content, -1);
	_tmp2_ = content;
	result = g_strcmp0 (_tmp2_, NOISE_PRESET_LIST_SEPARATOR_NAME) == 0;
	_g_free0 (content);
	return result;
}


static gboolean
___lambda20__gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                               GtkTreeIter* iter,
                                               gpointer self)
{
	gboolean result;
	result = __lambda20_ ((NoisePresetList*) self, model, iter);
	return result;
}


static void
_noise_preset_list_list_selection_change_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                gpointer self)
{
	noise_preset_list_list_selection_change ((NoisePresetList*) self);
}


NoisePresetList*
noise_preset_list_construct (GType object_type)
{
	NoisePresetList * self = NULL;
	GtkListStore* _tmp0_;
	GtkListStore* _tmp1_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp2_;
	GtkListStore* _tmp3_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_ = {0};
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_;
	const gchar* _tmp8_;
	self = (NoisePresetList*) g_object_new (object_type, NULL);
	noise_preset_list_set_ncustompresets (self, 0);
	self->priv->modifying_list = FALSE;
	self->priv->automatic_selected = FALSE;
	_tmp0_ = gtk_list_store_new (2, G_TYPE_OBJECT, G_TYPE_STRING, -1);
	_g_object_unref0 (self->priv->store);
	self->priv->store = _tmp0_;
	_tmp1_ = self->priv->store;
	gtk_combo_box_set_model ((GtkComboBox*) self, (GtkTreeModel*) _tmp1_);
	gtk_combo_box_set_id_column ((GtkComboBox*) self, 1);
	gtk_combo_box_set_row_separator_func ((GtkComboBox*) self, ___lambda20__gtk_tree_view_row_separator_func, g_object_ref (self), g_object_unref);
	_tmp2_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp2_);
	cell = _tmp2_;
	g_object_set (cell, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
	gtk_cell_layout_pack_start ((GtkCellLayout*) self, (GtkCellRenderer*) cell, TRUE);
	gtk_cell_layout_add_attribute ((GtkCellLayout*) self, (GtkCellRenderer*) cell, "text", 1);
	g_signal_connect_object ((GtkComboBox*) self, "changed", (GCallback) _noise_preset_list_list_selection_change_gtk_combo_box_changed, self, 0);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp3_ = self->priv->store;
	gtk_list_store_clear (_tmp3_);
	_tmp4_ = self->priv->store;
	gtk_list_store_append (_tmp4_, &_tmp5_);
	iter = _tmp5_;
	_tmp6_ = self->priv->store;
	_tmp7_ = iter;
	_tmp8_ = noise_preset_list_AUTOMATIC_MODE;
	gtk_list_store_set (_tmp6_, &_tmp7_, 0, NULL, 1, _tmp8_, -1);
	noise_preset_list_add_separator (self);
	_g_object_unref0 (cell);
	return self;
}


NoisePresetList*
noise_preset_list_new (void)
{
	return noise_preset_list_construct (NOISE_TYPE_PRESET_LIST);
}


void
noise_preset_list_add_separator (NoisePresetList* self)
{
	GtkTreeIter iter = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->store;
	gtk_list_store_append (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	_tmp2_ = self->priv->store;
	_tmp3_ = iter;
	gtk_list_store_set (_tmp2_, &_tmp3_, 0, NULL, 1, NOISE_PRESET_LIST_SEPARATOR_NAME, -1);
}


void
noise_preset_list_add_preset (NoisePresetList* self,
                              NoiseEqualizerPreset* ep)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_ = {0};
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GtkTreeIter _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ep != NULL);
	self->priv->modifying_list = TRUE;
	_tmp0_ = noise_equalizer_preset_get_is_default (ep);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		gint _tmp2_;
		gint _tmp3_;
		_tmp2_ = self->priv->_ncustompresets;
		if (_tmp2_ < 1) {
			noise_preset_list_add_separator (self);
		}
		_tmp3_ = self->priv->_ncustompresets;
		noise_preset_list_set_ncustompresets (self, _tmp3_ + 1);
	}
	_tmp4_ = self->priv->store;
	gtk_list_store_append (_tmp4_, &_tmp5_);
	iter = _tmp5_;
	_tmp6_ = self->priv->store;
	_tmp7_ = iter;
	_tmp8_ = noise_equalizer_preset_get_name (ep);
	_tmp9_ = _tmp8_;
	gtk_list_store_set (_tmp6_, &_tmp7_, 0, ep, 1, _tmp9_, -1);
	self->priv->modifying_list = FALSE;
	self->priv->automatic_selected = FALSE;
	_tmp10_ = iter;
	gtk_combo_box_set_active_iter ((GtkComboBox*) self, &_tmp10_);
}


void
noise_preset_list_remove_current_preset (NoisePresetList* self)
{
	GtkTreeIter iter = {0};
	gint _tmp22_;
	g_return_if_fail (self != NULL);
	self->priv->modifying_list = TRUE;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GtkListStore* _tmp2_;
				gint _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GtkTreeIter _tmp6_ = {0};
				gboolean _tmp7_;
				gboolean _tmp8_;
				GObject* o = NULL;
				GtkListStore* _tmp9_;
				GtkTreeIter _tmp10_;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				GObject* _tmp13_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->store;
				_tmp3_ = i;
				_tmp4_ = g_strdup_printf ("%i", _tmp3_);
				_tmp5_ = _tmp4_;
				_tmp7_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp2_, &_tmp6_, _tmp5_);
				iter = _tmp6_;
				_tmp8_ = !_tmp7_;
				_g_free0 (_tmp5_);
				if (_tmp8_) {
					break;
				}
				_tmp9_ = self->priv->store;
				_tmp10_ = iter;
				gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 0, &o, -1);
				_tmp13_ = o;
				if (_tmp13_ != NULL) {
					GObject* _tmp14_;
					_tmp14_ = o;
					_tmp12_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, NOISE_TYPE_EQUALIZER_PRESET);
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					GObject* _tmp15_;
					NoiseEqualizerPreset* _tmp16_;
					_tmp15_ = o;
					_tmp16_ = self->last_selected_preset;
					_tmp11_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, NOISE_TYPE_EQUALIZER_PRESET, NoiseEqualizerPreset) == _tmp16_;
				} else {
					_tmp11_ = FALSE;
				}
				if (_tmp11_) {
					GObject* _tmp17_;
					gboolean _tmp18_;
					gboolean _tmp19_;
					_tmp17_ = o;
					_tmp18_ = noise_equalizer_preset_get_is_default (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, NOISE_TYPE_EQUALIZER_PRESET, NoiseEqualizerPreset));
					_tmp19_ = _tmp18_;
					if (!_tmp19_) {
						gint _tmp20_;
						GtkListStore* _tmp21_;
						_tmp20_ = self->priv->_ncustompresets;
						noise_preset_list_set_ncustompresets (self, _tmp20_ - 1);
						_tmp21_ = self->priv->store;
						gtk_list_store_remove (_tmp21_, &iter);
						_g_object_unref0 (o);
						break;
					}
				}
				_g_object_unref0 (o);
			}
		}
	}
	_tmp22_ = self->priv->_ncustompresets;
	if (_tmp22_ < 1) {
		noise_preset_list_remove_separator_item (self, -1);
	}
	self->priv->modifying_list = FALSE;
	noise_preset_list_select_automatic_preset (self);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
noise_preset_list_real_list_selection_change (NoisePresetList* self)
{
	gboolean _tmp0_;
	GtkTreeIter it = {0};
	GtkTreeIter _tmp1_ = {0};
	GObject* o = NULL;
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
	gboolean _tmp4_ = FALSE;
	GObject* _tmp5_;
	gchar* option = NULL;
	GtkListStore* _tmp13_;
	GtkTreeIter _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	_tmp0_ = self->priv->modifying_list;
	if (_tmp0_) {
		return;
	}
	gtk_combo_box_get_active_iter ((GtkComboBox*) self, &_tmp1_);
	it = _tmp1_;
	_tmp2_ = self->priv->store;
	_tmp3_ = it;
	gtk_tree_model_get ((GtkTreeModel*) _tmp2_, &_tmp3_, 0, &o, -1);
	_tmp5_ = o;
	if (_tmp5_ != NULL) {
		GObject* _tmp6_;
		_tmp6_ = o;
		_tmp4_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, NOISE_TYPE_EQUALIZER_PRESET);
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		GObject* _tmp7_;
		NoiseEqualizerPreset* _tmp8_;
		GObject* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
		GObject* _tmp12_;
		_tmp7_ = o;
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp7_) : NULL);
		_g_object_unref0 (self->last_selected_preset);
		self->last_selected_preset = _tmp8_;
		_tmp9_ = o;
		_tmp10_ = noise_equalizer_preset_get_is_default (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp9_) : NULL);
		_tmp11_ = _tmp10_;
		if (!_tmp11_) {
			noise_preset_list_add_delete_preset_option (self);
		} else {
			noise_preset_list_remove_delete_option (self);
		}
		self->priv->automatic_selected = FALSE;
		_tmp12_ = o;
		g_signal_emit (self, noise_preset_list_signals[NOISE_PRESET_LIST_PRESET_SELECTED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp12_) : NULL);
		_g_object_unref0 (o);
		return;
	}
	_tmp13_ = self->priv->store;
	_tmp14_ = it;
	gtk_tree_model_get ((GtkTreeModel*) _tmp13_, &_tmp14_, 1, &option, -1);
	_tmp15_ = option;
	_tmp16_ = noise_preset_list_AUTOMATIC_MODE;
	if (g_strcmp0 (_tmp15_, _tmp16_) == 0) {
		self->priv->automatic_selected = TRUE;
		noise_preset_list_remove_delete_option (self);
		g_signal_emit (self, noise_preset_list_signals[NOISE_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL], 0);
	} else {
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		_tmp17_ = option;
		_tmp18_ = noise_preset_list_DELETE_PRESET;
		if (g_strcmp0 (_tmp17_, _tmp18_) == 0) {
			g_signal_emit (self, noise_preset_list_signals[NOISE_PRESET_LIST_DELETE_PRESET_CHOSEN_SIGNAL], 0);
		}
	}
	_g_free0 (option);
	_g_object_unref0 (o);
}


void
noise_preset_list_list_selection_change (NoisePresetList* self)
{
	g_return_if_fail (self != NULL);
	NOISE_PRESET_LIST_GET_CLASS (self)->list_selection_change (self);
}


void
noise_preset_list_select_automatic_preset (NoisePresetList* self)
{
	g_return_if_fail (self != NULL);
	self->priv->automatic_selected = TRUE;
	g_signal_emit (self, noise_preset_list_signals[NOISE_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL], 0);
	gtk_combo_box_set_active ((GtkComboBox*) self, 0);
}


void
noise_preset_list_select_preset (NoisePresetList* self,
                                 const gchar* preset_name)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (preset_name == NULL) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (preset_name);
		_tmp2_ = _tmp1_;
		_tmp0_ = _tmp2_ < 1;
	}
	if (!_tmp0_) {
		GtkTreeIter iter = {0};
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = TRUE;
				while (TRUE) {
					GtkListStore* _tmp5_;
					gint _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
					GtkTreeIter _tmp9_ = {0};
					gboolean _tmp10_;
					gboolean _tmp11_;
					GObject* o = NULL;
					GtkListStore* _tmp12_;
					GtkTreeIter _tmp13_;
					gboolean _tmp14_ = FALSE;
					gboolean _tmp15_ = FALSE;
					GObject* _tmp16_;
					if (!_tmp3_) {
						gint _tmp4_;
						_tmp4_ = i;
						i = _tmp4_ + 1;
					}
					_tmp3_ = FALSE;
					_tmp5_ = self->priv->store;
					_tmp6_ = i;
					_tmp7_ = g_strdup_printf ("%i", _tmp6_);
					_tmp8_ = _tmp7_;
					_tmp10_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp5_, &_tmp9_, _tmp8_);
					iter = _tmp9_;
					_tmp11_ = !_tmp10_;
					_g_free0 (_tmp8_);
					if (_tmp11_) {
						break;
					}
					_tmp12_ = self->priv->store;
					_tmp13_ = iter;
					gtk_tree_model_get ((GtkTreeModel*) _tmp12_, &_tmp13_, 0, &o, -1);
					_tmp16_ = o;
					if (_tmp16_ != NULL) {
						GObject* _tmp17_;
						_tmp17_ = o;
						_tmp15_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, NOISE_TYPE_EQUALIZER_PRESET);
					} else {
						_tmp15_ = FALSE;
					}
					if (_tmp15_) {
						GObject* _tmp18_;
						const gchar* _tmp19_;
						const gchar* _tmp20_;
						_tmp18_ = o;
						_tmp19_ = noise_equalizer_preset_get_name (G_TYPE_CHECK_INSTANCE_TYPE (_tmp18_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp18_) : NULL);
						_tmp20_ = _tmp19_;
						_tmp14_ = g_strcmp0 (_tmp20_, preset_name) == 0;
					} else {
						_tmp14_ = FALSE;
					}
					if (_tmp14_) {
						GtkTreeIter _tmp21_;
						GObject* _tmp22_;
						_tmp21_ = iter;
						gtk_combo_box_set_active_iter ((GtkComboBox*) self, &_tmp21_);
						self->priv->automatic_selected = FALSE;
						_tmp22_ = o;
						g_signal_emit (self, noise_preset_list_signals[NOISE_PRESET_LIST_PRESET_SELECTED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_TYPE (_tmp22_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp22_) : NULL);
						_g_object_unref0 (o);
						return;
					}
					_g_object_unref0 (o);
				}
			}
		}
	}
	noise_preset_list_select_automatic_preset (self);
}


NoiseEqualizerPreset*
noise_preset_list_get_selected_preset (NoisePresetList* self)
{
	NoiseEqualizerPreset* result = NULL;
	GtkTreeIter it = {0};
	GtkTreeIter _tmp0_ = {0};
	GObject* o = NULL;
	GtkListStore* _tmp1_;
	GtkTreeIter _tmp2_;
	gboolean _tmp3_ = FALSE;
	GObject* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	gtk_combo_box_get_active_iter ((GtkComboBox*) self, &_tmp0_);
	it = _tmp0_;
	_tmp1_ = self->priv->store;
	_tmp2_ = it;
	gtk_tree_model_get ((GtkTreeModel*) _tmp1_, &_tmp2_, 0, &o, -1);
	_tmp4_ = o;
	if (_tmp4_ != NULL) {
		GObject* _tmp5_;
		_tmp5_ = o;
		_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, NOISE_TYPE_EQUALIZER_PRESET);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		GObject* _tmp6_;
		NoiseEqualizerPreset* _tmp7_;
		_tmp6_ = o;
		_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp6_) : NULL);
		result = _tmp7_;
		_g_object_unref0 (o);
		return result;
	} else {
		result = NULL;
		_g_object_unref0 (o);
		return result;
	}
	_g_object_unref0 (o);
}


GeeCollection*
noise_preset_list_get_presets (NoisePresetList* self)
{
	GeeCollection* result = NULL;
	GeeLinkedList* rv = NULL;
	GeeLinkedList* _tmp0_;
	GtkTreeIter iter = {0};
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_EQUALIZER_PRESET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	rv = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				GtkListStore* _tmp3_;
				gint _tmp4_;
				gchar* _tmp5_;
				gchar* _tmp6_;
				GtkTreeIter _tmp7_ = {0};
				gboolean _tmp8_;
				gboolean _tmp9_;
				GObject* o = NULL;
				GtkListStore* _tmp10_;
				GtkTreeIter _tmp11_;
				gboolean _tmp12_ = FALSE;
				GObject* _tmp13_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = self->priv->store;
				_tmp4_ = i;
				_tmp5_ = g_strdup_printf ("%i", _tmp4_);
				_tmp6_ = _tmp5_;
				_tmp8_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp3_, &_tmp7_, _tmp6_);
				iter = _tmp7_;
				_tmp9_ = !_tmp8_;
				_g_free0 (_tmp6_);
				if (_tmp9_) {
					break;
				}
				_tmp10_ = self->priv->store;
				_tmp11_ = iter;
				gtk_tree_model_get ((GtkTreeModel*) _tmp10_, &_tmp11_, 0, &o, -1);
				_tmp13_ = o;
				if (_tmp13_ != NULL) {
					GObject* _tmp14_;
					_tmp14_ = o;
					_tmp12_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, NOISE_TYPE_EQUALIZER_PRESET);
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					GeeLinkedList* _tmp15_;
					GObject* _tmp16_;
					_tmp15_ = rv;
					_tmp16_ = o;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp16_) : NULL);
				}
				_g_object_unref0 (o);
			}
		}
	}
	result = (GeeCollection*) rv;
	return result;
}


static void
noise_preset_list_remove_delete_option (NoisePresetList* self)
{
	GtkTreeIter iter = {0};
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GtkListStore* _tmp2_;
				gint _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GtkTreeIter _tmp6_ = {0};
				gboolean _tmp7_;
				gboolean _tmp8_;
				gchar* text = NULL;
				GtkListStore* _tmp9_;
				GtkTreeIter _tmp10_;
				gboolean _tmp11_ = FALSE;
				const gchar* _tmp12_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->store;
				_tmp3_ = i;
				_tmp4_ = g_strdup_printf ("%i", _tmp3_);
				_tmp5_ = _tmp4_;
				_tmp7_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp2_, &_tmp6_, _tmp5_);
				iter = _tmp6_;
				_tmp8_ = !_tmp7_;
				_g_free0 (_tmp5_);
				if (_tmp8_) {
					break;
				}
				_tmp9_ = self->priv->store;
				_tmp10_ = iter;
				gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 1, &text, -1);
				_tmp12_ = text;
				if (_tmp12_ != NULL) {
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					_tmp13_ = text;
					_tmp14_ = noise_preset_list_DELETE_PRESET;
					_tmp11_ = g_strcmp0 (_tmp13_, _tmp14_) == 0;
				} else {
					_tmp11_ = FALSE;
				}
				if (_tmp11_) {
					GtkListStore* _tmp15_;
					_tmp15_ = self->priv->store;
					gtk_list_store_remove (_tmp15_, &iter);
					noise_preset_list_remove_separator_item (self, 1);
				}
				_g_free0 (text);
			}
		}
	}
}


static void
noise_preset_list_remove_separator_item (NoisePresetList* self,
                                         gint index)
{
	gint count = 0;
	gint nitems = 0;
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
	g_return_if_fail (self != NULL);
	count = 0;
	_tmp0_ = self->priv->store;
	nitems = gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp0_, NULL);
	{
		gint i = 0;
		gint _tmp1_;
		_tmp1_ = nitems;
		i = _tmp1_ - 1;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				GtkListStore* _tmp4_;
				gint _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				GtkTreeIter _tmp8_ = {0};
				gboolean _tmp9_;
				gboolean _tmp10_;
				gint _tmp11_;
				gchar* text = NULL;
				GtkListStore* _tmp12_;
				GtkTreeIter _tmp13_;
				gboolean _tmp14_ = FALSE;
				gboolean _tmp15_ = FALSE;
				gboolean _tmp16_ = FALSE;
				gint _tmp17_;
				gint _tmp18_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ - 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = self->priv->store;
				_tmp5_ = i;
				_tmp6_ = g_strdup_printf ("%i", _tmp5_);
				_tmp7_ = _tmp6_;
				_tmp9_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp4_, &_tmp8_, _tmp7_);
				iter = _tmp8_;
				_tmp10_ = !_tmp9_;
				_g_free0 (_tmp7_);
				if (_tmp10_) {
					break;
				}
				_tmp11_ = count;
				count = _tmp11_ + 1;
				_tmp12_ = self->priv->store;
				_tmp13_ = iter;
				gtk_tree_model_get ((GtkTreeModel*) _tmp12_, &_tmp13_, 1, &text, -1);
				_tmp17_ = nitems;
				_tmp18_ = count;
				if ((_tmp17_ - index) == _tmp18_) {
					_tmp16_ = TRUE;
				} else {
					_tmp16_ = index == -1;
				}
				if (_tmp16_) {
					const gchar* _tmp19_;
					_tmp19_ = text;
					_tmp15_ = _tmp19_ != NULL;
				} else {
					_tmp15_ = FALSE;
				}
				if (_tmp15_) {
					const gchar* _tmp20_;
					_tmp20_ = text;
					_tmp14_ = g_strcmp0 (_tmp20_, NOISE_PRESET_LIST_SEPARATOR_NAME) == 0;
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					GtkListStore* _tmp21_;
					_tmp21_ = self->priv->store;
					gtk_list_store_remove (_tmp21_, &iter);
					_g_free0 (text);
					break;
				}
				_g_free0 (text);
			}
		}
	}
}


static void
noise_preset_list_add_delete_preset_option (NoisePresetList* self)
{
	gboolean already_added = FALSE;
	GtkTreeIter last_iter = {0};
	GtkTreeIter new_iter = {0};
	gboolean _tmp21_;
	GtkListStore* _tmp22_;
	GtkTreeIter _tmp23_;
	GtkTreeIter _tmp24_ = {0};
	GtkListStore* _tmp25_;
	GtkTreeIter _tmp26_;
	const gchar* _tmp27_;
	GtkTreeIter _tmp28_;
	GtkListStore* _tmp29_;
	GtkTreeIter _tmp30_;
	GtkTreeIter _tmp31_ = {0};
	GtkListStore* _tmp32_;
	GtkTreeIter _tmp33_;
	g_return_if_fail (self != NULL);
	already_added = FALSE;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GtkListStore* _tmp2_;
				gint _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GtkTreeIter _tmp6_ = {0};
				gboolean _tmp7_;
				gboolean _tmp8_;
				gchar* text = NULL;
				GtkListStore* _tmp9_;
				GtkTreeIter _tmp10_;
				gboolean _tmp11_ = FALSE;
				const gchar* _tmp12_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->store;
				_tmp3_ = i;
				_tmp4_ = g_strdup_printf ("%i", _tmp3_);
				_tmp5_ = _tmp4_;
				_tmp7_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp2_, &_tmp6_, _tmp5_);
				last_iter = _tmp6_;
				_tmp8_ = !_tmp7_;
				_g_free0 (_tmp5_);
				if (_tmp8_) {
					break;
				}
				_tmp9_ = self->priv->store;
				_tmp10_ = last_iter;
				gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 1, &text, -1);
				_tmp12_ = text;
				if (_tmp12_ != NULL) {
					const gchar* _tmp13_;
					_tmp13_ = text;
					_tmp11_ = g_strcmp0 (_tmp13_, NOISE_PRESET_LIST_SEPARATOR_NAME) == 0;
				} else {
					_tmp11_ = FALSE;
				}
				if (_tmp11_) {
					GtkTreeIter _tmp14_;
					GtkListStore* _tmp15_;
					gboolean _tmp16_;
					_tmp14_ = last_iter;
					new_iter = _tmp14_;
					_tmp15_ = self->priv->store;
					_tmp16_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp15_, &new_iter);
					if (_tmp16_) {
						GtkListStore* _tmp17_;
						GtkTreeIter _tmp18_;
						const gchar* _tmp19_;
						const gchar* _tmp20_;
						_tmp17_ = self->priv->store;
						_tmp18_ = new_iter;
						gtk_tree_model_get ((GtkTreeModel*) _tmp17_, &_tmp18_, 1, &text, -1);
						_tmp19_ = text;
						_tmp20_ = noise_preset_list_DELETE_PRESET;
						already_added = g_strcmp0 (_tmp19_, _tmp20_) == 0;
					}
					_g_free0 (text);
					break;
				}
				_g_free0 (text);
			}
		}
	}
	_tmp21_ = already_added;
	if (_tmp21_) {
		return;
	}
	_tmp22_ = self->priv->store;
	_tmp23_ = last_iter;
	gtk_list_store_insert_after (_tmp22_, &_tmp24_, &_tmp23_);
	new_iter = _tmp24_;
	_tmp25_ = self->priv->store;
	_tmp26_ = new_iter;
	_tmp27_ = noise_preset_list_DELETE_PRESET;
	gtk_list_store_set (_tmp25_, &_tmp26_, 0, NULL, 1, _tmp27_, -1);
	_tmp28_ = new_iter;
	last_iter = _tmp28_;
	_tmp29_ = self->priv->store;
	_tmp30_ = last_iter;
	gtk_list_store_insert_after (_tmp29_, &_tmp31_, &_tmp30_);
	new_iter = _tmp31_;
	_tmp32_ = self->priv->store;
	_tmp33_ = new_iter;
	gtk_list_store_set (_tmp32_, &_tmp33_, 0, NULL, 1, NOISE_PRESET_LIST_SEPARATOR_NAME, -1);
}


gboolean
noise_preset_list_get_automatic_chosen (NoisePresetList* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->automatic_selected;
	result = _tmp0_;
	return result;
}


static gint
noise_preset_list_get_ncustompresets (NoisePresetList* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_ncustompresets;
	result = _tmp0_;
	return result;
}


static void
noise_preset_list_set_ncustompresets (NoisePresetList* self,
                                      gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_ncustompresets = value;
}


static void
noise_preset_list_class_init (NoisePresetListClass * klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	noise_preset_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoisePresetList_private_offset);
	((NoisePresetListClass *) klass)->list_selection_change = (void (*) (NoisePresetList *)) noise_preset_list_real_list_selection_change;
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_preset_list_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_preset_list_set_property;
	G_OBJECT_CLASS (klass)->finalize = noise_preset_list_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY, noise_preset_list_properties[NOISE_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY] = g_param_spec_boolean ("automatic-chosen", "automatic-chosen", "automatic-chosen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	noise_preset_list_signals[NOISE_PRESET_LIST_PRESET_SELECTED_SIGNAL] = g_signal_new ("preset-selected", NOISE_TYPE_PRESET_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_EQUALIZER_PRESET);
	noise_preset_list_signals[NOISE_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL] = g_signal_new ("automatic-preset-chosen", NOISE_TYPE_PRESET_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	noise_preset_list_signals[NOISE_PRESET_LIST_DELETE_PRESET_CHOSEN_SIGNAL] = g_signal_new ("delete-preset-chosen", NOISE_TYPE_PRESET_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	_tmp0_ = g_strdup (_ ("Automatic"));
	noise_preset_list_AUTOMATIC_MODE = _tmp0_;
	_tmp1_ = g_strdup (_ ("Delete Current"));
	noise_preset_list_DELETE_PRESET = _tmp1_;
}


static void
noise_preset_list_instance_init (NoisePresetList * self)
{
	self->priv = noise_preset_list_get_instance_private (self);
}


static void
noise_preset_list_finalize (GObject * obj)
{
	NoisePresetList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PRESET_LIST, NoisePresetList);
	_g_object_unref0 (self->last_selected_preset);
	_g_object_unref0 (self->priv->store);
	G_OBJECT_CLASS (noise_preset_list_parent_class)->finalize (obj);
}


GType
noise_preset_list_get_type (void)
{
	static volatile gsize noise_preset_list_type_id__volatile = 0;
	if (g_once_init_enter (&noise_preset_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePresetListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_preset_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePresetList), 0, (GInstanceInitFunc) noise_preset_list_instance_init, NULL };
		GType noise_preset_list_type_id;
		noise_preset_list_type_id = g_type_register_static (gtk_combo_box_get_type (), "NoisePresetList", &g_define_type_info, 0);
		NoisePresetList_private_offset = g_type_add_instance_private (noise_preset_list_type_id, sizeof (NoisePresetListPrivate));
		g_once_init_leave (&noise_preset_list_type_id__volatile, noise_preset_list_type_id);
	}
	return noise_preset_list_type_id__volatile;
}


static void
_vala_noise_preset_list_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	NoisePresetList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PRESET_LIST, NoisePresetList);
	switch (property_id) {
		case NOISE_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY:
		g_value_set_boolean (value, noise_preset_list_get_automatic_chosen (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_preset_list_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	NoisePresetList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PRESET_LIST, NoisePresetList);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



