/* SourceListView.c generated by valac 0.41.91, the Vala compiler
 * generated from SourceListView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/* Add an interface so that SourceListItem and SourceListExpandableItem still share a common*/
/* ancestor that is compatible with the SourceList widget.*/


#include <glib.h>
#include <glib-object.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include "io.elementary.music-core.h"
#include <gee.h>


#define NOISE_TYPE_SOURCE_LIST_ENTRY (noise_source_list_entry_get_type ())
#define NOISE_SOURCE_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SOURCE_LIST_ENTRY, NoiseSourceListEntry))
#define NOISE_IS_SOURCE_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SOURCE_LIST_ENTRY))
#define NOISE_SOURCE_LIST_ENTRY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NOISE_TYPE_SOURCE_LIST_ENTRY, NoiseSourceListEntryIface))

typedef struct _NoiseSourceListEntry NoiseSourceListEntry;
typedef struct _NoiseSourceListEntryIface NoiseSourceListEntryIface;

#define NOISE_TYPE_SOURCE_LIST_ITEM (noise_source_list_item_get_type ())
#define NOISE_SOURCE_LIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem))
#define NOISE_SOURCE_LIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItemClass))
#define NOISE_IS_SOURCE_LIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SOURCE_LIST_ITEM))
#define NOISE_IS_SOURCE_LIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SOURCE_LIST_ITEM))
#define NOISE_SOURCE_LIST_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItemClass))

typedef struct _NoiseSourceListItem NoiseSourceListItem;
typedef struct _NoiseSourceListItemClass NoiseSourceListItemClass;
typedef struct _NoiseSourceListItemPrivate NoiseSourceListItemPrivate;

#define NOISE_VIEW_WRAPPER_TYPE_HINT (noise_view_wrapper_hint_get_type ())
enum  {
	NOISE_SOURCE_LIST_ITEM_0_PROPERTY,
	NOISE_SOURCE_LIST_ITEM_VIEW_PROPERTY,
	NOISE_SOURCE_LIST_ITEM_HINT_PROPERTY,
	NOISE_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY,
	NOISE_SOURCE_LIST_ITEM_NUM_PROPERTIES
};
static GParamSpec* noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_EDIT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_SAVE_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_MEDIA_ADDED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_NUM_SIGNALS
};
static guint noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_NUM_SIGNALS] = {0};

#define NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM (noise_source_list_expandable_item_get_type ())
#define NOISE_SOURCE_LIST_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem))
#define NOISE_SOURCE_LIST_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItemClass))
#define NOISE_IS_SOURCE_LIST_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM))
#define NOISE_IS_SOURCE_LIST_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM))
#define NOISE_SOURCE_LIST_EXPANDABLE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItemClass))

typedef struct _NoiseSourceListExpandableItem NoiseSourceListExpandableItem;
typedef struct _NoiseSourceListExpandableItemClass NoiseSourceListExpandableItemClass;
typedef struct _NoiseSourceListExpandableItemPrivate NoiseSourceListExpandableItemPrivate;
enum  {
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_0_PROPERTY,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_NUM_PROPERTIES
};
static GParamSpec* noise_source_list_expandable_item_properties[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_NUM_PROPERTIES];
typedef struct _Block30Data Block30Data;
enum  {
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_IMPORT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_EJECT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_SYNC_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_NUM_SIGNALS
};
static guint noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_NUM_SIGNALS] = {0};

#define NOISE_TYPE_PLAY_LIST_CATEGORY (noise_play_list_category_get_type ())
#define NOISE_PLAY_LIST_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAY_LIST_CATEGORY, NoisePlayListCategory))
#define NOISE_PLAY_LIST_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAY_LIST_CATEGORY, NoisePlayListCategoryClass))
#define NOISE_IS_PLAY_LIST_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAY_LIST_CATEGORY))
#define NOISE_IS_PLAY_LIST_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAY_LIST_CATEGORY))
#define NOISE_PLAY_LIST_CATEGORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAY_LIST_CATEGORY, NoisePlayListCategoryClass))

typedef struct _NoisePlayListCategory NoisePlayListCategory;
typedef struct _NoisePlayListCategoryClass NoisePlayListCategoryClass;
typedef struct _NoisePlayListCategoryPrivate NoisePlayListCategoryPrivate;
enum  {
	NOISE_PLAY_LIST_CATEGORY_0_PROPERTY,
	NOISE_PLAY_LIST_CATEGORY_NUM_PROPERTIES
};
static GParamSpec* noise_play_list_category_properties[NOISE_PLAY_LIST_CATEGORY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;

#define NOISE_TYPE_LOCAL_LIBRARY (noise_local_library_get_type ())
#define NOISE_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibrary))
#define NOISE_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibraryClass))
#define NOISE_IS_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LOCAL_LIBRARY))
#define NOISE_IS_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LOCAL_LIBRARY))
#define NOISE_LOCAL_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibraryClass))

typedef struct _NoiseLocalLibrary NoiseLocalLibrary;
typedef struct _NoiseLocalLibraryClass NoiseLocalLibraryClass;
enum  {
	NOISE_PLAY_LIST_CATEGORY_PLAYLIST_IMPORT_CLICKED_SIGNAL,
	NOISE_PLAY_LIST_CATEGORY_NUM_SIGNALS
};
static guint noise_play_list_category_signals[NOISE_PLAY_LIST_CATEGORY_NUM_SIGNALS] = {0};

#define NOISE_TYPE_SOURCE_LIST_ROOT (noise_source_list_root_get_type ())
#define NOISE_SOURCE_LIST_ROOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SOURCE_LIST_ROOT, NoiseSourceListRoot))
#define NOISE_SOURCE_LIST_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SOURCE_LIST_ROOT, NoiseSourceListRootClass))
#define NOISE_IS_SOURCE_LIST_ROOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SOURCE_LIST_ROOT))
#define NOISE_IS_SOURCE_LIST_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SOURCE_LIST_ROOT))
#define NOISE_SOURCE_LIST_ROOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SOURCE_LIST_ROOT, NoiseSourceListRootClass))

typedef struct _NoiseSourceListRoot NoiseSourceListRoot;
typedef struct _NoiseSourceListRootClass NoiseSourceListRootClass;
typedef struct _NoiseSourceListRootPrivate NoiseSourceListRootPrivate;
enum  {
	NOISE_SOURCE_LIST_ROOT_0_PROPERTY,
	NOISE_SOURCE_LIST_ROOT_NUM_PROPERTIES
};
static GParamSpec* noise_source_list_root_properties[NOISE_SOURCE_LIST_ROOT_NUM_PROPERTIES];

#define NOISE_TYPE_SOURCE_LIST_VIEW (noise_source_list_view_get_type ())
#define NOISE_SOURCE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SOURCE_LIST_VIEW, NoiseSourceListView))
#define NOISE_SOURCE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SOURCE_LIST_VIEW, NoiseSourceListViewClass))
#define NOISE_IS_SOURCE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SOURCE_LIST_VIEW))
#define NOISE_IS_SOURCE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SOURCE_LIST_VIEW))
#define NOISE_SOURCE_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SOURCE_LIST_VIEW, NoiseSourceListViewClass))

typedef struct _NoiseSourceListView NoiseSourceListView;
typedef struct _NoiseSourceListViewClass NoiseSourceListViewClass;
typedef struct _NoiseSourceListViewPrivate NoiseSourceListViewPrivate;
enum  {
	NOISE_SOURCE_LIST_VIEW_0_PROPERTY,
	NOISE_SOURCE_LIST_VIEW_NUM_PROPERTIES
};
static GParamSpec* noise_source_list_view_properties[NOISE_SOURCE_LIST_VIEW_NUM_PROPERTIES];
typedef struct _Block31Data Block31Data;

#define NOISE_TYPE_VIEW_WRAPPER (noise_view_wrapper_get_type ())
#define NOISE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper))
#define NOISE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))
#define NOISE_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))

typedef struct _NoiseViewWrapper NoiseViewWrapper;
typedef struct _NoiseViewWrapperClass NoiseViewWrapperClass;

#define NOISE_TYPE_DEVICE_VIEW (noise_device_view_get_type ())
#define NOISE_DEVICE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE_VIEW, NoiseDeviceView))
#define NOISE_DEVICE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_DEVICE_VIEW, NoiseDeviceViewClass))
#define NOISE_IS_DEVICE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE_VIEW))
#define NOISE_IS_DEVICE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_DEVICE_VIEW))
#define NOISE_DEVICE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_DEVICE_VIEW, NoiseDeviceViewClass))

typedef struct _NoiseDeviceView NoiseDeviceView;
typedef struct _NoiseDeviceViewClass NoiseDeviceViewClass;
enum  {
	NOISE_SOURCE_LIST_VIEW_EDITED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_ITEM_ACTION_ACTIVATED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_ACTIVATED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_RENAME_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_EDIT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_REMOVE_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_SAVE_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_EXPORT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_IMPORT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_MEDIA_ADDED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_DEVICE_IMPORT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_DEVICE_EJECT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_DEVICE_SYNC_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_NUM_SIGNALS
};
static guint noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_NUM_SIGNALS] = {0};

struct _NoiseSourceListEntryIface {
	GTypeInterface parent_iface;
};

struct _NoiseSourceListItem {
	GraniteWidgetsSourceListItem parent_instance;
	NoiseSourceListItemPrivate * priv;
};

struct _NoiseSourceListItemClass {
	GraniteWidgetsSourceListItemClass parent_class;
};

typedef enum  {
	NOISE_VIEW_WRAPPER_HINT_NONE,
	NOISE_VIEW_WRAPPER_HINT_MUSIC,
	NOISE_VIEW_WRAPPER_HINT_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_CDROM,
	NOISE_VIEW_WRAPPER_HINT_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST,
	NOISE_VIEW_WRAPPER_HINT_QUEUE
} NoiseViewWrapperHint;

struct _NoiseSourceListItemPrivate {
	GtkGrid* _view;
	NoiseViewWrapperHint _hint;
	GIcon* _activatable_icon;
	GtkMenu* playlist_menu;
};

struct _NoiseSourceListExpandableItem {
	GraniteWidgetsSourceListExpandableItem parent_instance;
	NoiseSourceListExpandableItemPrivate * priv;
	NoiseViewWrapperHint hint;
};

struct _NoiseSourceListExpandableItemClass {
	GraniteWidgetsSourceListExpandableItemClass parent_class;
};

struct _NoiseSourceListExpandableItemPrivate {
	GtkGrid* _view;
	GtkMenu* device_menu;
};

struct _Block30Data {
	int _ref_count_;
	NoiseSourceListExpandableItem* self;
	GtkGrid* view;
};

struct _NoisePlayListCategory {
	GraniteWidgetsSourceListExpandableItem parent_instance;
	NoisePlayListCategoryPrivate * priv;
};

struct _NoisePlayListCategoryClass {
	GraniteWidgetsSourceListExpandableItemClass parent_class;
};

struct _NoisePlayListCategoryPrivate {
	GtkMenu* playlist_menu;
};

struct _NoiseSourceListRoot {
	GraniteWidgetsSourceListExpandableItem parent_instance;
	NoiseSourceListRootPrivate * priv;
};

struct _NoiseSourceListRootClass {
	GraniteWidgetsSourceListExpandableItemClass parent_class;
};

struct _NoiseSourceListView {
	GraniteWidgetsSourceList parent_instance;
	NoiseSourceListViewPrivate * priv;
};

struct _NoiseSourceListViewClass {
	GraniteWidgetsSourceListClass parent_class;
};

struct _NoiseSourceListViewPrivate {
	GraniteWidgetsSourceListExpandableItem* library_category;
	GraniteWidgetsSourceListExpandableItem* devices_category;
	GraniteWidgetsSourceListExpandableItem* network_category;
	NoisePlayListCategory* playlists_category;
};

struct _Block31Data {
	int _ref_count_;
	NoiseSourceListView* self;
	NoiseSourceListItem* sourcelist_item;
	NoiseSourceListExpandableItem* expandable_item;
};


static gint NoiseSourceListItem_private_offset;
static gpointer noise_source_list_item_parent_class = NULL;
static NoiseSourceListEntryIface * noise_source_list_item_noise_source_list_entry_parent_iface = NULL;
static GraniteWidgetsSourceListDragDestIface * noise_source_list_item_granite_widgets_source_list_drag_dest_parent_iface = NULL;
static gint NoiseSourceListExpandableItem_private_offset;
static gpointer noise_source_list_expandable_item_parent_class = NULL;
static NoiseSourceListEntryIface * noise_source_list_expandable_item_noise_source_list_entry_parent_iface = NULL;
static gint NoisePlayListCategory_private_offset;
static gpointer noise_play_list_category_parent_class = NULL;
static GraniteWidgetsSourceListSortableIface * noise_play_list_category_granite_widgets_source_list_sortable_parent_iface = NULL;
static gpointer noise_source_list_root_parent_class = NULL;
static GraniteWidgetsSourceListSortableIface * noise_source_list_root_granite_widgets_source_list_sortable_parent_iface = NULL;
static gint NoiseSourceListView_private_offset;
static gpointer noise_source_list_view_parent_class = NULL;

GType noise_source_list_entry_get_type (void) G_GNUC_CONST;
GType noise_source_list_item_get_type (void) G_GNUC_CONST;
GType noise_view_wrapper_hint_get_type (void) G_GNUC_CONST;
NoiseSourceListItem* noise_source_list_item_new (GtkGrid* view,
                                                 const gchar* name,
                                                 NoiseViewWrapperHint hint,
                                                 GIcon* icon,
                                                 GIcon* activatable_icon);
NoiseSourceListItem* noise_source_list_item_construct (GType object_type,
                                                       GtkGrid* view,
                                                       const gchar* name,
                                                       NoiseViewWrapperHint hint,
                                                       GIcon* icon,
                                                       GIcon* activatable_icon);
static GtkMenu* noise_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* base);
static gboolean noise_source_list_item_real_data_drop_possible (GraniteWidgetsSourceListDragDest* base,
                                                         GdkDragContext* context,
                                                         GtkSelectionData* data);
NoiseViewWrapperHint noise_source_list_item_get_hint (NoiseSourceListItem* self);
static GdkDragAction noise_source_list_item_real_data_received (GraniteWidgetsSourceListDragDest* base,
                                                         GdkDragContext* context,
                                                         GtkSelectionData* data);
GtkGrid* noise_source_list_item_get_view (NoiseSourceListItem* self);
static void noise_source_list_item_set_view (NoiseSourceListItem* self,
                                      GtkGrid* value);
static void noise_source_list_item_set_hint (NoiseSourceListItem* self,
                                      NoiseViewWrapperHint value);
GIcon* noise_source_list_item_get_activatable_icon (NoiseSourceListItem* self);
static void noise_source_list_item_set_activatable_icon (NoiseSourceListItem* self,
                                                  GIcon* value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data);
static GObject * noise_source_list_item_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _noise_source_list_item____lambda73_ (NoiseSourceListItem* self);
static void __noise_source_list_item____lambda73__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _noise_source_list_item____lambda74_ (NoiseSourceListItem* self);
static void __noise_source_list_item____lambda74__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _noise_source_list_item____lambda75_ (NoiseSourceListItem* self);
static void __noise_source_list_item____lambda75__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _noise_source_list_item____lambda76_ (NoiseSourceListItem* self);
static void __noise_source_list_item____lambda76__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _noise_source_list_item____lambda77_ (NoiseSourceListItem* self);
static void __noise_source_list_item____lambda77__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _noise_source_list_item____lambda78_ (NoiseSourceListItem* self);
static void __noise_source_list_item____lambda78__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _noise_source_list_item___lambda79_ (NoiseSourceListItem* self);
static void __noise_source_list_item___lambda79__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                  gpointer self);
static void noise_source_list_item_finalize (GObject * obj);
static void _vala_noise_source_list_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_noise_source_list_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
GType noise_source_list_expandable_item_get_type (void) G_GNUC_CONST;
NoiseSourceListExpandableItem* noise_source_list_expandable_item_new (GtkGrid* view,
                                                                      const gchar* name,
                                                                      NoiseViewWrapperHint hint,
                                                                      GIcon* icon,
                                                                      GIcon* activatable_icon,
                                                                      GObject* give_more_information);
NoiseSourceListExpandableItem* noise_source_list_expandable_item_construct (GType object_type,
                                                                            GtkGrid* view,
                                                                            const gchar* name,
                                                                            NoiseViewWrapperHint hint,
                                                                            GIcon* icon,
                                                                            GIcon* activatable_icon,
                                                                            GObject* give_more_information);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
void noise_source_list_expandable_item_set_view (NoiseSourceListExpandableItem* self,
                                                 GtkGrid* value);
static void ___lambda84_ (Block30Data* _data30_);
static void ____lambda84__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda85_ (Block30Data* _data30_);
static void ____lambda85__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void _____lambda86_ (Block30Data* _data30_);
static void ______lambda86__gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static void _____lambda87_ (Block30Data* _data30_);
static void ______lambda87__gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static void _____lambda88_ (Block30Data* _data30_);
static void ______lambda88__gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static GtkMenu* noise_source_list_expandable_item_real_get_context_menu (GraniteWidgetsSourceListItem* base);
GtkGrid* noise_source_list_expandable_item_get_view (NoiseSourceListExpandableItem* self);
static void noise_source_list_expandable_item_finalize (GObject * obj);
static void _vala_noise_source_list_expandable_item_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec);
static void _vala_noise_source_list_expandable_item_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec);
GType noise_play_list_category_get_type (void) G_GNUC_CONST;
NoisePlayListCategory* noise_play_list_category_new (const gchar* name);
NoisePlayListCategory* noise_play_list_category_construct (GType object_type,
                                                           const gchar* name);
static GtkMenu* noise_play_list_category_real_get_context_menu (GraniteWidgetsSourceListItem* base);
static gboolean noise_play_list_category_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base);
static gint noise_play_list_category_real_compare (GraniteWidgetsSourceListSortable* base,
                                            GraniteWidgetsSourceListItem* a,
                                            GraniteWidgetsSourceListItem* b);
static GObject * noise_play_list_category_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _noise_play_list_category___lambda80_ (NoisePlayListCategory* self);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
void noise_library_window_create_new_playlist (NoiseLibraryWindow* self,
                                               NoiseLibrary* library);
GType noise_local_library_get_type (void) G_GNUC_CONST;
NoiseLocalLibrary* noise_library_window_get_library_manager (NoiseLibraryWindow* self);
static void __noise_play_list_category___lambda80__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self);
static void _noise_play_list_category___lambda81_ (NoisePlayListCategory* self);
void noise_library_window_show_smart_playlist_dialog (NoiseLibraryWindow* self,
                                                      NoiseSmartPlaylist* smartplaylist);
static void __noise_play_list_category___lambda81__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self);
static void _noise_play_list_category___lambda82_ (NoisePlayListCategory* self);
static void __noise_play_list_category___lambda82__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self);
static void noise_play_list_category_finalize (GObject * obj);
GType noise_source_list_root_get_type (void) G_GNUC_CONST;
NoiseSourceListRoot* noise_source_list_root_new (void);
NoiseSourceListRoot* noise_source_list_root_construct (GType object_type);
static gboolean noise_source_list_root_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base);
static gint noise_source_list_root_real_compare (GraniteWidgetsSourceListSortable* base,
                                          GraniteWidgetsSourceListItem* a,
                                          GraniteWidgetsSourceListItem* b);
GType noise_source_list_view_get_type (void) G_GNUC_CONST;
NoiseSourceListView* noise_source_list_view_new (void);
NoiseSourceListView* noise_source_list_view_construct (GType object_type);
static void __lambda83_ (NoiseSourceListView* self);
static void ___lambda83__noise_play_list_category_playlist_import_clicked (NoisePlayListCategory* _sender,
                                                                    gpointer self);
void noise_source_list_view_change_playlist_category_visibility (NoiseSourceListView* self,
                                                                 gboolean visible);
NoiseSourceListEntry* noise_source_list_view_add_item (NoiseSourceListView* self,
                                                       GtkGrid* view,
                                                       const gchar* name,
                                                       NoiseViewWrapperHint hint,
                                                       GIcon* icon,
                                                       GIcon* activatable_icon,
                                                       NoiseSourceListExpandableItem* into_expandable,
                                                       GObject* give_more_information);
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
static void __lambda89_ (NoiseSourceListView* self);
static void ___lambda89__granite_widgets_source_list_item_activated (GraniteWidgetsSourceListItem* _sender,
                                                              gpointer self);
static void __lambda90_ (Block31Data* _data31_,
                  const gchar* new_name);
static void ___lambda90__granite_widgets_source_list_item_edited (GraniteWidgetsSourceListItem* _sender,
                                                           const gchar* new_name,
                                                           gpointer self);
static void __lambda91_ (Block31Data* _data31_,
                  GraniteWidgetsSourceListItem* sl);
static void ___lambda91__granite_widgets_source_list_item_action_activated (GraniteWidgetsSourceListItem* _sender,
                                                                     gpointer self);
static void __lambda92_ (NoiseSourceListView* self,
                  GtkGrid* view,
                  NoiseSourceListItem* item);
static void ___lambda92__noise_source_list_item_playlist_rename_clicked (NoiseSourceListItem* _sender,
                                                                  GtkGrid* view,
                                                                  NoiseSourceListItem* item,
                                                                  gpointer self);
static void __lambda93_ (NoiseSourceListView* self,
                  GtkGrid* view);
static void ___lambda93__noise_source_list_item_playlist_edit_clicked (NoiseSourceListItem* _sender,
                                                                GtkGrid* view,
                                                                gpointer self);
static void __lambda94_ (NoiseSourceListView* self,
                  GtkGrid* view);
static void ___lambda94__noise_source_list_item_playlist_remove_clicked (NoiseSourceListItem* _sender,
                                                                  GtkGrid* view,
                                                                  gpointer self);
static void __lambda95_ (NoiseSourceListView* self,
                  GtkGrid* view);
static void ___lambda95__noise_source_list_item_playlist_save_clicked (NoiseSourceListItem* _sender,
                                                                GtkGrid* view,
                                                                gpointer self);
static void __lambda96_ (NoiseSourceListView* self,
                  GtkGrid* view);
static void ___lambda96__noise_source_list_item_playlist_export_clicked (NoiseSourceListItem* _sender,
                                                                  GtkGrid* view,
                                                                  gpointer self);
static void __lambda97_ (NoiseSourceListView* self,
                  GtkGrid* view,
                  gchar** uris,
                  int uris_length1);
static void ___lambda97__noise_source_list_item_playlist_media_added (NoiseSourceListItem* _sender,
                                                               GtkGrid* view,
                                                               gchar** media,
                                                               int media_length1,
                                                               gpointer self);
static void __lambda98_ (Block31Data* _data31_,
                  GtkGrid* view);
static GtkGrid* noise_source_list_view_get_device_from_item (NoiseSourceListView* self,
                                                      NoiseSourceListExpandableItem* item);
static void ___lambda98__noise_source_list_expandable_item_device_import_clicked (NoiseSourceListExpandableItem* _sender,
                                                                           GtkGrid* view,
                                                                           gpointer self);
static void __lambda99_ (NoiseSourceListView* self,
                  GtkGrid* view);
static void ___lambda99__noise_source_list_expandable_item_device_eject_clicked (NoiseSourceListExpandableItem* _sender,
                                                                          GtkGrid* view,
                                                                          gpointer self);
static void __lambda100_ (NoiseSourceListView* self,
                   GtkGrid* view);
static void ___lambda100__noise_source_list_expandable_item_device_sync_clicked (NoiseSourceListExpandableItem* _sender,
                                                                          GtkGrid* view,
                                                                          gpointer self);
static void __lambda101_ (NoiseSourceListView* self,
                   GtkGrid* view);
static void ___lambda101__noise_source_list_expandable_item_device_new_playlist_clicked (NoiseSourceListExpandableItem* _sender,
                                                                                  GtkGrid* view,
                                                                                  gpointer self);
static void __lambda102_ (NoiseSourceListView* self,
                   GtkGrid* view);
static void ___lambda102__noise_source_list_expandable_item_device_new_smartplaylist_clicked (NoiseSourceListExpandableItem* _sender,
                                                                                       GtkGrid* view,
                                                                                       gpointer self);
static void noise_source_list_view_real_item_selected (GraniteWidgetsSourceList* base,
                                                GraniteWidgetsSourceListItem* item);
GType noise_view_wrapper_get_type (void) G_GNUC_CONST;
void noise_source_list_view_remove_playlist (NoiseSourceListView* self,
                                             NoiseViewWrapper* view);
static void noise_source_list_view_enumerate_children_items (NoiseSourceListView* self,
                                                      NoiseSourceListExpandableItem* exp_item,
                                                      GeeTreeSet* * pages);
GType noise_device_view_get_type (void) G_GNUC_CONST;
GeeCollection* noise_source_list_view_remove_device (NoiseSourceListView* self,
                                                     NoiseDeviceView* view);
static void noise_source_list_view_enumerate_children_pages (NoiseSourceListView* self,
                                                      NoiseSourceListExpandableItem* exp_item,
                                                      GeeTreeSet* * pages);
void noise_source_list_view_change_playlist_name (NoiseSourceListView* self,
                                                  NoiseViewWrapper* view,
                                                  const gchar* new_name);
void noise_source_list_view_change_device_name (NoiseSourceListView* self,
                                                NoiseDeviceView* view,
                                                const gchar* new_name);
static void g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void noise_source_list_view_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static void
noise_source_list_entry_default_init (NoiseSourceListEntryIface * iface)
{
}


GType
noise_source_list_entry_get_type (void)
{
	static volatile gsize noise_source_list_entry_type_id__volatile = 0;
	if (g_once_init_enter (&noise_source_list_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSourceListEntryIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_source_list_entry_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType noise_source_list_entry_type_id;
		noise_source_list_entry_type_id = g_type_register_static (G_TYPE_INTERFACE, "NoiseSourceListEntry", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (noise_source_list_entry_type_id, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
		g_once_init_leave (&noise_source_list_entry_type_id__volatile, noise_source_list_entry_type_id);
	}
	return noise_source_list_entry_type_id__volatile;
}


static inline gpointer
noise_source_list_item_get_instance_private (NoiseSourceListItem* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseSourceListItem_private_offset);
}


NoiseSourceListItem*
noise_source_list_item_construct (GType object_type,
                                  GtkGrid* view,
                                  const gchar* name,
                                  NoiseViewWrapperHint hint,
                                  GIcon* icon,
                                  GIcon* activatable_icon)
{
	NoiseSourceListItem * self = NULL;
	g_return_val_if_fail (view != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (icon != NULL, NULL);
	self = (NoiseSourceListItem*) g_object_new (object_type, "activatable-icon", activatable_icon, "hint", hint, "icon", icon, "name", name, "view", view, NULL);
	return self;
}


NoiseSourceListItem*
noise_source_list_item_new (GtkGrid* view,
                            const gchar* name,
                            NoiseViewWrapperHint hint,
                            GIcon* icon,
                            GIcon* activatable_icon)
{
	return noise_source_list_item_construct (NOISE_TYPE_SOURCE_LIST_ITEM, view, name, hint, icon, activatable_icon);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static GtkMenu*
noise_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* base)
{
	NoiseSourceListItem * self;
	GtkMenu* result = NULL;
	GtkMenu* _tmp0_;
	self = (NoiseSourceListItem*) base;
	_tmp0_ = self->priv->playlist_menu;
	if (_tmp0_ != NULL) {
		GtkMenu* _tmp1_;
		GtkWidget* _tmp2_;
		GtkMenu* _tmp4_;
		GtkMenu* _tmp5_;
		_tmp1_ = self->priv->playlist_menu;
		_tmp2_ = gtk_menu_get_attach_widget (_tmp1_);
		if (_tmp2_ != NULL) {
			GtkMenu* _tmp3_;
			_tmp3_ = self->priv->playlist_menu;
			gtk_menu_detach (_tmp3_);
		}
		_tmp4_ = self->priv->playlist_menu;
		_tmp5_ = _g_object_ref0 (_tmp4_);
		result = _tmp5_;
		return result;
	}
	result = NULL;
	return result;
}


static gboolean
noise_source_list_item_real_data_drop_possible (GraniteWidgetsSourceListDragDest* base,
                                                GdkDragContext* context,
                                                GtkSelectionData* data)
{
	NoiseSourceListItem * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	NoiseViewWrapperHint _tmp1_;
	self = (NoiseSourceListItem*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	g_return_val_if_fail (data != NULL, FALSE);
	_tmp1_ = self->priv->_hint;
	if (_tmp1_ == NOISE_VIEW_WRAPPER_HINT_PLAYLIST) {
		_tmp0_ = gtk_selection_data_get_target (data) == gdk_atom_intern_static_string ("text/uri-list");
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


static GdkDragAction
noise_source_list_item_real_data_received (GraniteWidgetsSourceListDragDest* base,
                                           GdkDragContext* context,
                                           GtkSelectionData* data)
{
	NoiseSourceListItem * self;
	GdkDragAction result = 0;
	GtkGrid* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	self = (NoiseSourceListItem*) base;
	g_return_val_if_fail (context != NULL, 0);
	g_return_val_if_fail (data != NULL, 0);
	_tmp0_ = self->priv->_view;
	_tmp2_ = _tmp1_ = gtk_selection_data_get_uris (data);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _vala_array_length (_tmp1_);
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_MEDIA_ADDED_SIGNAL], 0, _tmp0_, _tmp3_, _vala_array_length (_tmp1_));
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
	result = GDK_ACTION_COPY;
	return result;
}


GtkGrid*
noise_source_list_item_get_view (NoiseSourceListItem* self)
{
	GtkGrid* result;
	GtkGrid* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_view;
	result = _tmp0_;
	return result;
}


static void
noise_source_list_item_set_view (NoiseSourceListItem* self,
                                 GtkGrid* value)
{
	g_return_if_fail (self != NULL);
	if (noise_source_list_item_get_view (self) != value) {
		GtkGrid* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_view);
		self->priv->_view = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_VIEW_PROPERTY]);
	}
}


NoiseViewWrapperHint
noise_source_list_item_get_hint (NoiseSourceListItem* self)
{
	NoiseViewWrapperHint result;
	NoiseViewWrapperHint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_hint;
	result = _tmp0_;
	return result;
}


static void
noise_source_list_item_set_hint (NoiseSourceListItem* self,
                                 NoiseViewWrapperHint value)
{
	g_return_if_fail (self != NULL);
	if (noise_source_list_item_get_hint (self) != value) {
		self->priv->_hint = value;
		g_object_notify_by_pspec ((GObject *) self, noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_HINT_PROPERTY]);
	}
}


GIcon*
noise_source_list_item_get_activatable_icon (NoiseSourceListItem* self)
{
	GIcon* result;
	GIcon* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_activatable_icon;
	result = _tmp0_;
	return result;
}


static void
noise_source_list_item_set_activatable_icon (NoiseSourceListItem* self,
                                             GIcon* value)
{
	g_return_if_fail (self != NULL);
	if (noise_source_list_item_get_activatable_icon (self) != value) {
		GIcon* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_activatable_icon);
		self->priv->_activatable_icon = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY]);
	}
}


static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void
g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_BOXED_INT) (gpointer data1, gpointer arg_1, gpointer arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOXED_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_BOXED_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boxed (param_values + 2), g_value_get_int (param_values + 3), data2);
}


static void
_noise_source_list_item____lambda73_ (NoiseSourceListItem* self)
{
	GtkGrid* _tmp0_;
	_tmp0_ = self->priv->_view;
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL], 0, _tmp0_, self);
}


static void
__noise_source_list_item____lambda73__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
	_noise_source_list_item____lambda73_ ((NoiseSourceListItem*) self);
}


static void
_noise_source_list_item____lambda74_ (NoiseSourceListItem* self)
{
	GtkGrid* _tmp0_;
	_tmp0_ = self->priv->_view;
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL], 0, _tmp0_);
}


static void
__noise_source_list_item____lambda74__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
	_noise_source_list_item____lambda74_ ((NoiseSourceListItem*) self);
}


static void
_noise_source_list_item____lambda75_ (NoiseSourceListItem* self)
{
	GtkGrid* _tmp0_;
	_tmp0_ = self->priv->_view;
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL], 0, _tmp0_, self);
}


static void
__noise_source_list_item____lambda75__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
	_noise_source_list_item____lambda75_ ((NoiseSourceListItem*) self);
}


static void
_noise_source_list_item____lambda76_ (NoiseSourceListItem* self)
{
	GtkGrid* _tmp0_;
	_tmp0_ = self->priv->_view;
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_EDIT_CLICKED_SIGNAL], 0, _tmp0_);
}


static void
__noise_source_list_item____lambda76__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
	_noise_source_list_item____lambda76_ ((NoiseSourceListItem*) self);
}


static void
_noise_source_list_item____lambda77_ (NoiseSourceListItem* self)
{
	GtkGrid* _tmp0_;
	_tmp0_ = self->priv->_view;
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL], 0, _tmp0_);
}


static void
__noise_source_list_item____lambda77__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
	_noise_source_list_item____lambda77_ ((NoiseSourceListItem*) self);
}


static void
_noise_source_list_item____lambda78_ (NoiseSourceListItem* self)
{
	GtkGrid* _tmp0_;
	_tmp0_ = self->priv->_view;
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_SAVE_CLICKED_SIGNAL], 0, _tmp0_);
}


static void
__noise_source_list_item____lambda78__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
	_noise_source_list_item____lambda78_ ((NoiseSourceListItem*) self);
}


static void
_noise_source_list_item___lambda79_ (NoiseSourceListItem* self)
{
	GtkGrid* _tmp0_;
	_tmp0_ = self->priv->_view;
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL], 0, _tmp0_);
}


static void
__noise_source_list_item___lambda79__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                             gpointer self)
{
	_noise_source_list_item___lambda79_ ((NoiseSourceListItem*) self);
}


static GObject *
noise_source_list_item_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseSourceListItem * self;
	GtkMenu* _tmp0_;
	NoiseViewWrapperHint _tmp1_;
	GtkMenuItem* playlist_export = NULL;
	GtkMenuItem* _tmp26_;
	GtkMenuItem* _tmp27_;
	GtkMenu* _tmp28_;
	GtkMenuItem* _tmp29_;
	GtkMenu* _tmp30_;
	parent_class = G_OBJECT_CLASS (noise_source_list_item_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem);
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->playlist_menu);
	self->priv->playlist_menu = _tmp0_;
	_tmp1_ = self->priv->_hint;
	switch (_tmp1_) {
		case NOISE_VIEW_WRAPPER_HINT_PLAYLIST:
		{
			GtkMenuItem* playlist_rename = NULL;
			GtkMenuItem* _tmp2_;
			GtkMenuItem* playlist_remove = NULL;
			GtkMenuItem* _tmp3_;
			GtkMenu* _tmp4_;
			GtkMenuItem* _tmp5_;
			GtkMenu* _tmp6_;
			GtkMenuItem* _tmp7_;
			GtkMenuItem* _tmp8_;
			GtkMenuItem* _tmp9_;
			_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Rename"));
			g_object_ref_sink (_tmp2_);
			playlist_rename = _tmp2_;
			_tmp3_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove"));
			g_object_ref_sink (_tmp3_);
			playlist_remove = _tmp3_;
			_tmp4_ = self->priv->playlist_menu;
			_tmp5_ = playlist_rename;
			gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, _tmp5_);
			_tmp6_ = self->priv->playlist_menu;
			_tmp7_ = playlist_remove;
			gtk_menu_shell_append ((GtkMenuShell*) _tmp6_, _tmp7_);
			_tmp8_ = playlist_rename;
			g_signal_connect_object (_tmp8_, "activate", (GCallback) __noise_source_list_item____lambda73__gtk_menu_item_activate, self, 0);
			_tmp9_ = playlist_remove;
			g_signal_connect_object (_tmp9_, "activate", (GCallback) __noise_source_list_item____lambda74__gtk_menu_item_activate, self, 0);
			_g_object_unref0 (playlist_remove);
			_g_object_unref0 (playlist_rename);
			break;
		}
		case NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
		{
			GtkMenuItem* playlist_rename = NULL;
			GtkMenuItem* _tmp10_;
			GtkMenuItem* playlist_edit = NULL;
			GtkMenuItem* _tmp11_;
			GtkMenuItem* playlist_remove = NULL;
			GtkMenuItem* _tmp12_;
			GtkMenu* _tmp13_;
			GtkMenuItem* _tmp14_;
			GtkMenu* _tmp15_;
			GtkMenuItem* _tmp16_;
			GtkMenu* _tmp17_;
			GtkMenuItem* _tmp18_;
			GtkMenuItem* _tmp19_;
			GtkMenuItem* _tmp20_;
			GtkMenuItem* _tmp21_;
			_tmp10_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Rename"));
			g_object_ref_sink (_tmp10_);
			playlist_rename = _tmp10_;
			_tmp11_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Edit…"));
			g_object_ref_sink (_tmp11_);
			playlist_edit = _tmp11_;
			_tmp12_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove"));
			g_object_ref_sink (_tmp12_);
			playlist_remove = _tmp12_;
			_tmp13_ = self->priv->playlist_menu;
			_tmp14_ = playlist_rename;
			gtk_menu_shell_append ((GtkMenuShell*) _tmp13_, _tmp14_);
			_tmp15_ = self->priv->playlist_menu;
			_tmp16_ = playlist_edit;
			gtk_menu_shell_append ((GtkMenuShell*) _tmp15_, _tmp16_);
			_tmp17_ = self->priv->playlist_menu;
			_tmp18_ = playlist_remove;
			gtk_menu_shell_append ((GtkMenuShell*) _tmp17_, _tmp18_);
			_tmp19_ = playlist_rename;
			g_signal_connect_object (_tmp19_, "activate", (GCallback) __noise_source_list_item____lambda75__gtk_menu_item_activate, self, 0);
			_tmp20_ = playlist_edit;
			g_signal_connect_object (_tmp20_, "activate", (GCallback) __noise_source_list_item____lambda76__gtk_menu_item_activate, self, 0);
			_tmp21_ = playlist_remove;
			g_signal_connect_object (_tmp21_, "activate", (GCallback) __noise_source_list_item____lambda77__gtk_menu_item_activate, self, 0);
			_g_object_unref0 (playlist_remove);
			_g_object_unref0 (playlist_edit);
			_g_object_unref0 (playlist_rename);
			break;
		}
		case NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
		{
			GtkMenuItem* playlist_save = NULL;
			GtkMenuItem* _tmp22_;
			GtkMenu* _tmp23_;
			GtkMenuItem* _tmp24_;
			GtkMenuItem* _tmp25_;
			_tmp22_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Save as Playlist"));
			g_object_ref_sink (_tmp22_);
			playlist_save = _tmp22_;
			_tmp23_ = self->priv->playlist_menu;
			_tmp24_ = playlist_save;
			gtk_menu_shell_append ((GtkMenuShell*) _tmp23_, _tmp24_);
			_tmp25_ = playlist_save;
			g_signal_connect_object (_tmp25_, "activate", (GCallback) __noise_source_list_item____lambda78__gtk_menu_item_activate, self, 0);
			_g_object_unref0 (playlist_save);
			break;
		}
		default:
		break;
	}
	_tmp26_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Export…"));
	g_object_ref_sink (_tmp26_);
	playlist_export = _tmp26_;
	_tmp27_ = playlist_export;
	g_signal_connect_object (_tmp27_, "activate", (GCallback) __noise_source_list_item___lambda79__gtk_menu_item_activate, self, 0);
	_tmp28_ = self->priv->playlist_menu;
	_tmp29_ = playlist_export;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp28_, _tmp29_);
	_tmp30_ = self->priv->playlist_menu;
	gtk_widget_show_all ((GtkWidget*) _tmp30_);
	_g_object_unref0 (playlist_export);
	return obj;
}


static void
noise_source_list_item_class_init (NoiseSourceListItemClass * klass)
{
	noise_source_list_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseSourceListItem_private_offset);
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem *)) noise_source_list_item_real_get_context_menu;
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_source_list_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_source_list_item_set_property;
	G_OBJECT_CLASS (klass)->constructor = noise_source_list_item_constructor;
	G_OBJECT_CLASS (klass)->finalize = noise_source_list_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SOURCE_LIST_ITEM_VIEW_PROPERTY, noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", gtk_grid_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SOURCE_LIST_ITEM_HINT_PROPERTY, noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", NOISE_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY, noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY] = g_param_spec_object ("activatable-icon", "activatable-icon", "activatable-icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL] = g_signal_new ("playlist-rename-clicked", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, gtk_grid_get_type (), NOISE_TYPE_SOURCE_LIST_ITEM);
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_EDIT_CLICKED_SIGNAL] = g_signal_new ("playlist-edit-clicked", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL] = g_signal_new ("playlist-remove-clicked", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_SAVE_CLICKED_SIGNAL] = g_signal_new ("playlist-save-clicked", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-export-clicked", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_MEDIA_ADDED_SIGNAL] = g_signal_new ("playlist-media-added", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT, G_TYPE_NONE, 3, gtk_grid_get_type (), G_TYPE_STRV, G_TYPE_INT);
}


static void
noise_source_list_item_noise_source_list_entry_interface_init (NoiseSourceListEntryIface * iface)
{
	noise_source_list_item_noise_source_list_entry_parent_iface = g_type_interface_peek_parent (iface);
}


static void
noise_source_list_item_granite_widgets_source_list_drag_dest_interface_init (GraniteWidgetsSourceListDragDestIface * iface)
{
	noise_source_list_item_granite_widgets_source_list_drag_dest_parent_iface = g_type_interface_peek_parent (iface);
	iface->data_drop_possible = (gboolean (*) (GraniteWidgetsSourceListDragDest *, GdkDragContext*, GtkSelectionData*)) noise_source_list_item_real_data_drop_possible;
	iface->data_received = (GdkDragAction (*) (GraniteWidgetsSourceListDragDest *, GdkDragContext*, GtkSelectionData*)) noise_source_list_item_real_data_received;
}


static void
noise_source_list_item_instance_init (NoiseSourceListItem * self)
{
	self->priv = noise_source_list_item_get_instance_private (self);
}


static void
noise_source_list_item_finalize (GObject * obj)
{
	NoiseSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem);
	_g_object_unref0 (self->priv->_view);
	_g_object_unref0 (self->priv->_activatable_icon);
	_g_object_unref0 (self->priv->playlist_menu);
	G_OBJECT_CLASS (noise_source_list_item_parent_class)->finalize (obj);
}


/**
 * SourceList item. It stores the number of the corresponding page in the notebook widget.
 */
GType
noise_source_list_item_get_type (void)
{
	static volatile gsize noise_source_list_item_type_id__volatile = 0;
	if (g_once_init_enter (&noise_source_list_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSourceListItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_source_list_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSourceListItem), 0, (GInstanceInitFunc) noise_source_list_item_instance_init, NULL };
		static const GInterfaceInfo noise_source_list_entry_info = { (GInterfaceInitFunc) noise_source_list_item_noise_source_list_entry_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo granite_widgets_source_list_drag_dest_info = { (GInterfaceInitFunc) noise_source_list_item_granite_widgets_source_list_drag_dest_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_source_list_item_type_id;
		noise_source_list_item_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, "NoiseSourceListItem", &g_define_type_info, 0);
		g_type_add_interface_static (noise_source_list_item_type_id, NOISE_TYPE_SOURCE_LIST_ENTRY, &noise_source_list_entry_info);
		g_type_add_interface_static (noise_source_list_item_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST, &granite_widgets_source_list_drag_dest_info);
		NoiseSourceListItem_private_offset = g_type_add_instance_private (noise_source_list_item_type_id, sizeof (NoiseSourceListItemPrivate));
		g_once_init_leave (&noise_source_list_item_type_id__volatile, noise_source_list_item_type_id);
	}
	return noise_source_list_item_type_id__volatile;
}


static void
_vala_noise_source_list_item_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NoiseSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem);
	switch (property_id) {
		case NOISE_SOURCE_LIST_ITEM_VIEW_PROPERTY:
		g_value_set_object (value, noise_source_list_item_get_view (self));
		break;
		case NOISE_SOURCE_LIST_ITEM_HINT_PROPERTY:
		g_value_set_enum (value, noise_source_list_item_get_hint (self));
		break;
		case NOISE_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY:
		g_value_set_object (value, noise_source_list_item_get_activatable_icon (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_source_list_item_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NoiseSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem);
	switch (property_id) {
		case NOISE_SOURCE_LIST_ITEM_VIEW_PROPERTY:
		noise_source_list_item_set_view (self, g_value_get_object (value));
		break;
		case NOISE_SOURCE_LIST_ITEM_HINT_PROPERTY:
		noise_source_list_item_set_hint (self, g_value_get_enum (value));
		break;
		case NOISE_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY:
		noise_source_list_item_set_activatable_icon (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static inline gpointer
noise_source_list_expandable_item_get_instance_private (NoiseSourceListExpandableItem* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseSourceListExpandableItem_private_offset);
}


static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
	g_atomic_int_inc (&_data30_->_ref_count_);
	return _data30_;
}


static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
		NoiseSourceListExpandableItem* self;
		self = _data30_->self;
		_g_object_unref0 (_data30_->view);
		_g_object_unref0 (self);
		g_slice_free (Block30Data, _data30_);
	}
}


static void
___lambda84_ (Block30Data* _data30_)
{
	NoiseSourceListExpandableItem* self;
	self = _data30_->self;
	g_signal_emit (self, noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_IMPORT_CLICKED_SIGNAL], 0, _data30_->view);
}


static void
____lambda84__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
	___lambda84_ (self);
}


static void
___lambda85_ (Block30Data* _data30_)
{
	NoiseSourceListExpandableItem* self;
	self = _data30_->self;
	g_signal_emit (self, noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_EJECT_CLICKED_SIGNAL], 0, _data30_->view);
}


static void
____lambda85__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
	___lambda85_ (self);
}


static void
_____lambda86_ (Block30Data* _data30_)
{
	NoiseSourceListExpandableItem* self;
	self = _data30_->self;
	g_signal_emit (self, noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL], 0, _data30_->view);
}


static void
______lambda86__gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
	_____lambda86_ (self);
}


static void
_____lambda87_ (Block30Data* _data30_)
{
	NoiseSourceListExpandableItem* self;
	self = _data30_->self;
	g_signal_emit (self, noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL], 0, _data30_->view);
}


static void
______lambda87__gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
	_____lambda87_ (self);
}


static void
_____lambda88_ (Block30Data* _data30_)
{
	NoiseSourceListExpandableItem* self;
	self = _data30_->self;
	g_signal_emit (self, noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_SYNC_CLICKED_SIGNAL], 0, _data30_->view);
}


static void
______lambda88__gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
	_____lambda88_ (self);
}


NoiseSourceListExpandableItem*
noise_source_list_expandable_item_construct (GType object_type,
                                             GtkGrid* view,
                                             const gchar* name,
                                             NoiseViewWrapperHint hint,
                                             GIcon* icon,
                                             GIcon* activatable_icon,
                                             GObject* give_more_information)
{
	NoiseSourceListExpandableItem * self = NULL;
	Block30Data* _data30_;
	GtkGrid* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp28_;
	g_return_val_if_fail (view != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (icon != NULL, NULL);
	_data30_ = g_slice_new0 (Block30Data);
	_data30_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (view);
	_g_object_unref0 (_data30_->view);
	_data30_->view = _tmp0_;
	self = (NoiseSourceListExpandableItem*) granite_widgets_source_list_expandable_item_construct (object_type, name);
	_data30_->self = g_object_ref (self);
	noise_source_list_expandable_item_set_view (self, _data30_->view);
	granite_widgets_source_list_item_set_icon ((GraniteWidgetsSourceListItem*) self, icon);
	self->hint = hint;
	if (activatable_icon != NULL) {
		granite_widgets_source_list_item_set_activatable ((GraniteWidgetsSourceListItem*) self, activatable_icon);
	}
	_tmp1_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->device_menu);
	self->priv->device_menu = _tmp1_;
	if (hint == NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO) {
		GtkMenuItem* import_menuitem = NULL;
		GtkMenuItem* _tmp2_;
		GtkMenuItem* _tmp3_;
		GtkMenu* _tmp4_;
		GtkMenuItem* _tmp5_;
		_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Import to Library"));
		g_object_ref_sink (_tmp2_);
		import_menuitem = _tmp2_;
		_tmp3_ = import_menuitem;
		g_signal_connect_data (_tmp3_, "activate", (GCallback) ____lambda84__gtk_menu_item_activate, block30_data_ref (_data30_), (GClosureNotify) block30_data_unref, 0);
		_tmp4_ = self->priv->device_menu;
		_tmp5_ = import_menuitem;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, _tmp5_);
		_g_object_unref0 (import_menuitem);
	}
	if (hint == NOISE_VIEW_WRAPPER_HINT_DEVICE) {
		GtkMenuItem* eject_menuitem = NULL;
		GtkMenuItem* _tmp6_;
		GtkMenuItem* _tmp7_;
		GtkMenu* _tmp26_;
		GtkMenuItem* _tmp27_;
		_tmp6_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Eject"));
		g_object_ref_sink (_tmp6_);
		eject_menuitem = _tmp6_;
		_tmp7_ = eject_menuitem;
		g_signal_connect_data (_tmp7_, "activate", (GCallback) ____lambda85__gtk_menu_item_activate, block30_data_ref (_data30_), (GClosureNotify) block30_data_unref, 0);
		if (G_TYPE_CHECK_INSTANCE_TYPE (give_more_information, NOISE_TYPE_DEVICE)) {
			NoiseDevice* device = NULL;
			NoiseDevice* _tmp8_;
			NoiseLibrary* device_library = NULL;
			NoiseDevice* _tmp9_;
			NoiseLibrary* _tmp10_;
			NoiseLibrary* _tmp11_;
			NoiseLibrary* _tmp16_;
			NoiseDevice* _tmp21_;
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (give_more_information, NOISE_TYPE_DEVICE, NoiseDevice));
			device = _tmp8_;
			_tmp9_ = device;
			_tmp10_ = noise_device_get_library (_tmp9_);
			device_library = _tmp10_;
			_tmp11_ = device_library;
			if (noise_library_support_playlists (_tmp11_)) {
				GtkMenuItem* add_playlist_menuitem = NULL;
				GtkMenuItem* _tmp12_;
				GtkMenuItem* _tmp13_;
				GtkMenu* _tmp14_;
				GtkMenuItem* _tmp15_;
				_tmp12_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Playlist"));
				g_object_ref_sink (_tmp12_);
				add_playlist_menuitem = _tmp12_;
				_tmp13_ = add_playlist_menuitem;
				g_signal_connect_data (_tmp13_, "activate", (GCallback) ______lambda86__gtk_menu_item_activate, block30_data_ref (_data30_), (GClosureNotify) block30_data_unref, 0);
				_tmp14_ = self->priv->device_menu;
				_tmp15_ = add_playlist_menuitem;
				gtk_menu_shell_append ((GtkMenuShell*) _tmp14_, _tmp15_);
				_g_object_unref0 (add_playlist_menuitem);
			}
			_tmp16_ = device_library;
			if (noise_library_support_smart_playlists (_tmp16_)) {
				GtkMenuItem* add_smart_playlist_menuitem = NULL;
				GtkMenuItem* _tmp17_;
				GtkMenuItem* _tmp18_;
				GtkMenu* _tmp19_;
				GtkMenuItem* _tmp20_;
				_tmp17_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Smart Playlist"));
				g_object_ref_sink (_tmp17_);
				add_smart_playlist_menuitem = _tmp17_;
				_tmp18_ = add_smart_playlist_menuitem;
				g_signal_connect_data (_tmp18_, "activate", (GCallback) ______lambda87__gtk_menu_item_activate, block30_data_ref (_data30_), (GClosureNotify) block30_data_unref, 0);
				_tmp19_ = self->priv->device_menu;
				_tmp20_ = add_smart_playlist_menuitem;
				gtk_menu_shell_append ((GtkMenuShell*) _tmp19_, _tmp20_);
				_g_object_unref0 (add_smart_playlist_menuitem);
			}
			_tmp21_ = device;
			if (noise_device_read_only (_tmp21_) == FALSE) {
				GtkMenuItem* sync_menuitem = NULL;
				GtkMenuItem* _tmp22_;
				GtkMenuItem* _tmp23_;
				GtkMenu* _tmp24_;
				GtkMenuItem* _tmp25_;
				_tmp22_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Sync"));
				g_object_ref_sink (_tmp22_);
				sync_menuitem = _tmp22_;
				_tmp23_ = sync_menuitem;
				g_signal_connect_data (_tmp23_, "activate", (GCallback) ______lambda88__gtk_menu_item_activate, block30_data_ref (_data30_), (GClosureNotify) block30_data_unref, 0);
				_tmp24_ = self->priv->device_menu;
				_tmp25_ = sync_menuitem;
				gtk_menu_shell_append ((GtkMenuShell*) _tmp24_, _tmp25_);
				_g_object_unref0 (sync_menuitem);
			}
			_g_object_unref0 (device_library);
			_g_object_unref0 (device);
		}
		_tmp26_ = self->priv->device_menu;
		_tmp27_ = eject_menuitem;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp26_, _tmp27_);
		_g_object_unref0 (eject_menuitem);
	}
	_tmp28_ = self->priv->device_menu;
	gtk_widget_show_all ((GtkWidget*) _tmp28_);
	block30_data_unref (_data30_);
	_data30_ = NULL;
	return self;
}


NoiseSourceListExpandableItem*
noise_source_list_expandable_item_new (GtkGrid* view,
                                       const gchar* name,
                                       NoiseViewWrapperHint hint,
                                       GIcon* icon,
                                       GIcon* activatable_icon,
                                       GObject* give_more_information)
{
	return noise_source_list_expandable_item_construct (NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, view, name, hint, icon, activatable_icon, give_more_information);
}


static GtkMenu*
noise_source_list_expandable_item_real_get_context_menu (GraniteWidgetsSourceListItem* base)
{
	NoiseSourceListExpandableItem * self;
	GtkMenu* result = NULL;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	self = (NoiseSourceListExpandableItem*) base;
	_tmp0_ = self->priv->device_menu;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


GtkGrid*
noise_source_list_expandable_item_get_view (NoiseSourceListExpandableItem* self)
{
	GtkGrid* result;
	GtkGrid* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_view;
	result = _tmp0_;
	return result;
}


void
noise_source_list_expandable_item_set_view (NoiseSourceListExpandableItem* self,
                                            GtkGrid* value)
{
	g_return_if_fail (self != NULL);
	if (noise_source_list_expandable_item_get_view (self) != value) {
		GtkGrid* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_view);
		self->priv->_view = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_source_list_expandable_item_properties[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY]);
	}
}


static void
noise_source_list_expandable_item_class_init (NoiseSourceListExpandableItemClass * klass)
{
	noise_source_list_expandable_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseSourceListExpandableItem_private_offset);
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem *)) noise_source_list_expandable_item_real_get_context_menu;
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_source_list_expandable_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_source_list_expandable_item_set_property;
	G_OBJECT_CLASS (klass)->finalize = noise_source_list_expandable_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY, noise_source_list_expandable_item_properties[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", gtk_grid_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_IMPORT_CLICKED_SIGNAL] = g_signal_new ("device-import-clicked", NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_EJECT_CLICKED_SIGNAL] = g_signal_new ("device-eject-clicked", NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_SYNC_CLICKED_SIGNAL] = g_signal_new ("device-sync-clicked", NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-playlist-clicked", NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-smartplaylist-clicked", NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
}


static void
noise_source_list_expandable_item_noise_source_list_entry_interface_init (NoiseSourceListEntryIface * iface)
{
	noise_source_list_expandable_item_noise_source_list_entry_parent_iface = g_type_interface_peek_parent (iface);
}


static void
noise_source_list_expandable_item_instance_init (NoiseSourceListExpandableItem * self)
{
	self->priv = noise_source_list_expandable_item_get_instance_private (self);
}


static void
noise_source_list_expandable_item_finalize (GObject * obj)
{
	NoiseSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem);
	_g_object_unref0 (self->priv->_view);
	_g_object_unref0 (self->priv->device_menu);
	G_OBJECT_CLASS (noise_source_list_expandable_item_parent_class)->finalize (obj);
}


GType
noise_source_list_expandable_item_get_type (void)
{
	static volatile gsize noise_source_list_expandable_item_type_id__volatile = 0;
	if (g_once_init_enter (&noise_source_list_expandable_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSourceListExpandableItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_source_list_expandable_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSourceListExpandableItem), 0, (GInstanceInitFunc) noise_source_list_expandable_item_instance_init, NULL };
		static const GInterfaceInfo noise_source_list_entry_info = { (GInterfaceInitFunc) noise_source_list_expandable_item_noise_source_list_entry_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_source_list_expandable_item_type_id;
		noise_source_list_expandable_item_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "NoiseSourceListExpandableItem", &g_define_type_info, 0);
		g_type_add_interface_static (noise_source_list_expandable_item_type_id, NOISE_TYPE_SOURCE_LIST_ENTRY, &noise_source_list_entry_info);
		NoiseSourceListExpandableItem_private_offset = g_type_add_instance_private (noise_source_list_expandable_item_type_id, sizeof (NoiseSourceListExpandableItemPrivate));
		g_once_init_leave (&noise_source_list_expandable_item_type_id__volatile, noise_source_list_expandable_item_type_id);
	}
	return noise_source_list_expandable_item_type_id__volatile;
}


static void
_vala_noise_source_list_expandable_item_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec)
{
	NoiseSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem);
	switch (property_id) {
		case NOISE_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY:
		g_value_set_object (value, noise_source_list_expandable_item_get_view (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_source_list_expandable_item_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec)
{
	NoiseSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem);
	switch (property_id) {
		case NOISE_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY:
		noise_source_list_expandable_item_set_view (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static inline gpointer
noise_play_list_category_get_instance_private (NoisePlayListCategory* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePlayListCategory_private_offset);
}


NoisePlayListCategory*
noise_play_list_category_construct (GType object_type,
                                    const gchar* name)
{
	NoisePlayListCategory * self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (NoisePlayListCategory*) g_object_new (object_type, "name", name, NULL);
	return self;
}


NoisePlayListCategory*
noise_play_list_category_new (const gchar* name)
{
	return noise_play_list_category_construct (NOISE_TYPE_PLAY_LIST_CATEGORY, name);
}


static GtkMenu*
noise_play_list_category_real_get_context_menu (GraniteWidgetsSourceListItem* base)
{
	NoisePlayListCategory * self;
	GtkMenu* result = NULL;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	self = (NoisePlayListCategory*) base;
	_tmp0_ = self->priv->playlist_menu;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


static gboolean
noise_play_list_category_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base)
{
	NoisePlayListCategory * self;
	gboolean result = FALSE;
	self = (NoisePlayListCategory*) base;
	result = TRUE;
	return result;
}


static gint
noise_play_list_category_real_compare (GraniteWidgetsSourceListSortable* base,
                                       GraniteWidgetsSourceListItem* a,
                                       GraniteWidgetsSourceListItem* b)
{
	NoisePlayListCategory * self;
	gint result = 0;
	NoiseSourceListItem* item_a = NULL;
	NoiseSourceListItem* _tmp0_;
	NoiseSourceListItem* item_b = NULL;
	NoiseSourceListItem* _tmp1_;
	gboolean _tmp2_ = FALSE;
	NoiseSourceListItem* _tmp3_;
	NoiseSourceListItem* _tmp5_;
	NoiseViewWrapperHint _tmp6_;
	NoiseViewWrapperHint _tmp7_;
	NoiseSourceListItem* _tmp23_;
	NoiseViewWrapperHint _tmp24_;
	NoiseViewWrapperHint _tmp25_;
	NoiseSourceListItem* _tmp35_;
	NoiseViewWrapperHint _tmp36_;
	NoiseViewWrapperHint _tmp37_;
	self = (NoisePlayListCategory*) base;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (a, NOISE_TYPE_SOURCE_LIST_ITEM) ? ((NoiseSourceListItem*) a) : NULL);
	item_a = _tmp0_;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (b, NOISE_TYPE_SOURCE_LIST_ITEM) ? ((NoiseSourceListItem*) b) : NULL);
	item_b = _tmp1_;
	_tmp3_ = item_a;
	if (_tmp3_ == NULL) {
		_tmp2_ = TRUE;
	} else {
		NoiseSourceListItem* _tmp4_;
		_tmp4_ = item_b;
		_tmp2_ = _tmp4_ == NULL;
	}
	if (_tmp2_) {
		result = 0;
		_g_object_unref0 (item_b);
		_g_object_unref0 (item_a);
		return result;
	}
	_tmp5_ = item_a;
	_tmp6_ = noise_source_list_item_get_hint (_tmp5_);
	_tmp7_ = _tmp6_;
	if (_tmp7_ == NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
		NoiseSourceListItem* _tmp8_;
		NoiseViewWrapperHint _tmp9_;
		NoiseViewWrapperHint _tmp10_;
		_tmp8_ = item_b;
		_tmp9_ = noise_source_list_item_get_hint (_tmp8_);
		_tmp10_ = _tmp9_;
		if (_tmp10_ == NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
			GCompareFunc _tmp11_;
			NoiseSourceListItem* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			NoiseSourceListItem* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gint _tmp22_;
			_tmp11_ = g_strcmp0;
			_tmp12_ = item_a;
			_tmp13_ = granite_widgets_source_list_item_get_name ((GraniteWidgetsSourceListItem*) _tmp12_);
			_tmp14_ = _tmp13_;
			_tmp15_ = g_utf8_collate_key (_tmp14_, (gssize) -1);
			_tmp16_ = _tmp15_;
			_tmp17_ = item_b;
			_tmp18_ = granite_widgets_source_list_item_get_name ((GraniteWidgetsSourceListItem*) _tmp17_);
			_tmp19_ = _tmp18_;
			_tmp20_ = g_utf8_collate_key (_tmp19_, (gssize) -1);
			_tmp21_ = _tmp20_;
			_tmp22_ = _tmp11_ (_tmp16_, _tmp21_);
			_g_free0 (_tmp21_);
			_g_free0 (_tmp16_);
			result = _tmp22_;
			_g_object_unref0 (item_b);
			_g_object_unref0 (item_a);
			return result;
		}
		result = -1;
		_g_object_unref0 (item_b);
		_g_object_unref0 (item_a);
		return result;
	}
	_tmp23_ = item_a;
	_tmp24_ = noise_source_list_item_get_hint (_tmp23_);
	_tmp25_ = _tmp24_;
	if (_tmp25_ == NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST) {
		NoiseSourceListItem* _tmp26_;
		NoiseViewWrapperHint _tmp27_;
		NoiseViewWrapperHint _tmp28_;
		NoiseSourceListItem* _tmp29_;
		NoiseViewWrapperHint _tmp30_;
		NoiseViewWrapperHint _tmp31_;
		NoiseSourceListItem* _tmp32_;
		NoiseViewWrapperHint _tmp33_;
		NoiseViewWrapperHint _tmp34_;
		_tmp26_ = item_b;
		_tmp27_ = noise_source_list_item_get_hint (_tmp26_);
		_tmp28_ = _tmp27_;
		if (_tmp28_ == NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
			result = 1;
			_g_object_unref0 (item_b);
			_g_object_unref0 (item_a);
			return result;
		}
		_tmp29_ = item_b;
		_tmp30_ = noise_source_list_item_get_hint (_tmp29_);
		_tmp31_ = _tmp30_;
		if (_tmp31_ == NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST) {
			result = 0;
			_g_object_unref0 (item_b);
			_g_object_unref0 (item_a);
			return result;
		}
		_tmp32_ = item_b;
		_tmp33_ = noise_source_list_item_get_hint (_tmp32_);
		_tmp34_ = _tmp33_;
		if (_tmp34_ == NOISE_VIEW_WRAPPER_HINT_PLAYLIST) {
			result = -1;
			_g_object_unref0 (item_b);
			_g_object_unref0 (item_a);
			return result;
		}
	}
	_tmp35_ = item_a;
	_tmp36_ = noise_source_list_item_get_hint (_tmp35_);
	_tmp37_ = _tmp36_;
	if (_tmp37_ == NOISE_VIEW_WRAPPER_HINT_PLAYLIST) {
		NoiseSourceListItem* _tmp38_;
		NoiseViewWrapperHint _tmp39_;
		NoiseViewWrapperHint _tmp40_;
		_tmp38_ = item_b;
		_tmp39_ = noise_source_list_item_get_hint (_tmp38_);
		_tmp40_ = _tmp39_;
		if (_tmp40_ == NOISE_VIEW_WRAPPER_HINT_PLAYLIST) {
			result = 0;
			_g_object_unref0 (item_b);
			_g_object_unref0 (item_a);
			return result;
		}
		result = 1;
		_g_object_unref0 (item_b);
		_g_object_unref0 (item_a);
		return result;
	}
	result = 0;
	_g_object_unref0 (item_b);
	_g_object_unref0 (item_a);
	return result;
}


static void
_noise_play_list_category___lambda80_ (NoisePlayListCategory* self)
{
	NoiseLibraryWindow* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseLocalLibrary* _tmp2_;
	NoiseLocalLibrary* _tmp3_;
	_tmp0_ = noise_app_get_main_window ();
	_tmp1_ = _tmp0_;
	_tmp2_ = noise_library_window_get_library_manager (self);
	_tmp3_ = _tmp2_;
	noise_library_window_create_new_playlist (_tmp1_, (NoiseLibrary*) _tmp3_);
}


static void
__noise_play_list_category___lambda80__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self)
{
	_noise_play_list_category___lambda80_ ((NoisePlayListCategory*) self);
}


static void
_noise_play_list_category___lambda81_ (NoisePlayListCategory* self)
{
	NoiseLibraryWindow* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	_tmp0_ = noise_app_get_main_window ();
	_tmp1_ = _tmp0_;
	noise_library_window_show_smart_playlist_dialog (_tmp1_, NULL);
}


static void
__noise_play_list_category___lambda81__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self)
{
	_noise_play_list_category___lambda81_ ((NoisePlayListCategory*) self);
}


static void
_noise_play_list_category___lambda82_ (NoisePlayListCategory* self)
{
	g_signal_emit (self, noise_play_list_category_signals[NOISE_PLAY_LIST_CATEGORY_PLAYLIST_IMPORT_CLICKED_SIGNAL], 0);
}


static void
__noise_play_list_category___lambda82__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self)
{
	_noise_play_list_category___lambda82_ ((NoisePlayListCategory*) self);
}


static GObject *
noise_play_list_category_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoisePlayListCategory * self;
	GtkMenuItem* playlist_new = NULL;
	GtkMenuItem* _tmp0_;
	GtkMenuItem* smart_playlist_new = NULL;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* playlist_import = NULL;
	GtkMenuItem* _tmp2_;
	GtkMenu* _tmp3_;
	GtkMenu* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenu* _tmp6_;
	GtkMenuItem* _tmp7_;
	GtkMenu* _tmp8_;
	GtkMenuItem* _tmp9_;
	GtkMenu* _tmp10_;
	GtkMenuItem* _tmp11_;
	GtkMenuItem* _tmp12_;
	GtkMenuItem* _tmp13_;
	parent_class = G_OBJECT_CLASS (noise_play_list_category_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAY_LIST_CATEGORY, NoisePlayListCategory);
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Playlist"));
	g_object_ref_sink (_tmp0_);
	playlist_new = _tmp0_;
	_tmp1_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Smart Playlist"));
	g_object_ref_sink (_tmp1_);
	smart_playlist_new = _tmp1_;
	_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Import Playlists"));
	g_object_ref_sink (_tmp2_);
	playlist_import = _tmp2_;
	_tmp3_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->playlist_menu);
	self->priv->playlist_menu = _tmp3_;
	_tmp4_ = self->priv->playlist_menu;
	_tmp5_ = playlist_new;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, _tmp5_);
	_tmp6_ = self->priv->playlist_menu;
	_tmp7_ = smart_playlist_new;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp6_, _tmp7_);
	_tmp8_ = self->priv->playlist_menu;
	_tmp9_ = playlist_import;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp8_, _tmp9_);
	_tmp10_ = self->priv->playlist_menu;
	gtk_widget_show_all ((GtkWidget*) _tmp10_);
	_tmp11_ = playlist_new;
	g_signal_connect_object (_tmp11_, "activate", (GCallback) __noise_play_list_category___lambda80__gtk_menu_item_activate, self, 0);
	_tmp12_ = smart_playlist_new;
	g_signal_connect_object (_tmp12_, "activate", (GCallback) __noise_play_list_category___lambda81__gtk_menu_item_activate, self, 0);
	_tmp13_ = playlist_import;
	g_signal_connect_object (_tmp13_, "activate", (GCallback) __noise_play_list_category___lambda82__gtk_menu_item_activate, self, 0);
	_g_object_unref0 (playlist_import);
	_g_object_unref0 (smart_playlist_new);
	_g_object_unref0 (playlist_new);
	return obj;
}


static void
noise_play_list_category_class_init (NoisePlayListCategoryClass * klass)
{
	noise_play_list_category_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoisePlayListCategory_private_offset);
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem *)) noise_play_list_category_real_get_context_menu;
	G_OBJECT_CLASS (klass)->constructor = noise_play_list_category_constructor;
	G_OBJECT_CLASS (klass)->finalize = noise_play_list_category_finalize;
	noise_play_list_category_signals[NOISE_PLAY_LIST_CATEGORY_PLAYLIST_IMPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-import-clicked", NOISE_TYPE_PLAY_LIST_CATEGORY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
noise_play_list_category_granite_widgets_source_list_sortable_interface_init (GraniteWidgetsSourceListSortableIface * iface)
{
	noise_play_list_category_granite_widgets_source_list_sortable_parent_iface = g_type_interface_peek_parent (iface);
	iface->allow_dnd_sorting = (gboolean (*) (GraniteWidgetsSourceListSortable *)) noise_play_list_category_real_allow_dnd_sorting;
	iface->compare = (gint (*) (GraniteWidgetsSourceListSortable *, GraniteWidgetsSourceListItem*, GraniteWidgetsSourceListItem*)) noise_play_list_category_real_compare;
}


static void
noise_play_list_category_instance_init (NoisePlayListCategory * self)
{
	self->priv = noise_play_list_category_get_instance_private (self);
}


static void
noise_play_list_category_finalize (GObject * obj)
{
	NoisePlayListCategory * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAY_LIST_CATEGORY, NoisePlayListCategory);
	_g_object_unref0 (self->priv->playlist_menu);
	G_OBJECT_CLASS (noise_play_list_category_parent_class)->finalize (obj);
}


GType
noise_play_list_category_get_type (void)
{
	static volatile gsize noise_play_list_category_type_id__volatile = 0;
	if (g_once_init_enter (&noise_play_list_category_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePlayListCategoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_play_list_category_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePlayListCategory), 0, (GInstanceInitFunc) noise_play_list_category_instance_init, NULL };
		static const GInterfaceInfo granite_widgets_source_list_sortable_info = { (GInterfaceInitFunc) noise_play_list_category_granite_widgets_source_list_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_play_list_category_type_id;
		noise_play_list_category_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "NoisePlayListCategory", &g_define_type_info, 0);
		g_type_add_interface_static (noise_play_list_category_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, &granite_widgets_source_list_sortable_info);
		NoisePlayListCategory_private_offset = g_type_add_instance_private (noise_play_list_category_type_id, sizeof (NoisePlayListCategoryPrivate));
		g_once_init_leave (&noise_play_list_category_type_id__volatile, noise_play_list_category_type_id);
	}
	return noise_play_list_category_type_id__volatile;
}


NoiseSourceListRoot*
noise_source_list_root_construct (GType object_type)
{
	NoiseSourceListRoot * self = NULL;
	self = (NoiseSourceListRoot*) granite_widgets_source_list_expandable_item_construct (object_type, "SourceListRoot");
	return self;
}


NoiseSourceListRoot*
noise_source_list_root_new (void)
{
	return noise_source_list_root_construct (NOISE_TYPE_SOURCE_LIST_ROOT);
}


static gboolean
noise_source_list_root_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base)
{
	NoiseSourceListRoot * self;
	gboolean result = FALSE;
	self = (NoiseSourceListRoot*) base;
	result = TRUE;
	return result;
}


static gint
noise_source_list_root_real_compare (GraniteWidgetsSourceListSortable* base,
                                     GraniteWidgetsSourceListItem* a,
                                     GraniteWidgetsSourceListItem* b)
{
	NoiseSourceListRoot * self;
	gint result = 0;
	self = (NoiseSourceListRoot*) base;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	result = 0;
	return result;
}


static void
noise_source_list_root_class_init (NoiseSourceListRootClass * klass)
{
	noise_source_list_root_parent_class = g_type_class_peek_parent (klass);
}


static void
noise_source_list_root_granite_widgets_source_list_sortable_interface_init (GraniteWidgetsSourceListSortableIface * iface)
{
	noise_source_list_root_granite_widgets_source_list_sortable_parent_iface = g_type_interface_peek_parent (iface);
	iface->allow_dnd_sorting = (gboolean (*) (GraniteWidgetsSourceListSortable *)) noise_source_list_root_real_allow_dnd_sorting;
	iface->compare = (gint (*) (GraniteWidgetsSourceListSortable *, GraniteWidgetsSourceListItem*, GraniteWidgetsSourceListItem*)) noise_source_list_root_real_compare;
}


static void
noise_source_list_root_instance_init (NoiseSourceListRoot * self)
{
}


GType
noise_source_list_root_get_type (void)
{
	static volatile gsize noise_source_list_root_type_id__volatile = 0;
	if (g_once_init_enter (&noise_source_list_root_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSourceListRootClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_source_list_root_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSourceListRoot), 0, (GInstanceInitFunc) noise_source_list_root_instance_init, NULL };
		static const GInterfaceInfo granite_widgets_source_list_sortable_info = { (GInterfaceInitFunc) noise_source_list_root_granite_widgets_source_list_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_source_list_root_type_id;
		noise_source_list_root_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "NoiseSourceListRoot", &g_define_type_info, 0);
		g_type_add_interface_static (noise_source_list_root_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, &granite_widgets_source_list_sortable_info);
		g_once_init_leave (&noise_source_list_root_type_id__volatile, noise_source_list_root_type_id);
	}
	return noise_source_list_root_type_id__volatile;
}


static inline gpointer
noise_source_list_view_get_instance_private (NoiseSourceListView* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseSourceListView_private_offset);
}


static void
__lambda83_ (NoiseSourceListView* self)
{
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_IMPORT_CLICKED_SIGNAL], 0);
}


static void
___lambda83__noise_play_list_category_playlist_import_clicked (NoisePlayListCategory* _sender,
                                                               gpointer self)
{
	__lambda83_ ((NoiseSourceListView*) self);
}


NoiseSourceListView*
noise_source_list_view_construct (GType object_type)
{
	NoiseSourceListView * self = NULL;
	NoiseSourceListRoot* _tmp0_;
	NoiseSourceListRoot* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	GraniteWidgetsSourceListExpandableItem* _tmp4_;
	NoisePlayListCategory* _tmp5_;
	NoisePlayListCategory* _tmp6_;
	GraniteWidgetsSourceListExpandableItem* _tmp7_;
	GraniteWidgetsSourceListExpandableItem* _tmp8_;
	GraniteWidgetsSourceListExpandableItem* _tmp9_;
	GraniteWidgetsSourceListExpandableItem* _tmp10_;
	GraniteWidgetsSourceListExpandableItem* _tmp11_;
	GraniteWidgetsSourceListExpandableItem* _tmp12_;
	GraniteWidgetsSourceListExpandableItem* _tmp13_;
	GraniteWidgetsSourceListExpandableItem* _tmp14_;
	GraniteWidgetsSourceListExpandableItem* _tmp15_;
	GraniteWidgetsSourceListExpandableItem* _tmp16_;
	GraniteWidgetsSourceListExpandableItem* _tmp17_;
	NoisePlayListCategory* _tmp18_;
	GraniteWidgetsSourceListExpandableItem* _tmp19_;
	GraniteWidgetsSourceListExpandableItem* _tmp20_;
	GtkTargetEntry uri_list_entry = {0};
	GtkTargetEntry _tmp21_ = {0};
	GtkTargetEntry _tmp22_;
	GtkTargetEntry* _tmp23_;
	GtkTargetEntry* _tmp24_;
	gint _tmp24__length1;
	_tmp0_ = noise_source_list_root_new ();
	_tmp1_ = _tmp0_;
	self = (NoiseSourceListView*) granite_widgets_source_list_construct (object_type, (GraniteWidgetsSourceListExpandableItem*) _tmp1_);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = granite_widgets_source_list_expandable_item_new (_ ("Library"));
	_g_object_unref0 (self->priv->library_category);
	self->priv->library_category = _tmp2_;
	_tmp3_ = granite_widgets_source_list_expandable_item_new (_ ("Devices"));
	_g_object_unref0 (self->priv->devices_category);
	self->priv->devices_category = _tmp3_;
	_tmp4_ = granite_widgets_source_list_expandable_item_new (_ ("Network"));
	_g_object_unref0 (self->priv->network_category);
	self->priv->network_category = _tmp4_;
	_tmp5_ = noise_play_list_category_new (_ ("Playlists"));
	_g_object_unref0 (self->priv->playlists_category);
	self->priv->playlists_category = _tmp5_;
	_tmp6_ = self->priv->playlists_category;
	g_signal_connect_object (_tmp6_, "playlist-import-clicked", (GCallback) ___lambda83__noise_play_list_category_playlist_import_clicked, self, 0);
	_tmp7_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
	_tmp8_ = _tmp7_;
	_tmp9_ = self->priv->library_category;
	granite_widgets_source_list_expandable_item_add (_tmp8_, (GraniteWidgetsSourceListItem*) _tmp9_);
	_tmp10_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
	_tmp11_ = _tmp10_;
	_tmp12_ = self->priv->devices_category;
	granite_widgets_source_list_expandable_item_add (_tmp11_, (GraniteWidgetsSourceListItem*) _tmp12_);
	_tmp13_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
	_tmp14_ = _tmp13_;
	_tmp15_ = self->priv->network_category;
	granite_widgets_source_list_expandable_item_add (_tmp14_, (GraniteWidgetsSourceListItem*) _tmp15_);
	_tmp16_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
	_tmp17_ = _tmp16_;
	_tmp18_ = self->priv->playlists_category;
	granite_widgets_source_list_expandable_item_add (_tmp17_, (GraniteWidgetsSourceListItem*) _tmp18_);
	_tmp19_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
	_tmp20_ = _tmp19_;
	granite_widgets_source_list_expandable_item_expand_all (_tmp20_, FALSE, FALSE);
	_tmp21_.target = "text/uri-list";
	_tmp21_.flags = (guint) GTK_TARGET_SAME_APP;
	_tmp21_.info = (guint) 0;
	uri_list_entry = _tmp21_;
	_tmp22_ = uri_list_entry;
	_tmp23_ = g_new0 (GtkTargetEntry, 1);
	_tmp23_[0] = _tmp22_;
	_tmp24_ = _tmp23_;
	_tmp24__length1 = 1;
	granite_widgets_source_list_enable_drag_dest ((GraniteWidgetsSourceList*) self, _tmp24_, 1, GDK_ACTION_COPY);
	_tmp24_ = (g_free (_tmp24_), NULL);
	return self;
}


NoiseSourceListView*
noise_source_list_view_new (void)
{
	return noise_source_list_view_construct (NOISE_TYPE_SOURCE_LIST_VIEW);
}


/**
     * Change the visibility of each category
     */
void
noise_source_list_view_change_playlist_category_visibility (NoiseSourceListView* self,
                                                            gboolean visible)
{
	NoisePlayListCategory* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->playlists_category;
	granite_widgets_source_list_item_set_visible ((GraniteWidgetsSourceListItem*) _tmp0_, visible);
}


/**
     * Adds an item to the sidebar for the ViewWrapper object.
     * It chooses the appropiate category based on the object's hint property.
     *
     * TODO: Change ViewWrapper.Hint to core values.
     */
static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
	g_atomic_int_inc (&_data31_->_ref_count_);
	return _data31_;
}


static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
		NoiseSourceListView* self;
		self = _data31_->self;
		_g_object_unref0 (_data31_->expandable_item);
		_g_object_unref0 (_data31_->sourcelist_item);
		_g_object_unref0 (self);
		g_slice_free (Block31Data, _data31_);
	}
}


static void
__lambda89_ (NoiseSourceListView* self)
{
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_ACTIVATED_SIGNAL], 0);
}


static void
___lambda89__granite_widgets_source_list_item_activated (GraniteWidgetsSourceListItem* _sender,
                                                         gpointer self)
{
	__lambda89_ ((NoiseSourceListView*) self);
}


static void
__lambda90_ (Block31Data* _data31_,
             const gchar* new_name)
{
	NoiseSourceListView* self;
	NoiseSourceListItem* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	self = _data31_->self;
	g_return_if_fail (new_name != NULL);
	_tmp0_ = _data31_->sourcelist_item;
	_tmp1_ = noise_source_list_item_get_view (_tmp0_);
	_tmp2_ = _tmp1_;
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_EDITED_SIGNAL], 0, _tmp2_, new_name);
}


static void
___lambda90__granite_widgets_source_list_item_edited (GraniteWidgetsSourceListItem* _sender,
                                                      const gchar* new_name,
                                                      gpointer self)
{
	__lambda90_ (self, new_name);
}


static void
__lambda91_ (Block31Data* _data31_,
             GraniteWidgetsSourceListItem* sl)
{
	NoiseSourceListView* self;
	NoiseSourceListItem* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	self = _data31_->self;
	g_return_if_fail (sl != NULL);
	_tmp0_ = _data31_->sourcelist_item;
	_tmp1_ = noise_source_list_item_get_view (_tmp0_);
	_tmp2_ = _tmp1_;
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_ITEM_ACTION_ACTIVATED_SIGNAL], 0, _tmp2_);
}


static void
___lambda91__granite_widgets_source_list_item_action_activated (GraniteWidgetsSourceListItem* _sender,
                                                                gpointer self)
{
	__lambda91_ (self, _sender);
}


static void
__lambda92_ (NoiseSourceListView* self,
             GtkGrid* view,
             NoiseSourceListItem* item)
{
	g_return_if_fail (view != NULL);
	g_return_if_fail (item != NULL);
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_RENAME_CLICKED_SIGNAL], 0, view);
	granite_widgets_source_list_start_editing_item ((GraniteWidgetsSourceList*) self, (GraniteWidgetsSourceListItem*) item);
}


static void
___lambda92__noise_source_list_item_playlist_rename_clicked (NoiseSourceListItem* _sender,
                                                             GtkGrid* view,
                                                             NoiseSourceListItem* item,
                                                             gpointer self)
{
	__lambda92_ ((NoiseSourceListView*) self, view, item);
}


static void
__lambda93_ (NoiseSourceListView* self,
             GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_EDIT_CLICKED_SIGNAL], 0, view);
}


static void
___lambda93__noise_source_list_item_playlist_edit_clicked (NoiseSourceListItem* _sender,
                                                           GtkGrid* view,
                                                           gpointer self)
{
	__lambda93_ ((NoiseSourceListView*) self, view);
}


static void
__lambda94_ (NoiseSourceListView* self,
             GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_REMOVE_CLICKED_SIGNAL], 0, view);
}


static void
___lambda94__noise_source_list_item_playlist_remove_clicked (NoiseSourceListItem* _sender,
                                                             GtkGrid* view,
                                                             gpointer self)
{
	__lambda94_ ((NoiseSourceListView*) self, view);
}


static void
__lambda95_ (NoiseSourceListView* self,
             GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_SAVE_CLICKED_SIGNAL], 0, view);
}


static void
___lambda95__noise_source_list_item_playlist_save_clicked (NoiseSourceListItem* _sender,
                                                           GtkGrid* view,
                                                           gpointer self)
{
	__lambda95_ ((NoiseSourceListView*) self, view);
}


static void
__lambda96_ (NoiseSourceListView* self,
             GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_EXPORT_CLICKED_SIGNAL], 0, view);
}


static void
___lambda96__noise_source_list_item_playlist_export_clicked (NoiseSourceListItem* _sender,
                                                             GtkGrid* view,
                                                             gpointer self)
{
	__lambda96_ ((NoiseSourceListView*) self, view);
}


static void
__lambda97_ (NoiseSourceListView* self,
             GtkGrid* view,
             gchar** uris,
             int uris_length1)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_MEDIA_ADDED_SIGNAL], 0, view, uris, uris_length1);
}


static void
___lambda97__noise_source_list_item_playlist_media_added (NoiseSourceListItem* _sender,
                                                          GtkGrid* view,
                                                          gchar** media,
                                                          int media_length1,
                                                          gpointer self)
{
	__lambda97_ ((NoiseSourceListView*) self, view, media, media_length1);
}


static void
__lambda98_ (Block31Data* _data31_,
             GtkGrid* view)
{
	NoiseSourceListView* self;
	NoiseSourceListExpandableItem* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	self = _data31_->self;
	g_return_if_fail (view != NULL);
	_tmp0_ = _data31_->expandable_item;
	_tmp1_ = noise_source_list_view_get_device_from_item (self, _tmp0_);
	_tmp2_ = _tmp1_;
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_IMPORT_CLICKED_SIGNAL], 0, _tmp2_);
	_g_object_unref0 (_tmp2_);
}


static void
___lambda98__noise_source_list_expandable_item_device_import_clicked (NoiseSourceListExpandableItem* _sender,
                                                                      GtkGrid* view,
                                                                      gpointer self)
{
	__lambda98_ (self, view);
}


static void
__lambda99_ (NoiseSourceListView* self,
             GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_EJECT_CLICKED_SIGNAL], 0, view);
}


static void
___lambda99__noise_source_list_expandable_item_device_eject_clicked (NoiseSourceListExpandableItem* _sender,
                                                                     GtkGrid* view,
                                                                     gpointer self)
{
	__lambda99_ ((NoiseSourceListView*) self, view);
}


static void
__lambda100_ (NoiseSourceListView* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_SYNC_CLICKED_SIGNAL], 0, view);
}


static void
___lambda100__noise_source_list_expandable_item_device_sync_clicked (NoiseSourceListExpandableItem* _sender,
                                                                     GtkGrid* view,
                                                                     gpointer self)
{
	__lambda100_ ((NoiseSourceListView*) self, view);
}


static void
__lambda101_ (NoiseSourceListView* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL], 0, view);
}


static void
___lambda101__noise_source_list_expandable_item_device_new_playlist_clicked (NoiseSourceListExpandableItem* _sender,
                                                                             GtkGrid* view,
                                                                             gpointer self)
{
	__lambda101_ ((NoiseSourceListView*) self, view);
}


static void
__lambda102_ (NoiseSourceListView* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL], 0, view);
}


static void
___lambda102__noise_source_list_expandable_item_device_new_smartplaylist_clicked (NoiseSourceListExpandableItem* _sender,
                                                                                  GtkGrid* view,
                                                                                  gpointer self)
{
	__lambda102_ ((NoiseSourceListView*) self, view);
}


NoiseSourceListEntry*
noise_source_list_view_add_item (NoiseSourceListView* self,
                                 GtkGrid* view,
                                 const gchar* name,
                                 NoiseViewWrapperHint hint,
                                 GIcon* icon,
                                 GIcon* activatable_icon,
                                 NoiseSourceListExpandableItem* into_expandable,
                                 GObject* give_more_information)
{
	NoiseSourceListEntry* result = NULL;
	Block31Data* _data31_;
	NoiseSourceListItem* _tmp0_;
	NoiseSourceListExpandableItem* _tmp1_;
	NoiseSourceListItem* _tmp5_;
	NoiseSourceListItem* _tmp6_;
	NoiseSourceListExpandableItem* _tmp7_;
	NoiseSourceListItem* _tmp8_;
	NoiseSourceListItem* _tmp9_;
	NoiseSourceListItem* _tmp10_;
	NoiseSourceListItem* _tmp11_;
	NoiseSourceListItem* _tmp12_;
	NoiseSourceListItem* _tmp13_;
	NoiseSourceListExpandableItem* _tmp14_;
	NoiseSourceListExpandableItem* _tmp15_;
	NoiseSourceListExpandableItem* _tmp16_;
	NoiseSourceListExpandableItem* _tmp17_;
	NoiseSourceListExpandableItem* _tmp18_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (view != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (icon != NULL, NULL);
	_data31_ = g_slice_new0 (Block31Data);
	_data31_->_ref_count_ = 1;
	_data31_->self = g_object_ref (self);
	_tmp0_ = noise_source_list_item_new (view, name, hint, icon, activatable_icon);
	_data31_->sourcelist_item = _tmp0_;
	_tmp1_ = noise_source_list_expandable_item_new (view, name, hint, icon, activatable_icon, give_more_information);
	_data31_->expandable_item = _tmp1_;
	if (hint == NOISE_VIEW_WRAPPER_HINT_DEVICE) {
		NoiseSourceListExpandableItem* _tmp2_;
		NoiseSourceListExpandableItem* _tmp3_;
		_tmp2_ = _data31_->expandable_item;
		granite_widgets_source_list_expandable_item_set_collapsible ((GraniteWidgetsSourceListExpandableItem*) _tmp2_, FALSE);
		_tmp3_ = _data31_->expandable_item;
		granite_widgets_source_list_item_set_icon ((GraniteWidgetsSourceListItem*) _tmp3_, icon);
		if (activatable_icon != NULL) {
			NoiseSourceListExpandableItem* _tmp4_;
			_tmp4_ = _data31_->expandable_item;
			granite_widgets_source_list_item_set_activatable ((GraniteWidgetsSourceListItem*) _tmp4_, activatable_icon);
		}
	}
	_tmp5_ = _data31_->sourcelist_item;
	g_signal_connect_object ((GraniteWidgetsSourceListItem*) _tmp5_, "activated", (GCallback) ___lambda89__granite_widgets_source_list_item_activated, self, 0);
	_tmp6_ = _data31_->sourcelist_item;
	g_signal_connect_data ((GraniteWidgetsSourceListItem*) _tmp6_, "edited", (GCallback) ___lambda90__granite_widgets_source_list_item_edited, block31_data_ref (_data31_), (GClosureNotify) block31_data_unref, 0);
	_tmp7_ = _data31_->expandable_item;
	g_signal_connect_data ((GraniteWidgetsSourceListItem*) _tmp7_, "action-activated", (GCallback) ___lambda91__granite_widgets_source_list_item_action_activated, block31_data_ref (_data31_), (GClosureNotify) block31_data_unref, 0);
	_tmp8_ = _data31_->sourcelist_item;
	g_signal_connect_object (_tmp8_, "playlist-rename-clicked", (GCallback) ___lambda92__noise_source_list_item_playlist_rename_clicked, self, 0);
	_tmp9_ = _data31_->sourcelist_item;
	g_signal_connect_object (_tmp9_, "playlist-edit-clicked", (GCallback) ___lambda93__noise_source_list_item_playlist_edit_clicked, self, 0);
	_tmp10_ = _data31_->sourcelist_item;
	g_signal_connect_object (_tmp10_, "playlist-remove-clicked", (GCallback) ___lambda94__noise_source_list_item_playlist_remove_clicked, self, 0);
	_tmp11_ = _data31_->sourcelist_item;
	g_signal_connect_object (_tmp11_, "playlist-save-clicked", (GCallback) ___lambda95__noise_source_list_item_playlist_save_clicked, self, 0);
	_tmp12_ = _data31_->sourcelist_item;
	g_signal_connect_object (_tmp12_, "playlist-export-clicked", (GCallback) ___lambda96__noise_source_list_item_playlist_export_clicked, self, 0);
	_tmp13_ = _data31_->sourcelist_item;
	g_signal_connect_object (_tmp13_, "playlist-media-added", (GCallback) ___lambda97__noise_source_list_item_playlist_media_added, self, 0);
	_tmp14_ = _data31_->expandable_item;
	g_signal_connect_data (_tmp14_, "device-import-clicked", (GCallback) ___lambda98__noise_source_list_expandable_item_device_import_clicked, block31_data_ref (_data31_), (GClosureNotify) block31_data_unref, 0);
	_tmp15_ = _data31_->expandable_item;
	g_signal_connect_object (_tmp15_, "device-eject-clicked", (GCallback) ___lambda99__noise_source_list_expandable_item_device_eject_clicked, self, 0);
	_tmp16_ = _data31_->expandable_item;
	g_signal_connect_object (_tmp16_, "device-sync-clicked", (GCallback) ___lambda100__noise_source_list_expandable_item_device_sync_clicked, self, 0);
	_tmp17_ = _data31_->expandable_item;
	g_signal_connect_object (_tmp17_, "device-new-playlist-clicked", (GCallback) ___lambda101__noise_source_list_expandable_item_device_new_playlist_clicked, self, 0);
	_tmp18_ = _data31_->expandable_item;
	g_signal_connect_object (_tmp18_, "device-new-smartplaylist-clicked", (GCallback) ___lambda102__noise_source_list_expandable_item_device_new_smartplaylist_clicked, self, 0);
	switch (hint) {
		case NOISE_VIEW_WRAPPER_HINT_MUSIC:
		{
			if (into_expandable == NULL) {
				GraniteWidgetsSourceListExpandableItem* _tmp19_;
				NoiseSourceListItem* _tmp20_;
				_tmp19_ = self->priv->library_category;
				_tmp20_ = _data31_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add (_tmp19_, (GraniteWidgetsSourceListItem*) _tmp20_);
			} else {
				NoiseSourceListItem* _tmp21_;
				_tmp21_ = _data31_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp21_);
			}
			break;
		}
		case NOISE_VIEW_WRAPPER_HINT_PLAYLIST:
		{
			if (into_expandable == NULL) {
				NoiseSourceListItem* _tmp22_;
				NoisePlayListCategory* _tmp23_;
				NoiseSourceListItem* _tmp24_;
				_tmp22_ = _data31_->sourcelist_item;
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp22_, TRUE);
				_tmp23_ = self->priv->playlists_category;
				_tmp24_ = _data31_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp23_, (GraniteWidgetsSourceListItem*) _tmp24_);
			} else {
				NoiseSourceListItem* _tmp25_;
				NoiseSourceListItem* _tmp26_;
				_tmp25_ = _data31_->sourcelist_item;
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp25_, TRUE);
				_tmp26_ = _data31_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp26_);
			}
			break;
		}
		case NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
		{
			if (into_expandable == NULL) {
				NoiseSourceListItem* _tmp27_;
				NoisePlayListCategory* _tmp28_;
				NoiseSourceListItem* _tmp29_;
				_tmp27_ = _data31_->sourcelist_item;
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp27_, FALSE);
				_tmp28_ = self->priv->playlists_category;
				_tmp29_ = _data31_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp28_, (GraniteWidgetsSourceListItem*) _tmp29_);
			} else {
				NoiseSourceListItem* _tmp30_;
				NoiseSourceListItem* _tmp31_;
				_tmp30_ = _data31_->sourcelist_item;
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp30_, FALSE);
				_tmp31_ = _data31_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp31_);
			}
			break;
		}
		case NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
		{
			if (into_expandable == NULL) {
				NoiseSourceListItem* _tmp32_;
				NoisePlayListCategory* _tmp33_;
				NoiseSourceListItem* _tmp34_;
				_tmp32_ = _data31_->sourcelist_item;
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp32_, TRUE);
				_tmp33_ = self->priv->playlists_category;
				_tmp34_ = _data31_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp33_, (GraniteWidgetsSourceListItem*) _tmp34_);
			} else {
				NoiseSourceListItem* _tmp35_;
				_tmp35_ = _data31_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp35_);
			}
			break;
		}
		case NOISE_VIEW_WRAPPER_HINT_DEVICE:
		{
			if (into_expandable == NULL) {
				GraniteWidgetsSourceListExpandableItem* _tmp36_;
				NoiseSourceListExpandableItem* _tmp37_;
				_tmp36_ = self->priv->devices_category;
				_tmp37_ = _data31_->expandable_item;
				granite_widgets_source_list_expandable_item_add (_tmp36_, (GraniteWidgetsSourceListItem*) _tmp37_);
			} else {
				NoiseSourceListExpandableItem* _tmp38_;
				_tmp38_ = _data31_->expandable_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp38_);
			}
			break;
		}
		case NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO:
		{
			if (into_expandable == NULL) {
				GraniteWidgetsSourceListExpandableItem* _tmp39_;
				NoiseSourceListExpandableItem* _tmp40_;
				_tmp39_ = self->priv->devices_category;
				_tmp40_ = _data31_->expandable_item;
				granite_widgets_source_list_expandable_item_add (_tmp39_, (GraniteWidgetsSourceListItem*) _tmp40_);
			} else {
				NoiseSourceListExpandableItem* _tmp41_;
				_tmp41_ = _data31_->expandable_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp41_);
			}
			break;
		}
		case NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE:
		{
			if (into_expandable == NULL) {
				GraniteWidgetsSourceListExpandableItem* _tmp42_;
				NoiseSourceListItem* _tmp43_;
				_tmp42_ = self->priv->network_category;
				_tmp43_ = _data31_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add (_tmp42_, (GraniteWidgetsSourceListItem*) _tmp43_);
			} else {
				NoiseSourceListItem* _tmp44_;
				_tmp44_ = _data31_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp44_);
			}
			break;
		}
		default:
		{
			break;
		}
	}
	if (hint == NOISE_VIEW_WRAPPER_HINT_DEVICE) {
		NoiseSourceListExpandableItem* _tmp45_;
		NoiseSourceListEntry* _tmp46_;
		_tmp45_ = _data31_->expandable_item;
		_tmp46_ = _g_object_ref0 ((NoiseSourceListEntry*) _tmp45_);
		result = _tmp46_;
		block31_data_unref (_data31_);
		_data31_ = NULL;
		return result;
	} else {
		NoiseSourceListItem* _tmp47_;
		NoiseSourceListEntry* _tmp48_;
		_tmp47_ = _data31_->sourcelist_item;
		_tmp48_ = _g_object_ref0 ((NoiseSourceListEntry*) _tmp47_);
		result = _tmp48_;
		block31_data_unref (_data31_);
		_data31_ = NULL;
		return result;
	}
	block31_data_unref (_data31_);
	_data31_ = NULL;
}


static void
noise_source_list_view_real_item_selected (GraniteWidgetsSourceList* base,
                                           GraniteWidgetsSourceListItem* item)
{
	NoiseSourceListView * self;
	self = (NoiseSourceListView*) base;
	if (G_TYPE_CHECK_INSTANCE_TYPE (item, NOISE_TYPE_SOURCE_LIST_ITEM)) {
		NoiseSourceListItem* sidebar_item = NULL;
		NoiseSourceListItem* _tmp0_;
		NoiseSourceListItem* _tmp1_;
		GtkGrid* _tmp2_;
		GtkGrid* _tmp3_;
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (item, NOISE_TYPE_SOURCE_LIST_ITEM) ? ((NoiseSourceListItem*) item) : NULL);
		sidebar_item = _tmp0_;
		_tmp1_ = sidebar_item;
		_tmp2_ = noise_source_list_item_get_view (_tmp1_);
		_tmp3_ = _tmp2_;
		g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL], 0, _tmp3_);
		_g_object_unref0 (sidebar_item);
	} else {
		if (G_TYPE_CHECK_INSTANCE_TYPE (item, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
			NoiseSourceListExpandableItem* sidebar_item = NULL;
			NoiseSourceListExpandableItem* _tmp4_;
			NoiseSourceListExpandableItem* _tmp5_;
			GtkGrid* _tmp6_;
			GtkGrid* _tmp7_;
			_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (item, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM) ? ((NoiseSourceListExpandableItem*) item) : NULL);
			sidebar_item = _tmp4_;
			_tmp5_ = sidebar_item;
			_tmp6_ = noise_source_list_expandable_item_get_view (_tmp5_);
			_tmp7_ = _tmp6_;
			g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL], 0, _tmp7_);
			_g_object_unref0 (sidebar_item);
		}
	}
}


void
noise_source_list_view_remove_playlist (NoiseSourceListView* self,
                                        NoiseViewWrapper* view)
{
	GeeTreeSet* items = NULL;
	GeeTreeSet* _tmp15_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (view != NULL);
	{
		GeeIterator* _playlist_it = NULL;
		NoisePlayListCategory* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->playlists_category;
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_playlist_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* playlist = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListItem* _tmp9_;
			_tmp6_ = _playlist_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _playlist_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			playlist = (GraniteWidgetsSourceListItem*) _tmp8_;
			_tmp9_ = playlist;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
				GraniteWidgetsSourceListItem* _tmp10_;
				GtkGrid* _tmp11_;
				GtkGrid* _tmp12_;
				_tmp10_ = playlist;
				_tmp11_ = noise_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem));
				_tmp12_ = _tmp11_;
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp12_) {
					NoisePlayListCategory* _tmp13_;
					GraniteWidgetsSourceListItem* _tmp14_;
					_tmp13_ = self->priv->playlists_category;
					_tmp14_ = playlist;
					granite_widgets_source_list_expandable_item_remove ((GraniteWidgetsSourceListExpandableItem*) _tmp13_, _tmp14_);
					_g_object_unref0 (playlist);
					_g_object_unref0 (_playlist_it);
					return;
				}
			}
			_g_object_unref0 (playlist);
		}
		_g_object_unref0 (_playlist_it);
	}
	_tmp15_ = gee_tree_set_new (NOISE_TYPE_SOURCE_LIST_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	items = _tmp15_;
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
		GeeCollection* _tmp19_;
		GeeIterator* _tmp20_;
		GeeIterator* _tmp21_;
		_tmp16_ = self->priv->devices_category;
		_tmp17_ = granite_widgets_source_list_expandable_item_get_children (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = _tmp18_;
		_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
		_tmp21_ = _tmp20_;
		_g_object_unref0 (_tmp19_);
		_device_it = _tmp21_;
		while (TRUE) {
			GeeIterator* _tmp22_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp23_;
			gpointer _tmp24_;
			GraniteWidgetsSourceListItem* _tmp25_;
			_tmp22_ = _device_it;
			if (!gee_iterator_next (_tmp22_)) {
				break;
			}
			_tmp23_ = _device_it;
			_tmp24_ = gee_iterator_get (_tmp23_);
			device = (GraniteWidgetsSourceListItem*) _tmp24_;
			_tmp25_ = device;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp25_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
				GraniteWidgetsSourceListItem* _tmp26_;
				_tmp26_ = device;
				noise_source_list_view_enumerate_children_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem), &items);
				{
					GeeIterator* _item_it = NULL;
					GeeTreeSet* _tmp27_;
					GeeIterator* _tmp28_;
					_tmp27_ = items;
					_tmp28_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp27_);
					_item_it = _tmp28_;
					while (TRUE) {
						GeeIterator* _tmp29_;
						NoiseSourceListItem* item = NULL;
						GeeIterator* _tmp30_;
						gpointer _tmp31_;
						NoiseSourceListItem* _tmp32_;
						GtkGrid* _tmp33_;
						GtkGrid* _tmp34_;
						_tmp29_ = _item_it;
						if (!gee_iterator_next (_tmp29_)) {
							break;
						}
						_tmp30_ = _item_it;
						_tmp31_ = gee_iterator_get (_tmp30_);
						item = (NoiseSourceListItem*) _tmp31_;
						_tmp32_ = item;
						_tmp33_ = noise_source_list_item_get_view (_tmp32_);
						_tmp34_ = _tmp33_;
						if (_tmp34_ == G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid)) {
							NoiseSourceListItem* _tmp35_;
							GraniteWidgetsSourceListExpandableItem* _tmp36_;
							GraniteWidgetsSourceListExpandableItem* _tmp37_;
							NoiseSourceListItem* _tmp38_;
							_tmp35_ = item;
							_tmp36_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) _tmp35_);
							_tmp37_ = _tmp36_;
							_tmp38_ = item;
							granite_widgets_source_list_expandable_item_remove (_tmp37_, (GraniteWidgetsSourceListItem*) _tmp38_);
							_g_object_unref0 (item);
							_g_object_unref0 (_item_it);
							_g_object_unref0 (device);
							_g_object_unref0 (_device_it);
							_g_object_unref0 (items);
							return;
						}
						_g_object_unref0 (item);
					}
					_g_object_unref0 (_item_it);
				}
			}
			_g_object_unref0 (device);
		}
		_g_object_unref0 (_device_it);
	}
	_g_object_unref0 (items);
}


GeeCollection*
noise_source_list_view_remove_device (NoiseSourceListView* self,
                                      NoiseDeviceView* view)
{
	GeeCollection* result = NULL;
	GeeTreeSet* pages = NULL;
	GeeTreeSet* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (view != NULL, NULL);
	_tmp0_ = gee_tree_set_new (gtk_grid_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	pages = _tmp0_;
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
		_tmp1_ = self->priv->devices_category;
		_tmp2_ = granite_widgets_source_list_expandable_item_get_children (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = _tmp3_;
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
		_tmp6_ = _tmp5_;
		_g_object_unref0 (_tmp4_);
		_device_it = _tmp6_;
		while (TRUE) {
			GeeIterator* _tmp7_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GraniteWidgetsSourceListItem* _tmp10_;
			_tmp7_ = _device_it;
			if (!gee_iterator_next (_tmp7_)) {
				break;
			}
			_tmp8_ = _device_it;
			_tmp9_ = gee_iterator_get (_tmp8_);
			device = (GraniteWidgetsSourceListItem*) _tmp9_;
			_tmp10_ = device;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
				GraniteWidgetsSourceListItem* _tmp11_;
				GtkGrid* _tmp12_;
				GtkGrid* _tmp13_;
				_tmp11_ = device;
				_tmp12_ = noise_source_list_expandable_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem));
				_tmp13_ = _tmp12_;
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp13_) {
					GraniteWidgetsSourceListItem* _tmp14_;
					GraniteWidgetsSourceListExpandableItem* _tmp15_;
					GraniteWidgetsSourceListItem* _tmp16_;
					_tmp14_ = device;
					noise_source_list_view_enumerate_children_pages (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem), &pages);
					_tmp15_ = self->priv->devices_category;
					_tmp16_ = device;
					granite_widgets_source_list_expandable_item_remove (_tmp15_, _tmp16_);
					result = (GeeCollection*) pages;
					_g_object_unref0 (device);
					_g_object_unref0 (_device_it);
					return result;
				}
			}
			_g_object_unref0 (device);
		}
		_g_object_unref0 (_device_it);
	}
	result = (GeeCollection*) pages;
	return result;
}


static GtkGrid*
noise_source_list_view_get_device_from_item (NoiseSourceListView* self,
                                             NoiseSourceListExpandableItem* item)
{
	GtkGrid* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (item != NULL, NULL);
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->devices_category;
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_device_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListExpandableItem* _tmp9_;
			GraniteWidgetsSourceListExpandableItem* _tmp10_;
			GraniteWidgetsSourceListItem* _tmp11_;
			_tmp6_ = _device_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _device_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			device = (GraniteWidgetsSourceListItem*) _tmp8_;
			_tmp9_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) item);
			_tmp10_ = _tmp9_;
			_tmp11_ = device;
			if (_tmp10_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem)) {
				GraniteWidgetsSourceListItem* _tmp12_;
				_tmp12_ = device;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
					GraniteWidgetsSourceListItem* _tmp13_;
					GtkGrid* _tmp14_;
					GtkGrid* _tmp15_;
					GtkGrid* _tmp16_;
					_tmp13_ = device;
					_tmp14_ = noise_source_list_expandable_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem));
					_tmp15_ = _tmp14_;
					_tmp16_ = _g_object_ref0 (_tmp15_);
					result = _tmp16_;
					_g_object_unref0 (device);
					_g_object_unref0 (_device_it);
					return result;
				}
			}
			_g_object_unref0 (device);
		}
		_g_object_unref0 (_device_it);
	}
	result = NULL;
	return result;
}


static void
noise_source_list_view_enumerate_children_pages (NoiseSourceListView* self,
                                                 NoiseSourceListExpandableItem* exp_item,
                                                 GeeTreeSet* * pages)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (exp_item != NULL);
	g_return_if_fail (*pages != NULL);
	{
		GeeIterator* _views_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
		_tmp0_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) G_TYPE_CHECK_INSTANCE_CAST (exp_item, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem));
		_tmp1_ = _tmp0_;
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_views_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			GraniteWidgetsSourceListItem* views = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GraniteWidgetsSourceListItem* _tmp8_;
			_tmp5_ = _views_it;
			if (!gee_iterator_next (_tmp5_)) {
				break;
			}
			_tmp6_ = _views_it;
			_tmp7_ = gee_iterator_get (_tmp6_);
			views = (GraniteWidgetsSourceListItem*) _tmp7_;
			_tmp8_ = views;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
				GraniteWidgetsSourceListItem* _tmp9_;
				GtkGrid* _tmp10_;
				GtkGrid* _tmp11_;
				GraniteWidgetsSourceListItem* _tmp12_;
				_tmp9_ = views;
				_tmp10_ = noise_source_list_expandable_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem));
				_tmp11_ = _tmp10_;
				gee_abstract_collection_add ((GeeAbstractCollection*) (*pages), _tmp11_);
				_tmp12_ = views;
				noise_source_list_view_enumerate_children_pages (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem), pages);
			} else {
				GraniteWidgetsSourceListItem* _tmp13_;
				_tmp13_ = views;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
					GraniteWidgetsSourceListItem* _tmp14_;
					GtkGrid* _tmp15_;
					GtkGrid* _tmp16_;
					_tmp14_ = views;
					_tmp15_ = noise_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem));
					_tmp16_ = _tmp15_;
					gee_abstract_collection_add ((GeeAbstractCollection*) (*pages), _tmp16_);
				}
			}
			_g_object_unref0 (views);
		}
		_g_object_unref0 (_views_it);
	}
}


static void
noise_source_list_view_enumerate_children_items (NoiseSourceListView* self,
                                                 NoiseSourceListExpandableItem* exp_item,
                                                 GeeTreeSet* * pages)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (exp_item != NULL);
	g_return_if_fail (*pages != NULL);
	{
		GeeIterator* _views_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
		_tmp0_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) G_TYPE_CHECK_INSTANCE_CAST (exp_item, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem));
		_tmp1_ = _tmp0_;
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_views_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			GraniteWidgetsSourceListItem* views = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GraniteWidgetsSourceListItem* _tmp8_;
			_tmp5_ = _views_it;
			if (!gee_iterator_next (_tmp5_)) {
				break;
			}
			_tmp6_ = _views_it;
			_tmp7_ = gee_iterator_get (_tmp6_);
			views = (GraniteWidgetsSourceListItem*) _tmp7_;
			_tmp8_ = views;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
				GraniteWidgetsSourceListItem* _tmp9_;
				_tmp9_ = views;
				noise_source_list_view_enumerate_children_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem), pages);
			} else {
				GraniteWidgetsSourceListItem* _tmp10_;
				_tmp10_ = views;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
					GraniteWidgetsSourceListItem* _tmp11_;
					_tmp11_ = views;
					gee_abstract_collection_add ((GeeAbstractCollection*) (*pages), G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem));
				}
			}
			_g_object_unref0 (views);
		}
		_g_object_unref0 (_views_it);
	}
}


void
noise_source_list_view_change_playlist_name (NoiseSourceListView* self,
                                             NoiseViewWrapper* view,
                                             const gchar* new_name)
{
	GeeTreeSet* items = NULL;
	GeeTreeSet* _tmp14_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (view != NULL);
	g_return_if_fail (new_name != NULL);
	{
		GeeIterator* _playlist_it = NULL;
		NoisePlayListCategory* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->playlists_category;
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_playlist_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* playlist = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListItem* _tmp9_;
			_tmp6_ = _playlist_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _playlist_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			playlist = (GraniteWidgetsSourceListItem*) _tmp8_;
			_tmp9_ = playlist;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
				GraniteWidgetsSourceListItem* _tmp10_;
				GtkGrid* _tmp11_;
				GtkGrid* _tmp12_;
				_tmp10_ = playlist;
				_tmp11_ = noise_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem));
				_tmp12_ = _tmp11_;
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp12_) {
					GraniteWidgetsSourceListItem* _tmp13_;
					_tmp13_ = playlist;
					granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem), new_name);
					_g_object_unref0 (playlist);
					_g_object_unref0 (_playlist_it);
					return;
				}
			}
			_g_object_unref0 (playlist);
		}
		_g_object_unref0 (_playlist_it);
	}
	_tmp14_ = gee_tree_set_new (NOISE_TYPE_SOURCE_LIST_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	items = _tmp14_;
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp15_;
		GeeCollection* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
		GeeIterator* _tmp19_;
		GeeIterator* _tmp20_;
		_tmp15_ = self->priv->devices_category;
		_tmp16_ = granite_widgets_source_list_expandable_item_get_children (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = _tmp17_;
		_tmp19_ = gee_iterable_iterator ((GeeIterable*) _tmp18_);
		_tmp20_ = _tmp19_;
		_g_object_unref0 (_tmp18_);
		_device_it = _tmp20_;
		while (TRUE) {
			GeeIterator* _tmp21_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp22_;
			gpointer _tmp23_;
			GraniteWidgetsSourceListItem* _tmp24_;
			_tmp21_ = _device_it;
			if (!gee_iterator_next (_tmp21_)) {
				break;
			}
			_tmp22_ = _device_it;
			_tmp23_ = gee_iterator_get (_tmp22_);
			device = (GraniteWidgetsSourceListItem*) _tmp23_;
			_tmp24_ = device;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp24_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
				GraniteWidgetsSourceListItem* _tmp25_;
				_tmp25_ = device;
				noise_source_list_view_enumerate_children_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem), &items);
				{
					GeeIterator* _item_it = NULL;
					GeeTreeSet* _tmp26_;
					GeeIterator* _tmp27_;
					_tmp26_ = items;
					_tmp27_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp26_);
					_item_it = _tmp27_;
					while (TRUE) {
						GeeIterator* _tmp28_;
						NoiseSourceListItem* item = NULL;
						GeeIterator* _tmp29_;
						gpointer _tmp30_;
						NoiseSourceListItem* _tmp31_;
						GtkGrid* _tmp32_;
						GtkGrid* _tmp33_;
						_tmp28_ = _item_it;
						if (!gee_iterator_next (_tmp28_)) {
							break;
						}
						_tmp29_ = _item_it;
						_tmp30_ = gee_iterator_get (_tmp29_);
						item = (NoiseSourceListItem*) _tmp30_;
						_tmp31_ = item;
						_tmp32_ = noise_source_list_item_get_view (_tmp31_);
						_tmp33_ = _tmp32_;
						if (_tmp33_ == G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid)) {
							NoiseSourceListItem* _tmp34_;
							_tmp34_ = item;
							granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem), new_name);
							_g_object_unref0 (item);
							_g_object_unref0 (_item_it);
							_g_object_unref0 (device);
							_g_object_unref0 (_device_it);
							_g_object_unref0 (items);
							return;
						}
						_g_object_unref0 (item);
					}
					_g_object_unref0 (_item_it);
				}
			}
			_g_object_unref0 (device);
		}
		_g_object_unref0 (_device_it);
	}
	_g_object_unref0 (items);
}


void
noise_source_list_view_change_device_name (NoiseSourceListView* self,
                                           NoiseDeviceView* view,
                                           const gchar* new_name)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (view != NULL);
	g_return_if_fail (new_name != NULL);
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->devices_category;
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_device_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListItem* _tmp9_;
			_tmp6_ = _device_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _device_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			device = (GraniteWidgetsSourceListItem*) _tmp8_;
			_tmp9_ = device;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
				GraniteWidgetsSourceListItem* _tmp10_;
				GtkGrid* _tmp11_;
				GtkGrid* _tmp12_;
				_tmp10_ = device;
				_tmp11_ = noise_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem));
				_tmp12_ = _tmp11_;
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp12_) {
					GraniteWidgetsSourceListItem* _tmp13_;
					_tmp13_ = device;
					granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem), new_name);
					_g_object_unref0 (device);
					_g_object_unref0 (_device_it);
					return;
				}
			}
			_g_object_unref0 (device);
		}
		_g_object_unref0 (_device_it);
	}
}


static void
g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_STRING) (gpointer data1, gpointer arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_string (param_values + 2), data2);
}


static void
noise_source_list_view_class_init (NoiseSourceListViewClass * klass)
{
	noise_source_list_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseSourceListView_private_offset);
	((GraniteWidgetsSourceListClass *) klass)->item_selected = (void (*) (GraniteWidgetsSourceList *, GraniteWidgetsSourceListItem*)) noise_source_list_view_real_item_selected;
	G_OBJECT_CLASS (klass)->finalize = noise_source_list_view_finalize;
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_EDITED_SIGNAL] = g_signal_new ("edited", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING, G_TYPE_NONE, 2, gtk_grid_get_type (), G_TYPE_STRING);
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_ITEM_ACTION_ACTIVATED_SIGNAL] = g_signal_new ("item-action-activated", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_ACTIVATED_SIGNAL] = g_signal_new ("activated", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_RENAME_CLICKED_SIGNAL] = g_signal_new ("playlist-rename-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_EDIT_CLICKED_SIGNAL] = g_signal_new ("playlist-edit-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_REMOVE_CLICKED_SIGNAL] = g_signal_new ("playlist-remove-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_SAVE_CLICKED_SIGNAL] = g_signal_new ("playlist-save-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_EXPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-export-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_IMPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-import-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_MEDIA_ADDED_SIGNAL] = g_signal_new ("playlist-media-added", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT, G_TYPE_NONE, 3, gtk_grid_get_type (), G_TYPE_STRV, G_TYPE_INT);
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_IMPORT_CLICKED_SIGNAL] = g_signal_new ("device-import-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_EJECT_CLICKED_SIGNAL] = g_signal_new ("device-eject-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_SYNC_CLICKED_SIGNAL] = g_signal_new ("device-sync-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-playlist-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-smartplaylist-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
}


static void
noise_source_list_view_instance_init (NoiseSourceListView * self)
{
	self->priv = noise_source_list_view_get_instance_private (self);
}


static void
noise_source_list_view_finalize (GObject * obj)
{
	NoiseSourceListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SOURCE_LIST_VIEW, NoiseSourceListView);
	_g_object_unref0 (self->priv->library_category);
	_g_object_unref0 (self->priv->devices_category);
	_g_object_unref0 (self->priv->network_category);
	_g_object_unref0 (self->priv->playlists_category);
	G_OBJECT_CLASS (noise_source_list_view_parent_class)->finalize (obj);
}


GType
noise_source_list_view_get_type (void)
{
	static volatile gsize noise_source_list_view_type_id__volatile = 0;
	if (g_once_init_enter (&noise_source_list_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSourceListViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_source_list_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSourceListView), 0, (GInstanceInitFunc) noise_source_list_view_instance_init, NULL };
		GType noise_source_list_view_type_id;
		noise_source_list_view_type_id = g_type_register_static (GRANITE_WIDGETS_TYPE_SOURCE_LIST, "NoiseSourceListView", &g_define_type_info, 0);
		NoiseSourceListView_private_offset = g_type_add_instance_private (noise_source_list_view_type_id, sizeof (NoiseSourceListViewPrivate));
		g_once_init_leave (&noise_source_list_view_type_id__volatile, noise_source_list_view_type_id);
	}
	return noise_source_list_view_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



