/* NotImportedDialog.c generated by valac 0.41.91, the Vala compiler
 * generated from NotImportedDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */
/* Merely a place holder for multiple pieces of information regarding
 * the current media playing. Mostly here because of dependence. */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gio/gio.h>


#define NOISE_TYPE_NOT_IMPORTED_DIALOG (noise_not_imported_dialog_get_type ())
#define NOISE_NOT_IMPORTED_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_NOT_IMPORTED_DIALOG, NoiseNotImportedDialog))
#define NOISE_NOT_IMPORTED_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_NOT_IMPORTED_DIALOG, NoiseNotImportedDialogClass))
#define NOISE_IS_NOT_IMPORTED_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_NOT_IMPORTED_DIALOG))
#define NOISE_IS_NOT_IMPORTED_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_NOT_IMPORTED_DIALOG))
#define NOISE_NOT_IMPORTED_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_NOT_IMPORTED_DIALOG, NoiseNotImportedDialogClass))

typedef struct _NoiseNotImportedDialog NoiseNotImportedDialog;
typedef struct _NoiseNotImportedDialogClass NoiseNotImportedDialogClass;
typedef struct _NoiseNotImportedDialogPrivate NoiseNotImportedDialogPrivate;
enum  {
	NOISE_NOT_IMPORTED_DIALOG_0_PROPERTY,
	NOISE_NOT_IMPORTED_DIALOG_NUM_PROPERTIES
};
static GParamSpec* noise_not_imported_dialog_properties[NOISE_NOT_IMPORTED_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block12Data Block12Data;

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

struct _NoiseNotImportedDialog {
	GtkDialog parent_instance;
	NoiseNotImportedDialogPrivate * priv;
};

struct _NoiseNotImportedDialogClass {
	GtkDialogClass parent_class;
	void (*moveToTrashClick) (NoiseNotImportedDialog* self);
	void (*ignoreClick) (NoiseNotImportedDialog* self);
};

struct _NoiseNotImportedDialogPrivate {
	GeeLinkedList* _files;
	gchar* music_folder;
	GtkListStore* filesModel;
	GtkButton* moveToTrash;
};

struct _Block12Data {
	int _ref_count_;
	NoiseNotImportedDialog* self;
	GtkCheckButton* trashAll;
	GtkTreeView* filesView;
	GtkExpander* expander;
};


static gint NoiseNotImportedDialog_private_offset;
static gpointer noise_not_imported_dialog_parent_class = NULL;

GType noise_not_imported_dialog_get_type (void) G_GNUC_CONST;
NoiseNotImportedDialog* noise_not_imported_dialog_new (GeeCollection* files,
                                                       const gchar* music);
NoiseNotImportedDialog* noise_not_imported_dialog_construct (GType object_type,
                                                             GeeCollection* files,
                                                             const gchar* music);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
void noise_not_imported_dialog_moveToTrashClick (NoiseNotImportedDialog* self);
static void _noise_not_imported_dialog_moveToTrashClick_gtk_button_clicked (GtkButton* _sender,
                                                                     gpointer self);
static void __lambda13_ (NoiseNotImportedDialog* self,
                  GtkCellRendererToggle* toggle,
                  const gchar* path);
gboolean noise_not_imported_dialog_updateMoveToTrashSensetivity (NoiseNotImportedDialog* self,
                                                                 GtkTreeModel* model,
                                                                 GtkTreePath* path,
                                                                 GtkTreeIter* iter);
static gboolean _noise_not_imported_dialog_updateMoveToTrashSensetivity_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                              GtkTreePath* path,
                                                                                              GtkTreeIter* iter,
                                                                                              gpointer self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void ___lambda13__gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                                    const gchar* path,
                                                    gpointer self);
static void __lambda14_ (Block12Data* _data12_);
gboolean noise_not_imported_dialog_selectAll (NoiseNotImportedDialog* self,
                                              GtkTreeModel* model,
                                              GtkTreePath* path,
                                              GtkTreeIter* iter);
static gboolean _noise_not_imported_dialog_selectAll_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                           GtkTreePath* path,
                                                                           GtkTreeIter* iter,
                                                                           gpointer self);
gboolean noise_not_imported_dialog_unselectAll (NoiseNotImportedDialog* self,
                                                GtkTreeModel* model,
                                                GtkTreePath* path,
                                                GtkTreeIter* iter);
static gboolean _noise_not_imported_dialog_unselectAll_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                             GtkTreePath* path,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self);
static void ___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda15_ (NoiseNotImportedDialog* self);
static void ___lambda15__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda16_ (Block12Data* _data12_);
static void ___lambda16__gtk_expander_activate (GtkExpander* _sender,
                                         gpointer self);
gboolean noise_not_imported_dialog_deleteSelectedItems (NoiseNotImportedDialog* self,
                                                        GtkTreeModel* model,
                                                        GtkTreePath* path,
                                                        GtkTreeIter* iter);
static void noise_not_imported_dialog_real_moveToTrashClick (NoiseNotImportedDialog* self);
static gboolean _noise_not_imported_dialog_deleteSelectedItems_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                     GtkTreePath* path,
                                                                                     GtkTreeIter* iter,
                                                                                     gpointer self);
void noise_not_imported_dialog_ignoreClick (NoiseNotImportedDialog* self);
static void noise_not_imported_dialog_real_ignoreClick (NoiseNotImportedDialog* self);
static void noise_not_imported_dialog_finalize (GObject * obj);


static inline gpointer
noise_not_imported_dialog_get_instance_private (NoiseNotImportedDialog* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseNotImportedDialog_private_offset);
}


static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
	g_atomic_int_inc (&_data12_->_ref_count_);
	return _data12_;
}


static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
		NoiseNotImportedDialog* self;
		self = _data12_->self;
		_g_object_unref0 (_data12_->expander);
		_g_object_unref0 (_data12_->filesView);
		_g_object_unref0 (_data12_->trashAll);
		_g_object_unref0 (self);
		g_slice_free (Block12Data, _data12_);
	}
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch21_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch21_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally21;
	__catch21_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally21:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static void
_noise_not_imported_dialog_moveToTrashClick_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self)
{
	noise_not_imported_dialog_moveToTrashClick ((NoiseNotImportedDialog*) self);
}


static gboolean
_noise_not_imported_dialog_updateMoveToTrashSensetivity_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                     GtkTreePath* path,
                                                                                     GtkTreeIter* iter,
                                                                                     gpointer self)
{
	gboolean result;
	result = noise_not_imported_dialog_updateMoveToTrashSensetivity ((NoiseNotImportedDialog*) self, model, path, iter);
	return result;
}


static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}


static void
__lambda13_ (NoiseNotImportedDialog* self,
             GtkCellRendererToggle* toggle,
             const gchar* path)
{
	GtkTreePath* tree_path = NULL;
	GtkTreePath* _tmp0_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	GtkListStore* _tmp3_;
	GtkTreeIter _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GtkButton* _tmp7_;
	GtkListStore* _tmp8_;
	g_return_if_fail (toggle != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = gtk_tree_path_new_from_string (path);
	tree_path = _tmp0_;
	_tmp1_ = self->priv->filesModel;
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp1_, &_tmp2_, tree_path);
	iter = _tmp2_;
	_tmp3_ = self->priv->filesModel;
	_tmp4_ = iter;
	_tmp5_ = gtk_cell_renderer_toggle_get_active (toggle);
	_tmp6_ = _tmp5_;
	gtk_list_store_set (_tmp3_, &_tmp4_, 0, !_tmp6_, -1);
	_tmp7_ = self->priv->moveToTrash;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
	_tmp8_ = self->priv->filesModel;
	gtk_tree_model_foreach ((GtkTreeModel*) _tmp8_, _noise_not_imported_dialog_updateMoveToTrashSensetivity_gtk_tree_model_foreach_func, self);
	__vala_GtkTreePath_free0 (tree_path);
}


static void
___lambda13__gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                               const gchar* path,
                                               gpointer self)
{
	__lambda13_ ((NoiseNotImportedDialog*) self, _sender, path);
}


static gboolean
_noise_not_imported_dialog_selectAll_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                  GtkTreePath* path,
                                                                  GtkTreeIter* iter,
                                                                  gpointer self)
{
	gboolean result;
	result = noise_not_imported_dialog_selectAll ((NoiseNotImportedDialog*) self, model, path, iter);
	return result;
}


static gboolean
_noise_not_imported_dialog_unselectAll_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                    GtkTreePath* path,
                                                                    GtkTreeIter* iter,
                                                                    gpointer self)
{
	gboolean result;
	result = noise_not_imported_dialog_unselectAll ((NoiseNotImportedDialog*) self, model, path, iter);
	return result;
}


static void
__lambda14_ (Block12Data* _data12_)
{
	NoiseNotImportedDialog* self;
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data12_->self;
	_tmp0_ = _data12_->trashAll;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GtkListStore* _tmp3_;
		GtkTreeView* _tmp4_;
		GtkButton* _tmp5_;
		_tmp3_ = self->priv->filesModel;
		gtk_tree_model_foreach ((GtkTreeModel*) _tmp3_, _noise_not_imported_dialog_selectAll_gtk_tree_model_foreach_func, self);
		_tmp4_ = _data12_->filesView;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, FALSE);
		_tmp5_ = self->priv->moveToTrash;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, TRUE);
	} else {
		GtkListStore* _tmp6_;
		GtkTreeView* _tmp7_;
		GtkButton* _tmp8_;
		_tmp6_ = self->priv->filesModel;
		gtk_tree_model_foreach ((GtkTreeModel*) _tmp6_, _noise_not_imported_dialog_unselectAll_gtk_tree_model_foreach_func, self);
		_tmp7_ = _data12_->filesView;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, TRUE);
		_tmp8_ = self->priv->moveToTrash;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
	}
}


static void
___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
	__lambda14_ (self);
}


static void
__lambda15_ (NoiseNotImportedDialog* self)
{
	gtk_widget_destroy ((GtkWidget*) self);
}


static void
___lambda15__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda15_ ((NoiseNotImportedDialog*) self);
}


static void
__lambda16_ (Block12Data* _data12_)
{
	NoiseNotImportedDialog* self;
	self = _data12_->self;
	if (gtk_expander_get_expanded (_data12_->expander)) {
		gtk_widget_set_size_request ((GtkWidget*) _data12_->expander, -1, -1);
	} else {
		gtk_widget_set_size_request ((GtkWidget*) _data12_->expander, -1, 120);
	}
}


static void
___lambda16__gtk_expander_activate (GtkExpander* _sender,
                                    gpointer self)
{
	__lambda16_ (self);
}


NoiseNotImportedDialog*
noise_not_imported_dialog_construct (GType object_type,
                                     GeeCollection* files,
                                     const gchar* music)
{
	NoiseNotImportedDialog * self = NULL;
	Block12Data* _data12_;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	gchar* _tmp2_;
	NoiseLibraryWindow* _tmp3_;
	NoiseLibraryWindow* _tmp4_;
	GtkImage* warning = NULL;
	GtkImage* _tmp5_;
	GtkLabel* title = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkStyleContext* _tmp14_;
	gchar* secondary_text = NULL;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gchar* _tmp19_;
	GtkLabel* info = NULL;
	const gchar* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkCheckButton* _tmp23_;
	GtkCheckButton* _tmp24_;
	GtkCellRendererToggle* toggle = NULL;
	GtkCellRendererToggle* _tmp25_;
	GtkTreeViewColumn* column = NULL;
	GtkTreeViewColumn* _tmp26_;
	GtkTreeViewColumn* _tmp27_;
	GtkTreeViewColumn* _tmp28_;
	GtkCellRendererToggle* _tmp29_;
	GtkTreeViewColumn* _tmp30_;
	GtkCellRendererToggle* _tmp31_;
	GtkListStore* _tmp32_;
	GtkTreeView* _tmp33_;
	GtkTreeView* _tmp34_;
	GtkListStore* _tmp35_;
	GtkTreeView* _tmp36_;
	GtkTreeViewColumn* _tmp37_;
	GtkTreeView* _tmp38_;
	GtkCellRendererText* _tmp39_;
	GtkCellRendererText* _tmp40_;
	GtkTreeView* _tmp41_;
	GtkScrolledWindow* files_scrolled = NULL;
	GtkScrolledWindow* _tmp58_;
	GtkTreeView* _tmp59_;
	GtkExpander* _tmp60_;
	GtkButton* _tmp61_;
	GtkButton* _tmp62_;
	GtkButton* okButton = NULL;
	GtkButton* _tmp63_;
	GtkButtonBox* bottomButtons = NULL;
	GtkButtonBox* _tmp64_;
	GtkButton* _tmp65_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp66_;
	GtkImage* _tmp67_;
	GtkLabel* _tmp68_;
	GtkLabel* _tmp69_;
	GtkCheckButton* _tmp70_;
	GtkBox* _tmp71_;
	GtkButton* _tmp72_;
	GtkCellRendererToggle* _tmp73_;
	GtkCheckButton* _tmp74_;
	g_return_val_if_fail (files != NULL, NULL);
	g_return_val_if_fail (music != NULL, NULL);
	_data12_ = g_slice_new0 (Block12Data);
	_data12_->_ref_count_ = 1;
	self = (NoiseNotImportedDialog*) g_object_new (object_type, NULL);
	_data12_->self = g_object_ref (self);
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->_files);
	self->priv->_files = _tmp0_;
	_tmp1_ = self->priv->_files;
	gee_collection_add_all ((GeeCollection*) _tmp1_, files);
	_tmp2_ = g_strdup (music);
	_g_free0 (self->priv->music_folder);
	self->priv->music_folder = _tmp2_;
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
	_tmp3_ = noise_app_get_main_window ();
	_tmp4_ = _tmp3_;
	gtk_window_set_transient_for ((GtkWindow*) self, (GtkWindow*) _tmp4_);
	gtk_window_set_destroy_with_parent ((GtkWindow*) self, TRUE);
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("dialog-error", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
	g_object_ref_sink (_tmp5_);
	warning = _tmp5_;
	_tmp6_ = self->priv->music_folder;
	_tmp7_ = g_strdup_printf (_ ("Issues while importing from %s"), _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = (GtkLabel*) gtk_label_new (_tmp8_);
	g_object_ref_sink (_tmp9_);
	_tmp10_ = _tmp9_;
	_g_free0 (_tmp8_);
	title = _tmp10_;
	_tmp11_ = title;
	gtk_widget_set_halign ((GtkWidget*) _tmp11_, GTK_ALIGN_START);
	_tmp12_ = title;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp12_, TRUE);
	_tmp13_ = title;
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
	gtk_style_context_add_class (_tmp14_, GRANITE_STYLE_CLASS_PRIMARY_LABEL);
	_tmp15_ = gee_collection_get_size (files);
	_tmp16_ = _tmp15_;
	_tmp17_ = gee_collection_get_size (files);
	_tmp18_ = _tmp17_;
	_tmp19_ = g_strdup_printf (ngettext ("Unable to import %d item. The file may be damaged.", "Unable to import %d items. The files may be damaged.", (gulong) _tmp16_), _tmp18_);
	secondary_text = _tmp19_;
	_tmp20_ = secondary_text;
	_tmp21_ = (GtkLabel*) gtk_label_new (_tmp20_);
	g_object_ref_sink (_tmp21_);
	info = _tmp21_;
	_tmp22_ = info;
	gtk_widget_set_halign ((GtkWidget*) _tmp22_, GTK_ALIGN_START);
	_tmp23_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Move all corrupted files to trash"));
	g_object_ref_sink (_tmp23_);
	_data12_->trashAll = _tmp23_;
	_tmp24_ = _data12_->trashAll;
	gtk_widget_set_valign ((GtkWidget*) _tmp24_, GTK_ALIGN_CENTER);
	_tmp25_ = (GtkCellRendererToggle*) gtk_cell_renderer_toggle_new ();
	g_object_ref_sink (_tmp25_);
	toggle = _tmp25_;
	_tmp26_ = gtk_tree_view_column_new ();
	g_object_ref_sink (_tmp26_);
	column = _tmp26_;
	_tmp27_ = column;
	gtk_tree_view_column_set_title (_tmp27_, _ ("del"));
	_tmp28_ = column;
	_tmp29_ = toggle;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp28_, (GtkCellRenderer*) _tmp29_, FALSE);
	_tmp30_ = column;
	_tmp31_ = toggle;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp30_, (GtkCellRenderer*) _tmp31_, "active", 0);
	_tmp32_ = gtk_list_store_new (2, G_TYPE_BOOLEAN, G_TYPE_STRING, -1);
	_g_object_unref0 (self->priv->filesModel);
	self->priv->filesModel = _tmp32_;
	_tmp33_ = (GtkTreeView*) gtk_tree_view_new ();
	g_object_ref_sink (_tmp33_);
	_data12_->filesView = _tmp33_;
	_tmp34_ = _data12_->filesView;
	_tmp35_ = self->priv->filesModel;
	gtk_tree_view_set_model (_tmp34_, (GtkTreeModel*) _tmp35_);
	_tmp36_ = _data12_->filesView;
	_tmp37_ = column;
	gtk_tree_view_append_column (_tmp36_, _tmp37_);
	_tmp38_ = _data12_->filesView;
	_tmp39_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp39_);
	_tmp40_ = _tmp39_;
	gtk_tree_view_insert_column_with_attributes (_tmp38_, -1, _ ("File Location"), (GtkCellRenderer*) _tmp40_, "text", 1, NULL, NULL);
	_g_object_unref0 (_tmp40_);
	_tmp41_ = _data12_->filesView;
	gtk_tree_view_set_headers_visible (_tmp41_, FALSE);
	{
		GeeIterator* _file_it = NULL;
		GeeIterator* _tmp42_;
		_tmp42_ = gee_iterable_iterator ((GeeIterable*) files);
		_file_it = _tmp42_;
		while (TRUE) {
			GeeIterator* _tmp43_;
			gchar* file = NULL;
			GeeIterator* _tmp44_;
			gpointer _tmp45_;
			GtkTreeIter item = {0};
			GtkListStore* _tmp46_;
			GtkTreeIter _tmp47_ = {0};
			GtkListStore* _tmp48_;
			GtkTreeIter _tmp49_;
			const gchar* _tmp50_;
			const gchar* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
			_tmp43_ = _file_it;
			if (!gee_iterator_next (_tmp43_)) {
				break;
			}
			_tmp44_ = _file_it;
			_tmp45_ = gee_iterator_get (_tmp44_);
			file = (gchar*) _tmp45_;
			_tmp46_ = self->priv->filesModel;
			gtk_list_store_append (_tmp46_, &_tmp47_);
			item = _tmp47_;
			_tmp48_ = self->priv->filesModel;
			_tmp49_ = item;
			_tmp50_ = file;
			_tmp51_ = self->priv->music_folder;
			_tmp52_ = g_strconcat ("file://", _tmp51_, NULL);
			_tmp53_ = _tmp52_;
			_tmp54_ = string_replace (_tmp50_, _tmp53_, "");
			_tmp55_ = _tmp54_;
			_tmp56_ = g_uri_unescape_string (_tmp55_, NULL);
			_tmp57_ = _tmp56_;
			gtk_list_store_set (_tmp48_, &_tmp49_, 0, FALSE, 1, _tmp57_, -1);
			_g_free0 (_tmp57_);
			_g_free0 (_tmp55_);
			_g_free0 (_tmp53_);
			_g_free0 (file);
		}
		_g_object_unref0 (_file_it);
	}
	_tmp58_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp58_);
	files_scrolled = _tmp58_;
	_tmp59_ = _data12_->filesView;
	gtk_container_add ((GtkContainer*) files_scrolled, (GtkWidget*) _tmp59_);
	gtk_scrolled_window_set_policy (files_scrolled, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	g_object_set ((GtkWidget*) files_scrolled, "expand", TRUE, NULL);
	g_object_set ((GtkWidget*) files_scrolled, "margin", 6, NULL);
	_tmp60_ = (GtkExpander*) gtk_expander_new (_ ("Select individual files to move to trash:"));
	g_object_ref_sink (_tmp60_);
	_data12_->expander = _tmp60_;
	gtk_container_add ((GtkContainer*) _data12_->expander, (GtkWidget*) files_scrolled);
	gtk_expander_set_expanded (_data12_->expander, FALSE);
	_tmp61_ = (GtkButton*) gtk_button_new_with_label (_ ("Move to Trash"));
	g_object_ref_sink (_tmp61_);
	_g_object_unref0 (self->priv->moveToTrash);
	self->priv->moveToTrash = _tmp61_;
	_tmp62_ = self->priv->moveToTrash;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp62_, FALSE);
	_tmp63_ = (GtkButton*) gtk_button_new_with_label (_ ("Ignore"));
	g_object_ref_sink (_tmp63_);
	okButton = _tmp63_;
	_tmp64_ = (GtkButtonBox*) gtk_button_box_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp64_);
	bottomButtons = _tmp64_;
	gtk_button_box_set_layout (bottomButtons, GTK_BUTTONBOX_END);
	_tmp65_ = self->priv->moveToTrash;
	gtk_box_pack_end ((GtkBox*) bottomButtons, (GtkWidget*) _tmp65_, FALSE, FALSE, (guint) 0);
	gtk_box_pack_end ((GtkBox*) bottomButtons, (GtkWidget*) okButton, FALSE, FALSE, (guint) 0);
	gtk_box_set_spacing ((GtkBox*) bottomButtons, 12);
	_tmp66_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp66_);
	grid = _tmp66_;
	gtk_grid_set_column_spacing (grid, 12);
	gtk_grid_set_row_spacing (grid, 6);
	g_object_set ((GtkWidget*) grid, "margin", 12, NULL);
	gtk_widget_set_margin_bottom ((GtkWidget*) grid, 0);
	g_object_set ((GtkWidget*) grid, "expand", TRUE, NULL);
	_tmp67_ = warning;
	gtk_grid_attach (grid, (GtkWidget*) _tmp67_, 0, 0, 1, 2);
	_tmp68_ = title;
	gtk_grid_attach (grid, (GtkWidget*) _tmp68_, 1, 0, 1, 1);
	_tmp69_ = info;
	gtk_grid_attach (grid, (GtkWidget*) _tmp69_, 1, 1, 1, 1);
	_tmp70_ = _data12_->trashAll;
	gtk_grid_attach (grid, (GtkWidget*) _tmp70_, 0, 2, 2, 1);
	gtk_grid_attach (grid, (GtkWidget*) _data12_->expander, 0, 3, 2, 1);
	gtk_grid_attach (grid, (GtkWidget*) bottomButtons, 0, 4, 2, 1);
	_tmp71_ = gtk_dialog_get_content_area ((GtkDialog*) self);
	gtk_container_add ((GtkContainer*) _tmp71_, (GtkWidget*) grid);
	_tmp72_ = self->priv->moveToTrash;
	g_signal_connect_object (_tmp72_, "clicked", (GCallback) _noise_not_imported_dialog_moveToTrashClick_gtk_button_clicked, self, 0);
	_tmp73_ = toggle;
	g_signal_connect_object (_tmp73_, "toggled", (GCallback) ___lambda13__gtk_cell_renderer_toggle_toggled, self, 0);
	_tmp74_ = _data12_->trashAll;
	g_signal_connect_data ((GtkToggleButton*) _tmp74_, "toggled", (GCallback) ___lambda14__gtk_toggle_button_toggled, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
	g_signal_connect_object (okButton, "clicked", (GCallback) ___lambda15__gtk_button_clicked, self, 0);
	g_signal_connect_data (_data12_->expander, "activate", (GCallback) ___lambda16__gtk_expander_activate, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (grid);
	_g_object_unref0 (bottomButtons);
	_g_object_unref0 (okButton);
	_g_object_unref0 (files_scrolled);
	_g_object_unref0 (column);
	_g_object_unref0 (toggle);
	_g_object_unref0 (info);
	_g_free0 (secondary_text);
	_g_object_unref0 (title);
	_g_object_unref0 (warning);
	block12_data_unref (_data12_);
	_data12_ = NULL;
	return self;
}


NoiseNotImportedDialog*
noise_not_imported_dialog_new (GeeCollection* files,
                               const gchar* music)
{
	return noise_not_imported_dialog_construct (NOISE_TYPE_NOT_IMPORTED_DIALOG, files, music);
}


gboolean
noise_not_imported_dialog_updateMoveToTrashSensetivity (NoiseNotImportedDialog* self,
                                                        GtkTreeModel* model,
                                                        GtkTreePath* path,
                                                        GtkTreeIter* iter)
{
	gboolean result = FALSE;
	gboolean sel = FALSE;
	GtkTreeIter _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	sel = FALSE;
	_tmp0_ = *iter;
	gtk_tree_model_get (model, &_tmp0_, 0, &sel, -1);
	_tmp1_ = sel;
	if (_tmp1_) {
		GtkButton* _tmp2_;
		_tmp2_ = self->priv->moveToTrash;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, TRUE);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


gboolean
noise_not_imported_dialog_selectAll (NoiseNotImportedDialog* self,
                                     GtkTreeModel* model,
                                     GtkTreePath* path,
                                     GtkTreeIter* iter)
{
	gboolean result = FALSE;
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = self->priv->filesModel;
	_tmp1_ = *iter;
	gtk_list_store_set (_tmp0_, &_tmp1_, 0, TRUE, -1);
	result = FALSE;
	return result;
}


gboolean
noise_not_imported_dialog_unselectAll (NoiseNotImportedDialog* self,
                                       GtkTreeModel* model,
                                       GtkTreePath* path,
                                       GtkTreeIter* iter)
{
	gboolean result = FALSE;
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = self->priv->filesModel;
	_tmp1_ = *iter;
	gtk_list_store_set (_tmp0_, &_tmp1_, 0, FALSE, -1);
	result = FALSE;
	return result;
}


gboolean
noise_not_imported_dialog_deleteSelectedItems (NoiseNotImportedDialog* self,
                                               GtkTreeModel* model,
                                               GtkTreePath* path,
                                               GtkTreeIter* iter)
{
	gboolean result = FALSE;
	gboolean selected = FALSE;
	gchar* location = NULL;
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
	gboolean _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = self->priv->filesModel;
	_tmp1_ = *iter;
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, 0, &selected, -1);
	_tmp2_ = self->priv->filesModel;
	_tmp3_ = *iter;
	gtk_tree_model_get ((GtkTreeModel*) _tmp2_, &_tmp3_, 1, &location, -1);
	_tmp4_ = selected;
	if (_tmp4_) {
		{
			GFile* file = NULL;
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
			_tmp5_ = self->priv->music_folder;
			_tmp6_ = location;
			_tmp7_ = g_strconcat (_tmp5_, _tmp6_, NULL);
			_tmp8_ = _tmp7_;
			_tmp9_ = g_file_new_for_path (_tmp8_);
			_tmp10_ = _tmp9_;
			_g_free0 (_tmp8_);
			file = _tmp10_;
			_tmp11_ = file;
			g_file_trash (_tmp11_, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (file);
				goto __catch22_g_error;
			}
			_g_object_unref0 (file);
		}
		goto __finally22;
		__catch22_g_error:
		{
			GError* err = NULL;
			const gchar* _tmp12_;
			GError* _tmp13_;
			const gchar* _tmp14_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp12_ = location;
			_tmp13_ = err;
			_tmp14_ = _tmp13_->message;
			g_warning ("NotImportedDialog.vala:198: Could not move file %s to recycle: %s\n", _tmp12_, _tmp14_);
			_g_error_free0 (err);
		}
		__finally22:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gboolean _tmp15_ = FALSE;
			_g_free0 (location);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp15_;
		}
	}
	result = FALSE;
	_g_free0 (location);
	return result;
}


static gboolean
_noise_not_imported_dialog_deleteSelectedItems_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                            GtkTreePath* path,
                                                                            GtkTreeIter* iter,
                                                                            gpointer self)
{
	gboolean result;
	result = noise_not_imported_dialog_deleteSelectedItems ((NoiseNotImportedDialog*) self, model, path, iter);
	return result;
}


static void
noise_not_imported_dialog_real_moveToTrashClick (NoiseNotImportedDialog* self)
{
	GtkListStore* _tmp0_;
	_tmp0_ = self->priv->filesModel;
	gtk_tree_model_foreach ((GtkTreeModel*) _tmp0_, _noise_not_imported_dialog_deleteSelectedItems_gtk_tree_model_foreach_func, self);
	gtk_widget_destroy ((GtkWidget*) self);
}


void
noise_not_imported_dialog_moveToTrashClick (NoiseNotImportedDialog* self)
{
	g_return_if_fail (self != NULL);
	NOISE_NOT_IMPORTED_DIALOG_GET_CLASS (self)->moveToTrashClick (self);
}


static void
noise_not_imported_dialog_real_ignoreClick (NoiseNotImportedDialog* self)
{
	gtk_widget_destroy ((GtkWidget*) self);
}


void
noise_not_imported_dialog_ignoreClick (NoiseNotImportedDialog* self)
{
	g_return_if_fail (self != NULL);
	NOISE_NOT_IMPORTED_DIALOG_GET_CLASS (self)->ignoreClick (self);
}


static void
noise_not_imported_dialog_class_init (NoiseNotImportedDialogClass * klass)
{
	noise_not_imported_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseNotImportedDialog_private_offset);
	((NoiseNotImportedDialogClass *) klass)->moveToTrashClick = (void (*) (NoiseNotImportedDialog *)) noise_not_imported_dialog_real_moveToTrashClick;
	((NoiseNotImportedDialogClass *) klass)->ignoreClick = (void (*) (NoiseNotImportedDialog *)) noise_not_imported_dialog_real_ignoreClick;
	G_OBJECT_CLASS (klass)->finalize = noise_not_imported_dialog_finalize;
}


static void
noise_not_imported_dialog_instance_init (NoiseNotImportedDialog * self)
{
	self->priv = noise_not_imported_dialog_get_instance_private (self);
}


static void
noise_not_imported_dialog_finalize (GObject * obj)
{
	NoiseNotImportedDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_NOT_IMPORTED_DIALOG, NoiseNotImportedDialog);
	_g_object_unref0 (self->priv->_files);
	_g_free0 (self->priv->music_folder);
	_g_object_unref0 (self->priv->filesModel);
	_g_object_unref0 (self->priv->moveToTrash);
	G_OBJECT_CLASS (noise_not_imported_dialog_parent_class)->finalize (obj);
}


GType
noise_not_imported_dialog_get_type (void)
{
	static volatile gsize noise_not_imported_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&noise_not_imported_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseNotImportedDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_not_imported_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseNotImportedDialog), 0, (GInstanceInitFunc) noise_not_imported_dialog_instance_init, NULL };
		GType noise_not_imported_dialog_type_id;
		noise_not_imported_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "NoiseNotImportedDialog", &g_define_type_info, 0);
		NoiseNotImportedDialog_private_offset = g_type_add_instance_private (noise_not_imported_dialog_type_id, sizeof (NoiseNotImportedDialogPrivate));
		g_once_init_leave (&noise_not_imported_dialog_type_id__volatile, noise_not_imported_dialog_type_id);
	}
	return noise_not_imported_dialog_type_id__volatile;
}



