/* DevicePreferences.c generated by valac 0.41.91, the Vala compiler
 * generated from DevicePreferences.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <libgda/libgda.h>
#include "io.elementary.music-core.h"


#define NOISE_TYPE_DEVICE_PREFERENCES (noise_device_preferences_get_type ())
#define NOISE_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences))
#define NOISE_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferencesClass))
#define NOISE_IS_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE_PREFERENCES))
#define NOISE_IS_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_DEVICE_PREFERENCES))
#define NOISE_DEVICE_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferencesClass))

typedef struct _NoiseDevicePreferences NoiseDevicePreferences;
typedef struct _NoiseDevicePreferencesClass NoiseDevicePreferencesClass;
typedef struct _NoiseDevicePreferencesPrivate NoiseDevicePreferencesPrivate;
enum  {
	NOISE_DEVICE_PREFERENCES_0_PROPERTY,
	NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY,
	NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY,
	NOISE_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY,
	NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY,
	NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY,
	NOISE_DEVICE_PREFERENCES_NUM_PROPERTIES
};
static GParamSpec* noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _NoiseDevicePreferences {
	GObject parent_instance;
	NoiseDevicePreferencesPrivate * priv;
	gboolean* _sync_when_mounted;
	guint* _last_sync_time;
	gboolean* _sync_music;
	gboolean* _sync_all_music;
};

struct _NoiseDevicePreferencesClass {
	GObjectClass parent_class;
};

struct _NoiseDevicePreferencesPrivate {
	gchar* id;
	GdaConnection* connection;
};


static gint NoiseDevicePreferences_private_offset;
static gpointer noise_device_preferences_parent_class = NULL;

GType noise_device_preferences_get_type (void) G_GNUC_CONST;
NoiseDevicePreferences* noise_device_preferences_new (NoiseDevice* device,
                                                      GdaConnection* connection);
NoiseDevicePreferences* noise_device_preferences_construct (GType object_type,
                                                            NoiseDevice* device,
                                                            GdaConnection* connection);
static GValue* noise_device_preferences_query_field (NoiseDevicePreferences* self,
                                              const gchar* field);
static void _vala_GValue_free (GValue* self);
#define NOISE_DATABASE_DEVICES_TABLE_NAME "devices"
static guint noise_device_preferences_common_uint_getter (NoiseDevicePreferences* self,
                                                   const gchar* field,
                                                   guint** temp);
static guint* _uint_dup (guint* self);
static void noise_device_preferences_common_uint_setter (NoiseDevicePreferences* self,
                                                  const gchar* field,
                                                  guint value,
                                                  guint** temp);
static void noise_device_preferences_set_field (NoiseDevicePreferences* self,
                                         const gchar* field,
                                         GValue* value);
static gboolean noise_device_preferences_common_bool_getter (NoiseDevicePreferences* self,
                                                      const gchar* field,
                                                      gboolean** temp);
static gboolean* _bool_dup (gboolean* self);
static void noise_device_preferences_common_bool_setter (NoiseDevicePreferences* self,
                                                  const gchar* field,
                                                  gboolean value,
                                                  gboolean** temp);
static GValue* _g_value_dup (GValue* self);
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
gboolean noise_device_preferences_get_sync_when_mounted (NoiseDevicePreferences* self);
void noise_device_preferences_set_sync_when_mounted (NoiseDevicePreferences* self,
                                                     gboolean value);
guint noise_device_preferences_get_last_sync_time (NoiseDevicePreferences* self);
void noise_device_preferences_set_last_sync_time (NoiseDevicePreferences* self,
                                                  guint value);
gboolean noise_device_preferences_get_sync_music (NoiseDevicePreferences* self);
void noise_device_preferences_set_sync_music (NoiseDevicePreferences* self,
                                              gboolean value);
gboolean noise_device_preferences_get_sync_all_music (NoiseDevicePreferences* self);
void noise_device_preferences_set_sync_all_music (NoiseDevicePreferences* self,
                                                  gboolean value);
NoisePlaylist* noise_device_preferences_get_music_playlist (NoiseDevicePreferences* self);
void noise_device_preferences_set_music_playlist (NoiseDevicePreferences* self,
                                                  NoisePlaylist* value);
static void noise_device_preferences_finalize (GObject * obj);
static void _vala_noise_device_preferences_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_noise_device_preferences_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);


static inline gpointer
noise_device_preferences_get_instance_private (NoiseDevicePreferences* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseDevicePreferences_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
_vala_GValue_free (GValue* self)
{
	g_value_unset (self);
	g_free (self);
}


NoiseDevicePreferences*
noise_device_preferences_construct (GType object_type,
                                    NoiseDevice* device,
                                    GdaConnection* connection)
{
	NoiseDevicePreferences * self = NULL;
	gchar* _tmp0_;
	GdaConnection* _tmp1_;
	GValue* _tmp2_;
	GValue* _tmp3_;
	gboolean _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (device != NULL, NULL);
	g_return_val_if_fail (connection != NULL, NULL);
	self = (NoiseDevicePreferences*) g_object_new (object_type, NULL);
	_tmp0_ = noise_device_get_unique_identifier (device);
	_g_free0 (self->priv->id);
	self->priv->id = _tmp0_;
	_tmp1_ = _g_object_ref0 (connection);
	_g_object_unref0 (self->priv->connection);
	self->priv->connection = _tmp1_;
	_tmp2_ = noise_device_preferences_query_field (self, "sync_music");
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_ == NULL;
	__vala_GValue_free0 (_tmp3_);
	if (_tmp4_) {
		{
			GdaSqlBuilder* builder = NULL;
			GdaSqlBuilder* _tmp5_;
			GdaSqlBuilder* _tmp6_;
			GdaSqlBuilder* _tmp7_;
			const gchar* _tmp8_;
			GValue* _tmp9_ = NULL;
			GdaStatement* _tmp10_ = NULL;
			GdaSqlBuilder* _tmp11_;
			GdaStatement* _tmp12_;
			_tmp5_ = gda_sql_builder_new (GDA_SQL_STATEMENT_INSERT);
			builder = _tmp5_;
			_tmp6_ = builder;
			gda_sql_builder_set_table (_tmp6_, NOISE_DATABASE_DEVICES_TABLE_NAME);
			_tmp7_ = builder;
			_tmp8_ = self->priv->id;
			_tmp9_ = g_new0 (GValue, 1);
			g_value_init (_tmp9_, G_TYPE_STRING);
			g_value_set_string (_tmp9_, _tmp8_);
			gda_sql_builder_add_field_value_as_gvalue (_tmp7_, "unique_id", _tmp9_);
			__vala_GValue_free0 (_tmp9_);
			_tmp11_ = builder;
			_tmp12_ = gda_sql_builder_get_statement (_tmp11_, &_inner_error_);
			_tmp10_ = _tmp12_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (builder);
				goto __catch33_g_error;
			}
			gda_connection_statement_execute_non_select (connection, _tmp10_, NULL, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (_tmp10_);
				_g_object_unref0 (builder);
				goto __catch33_g_error;
			}
			_g_object_unref0 (_tmp10_);
			_g_object_unref0 (builder);
		}
		goto __finally33;
		__catch33_g_error:
		{
			GError* e = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp13_ = e;
			_tmp14_ = _tmp13_->message;
			g_warning ("DevicePreferences.vala:121: Could not save media: %s", _tmp14_);
			_g_error_free0 (e);
		}
		__finally33:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	return self;
}


NoiseDevicePreferences*
noise_device_preferences_new (NoiseDevice* device,
                              GdaConnection* connection)
{
	return noise_device_preferences_construct (NOISE_TYPE_DEVICE_PREFERENCES, device, connection);
}


static guint*
_uint_dup (guint* self)
{
	guint* dup;
	dup = g_new0 (guint, 1);
	memcpy (dup, self, sizeof (guint));
	return dup;
}


static gpointer
__uint_dup0 (gpointer self)
{
	return self ? _uint_dup (self) : NULL;
}


static guint
noise_device_preferences_common_uint_getter (NoiseDevicePreferences* self,
                                             const gchar* field,
                                             guint** temp)
{
	guint result = 0U;
	GValue* _result_ = NULL;
	GValue* _tmp0_;
	GValue* _tmp1_;
	GValue* _tmp4_;
	guint _tmp5_;
	guint* _tmp6_;
	g_return_val_if_fail (self != NULL, 0U);
	g_return_val_if_fail (field != NULL, 0U);
	if ((*temp) != NULL) {
		result = *(*temp);
		return result;
	}
	_tmp0_ = noise_device_preferences_query_field (self, field);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (G_VALUE_TYPE (_tmp1_) == gda_null_get_type ()) {
		guint _tmp2_;
		guint* _tmp3_;
		_tmp2_ = (guint) 0;
		_tmp3_ = __uint_dup0 (&_tmp2_);
		_g_free0 (*temp);
		*temp = _tmp3_;
		result = *(*temp);
		__vala_GValue_free0 (_result_);
		return result;
	}
	_tmp4_ = _result_;
	_tmp5_ = (guint) g_value_get_int (_tmp4_);
	_tmp6_ = __uint_dup0 (&_tmp5_);
	_g_free0 (*temp);
	*temp = _tmp6_;
	result = *(*temp);
	__vala_GValue_free0 (_result_);
	return result;
}


static void
noise_device_preferences_common_uint_setter (NoiseDevicePreferences* self,
                                             const gchar* field,
                                             guint value,
                                             guint** temp)
{
	guint* _tmp0_;
	GValue _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	_tmp0_ = __uint_dup0 (&value);
	_g_free0 (*temp);
	*temp = _tmp0_;
	g_value_init (&_tmp1_, G_TYPE_UINT);
	g_value_set_uint (&_tmp1_, value);
	noise_device_preferences_set_field (self, field, &_tmp1_);
	G_IS_VALUE (&_tmp1_) ? (g_value_unset (&_tmp1_), NULL) : NULL;
}


static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
	dup = g_new0 (gboolean, 1);
	memcpy (dup, self, sizeof (gboolean));
	return dup;
}


static gpointer
__bool_dup0 (gpointer self)
{
	return self ? _bool_dup (self) : NULL;
}


static gboolean
noise_device_preferences_common_bool_getter (NoiseDevicePreferences* self,
                                             const gchar* field,
                                             gboolean** temp)
{
	gboolean result = FALSE;
	GValue* _result_ = NULL;
	GValue* _tmp0_;
	GValue* _tmp1_;
	GValue* _tmp4_;
	gboolean _tmp5_;
	gboolean* _tmp6_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (field != NULL, FALSE);
	if ((*temp) != NULL) {
		result = *(*temp);
		return result;
	}
	_tmp0_ = noise_device_preferences_query_field (self, field);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (G_VALUE_TYPE (_tmp1_) == gda_null_get_type ()) {
		gboolean _tmp2_;
		gboolean* _tmp3_;
		_tmp2_ = FALSE;
		_tmp3_ = __bool_dup0 (&_tmp2_);
		_g_free0 (*temp);
		*temp = _tmp3_;
		result = *(*temp);
		__vala_GValue_free0 (_result_);
		return result;
	}
	_tmp4_ = _result_;
	_tmp5_ = g_value_get_int (_tmp4_) == 1;
	_tmp6_ = __bool_dup0 (&_tmp5_);
	_g_free0 (*temp);
	*temp = _tmp6_;
	result = *(*temp);
	__vala_GValue_free0 (_result_);
	return result;
}


static void
noise_device_preferences_common_bool_setter (NoiseDevicePreferences* self,
                                             const gchar* field,
                                             gboolean value,
                                             gboolean** temp)
{
	gboolean* _tmp0_;
	GValue _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	_tmp0_ = __bool_dup0 (&value);
	_g_free0 (*temp);
	*temp = _tmp0_;
	g_value_init (&_tmp1_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp1_, value);
	noise_device_preferences_set_field (self, field, &_tmp1_);
	G_IS_VALUE (&_tmp1_) ? (g_value_unset (&_tmp1_), NULL) : NULL;
}


static GValue*
_g_value_dup (GValue* self)
{
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static gpointer
__g_value_dup0 (gpointer self)
{
	return self ? _g_value_dup (self) : NULL;
}


static GValue*
noise_device_preferences_query_field (NoiseDevicePreferences* self,
                                      const gchar* field)
{
	GValue* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (field != NULL, NULL);
	{
		GdaSqlBuilder* sql = NULL;
		GdaSqlBuilder* _tmp0_;
		GdaSqlBuilder* _tmp1_;
		GdaSqlBuilder* _tmp2_;
		GdaSqlBuilder* _tmp3_;
		GdaSqlBuilderId id_field = 0U;
		GdaSqlBuilder* _tmp4_;
		GdaSqlBuilderId id_param = 0U;
		GdaSqlBuilder* _tmp5_;
		const gchar* _tmp6_;
		GValue* _tmp7_ = NULL;
		GdaSqlBuilderId _tmp8_;
		GdaSqlBuilderId id_cond = 0U;
		GdaSqlBuilder* _tmp9_;
		GdaSqlBuilderId _tmp10_;
		GdaSqlBuilderId _tmp11_;
		GdaSqlBuilder* _tmp12_;
		GdaSqlBuilderId _tmp13_;
		GdaStatement* _tmp14_ = NULL;
		GdaSqlBuilder* _tmp15_;
		GdaStatement* _tmp16_;
		GdaDataModel* data_model = NULL;
		GdaConnection* _tmp17_;
		GdaDataModel* _tmp18_;
		GValue* _tmp19_ = NULL;
		GdaDataModel* _tmp20_;
		GdaDataModel* _tmp21_;
		GValue* _tmp22_;
		_tmp0_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
		sql = _tmp0_;
		_tmp1_ = sql;
		gda_sql_builder_select_add_target (_tmp1_, NOISE_DATABASE_DEVICES_TABLE_NAME, NULL);
		_tmp2_ = sql;
		_tmp3_ = sql;
		gda_sql_builder_add_field_value_id (_tmp2_, gda_sql_builder_add_id (_tmp3_, field), (GdaSqlBuilderId) 0);
		_tmp4_ = sql;
		id_field = gda_sql_builder_add_id (_tmp4_, "unique_id");
		_tmp5_ = sql;
		_tmp6_ = self->priv->id;
		_tmp7_ = g_new0 (GValue, 1);
		g_value_init (_tmp7_, G_TYPE_STRING);
		g_value_set_string (_tmp7_, _tmp6_);
		_tmp8_ = gda_sql_builder_add_expr_value (_tmp5_, NULL, _tmp7_);
		__vala_GValue_free0 (_tmp7_);
		id_param = _tmp8_;
		_tmp9_ = sql;
		_tmp10_ = id_field;
		_tmp11_ = id_param;
		id_cond = gda_sql_builder_add_cond (_tmp9_, GDA_SQL_OPERATOR_TYPE_EQ, _tmp10_, _tmp11_, (GdaSqlBuilderId) 0);
		_tmp12_ = sql;
		_tmp13_ = id_cond;
		gda_sql_builder_set_where (_tmp12_, _tmp13_);
		_tmp15_ = sql;
		_tmp16_ = gda_sql_builder_get_statement (_tmp15_, &_inner_error_);
		_tmp14_ = _tmp16_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (sql);
			goto __catch34_g_error;
		}
		_tmp17_ = self->priv->connection;
		_tmp18_ = gda_connection_statement_execute_select (_tmp17_, _tmp14_, NULL, &_inner_error_);
		data_model = _tmp18_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (_tmp14_);
			_g_object_unref0 (sql);
			goto __catch34_g_error;
		}
		_tmp20_ = data_model;
		_tmp21_ = data_model;
		_tmp19_ = gda_data_model_get_value_at (_tmp20_, gda_data_model_get_column_index (_tmp21_, field), 0, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (data_model);
			_g_object_unref0 (_tmp14_);
			_g_object_unref0 (sql);
			goto __catch34_g_error;
		}
		_tmp22_ = __g_value_dup0 (_tmp19_);
		result = _tmp22_;
		_g_object_unref0 (data_model);
		_g_object_unref0 (_tmp14_);
		_g_object_unref0 (sql);
		return result;
	}
	goto __finally34;
	__catch34_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp23_ = e;
		_tmp24_ = _tmp23_->message;
		g_critical ("DevicePreferences.vala:176: Could not query field %s: %s", field, _tmp24_);
		result = NULL;
		_g_error_free0 (e);
		return result;
	}
	__finally34:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


static void
__vala_GValue_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
}


static inline void
_g_slist_free___vala_GValue_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
}


static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}


static void
noise_device_preferences_set_field (NoiseDevicePreferences* self,
                                    const gchar* field,
                                    GValue* value)
{
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	g_return_if_fail (value != NULL);
	{
		GSList* col_names = NULL;
		gchar* _tmp0_;
		GSList* values = NULL;
		GValue _tmp1_;
		GValue _tmp2_;
		GValue* _tmp3_;
		GdaConnection* _tmp4_;
		const gchar* _tmp5_;
		GValue _tmp6_ = {0};
		col_names = NULL;
		_tmp0_ = g_strdup (field);
		col_names = g_slist_append (col_names, _tmp0_);
		values = NULL;
		_tmp1_ = *value;
		_tmp2_ = _tmp1_;
		_tmp3_ = __g_value_dup0 (&_tmp2_);
		values = g_slist_append (values, _tmp3_);
		_tmp4_ = self->priv->connection;
		_tmp5_ = self->priv->id;
		g_value_init (&_tmp6_, G_TYPE_STRING);
		g_value_set_string (&_tmp6_, _tmp5_);
		gda_connection_update_row_in_table_v (_tmp4_, NOISE_DATABASE_DEVICES_TABLE_NAME, "unique_id", &_tmp6_, col_names, values, &_inner_error_);
		G_IS_VALUE (&_tmp6_) ? (g_value_unset (&_tmp6_), NULL) : NULL;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			goto __catch35_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
	}
	goto __finally35;
	__catch35_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		g_critical ("DevicePreferences.vala:189: Could not set field %s: %s", field, _tmp8_);
		_g_error_free0 (e);
	}
	__finally35:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


gboolean
noise_device_preferences_get_sync_when_mounted (NoiseDevicePreferences* self)
{
	gboolean result;
	gboolean* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	noise_device_preferences_common_bool_getter (self, "sync_when_mounted", &self->_sync_when_mounted);
	_tmp0_ = self->_sync_when_mounted;
	result = *_tmp0_;
	return result;
}


void
noise_device_preferences_set_sync_when_mounted (NoiseDevicePreferences* self,
                                                gboolean value)
{
	g_return_if_fail (self != NULL);
	noise_device_preferences_common_bool_setter (self, "sync_when_mounted", value, &self->_sync_when_mounted);
	g_object_notify_by_pspec ((GObject *) self, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY]);
}


guint
noise_device_preferences_get_last_sync_time (NoiseDevicePreferences* self)
{
	guint result;
	guint* _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	noise_device_preferences_common_uint_getter (self, "last_sync_time", &self->_last_sync_time);
	_tmp0_ = self->_last_sync_time;
	result = *_tmp0_;
	return result;
}


void
noise_device_preferences_set_last_sync_time (NoiseDevicePreferences* self,
                                             guint value)
{
	g_return_if_fail (self != NULL);
	noise_device_preferences_common_uint_setter (self, "last_sync_time", value, &self->_last_sync_time);
	g_object_notify_by_pspec ((GObject *) self, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY]);
}


gboolean
noise_device_preferences_get_sync_music (NoiseDevicePreferences* self)
{
	gboolean result;
	gboolean* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	noise_device_preferences_common_bool_getter (self, "sync_music", &self->_sync_music);
	_tmp0_ = self->_sync_music;
	result = *_tmp0_;
	return result;
}


void
noise_device_preferences_set_sync_music (NoiseDevicePreferences* self,
                                         gboolean value)
{
	g_return_if_fail (self != NULL);
	noise_device_preferences_common_bool_setter (self, "sync_music", value, &self->_sync_music);
	g_object_notify_by_pspec ((GObject *) self, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY]);
}


gboolean
noise_device_preferences_get_sync_all_music (NoiseDevicePreferences* self)
{
	gboolean result;
	gboolean* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	noise_device_preferences_common_bool_getter (self, "sync_all_music", &self->_sync_all_music);
	_tmp0_ = self->_sync_all_music;
	result = *_tmp0_;
	return result;
}


void
noise_device_preferences_set_sync_all_music (NoiseDevicePreferences* self,
                                             gboolean value)
{
	g_return_if_fail (self != NULL);
	noise_device_preferences_common_bool_setter (self, "sync_all_music", value, &self->_sync_all_music);
	g_object_notify_by_pspec ((GObject *) self, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY]);
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch36_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch36_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally36;
	__catch36_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally36:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static gint64
int64_parse (const gchar* str)
{
	gint64 result = 0LL;
	gint64 _tmp0_;
	g_return_val_if_fail (str != NULL, 0LL);
	_tmp0_ = g_ascii_strtoll (str, NULL, (guint) 0);
	result = _tmp0_;
	return result;
}


NoisePlaylist*
noise_device_preferences_get_music_playlist (NoiseDevicePreferences* self)
{
	NoisePlaylist* result;
	GValue* _result_ = NULL;
	GValue* _tmp0_;
	GValue* _tmp1_;
	gchar* playlist_string = NULL;
	GValue* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	const gchar* _tmp8_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_device_preferences_query_field (self, "music_playlist");
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (G_VALUE_TYPE (_tmp1_) == gda_null_get_type ()) {
		result = NULL;
		__vala_GValue_free0 (_result_);
		return result;
	}
	_tmp2_ = _result_;
	_tmp3_ = g_value_get_string (_tmp2_);
	_tmp4_ = g_strdup (_tmp3_);
	playlist_string = _tmp4_;
	_tmp6_ = playlist_string;
	if (g_strcmp0 (_tmp6_, "") == 0) {
		_tmp5_ = TRUE;
	} else {
		const gchar* _tmp7_;
		_tmp7_ = playlist_string;
		_tmp5_ = _tmp7_ == NULL;
	}
	if (_tmp5_) {
		result = NULL;
		_g_free0 (playlist_string);
		__vala_GValue_free0 (_result_);
		return result;
	}
	_tmp8_ = playlist_string;
	if (string_contains (_tmp8_, "p")) {
		const gchar* _tmp9_;
		gchar* _tmp10_;
		NoiseLibrariesManager* _tmp11_;
		NoiseLibrary* _tmp12_;
		const gchar* _tmp13_;
		NoiseStaticPlaylist* _tmp14_;
		_tmp9_ = playlist_string;
		_tmp10_ = string_replace (_tmp9_, "p", "");
		_g_free0 (playlist_string);
		playlist_string = _tmp10_;
		_tmp11_ = noise_libraries_manager;
		_tmp12_ = _tmp11_->local_library;
		_tmp13_ = playlist_string;
		_tmp14_ = noise_library_playlist_from_id (_tmp12_, int64_parse (_tmp13_));
		result = (NoisePlaylist*) _tmp14_;
		_g_free0 (playlist_string);
		__vala_GValue_free0 (_result_);
		return result;
	} else {
		const gchar* _tmp15_;
		gchar* _tmp16_;
		NoiseLibrariesManager* _tmp17_;
		NoiseLibrary* _tmp18_;
		const gchar* _tmp19_;
		NoiseSmartPlaylist* _tmp20_;
		_tmp15_ = playlist_string;
		_tmp16_ = string_replace (_tmp15_, "s", "");
		_g_free0 (playlist_string);
		playlist_string = _tmp16_;
		_tmp17_ = noise_libraries_manager;
		_tmp18_ = _tmp17_->local_library;
		_tmp19_ = playlist_string;
		_tmp20_ = noise_library_smart_playlist_from_id (_tmp18_, int64_parse (_tmp19_));
		result = (NoisePlaylist*) _tmp20_;
		_g_free0 (playlist_string);
		__vala_GValue_free0 (_result_);
		return result;
	}
	_g_free0 (playlist_string);
	__vala_GValue_free0 (_result_);
}


void
noise_device_preferences_set_music_playlist (NoiseDevicePreferences* self,
                                             NoisePlaylist* value)
{
	gchar* playlist_string = NULL;
	gchar* _tmp0_;
	const gchar* _tmp7_;
	GValue _tmp8_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup ("");
	playlist_string = _tmp0_;
	if (value != NULL) {
		if (G_TYPE_CHECK_INSTANCE_TYPE (value, NOISE_TYPE_STATIC_PLAYLIST)) {
			gint64 _tmp1_;
			gint64 _tmp2_;
			gchar* _tmp3_;
			_tmp1_ = noise_playlist_get_rowid (value);
			_tmp2_ = _tmp1_;
			_tmp3_ = g_strdup_printf ("p%lld", _tmp2_);
			_g_free0 (playlist_string);
			playlist_string = _tmp3_;
		} else {
			gint64 _tmp4_;
			gint64 _tmp5_;
			gchar* _tmp6_;
			_tmp4_ = noise_playlist_get_rowid (value);
			_tmp5_ = _tmp4_;
			_tmp6_ = g_strdup_printf ("s%lld", _tmp5_);
			_g_free0 (playlist_string);
			playlist_string = _tmp6_;
		}
	}
	_tmp7_ = playlist_string;
	g_value_init (&_tmp8_, G_TYPE_STRING);
	g_value_set_string (&_tmp8_, _tmp7_);
	noise_device_preferences_set_field (self, "music_playlist", &_tmp8_);
	G_IS_VALUE (&_tmp8_) ? (g_value_unset (&_tmp8_), NULL) : NULL;
	_g_free0 (playlist_string);
	g_object_notify_by_pspec ((GObject *) self, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY]);
}


static void
noise_device_preferences_class_init (NoiseDevicePreferencesClass * klass)
{
	noise_device_preferences_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseDevicePreferences_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_device_preferences_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_device_preferences_set_property;
	G_OBJECT_CLASS (klass)->finalize = noise_device_preferences_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY] = g_param_spec_boolean ("sync-when-mounted", "sync-when-mounted", "sync-when-mounted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY] = g_param_spec_uint ("last-sync-time", "last-sync-time", "last-sync-time", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY] = g_param_spec_boolean ("sync-music", "sync-music", "sync-music", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY] = g_param_spec_boolean ("sync-all-music", "sync-all-music", "sync-all-music", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY] = g_param_spec_object ("music-playlist", "music-playlist", "music-playlist", NOISE_TYPE_PLAYLIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void
noise_device_preferences_instance_init (NoiseDevicePreferences * self)
{
	self->priv = noise_device_preferences_get_instance_private (self);
	self->_sync_when_mounted = NULL;
	self->_last_sync_time = NULL;
	self->_sync_music = NULL;
	self->_sync_all_music = NULL;
}


static void
noise_device_preferences_finalize (GObject * obj)
{
	NoiseDevicePreferences * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences);
	_g_free0 (self->priv->id);
	_g_free0 (self->_sync_when_mounted);
	_g_free0 (self->_last_sync_time);
	_g_free0 (self->_sync_music);
	_g_free0 (self->_sync_all_music);
	_g_object_unref0 (self->priv->connection);
	G_OBJECT_CLASS (noise_device_preferences_parent_class)->finalize (obj);
}


GType
noise_device_preferences_get_type (void)
{
	static volatile gsize noise_device_preferences_type_id__volatile = 0;
	if (g_once_init_enter (&noise_device_preferences_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseDevicePreferencesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_device_preferences_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseDevicePreferences), 0, (GInstanceInitFunc) noise_device_preferences_instance_init, NULL };
		GType noise_device_preferences_type_id;
		noise_device_preferences_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseDevicePreferences", &g_define_type_info, 0);
		NoiseDevicePreferences_private_offset = g_type_add_instance_private (noise_device_preferences_type_id, sizeof (NoiseDevicePreferencesPrivate));
		g_once_init_leave (&noise_device_preferences_type_id__volatile, noise_device_preferences_type_id);
	}
	return noise_device_preferences_type_id__volatile;
}


static void
_vala_noise_device_preferences_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	NoiseDevicePreferences * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences);
	switch (property_id) {
		case NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY:
		g_value_set_boolean (value, noise_device_preferences_get_sync_when_mounted (self));
		break;
		case NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY:
		g_value_set_uint (value, noise_device_preferences_get_last_sync_time (self));
		break;
		case NOISE_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY:
		g_value_set_boolean (value, noise_device_preferences_get_sync_music (self));
		break;
		case NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY:
		g_value_set_boolean (value, noise_device_preferences_get_sync_all_music (self));
		break;
		case NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY:
		g_value_take_object (value, noise_device_preferences_get_music_playlist (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_device_preferences_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	NoiseDevicePreferences * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences);
	switch (property_id) {
		case NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY:
		noise_device_preferences_set_sync_when_mounted (self, g_value_get_boolean (value));
		break;
		case NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY:
		noise_device_preferences_set_last_sync_time (self, g_value_get_uint (value));
		break;
		case NOISE_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY:
		noise_device_preferences_set_sync_music (self, g_value_get_boolean (value));
		break;
		case NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY:
		noise_device_preferences_set_sync_all_music (self, g_value_get_boolean (value));
		break;
		case NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY:
		noise_device_preferences_set_music_playlist (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



