/* LocalMedia.c generated by valac 0.41.91, the Vala compiler
 * generated from LocalMedia.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <libgda/libgda.h>


#define NOISE_TYPE_LOCAL_MEDIA (noise_local_media_get_type ())
#define NOISE_LOCAL_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMedia))
#define NOISE_LOCAL_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMediaClass))
#define NOISE_IS_LOCAL_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LOCAL_MEDIA))
#define NOISE_IS_LOCAL_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LOCAL_MEDIA))
#define NOISE_LOCAL_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMediaClass))

typedef struct _NoiseLocalMedia NoiseLocalMedia;
typedef struct _NoiseLocalMediaClass NoiseLocalMediaClass;
typedef struct _NoiseLocalMediaPrivate NoiseLocalMediaPrivate;
enum  {
	NOISE_LOCAL_MEDIA_0_PROPERTY,
	NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY,
	NOISE_LOCAL_MEDIA_TITLE_PROPERTY,
	NOISE_LOCAL_MEDIA_TRACK_PROPERTY,
	NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY,
	NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY,
	NOISE_LOCAL_MEDIA_ARTIST_PROPERTY,
	NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY,
	NOISE_LOCAL_MEDIA_ALBUM_PROPERTY,
	NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY,
	NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY,
	NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY,
	NOISE_LOCAL_MEDIA_GROUPING_PROPERTY,
	NOISE_LOCAL_MEDIA_GENRE_PROPERTY,
	NOISE_LOCAL_MEDIA_COMMENT_PROPERTY,
	NOISE_LOCAL_MEDIA_LYRICS_PROPERTY,
	NOISE_LOCAL_MEDIA_YEAR_PROPERTY,
	NOISE_LOCAL_MEDIA_BITRATE_PROPERTY,
	NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY,
	NOISE_LOCAL_MEDIA_LENGTH_PROPERTY,
	NOISE_LOCAL_MEDIA_RATING_PROPERTY,
	NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY,
	NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY,
	NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY,
	NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY,
	NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY,
	NOISE_LOCAL_MEDIA_SHOW_PROPERTY,
	NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY,
	NOISE_LOCAL_MEDIA_NUM_PROPERTIES
};
static GParamSpec* noise_local_media_properties[NOISE_LOCAL_MEDIA_NUM_PROPERTIES];
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NoiseLocalMedia {
	NoiseMedia parent_instance;
	NoiseLocalMediaPrivate * priv;
	guint* _year;
	guint* _bitrate;
	guint* _samplerate;
	guint* _length;
	guint* _play_count;
	guint* _skip_count;
	guint* _date_added;
	guint* _last_played;
	guint* _last_modified;
};

struct _NoiseLocalMediaClass {
	NoiseMediaClass parent_class;
};

struct _NoiseLocalMediaPrivate {
	guint64* _file_size;
	gchar* _title;
	guint* _track;
	guint* _track_count;
	gchar* _composer;
	gchar* _artist;
	gchar* _album_artist;
	gchar* _album;
	guint* _album_number;
	guint* _album_count;
	NoiseAlbum* _album_info;
	gchar* _grouping;
	gchar* _genre;
	gchar* _comment;
	gchar* _lyrics;
	guint* _show;
	gint _resume_pos;
	GdaConnection* connection;
};


static gint NoiseLocalMedia_private_offset;
static gpointer noise_local_media_parent_class = NULL;

GType noise_local_media_get_type (void) G_GNUC_CONST;
NoiseLocalMedia* noise_local_media_new (gint64 rowid,
                                        GdaConnection* connection);
NoiseLocalMedia* noise_local_media_construct (GType object_type,
                                              gint64 rowid,
                                              GdaConnection* connection);
GValue* noise_database_query_field (gint64 rowid,
                                    GdaConnection* connection,
                                    const gchar* table,
                                    const gchar* field);
#define NOISE_DATABASE_MEDIA_TABLE_NAME "media"
static void _vala_GValue_free (GValue* self);
NoiseLocalMedia* noise_local_media_new_from_media (GdaConnection* connection,
                                                   NoiseMedia* m);
NoiseLocalMedia* noise_local_media_construct_from_media (GType object_type,
                                                         GdaConnection* connection,
                                                         NoiseMedia* m);
#define NOISE_DATABASE_MEDIA_ROWID "+26"
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static guint64 noise_local_media_common_uint64_getter (NoiseLocalMedia* self,
                                                const gchar* field,
                                                guint64** temp);
static guint64* _uint64_dup (guint64* self);
static void noise_local_media_common_uint64_setter (NoiseLocalMedia* self,
                                             const gchar* field,
                                             guint64 value,
                                             guint64** temp);
void noise_database_set_field (gint64 rowid,
                               GdaConnection* connection,
                               const gchar* table,
                               const gchar* field,
                               GValue* value);
static guint noise_local_media_common_uint_getter (NoiseLocalMedia* self,
                                            const gchar* field,
                                            guint** temp);
static guint* _uint_dup (guint* self);
static void noise_local_media_common_uint_setter (NoiseLocalMedia* self,
                                           const gchar* field,
                                           guint value,
                                           guint** temp);
static gchar* noise_local_media_common_string_getter (NoiseLocalMedia* self,
                                               const gchar* field,
                                               gchar* * temp);
static void noise_local_media_common_string_setter (NoiseLocalMedia* self,
                                             const gchar* field,
                                             const gchar* value,
                                             gchar* * temp);
static gboolean _uint_equal (const guint * s1,
                      const guint * s2);
static void noise_local_media_finalize (GObject * obj);
static void _vala_noise_local_media_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_noise_local_media_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);


static inline gpointer
noise_local_media_get_instance_private (NoiseLocalMedia* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseLocalMedia_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
_vala_GValue_free (GValue* self)
{
	g_value_unset (self);
	g_free (self);
}


NoiseLocalMedia*
noise_local_media_construct (GType object_type,
                             gint64 rowid,
                             GdaConnection* connection)
{
	NoiseLocalMedia * self = NULL;
	GdaConnection* _tmp0_;
	GValue* query = NULL;
	GValue* _tmp1_;
	GValue* _tmp2_;
	g_return_val_if_fail (connection != NULL, NULL);
	self = (NoiseLocalMedia*) g_object_new (object_type, "rowid", rowid, NULL);
	_tmp0_ = _g_object_ref0 (connection);
	_g_object_unref0 (self->priv->connection);
	self->priv->connection = _tmp0_;
	_tmp1_ = noise_database_query_field (rowid, connection, NOISE_DATABASE_MEDIA_TABLE_NAME, "uri");
	query = _tmp1_;
	_tmp2_ = query;
	if (_tmp2_ != NULL) {
		GValue* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp3_ = query;
		_tmp4_ = g_value_dup_string (_tmp3_);
		_tmp5_ = _tmp4_;
		noise_media_set_uri ((NoiseMedia*) self, _tmp5_);
		_g_free0 (_tmp5_);
	}
	__vala_GValue_free0 (query);
	return self;
}


NoiseLocalMedia*
noise_local_media_new (gint64 rowid,
                       GdaConnection* connection)
{
	return noise_local_media_construct (NOISE_TYPE_LOCAL_MEDIA, rowid, connection);
}


static void
__vala_GValue_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
}


static inline void
_g_slist_free___vala_GValue_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
}


static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}


NoiseLocalMedia*
noise_local_media_construct_from_media (GType object_type,
                                        GdaConnection* connection,
                                        NoiseMedia* m)
{
	NoiseLocalMedia * self = NULL;
	GValue* query = NULL;
	gint64 _tmp124_;
	gint64 _tmp125_;
	GValue* _tmp126_;
	GValue* _tmp127_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (connection != NULL, NULL);
	g_return_val_if_fail (m != NULL, NULL);
	{
		GdaSqlBuilder* builder = NULL;
		GdaSqlBuilder* _tmp0_;
		GdaSqlBuilder* _tmp1_;
		GdaSqlBuilder* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GValue* _tmp5_ = NULL;
		GdaSet* last_insert_row = NULL;
		GdaStatement* _tmp6_ = NULL;
		GdaSqlBuilder* _tmp7_;
		GdaStatement* _tmp8_;
		GdaSet* _tmp9_ = NULL;
		gint64 _rowid = 0LL;
		GdaSet* _tmp10_;
		GValue _tmp11_;
		gint64 _tmp12_;
		GdaConnection* _tmp13_;
		GSList* col_names = NULL;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		GSList* values = NULL;
		guint64 _tmp40_;
		guint64 _tmp41_;
		GValue* _tmp42_ = NULL;
		const gchar* _tmp43_;
		const gchar* _tmp44_;
		GValue* _tmp45_ = NULL;
		const gchar* _tmp46_;
		const gchar* _tmp47_;
		GValue* _tmp48_ = NULL;
		const gchar* _tmp49_;
		const gchar* _tmp50_;
		GValue* _tmp51_ = NULL;
		const gchar* _tmp52_;
		const gchar* _tmp53_;
		GValue* _tmp54_ = NULL;
		const gchar* _tmp55_;
		const gchar* _tmp56_;
		GValue* _tmp57_ = NULL;
		const gchar* _tmp58_;
		const gchar* _tmp59_;
		GValue* _tmp60_ = NULL;
		const gchar* _tmp61_;
		const gchar* _tmp62_;
		GValue* _tmp63_ = NULL;
		const gchar* _tmp64_;
		const gchar* _tmp65_;
		GValue* _tmp66_ = NULL;
		const gchar* _tmp67_;
		const gchar* _tmp68_;
		GValue* _tmp69_ = NULL;
		gboolean _tmp70_;
		gboolean _tmp71_;
		GValue* _tmp72_ = NULL;
		guint _tmp73_;
		guint _tmp74_;
		GValue* _tmp75_ = NULL;
		guint _tmp76_;
		guint _tmp77_;
		GValue* _tmp78_ = NULL;
		guint _tmp79_;
		guint _tmp80_;
		GValue* _tmp81_ = NULL;
		guint _tmp82_;
		guint _tmp83_;
		GValue* _tmp84_ = NULL;
		guint _tmp85_;
		guint _tmp86_;
		GValue* _tmp87_ = NULL;
		guint _tmp88_;
		guint _tmp89_;
		GValue* _tmp90_ = NULL;
		guint _tmp91_;
		guint _tmp92_;
		GValue* _tmp93_ = NULL;
		guint _tmp94_;
		guint _tmp95_;
		GValue* _tmp96_ = NULL;
		guint _tmp97_;
		guint _tmp98_;
		GValue* _tmp99_ = NULL;
		guint _tmp100_;
		guint _tmp101_;
		GValue* _tmp102_ = NULL;
		guint _tmp103_;
		guint _tmp104_;
		GValue* _tmp105_ = NULL;
		guint _tmp106_;
		guint _tmp107_;
		GValue* _tmp108_ = NULL;
		guint _tmp109_;
		guint _tmp110_;
		GValue* _tmp111_ = NULL;
		guint _tmp112_;
		guint _tmp113_;
		GValue* _tmp114_ = NULL;
		gboolean _tmp115_;
		gboolean _tmp116_;
		GValue* _tmp117_ = NULL;
		GdaSet* _tmp118_;
		GSList* _tmp119_;
		GSList* _tmp120_;
		GValue _tmp121_;
		_tmp0_ = gda_sql_builder_new (GDA_SQL_STATEMENT_INSERT);
		builder = _tmp0_;
		_tmp1_ = builder;
		gda_sql_builder_set_table (_tmp1_, NOISE_DATABASE_MEDIA_TABLE_NAME);
		_tmp2_ = builder;
		_tmp3_ = noise_media_get_uri (m);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_new0 (GValue, 1);
		g_value_init (_tmp5_, G_TYPE_STRING);
		g_value_take_string (_tmp5_, _tmp4_);
		gda_sql_builder_add_field_value_as_gvalue (_tmp2_, "uri", _tmp5_);
		__vala_GValue_free0 (_tmp5_);
		_tmp7_ = builder;
		_tmp8_ = gda_sql_builder_get_statement (_tmp7_, &_inner_error_);
		_tmp6_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (last_insert_row);
			_g_object_unref0 (builder);
			goto __catch66_g_error;
		}
		gda_connection_statement_execute_non_select (connection, _tmp6_, NULL, &_tmp9_, &_inner_error_);
		_g_object_unref0 (last_insert_row);
		last_insert_row = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (_tmp6_);
			_g_object_unref0 (last_insert_row);
			_g_object_unref0 (builder);
			goto __catch66_g_error;
		}
		_tmp10_ = last_insert_row;
		_tmp11_ = *gda_set_get_holder_value (_tmp10_, NOISE_DATABASE_MEDIA_ROWID);
		_rowid = g_value_get_int64 (&_tmp11_);
		_tmp12_ = _rowid;
		self = (NoiseLocalMedia*) g_object_new (object_type, "rowid", _tmp12_, NULL);
		_tmp13_ = _g_object_ref0 (connection);
		_g_object_unref0 (self->priv->connection);
		self->priv->connection = _tmp13_;
		col_names = NULL;
		_tmp14_ = g_strdup ("file_size");
		col_names = g_slist_append (col_names, _tmp14_);
		_tmp15_ = g_strdup ("title");
		col_names = g_slist_append (col_names, _tmp15_);
		_tmp16_ = g_strdup ("artist");
		col_names = g_slist_append (col_names, _tmp16_);
		_tmp17_ = g_strdup ("composer");
		col_names = g_slist_append (col_names, _tmp17_);
		_tmp18_ = g_strdup ("album_artist");
		col_names = g_slist_append (col_names, _tmp18_);
		_tmp19_ = g_strdup ("album");
		col_names = g_slist_append (col_names, _tmp19_);
		_tmp20_ = g_strdup ("grouping");
		col_names = g_slist_append (col_names, _tmp20_);
		_tmp21_ = g_strdup ("genre");
		col_names = g_slist_append (col_names, _tmp21_);
		_tmp22_ = g_strdup ("comment");
		col_names = g_slist_append (col_names, _tmp22_);
		_tmp23_ = g_strdup ("lyrics");
		col_names = g_slist_append (col_names, _tmp23_);
		_tmp24_ = g_strdup ("has_embedded");
		col_names = g_slist_append (col_names, _tmp24_);
		_tmp25_ = g_strdup ("year");
		col_names = g_slist_append (col_names, _tmp25_);
		_tmp26_ = g_strdup ("track");
		col_names = g_slist_append (col_names, _tmp26_);
		_tmp27_ = g_strdup ("track_count");
		col_names = g_slist_append (col_names, _tmp27_);
		_tmp28_ = g_strdup ("album_number");
		col_names = g_slist_append (col_names, _tmp28_);
		_tmp29_ = g_strdup ("album_count");
		col_names = g_slist_append (col_names, _tmp29_);
		_tmp30_ = g_strdup ("bitrate");
		col_names = g_slist_append (col_names, _tmp30_);
		_tmp31_ = g_strdup ("length");
		col_names = g_slist_append (col_names, _tmp31_);
		_tmp32_ = g_strdup ("samplerate");
		col_names = g_slist_append (col_names, _tmp32_);
		_tmp33_ = g_strdup ("rating");
		col_names = g_slist_append (col_names, _tmp33_);
		_tmp34_ = g_strdup ("playcount");
		col_names = g_slist_append (col_names, _tmp34_);
		_tmp35_ = g_strdup ("skipcount");
		col_names = g_slist_append (col_names, _tmp35_);
		_tmp36_ = g_strdup ("dateadded");
		col_names = g_slist_append (col_names, _tmp36_);
		_tmp37_ = g_strdup ("lastplayed");
		col_names = g_slist_append (col_names, _tmp37_);
		_tmp38_ = g_strdup ("lastmodified");
		col_names = g_slist_append (col_names, _tmp38_);
		_tmp39_ = g_strdup ("show");
		col_names = g_slist_append (col_names, _tmp39_);
		values = NULL;
		_tmp40_ = noise_media_get_file_size (m);
		_tmp41_ = _tmp40_;
		_tmp42_ = g_new0 (GValue, 1);
		g_value_init (_tmp42_, G_TYPE_UINT64);
		g_value_set_uint64 (_tmp42_, _tmp41_);
		values = g_slist_append (values, _tmp42_);
		_tmp43_ = noise_media_get_title (m);
		_tmp44_ = _tmp43_;
		_tmp45_ = g_new0 (GValue, 1);
		g_value_init (_tmp45_, G_TYPE_STRING);
		g_value_set_string (_tmp45_, _tmp44_);
		values = g_slist_append (values, _tmp45_);
		_tmp46_ = noise_media_get_artist (m);
		_tmp47_ = _tmp46_;
		_tmp48_ = g_new0 (GValue, 1);
		g_value_init (_tmp48_, G_TYPE_STRING);
		g_value_set_string (_tmp48_, _tmp47_);
		values = g_slist_append (values, _tmp48_);
		_tmp49_ = noise_media_get_composer (m);
		_tmp50_ = _tmp49_;
		_tmp51_ = g_new0 (GValue, 1);
		g_value_init (_tmp51_, G_TYPE_STRING);
		g_value_set_string (_tmp51_, _tmp50_);
		values = g_slist_append (values, _tmp51_);
		_tmp52_ = noise_media_get_album_artist (m);
		_tmp53_ = _tmp52_;
		_tmp54_ = g_new0 (GValue, 1);
		g_value_init (_tmp54_, G_TYPE_STRING);
		g_value_set_string (_tmp54_, _tmp53_);
		values = g_slist_append (values, _tmp54_);
		_tmp55_ = noise_media_get_album (m);
		_tmp56_ = _tmp55_;
		_tmp57_ = g_new0 (GValue, 1);
		g_value_init (_tmp57_, G_TYPE_STRING);
		g_value_set_string (_tmp57_, _tmp56_);
		values = g_slist_append (values, _tmp57_);
		_tmp58_ = noise_media_get_grouping (m);
		_tmp59_ = _tmp58_;
		_tmp60_ = g_new0 (GValue, 1);
		g_value_init (_tmp60_, G_TYPE_STRING);
		g_value_set_string (_tmp60_, _tmp59_);
		values = g_slist_append (values, _tmp60_);
		_tmp61_ = noise_media_get_genre (m);
		_tmp62_ = _tmp61_;
		_tmp63_ = g_new0 (GValue, 1);
		g_value_init (_tmp63_, G_TYPE_STRING);
		g_value_set_string (_tmp63_, _tmp62_);
		values = g_slist_append (values, _tmp63_);
		_tmp64_ = noise_media_get_comment (m);
		_tmp65_ = _tmp64_;
		_tmp66_ = g_new0 (GValue, 1);
		g_value_init (_tmp66_, G_TYPE_STRING);
		g_value_set_string (_tmp66_, _tmp65_);
		values = g_slist_append (values, _tmp66_);
		_tmp67_ = noise_media_get_lyrics (m);
		_tmp68_ = _tmp67_;
		_tmp69_ = g_new0 (GValue, 1);
		g_value_init (_tmp69_, G_TYPE_STRING);
		g_value_set_string (_tmp69_, _tmp68_);
		values = g_slist_append (values, _tmp69_);
		_tmp70_ = noise_media_get_has_embedded (m);
		_tmp71_ = _tmp70_;
		_tmp72_ = g_new0 (GValue, 1);
		g_value_init (_tmp72_, G_TYPE_BOOLEAN);
		g_value_set_boolean (_tmp72_, _tmp71_);
		values = g_slist_append (values, _tmp72_);
		_tmp73_ = noise_media_get_year (m);
		_tmp74_ = _tmp73_;
		_tmp75_ = g_new0 (GValue, 1);
		g_value_init (_tmp75_, G_TYPE_UINT);
		g_value_set_uint (_tmp75_, _tmp74_);
		values = g_slist_append (values, _tmp75_);
		_tmp76_ = noise_media_get_track (m);
		_tmp77_ = _tmp76_;
		_tmp78_ = g_new0 (GValue, 1);
		g_value_init (_tmp78_, G_TYPE_UINT);
		g_value_set_uint (_tmp78_, _tmp77_);
		values = g_slist_append (values, _tmp78_);
		_tmp79_ = noise_media_get_track_count (m);
		_tmp80_ = _tmp79_;
		_tmp81_ = g_new0 (GValue, 1);
		g_value_init (_tmp81_, G_TYPE_UINT);
		g_value_set_uint (_tmp81_, _tmp80_);
		values = g_slist_append (values, _tmp81_);
		_tmp82_ = noise_media_get_album_number (m);
		_tmp83_ = _tmp82_;
		_tmp84_ = g_new0 (GValue, 1);
		g_value_init (_tmp84_, G_TYPE_UINT);
		g_value_set_uint (_tmp84_, _tmp83_);
		values = g_slist_append (values, _tmp84_);
		_tmp85_ = noise_media_get_album_count (m);
		_tmp86_ = _tmp85_;
		_tmp87_ = g_new0 (GValue, 1);
		g_value_init (_tmp87_, G_TYPE_UINT);
		g_value_set_uint (_tmp87_, _tmp86_);
		values = g_slist_append (values, _tmp87_);
		_tmp88_ = noise_media_get_bitrate (m);
		_tmp89_ = _tmp88_;
		_tmp90_ = g_new0 (GValue, 1);
		g_value_init (_tmp90_, G_TYPE_UINT);
		g_value_set_uint (_tmp90_, _tmp89_);
		values = g_slist_append (values, _tmp90_);
		_tmp91_ = noise_media_get_length (m);
		_tmp92_ = _tmp91_;
		_tmp93_ = g_new0 (GValue, 1);
		g_value_init (_tmp93_, G_TYPE_UINT);
		g_value_set_uint (_tmp93_, _tmp92_);
		values = g_slist_append (values, _tmp93_);
		_tmp94_ = noise_media_get_samplerate (m);
		_tmp95_ = _tmp94_;
		_tmp96_ = g_new0 (GValue, 1);
		g_value_init (_tmp96_, G_TYPE_UINT);
		g_value_set_uint (_tmp96_, _tmp95_);
		values = g_slist_append (values, _tmp96_);
		_tmp97_ = noise_media_get_rating (m);
		_tmp98_ = _tmp97_;
		_tmp99_ = g_new0 (GValue, 1);
		g_value_init (_tmp99_, G_TYPE_UINT);
		g_value_set_uint (_tmp99_, _tmp98_);
		values = g_slist_append (values, _tmp99_);
		_tmp100_ = noise_media_get_play_count (m);
		_tmp101_ = _tmp100_;
		_tmp102_ = g_new0 (GValue, 1);
		g_value_init (_tmp102_, G_TYPE_UINT);
		g_value_set_uint (_tmp102_, _tmp101_);
		values = g_slist_append (values, _tmp102_);
		_tmp103_ = noise_media_get_skip_count (m);
		_tmp104_ = _tmp103_;
		_tmp105_ = g_new0 (GValue, 1);
		g_value_init (_tmp105_, G_TYPE_UINT);
		g_value_set_uint (_tmp105_, _tmp104_);
		values = g_slist_append (values, _tmp105_);
		_tmp106_ = noise_media_get_date_added (m);
		_tmp107_ = _tmp106_;
		_tmp108_ = g_new0 (GValue, 1);
		g_value_init (_tmp108_, G_TYPE_UINT);
		g_value_set_uint (_tmp108_, _tmp107_);
		values = g_slist_append (values, _tmp108_);
		_tmp109_ = noise_media_get_last_played (m);
		_tmp110_ = _tmp109_;
		_tmp111_ = g_new0 (GValue, 1);
		g_value_init (_tmp111_, G_TYPE_UINT);
		g_value_set_uint (_tmp111_, _tmp110_);
		values = g_slist_append (values, _tmp111_);
		_tmp112_ = noise_media_get_last_modified (m);
		_tmp113_ = _tmp112_;
		_tmp114_ = g_new0 (GValue, 1);
		g_value_init (_tmp114_, G_TYPE_UINT);
		g_value_set_uint (_tmp114_, _tmp113_);
		values = g_slist_append (values, _tmp114_);
		_tmp115_ = noise_media_get_show (m);
		_tmp116_ = _tmp115_;
		_tmp117_ = g_new0 (GValue, 1);
		g_value_init (_tmp117_, G_TYPE_BOOLEAN);
		g_value_set_boolean (_tmp117_, _tmp116_);
		values = g_slist_append (values, _tmp117_);
		_tmp118_ = last_insert_row;
		_tmp119_ = col_names;
		_tmp120_ = values;
		_tmp121_ = *gda_set_get_holder_value (_tmp118_, NOISE_DATABASE_MEDIA_ROWID);
		gda_connection_update_row_in_table_v (connection, NOISE_DATABASE_MEDIA_TABLE_NAME, "rowid", &_tmp121_, _tmp119_, _tmp120_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			_g_object_unref0 (_tmp6_);
			_g_object_unref0 (last_insert_row);
			_g_object_unref0 (builder);
			goto __catch66_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
		_g_object_unref0 (_tmp6_);
		_g_object_unref0 (last_insert_row);
		_g_object_unref0 (builder);
	}
	goto __finally66;
	__catch66_g_error:
	{
		GError* e = NULL;
		GError* _tmp122_;
		const gchar* _tmp123_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp122_ = e;
		_tmp123_ = _tmp122_->message;
		g_warning ("LocalMedia.vala:392: Could not save media: %s", _tmp123_);
		_g_error_free0 (e);
	}
	__finally66:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp124_ = noise_media_get_rowid ((NoiseMedia*) self);
	_tmp125_ = _tmp124_;
	_tmp126_ = noise_database_query_field (_tmp125_, connection, NOISE_DATABASE_MEDIA_TABLE_NAME, "uri");
	query = _tmp126_;
	_tmp127_ = query;
	if (_tmp127_ != NULL) {
		GValue* _tmp128_;
		gchar* _tmp129_;
		gchar* _tmp130_;
		_tmp128_ = query;
		_tmp129_ = g_value_dup_string (_tmp128_);
		_tmp130_ = _tmp129_;
		noise_media_set_uri ((NoiseMedia*) self, _tmp130_);
		_g_free0 (_tmp130_);
	}
	__vala_GValue_free0 (query);
	return self;
}


NoiseLocalMedia*
noise_local_media_new_from_media (GdaConnection* connection,
                                  NoiseMedia* m)
{
	return noise_local_media_construct_from_media (NOISE_TYPE_LOCAL_MEDIA, connection, m);
}


static guint64*
_uint64_dup (guint64* self)
{
	guint64* dup;
	dup = g_new0 (guint64, 1);
	memcpy (dup, self, sizeof (guint64));
	return dup;
}


static gpointer
__uint64_dup0 (gpointer self)
{
	return self ? _uint64_dup (self) : NULL;
}


static guint64
noise_local_media_common_uint64_getter (NoiseLocalMedia* self,
                                        const gchar* field,
                                        guint64** temp)
{
	guint64 result = 0ULL;
	GValue* query = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
	g_return_val_if_fail (self != NULL, 0ULL);
	g_return_val_if_fail (field != NULL, 0ULL);
	if ((*temp) != NULL) {
		result = *(*temp);
		return result;
	}
	_tmp0_ = noise_media_get_rowid ((NoiseMedia*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	_tmp3_ = noise_database_query_field (_tmp1_, _tmp2_, NOISE_DATABASE_MEDIA_TABLE_NAME, field);
	query = _tmp3_;
	_tmp4_ = query;
	if (_tmp4_ != NULL) {
		GValue* _tmp5_;
		guint64 _tmp6_;
		guint64* _tmp7_;
		_tmp5_ = query;
		_tmp6_ = (guint64) g_value_get_int (_tmp5_);
		_tmp7_ = __uint64_dup0 (&_tmp6_);
		_g_free0 (*temp);
		*temp = _tmp7_;
		result = *(*temp);
		__vala_GValue_free0 (query);
		return result;
	} else {
		result = (guint64) 0;
		__vala_GValue_free0 (query);
		return result;
	}
	__vala_GValue_free0 (query);
}


static void
noise_local_media_common_uint64_setter (NoiseLocalMedia* self,
                                        const gchar* field,
                                        guint64 value,
                                        guint64** temp)
{
	guint64* _tmp0_;
	GValue val = {0};
	GValue _tmp1_ = {0};
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	_tmp0_ = __uint64_dup0 (&value);
	_g_free0 (*temp);
	*temp = _tmp0_;
	g_value_init (&_tmp1_, G_TYPE_UINT64);
	val = _tmp1_;
	g_value_set_uint64 (&val, value);
	_tmp2_ = noise_media_get_rowid ((NoiseMedia*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->connection;
	_tmp5_ = val;
	noise_database_set_field (_tmp3_, _tmp4_, NOISE_DATABASE_MEDIA_TABLE_NAME, field, &_tmp5_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}


static guint*
_uint_dup (guint* self)
{
	guint* dup;
	dup = g_new0 (guint, 1);
	memcpy (dup, self, sizeof (guint));
	return dup;
}


static gpointer
__uint_dup0 (gpointer self)
{
	return self ? _uint_dup (self) : NULL;
}


static guint
noise_local_media_common_uint_getter (NoiseLocalMedia* self,
                                      const gchar* field,
                                      guint** temp)
{
	guint result = 0U;
	GValue* query = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
	g_return_val_if_fail (self != NULL, 0U);
	g_return_val_if_fail (field != NULL, 0U);
	if ((*temp) != NULL) {
		result = *(*temp);
		return result;
	}
	_tmp0_ = noise_media_get_rowid ((NoiseMedia*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	_tmp3_ = noise_database_query_field (_tmp1_, _tmp2_, NOISE_DATABASE_MEDIA_TABLE_NAME, field);
	query = _tmp3_;
	_tmp4_ = query;
	if (_tmp4_ != NULL) {
		GValue* _tmp5_;
		guint _tmp6_;
		guint* _tmp7_;
		_tmp5_ = query;
		_tmp6_ = (guint) g_value_get_int (_tmp5_);
		_tmp7_ = __uint_dup0 (&_tmp6_);
		_g_free0 (*temp);
		*temp = _tmp7_;
		result = *(*temp);
		__vala_GValue_free0 (query);
		return result;
	} else {
		result = (guint) 0;
		__vala_GValue_free0 (query);
		return result;
	}
	__vala_GValue_free0 (query);
}


static void
noise_local_media_common_uint_setter (NoiseLocalMedia* self,
                                      const gchar* field,
                                      guint value,
                                      guint** temp)
{
	guint* _tmp0_;
	GValue val = {0};
	GValue _tmp1_ = {0};
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	_tmp0_ = __uint_dup0 (&value);
	_g_free0 (*temp);
	*temp = _tmp0_;
	g_value_init (&_tmp1_, G_TYPE_UINT);
	val = _tmp1_;
	g_value_set_uint (&val, value);
	_tmp2_ = noise_media_get_rowid ((NoiseMedia*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->connection;
	_tmp5_ = val;
	noise_database_set_field (_tmp3_, _tmp4_, NOISE_DATABASE_MEDIA_TABLE_NAME, field, &_tmp5_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}


static gchar*
noise_local_media_common_string_getter (NoiseLocalMedia* self,
                                        const gchar* field,
                                        gchar* * temp)
{
	gchar* result = NULL;
	GValue* query = NULL;
	gint64 _tmp1_;
	gint64 _tmp2_;
	GdaConnection* _tmp3_;
	GValue* _tmp4_;
	GValue* _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (field != NULL, NULL);
	if ((*temp) != NULL) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (*temp);
		result = _tmp0_;
		return result;
	}
	_tmp1_ = noise_media_get_rowid ((NoiseMedia*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->connection;
	_tmp4_ = noise_database_query_field (_tmp2_, _tmp3_, NOISE_DATABASE_MEDIA_TABLE_NAME, field);
	query = _tmp4_;
	_tmp5_ = query;
	if (_tmp5_ != NULL) {
		GValue* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp6_ = query;
		_tmp7_ = g_value_dup_string (_tmp6_);
		_g_free0 (*temp);
		*temp = _tmp7_;
		_tmp8_ = self->priv->_composer;
		_tmp9_ = g_strdup (_tmp8_);
		result = _tmp9_;
		__vala_GValue_free0 (query);
		return result;
	} else {
		const gchar* _tmp10_;
		gchar* _tmp11_;
		_tmp10_ = noise_media_UNKNOWN;
		_tmp11_ = g_strdup (_tmp10_);
		result = _tmp11_;
		__vala_GValue_free0 (query);
		return result;
	}
	__vala_GValue_free0 (query);
}


static void
noise_local_media_common_string_setter (NoiseLocalMedia* self,
                                        const gchar* field,
                                        const gchar* value,
                                        gchar* * temp)
{
	gchar* _tmp0_;
	GValue val = {0};
	GValue _tmp1_ = {0};
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	g_return_if_fail (value != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (*temp);
	*temp = _tmp0_;
	g_value_init (&_tmp1_, G_TYPE_STRING);
	val = _tmp1_;
	g_value_set_string (&val, value);
	_tmp2_ = noise_media_get_rowid ((NoiseMedia*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->connection;
	_tmp5_ = val;
	noise_database_set_field (_tmp3_, _tmp4_, NOISE_DATABASE_MEDIA_TABLE_NAME, field, &_tmp5_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}


static guint64
noise_local_media_real_get_file_size (NoiseMedia* base)
{
	guint64 result;
	NoiseLocalMedia* self;
	guint64* _tmp0_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint64_getter (self, "file_size", &self->priv->_file_size);
	_tmp0_ = self->priv->_file_size;
	result = *_tmp0_;
	return result;
}


static void
noise_local_media_real_set_file_size (NoiseMedia* base,
                                      guint64 value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint64_setter (self, "file_size", value, &self->priv->_file_size);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY]);
}


static const gchar*
noise_local_media_real_get_title (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (NoiseLocalMedia*) base;
	_tmp0_ = noise_local_media_common_string_getter (self, "title", &self->priv->_title);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_title;
	result = _tmp2_;
	return result;
}


static void
noise_local_media_real_set_title (NoiseMedia* base,
                                  const gchar* value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_string_setter (self, "title", value, &self->priv->_title);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_TITLE_PROPERTY]);
}


static guint
noise_local_media_real_get_track (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_getter (self, "track", &self->priv->_track);
	_tmp0_ = self->priv->_track;
	result = *_tmp0_;
	return result;
}


static void
noise_local_media_real_set_track (NoiseMedia* base,
                                  guint value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_setter (self, "track", value, &self->priv->_track);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_TRACK_PROPERTY]);
}


static guint
noise_local_media_real_get_track_count (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_getter (self, "track_count", &self->priv->_track_count);
	_tmp0_ = self->priv->_track_count;
	result = *_tmp0_;
	return result;
}


static void
noise_local_media_real_set_track_count (NoiseMedia* base,
                                        guint value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_setter (self, "track_count", value, &self->priv->_track_count);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY]);
}


static const gchar*
noise_local_media_real_get_composer (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (NoiseLocalMedia*) base;
	_tmp0_ = noise_local_media_common_string_getter (self, "composer", &self->priv->_composer);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_composer;
	result = _tmp2_;
	return result;
}


static void
noise_local_media_real_set_composer (NoiseMedia* base,
                                     const gchar* value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_string_setter (self, "composer", value, &self->priv->_composer);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY]);
}


static const gchar*
noise_local_media_real_get_artist (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (NoiseLocalMedia*) base;
	_tmp0_ = noise_local_media_common_string_getter (self, "artist", &self->priv->_artist);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_artist;
	result = _tmp2_;
	return result;
}


static void
noise_local_media_real_set_artist (NoiseMedia* base,
                                   const gchar* value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_string_setter (self, "artist", value, &self->priv->_artist);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ARTIST_PROPERTY]);
}


static const gchar*
noise_local_media_real_get_album_artist (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (NoiseLocalMedia*) base;
	_tmp0_ = noise_local_media_common_string_getter (self, "album_artist", &self->priv->_album_artist);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_album_artist;
	result = _tmp2_;
	return result;
}


static void
noise_local_media_real_set_album_artist (NoiseMedia* base,
                                         const gchar* value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_string_setter (self, "album_artist", value, &self->priv->_album_artist);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY]);
}


static const gchar*
noise_local_media_real_get_album (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (NoiseLocalMedia*) base;
	_tmp0_ = noise_local_media_common_string_getter (self, "album", &self->priv->_album);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_album;
	result = _tmp2_;
	return result;
}


static void
noise_local_media_real_set_album (NoiseMedia* base,
                                  const gchar* value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_string_setter (self, "album", value, &self->priv->_album);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_PROPERTY]);
}


static guint
noise_local_media_real_get_album_number (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_getter (self, "album_number", &self->priv->_album_number);
	_tmp0_ = self->priv->_album_number;
	result = *_tmp0_;
	return result;
}


static void
noise_local_media_real_set_album_number (NoiseMedia* base,
                                         guint value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_setter (self, "album_number", value, &self->priv->_album_number);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY]);
}


static guint
noise_local_media_real_get_album_count (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_getter (self, "album_count", &self->priv->_album_count);
	_tmp0_ = self->priv->_album_count;
	result = *_tmp0_;
	return result;
}


static void
noise_local_media_real_set_album_count (NoiseMedia* base,
                                        guint value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_setter (self, "album_count", value, &self->priv->_album_count);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY]);
}


static NoiseAlbum*
noise_local_media_real_get_album_info (NoiseMedia* base)
{
	NoiseAlbum* result;
	NoiseLocalMedia* self;
	NoiseAlbum* _tmp0_;
	self = (NoiseLocalMedia*) base;
	_tmp0_ = self->priv->_album_info;
	result = _tmp0_;
	return result;
}


static void
noise_local_media_real_set_album_info (NoiseMedia* base,
                                       NoiseAlbum* value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	if (noise_local_media_real_get_album_info (base) != value) {
		self->priv->_album_info = value;
		g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY]);
	}
}


static const gchar*
noise_local_media_real_get_grouping (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (NoiseLocalMedia*) base;
	_tmp0_ = noise_local_media_common_string_getter (self, "grouping", &self->priv->_grouping);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_grouping;
	result = _tmp2_;
	return result;
}


static void
noise_local_media_real_set_grouping (NoiseMedia* base,
                                     const gchar* value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_string_setter (self, "grouping", value, &self->priv->_grouping);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_GROUPING_PROPERTY]);
}


static const gchar*
noise_local_media_real_get_genre (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (NoiseLocalMedia*) base;
	_tmp0_ = noise_local_media_common_string_getter (self, "genre", &self->priv->_genre);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_genre;
	result = _tmp2_;
	return result;
}


static void
noise_local_media_real_set_genre (NoiseMedia* base,
                                  const gchar* value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_string_setter (self, "genre", value, &self->priv->_genre);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_GENRE_PROPERTY]);
}


static const gchar*
noise_local_media_real_get_comment (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (NoiseLocalMedia*) base;
	_tmp0_ = noise_local_media_common_string_getter (self, "comment", &self->priv->_comment);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_comment;
	result = _tmp2_;
	return result;
}


static void
noise_local_media_real_set_comment (NoiseMedia* base,
                                    const gchar* value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_string_setter (self, "comment", value, &self->priv->_comment);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_COMMENT_PROPERTY]);
}


static const gchar*
noise_local_media_real_get_lyrics (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (NoiseLocalMedia*) base;
	_tmp0_ = noise_local_media_common_string_getter (self, "lyrics", &self->priv->_lyrics);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_lyrics;
	result = _tmp2_;
	return result;
}


static void
noise_local_media_real_set_lyrics (NoiseMedia* base,
                                   const gchar* value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_string_setter (self, "lyrics", value, &self->priv->_lyrics);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_LYRICS_PROPERTY]);
}


static guint
noise_local_media_real_get_year (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_getter (self, "year", &self->_year);
	_tmp0_ = self->_year;
	result = *_tmp0_;
	return result;
}


static void
noise_local_media_real_set_year (NoiseMedia* base,
                                 guint value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_setter (self, "year", value, &self->_year);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_YEAR_PROPERTY]);
}


static guint
noise_local_media_real_get_bitrate (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_getter (self, "bitrate", &self->_bitrate);
	_tmp0_ = self->_bitrate;
	result = *_tmp0_;
	return result;
}


static void
noise_local_media_real_set_bitrate (NoiseMedia* base,
                                    guint value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_setter (self, "bitrate", value, &self->_bitrate);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_BITRATE_PROPERTY]);
}


static guint
noise_local_media_real_get_samplerate (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_getter (self, "samplerate", &self->_samplerate);
	_tmp0_ = self->_samplerate;
	result = *_tmp0_;
	return result;
}


static void
noise_local_media_real_set_samplerate (NoiseMedia* base,
                                       guint value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_setter (self, "samplerate", value, &self->_samplerate);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY]);
}


static guint
noise_local_media_real_get_length (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_getter (self, "length", &self->_length);
	_tmp0_ = self->_length;
	result = *_tmp0_;
	return result;
}


static void
noise_local_media_real_set_length (NoiseMedia* base,
                                   guint value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_setter (self, "length", value, &self->_length);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_LENGTH_PROPERTY]);
}


static guint
noise_local_media_real_get_rating (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint _tmp0_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_getter (self, "rating", &((NoiseMedia*) self)->_rating);
	_tmp0_ = ((NoiseMedia*) self)->_rating;
	result = _tmp0_;
	return result;
}


static void
noise_local_media_real_set_rating (NoiseMedia* base,
                                   guint value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_setter (self, "rating", CLAMP (value, (guint) 0, (guint) 5), &((NoiseMedia*) self)->_rating);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_RATING_PROPERTY]);
}


static guint
noise_local_media_real_get_play_count (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_getter (self, "playcount", &self->_play_count);
	_tmp0_ = self->_play_count;
	result = *_tmp0_;
	return result;
}


static void
noise_local_media_real_set_play_count (NoiseMedia* base,
                                       guint value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_setter (self, "playcount", value, &self->_play_count);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY]);
}


static guint
noise_local_media_real_get_skip_count (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_getter (self, "skipcount", &self->_skip_count);
	_tmp0_ = self->_skip_count;
	result = *_tmp0_;
	return result;
}


static void
noise_local_media_real_set_skip_count (NoiseMedia* base,
                                       guint value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_setter (self, "skipcount", value, &self->_skip_count);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY]);
}


static guint
noise_local_media_real_get_date_added (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_getter (self, "dateadded", &self->_date_added);
	_tmp0_ = self->_date_added;
	result = *_tmp0_;
	return result;
}


static void
noise_local_media_real_set_date_added (NoiseMedia* base,
                                       guint value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_setter (self, "dateadded", value, &self->_date_added);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY]);
}


static guint
noise_local_media_real_get_last_played (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_getter (self, "lastplayed", &self->_last_played);
	_tmp0_ = self->_last_played;
	result = *_tmp0_;
	return result;
}


static void
noise_local_media_real_set_last_played (NoiseMedia* base,
                                        guint value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_setter (self, "lastplayed", value, &self->_last_played);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY]);
}


static guint
noise_local_media_real_get_last_modified (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_getter (self, "lastmodified", &self->_last_modified);
	_tmp0_ = self->_last_modified;
	result = *_tmp0_;
	return result;
}


static void
noise_local_media_real_set_last_modified (NoiseMedia* base,
                                          guint value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_setter (self, "lastmodified", value, &self->_last_modified);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY]);
}


static gboolean
_uint_equal (const guint * s1,
             const guint * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	return (*s1) == (*s2);
}


static gboolean
noise_local_media_real_get_show (NoiseMedia* base)
{
	gboolean result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
	guint _tmp1_;
	self = (NoiseLocalMedia*) base;
	noise_local_media_common_uint_getter (self, "show", &self->priv->_show);
	_tmp0_ = self->priv->_show;
	_tmp1_ = (guint) 1;
	result = _uint_equal (_tmp0_, &_tmp1_) == TRUE;
	return result;
}


static void
noise_local_media_real_set_show (NoiseMedia* base,
                                 gboolean value)
{
	NoiseLocalMedia* self;
	gint _tmp0_ = 0;
	self = (NoiseLocalMedia*) base;
	if (value) {
		_tmp0_ = 1;
	} else {
		_tmp0_ = 0;
	}
	noise_local_media_common_uint_setter (self, "show", (guint) _tmp0_, &self->priv->_show);
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_SHOW_PROPERTY]);
}


static gint
noise_local_media_real_get_resume_pos (NoiseMedia* base)
{
	gint result;
	NoiseLocalMedia* self;
	gint _tmp0_;
	self = (NoiseLocalMedia*) base;
	_tmp0_ = self->priv->_resume_pos;
	result = _tmp0_;
	return result;
}


static void
noise_local_media_real_set_resume_pos (NoiseMedia* base,
                                       gint value)
{
	NoiseLocalMedia* self;
	self = (NoiseLocalMedia*) base;
	if (noise_local_media_real_get_resume_pos (base) != value) {
		self->priv->_resume_pos = value;
		g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY]);
	}
}


static void
noise_local_media_class_init (NoiseLocalMediaClass * klass)
{
	noise_local_media_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseLocalMedia_private_offset);
	NOISE_MEDIA_CLASS (klass)->get_file_size = noise_local_media_real_get_file_size;
	NOISE_MEDIA_CLASS (klass)->set_file_size = noise_local_media_real_set_file_size;
	NOISE_MEDIA_CLASS (klass)->get_title = noise_local_media_real_get_title;
	NOISE_MEDIA_CLASS (klass)->set_title = noise_local_media_real_set_title;
	NOISE_MEDIA_CLASS (klass)->get_track = noise_local_media_real_get_track;
	NOISE_MEDIA_CLASS (klass)->set_track = noise_local_media_real_set_track;
	NOISE_MEDIA_CLASS (klass)->get_track_count = noise_local_media_real_get_track_count;
	NOISE_MEDIA_CLASS (klass)->set_track_count = noise_local_media_real_set_track_count;
	NOISE_MEDIA_CLASS (klass)->get_composer = noise_local_media_real_get_composer;
	NOISE_MEDIA_CLASS (klass)->set_composer = noise_local_media_real_set_composer;
	NOISE_MEDIA_CLASS (klass)->get_artist = noise_local_media_real_get_artist;
	NOISE_MEDIA_CLASS (klass)->set_artist = noise_local_media_real_set_artist;
	NOISE_MEDIA_CLASS (klass)->get_album_artist = noise_local_media_real_get_album_artist;
	NOISE_MEDIA_CLASS (klass)->set_album_artist = noise_local_media_real_set_album_artist;
	NOISE_MEDIA_CLASS (klass)->get_album = noise_local_media_real_get_album;
	NOISE_MEDIA_CLASS (klass)->set_album = noise_local_media_real_set_album;
	NOISE_MEDIA_CLASS (klass)->get_album_number = noise_local_media_real_get_album_number;
	NOISE_MEDIA_CLASS (klass)->set_album_number = noise_local_media_real_set_album_number;
	NOISE_MEDIA_CLASS (klass)->get_album_count = noise_local_media_real_get_album_count;
	NOISE_MEDIA_CLASS (klass)->set_album_count = noise_local_media_real_set_album_count;
	NOISE_MEDIA_CLASS (klass)->get_album_info = noise_local_media_real_get_album_info;
	NOISE_MEDIA_CLASS (klass)->set_album_info = noise_local_media_real_set_album_info;
	NOISE_MEDIA_CLASS (klass)->get_grouping = noise_local_media_real_get_grouping;
	NOISE_MEDIA_CLASS (klass)->set_grouping = noise_local_media_real_set_grouping;
	NOISE_MEDIA_CLASS (klass)->get_genre = noise_local_media_real_get_genre;
	NOISE_MEDIA_CLASS (klass)->set_genre = noise_local_media_real_set_genre;
	NOISE_MEDIA_CLASS (klass)->get_comment = noise_local_media_real_get_comment;
	NOISE_MEDIA_CLASS (klass)->set_comment = noise_local_media_real_set_comment;
	NOISE_MEDIA_CLASS (klass)->get_lyrics = noise_local_media_real_get_lyrics;
	NOISE_MEDIA_CLASS (klass)->set_lyrics = noise_local_media_real_set_lyrics;
	NOISE_MEDIA_CLASS (klass)->get_year = noise_local_media_real_get_year;
	NOISE_MEDIA_CLASS (klass)->set_year = noise_local_media_real_set_year;
	NOISE_MEDIA_CLASS (klass)->get_bitrate = noise_local_media_real_get_bitrate;
	NOISE_MEDIA_CLASS (klass)->set_bitrate = noise_local_media_real_set_bitrate;
	NOISE_MEDIA_CLASS (klass)->get_samplerate = noise_local_media_real_get_samplerate;
	NOISE_MEDIA_CLASS (klass)->set_samplerate = noise_local_media_real_set_samplerate;
	NOISE_MEDIA_CLASS (klass)->get_length = noise_local_media_real_get_length;
	NOISE_MEDIA_CLASS (klass)->set_length = noise_local_media_real_set_length;
	NOISE_MEDIA_CLASS (klass)->get_rating = noise_local_media_real_get_rating;
	NOISE_MEDIA_CLASS (klass)->set_rating = noise_local_media_real_set_rating;
	NOISE_MEDIA_CLASS (klass)->get_play_count = noise_local_media_real_get_play_count;
	NOISE_MEDIA_CLASS (klass)->set_play_count = noise_local_media_real_set_play_count;
	NOISE_MEDIA_CLASS (klass)->get_skip_count = noise_local_media_real_get_skip_count;
	NOISE_MEDIA_CLASS (klass)->set_skip_count = noise_local_media_real_set_skip_count;
	NOISE_MEDIA_CLASS (klass)->get_date_added = noise_local_media_real_get_date_added;
	NOISE_MEDIA_CLASS (klass)->set_date_added = noise_local_media_real_set_date_added;
	NOISE_MEDIA_CLASS (klass)->get_last_played = noise_local_media_real_get_last_played;
	NOISE_MEDIA_CLASS (klass)->set_last_played = noise_local_media_real_set_last_played;
	NOISE_MEDIA_CLASS (klass)->get_last_modified = noise_local_media_real_get_last_modified;
	NOISE_MEDIA_CLASS (klass)->set_last_modified = noise_local_media_real_set_last_modified;
	NOISE_MEDIA_CLASS (klass)->get_show = noise_local_media_real_get_show;
	NOISE_MEDIA_CLASS (klass)->set_show = noise_local_media_real_set_show;
	NOISE_MEDIA_CLASS (klass)->get_resume_pos = noise_local_media_real_get_resume_pos;
	NOISE_MEDIA_CLASS (klass)->set_resume_pos = noise_local_media_real_set_resume_pos;
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_local_media_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_local_media_set_property;
	G_OBJECT_CLASS (klass)->finalize = noise_local_media_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY] = g_param_spec_uint64 ("file-size", "file-size", "file-size", 0, G_MAXUINT64, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_TITLE_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_TRACK_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_TRACK_PROPERTY] = g_param_spec_uint ("track", "track", "track", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY] = g_param_spec_uint ("track-count", "track-count", "track-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY] = g_param_spec_string ("composer", "composer", "composer", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ARTIST_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ARTIST_PROPERTY] = g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY] = g_param_spec_string ("album-artist", "album-artist", "album-artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ALBUM_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_PROPERTY] = g_param_spec_string ("album", "album", "album", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY] = g_param_spec_uint ("album-number", "album-number", "album-number", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY] = g_param_spec_uint ("album-count", "album-count", "album-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY] = g_param_spec_object ("album-info", "album-info", "album-info", NOISE_TYPE_ALBUM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_GROUPING_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_GROUPING_PROPERTY] = g_param_spec_string ("grouping", "grouping", "grouping", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_GENRE_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_GENRE_PROPERTY] = g_param_spec_string ("genre", "genre", "genre", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_COMMENT_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_COMMENT_PROPERTY] = g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_LYRICS_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_LYRICS_PROPERTY] = g_param_spec_string ("lyrics", "lyrics", "lyrics", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_YEAR_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_YEAR_PROPERTY] = g_param_spec_uint ("year", "year", "year", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_BITRATE_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_BITRATE_PROPERTY] = g_param_spec_uint ("bitrate", "bitrate", "bitrate", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY] = g_param_spec_uint ("samplerate", "samplerate", "samplerate", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_LENGTH_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_LENGTH_PROPERTY] = g_param_spec_uint ("length", "length", "length", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_RATING_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_RATING_PROPERTY] = g_param_spec_uint ("rating", "rating", "rating", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY] = g_param_spec_uint ("play-count", "play-count", "play-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY] = g_param_spec_uint ("skip-count", "skip-count", "skip-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY] = g_param_spec_uint ("date-added", "date-added", "date-added", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY] = g_param_spec_uint ("last-played", "last-played", "last-played", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY] = g_param_spec_uint ("last-modified", "last-modified", "last-modified", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_SHOW_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_SHOW_PROPERTY] = g_param_spec_boolean ("show", "show", "show", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY] = g_param_spec_int ("resume-pos", "resume-pos", "resume-pos", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void
noise_local_media_instance_init (NoiseLocalMedia * self)
{
	self->priv = noise_local_media_get_instance_private (self);
	self->priv->_file_size = NULL;
	self->priv->_title = NULL;
	self->priv->_track = NULL;
	self->priv->_track_count = NULL;
	self->priv->_composer = NULL;
	self->priv->_artist = NULL;
	self->priv->_album_artist = NULL;
	self->priv->_album = NULL;
	self->priv->_album_number = NULL;
	self->priv->_album_count = NULL;
	self->priv->_album_info = NULL;
	self->priv->_grouping = NULL;
	self->priv->_genre = NULL;
	self->priv->_comment = NULL;
	self->priv->_lyrics = NULL;
	self->_year = NULL;
	self->_bitrate = NULL;
	self->_samplerate = NULL;
	self->_length = NULL;
	self->_play_count = NULL;
	self->_skip_count = NULL;
	self->_date_added = NULL;
	self->_last_played = NULL;
	self->_last_modified = NULL;
	self->priv->_show = NULL;
	self->priv->_resume_pos = 0;
}


static void
noise_local_media_finalize (GObject * obj)
{
	NoiseLocalMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMedia);
	_g_free0 (self->priv->_file_size);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->_track);
	_g_free0 (self->priv->_track_count);
	_g_free0 (self->priv->_composer);
	_g_free0 (self->priv->_artist);
	_g_free0 (self->priv->_album_artist);
	_g_free0 (self->priv->_album);
	_g_free0 (self->priv->_album_number);
	_g_free0 (self->priv->_album_count);
	_g_free0 (self->priv->_grouping);
	_g_free0 (self->priv->_genre);
	_g_free0 (self->priv->_comment);
	_g_free0 (self->priv->_lyrics);
	_g_free0 (self->_year);
	_g_free0 (self->_bitrate);
	_g_free0 (self->_samplerate);
	_g_free0 (self->_length);
	_g_free0 (self->_play_count);
	_g_free0 (self->_skip_count);
	_g_free0 (self->_date_added);
	_g_free0 (self->_last_played);
	_g_free0 (self->_last_modified);
	_g_free0 (self->priv->_show);
	_g_object_unref0 (self->priv->connection);
	G_OBJECT_CLASS (noise_local_media_parent_class)->finalize (obj);
}


GType
noise_local_media_get_type (void)
{
	static volatile gsize noise_local_media_type_id__volatile = 0;
	if (g_once_init_enter (&noise_local_media_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseLocalMediaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_local_media_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseLocalMedia), 0, (GInstanceInitFunc) noise_local_media_instance_init, NULL };
		GType noise_local_media_type_id;
		noise_local_media_type_id = g_type_register_static (NOISE_TYPE_MEDIA, "NoiseLocalMedia", &g_define_type_info, 0);
		NoiseLocalMedia_private_offset = g_type_add_instance_private (noise_local_media_type_id, sizeof (NoiseLocalMediaPrivate));
		g_once_init_leave (&noise_local_media_type_id__volatile, noise_local_media_type_id);
	}
	return noise_local_media_type_id__volatile;
}


static void
_vala_noise_local_media_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	NoiseLocalMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMedia);
	switch (property_id) {
		case NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY:
		g_value_set_uint64 (value, noise_media_get_file_size ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_TITLE_PROPERTY:
		g_value_set_string (value, noise_media_get_title ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_TRACK_PROPERTY:
		g_value_set_uint (value, noise_media_get_track ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY:
		g_value_set_uint (value, noise_media_get_track_count ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY:
		g_value_set_string (value, noise_media_get_composer ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_ARTIST_PROPERTY:
		g_value_set_string (value, noise_media_get_artist ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY:
		g_value_set_string (value, noise_media_get_album_artist ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_ALBUM_PROPERTY:
		g_value_set_string (value, noise_media_get_album ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY:
		g_value_set_uint (value, noise_media_get_album_number ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY:
		g_value_set_uint (value, noise_media_get_album_count ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY:
		g_value_set_object (value, noise_media_get_album_info ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_GROUPING_PROPERTY:
		g_value_set_string (value, noise_media_get_grouping ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_GENRE_PROPERTY:
		g_value_set_string (value, noise_media_get_genre ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_COMMENT_PROPERTY:
		g_value_set_string (value, noise_media_get_comment ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_LYRICS_PROPERTY:
		g_value_set_string (value, noise_media_get_lyrics ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_YEAR_PROPERTY:
		g_value_set_uint (value, noise_media_get_year ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_BITRATE_PROPERTY:
		g_value_set_uint (value, noise_media_get_bitrate ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY:
		g_value_set_uint (value, noise_media_get_samplerate ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_LENGTH_PROPERTY:
		g_value_set_uint (value, noise_media_get_length ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_RATING_PROPERTY:
		g_value_set_uint (value, noise_media_get_rating ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY:
		g_value_set_uint (value, noise_media_get_play_count ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY:
		g_value_set_uint (value, noise_media_get_skip_count ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY:
		g_value_set_uint (value, noise_media_get_date_added ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY:
		g_value_set_uint (value, noise_media_get_last_played ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY:
		g_value_set_uint (value, noise_media_get_last_modified ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_SHOW_PROPERTY:
		g_value_set_boolean (value, noise_media_get_show ((NoiseMedia*) self));
		break;
		case NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY:
		g_value_set_int (value, noise_media_get_resume_pos ((NoiseMedia*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_local_media_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	NoiseLocalMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMedia);
	switch (property_id) {
		case NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY:
		noise_media_set_file_size ((NoiseMedia*) self, g_value_get_uint64 (value));
		break;
		case NOISE_LOCAL_MEDIA_TITLE_PROPERTY:
		noise_media_set_title ((NoiseMedia*) self, g_value_get_string (value));
		break;
		case NOISE_LOCAL_MEDIA_TRACK_PROPERTY:
		noise_media_set_track ((NoiseMedia*) self, g_value_get_uint (value));
		break;
		case NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY:
		noise_media_set_track_count ((NoiseMedia*) self, g_value_get_uint (value));
		break;
		case NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY:
		noise_media_set_composer ((NoiseMedia*) self, g_value_get_string (value));
		break;
		case NOISE_LOCAL_MEDIA_ARTIST_PROPERTY:
		noise_media_set_artist ((NoiseMedia*) self, g_value_get_string (value));
		break;
		case NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY:
		noise_media_set_album_artist ((NoiseMedia*) self, g_value_get_string (value));
		break;
		case NOISE_LOCAL_MEDIA_ALBUM_PROPERTY:
		noise_media_set_album ((NoiseMedia*) self, g_value_get_string (value));
		break;
		case NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY:
		noise_media_set_album_number ((NoiseMedia*) self, g_value_get_uint (value));
		break;
		case NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY:
		noise_media_set_album_count ((NoiseMedia*) self, g_value_get_uint (value));
		break;
		case NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY:
		noise_media_set_album_info ((NoiseMedia*) self, g_value_get_object (value));
		break;
		case NOISE_LOCAL_MEDIA_GROUPING_PROPERTY:
		noise_media_set_grouping ((NoiseMedia*) self, g_value_get_string (value));
		break;
		case NOISE_LOCAL_MEDIA_GENRE_PROPERTY:
		noise_media_set_genre ((NoiseMedia*) self, g_value_get_string (value));
		break;
		case NOISE_LOCAL_MEDIA_COMMENT_PROPERTY:
		noise_media_set_comment ((NoiseMedia*) self, g_value_get_string (value));
		break;
		case NOISE_LOCAL_MEDIA_LYRICS_PROPERTY:
		noise_media_set_lyrics ((NoiseMedia*) self, g_value_get_string (value));
		break;
		case NOISE_LOCAL_MEDIA_YEAR_PROPERTY:
		noise_media_set_year ((NoiseMedia*) self, g_value_get_uint (value));
		break;
		case NOISE_LOCAL_MEDIA_BITRATE_PROPERTY:
		noise_media_set_bitrate ((NoiseMedia*) self, g_value_get_uint (value));
		break;
		case NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY:
		noise_media_set_samplerate ((NoiseMedia*) self, g_value_get_uint (value));
		break;
		case NOISE_LOCAL_MEDIA_LENGTH_PROPERTY:
		noise_media_set_length ((NoiseMedia*) self, g_value_get_uint (value));
		break;
		case NOISE_LOCAL_MEDIA_RATING_PROPERTY:
		noise_media_set_rating ((NoiseMedia*) self, g_value_get_uint (value));
		break;
		case NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY:
		noise_media_set_play_count ((NoiseMedia*) self, g_value_get_uint (value));
		break;
		case NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY:
		noise_media_set_skip_count ((NoiseMedia*) self, g_value_get_uint (value));
		break;
		case NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY:
		noise_media_set_date_added ((NoiseMedia*) self, g_value_get_uint (value));
		break;
		case NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY:
		noise_media_set_last_played ((NoiseMedia*) self, g_value_get_uint (value));
		break;
		case NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY:
		noise_media_set_last_modified ((NoiseMedia*) self, g_value_get_uint (value));
		break;
		case NOISE_LOCAL_MEDIA_SHOW_PROPERTY:
		noise_media_set_show ((NoiseMedia*) self, g_value_get_boolean (value));
		break;
		case NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY:
		noise_media_set_resume_pos ((NoiseMedia*) self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



