/* LocalSmartPlaylist.c generated by valac 0.41.91, the Vala compiler
 * generated from LocalSmartPlaylist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <libgda/libgda.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>


#define NOISE_TYPE_LOCAL_SMART_PLAYLIST (noise_local_smart_playlist_get_type ())
#define NOISE_LOCAL_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylist))
#define NOISE_LOCAL_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylistClass))
#define NOISE_IS_LOCAL_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LOCAL_SMART_PLAYLIST))
#define NOISE_IS_LOCAL_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LOCAL_SMART_PLAYLIST))
#define NOISE_LOCAL_SMART_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylistClass))

typedef struct _NoiseLocalSmartPlaylist NoiseLocalSmartPlaylist;
typedef struct _NoiseLocalSmartPlaylistClass NoiseLocalSmartPlaylistClass;
typedef struct _NoiseLocalSmartPlaylistPrivate NoiseLocalSmartPlaylistPrivate;
enum  {
	NOISE_LOCAL_SMART_PLAYLIST_0_PROPERTY,
	NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY,
	NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY,
	NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY,
	NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY,
	NOISE_LOCAL_SMART_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _NoiseLocalSmartPlaylist {
	NoiseSmartPlaylist parent_instance;
	NoiseLocalSmartPlaylistPrivate * priv;
};

struct _NoiseLocalSmartPlaylistClass {
	NoiseSmartPlaylistClass parent_class;
};

struct _NoiseLocalSmartPlaylistPrivate {
	GdaConnection* connection;
	gchar* _name;
};


static gint NoiseLocalSmartPlaylist_private_offset;
static gpointer noise_local_smart_playlist_parent_class = NULL;

GType noise_local_smart_playlist_get_type (void) G_GNUC_CONST;
#define NOISE_LOCAL_SMART_PLAYLIST_QUERY_SEPARATOR "<query_sep>"
#define NOISE_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR "<val_sep>"
NoiseLocalSmartPlaylist* noise_local_smart_playlist_new (gint64 rowid,
                                                         GdaConnection* connection);
NoiseLocalSmartPlaylist* noise_local_smart_playlist_construct (GType object_type,
                                                               gint64 rowid,
                                                               GdaConnection* connection);
GValue* noise_database_query_field (gint64 rowid,
                                    GdaConnection* connection,
                                    const gchar* table,
                                    const gchar* field);
#define NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME "smart_playlists"
static void _vala_GValue_free (GValue* self);
void noise_local_smart_playlist_queries_from_string (NoiseLocalSmartPlaylist* self,
                                                     const gchar* q);
static void noise_local_smart_playlist_real_analyse_all (NoiseSmartPlaylist* base);
static gint64* _int64_dup (gint64* self);
#define NOISE_DATABASE_MEDIA_TABLE_NAME "media"
GdaSqlBuilderId noise_database_process_smart_query (GdaSqlBuilder* builder,
                                                    NoiseSmartQuery* sq);
static void _vala_array_add2 (GdaSqlBuilderId* * array,
                       int* length,
                       int* size,
                       GdaSqlBuilderId value);
static void noise_local_smart_playlist_real_clear_queries (NoiseSmartPlaylist* base);
void noise_database_set_field (gint64 rowid,
                               GdaConnection* connection,
                               const gchar* table,
                               const gchar* field,
                               GValue* value);
static void noise_local_smart_playlist_real_add_query (NoiseSmartPlaylist* base,
                                                NoiseSmartQuery* s);
static gchar* noise_local_smart_playlist_queries_to_string (NoiseLocalSmartPlaylist* self);
static void noise_local_smart_playlist_real_add_queries (NoiseSmartPlaylist* base,
                                                  GeeCollection* queries);
void noise_local_smart_playlist_add_defaults (GdaConnection* connection);
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static void noise_local_smart_playlist_finalize (GObject * obj);
static void _vala_noise_local_smart_playlist_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_noise_local_smart_playlist_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static inline gpointer
noise_local_smart_playlist_get_instance_private (NoiseLocalSmartPlaylist* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseLocalSmartPlaylist_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
_vala_GValue_free (GValue* self)
{
	g_value_unset (self);
	g_free (self);
}


NoiseLocalSmartPlaylist*
noise_local_smart_playlist_construct (GType object_type,
                                      gint64 rowid,
                                      GdaConnection* connection)
{
	NoiseLocalSmartPlaylist * self = NULL;
	NoiseLibrariesManager* _tmp0_;
	NoiseLibrary* _tmp1_;
	GdaConnection* _tmp2_;
	gchar* queries_str = NULL;
	GValue* _tmp3_;
	GValue* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	g_return_val_if_fail (connection != NULL, NULL);
	_tmp0_ = noise_libraries_manager;
	_tmp1_ = _tmp0_->local_library;
	self = (NoiseLocalSmartPlaylist*) noise_smart_playlist_construct (object_type, _tmp1_);
	_tmp2_ = _g_object_ref0 (connection);
	_g_object_unref0 (self->priv->connection);
	self->priv->connection = _tmp2_;
	noise_playlist_set_rowid ((NoisePlaylist*) self, rowid);
	_tmp3_ = noise_database_query_field (rowid, connection, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries");
	_tmp4_ = _tmp3_;
	_tmp5_ = g_value_get_string (_tmp4_);
	_tmp6_ = g_strdup (_tmp5_);
	_tmp7_ = _tmp6_;
	__vala_GValue_free0 (_tmp4_);
	queries_str = _tmp7_;
	noise_local_smart_playlist_queries_from_string (self, queries_str);
	_g_free0 (queries_str);
	return self;
}


NoiseLocalSmartPlaylist*
noise_local_smart_playlist_new (gint64 rowid,
                                GdaConnection* connection)
{
	return noise_local_smart_playlist_construct (NOISE_TYPE_LOCAL_SMART_PLAYLIST, rowid, connection);
}


static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
	dup = g_new0 (gint64, 1);
	memcpy (dup, self, sizeof (gint64));
	return dup;
}


static void
_vala_array_add2 (GdaSqlBuilderId* * array,
                  int* length,
                  int* size,
                  GdaSqlBuilderId value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GdaSqlBuilderId, *array, *size);
	}
	(*array)[(*length)++] = value;
}


static void
noise_local_smart_playlist_real_analyse_all (NoiseSmartPlaylist* base)
{
	NoiseLocalSmartPlaylist * self;
	GeeTreeSet* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GeeTreeSet* rowids = NULL;
	GeeTreeSet* _tmp10_;
	GError * _inner_error_ = NULL;
	self = (NoiseLocalSmartPlaylist*) base;
	_tmp0_ = ((NoiseSmartPlaylist*) self)->queries;
	_tmp1_ = gee_collection_get_is_empty ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GeeCollection* meds = NULL;
		NoiseLibrary* _tmp3_;
		NoiseLibrary* _tmp4_;
		GeeCollection* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
		_tmp3_ = noise_smart_playlist_get_library ((NoiseSmartPlaylist*) self);
		_tmp4_ = _tmp3_;
		_tmp5_ = noise_library_get_medias (_tmp4_);
		meds = _tmp5_;
		_tmp6_ = noise_playlist_get_medias ((NoisePlaylist*) self);
		_tmp7_ = _tmp6_;
		_tmp8_ = meds;
		gee_array_list_add_all (_tmp7_, _tmp8_);
		_tmp9_ = meds;
		g_signal_emit_by_name ((NoisePlaylist*) self, "media-added", _tmp9_);
		_g_object_unref0 (meds);
		return;
	}
	_tmp10_ = gee_tree_set_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	rowids = _tmp10_;
	{
		GdaSqlBuilder* sql = NULL;
		GdaSqlBuilder* _tmp11_;
		GdaSqlBuilder* _tmp12_;
		GdaSqlBuilder* _tmp13_;
		GdaSqlBuilderId* ids = NULL;
		gint ids_length1;
		gint _ids_size_;
		GdaSqlOperatorType sql_operator_type = 0;
		NoiseSmartPlaylistConditionalType _tmp22_;
		NoiseSmartPlaylistConditionalType _tmp23_;
		GdaSqlBuilderId id_cond = 0U;
		GdaSqlBuilder* _tmp24_;
		GdaSqlOperatorType _tmp25_;
		GdaSqlBuilderId* _tmp26_;
		gint _tmp26__length1;
		GdaSqlBuilder* _tmp27_;
		GdaSqlBuilderId _tmp28_;
		GdaStatement* statm = NULL;
		GdaSqlBuilder* _tmp29_;
		GdaStatement* _tmp30_;
		GdaDataModel* data_model = NULL;
		GdaConnection* _tmp31_;
		GdaStatement* _tmp32_;
		GdaDataModel* _tmp33_;
		GdaDataModelIter* data_model_iter = NULL;
		GdaDataModel* _tmp34_;
		GdaDataModelIter* _tmp35_;
		GdaDataModelIter* _tmp36_;
		GeeCollection* meds = NULL;
		NoiseLibrary* _tmp42_;
		NoiseLibrary* _tmp43_;
		GeeTreeSet* _tmp44_;
		GeeCollection* _tmp45_;
		GeeArrayList* _tmp46_;
		GeeArrayList* _tmp47_;
		GeeCollection* _tmp48_;
		GeeCollection* _tmp49_;
		_tmp11_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
		sql = _tmp11_;
		_tmp12_ = sql;
		gda_sql_builder_select_add_target (_tmp12_, NOISE_DATABASE_MEDIA_TABLE_NAME, NULL);
		_tmp13_ = sql;
		gda_sql_builder_select_add_field (_tmp13_, "rowid", NULL, NULL);
		ids = NULL;
		ids_length1 = 0;
		_ids_size_ = ids_length1;
		{
			GeeIterator* _q_it = NULL;
			GeeTreeSet* _tmp14_;
			GeeIterator* _tmp15_;
			_tmp14_ = ((NoiseSmartPlaylist*) self)->queries;
			_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
			_q_it = _tmp15_;
			while (TRUE) {
				GeeIterator* _tmp16_;
				NoiseSmartQuery* q = NULL;
				GeeIterator* _tmp17_;
				gpointer _tmp18_;
				GdaSqlBuilderId* _tmp19_;
				gint _tmp19__length1;
				GdaSqlBuilder* _tmp20_;
				NoiseSmartQuery* _tmp21_;
				_tmp16_ = _q_it;
				if (!gee_iterator_next (_tmp16_)) {
					break;
				}
				_tmp17_ = _q_it;
				_tmp18_ = gee_iterator_get (_tmp17_);
				q = (NoiseSmartQuery*) _tmp18_;
				_tmp19_ = ids;
				_tmp19__length1 = ids_length1;
				_tmp20_ = sql;
				_tmp21_ = q;
				_vala_array_add2 (&ids, &ids_length1, &_ids_size_, noise_database_process_smart_query (_tmp20_, _tmp21_));
				_g_object_unref0 (q);
			}
			_g_object_unref0 (_q_it);
		}
		sql_operator_type = GDA_SQL_OPERATOR_TYPE_AND;
		_tmp22_ = noise_smart_playlist_get_conditional ((NoiseSmartPlaylist*) self);
		_tmp23_ = _tmp22_;
		if (_tmp23_ == NOISE_SMART_PLAYLIST_CONDITIONAL_TYPE_ANY) {
			sql_operator_type = GDA_SQL_OPERATOR_TYPE_OR;
		}
		_tmp24_ = sql;
		_tmp25_ = sql_operator_type;
		_tmp26_ = ids;
		_tmp26__length1 = ids_length1;
		id_cond = gda_sql_builder_add_cond_v (_tmp24_, _tmp25_, _tmp26_, _tmp26__length1);
		_tmp27_ = sql;
		_tmp28_ = id_cond;
		gda_sql_builder_set_where (_tmp27_, _tmp28_);
		_tmp29_ = sql;
		_tmp30_ = gda_sql_builder_get_statement (_tmp29_, &_inner_error_);
		statm = _tmp30_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			ids = (g_free (ids), NULL);
			_g_object_unref0 (sql);
			goto __catch67_g_error;
		}
		_tmp31_ = self->priv->connection;
		_tmp32_ = statm;
		_tmp33_ = gda_connection_statement_execute_select (_tmp31_, _tmp32_, NULL, &_inner_error_);
		data_model = _tmp33_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (statm);
			ids = (g_free (ids), NULL);
			_g_object_unref0 (sql);
			goto __catch67_g_error;
		}
		_tmp34_ = data_model;
		_tmp35_ = gda_data_model_create_iter (_tmp34_);
		data_model_iter = _tmp35_;
		_tmp36_ = data_model_iter;
		gda_data_model_iter_move_to_row (_tmp36_, -1);
		while (TRUE) {
			GdaDataModelIter* _tmp37_;
			GValue* val = NULL;
			GdaDataModelIter* _tmp38_;
			GeeTreeSet* _tmp39_;
			GValue* _tmp40_;
			gint64 _tmp41_;
			_tmp37_ = data_model_iter;
			if (!gda_data_model_iter_move_next (_tmp37_)) {
				break;
			}
			_tmp38_ = data_model_iter;
			val = gda_data_model_iter_get_value_at (_tmp38_, 0);
			_tmp39_ = rowids;
			_tmp40_ = val;
			_tmp41_ = g_value_get_int64 (_tmp40_);
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp39_, &_tmp41_);
		}
		_tmp42_ = noise_smart_playlist_get_library ((NoiseSmartPlaylist*) self);
		_tmp43_ = _tmp42_;
		_tmp44_ = rowids;
		_tmp45_ = noise_library_medias_from_ids (_tmp43_, (GeeCollection*) _tmp44_);
		meds = _tmp45_;
		_tmp46_ = noise_playlist_get_medias ((NoisePlaylist*) self);
		_tmp47_ = _tmp46_;
		_tmp48_ = meds;
		gee_array_list_add_all (_tmp47_, _tmp48_);
		_tmp49_ = meds;
		g_signal_emit_by_name ((NoisePlaylist*) self, "media-added", _tmp49_);
		_g_object_unref0 (meds);
		_g_object_unref0 (data_model_iter);
		_g_object_unref0 (data_model);
		_g_object_unref0 (statm);
		ids = (g_free (ids), NULL);
		_g_object_unref0 (sql);
	}
	goto __finally67;
	__catch67_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp50_;
		const gchar* _tmp51_;
		GError* _tmp52_;
		const gchar* _tmp53_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp50_ = noise_playlist_get_name ((NoisePlaylist*) self);
		_tmp51_ = _tmp50_;
		_tmp52_ = e;
		_tmp53_ = _tmp52_->message;
		g_critical ("LocalSmartPlaylist.vala:129: Could not query media for smart playlist " \
"%s: %s", _tmp51_, _tmp53_);
		_g_error_free0 (e);
	}
	__finally67:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (rowids);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_object_unref0 (rowids);
}


static void
noise_local_smart_playlist_real_clear_queries (NoiseSmartPlaylist* base)
{
	NoiseLocalSmartPlaylist * self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
	self = (NoiseLocalSmartPlaylist*) base;
	NOISE_SMART_PLAYLIST_CLASS (noise_local_smart_playlist_parent_class)->clear_queries (G_TYPE_CHECK_INSTANCE_CAST (self, NOISE_TYPE_SMART_PLAYLIST, NoiseSmartPlaylist));
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	g_value_init (&_tmp3_, G_TYPE_STRING);
	g_value_set_string (&_tmp3_, "");
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries", &_tmp3_);
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
}


static void
noise_local_smart_playlist_real_add_query (NoiseSmartPlaylist* base,
                                           NoiseSmartQuery* s)
{
	NoiseLocalSmartPlaylist * self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	gchar* _tmp3_;
	GValue _tmp4_ = {0};
	self = (NoiseLocalSmartPlaylist*) base;
	g_return_if_fail (s != NULL);
	NOISE_SMART_PLAYLIST_CLASS (noise_local_smart_playlist_parent_class)->add_query (G_TYPE_CHECK_INSTANCE_CAST (self, NOISE_TYPE_SMART_PLAYLIST, NoiseSmartPlaylist), s);
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	_tmp3_ = noise_local_smart_playlist_queries_to_string (self);
	g_value_init (&_tmp4_, G_TYPE_STRING);
	g_value_take_string (&_tmp4_, _tmp3_);
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries", &_tmp4_);
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
}


static void
noise_local_smart_playlist_real_add_queries (NoiseSmartPlaylist* base,
                                             GeeCollection* queries)
{
	NoiseLocalSmartPlaylist * self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	gchar* _tmp3_;
	GValue _tmp4_ = {0};
	self = (NoiseLocalSmartPlaylist*) base;
	g_return_if_fail (queries != NULL);
	NOISE_SMART_PLAYLIST_CLASS (noise_local_smart_playlist_parent_class)->add_queries (G_TYPE_CHECK_INSTANCE_CAST (self, NOISE_TYPE_SMART_PLAYLIST, NoiseSmartPlaylist), queries);
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	_tmp3_ = noise_local_smart_playlist_queries_to_string (self);
	g_value_init (&_tmp4_, G_TYPE_STRING);
	g_value_take_string (&_tmp4_, _tmp3_);
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries", &_tmp4_);
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
}


static gchar*
noise_local_smart_playlist_queries_to_string (NoiseLocalSmartPlaylist* self)
{
	gchar* result = NULL;
	GString* sb = NULL;
	GString* _tmp0_;
	GString* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	sb = _tmp0_;
	{
		GeeIterator* _q_it = NULL;
		GeeTreeSet* _tmp1_;
		GeeIterator* _tmp2_;
		_tmp1_ = ((NoiseSmartPlaylist*) self)->queries;
		_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
		_q_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			NoiseSmartQuery* q = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GString* _tmp6_;
			gssize _tmp7_;
			GString* _tmp9_;
			NoiseSmartQuery* _tmp10_;
			NoiseSmartQueryFieldType _tmp11_;
			NoiseSmartQueryFieldType _tmp12_;
			GString* _tmp13_;
			GString* _tmp14_;
			NoiseSmartQuery* _tmp15_;
			NoiseSmartQueryComparatorType _tmp16_;
			NoiseSmartQueryComparatorType _tmp17_;
			GString* _tmp18_;
			NoiseSmartQuery* _tmp19_;
			GValue _tmp20_ = {0};
			GValue _tmp21_;
			_tmp3_ = _q_it;
			if (!gee_iterator_next (_tmp3_)) {
				break;
			}
			_tmp4_ = _q_it;
			_tmp5_ = gee_iterator_get (_tmp4_);
			q = (NoiseSmartQuery*) _tmp5_;
			_tmp6_ = sb;
			_tmp7_ = _tmp6_->len;
			if (_tmp7_ != ((gssize) 0)) {
				GString* _tmp8_;
				_tmp8_ = sb;
				g_string_append (_tmp8_, NOISE_LOCAL_SMART_PLAYLIST_QUERY_SEPARATOR);
			}
			_tmp9_ = sb;
			_tmp10_ = q;
			_tmp11_ = noise_smart_query_get_field (_tmp10_);
			_tmp12_ = _tmp11_;
			g_string_append_printf (_tmp9_, "%d", (gint) _tmp12_);
			_tmp13_ = sb;
			g_string_append (_tmp13_, NOISE_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR);
			_tmp14_ = sb;
			_tmp15_ = q;
			_tmp16_ = noise_smart_query_get_comparator (_tmp15_);
			_tmp17_ = _tmp16_;
			g_string_append_printf (_tmp14_, "%d", (gint) _tmp17_);
			_tmp18_ = sb;
			g_string_append (_tmp18_, NOISE_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR);
			_tmp19_ = q;
			noise_smart_query_get_value (_tmp19_, &_tmp20_);
			_tmp21_ = _tmp20_;
			if (G_VALUE_TYPE (&_tmp21_) == G_TYPE_STRING) {
				GString* _tmp22_;
				NoiseSmartQuery* _tmp23_;
				GValue _tmp24_ = {0};
				GValue _tmp25_;
				const gchar* _tmp26_;
				_tmp22_ = sb;
				_tmp23_ = q;
				noise_smart_query_get_value (_tmp23_, &_tmp24_);
				_tmp25_ = _tmp24_;
				_tmp26_ = g_value_get_string (&_tmp25_);
				g_string_append (_tmp22_, _tmp26_);
			} else {
				GString* _tmp27_;
				NoiseSmartQuery* _tmp28_;
				GValue _tmp29_ = {0};
				GValue _tmp30_;
				_tmp27_ = sb;
				_tmp28_ = q;
				noise_smart_query_get_value (_tmp28_, &_tmp29_);
				_tmp30_ = _tmp29_;
				g_string_append_printf (_tmp27_, "%d", g_value_get_int (&_tmp30_));
			}
			_g_object_unref0 (q);
		}
		_g_object_unref0 (_q_it);
	}
	_tmp31_ = sb;
	_tmp32_ = _tmp31_->str;
	_tmp33_ = g_strdup (_tmp32_);
	result = _tmp33_;
	_g_string_free0 (sb);
	return result;
}


void
noise_local_smart_playlist_queries_from_string (NoiseLocalSmartPlaylist* self,
                                                const gchar* q)
{
	gchar** queries_in_string = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint queries_in_string_length1;
	gint _queries_in_string_size_;
	GeeTreeSet* new_queries = NULL;
	GeeTreeSet* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GeeTreeSet* _tmp32_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (q != NULL);
	_tmp1_ = _tmp0_ = g_strsplit (q, NOISE_LOCAL_SMART_PLAYLIST_QUERY_SEPARATOR, 0);
	queries_in_string = _tmp1_;
	queries_in_string_length1 = _vala_array_length (_tmp0_);
	_queries_in_string_size_ = queries_in_string_length1;
	_tmp2_ = gee_tree_set_new (NOISE_TYPE_SMART_QUERY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	new_queries = _tmp2_;
	_tmp3_ = queries_in_string;
	_tmp3__length1 = queries_in_string_length1;
	{
		gchar** query_string_collection = NULL;
		gint query_string_collection_length1 = 0;
		gint _query_string_collection_size_ = 0;
		gint query_string_it = 0;
		query_string_collection = _tmp3_;
		query_string_collection_length1 = _tmp3__length1;
		for (query_string_it = 0; query_string_it < _tmp3__length1; query_string_it = query_string_it + 1) {
			gchar* _tmp4_;
			gchar* query_string = NULL;
			_tmp4_ = g_strdup (query_string_collection[query_string_it]);
			query_string = _tmp4_;
			{
				const gchar* _tmp5_;
				gchar** pieces_of_query = NULL;
				const gchar* _tmp6_;
				gchar** _tmp7_;
				gchar** _tmp8_;
				gint pieces_of_query_length1;
				gint _pieces_of_query_size_;
				gint _tmp9_;
				NoiseSmartQuery* sq = NULL;
				NoiseSmartQuery* _tmp10_;
				NoiseSmartQuery* _tmp11_;
				gchar** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				NoiseSmartQuery* _tmp14_;
				gchar** _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
				NoiseSmartQuery* _tmp17_;
				NoiseSmartQueryFieldType _tmp18_;
				NoiseSmartQueryFieldType _tmp19_;
				GeeTreeSet* _tmp30_;
				NoiseSmartQuery* _tmp31_;
				_tmp5_ = query_string;
				if (g_strcmp0 (_tmp5_, "") == 0) {
					_g_free0 (query_string);
					continue;
				}
				_tmp6_ = query_string;
				_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, NOISE_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR, 3);
				pieces_of_query = _tmp8_;
				pieces_of_query_length1 = _vala_array_length (_tmp7_);
				_pieces_of_query_size_ = pieces_of_query_length1;
				_tmp9_ = 3;
				pieces_of_query = g_renew (gchar*, pieces_of_query, 3);
				(_tmp9_ > pieces_of_query_length1) ? memset (pieces_of_query + pieces_of_query_length1, 0, sizeof (gchar*) * (_tmp9_ - pieces_of_query_length1)) : NULL;
				pieces_of_query_length1 = _tmp9_;
				_pieces_of_query_size_ = _tmp9_;
				_tmp10_ = noise_smart_query_new ();
				sq = _tmp10_;
				_tmp11_ = sq;
				_tmp12_ = pieces_of_query;
				_tmp12__length1 = pieces_of_query_length1;
				_tmp13_ = _tmp12_[0];
				noise_smart_query_set_field (_tmp11_, (NoiseSmartQueryFieldType) atoi (_tmp13_));
				_tmp14_ = sq;
				_tmp15_ = pieces_of_query;
				_tmp15__length1 = pieces_of_query_length1;
				_tmp16_ = _tmp15_[1];
				noise_smart_query_set_comparator (_tmp14_, (NoiseSmartQueryComparatorType) atoi (_tmp16_));
				_tmp17_ = sq;
				_tmp18_ = noise_smart_query_get_field (_tmp17_);
				_tmp19_ = _tmp18_;
				switch (_tmp19_) {
					case NOISE_SMART_QUERY_FIELD_TYPE_ALBUM:
					case NOISE_SMART_QUERY_FIELD_TYPE_ARTIST:
					case NOISE_SMART_QUERY_FIELD_TYPE_COMPOSER:
					case NOISE_SMART_QUERY_FIELD_TYPE_COMMENT:
					case NOISE_SMART_QUERY_FIELD_TYPE_GENRE:
					case NOISE_SMART_QUERY_FIELD_TYPE_GROUPING:
					case NOISE_SMART_QUERY_FIELD_TYPE_TITLE:
					case NOISE_SMART_QUERY_FIELD_TYPE_URI:
					{
						GValue val = {0};
						GValue _tmp20_ = {0};
						gchar** _tmp21_;
						gint _tmp21__length1;
						const gchar* _tmp22_;
						NoiseSmartQuery* _tmp23_;
						GValue _tmp24_;
						g_value_init (&_tmp20_, G_TYPE_STRING);
						val = _tmp20_;
						_tmp21_ = pieces_of_query;
						_tmp21__length1 = pieces_of_query_length1;
						_tmp22_ = _tmp21_[2];
						g_value_set_string (&val, _tmp22_);
						_tmp23_ = sq;
						_tmp24_ = val;
						noise_smart_query_set_value (_tmp23_, &_tmp24_);
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
						break;
					}
					default:
					{
						GValue val = {0};
						GValue _tmp25_ = {0};
						gchar** _tmp26_;
						gint _tmp26__length1;
						const gchar* _tmp27_;
						NoiseSmartQuery* _tmp28_;
						GValue _tmp29_;
						g_value_init (&_tmp25_, G_TYPE_INT);
						val = _tmp25_;
						_tmp26_ = pieces_of_query;
						_tmp26__length1 = pieces_of_query_length1;
						_tmp27_ = _tmp26_[2];
						g_value_set_int (&val, atoi (_tmp27_));
						_tmp28_ = sq;
						_tmp29_ = val;
						noise_smart_query_set_value (_tmp28_, &_tmp29_);
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
						break;
					}
				}
				_tmp30_ = new_queries;
				_tmp31_ = sq;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
				_g_object_unref0 (sq);
				pieces_of_query = (_vala_array_free (pieces_of_query, pieces_of_query_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (query_string);
			}
		}
	}
	_tmp32_ = new_queries;
	noise_smart_playlist_add_queries ((NoiseSmartPlaylist*) self, (GeeCollection*) _tmp32_);
	_g_object_unref0 (new_queries);
	queries_in_string = (_vala_array_free (queries_in_string, queries_in_string_length1, (GDestroyNotify) g_free), NULL);
}


static void
__vala_GValue_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
}


static inline void
_g_slist_free___vala_GValue_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
}


static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}


void
noise_local_smart_playlist_add_defaults (GdaConnection* connection)
{
	GError * _inner_error_ = NULL;
	g_return_if_fail (connection != NULL);
	{
		GSList* col_names = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GSList* values = NULL;
		GValue* _tmp5_ = NULL;
		GValue* _tmp6_ = NULL;
		GValue* _tmp7_ = NULL;
		GValue* _tmp8_ = NULL;
		GValue* _tmp9_ = NULL;
		GSList* _tmp10_;
		GSList* _tmp11_;
		GValue* _tmp12_ = NULL;
		GValue* _tmp13_ = NULL;
		GValue* _tmp14_ = NULL;
		GValue* _tmp15_ = NULL;
		GValue* _tmp16_ = NULL;
		GSList* _tmp17_;
		GSList* _tmp18_;
		GValue* _tmp19_ = NULL;
		GValue* _tmp20_ = NULL;
		GValue* _tmp21_ = NULL;
		GValue* _tmp22_ = NULL;
		GValue* _tmp23_ = NULL;
		GSList* _tmp24_;
		GSList* _tmp25_;
		GValue* _tmp26_ = NULL;
		GValue* _tmp27_ = NULL;
		GValue* _tmp28_ = NULL;
		GValue* _tmp29_ = NULL;
		GValue* _tmp30_ = NULL;
		GSList* _tmp31_;
		GSList* _tmp32_;
		GValue* _tmp33_ = NULL;
		GValue* _tmp34_ = NULL;
		GValue* _tmp35_ = NULL;
		GValue* _tmp36_ = NULL;
		GValue* _tmp37_ = NULL;
		GSList* _tmp38_;
		GSList* _tmp39_;
		GValue* _tmp40_ = NULL;
		GValue* _tmp41_ = NULL;
		GValue* _tmp42_ = NULL;
		GValue* _tmp43_ = NULL;
		GValue* _tmp44_ = NULL;
		GSList* _tmp45_;
		GSList* _tmp46_;
		col_names = NULL;
		_tmp0_ = g_strdup ("name");
		col_names = g_slist_append (col_names, _tmp0_);
		_tmp1_ = g_strdup ("queries");
		col_names = g_slist_append (col_names, _tmp1_);
		_tmp2_ = g_strdup ("and_or");
		col_names = g_slist_append (col_names, _tmp2_);
		_tmp3_ = g_strdup ("limited");
		col_names = g_slist_append (col_names, _tmp3_);
		_tmp4_ = g_strdup ("limit_amount");
		col_names = g_slist_append (col_names, _tmp4_);
		values = NULL;
		_tmp5_ = g_new0 (GValue, 1);
		g_value_init (_tmp5_, G_TYPE_STRING);
		g_value_set_string (_tmp5_, _ ("Favorite Songs"));
		values = g_slist_append (values, _tmp5_);
		_tmp6_ = g_new0 (GValue, 1);
		g_value_init (_tmp6_, G_TYPE_STRING);
		g_value_set_string (_tmp6_, "10<val_sep>2<val_sep>4<query_sep>12<val_sep>0<val_sep>0<query_sep>11<v" \
"al_sep>6<val_sep>3");
		values = g_slist_append (values, _tmp6_);
		_tmp7_ = g_new0 (GValue, 1);
		g_value_init (_tmp7_, G_TYPE_INT);
		g_value_set_int (_tmp7_, 1);
		values = g_slist_append (values, _tmp7_);
		_tmp8_ = g_new0 (GValue, 1);
		g_value_init (_tmp8_, G_TYPE_INT);
		g_value_set_int (_tmp8_, 1);
		values = g_slist_append (values, _tmp8_);
		_tmp9_ = g_new0 (GValue, 1);
		g_value_init (_tmp9_, G_TYPE_INT);
		g_value_set_int (_tmp9_, 50);
		values = g_slist_append (values, _tmp9_);
		_tmp10_ = col_names;
		_tmp11_ = values;
		gda_connection_insert_row_into_table_v (connection, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp10_, _tmp11_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			goto __catch68_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		values = NULL;
		_tmp12_ = g_new0 (GValue, 1);
		g_value_init (_tmp12_, G_TYPE_STRING);
		g_value_set_string (_tmp12_, _ ("Recently Added"));
		values = g_slist_append (values, _tmp12_);
		_tmp13_ = g_new0 (GValue, 1);
		g_value_init (_tmp13_, G_TYPE_STRING);
		g_value_set_string (_tmp13_, "5<val_sep>7<val_sep>7");
		values = g_slist_append (values, _tmp13_);
		_tmp14_ = g_new0 (GValue, 1);
		g_value_init (_tmp14_, G_TYPE_INT);
		g_value_set_int (_tmp14_, 1);
		values = g_slist_append (values, _tmp14_);
		_tmp15_ = g_new0 (GValue, 1);
		g_value_init (_tmp15_, G_TYPE_INT);
		g_value_set_int (_tmp15_, 1);
		values = g_slist_append (values, _tmp15_);
		_tmp16_ = g_new0 (GValue, 1);
		g_value_init (_tmp16_, G_TYPE_INT);
		g_value_set_int (_tmp16_, 50);
		values = g_slist_append (values, _tmp16_);
		_tmp17_ = col_names;
		_tmp18_ = values;
		gda_connection_insert_row_into_table_v (connection, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp17_, _tmp18_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			goto __catch68_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		values = NULL;
		_tmp19_ = g_new0 (GValue, 1);
		g_value_init (_tmp19_, G_TYPE_STRING);
		g_value_set_string (_tmp19_, _ ("Recent Favorites"));
		values = g_slist_append (values, _tmp19_);
		_tmp20_ = g_new0 (GValue, 1);
		g_value_init (_tmp20_, G_TYPE_STRING);
		g_value_set_string (_tmp20_, "10<val_sep>2<val_sep>4<query_sep>12<val_sep>0<val_sep>0<query_sep>8<va" \
"l_sep>7<val_sep>7");
		values = g_slist_append (values, _tmp20_);
		_tmp21_ = g_new0 (GValue, 1);
		g_value_init (_tmp21_, G_TYPE_INT);
		g_value_set_int (_tmp21_, 1);
		values = g_slist_append (values, _tmp21_);
		_tmp22_ = g_new0 (GValue, 1);
		g_value_init (_tmp22_, G_TYPE_INT);
		g_value_set_int (_tmp22_, 1);
		values = g_slist_append (values, _tmp22_);
		_tmp23_ = g_new0 (GValue, 1);
		g_value_init (_tmp23_, G_TYPE_INT);
		g_value_set_int (_tmp23_, 50);
		values = g_slist_append (values, _tmp23_);
		_tmp24_ = col_names;
		_tmp25_ = values;
		gda_connection_insert_row_into_table_v (connection, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp24_, _tmp25_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			goto __catch68_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		values = NULL;
		_tmp26_ = g_new0 (GValue, 1);
		g_value_init (_tmp26_, G_TYPE_STRING);
		g_value_set_string (_tmp26_, _ ("Never Played"));
		values = g_slist_append (values, _tmp26_);
		_tmp27_ = g_new0 (GValue, 1);
		g_value_init (_tmp27_, G_TYPE_STRING);
		g_value_set_string (_tmp27_, "10<val_sep>0<val_sep>0");
		values = g_slist_append (values, _tmp27_);
		_tmp28_ = g_new0 (GValue, 1);
		g_value_init (_tmp28_, G_TYPE_INT);
		g_value_set_int (_tmp28_, 0);
		values = g_slist_append (values, _tmp28_);
		_tmp29_ = g_new0 (GValue, 1);
		g_value_init (_tmp29_, G_TYPE_INT);
		g_value_set_int (_tmp29_, 1);
		values = g_slist_append (values, _tmp29_);
		_tmp30_ = g_new0 (GValue, 1);
		g_value_init (_tmp30_, G_TYPE_INT);
		g_value_set_int (_tmp30_, 50);
		values = g_slist_append (values, _tmp30_);
		_tmp31_ = col_names;
		_tmp32_ = values;
		gda_connection_insert_row_into_table_v (connection, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp31_, _tmp32_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			goto __catch68_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		values = NULL;
		_tmp33_ = g_new0 (GValue, 1);
		g_value_init (_tmp33_, G_TYPE_STRING);
		g_value_set_string (_tmp33_, _ ("Over Played"));
		values = g_slist_append (values, _tmp33_);
		_tmp34_ = g_new0 (GValue, 1);
		g_value_init (_tmp34_, G_TYPE_STRING);
		g_value_set_string (_tmp34_, "10<val_sep>6<val_sep>10");
		values = g_slist_append (values, _tmp34_);
		_tmp35_ = g_new0 (GValue, 1);
		g_value_init (_tmp35_, G_TYPE_INT);
		g_value_set_int (_tmp35_, 1);
		values = g_slist_append (values, _tmp35_);
		_tmp36_ = g_new0 (GValue, 1);
		g_value_init (_tmp36_, G_TYPE_INT);
		g_value_set_int (_tmp36_, 1);
		values = g_slist_append (values, _tmp36_);
		_tmp37_ = g_new0 (GValue, 1);
		g_value_init (_tmp37_, G_TYPE_INT);
		g_value_set_int (_tmp37_, 50);
		values = g_slist_append (values, _tmp37_);
		_tmp38_ = col_names;
		_tmp39_ = values;
		gda_connection_insert_row_into_table_v (connection, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp38_, _tmp39_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			goto __catch68_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		values = NULL;
		_tmp40_ = g_new0 (GValue, 1);
		g_value_init (_tmp40_, G_TYPE_STRING);
		g_value_set_string (_tmp40_, _ ("Not Recently Played"));
		values = g_slist_append (values, _tmp40_);
		_tmp41_ = g_new0 (GValue, 1);
		g_value_init (_tmp41_, G_TYPE_STRING);
		g_value_set_string (_tmp41_, "8<val_sep>8<val_sep>7");
		values = g_slist_append (values, _tmp41_);
		_tmp42_ = g_new0 (GValue, 1);
		g_value_init (_tmp42_, G_TYPE_INT);
		g_value_set_int (_tmp42_, 1);
		values = g_slist_append (values, _tmp42_);
		_tmp43_ = g_new0 (GValue, 1);
		g_value_init (_tmp43_, G_TYPE_INT);
		g_value_set_int (_tmp43_, 1);
		values = g_slist_append (values, _tmp43_);
		_tmp44_ = g_new0 (GValue, 1);
		g_value_init (_tmp44_, G_TYPE_INT);
		g_value_set_int (_tmp44_, 50);
		values = g_slist_append (values, _tmp44_);
		_tmp45_ = col_names;
		_tmp46_ = values;
		gda_connection_insert_row_into_table_v (connection, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp45_, _tmp46_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			goto __catch68_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
	}
	goto __finally68;
	__catch68_g_error:
	{
		GError* e = NULL;
		GError* _tmp47_;
		const gchar* _tmp48_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp47_ = e;
		_tmp48_ = _tmp47_->message;
		g_critical ("LocalSmartPlaylist.vala:264: Could not initialize smart playlists: %s", _tmp48_);
		_g_error_free0 (e);
	}
	__finally68:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static const gchar*
noise_local_smart_playlist_real_get_name (NoisePlaylist* base)
{
	const gchar* result;
	NoiseLocalSmartPlaylist* self;
	const gchar* _tmp0_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue* _tmp5_;
	GValue* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	self = (NoiseLocalSmartPlaylist*) base;
	_tmp0_ = self->priv->_name;
	if (_tmp0_ != NULL) {
		const gchar* _tmp1_;
		_tmp1_ = self->priv->_name;
		result = _tmp1_;
		return result;
	}
	_tmp2_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->connection;
	_tmp5_ = noise_database_query_field (_tmp3_, _tmp4_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "name");
	_tmp6_ = _tmp5_;
	_tmp7_ = g_value_dup_string (_tmp6_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp7_;
	__vala_GValue_free0 (_tmp6_);
	_tmp8_ = self->priv->_name;
	result = _tmp8_;
	return result;
}


static void
noise_local_smart_playlist_real_set_name (NoisePlaylist* base,
                                          const gchar* value)
{
	NoiseLocalSmartPlaylist* self;
	gchar* _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	GdaConnection* _tmp3_;
	GValue _tmp4_ = {0};
	self = (NoiseLocalSmartPlaylist*) base;
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp0_;
	_tmp1_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->connection;
	g_value_init (&_tmp4_, G_TYPE_STRING);
	g_value_set_string (&_tmp4_, value);
	noise_database_set_field (_tmp2_, _tmp3_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "name", &_tmp4_);
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
	g_object_notify_by_pspec ((GObject *) self, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY]);
}


static NoiseSmartPlaylistConditionalType
noise_local_smart_playlist_real_get_conditional (NoiseSmartPlaylist* base)
{
	NoiseSmartPlaylistConditionalType result;
	NoiseLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
	NoiseSmartPlaylistConditionalType _tmp5_;
	self = (NoiseLocalSmartPlaylist*) base;
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	_tmp3_ = noise_database_query_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "and_or");
	_tmp4_ = _tmp3_;
	_tmp5_ = (NoiseSmartPlaylistConditionalType) g_value_get_int (_tmp4_);
	__vala_GValue_free0 (_tmp4_);
	result = _tmp5_;
	return result;
}


static void
noise_local_smart_playlist_real_set_conditional (NoiseSmartPlaylist* base,
                                                 NoiseSmartPlaylistConditionalType value)
{
	NoiseLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
	self = (NoiseLocalSmartPlaylist*) base;
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	g_value_init (&_tmp3_, NOISE_SMART_PLAYLIST_TYPE_CONDITIONAL_TYPE);
	g_value_set_enum (&_tmp3_, value);
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "and_or", &_tmp3_);
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
	g_object_notify_by_pspec ((GObject *) self, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY]);
}


static guint
noise_local_smart_playlist_real_get_limit_amount (NoiseSmartPlaylist* base)
{
	guint result;
	NoiseLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
	guint _tmp5_;
	self = (NoiseLocalSmartPlaylist*) base;
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	_tmp3_ = noise_database_query_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limit_amount");
	_tmp4_ = _tmp3_;
	_tmp5_ = (guint) g_value_get_int (_tmp4_);
	__vala_GValue_free0 (_tmp4_);
	result = _tmp5_;
	return result;
}


static void
noise_local_smart_playlist_real_set_limit_amount (NoiseSmartPlaylist* base,
                                                  guint value)
{
	NoiseLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
	self = (NoiseLocalSmartPlaylist*) base;
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	g_value_init (&_tmp3_, G_TYPE_UINT);
	g_value_set_uint (&_tmp3_, value);
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limit_amount", &_tmp3_);
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
	g_object_notify_by_pspec ((GObject *) self, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY]);
}


static gboolean
noise_local_smart_playlist_real_get_limit (NoiseSmartPlaylist* base)
{
	gboolean result;
	NoiseLocalSmartPlaylist* self;
	GValue* val = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	self = (NoiseLocalSmartPlaylist*) base;
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	_tmp3_ = noise_database_query_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limited");
	val = _tmp3_;
	result = (gboolean) g_value_get_int (val);
	__vala_GValue_free0 (val);
	return result;
}


static void
noise_local_smart_playlist_real_set_limit (NoiseSmartPlaylist* base,
                                           gboolean value)
{
	NoiseLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
	self = (NoiseLocalSmartPlaylist*) base;
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	g_value_init (&_tmp3_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp3_, value);
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limited", &_tmp3_);
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
	g_object_notify_by_pspec ((GObject *) self, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY]);
}


static void
noise_local_smart_playlist_class_init (NoiseLocalSmartPlaylistClass * klass)
{
	noise_local_smart_playlist_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseLocalSmartPlaylist_private_offset);
	((NoiseSmartPlaylistClass *) klass)->analyse_all = (void (*) (NoiseSmartPlaylist *)) noise_local_smart_playlist_real_analyse_all;
	((NoiseSmartPlaylistClass *) klass)->clear_queries = (void (*) (NoiseSmartPlaylist *)) noise_local_smart_playlist_real_clear_queries;
	((NoiseSmartPlaylistClass *) klass)->add_query = (void (*) (NoiseSmartPlaylist *, NoiseSmartQuery*)) noise_local_smart_playlist_real_add_query;
	((NoiseSmartPlaylistClass *) klass)->add_queries = (void (*) (NoiseSmartPlaylist *, GeeCollection*)) noise_local_smart_playlist_real_add_queries;
	NOISE_PLAYLIST_CLASS (klass)->get_name = noise_local_smart_playlist_real_get_name;
	NOISE_PLAYLIST_CLASS (klass)->set_name = noise_local_smart_playlist_real_set_name;
	NOISE_SMART_PLAYLIST_CLASS (klass)->get_conditional = noise_local_smart_playlist_real_get_conditional;
	NOISE_SMART_PLAYLIST_CLASS (klass)->set_conditional = noise_local_smart_playlist_real_set_conditional;
	NOISE_SMART_PLAYLIST_CLASS (klass)->get_limit_amount = noise_local_smart_playlist_real_get_limit_amount;
	NOISE_SMART_PLAYLIST_CLASS (klass)->set_limit_amount = noise_local_smart_playlist_real_set_limit_amount;
	NOISE_SMART_PLAYLIST_CLASS (klass)->get_limit = noise_local_smart_playlist_real_get_limit;
	NOISE_SMART_PLAYLIST_CLASS (klass)->set_limit = noise_local_smart_playlist_real_set_limit;
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_local_smart_playlist_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_local_smart_playlist_set_property;
	G_OBJECT_CLASS (klass)->finalize = noise_local_smart_playlist_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY] = g_param_spec_enum ("conditional", "conditional", "conditional", NOISE_SMART_PLAYLIST_TYPE_CONDITIONAL_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY] = g_param_spec_uint ("limit-amount", "limit-amount", "limit-amount", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY] = g_param_spec_boolean ("limit", "limit", "limit", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void
noise_local_smart_playlist_instance_init (NoiseLocalSmartPlaylist * self)
{
	self->priv = noise_local_smart_playlist_get_instance_private (self);
	self->priv->_name = NULL;
}


static void
noise_local_smart_playlist_finalize (GObject * obj)
{
	NoiseLocalSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylist);
	_g_object_unref0 (self->priv->connection);
	_g_free0 (self->priv->_name);
	G_OBJECT_CLASS (noise_local_smart_playlist_parent_class)->finalize (obj);
}


GType
noise_local_smart_playlist_get_type (void)
{
	static volatile gsize noise_local_smart_playlist_type_id__volatile = 0;
	if (g_once_init_enter (&noise_local_smart_playlist_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseLocalSmartPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_local_smart_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseLocalSmartPlaylist), 0, (GInstanceInitFunc) noise_local_smart_playlist_instance_init, NULL };
		GType noise_local_smart_playlist_type_id;
		noise_local_smart_playlist_type_id = g_type_register_static (NOISE_TYPE_SMART_PLAYLIST, "NoiseLocalSmartPlaylist", &g_define_type_info, 0);
		NoiseLocalSmartPlaylist_private_offset = g_type_add_instance_private (noise_local_smart_playlist_type_id, sizeof (NoiseLocalSmartPlaylistPrivate));
		g_once_init_leave (&noise_local_smart_playlist_type_id__volatile, noise_local_smart_playlist_type_id);
	}
	return noise_local_smart_playlist_type_id__volatile;
}


static void
_vala_noise_local_smart_playlist_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	NoiseLocalSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylist);
	switch (property_id) {
		case NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY:
		g_value_set_string (value, noise_playlist_get_name ((NoisePlaylist*) self));
		break;
		case NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY:
		g_value_set_enum (value, noise_smart_playlist_get_conditional ((NoiseSmartPlaylist*) self));
		break;
		case NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY:
		g_value_set_uint (value, noise_smart_playlist_get_limit_amount ((NoiseSmartPlaylist*) self));
		break;
		case NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY:
		g_value_set_boolean (value, noise_smart_playlist_get_limit ((NoiseSmartPlaylist*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_local_smart_playlist_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	NoiseLocalSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylist);
	switch (property_id) {
		case NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY:
		noise_playlist_set_name ((NoisePlaylist*) self, g_value_get_string (value));
		break;
		case NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY:
		noise_smart_playlist_set_conditional ((NoiseSmartPlaylist*) self, g_value_get_enum (value));
		break;
		case NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY:
		noise_smart_playlist_set_limit_amount ((NoiseSmartPlaylist*) self, g_value_get_uint (value));
		break;
		case NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY:
		noise_smart_playlist_set_limit ((NoiseSmartPlaylist*) self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



