/* DeviceView.c generated by valac 0.41.91, the Vala compiler
 * generated from DeviceView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "io.elementary.music-core.h"
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_TYPE_DEVICE_VIEW (noise_device_view_get_type ())
#define NOISE_DEVICE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE_VIEW, NoiseDeviceView))
#define NOISE_DEVICE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_DEVICE_VIEW, NoiseDeviceViewClass))
#define NOISE_IS_DEVICE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE_VIEW))
#define NOISE_IS_DEVICE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_DEVICE_VIEW))
#define NOISE_DEVICE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_DEVICE_VIEW, NoiseDeviceViewClass))

typedef struct _NoiseDeviceView NoiseDeviceView;
typedef struct _NoiseDeviceViewClass NoiseDeviceViewClass;
typedef struct _NoiseDeviceViewPrivate NoiseDeviceViewPrivate;

#define NOISE_TYPE_DEVICE_PREFERENCES (noise_device_preferences_get_type ())
#define NOISE_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences))
#define NOISE_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferencesClass))
#define NOISE_IS_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE_PREFERENCES))
#define NOISE_IS_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_DEVICE_PREFERENCES))
#define NOISE_DEVICE_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferencesClass))

typedef struct _NoiseDevicePreferences NoiseDevicePreferences;
typedef struct _NoiseDevicePreferencesClass NoiseDevicePreferencesClass;
enum  {
	NOISE_DEVICE_VIEW_0_PROPERTY,
	NOISE_DEVICE_VIEW_DEVICE_PROPERTY,
	NOISE_DEVICE_VIEW_PREFERENCES_PROPERTY,
	NOISE_DEVICE_VIEW_NUM_PROPERTIES
};
static GParamSpec* noise_device_view_properties[NOISE_DEVICE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block20Data Block20Data;

#define NOISE_TYPE_DEVICE_SUMMARY_WIDGET (noise_device_summary_widget_get_type ())
#define NOISE_DEVICE_SUMMARY_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE_SUMMARY_WIDGET, NoiseDeviceSummaryWidget))
#define NOISE_DEVICE_SUMMARY_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_DEVICE_SUMMARY_WIDGET, NoiseDeviceSummaryWidgetClass))
#define NOISE_IS_DEVICE_SUMMARY_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE_SUMMARY_WIDGET))
#define NOISE_IS_DEVICE_SUMMARY_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_DEVICE_SUMMARY_WIDGET))
#define NOISE_DEVICE_SUMMARY_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_DEVICE_SUMMARY_WIDGET, NoiseDeviceSummaryWidgetClass))

typedef struct _NoiseDeviceSummaryWidget NoiseDeviceSummaryWidget;
typedef struct _NoiseDeviceSummaryWidgetClass NoiseDeviceSummaryWidgetClass;

struct _NoiseDeviceView {
	GtkGrid parent_instance;
	NoiseDeviceViewPrivate * priv;
};

struct _NoiseDeviceViewClass {
	GtkGridClass parent_class;
};

struct _NoiseDeviceViewPrivate {
	NoiseDevice* _device;
	NoiseDevicePreferences* _preferences;
};

struct _Block20Data {
	int _ref_count_;
	NoiseDeviceView* self;
	GtkLabel* infobar_label;
	GtkInfoBar* infobar;
	gulong connector;
};


static gint NoiseDeviceView_private_offset;
static gpointer noise_device_view_parent_class = NULL;

GType noise_device_view_get_type (void) G_GNUC_CONST;
GType noise_device_preferences_get_type (void) G_GNUC_CONST;
NoiseDeviceView* noise_device_view_new (NoiseDevice* device,
                                        NoiseDevicePreferences* preferences);
NoiseDeviceView* noise_device_view_construct (GType object_type,
                                              NoiseDevice* device,
                                              NoiseDevicePreferences* preferences);
NoiseDevice* noise_device_view_get_device (NoiseDeviceView* self);
static void noise_device_view_set_device (NoiseDeviceView* self,
                                   NoiseDevice* value);
NoiseDevicePreferences* noise_device_view_get_preferences (NoiseDeviceView* self);
static void noise_device_view_set_preferences (NoiseDeviceView* self,
                                        NoiseDevicePreferences* value);
static GObject * noise_device_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static Block20Data* block20_data_ref (Block20Data* _data20_);
static void block20_data_unref (void * _userdata_);
GType noise_device_summary_widget_get_type (void) G_GNUC_CONST;
NoiseDeviceSummaryWidget* noise_device_summary_widget_new (NoiseDevice* device,
                                                           NoiseDevicePreferences* preferences);
NoiseDeviceSummaryWidget* noise_device_summary_widget_construct (GType object_type,
                                                                 NoiseDevice* device,
                                                                 NoiseDevicePreferences* preferences);
static void _noise_device_view___lambda112_ (NoiseDeviceView* self);
static void __noise_device_view___lambda112__noise_notification_manager_progress_canceled (NoiseNotificationManager* _sender,
                                                                                    gpointer self);
static void _noise_device_view___lambda113_ (Block20Data* _data20_);
static void __noise_device_view___lambda113__noise_device_device_unmounted (NoiseDevice* _sender,
                                                                     gpointer self);
static void _noise_device_view___lambda114_ (Block20Data* _data20_,
                                      const gchar* label,
                                      GtkMessageType message_type);
static void __noise_device_view___lambda114__noise_device_infobar_message (NoiseDevice* _sender,
                                                                    const gchar* label,
                                                                    GtkMessageType message_type,
                                                                    gpointer self);
static void _noise_device_view___lambda115_ (Block20Data* _data20_,
                                      GtkInfoBar* _self_,
                                      gint response);
static void __noise_device_view___lambda115__gtk_info_bar_response (GtkInfoBar* _sender,
                                                             gint response_id,
                                                             gpointer self);
gboolean noise_device_preferences_get_sync_when_mounted (NoiseDevicePreferences* self);
void noise_device_summary_widget_sync_clicked (NoiseDeviceSummaryWidget* self);
static void noise_device_view_finalize (GObject * obj);
static void _vala_noise_device_view_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_noise_device_view_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);


static inline gpointer
noise_device_view_get_instance_private (NoiseDeviceView* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseDeviceView_private_offset);
}


NoiseDeviceView*
noise_device_view_construct (GType object_type,
                             NoiseDevice* device,
                             NoiseDevicePreferences* preferences)
{
	NoiseDeviceView * self = NULL;
	g_return_val_if_fail (device != NULL, NULL);
	g_return_val_if_fail (preferences != NULL, NULL);
	self = (NoiseDeviceView*) g_object_new (object_type, "device", device, "preferences", preferences, NULL);
	return self;
}


NoiseDeviceView*
noise_device_view_new (NoiseDevice* device,
                       NoiseDevicePreferences* preferences)
{
	return noise_device_view_construct (NOISE_TYPE_DEVICE_VIEW, device, preferences);
}


NoiseDevice*
noise_device_view_get_device (NoiseDeviceView* self)
{
	NoiseDevice* result;
	NoiseDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_device;
	result = _tmp0_;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
noise_device_view_set_device (NoiseDeviceView* self,
                              NoiseDevice* value)
{
	g_return_if_fail (self != NULL);
	if (noise_device_view_get_device (self) != value) {
		NoiseDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_device);
		self->priv->_device = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_device_view_properties[NOISE_DEVICE_VIEW_DEVICE_PROPERTY]);
	}
}


NoiseDevicePreferences*
noise_device_view_get_preferences (NoiseDeviceView* self)
{
	NoiseDevicePreferences* result;
	NoiseDevicePreferences* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_preferences;
	result = _tmp0_;
	return result;
}


static void
noise_device_view_set_preferences (NoiseDeviceView* self,
                                   NoiseDevicePreferences* value)
{
	g_return_if_fail (self != NULL);
	if (noise_device_view_get_preferences (self) != value) {
		NoiseDevicePreferences* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_preferences);
		self->priv->_preferences = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_device_view_properties[NOISE_DEVICE_VIEW_PREFERENCES_PROPERTY]);
	}
}


static Block20Data*
block20_data_ref (Block20Data* _data20_)
{
	g_atomic_int_inc (&_data20_->_ref_count_);
	return _data20_;
}


static void
block20_data_unref (void * _userdata_)
{
	Block20Data* _data20_;
	_data20_ = (Block20Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data20_->_ref_count_)) {
		NoiseDeviceView* self;
		self = _data20_->self;
		_g_object_unref0 (_data20_->infobar);
		_g_object_unref0 (_data20_->infobar_label);
		_g_object_unref0 (self);
		g_slice_free (Block20Data, _data20_);
	}
}


static void
_noise_device_view___lambda112_ (NoiseDeviceView* self)
{
	NoiseDevice* _tmp0_;
	NoiseLibrary* _tmp1_;
	NoiseLibrary* _tmp2_;
	gboolean _tmp3_;
	_tmp0_ = self->priv->_device;
	_tmp1_ = noise_device_get_library (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = noise_library_doing_file_operations (_tmp2_);
	_g_object_unref0 (_tmp2_);
	if (_tmp3_) {
		NoiseNotificationManager* _tmp4_;
		NoiseNotificationManager* _tmp5_;
		_tmp4_ = noise_notification_manager_get_default ();
		_tmp5_ = _tmp4_;
		g_signal_emit_by_name (_tmp5_, "show-alert", _ ("Cancelling…"), _ ("Device operation has been cancelled and will stop after this media."));
		_g_object_unref0 (_tmp5_);
	}
}


static void
__noise_device_view___lambda112__noise_notification_manager_progress_canceled (NoiseNotificationManager* _sender,
                                                                               gpointer self)
{
	_noise_device_view___lambda112_ ((NoiseDeviceView*) self);
}


static void
_noise_device_view___lambda113_ (Block20Data* _data20_)
{
	NoiseDeviceView* self;
	NoiseDevice* _tmp0_;
	gulong _tmp1_;
	self = _data20_->self;
	g_message ("DeviceView.vala:71: device unmounted\n");
	_tmp0_ = self->priv->_device;
	_tmp1_ = _data20_->connector;
	g_signal_handler_disconnect ((GObject*) _tmp0_, _tmp1_);
}


static void
__noise_device_view___lambda113__noise_device_device_unmounted (NoiseDevice* _sender,
                                                                gpointer self)
{
	_noise_device_view___lambda113_ (self);
}


static void
_noise_device_view___lambda114_ (Block20Data* _data20_,
                                 const gchar* label,
                                 GtkMessageType message_type)
{
	NoiseDeviceView* self;
	GtkLabel* _tmp0_;
	GtkInfoBar* _tmp1_;
	GtkInfoBar* _tmp2_;
	self = _data20_->self;
	g_return_if_fail (label != NULL);
	_tmp0_ = _data20_->infobar_label;
	gtk_label_set_label (_tmp0_, label);
	_tmp1_ = _data20_->infobar;
	gtk_info_bar_set_message_type (_tmp1_, message_type);
	_tmp2_ = _data20_->infobar;
	gtk_widget_show_all ((GtkWidget*) _tmp2_);
}


static void
__noise_device_view___lambda114__noise_device_infobar_message (NoiseDevice* _sender,
                                                               const gchar* label,
                                                               GtkMessageType message_type,
                                                               gpointer self)
{
	_noise_device_view___lambda114_ (self, label, message_type);
}


static void
_noise_device_view___lambda115_ (Block20Data* _data20_,
                                 GtkInfoBar* _self_,
                                 gint response)
{
	NoiseDeviceView* self;
	GtkInfoBar* _tmp0_;
	self = _data20_->self;
	g_return_if_fail (_self_ != NULL);
	_tmp0_ = _data20_->infobar;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
}


static void
__noise_device_view___lambda115__gtk_info_bar_response (GtkInfoBar* _sender,
                                                        gint response_id,
                                                        gpointer self)
{
	_noise_device_view___lambda115_ (self, _sender, response_id);
}


static GObject *
noise_device_view_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseDeviceView * self;
	Block20Data* _data20_;
	GtkLabel* _tmp0_;
	GtkInfoBar* _tmp1_;
	GtkInfoBar* _tmp2_;
	GtkInfoBar* _tmp3_;
	GtkInfoBar* _tmp4_;
	GtkContainer* _tmp5_;
	GtkLabel* _tmp6_;
	NoiseDeviceSummaryWidget* summary = NULL;
	NoiseDevice* _tmp7_;
	NoiseDevicePreferences* _tmp8_;
	NoiseDeviceSummaryWidget* _tmp9_;
	GtkInfoBar* _tmp10_;
	GtkWidget* custom_view = NULL;
	NoiseDevice* _tmp11_;
	GtkWidget* _tmp12_;
	GtkWidget* _tmp13_;
	GtkInfoBar* _tmp16_;
	NoiseNotificationManager* _tmp17_;
	NoiseNotificationManager* _tmp18_;
	gulong _tmp19_;
	gulong _tmp20_;
	NoiseDevice* _tmp21_;
	NoiseDevice* _tmp22_;
	GtkInfoBar* _tmp23_;
	NoiseDevicePreferences* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	parent_class = G_OBJECT_CLASS (noise_device_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_DEVICE_VIEW, NoiseDeviceView);
	_data20_ = g_slice_new0 (Block20Data);
	_data20_->_ref_count_ = 1;
	_data20_->self = g_object_ref (self);
	_tmp0_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp0_);
	_data20_->infobar_label = _tmp0_;
	_tmp1_ = (GtkInfoBar*) gtk_info_bar_new ();
	g_object_ref_sink (_tmp1_);
	_data20_->infobar = _tmp1_;
	_tmp2_ = _data20_->infobar;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
	_tmp3_ = _data20_->infobar;
	gtk_info_bar_add_button (_tmp3_, _ ("Close"), 0);
	_tmp4_ = _data20_->infobar;
	_tmp5_ = gtk_info_bar_get_content_area (_tmp4_);
	_tmp6_ = _data20_->infobar_label;
	gtk_container_add (_tmp5_, (GtkWidget*) _tmp6_);
	_tmp7_ = self->priv->_device;
	_tmp8_ = self->priv->_preferences;
	_tmp9_ = noise_device_summary_widget_new (_tmp7_, _tmp8_);
	g_object_ref_sink (_tmp9_);
	summary = _tmp9_;
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	_tmp10_ = _data20_->infobar;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp10_, 0, 0, 1, 1);
	_tmp11_ = self->priv->_device;
	_tmp12_ = noise_device_get_custom_view (_tmp11_);
	custom_view = _tmp12_;
	_tmp13_ = custom_view;
	if (_tmp13_ != NULL) {
		GtkWidget* _tmp14_;
		_tmp14_ = custom_view;
		gtk_grid_attach ((GtkGrid*) self, _tmp14_, 0, 1, 1, 1);
	} else {
		NoiseDeviceSummaryWidget* _tmp15_;
		_tmp15_ = summary;
		gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp15_, 0, 1, 1, 1);
	}
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp16_ = _data20_->infobar;
	gtk_widget_hide ((GtkWidget*) _tmp16_);
	_tmp17_ = noise_notification_manager_get_default ();
	_tmp18_ = _tmp17_;
	_tmp19_ = g_signal_connect_object (_tmp18_, "progress-canceled", (GCallback) __noise_device_view___lambda112__noise_notification_manager_progress_canceled, self, 0);
	_tmp20_ = _tmp19_;
	_g_object_unref0 (_tmp18_);
	_data20_->connector = _tmp20_;
	_tmp21_ = self->priv->_device;
	g_signal_connect_data (_tmp21_, "device-unmounted", (GCallback) __noise_device_view___lambda113__noise_device_device_unmounted, block20_data_ref (_data20_), (GClosureNotify) block20_data_unref, 0);
	_tmp22_ = self->priv->_device;
	g_signal_connect_data (_tmp22_, "infobar-message", (GCallback) __noise_device_view___lambda114__noise_device_infobar_message, block20_data_ref (_data20_), (GClosureNotify) block20_data_unref, 0);
	_tmp23_ = _data20_->infobar;
	g_signal_connect_data (_tmp23_, "response", (GCallback) __noise_device_view___lambda115__gtk_info_bar_response, block20_data_ref (_data20_), (GClosureNotify) block20_data_unref, 0);
	_tmp24_ = self->priv->_preferences;
	_tmp25_ = noise_device_preferences_get_sync_when_mounted (_tmp24_);
	_tmp26_ = _tmp25_;
	if (_tmp26_) {
		NoiseDeviceSummaryWidget* _tmp27_;
		_tmp27_ = summary;
		noise_device_summary_widget_sync_clicked (_tmp27_);
	}
	_g_object_unref0 (custom_view);
	_g_object_unref0 (summary);
	block20_data_unref (_data20_);
	_data20_ = NULL;
	return obj;
}


static void
noise_device_view_class_init (NoiseDeviceViewClass * klass)
{
	noise_device_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseDeviceView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_device_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_device_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = noise_device_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = noise_device_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_VIEW_DEVICE_PROPERTY, noise_device_view_properties[NOISE_DEVICE_VIEW_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", NOISE_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_VIEW_PREFERENCES_PROPERTY, noise_device_view_properties[NOISE_DEVICE_VIEW_PREFERENCES_PROPERTY] = g_param_spec_object ("preferences", "preferences", "preferences", NOISE_TYPE_DEVICE_PREFERENCES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void
noise_device_view_instance_init (NoiseDeviceView * self)
{
	self->priv = noise_device_view_get_instance_private (self);
}


static void
noise_device_view_finalize (GObject * obj)
{
	NoiseDeviceView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_DEVICE_VIEW, NoiseDeviceView);
	_g_object_unref0 (self->priv->_device);
	_g_object_unref0 (self->priv->_preferences);
	G_OBJECT_CLASS (noise_device_view_parent_class)->finalize (obj);
}


GType
noise_device_view_get_type (void)
{
	static volatile gsize noise_device_view_type_id__volatile = 0;
	if (g_once_init_enter (&noise_device_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseDeviceViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_device_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseDeviceView), 0, (GInstanceInitFunc) noise_device_view_instance_init, NULL };
		GType noise_device_view_type_id;
		noise_device_view_type_id = g_type_register_static (gtk_grid_get_type (), "NoiseDeviceView", &g_define_type_info, 0);
		NoiseDeviceView_private_offset = g_type_add_instance_private (noise_device_view_type_id, sizeof (NoiseDeviceViewPrivate));
		g_once_init_leave (&noise_device_view_type_id__volatile, noise_device_view_type_id);
	}
	return noise_device_view_type_id__volatile;
}


static void
_vala_noise_device_view_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	NoiseDeviceView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_DEVICE_VIEW, NoiseDeviceView);
	switch (property_id) {
		case NOISE_DEVICE_VIEW_DEVICE_PROPERTY:
		g_value_set_object (value, noise_device_view_get_device (self));
		break;
		case NOISE_DEVICE_VIEW_PREFERENCES_PROPERTY:
		g_value_set_object (value, noise_device_view_get_preferences (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_device_view_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	NoiseDeviceView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_DEVICE_VIEW, NoiseDeviceView);
	switch (property_id) {
		case NOISE_DEVICE_VIEW_DEVICE_PROPERTY:
		noise_device_view_set_device (self, g_value_get_object (value));
		break;
		case NOISE_DEVICE_VIEW_PREFERENCES_PROPERTY:
		noise_device_view_set_preferences (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



