/* BrowserColumnModel.c generated by valac 0.41.91, the Vala compiler
 * generated from BrowserColumnModel.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <stdarg.h>
#include "io.elementary.music-core.h"


#define NOISE_TYPE_BROWSER_COLUMN_MODEL (noise_browser_column_model_get_type ())
#define NOISE_BROWSER_COLUMN_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModel))
#define NOISE_BROWSER_COLUMN_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModelClass))
#define NOISE_IS_BROWSER_COLUMN_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_BROWSER_COLUMN_MODEL))
#define NOISE_IS_BROWSER_COLUMN_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_BROWSER_COLUMN_MODEL))
#define NOISE_BROWSER_COLUMN_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModelClass))

typedef struct _NoiseBrowserColumnModel NoiseBrowserColumnModel;
typedef struct _NoiseBrowserColumnModelClass NoiseBrowserColumnModelClass;
typedef struct _NoiseBrowserColumnModelPrivate NoiseBrowserColumnModelPrivate;

#define NOISE_BROWSER_COLUMN_TYPE_CATEGORY (noise_browser_column_category_get_type ())
enum  {
	NOISE_BROWSER_COLUMN_MODEL_0_PROPERTY,
	NOISE_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY,
	NOISE_BROWSER_COLUMN_MODEL_NUM_PROPERTIES
};
static GParamSpec* noise_browser_column_model_properties[NOISE_BROWSER_COLUMN_MODEL_NUM_PROPERTIES];
#define _g_sequence_free0(var) ((var == NULL) ? NULL : (var = (g_sequence_free (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NoiseBrowserColumnModel {
	GObject parent_instance;
	NoiseBrowserColumnModelPrivate * priv;
};

struct _NoiseBrowserColumnModelClass {
	GObjectClass parent_class;
};

typedef enum  {
	NOISE_BROWSER_COLUMN_CATEGORY_RATING,
	NOISE_BROWSER_COLUMN_CATEGORY_GROUPING,
	NOISE_BROWSER_COLUMN_CATEGORY_YEAR,
	NOISE_BROWSER_COLUMN_CATEGORY_GENRE,
	NOISE_BROWSER_COLUMN_CATEGORY_COMPOSER,
	NOISE_BROWSER_COLUMN_CATEGORY_ARTIST,
	NOISE_BROWSER_COLUMN_CATEGORY_ALBUM,
	NOISE_BROWSER_COLUMN_CATEGORY_N_CATEGORIES
} NoiseBrowserColumnCategory;

struct _NoiseBrowserColumnModelPrivate {
	gint stamp;
	GSequence* rows;
	GtkTreeIter* first_iter;
	gint sort_column_id;
	GtkSortType sort_direction;
	GtkTreeIterCompareFunc default_sort_func;
	gpointer default_sort_func_target;
	NoiseBrowserColumnCategory category;
};


static gint NoiseBrowserColumnModel_private_offset;
static gpointer noise_browser_column_model_parent_class = NULL;
static GtkTreeModelIface * noise_browser_column_model_gtk_tree_model_parent_iface = NULL;
static GtkTreeSortableIface * noise_browser_column_model_gtk_tree_sortable_parent_iface = NULL;

GType noise_browser_column_model_get_type (void) G_GNUC_CONST;
GType noise_browser_column_category_get_type (void) G_GNUC_CONST;
NoiseBrowserColumnModel* noise_browser_column_model_new (NoiseBrowserColumnCategory category);
NoiseBrowserColumnModel* noise_browser_column_model_construct (GType object_type,
                                                               NoiseBrowserColumnCategory category);
static void _g_free0_ (gpointer var);
static GtkTreeModelFlags noise_browser_column_model_real_get_flags (GtkTreeModel* base);
static gboolean noise_browser_column_model_real_get_iter (GtkTreeModel* base,
                                                   GtkTreeIter* iter,
                                                   GtkTreePath* path);
static gint noise_browser_column_model_real_get_n_columns (GtkTreeModel* base);
static GType noise_browser_column_model_real_get_column_type (GtkTreeModel* base,
                                                       gint col);
static GtkTreePath* noise_browser_column_model_real_get_path (GtkTreeModel* base,
                                                       GtkTreeIter* iter);
static void noise_browser_column_model_real_get_value (GtkTreeModel* base,
                                                GtkTreeIter* iter,
                                                gint column,
                                                GValue* val);
static gboolean noise_browser_column_model_real_iter_children (GtkTreeModel* base,
                                                        GtkTreeIter* iter,
                                                        GtkTreeIter* parent);
static gboolean noise_browser_column_model_real_iter_has_child (GtkTreeModel* base,
                                                         GtkTreeIter* iter);
static gint noise_browser_column_model_real_iter_n_children (GtkTreeModel* base,
                                                      GtkTreeIter* iter);
static gboolean noise_browser_column_model_real_iter_next (GtkTreeModel* base,
                                                    GtkTreeIter* iter);
static gboolean noise_browser_column_model_real_iter_nth_child (GtkTreeModel* base,
                                                         GtkTreeIter* iter,
                                                         GtkTreeIter* parent,
                                                         gint n);
static gboolean noise_browser_column_model_real_iter_parent (GtkTreeModel* base,
                                                      GtkTreeIter* iter,
                                                      GtkTreeIter* child);
static void noise_browser_column_model_real_ref_node (GtkTreeModel* base,
                                               GtkTreeIter* iter);
static void noise_browser_column_model_real_unref_node (GtkTreeModel* base,
                                                 GtkTreeIter* iter);
void noise_browser_column_model_append (NoiseBrowserColumnModel* self,
                                        GtkTreeIter* iter);
void noise_browser_column_model_append_items (NoiseBrowserColumnModel* self,
                                              GeeCollection* strings,
                                              gboolean emit);
static void noise_browser_column_model_add_first_element (NoiseBrowserColumnModel* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void noise_browser_column_model_update_first_item (NoiseBrowserColumnModel* self);
static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self);
static gchar* noise_browser_column_model_get_first_item_text (NoiseBrowserColumnModel* self,
                                                       gint n_items);
gint noise_browser_column_model_get_n_items (NoiseBrowserColumnModel* self);
void noise_browser_column_model_set (NoiseBrowserColumnModel* self,
                                     GtkTreeIter* iter,
                                     ...);
void noise_browser_column_model_remove (NoiseBrowserColumnModel* self,
                                        GtkTreeIter* iter);
static gboolean noise_browser_column_model_real_get_sort_column_id (GtkTreeSortable* base,
                                                             gint* sort_column_id,
                                                             GtkSortType* order);
static gboolean noise_browser_column_model_real_has_default_sort_func (GtkTreeSortable* base);
static void noise_browser_column_model_real_set_default_sort_func (GtkTreeSortable* base,
                                                            GtkTreeIterCompareFunc sort_func,
                                                            gpointer sort_func_target,
                                                            GDestroyNotify sort_func_target_destroy_notify);
static void noise_browser_column_model_real_set_sort_column_id (GtkTreeSortable* base,
                                                         gint sort_column_id,
                                                         GtkSortType order);
gint noise_browser_column_model_sequenceIterCompareFunc (NoiseBrowserColumnModel* self,
                                                         GSequenceIter* a,
                                                         GSequenceIter* b);
static gint _noise_browser_column_model_sequenceIterCompareFunc_gsequence_iter_compare_func (GSequenceIter* a,
                                                                                      GSequenceIter* b,
                                                                                      gpointer self);
static void noise_browser_column_model_real_set_sort_func (GtkTreeSortable* base,
                                                    gint sort_column_id,
                                                    GtkTreeIterCompareFunc sort_func,
                                                    gpointer sort_func_target,
                                                    GDestroyNotify sort_func_target_destroy_notify);
static void noise_browser_column_model_finalize (GObject * obj);
static void _vala_noise_browser_column_model_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);


static inline gpointer
noise_browser_column_model_get_instance_private (NoiseBrowserColumnModel* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseBrowserColumnModel_private_offset);
}


/** Initialize data storage, columns, etc. **/
static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


NoiseBrowserColumnModel*
noise_browser_column_model_construct (GType object_type,
                                      NoiseBrowserColumnCategory category)
{
	NoiseBrowserColumnModel * self = NULL;
	GSequence* _tmp0_;
	self = (NoiseBrowserColumnModel*) g_object_new (object_type, NULL);
	_tmp0_ = g_sequence_new (_g_free0_);
	_g_sequence_free0 (self->priv->rows);
	self->priv->rows = _tmp0_;
	self->priv->category = category;
	self->priv->sort_column_id = -2;
	self->priv->sort_direction = GTK_SORT_ASCENDING;
	return self;
}


NoiseBrowserColumnModel*
noise_browser_column_model_new (NoiseBrowserColumnCategory category)
{
	return noise_browser_column_model_construct (NOISE_TYPE_BROWSER_COLUMN_MODEL, category);
}


/** Returns a set of flags supported by this interface **/
static GtkTreeModelFlags
noise_browser_column_model_real_get_flags (GtkTreeModel* base)
{
	NoiseBrowserColumnModel * self;
	GtkTreeModelFlags result = 0;
	self = (NoiseBrowserColumnModel*) base;
	result = GTK_TREE_MODEL_LIST_ONLY;
	return result;
}


/** Sets iter to a valid iterator pointing to path **/
static gboolean
noise_browser_column_model_real_get_iter (GtkTreeModel* base,
                                          GtkTreeIter* iter,
                                          GtkTreePath* path)
{
	NoiseBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	gint path_index = 0;
	gint _tmp0_;
	gint* _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GSequence* _tmp5_;
	GSequenceIter* seq_iter = NULL;
	GSequence* _tmp9_;
	gint _tmp10_;
	GSequenceIter* _tmp11_;
	GSequenceIter* _tmp12_;
	gint _tmp13_;
	GSequenceIter* _tmp14_;
	self = (NoiseBrowserColumnModel*) base;
	g_return_val_if_fail (path != NULL, FALSE);
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	_tmp1_ = gtk_tree_path_get_indices_with_depth (path, &_tmp0_);
	_tmp2_ = _tmp1_[0];
	path_index = _tmp2_;
	_tmp5_ = self->priv->rows;
	if (g_sequence_get_length (_tmp5_) == 0) {
		_tmp4_ = TRUE;
	} else {
		gint _tmp6_;
		_tmp6_ = path_index;
		_tmp4_ = _tmp6_ < 0;
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		gint _tmp7_;
		GSequence* _tmp8_;
		_tmp7_ = path_index;
		_tmp8_ = self->priv->rows;
		_tmp3_ = _tmp7_ >= g_sequence_get_length (_tmp8_);
	}
	if (_tmp3_) {
		result = FALSE;
		if (iter) {
			*iter = _vala_iter;
		}
		return result;
	}
	_tmp9_ = self->priv->rows;
	_tmp10_ = path_index;
	_tmp11_ = g_sequence_get_iter_at_pos (_tmp9_, _tmp10_);
	seq_iter = _tmp11_;
	_tmp12_ = seq_iter;
	if (_tmp12_ == NULL) {
		result = FALSE;
		if (iter) {
			*iter = _vala_iter;
		}
		return result;
	}
	_tmp13_ = self->priv->stamp;
	_vala_iter.stamp = _tmp13_;
	_tmp14_ = seq_iter;
	_vala_iter.user_data = _tmp14_;
	result = TRUE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}


/** Returns the number of columns supported by tree_model. **/
static gint
noise_browser_column_model_real_get_n_columns (GtkTreeModel* base)
{
	NoiseBrowserColumnModel * self;
	gint result = 0;
	self = (NoiseBrowserColumnModel*) base;
	result = 1;
	return result;
}


static GType
noise_browser_column_model_real_get_column_type (GtkTreeModel* base,
                                                 gint col)
{
	NoiseBrowserColumnModel * self;
	GType result = 0UL;
	self = (NoiseBrowserColumnModel*) base;
	result = G_TYPE_STRING;
	return result;
}


/** Returns a newly-created Gtk.TreePath referenced by iter. **/
static GtkTreePath*
noise_browser_column_model_real_get_path (GtkTreeModel* base,
                                          GtkTreeIter* iter)
{
	NoiseBrowserColumnModel * self;
	GtkTreePath* result = NULL;
	GtkTreeIter _tmp0_;
	void* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkTreePath* _tmp4_;
	GtkTreePath* _tmp5_;
	self = (NoiseBrowserColumnModel*) base;
	g_return_val_if_fail (iter != NULL, NULL);
	_tmp0_ = *iter;
	_tmp1_ = _tmp0_.user_data;
	_tmp2_ = g_strdup_printf ("%i", g_sequence_iter_get_position ((GSequenceIter*) _tmp1_));
	_tmp3_ = _tmp2_;
	_tmp4_ = gtk_tree_path_new_from_string (_tmp3_);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	result = _tmp5_;
	return result;
}


/** Initializes and sets value to that at column. **/
static void
noise_browser_column_model_real_get_value (GtkTreeModel* base,
                                           GtkTreeIter* iter,
                                           gint column,
                                           GValue* val)
{
	NoiseBrowserColumnModel * self;
	GValue _vala_val = {0};
	GValue _tmp0_ = {0};
	GValue _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GtkTreeIter _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GtkTreeIter _tmp7_;
	void* _tmp8_;
	self = (NoiseBrowserColumnModel*) base;
	g_return_if_fail (iter != NULL);
	g_value_init (&_tmp0_, G_TYPE_STRING);
	G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
	_vala_val = _tmp0_;
	_tmp1_ = _vala_val;
	_tmp4_ = *iter;
	_tmp5_ = _tmp4_.stamp;
	_tmp6_ = self->priv->stamp;
	if (_tmp5_ != _tmp6_) {
		_tmp3_ = TRUE;
	} else {
		_tmp3_ = column < 0;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = column >= 1;
	}
	if (_tmp2_) {
		if (val) {
			*val = _vala_val;
		} else {
			G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
		}
		return;
	}
	_tmp7_ = *iter;
	_tmp8_ = _tmp7_.user_data;
	if (!g_sequence_iter_is_end ((GSequenceIter*) _tmp8_)) {
		GtkTreeIter _tmp9_;
		void* _tmp10_;
		gconstpointer _tmp11_;
		GValue _tmp12_ = {0};
		_tmp9_ = *iter;
		_tmp10_ = _tmp9_.user_data;
		_tmp11_ = g_sequence_get ((GSequenceIter*) _tmp10_);
		g_value_init (&_tmp12_, G_TYPE_STRING);
		g_value_set_string (&_tmp12_, (const gchar*) _tmp11_);
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
		_vala_val = _tmp12_;
	}
	if (val) {
		*val = _vala_val;
	} else {
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
	}
}


/** Sets iter to point to the first child of parent. **/
static gboolean
noise_browser_column_model_real_iter_children (GtkTreeModel* base,
                                               GtkTreeIter* iter,
                                               GtkTreeIter* parent)
{
	NoiseBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	self = (NoiseBrowserColumnModel*) base;
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	result = FALSE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}


/** Returns true if iter has children, false otherwise. **/
static gboolean
noise_browser_column_model_real_iter_has_child (GtkTreeModel* base,
                                                GtkTreeIter* iter)
{
	NoiseBrowserColumnModel * self;
	gboolean result = FALSE;
	self = (NoiseBrowserColumnModel*) base;
	g_return_val_if_fail (iter != NULL, FALSE);
	result = FALSE;
	return result;
}


/** Returns the number of children that iter has. **/
static gint
noise_browser_column_model_real_iter_n_children (GtkTreeModel* base,
                                                 GtkTreeIter* iter)
{
	NoiseBrowserColumnModel * self;
	gint result = 0;
	self = (NoiseBrowserColumnModel*) base;
	if (iter == NULL) {
		GSequence* _tmp0_;
		_tmp0_ = self->priv->rows;
		result = g_sequence_get_length (_tmp0_);
		return result;
	}
	result = 0;
	return result;
}


/** Sets iter to point to the node following it at the current level. **/
static gboolean
noise_browser_column_model_real_iter_next (GtkTreeModel* base,
                                           GtkTreeIter* iter)
{
	NoiseBrowserColumnModel * self;
	gboolean result = FALSE;
	GtkTreeIter _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	GSequenceIter* _tmp5_;
	GtkTreeIter _tmp6_;
	void* _tmp7_;
	self = (NoiseBrowserColumnModel*) base;
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = *iter;
	_tmp1_ = _tmp0_.stamp;
	_tmp2_ = self->priv->stamp;
	if (_tmp1_ != _tmp2_) {
		result = FALSE;
		return result;
	}
	_tmp3_ = *iter;
	_tmp4_ = _tmp3_.user_data;
	_tmp5_ = g_sequence_iter_next ((GSequenceIter*) _tmp4_);
	(*iter).user_data = _tmp5_;
	_tmp6_ = *iter;
	_tmp7_ = _tmp6_.user_data;
	if (g_sequence_iter_is_end ((GSequenceIter*) _tmp7_)) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


/** Sets iter to be the child of parent, using the given index. **/
static gboolean
noise_browser_column_model_real_iter_nth_child (GtkTreeModel* base,
                                                GtkTreeIter* iter,
                                                GtkTreeIter* parent,
                                                gint n)
{
	NoiseBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _tmp3_;
	GSequence* _tmp4_;
	GSequenceIter* _tmp5_;
	self = (NoiseBrowserColumnModel*) base;
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	if (n < 0) {
		_tmp1_ = TRUE;
	} else {
		GSequence* _tmp2_;
		_tmp2_ = self->priv->rows;
		_tmp1_ = n >= g_sequence_get_length (_tmp2_);
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = parent != NULL;
	}
	if (_tmp0_) {
		result = FALSE;
		if (iter) {
			*iter = _vala_iter;
		}
		return result;
	}
	_tmp3_ = self->priv->stamp;
	_vala_iter.stamp = _tmp3_;
	_tmp4_ = self->priv->rows;
	_tmp5_ = g_sequence_get_iter_at_pos (_tmp4_, n);
	_vala_iter.user_data = _tmp5_;
	result = TRUE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}


/** Sets iter to be the parent of child. **/
static gboolean
noise_browser_column_model_real_iter_parent (GtkTreeModel* base,
                                             GtkTreeIter* iter,
                                             GtkTreeIter* child)
{
	NoiseBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	self = (NoiseBrowserColumnModel*) base;
	g_return_val_if_fail (child != NULL, FALSE);
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	result = FALSE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}


/** Lets the tree ref the node. **/
static void
noise_browser_column_model_real_ref_node (GtkTreeModel* base,
                                          GtkTreeIter* iter)
{
	NoiseBrowserColumnModel * self;
	self = (NoiseBrowserColumnModel*) base;
	g_return_if_fail (iter != NULL);
}


/** Lets the tree unref the node. **/
static void
noise_browser_column_model_real_unref_node (GtkTreeModel* base,
                                            GtkTreeIter* iter)
{
	NoiseBrowserColumnModel * self;
	self = (NoiseBrowserColumnModel*) base;
	g_return_if_fail (iter != NULL);
}


/** simply adds iter to the model **/
void
noise_browser_column_model_append (NoiseBrowserColumnModel* self,
                                   GtkTreeIter* iter)
{
	GtkTreeIter _vala_iter = {0};
	GSequenceIter* added = NULL;
	GSequence* _tmp0_;
	gchar* _tmp1_;
	GSequenceIter* _tmp2_;
	gint _tmp3_;
	g_return_if_fail (self != NULL);
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	_tmp0_ = self->priv->rows;
	_tmp1_ = g_strdup ("");
	_tmp2_ = g_sequence_append (_tmp0_, _tmp1_);
	added = _tmp2_;
	_tmp3_ = self->priv->stamp;
	_vala_iter.stamp = _tmp3_;
	_vala_iter.user_data = added;
	if (iter) {
		*iter = _vala_iter;
	}
}


/** convenience method to insert strings into the model. No iters returned. **/
static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}


void
noise_browser_column_model_append_items (NoiseBrowserColumnModel* self,
                                         GeeCollection* strings,
                                         gboolean emit)
{
	GtkTreeIter* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (strings != NULL);
	_tmp0_ = self->priv->first_iter;
	if (_tmp0_ == NULL) {
		noise_browser_column_model_add_first_element (self);
	}
	{
		GeeIterator* _s_it = NULL;
		GeeIterator* _tmp1_;
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) strings);
		_s_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			gchar* s = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GSequenceIter* added = NULL;
			GSequence* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			GSequenceIter* _tmp8_;
			_tmp2_ = _s_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _s_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			s = (gchar*) _tmp4_;
			_tmp5_ = self->priv->rows;
			_tmp6_ = s;
			_tmp7_ = g_strdup (_tmp6_);
			_tmp8_ = g_sequence_append (_tmp5_, _tmp7_);
			added = _tmp8_;
			if (emit) {
				GtkTreePath* path = NULL;
				GSequenceIter* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				GtkTreePath* _tmp12_;
				GtkTreePath* _tmp13_;
				GtkTreeIter iter = {0};
				gint _tmp14_;
				GSequenceIter* _tmp15_;
				GtkTreePath* _tmp16_;
				GtkTreeIter _tmp17_;
				_tmp9_ = added;
				_tmp10_ = g_strdup_printf ("%i", g_sequence_iter_get_position (_tmp9_));
				_tmp11_ = _tmp10_;
				_tmp12_ = gtk_tree_path_new_from_string (_tmp11_);
				_tmp13_ = _tmp12_;
				_g_free0 (_tmp11_);
				path = _tmp13_;
				memset (&iter, 0, sizeof (GtkTreeIter));
				_tmp14_ = self->priv->stamp;
				iter.stamp = _tmp14_;
				_tmp15_ = added;
				iter.user_data = _tmp15_;
				_tmp16_ = path;
				_tmp17_ = iter;
				gtk_tree_model_row_inserted ((GtkTreeModel*) self, _tmp16_, &_tmp17_);
				__vala_GtkTreePath_free0 (path);
			}
			_g_free0 (s);
		}
		_g_object_unref0 (_s_it);
	}
	noise_browser_column_model_update_first_item (self);
}


static GtkTreeIter*
_gtk_tree_iter_dup (GtkTreeIter* self)
{
	GtkTreeIter* dup;
	dup = g_new0 (GtkTreeIter, 1);
	memcpy (dup, self, sizeof (GtkTreeIter));
	return dup;
}


static gpointer
__gtk_tree_iter_dup0 (gpointer self)
{
	return self ? _gtk_tree_iter_dup (self) : NULL;
}


static void
noise_browser_column_model_add_first_element (NoiseBrowserColumnModel* self)
{
	GSequenceIter* added = NULL;
	GSequence* _tmp0_;
	gchar* _tmp1_;
	GSequenceIter* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkTreeIter* _tmp4_;
	GtkTreeIter* _tmp5_;
	gint _tmp6_;
	GtkTreeIter* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->rows;
	_tmp1_ = g_strdup ("All");
	_tmp2_ = g_sequence_append (_tmp0_, _tmp1_);
	added = _tmp2_;
	memset (&_tmp3_, 0, sizeof (GtkTreeIter));
	_tmp4_ = __gtk_tree_iter_dup0 (&_tmp3_);
	_g_free0 (self->priv->first_iter);
	self->priv->first_iter = _tmp4_;
	_tmp5_ = self->priv->first_iter;
	_tmp6_ = self->priv->stamp;
	(*_tmp5_).stamp = _tmp6_;
	_tmp7_ = self->priv->first_iter;
	(*_tmp7_).user_data = added;
}


static void
noise_browser_column_model_update_first_item (NoiseBrowserColumnModel* self)
{
	GtkTreeIter* _tmp0_;
	void* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->first_iter;
	_tmp1_ = (*_tmp0_).user_data;
	_tmp2_ = noise_browser_column_model_get_n_items (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = noise_browser_column_model_get_first_item_text (self, _tmp3_);
	g_sequence_set ((GSequenceIter*) _tmp1_, _tmp4_);
}


static gchar*
noise_browser_column_model_get_first_item_text (NoiseBrowserColumnModel* self,
                                                gint n_items)
{
	gchar* result = NULL;
	gchar* rv = NULL;
	gchar* _tmp0_;
	NoiseBrowserColumnCategory _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("");
	rv = _tmp0_;
	_tmp1_ = self->priv->category;
	switch (_tmp1_) {
		case NOISE_BROWSER_COLUMN_CATEGORY_GENRE:
		{
			if (n_items == 1) {
				gchar* _tmp2_;
				_tmp2_ = g_strdup (_ ("All Genres"));
				_g_free0 (rv);
				rv = _tmp2_;
			} else {
				if (n_items > 1) {
					gchar* _tmp3_;
					_tmp3_ = g_strdup_printf (_ ("All %i Genres"), n_items);
					_g_free0 (rv);
					rv = _tmp3_;
				} else {
					gchar* _tmp4_;
					_tmp4_ = g_strdup (_ ("No Genres"));
					_g_free0 (rv);
					rv = _tmp4_;
				}
			}
			break;
		}
		case NOISE_BROWSER_COLUMN_CATEGORY_ARTIST:
		{
			if (n_items == 1) {
				gchar* _tmp5_;
				_tmp5_ = g_strdup (_ ("All Artists"));
				_g_free0 (rv);
				rv = _tmp5_;
			} else {
				if (n_items > 1) {
					gchar* _tmp6_;
					_tmp6_ = g_strdup_printf (_ ("All %i Artists"), n_items);
					_g_free0 (rv);
					rv = _tmp6_;
				} else {
					gchar* _tmp7_;
					_tmp7_ = g_strdup (_ ("No Artists"));
					_g_free0 (rv);
					rv = _tmp7_;
				}
			}
			break;
		}
		case NOISE_BROWSER_COLUMN_CATEGORY_ALBUM:
		{
			if (n_items == 1) {
				gchar* _tmp8_;
				_tmp8_ = g_strdup (_ ("All Albums"));
				_g_free0 (rv);
				rv = _tmp8_;
			} else {
				if (n_items > 1) {
					gchar* _tmp9_;
					_tmp9_ = g_strdup_printf (_ ("All %i Albums"), n_items);
					_g_free0 (rv);
					rv = _tmp9_;
				} else {
					gchar* _tmp10_;
					_tmp10_ = g_strdup (_ ("No Albums"));
					_g_free0 (rv);
					rv = _tmp10_;
				}
			}
			break;
		}
		case NOISE_BROWSER_COLUMN_CATEGORY_YEAR:
		{
			if (n_items == 1) {
				gchar* _tmp11_;
				_tmp11_ = g_strdup (_ ("All Years"));
				_g_free0 (rv);
				rv = _tmp11_;
			} else {
				if (n_items > 1) {
					gchar* _tmp12_;
					_tmp12_ = g_strdup_printf (_ ("All %i Years"), n_items);
					_g_free0 (rv);
					rv = _tmp12_;
				} else {
					gchar* _tmp13_;
					_tmp13_ = g_strdup (_ ("No Years"));
					_g_free0 (rv);
					rv = _tmp13_;
				}
			}
			break;
		}
		case NOISE_BROWSER_COLUMN_CATEGORY_RATING:
		{
			if (n_items >= 1) {
				gchar* _tmp14_;
				_tmp14_ = g_strdup (_ ("All Ratings"));
				_g_free0 (rv);
				rv = _tmp14_;
			} else {
				gchar* _tmp15_;
				_tmp15_ = g_strdup (_ ("No Ratings"));
				_g_free0 (rv);
				rv = _tmp15_;
			}
			break;
		}
		case NOISE_BROWSER_COLUMN_CATEGORY_GROUPING:
		{
			if (n_items == 1) {
				gchar* _tmp16_;
				_tmp16_ = g_strdup (_ ("All Groupings"));
				_g_free0 (rv);
				rv = _tmp16_;
			} else {
				if (n_items > 1) {
					gchar* _tmp17_;
					_tmp17_ = g_strdup_printf (_ ("All %i Groupings"), n_items);
					_g_free0 (rv);
					rv = _tmp17_;
				} else {
					gchar* _tmp18_;
					_tmp18_ = g_strdup (_ ("No Groupings"));
					_g_free0 (rv);
					rv = _tmp18_;
				}
			}
			break;
		}
		case NOISE_BROWSER_COLUMN_CATEGORY_COMPOSER:
		{
			if (n_items == 1) {
				gchar* _tmp19_;
				_tmp19_ = g_strdup (_ ("All Composers"));
				_g_free0 (rv);
				rv = _tmp19_;
			} else {
				if (n_items > 1) {
					gchar* _tmp20_;
					_tmp20_ = g_strdup_printf (_ ("All %i Composers"), n_items);
					_g_free0 (rv);
					rv = _tmp20_;
				} else {
					gchar* _tmp21_;
					_tmp21_ = g_strdup (_ ("No Composers"));
					_g_free0 (rv);
					rv = _tmp21_;
				}
			}
			break;
		}
		default:
		break;
	}
	result = rv;
	return result;
}


void
noise_browser_column_model_set (NoiseBrowserColumnModel* self,
                                GtkTreeIter* iter,
                                ...)
{
	GtkTreeIter _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	va_list args = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = *iter;
	_tmp1_ = _tmp0_.stamp;
	_tmp2_ = self->priv->stamp;
	if (_tmp1_ != _tmp2_) {
		return;
	}
	va_start (args, iter);
	while (TRUE) {
		gint col = 0;
		gboolean _tmp3_ = FALSE;
		gint _tmp4_;
		col = va_arg (args, gint);
		_tmp4_ = col;
		if (_tmp4_ < 0) {
			_tmp3_ = TRUE;
		} else {
			gint _tmp5_;
			_tmp5_ = col;
			_tmp3_ = _tmp5_ >= 1;
		}
		if (_tmp3_) {
			va_end (args);
			return;
		} else {
			gint _tmp6_;
			_tmp6_ = col;
			if (_tmp6_ == 0) {
				gchar* val = NULL;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				GtkTreeIter _tmp9_;
				void* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				_tmp7_ = va_arg (args, gchar*);
				_tmp8_ = g_strdup (_tmp7_);
				val = _tmp8_;
				_tmp9_ = *iter;
				_tmp10_ = _tmp9_.user_data;
				_tmp11_ = val;
				_tmp12_ = g_strdup (_tmp11_);
				g_sequence_set ((GSequenceIter*) _tmp10_, _tmp12_);
				_g_free0 (val);
			}
		}
	}
	va_end (args);
}


void
noise_browser_column_model_remove (NoiseBrowserColumnModel* self,
                                   GtkTreeIter* iter)
{
	GtkTreeIter _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GSequenceIter* sequence_iter = NULL;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	GtkTreePath* path = NULL;
	GSequenceIter* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkTreePath* _tmp8_;
	GtkTreePath* _tmp9_;
	GSequenceIter* _tmp10_;
	GtkTreePath* _tmp11_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = *iter;
	_tmp1_ = _tmp0_.stamp;
	_tmp2_ = self->priv->stamp;
	if (_tmp1_ != _tmp2_) {
		return;
	}
	_tmp3_ = *iter;
	_tmp4_ = _tmp3_.user_data;
	sequence_iter = (GSequenceIter*) _tmp4_;
	_tmp5_ = sequence_iter;
	_tmp6_ = g_strdup_printf ("%i", g_sequence_iter_get_position (_tmp5_));
	_tmp7_ = _tmp6_;
	_tmp8_ = gtk_tree_path_new_from_string (_tmp7_);
	_tmp9_ = _tmp8_;
	_g_free0 (_tmp7_);
	path = _tmp9_;
	_tmp10_ = sequence_iter;
	g_sequence_remove (_tmp10_);
	_tmp11_ = path;
	gtk_tree_model_row_deleted ((GtkTreeModel*) self, _tmp11_);
	__vala_GtkTreePath_free0 (path);
}


/** Fills in sort_column_id and order with the current sort column and the order. **/
static gboolean
noise_browser_column_model_real_get_sort_column_id (GtkTreeSortable* base,
                                                    gint* sort_column_id,
                                                    GtkSortType* order)
{
	NoiseBrowserColumnModel * self;
	gint _vala_sort_column_id = 0;
	GtkSortType _vala_order = 0;
	gboolean result = FALSE;
	gint _tmp0_;
	GtkSortType _tmp1_;
	self = (NoiseBrowserColumnModel*) base;
	_tmp0_ = self->priv->sort_column_id;
	_vala_sort_column_id = _tmp0_;
	_tmp1_ = self->priv->sort_direction;
	_vala_order = _tmp1_;
	result = TRUE;
	if (sort_column_id) {
		*sort_column_id = _vala_sort_column_id;
	}
	if (order) {
		*order = _vala_order;
	}
	return result;
}


/** Returns true if the model has a default sort function. **/
static gboolean
noise_browser_column_model_real_has_default_sort_func (GtkTreeSortable* base)
{
	NoiseBrowserColumnModel * self;
	gboolean result = FALSE;
	GtkTreeIterCompareFunc _tmp0_;
	void* _tmp0__target;
	self = (NoiseBrowserColumnModel*) base;
	_tmp0_ = self->priv->default_sort_func;
	_tmp0__target = self->priv->default_sort_func_target;
	result = _tmp0_ != NULL;
	return result;
}


/** Sets the default comparison function used when sorting to be sort_func. **/
static void
noise_browser_column_model_real_set_default_sort_func (GtkTreeSortable* base,
                                                       GtkTreeIterCompareFunc sort_func,
                                                       gpointer sort_func_target,
                                                       GDestroyNotify sort_func_target_destroy_notify)
{
	NoiseBrowserColumnModel * self;
	self = (NoiseBrowserColumnModel*) base;
	self->priv->default_sort_func = sort_func;
	self->priv->default_sort_func_target = sort_func_target;
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
	sort_func = NULL;
	sort_func_target = NULL;
	sort_func_target_destroy_notify = NULL;
}


/** Sets the current sort column to be sort_column_id. **/
static gint
_noise_browser_column_model_sequenceIterCompareFunc_gsequence_iter_compare_func (GSequenceIter* a,
                                                                                 GSequenceIter* b,
                                                                                 gpointer self)
{
	gint result;
	result = noise_browser_column_model_sequenceIterCompareFunc ((NoiseBrowserColumnModel*) self, a, b);
	return result;
}


static void
noise_browser_column_model_real_set_sort_column_id (GtkTreeSortable* base,
                                                    gint sort_column_id,
                                                    GtkSortType order)
{
	NoiseBrowserColumnModel * self;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean changed = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	self = (NoiseBrowserColumnModel*) base;
	_tmp1_ = self->priv->sort_column_id;
	if (_tmp1_ != sort_column_id) {
		_tmp0_ = TRUE;
	} else {
		GtkSortType _tmp2_;
		_tmp2_ = self->priv->sort_direction;
		_tmp0_ = order != _tmp2_;
	}
	changed = _tmp0_;
	self->priv->sort_column_id = sort_column_id;
	self->priv->sort_direction = order;
	_tmp4_ = changed;
	if (_tmp4_) {
		_tmp3_ = sort_column_id >= 0;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		GSequence* _tmp5_;
		_tmp5_ = self->priv->rows;
		g_sequence_sort_iter (_tmp5_, _noise_browser_column_model_sequenceIterCompareFunc_gsequence_iter_compare_func, self);
		gtk_tree_sortable_sort_column_changed ((GtkTreeSortable*) self);
	}
}


static void
noise_browser_column_model_real_set_sort_func (GtkTreeSortable* base,
                                               gint sort_column_id,
                                               GtkTreeIterCompareFunc sort_func,
                                               gpointer sort_func_target,
                                               GDestroyNotify sort_func_target_destroy_notify)
{
	NoiseBrowserColumnModel * self;
	self = (NoiseBrowserColumnModel*) base;
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
	sort_func = NULL;
	sort_func_target = NULL;
	sort_func_target_destroy_notify = NULL;
}


/** Custom function to use built in sort in Sequence to our advantage **/
gint
noise_browser_column_model_sequenceIterCompareFunc (NoiseBrowserColumnModel* self,
                                                    GSequenceIter* a,
                                                    GSequenceIter* b)
{
	gint result = 0;
	gint rv = 0;
	gint _tmp0_;
	gint _tmp1_;
	GtkSortType _tmp13_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	rv = 1;
	_tmp0_ = self->priv->sort_column_id;
	if (_tmp0_ < 0) {
		result = 0;
		return result;
	}
	_tmp1_ = self->priv->sort_column_id;
	if (_tmp1_ == 0) {
		GSequenceIter* first_sequence_iter = NULL;
		GtkTreeIter* _tmp2_;
		void* _tmp3_;
		GSequenceIter* _tmp4_;
		_tmp2_ = self->priv->first_iter;
		_tmp3_ = (*_tmp2_).user_data;
		first_sequence_iter = (GSequenceIter*) _tmp3_;
		_tmp4_ = first_sequence_iter;
		if (a == _tmp4_) {
			rv = -1;
		} else {
			GSequenceIter* _tmp5_;
			_tmp5_ = first_sequence_iter;
			if (b == _tmp5_) {
				rv = 1;
			} else {
				gboolean _tmp6_ = FALSE;
				NoiseBrowserColumnCategory _tmp7_;
				_tmp7_ = self->priv->category;
				if (_tmp7_ == NOISE_BROWSER_COLUMN_CATEGORY_ARTIST) {
					_tmp6_ = TRUE;
				} else {
					NoiseBrowserColumnCategory _tmp8_;
					_tmp8_ = self->priv->category;
					_tmp6_ = _tmp8_ == NOISE_BROWSER_COLUMN_CATEGORY_ALBUM;
				}
				if (_tmp6_) {
					gconstpointer _tmp9_;
					gconstpointer _tmp10_;
					_tmp9_ = g_sequence_get (a);
					_tmp10_ = g_sequence_get (b);
					rv = noise_string_compare ((const gchar*) _tmp9_, (const gchar*) _tmp10_);
				} else {
					gconstpointer _tmp11_;
					gconstpointer _tmp12_;
					_tmp11_ = g_sequence_get (a);
					_tmp12_ = g_sequence_get (b);
					rv = noise_string_compare ((const gchar*) _tmp11_, (const gchar*) _tmp12_);
				}
			}
		}
	}
	_tmp13_ = self->priv->sort_direction;
	if (_tmp13_ == GTK_SORT_DESCENDING) {
		gint _tmp14_ = 0;
		gint _tmp15_;
		_tmp15_ = rv;
		if (_tmp15_ > 0) {
			_tmp14_ = -1;
		} else {
			_tmp14_ = 1;
		}
		rv = _tmp14_;
	}
	result = rv;
	return result;
}


gint
noise_browser_column_model_get_n_items (NoiseBrowserColumnModel* self)
{
	gint result;
	GSequence* _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->rows;
	result = g_sequence_get_length (_tmp0_) - 1;
	return result;
}


static void
noise_browser_column_model_class_init (NoiseBrowserColumnModelClass * klass)
{
	noise_browser_column_model_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseBrowserColumnModel_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_browser_column_model_get_property;
	G_OBJECT_CLASS (klass)->finalize = noise_browser_column_model_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY, noise_browser_column_model_properties[NOISE_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY] = g_param_spec_int ("n-items", "n-items", "n-items", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
noise_browser_column_model_gtk_tree_model_interface_init (GtkTreeModelIface * iface)
{
	noise_browser_column_model_gtk_tree_model_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_flags = (GtkTreeModelFlags (*) (GtkTreeModel *)) noise_browser_column_model_real_get_flags;
	iface->get_iter = (gboolean (*) (GtkTreeModel *, GtkTreeIter*, GtkTreePath*)) noise_browser_column_model_real_get_iter;
	iface->get_n_columns = (gint (*) (GtkTreeModel *)) noise_browser_column_model_real_get_n_columns;
	iface->get_column_type = (GType (*) (GtkTreeModel *, gint)) noise_browser_column_model_real_get_column_type;
	iface->get_path = (GtkTreePath* (*) (GtkTreeModel *, GtkTreeIter*)) noise_browser_column_model_real_get_path;
	iface->get_value = (void (*) (GtkTreeModel *, GtkTreeIter*, gint, GValue*)) noise_browser_column_model_real_get_value;
	iface->iter_children = (gboolean (*) (GtkTreeModel *, GtkTreeIter*, GtkTreeIter*)) noise_browser_column_model_real_iter_children;
	iface->iter_has_child = (gboolean (*) (GtkTreeModel *, GtkTreeIter*)) noise_browser_column_model_real_iter_has_child;
	iface->iter_n_children = (gint (*) (GtkTreeModel *, GtkTreeIter*)) noise_browser_column_model_real_iter_n_children;
	iface->iter_next = (gboolean (*) (GtkTreeModel *, GtkTreeIter*)) noise_browser_column_model_real_iter_next;
	iface->iter_nth_child = (gboolean (*) (GtkTreeModel *, GtkTreeIter*, GtkTreeIter*, gint)) noise_browser_column_model_real_iter_nth_child;
	iface->iter_parent = (gboolean (*) (GtkTreeModel *, GtkTreeIter*, GtkTreeIter*)) noise_browser_column_model_real_iter_parent;
	iface->ref_node = (void (*) (GtkTreeModel *, GtkTreeIter*)) noise_browser_column_model_real_ref_node;
	iface->unref_node = (void (*) (GtkTreeModel *, GtkTreeIter*)) noise_browser_column_model_real_unref_node;
}


static void
noise_browser_column_model_gtk_tree_sortable_interface_init (GtkTreeSortableIface * iface)
{
	noise_browser_column_model_gtk_tree_sortable_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_sort_column_id = (gboolean (*) (GtkTreeSortable *, gint*, GtkSortType*)) noise_browser_column_model_real_get_sort_column_id;
	iface->has_default_sort_func = (gboolean (*) (GtkTreeSortable *)) noise_browser_column_model_real_has_default_sort_func;
	iface->set_default_sort_func = (void (*) (GtkTreeSortable *, GtkTreeIterCompareFunc, gpointer, GDestroyNotify)) noise_browser_column_model_real_set_default_sort_func;
	iface->set_sort_column_id = (void (*) (GtkTreeSortable *, gint, GtkSortType)) noise_browser_column_model_real_set_sort_column_id;
	iface->set_sort_func = (void (*) (GtkTreeSortable *, gint, GtkTreeIterCompareFunc, gpointer, GDestroyNotify)) noise_browser_column_model_real_set_sort_func;
}


static void
noise_browser_column_model_instance_init (NoiseBrowserColumnModel * self)
{
	self->priv = noise_browser_column_model_get_instance_private (self);
	self->priv->stamp = (gint) g_random_int ();
}


static void
noise_browser_column_model_finalize (GObject * obj)
{
	NoiseBrowserColumnModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModel);
	_g_sequence_free0 (self->priv->rows);
	_g_free0 (self->priv->first_iter);
	G_OBJECT_CLASS (noise_browser_column_model_parent_class)->finalize (obj);
}


GType
noise_browser_column_model_get_type (void)
{
	static volatile gsize noise_browser_column_model_type_id__volatile = 0;
	if (g_once_init_enter (&noise_browser_column_model_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseBrowserColumnModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_browser_column_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseBrowserColumnModel), 0, (GInstanceInitFunc) noise_browser_column_model_instance_init, NULL };
		static const GInterfaceInfo gtk_tree_model_info = { (GInterfaceInitFunc) noise_browser_column_model_gtk_tree_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gtk_tree_sortable_info = { (GInterfaceInitFunc) noise_browser_column_model_gtk_tree_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_browser_column_model_type_id;
		noise_browser_column_model_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseBrowserColumnModel", &g_define_type_info, 0);
		g_type_add_interface_static (noise_browser_column_model_type_id, gtk_tree_model_get_type (), &gtk_tree_model_info);
		g_type_add_interface_static (noise_browser_column_model_type_id, gtk_tree_sortable_get_type (), &gtk_tree_sortable_info);
		NoiseBrowserColumnModel_private_offset = g_type_add_instance_private (noise_browser_column_model_type_id, sizeof (NoiseBrowserColumnModelPrivate));
		g_once_init_leave (&noise_browser_column_model_type_id__volatile, noise_browser_column_model_type_id);
	}
	return noise_browser_column_model_type_id__volatile;
}


static void
_vala_noise_browser_column_model_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	NoiseBrowserColumnModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModel);
	switch (property_id) {
		case NOISE_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY:
		g_value_set_int (value, noise_browser_column_model_get_n_items (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



