/* ViewWrapper.c generated by valac 0.41.91, the Vala compiler
 * generated from ViewWrapper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>,
 *              Scott Ringwelski <sgringwe@mtu.edu>
 */
/*
 * Container and controller of the list and grid views, and info widgets
 * (welcome screen and embedded alert).
 *
 * A ViewWrapper triggers searches, status info updates, and also handles
 * view switching. It also works as a proxy for setting the media contained
 * by all the views. Please see set_media(), update_media(), remove_media()
 * and add_media().
 *
 * The views it contains implement the {@link Noise.ContentView} interface.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <granite.h>
#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>


#define NOISE_TYPE_VIEW_WRAPPER (noise_view_wrapper_get_type ())
#define NOISE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper))
#define NOISE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))
#define NOISE_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))

typedef struct _NoiseViewWrapper NoiseViewWrapper;
typedef struct _NoiseViewWrapperClass NoiseViewWrapperClass;
typedef struct _NoiseViewWrapperPrivate NoiseViewWrapperPrivate;

#define NOISE_TYPE_LIST_VIEW (noise_list_view_get_type ())
#define NOISE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIST_VIEW, NoiseListView))
#define NOISE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIST_VIEW, NoiseListViewClass))
#define NOISE_IS_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIST_VIEW))
#define NOISE_IS_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIST_VIEW))
#define NOISE_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIST_VIEW, NoiseListViewClass))

typedef struct _NoiseListView NoiseListView;
typedef struct _NoiseListViewClass NoiseListViewClass;

#define NOISE_TYPE_ALBUMS_VIEW (noise_albums_view_get_type ())
#define NOISE_ALBUMS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_ALBUMS_VIEW, NoiseAlbumsView))
#define NOISE_ALBUMS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_ALBUMS_VIEW, NoiseAlbumsViewClass))
#define NOISE_IS_ALBUMS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_ALBUMS_VIEW))
#define NOISE_IS_ALBUMS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_ALBUMS_VIEW))
#define NOISE_ALBUMS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_ALBUMS_VIEW, NoiseAlbumsViewClass))

typedef struct _NoiseAlbumsView NoiseAlbumsView;
typedef struct _NoiseAlbumsViewClass NoiseAlbumsViewClass;

#define NOISE_VIEW_WRAPPER_TYPE_HINT (noise_view_wrapper_hint_get_type ())

#define NOISE_TYPE_VIEW_STACK (noise_view_stack_get_type ())
#define NOISE_VIEW_STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_STACK, NoiseViewStack))
#define NOISE_VIEW_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_VIEW_STACK, NoiseViewStackClass))
#define NOISE_IS_VIEW_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_STACK))
#define NOISE_IS_VIEW_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_VIEW_STACK))
#define NOISE_VIEW_STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_VIEW_STACK, NoiseViewStackClass))

typedef struct _NoiseViewStack NoiseViewStack;
typedef struct _NoiseViewStackClass NoiseViewStackClass;

#define NOISE_VIEW_WRAPPER_TYPE_VIEW_TYPE (noise_view_wrapper_view_type_get_type ())
enum  {
	NOISE_VIEW_WRAPPER_0_PROPERTY,
	NOISE_VIEW_WRAPPER_LIST_VIEW_PROPERTY,
	NOISE_VIEW_WRAPPER_GRID_VIEW_PROPERTY,
	NOISE_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY,
	NOISE_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY,
	NOISE_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY,
	NOISE_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY,
	NOISE_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY,
	NOISE_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY,
	NOISE_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY,
	NOISE_VIEW_WRAPPER_HINT_PROPERTY,
	NOISE_VIEW_WRAPPER_LIBRARY_PROPERTY,
	NOISE_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY,
	NOISE_VIEW_WRAPPER_PLAYLIST_PROPERTY,
	NOISE_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY,
	NOISE_VIEW_WRAPPER_NUM_PROPERTIES
};
static GParamSpec* noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NOISE_TYPE_GENERIC_LIST (noise_generic_list_get_type ())
#define NOISE_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_GENERIC_LIST, NoiseGenericList))
#define NOISE_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_GENERIC_LIST, NoiseGenericListClass))
#define NOISE_IS_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_GENERIC_LIST))
#define NOISE_IS_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_GENERIC_LIST))
#define NOISE_GENERIC_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_GENERIC_LIST, NoiseGenericListClass))

typedef struct _NoiseGenericList NoiseGenericList;
typedef struct _NoiseGenericListClass NoiseGenericListClass;

#define NOISE_TYPE_MUSIC_LIST_VIEW (noise_music_list_view_get_type ())
#define NOISE_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListView))
#define NOISE_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListViewClass))
#define NOISE_IS_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MUSIC_LIST_VIEW))
#define NOISE_IS_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MUSIC_LIST_VIEW))
#define NOISE_MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListViewClass))

typedef struct _NoiseMusicListView NoiseMusicListView;
typedef struct _NoiseMusicListViewClass NoiseMusicListViewClass;

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;

#define NOISE_WIDGETS_TYPE_VIEW_SELECTOR (noise_widgets_view_selector_get_type ())
#define NOISE_WIDGETS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelector))
#define NOISE_WIDGETS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelectorClass))
#define NOISE_WIDGETS_IS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR))
#define NOISE_WIDGETS_IS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_WIDGETS_TYPE_VIEW_SELECTOR))
#define NOISE_WIDGETS_VIEW_SELECTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelectorClass))

typedef struct _NoiseWidgetsViewSelector NoiseWidgetsViewSelector;
typedef struct _NoiseWidgetsViewSelectorClass NoiseWidgetsViewSelectorClass;

#define NOISE_TYPE_COLUMN_BROWSER (noise_column_browser_get_type ())
#define NOISE_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowser))
#define NOISE_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowserClass))
#define NOISE_IS_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_COLUMN_BROWSER))
#define NOISE_IS_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_COLUMN_BROWSER))
#define NOISE_COLUMN_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowserClass))

typedef struct _NoiseColumnBrowser NoiseColumnBrowser;
typedef struct _NoiseColumnBrowserClass NoiseColumnBrowserClass;

#define NOISE_WIDGETS_VIEW_SELECTOR_TYPE_MODE (noise_widgets_view_selector_mode_get_type ())

#define NOISE_TYPE_PLAYBACK_MANAGER (noise_playback_manager_get_type ())
#define NOISE_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager))
#define NOISE_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))
#define NOISE_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))

typedef struct _NoisePlaybackManager NoisePlaybackManager;
typedef struct _NoisePlaybackManagerClass NoisePlaybackManagerClass;

#define NOISE_TYPE_VIEW_INTERFACE (noise_view_interface_get_type ())
#define NOISE_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_INTERFACE, NoiseViewInterface))
#define NOISE_IS_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_INTERFACE))
#define NOISE_VIEW_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NOISE_TYPE_VIEW_INTERFACE, NoiseViewInterfaceIface))

typedef struct _NoiseViewInterface NoiseViewInterface;
typedef struct _NoiseViewInterfaceIface NoiseViewInterfaceIface;
typedef struct _NoiseViewWrapperSetMediaAsyncData NoiseViewWrapperSetMediaAsyncData;
typedef struct _NoiseViewWrapperAddMediaAsyncData NoiseViewWrapperAddMediaAsyncData;
typedef struct _NoiseViewWrapperRemoveMediaAsyncData NoiseViewWrapperRemoveMediaAsyncData;
typedef struct _NoiseViewWrapperUpdateMediaAsyncData NoiseViewWrapperUpdateMediaAsyncData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NoiseViewWrapper {
	GtkGrid parent_instance;
	NoiseViewWrapperPrivate * priv;
};

struct _NoiseViewWrapperClass {
	GtkGridClass parent_class;
	gboolean (*check_have_media) (NoiseViewWrapper* self);
	void (*select_proper_content_view) (NoiseViewWrapper* self);
	void (*set_no_media_alert) (NoiseViewWrapper* self);
};

typedef enum  {
	NOISE_VIEW_WRAPPER_HINT_NONE,
	NOISE_VIEW_WRAPPER_HINT_MUSIC,
	NOISE_VIEW_WRAPPER_HINT_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_CDROM,
	NOISE_VIEW_WRAPPER_HINT_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST,
	NOISE_VIEW_WRAPPER_HINT_QUEUE
} NoiseViewWrapperHint;

typedef enum  {
	NOISE_VIEW_WRAPPER_VIEW_TYPE_GRID = 0,
	NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST = 1,
	NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT = 2,
	NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME = 3,
	NOISE_VIEW_WRAPPER_VIEW_TYPE_NONE = 4
} NoiseViewWrapperViewType;

struct _NoiseViewWrapperPrivate {
	NoiseListView* _list_view;
	NoiseAlbumsView* _grid_view;
	GraniteWidgetsAlertView* _embedded_alert;
	GraniteWidgetsWelcome* _welcome_screen;
	NoiseViewWrapperHint _hint;
	NoiseLibrary* _library;
	NoisePlaylist* _playlist;
	gboolean widgets_ready;
	NoiseViewStack* view_stack;
	NoiseViewWrapperViewType last_used_view;
	gboolean data_initialized;
	GRecMutex __lock_NoiseViewWrapperlist_view;
	GRecMutex __lock_NoiseViewWrappergrid_view;
};

typedef enum  {
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_GRID = 0,
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST = 1,
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN = 2
} NoiseWidgetsViewSelectorMode;

struct _NoiseViewInterfaceIface {
	GTypeInterface parent_iface;
	NoiseViewWrapperHint (*get_hint) (NoiseViewInterface* self);
	GeeCollection* (*get_media) (NoiseViewInterface* self);
	GeeCollection* (*get_visible_media) (NoiseViewInterface* self);
	void (*refilter) (NoiseViewInterface* self);
	void (*set_media) (NoiseViewInterface* self, GeeCollection* new_media);
	void (*add_media) (NoiseViewInterface* self, GeeCollection* to_add);
	void (*remove_media) (NoiseViewInterface* self, GeeCollection* to_remove);
	void (*update_media) (NoiseViewInterface* self, GeeCollection* to_update);
};

struct _NoiseViewWrapperSetMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	NoiseViewWrapper* self;
	GeeCollection* new_media;
	gboolean _tmp0_;
};

struct _NoiseViewWrapperAddMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	NoiseViewWrapper* self;
	GeeCollection* to_add;
	gboolean _tmp0_;
};

struct _NoiseViewWrapperRemoveMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	NoiseViewWrapper* self;
	GeeCollection* to_remove;
	gboolean _tmp0_;
};

struct _NoiseViewWrapperUpdateMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	NoiseViewWrapper* self;
	GeeCollection* to_update;
	gboolean _tmp0_;
};


static gint NoiseViewWrapper_private_offset;
static gpointer noise_view_wrapper_parent_class = NULL;

GType noise_view_wrapper_get_type (void) G_GNUC_CONST;
GType noise_list_view_get_type (void) G_GNUC_CONST;
GType noise_albums_view_get_type (void) G_GNUC_CONST;
GType noise_view_wrapper_hint_get_type (void) G_GNUC_CONST;
GType noise_view_stack_get_type (void) G_GNUC_CONST;
GType noise_view_wrapper_view_type_get_type (void) G_GNUC_CONST;
#define NOISE_VIEW_WRAPPER_VIEW_CONSTRUCT_PRIORITY (G_PRIORITY_DEFAULT_IDLE - 10)
NoiseViewWrapper* noise_view_wrapper_construct (GType object_type,
                                                NoiseViewWrapperHint hint,
                                                NoiseLibrary* library);
void noise_view_wrapper_pack_views (NoiseViewWrapper* self);
gboolean noise_view_wrapper_get_has_grid_view (NoiseViewWrapper* self);
NoiseAlbumsView* noise_view_wrapper_get_grid_view (NoiseViewWrapper* self);
void noise_view_stack_add_view (NoiseViewStack* self,
                                GtkWidget* view);
gboolean noise_view_wrapper_get_has_list_view (NoiseViewWrapper* self);
NoiseListView* noise_view_wrapper_get_list_view (NoiseViewWrapper* self);
gboolean noise_view_wrapper_get_has_welcome_screen (NoiseViewWrapper* self);
GraniteWidgetsWelcome* noise_view_wrapper_get_welcome_screen (NoiseViewWrapper* self);
gboolean noise_view_wrapper_get_has_embedded_alert (NoiseViewWrapper* self);
GraniteWidgetsAlertView* noise_view_wrapper_get_embedded_alert (NoiseViewWrapper* self);
void noise_view_wrapper_set_active_view (NoiseViewWrapper* self,
                                         NoiseViewWrapperViewType type,
                                         gboolean* successful);
NoiseViewWrapperViewType noise_view_wrapper_get_current_view (NoiseViewWrapper* self);
gboolean noise_view_wrapper_get_is_current_wrapper (NoiseViewWrapper* self);
GType noise_generic_list_get_type (void) G_GNUC_CONST;
GType noise_music_list_view_get_type (void) G_GNUC_CONST;
NoiseMusicListView* noise_list_view_get_list_view (NoiseListView* self);
void noise_generic_list_scroll_to_current_media (NoiseGenericList* self,
                                                 gboolean unfilter_if_not_found);
NoiseViewWrapperHint noise_view_wrapper_get_hint (NoiseViewWrapper* self);
const gchar* noise_view_wrapper_hint_to_string (NoiseViewWrapperHint self);
const gchar* noise_view_wrapper_view_type_to_string (NoiseViewWrapperViewType self);
void noise_view_wrapper_update_library_window_widgets (NoiseViewWrapper* self);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
gboolean noise_library_window_get_initialization_finished (NoiseLibraryWindow* self);
GtkSearchEntry* noise_library_window_get_search_entry (NoiseLibraryWindow* self);
gint noise_view_wrapper_get_media_count (NoiseViewWrapper* self);
GType noise_widgets_view_selector_get_type (void) G_GNUC_CONST;
NoiseWidgetsViewSelector* noise_library_window_get_view_selector (NoiseLibraryWindow* self);
void noise_widgets_view_selector_set_sensitive (NoiseWidgetsViewSelector* self,
                                                gboolean value);
GType noise_column_browser_get_type (void) G_GNUC_CONST;
NoiseColumnBrowser* noise_list_view_get_column_browser (NoiseListView* self);
void noise_widgets_view_selector_set_column_browser_toggle_active (NoiseWidgetsViewSelector* self,
                                                                   gboolean active);
gboolean noise_widgets_view_selector_get_column_browser_toggle_active (NoiseWidgetsViewSelector* self);
GType noise_widgets_view_selector_mode_get_type (void) G_GNUC_CONST;
NoiseWidgetsViewSelectorMode noise_widgets_view_selector_get_selected (NoiseWidgetsViewSelector* self);
void noise_widgets_view_selector_set_selected (NoiseWidgetsViewSelector* self,
                                               NoiseWidgetsViewSelectorMode value);
void noise_view_wrapper_view_selector_changed (NoiseViewWrapper* self);
gboolean noise_widgets_view_selector_get_sensitive (NoiseWidgetsViewSelector* self);
void noise_view_wrapper_play_first_media (NoiseViewWrapper* self,
                                          gboolean* force);
void noise_list_view_set_as_current_list (NoiseListView* self,
                                          gint media_id);
GType noise_playback_manager_get_type (void) G_GNUC_CONST;
NoisePlaybackManager* noise_app_get_player (void);
NoiseMedia* noise_playback_manager_media_from_current_index (NoisePlaybackManager* self,
                                                             gint index_in_current);
void noise_playback_manager_play_media (NoisePlaybackManager* self,
                                        NoiseMedia* m);
void noise_playback_manager_start_playback (NoisePlaybackManager* self);
void noise_view_wrapper_set_as_current_view (NoiseViewWrapper* self);
void noise_view_wrapper_update_visible_media (NoiseViewWrapper* self);
gboolean noise_view_wrapper_check_have_media (NoiseViewWrapper* self);
static void noise_view_wrapper_search_field_changed (NoiseViewWrapper* self);
static gboolean noise_view_wrapper_real_check_have_media (NoiseViewWrapper* self);
void noise_view_wrapper_select_proper_content_view (NoiseViewWrapper* self);
void noise_view_wrapper_set_no_media_alert (NoiseViewWrapper* self);
static void noise_view_wrapper_real_select_proper_content_view (NoiseViewWrapper* self);
GeeCollection* noise_view_wrapper_get_media_list (NoiseViewWrapper* self);
GType noise_view_interface_get_type (void) G_GNUC_CONST;
GeeCollection* noise_view_interface_get_media (NoiseViewInterface* self);
void noise_view_wrapper_clear_filters (NoiseViewWrapper* self);
void noise_view_interface_refilter (NoiseViewInterface* self);
static void noise_view_wrapper_real_set_no_media_alert (NoiseViewWrapper* self);
static void noise_view_wrapper_set_media_async_data_free (gpointer _data);
static void noise_view_wrapper_set_media_async_async_ready_wrapper (GObject *source_object,
                                                             GAsyncResult *res,
                                                             void *user_data);
void noise_view_wrapper_set_media_async (NoiseViewWrapper* self,
                                         GeeCollection* new_media,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
void noise_view_wrapper_set_media_finish (NoiseViewWrapper* self,
                                          GAsyncResult* _res_);
static gboolean noise_view_wrapper_set_media_async_co (NoiseViewWrapperSetMediaAsyncData* _data_);
static void noise_view_wrapper_set_media (NoiseViewWrapper* self,
                                   GeeCollection* new_media);
static void noise_view_wrapper_add_media_async_data_free (gpointer _data);
static void noise_view_wrapper_add_media_async_async_ready_wrapper (GObject *source_object,
                                                             GAsyncResult *res,
                                                             void *user_data);
void noise_view_wrapper_add_media_async (NoiseViewWrapper* self,
                                         GeeCollection* to_add,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
void noise_view_wrapper_add_media_finish (NoiseViewWrapper* self,
                                          GAsyncResult* _res_);
static gboolean noise_view_wrapper_add_media_async_co (NoiseViewWrapperAddMediaAsyncData* _data_);
static void noise_view_wrapper_add_media (NoiseViewWrapper* self,
                                   GeeCollection* new_media);
static void noise_view_wrapper_remove_media_async_data_free (gpointer _data);
static void noise_view_wrapper_remove_media_async_async_ready_wrapper (GObject *source_object,
                                                                GAsyncResult *res,
                                                                void *user_data);
void noise_view_wrapper_remove_media_async (NoiseViewWrapper* self,
                                            GeeCollection* to_remove,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
void noise_view_wrapper_remove_media_finish (NoiseViewWrapper* self,
                                             GAsyncResult* _res_);
static gboolean noise_view_wrapper_remove_media_async_co (NoiseViewWrapperRemoveMediaAsyncData* _data_);
static void noise_view_wrapper_remove_media (NoiseViewWrapper* self,
                                      GeeCollection* media);
static void noise_view_wrapper_update_media_async_data_free (gpointer _data);
static void noise_view_wrapper_update_media_async_async_ready_wrapper (GObject *source_object,
                                                                GAsyncResult *res,
                                                                void *user_data);
void noise_view_wrapper_update_media_async (NoiseViewWrapper* self,
                                            GeeCollection* to_update,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
void noise_view_wrapper_update_media_finish (NoiseViewWrapper* self,
                                             GAsyncResult* _res_);
static gboolean noise_view_wrapper_update_media_async_co (NoiseViewWrapperUpdateMediaAsyncData* _data_);
static void noise_view_wrapper_update_media (NoiseViewWrapper* self,
                                      GeeCollection* media);
void noise_view_interface_set_media (NoiseViewInterface* self,
                                     GeeCollection* new_media);
static void noise_view_wrapper_update_widget_state (NoiseViewWrapper* self);
void noise_view_interface_update_media (NoiseViewInterface* self,
                                        GeeCollection* to_update);
void noise_view_interface_add_media (NoiseViewInterface* self,
                                     GeeCollection* to_add);
void noise_view_interface_remove_media (NoiseViewInterface* self,
                                        GeeCollection* to_remove);
void noise_view_wrapper_set_list_view (NoiseViewWrapper* self,
                                       NoiseListView* value);
void noise_view_wrapper_set_grid_view (NoiseViewWrapper* self,
                                       NoiseAlbumsView* value);
void noise_view_wrapper_set_embedded_alert (NoiseViewWrapper* self,
                                            GraniteWidgetsAlertView* value);
void noise_view_wrapper_set_welcome_screen (NoiseViewWrapper* self,
                                            GraniteWidgetsWelcome* value);
void noise_view_wrapper_set_hint (NoiseViewWrapper* self,
                                  NoiseViewWrapperHint value);
NoiseLibrary* noise_view_wrapper_get_library (NoiseViewWrapper* self);
void noise_view_wrapper_set_library (NoiseViewWrapper* self,
                                     NoiseLibrary* value);
NoiseViewStack* noise_library_window_get_view_stack (NoiseLibraryWindow* self);
NoisePlaylist* noise_view_wrapper_get_playlist (NoiseViewWrapper* self);
void noise_view_wrapper_set_playlist (NoiseViewWrapper* self,
                                      NoisePlaylist* value);
guint noise_list_view_get_n_media (NoiseListView* self);
static GObject * noise_view_wrapper_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
NoiseViewStack* noise_view_stack_new (void);
NoiseViewStack* noise_view_stack_construct (GType object_type);
static void _noise_view_wrapper_view_selector_changed_noise_widgets_view_selector_mode_changed (NoiseWidgetsViewSelector* _sender,
                                                                                         NoiseWidgetsViewSelectorMode new_mode,
                                                                                         gpointer self);
static void _noise_view_wrapper_search_field_changed_noise_library_search_finished (NoiseLibrary* _sender,
                                                                             gpointer self);
static void noise_view_wrapper_finalize (GObject * obj);
static void _vala_noise_view_wrapper_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_noise_view_wrapper_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);


static inline gpointer
noise_view_wrapper_get_instance_private (NoiseViewWrapper* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseViewWrapper_private_offset);
}


GType
noise_view_wrapper_hint_get_type (void)
{
	static volatile gsize noise_view_wrapper_hint_type_id__volatile = 0;
	if (g_once_init_enter (&noise_view_wrapper_hint_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_VIEW_WRAPPER_HINT_NONE, "NOISE_VIEW_WRAPPER_HINT_NONE", "none"}, {NOISE_VIEW_WRAPPER_HINT_MUSIC, "NOISE_VIEW_WRAPPER_HINT_MUSIC", "music"}, {NOISE_VIEW_WRAPPER_HINT_PLAYLIST, "NOISE_VIEW_WRAPPER_HINT_PLAYLIST", "playlist"}, {NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST, "NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST", "read-only-playlist"}, {NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST, "NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST", "smart-playlist"}, {NOISE_VIEW_WRAPPER_HINT_CDROM, "NOISE_VIEW_WRAPPER_HINT_CDROM", "cdrom"}, {NOISE_VIEW_WRAPPER_HINT_DEVICE, "NOISE_VIEW_WRAPPER_HINT_DEVICE", "device"}, {NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO, "NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO", "device-audio"}, {NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST, "NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST", "device-podcast"}, {NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK, "NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK", "device-audiobook"}, {NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE, "NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE", "network-device"}, {NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST, "NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST", "album-list"}, {NOISE_VIEW_WRAPPER_HINT_QUEUE, "NOISE_VIEW_WRAPPER_HINT_QUEUE", "queue"}, {0, NULL, NULL}};
		GType noise_view_wrapper_hint_type_id;
		noise_view_wrapper_hint_type_id = g_enum_register_static ("NoiseViewWrapperHint", values);
		g_once_init_leave (&noise_view_wrapper_hint_type_id__volatile, noise_view_wrapper_hint_type_id);
	}
	return noise_view_wrapper_hint_type_id__volatile;
}


/**
     * Type of visual representation of the media.
     *
     * Values *must* match the index of the respective view in the view selector.
     */
GType
noise_view_wrapper_view_type_get_type (void)
{
	static volatile gsize noise_view_wrapper_view_type_type_id__volatile = 0;
	if (g_once_init_enter (&noise_view_wrapper_view_type_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_VIEW_WRAPPER_VIEW_TYPE_GRID, "NOISE_VIEW_WRAPPER_VIEW_TYPE_GRID", "grid"}, {NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST, "NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST", "list"}, {NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT, "NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT", "alert"}, {NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME, "NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME", "welcome"}, {NOISE_VIEW_WRAPPER_VIEW_TYPE_NONE, "NOISE_VIEW_WRAPPER_VIEW_TYPE_NONE", "none"}, {0, NULL, NULL}};
		GType noise_view_wrapper_view_type_type_id;
		noise_view_wrapper_view_type_type_id = g_enum_register_static ("NoiseViewWrapperViewType", values);
		g_once_init_leave (&noise_view_wrapper_view_type_type_id__volatile, noise_view_wrapper_view_type_type_id);
	}
	return noise_view_wrapper_view_type_type_id__volatile;
}


NoiseViewWrapper*
noise_view_wrapper_construct (GType object_type,
                              NoiseViewWrapperHint hint,
                              NoiseLibrary* library)
{
	NoiseViewWrapper * self = NULL;
	g_return_val_if_fail (library != NULL, NULL);
	self = (NoiseViewWrapper*) g_object_new (object_type, "hint", hint, "library", library, NULL);
	return self;
}


/**
     * Checks which views are available and packs them in (if they are not packed yet)
     */
void
noise_view_wrapper_pack_views (NoiseViewWrapper* self)
{
	NoiseViewStack* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_;
	gboolean _tmp30_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->view_stack;
	_vala_assert (_tmp0_ != NULL, "view_stack != null");
	_tmp2_ = noise_view_wrapper_get_has_grid_view (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		NoiseAlbumsView* _tmp4_;
		GtkContainer* _tmp5_;
		GtkContainer* _tmp6_;
		NoiseViewStack* _tmp7_;
		_tmp4_ = self->priv->_grid_view;
		_tmp5_ = gtk_widget_get_parent ((GtkWidget*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = self->priv->view_stack;
		_tmp1_ = _tmp6_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_container_get_type (), GtkContainer);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		NoiseViewStack* _tmp8_;
		NoiseAlbumsView* _tmp9_;
		_tmp8_ = self->priv->view_stack;
		_tmp9_ = self->priv->_grid_view;
		noise_view_stack_add_view (_tmp8_, (GtkWidget*) _tmp9_);
	}
	_tmp11_ = noise_view_wrapper_get_has_list_view (self);
	_tmp12_ = _tmp11_;
	if (_tmp12_) {
		NoiseListView* _tmp13_;
		GtkContainer* _tmp14_;
		GtkContainer* _tmp15_;
		NoiseViewStack* _tmp16_;
		_tmp13_ = self->priv->_list_view;
		_tmp14_ = gtk_widget_get_parent ((GtkWidget*) _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = self->priv->view_stack;
		_tmp10_ = _tmp15_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_container_get_type (), GtkContainer);
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		NoiseViewStack* _tmp17_;
		NoiseListView* _tmp18_;
		_tmp17_ = self->priv->view_stack;
		_tmp18_ = self->priv->_list_view;
		noise_view_stack_add_view (_tmp17_, (GtkWidget*) _tmp18_);
	}
	_tmp20_ = noise_view_wrapper_get_has_welcome_screen (self);
	_tmp21_ = _tmp20_;
	if (_tmp21_) {
		GraniteWidgetsWelcome* _tmp22_;
		GtkContainer* _tmp23_;
		GtkContainer* _tmp24_;
		NoiseViewStack* _tmp25_;
		_tmp22_ = self->priv->_welcome_screen;
		_tmp23_ = gtk_widget_get_parent ((GtkWidget*) _tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = self->priv->view_stack;
		_tmp19_ = _tmp24_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_container_get_type (), GtkContainer);
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		NoiseViewStack* _tmp26_;
		GraniteWidgetsWelcome* _tmp27_;
		_tmp26_ = self->priv->view_stack;
		_tmp27_ = self->priv->_welcome_screen;
		noise_view_stack_add_view (_tmp26_, (GtkWidget*) _tmp27_);
	}
	_tmp29_ = noise_view_wrapper_get_has_embedded_alert (self);
	_tmp30_ = _tmp29_;
	if (_tmp30_) {
		GraniteWidgetsAlertView* _tmp31_;
		GtkContainer* _tmp32_;
		GtkContainer* _tmp33_;
		NoiseViewStack* _tmp34_;
		_tmp31_ = self->priv->_embedded_alert;
		_tmp32_ = gtk_widget_get_parent ((GtkWidget*) _tmp31_);
		_tmp33_ = _tmp32_;
		_tmp34_ = self->priv->view_stack;
		_tmp28_ = _tmp33_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, gtk_container_get_type (), GtkContainer);
	} else {
		_tmp28_ = FALSE;
	}
	if (_tmp28_) {
		NoiseViewStack* _tmp35_;
		GraniteWidgetsAlertView* _tmp36_;
		_tmp35_ = self->priv->view_stack;
		_tmp36_ = self->priv->_embedded_alert;
		noise_view_stack_add_view (_tmp35_, (GtkWidget*) _tmp36_);
	}
	self->priv->widgets_ready = TRUE;
	gtk_widget_show_all ((GtkWidget*) self);
}


/**
     * Convenient visibility method
     */
void
noise_view_wrapper_set_active_view (NoiseViewWrapper* self,
                                    NoiseViewWrapperViewType type,
                                    gboolean* successful)
{
	gboolean _vala_successful = FALSE;
	gboolean _tmp0_ = FALSE;
	NoiseViewWrapperViewType _tmp1_;
	NoiseViewWrapperViewType _tmp2_;
	gboolean _tmp27_;
	g_return_if_fail (self != NULL);
	_vala_successful = TRUE;
	_tmp1_ = noise_view_wrapper_get_current_view (self);
	_tmp2_ = _tmp1_;
	if (type == _tmp2_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp3_ = noise_view_wrapper_get_is_current_wrapper (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = !_tmp4_;
	}
	if (_tmp0_) {
		if (successful) {
			*successful = _vala_successful;
		}
		return;
	}
	switch (type) {
		case NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST:
		{
			gboolean _tmp5_;
			gboolean _tmp6_;
			_tmp5_ = noise_view_wrapper_get_has_list_view (self);
			_tmp6_ = _tmp5_;
			if (_tmp6_) {
				NoiseViewStack* _tmp7_;
				NoiseListView* _tmp8_;
				NoiseListView* _tmp9_;
				NoiseMusicListView* _tmp10_;
				NoiseMusicListView* _tmp11_;
				_tmp7_ = self->priv->view_stack;
				_tmp8_ = self->priv->_list_view;
				gtk_stack_set_visible_child ((GtkStack*) _tmp7_, (GtkWidget*) _tmp8_);
				_tmp9_ = self->priv->_list_view;
				_tmp10_ = noise_list_view_get_list_view (_tmp9_);
				_tmp11_ = _tmp10_;
				noise_generic_list_scroll_to_current_media ((NoiseGenericList*) _tmp11_, TRUE);
			} else {
				_vala_successful = FALSE;
			}
			break;
		}
		case NOISE_VIEW_WRAPPER_VIEW_TYPE_GRID:
		{
			gboolean _tmp12_;
			gboolean _tmp13_;
			_tmp12_ = noise_view_wrapper_get_has_grid_view (self);
			_tmp13_ = _tmp12_;
			if (_tmp13_) {
				NoiseViewStack* _tmp14_;
				NoiseAlbumsView* _tmp15_;
				_tmp14_ = self->priv->view_stack;
				_tmp15_ = self->priv->_grid_view;
				gtk_stack_set_visible_child ((GtkStack*) _tmp14_, (GtkWidget*) _tmp15_);
			} else {
				gboolean _tmp16_;
				gboolean _tmp17_;
				_tmp16_ = noise_view_wrapper_get_has_list_view (self);
				_tmp17_ = _tmp16_;
				if (_tmp17_) {
					NoiseViewStack* _tmp18_;
					NoiseListView* _tmp19_;
					NoiseListView* _tmp20_;
					NoiseMusicListView* _tmp21_;
					NoiseMusicListView* _tmp22_;
					_tmp18_ = self->priv->view_stack;
					_tmp19_ = self->priv->_list_view;
					gtk_stack_set_visible_child ((GtkStack*) _tmp18_, (GtkWidget*) _tmp19_);
					_tmp20_ = self->priv->_list_view;
					_tmp21_ = noise_list_view_get_list_view (_tmp20_);
					_tmp22_ = _tmp21_;
					noise_generic_list_scroll_to_current_media ((NoiseGenericList*) _tmp22_, TRUE);
				}
				_vala_successful = FALSE;
			}
			break;
		}
		case NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT:
		{
			NoiseViewStack* _tmp23_;
			GraniteWidgetsAlertView* _tmp24_;
			_tmp23_ = self->priv->view_stack;
			_tmp24_ = self->priv->_embedded_alert;
			gtk_stack_set_visible_child ((GtkStack*) _tmp23_, (GtkWidget*) _tmp24_);
			break;
		}
		case NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME:
		{
			NoiseViewStack* _tmp25_;
			GraniteWidgetsWelcome* _tmp26_;
			_tmp25_ = self->priv->view_stack;
			_tmp26_ = self->priv->_welcome_screen;
			gtk_stack_set_visible_child ((GtkStack*) _tmp25_, (GtkWidget*) _tmp26_);
			break;
		}
		default:
		break;
	}
	_tmp27_ = _vala_successful;
	if (!_tmp27_) {
		NoiseViewWrapperHint _tmp28_;
		GEnumValue* _tmp29_;
		GEnumValue* _tmp30_;
		_tmp28_ = self->priv->_hint;
		_tmp29_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp28_);
		_tmp30_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_VIEW_TYPE), type);
		g_debug ("ViewWrapper.vala:208: %s : VIEW %s was not available", (_tmp29_ != NULL) ? _tmp29_->value_name : NULL, (_tmp30_ != NULL) ? _tmp30_->value_name : NULL);
		if (successful) {
			*successful = _vala_successful;
		}
		return;
	}
	self->priv->last_used_view = type;
	noise_view_wrapper_update_library_window_widgets (self);
	if (successful) {
		*successful = _vala_successful;
	}
}


/**
     * This method ensures that the view switcher and search box are sensitive/insensitive
     * when they have to. It also selects the proper view switcher item based on the
     * current view.
     */
void
noise_view_wrapper_update_library_window_widgets (NoiseViewWrapper* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	NoiseViewWrapperHint _tmp10_;
	GEnumValue* _tmp11_;
	NoiseLibraryWindow* _tmp12_;
	NoiseLibraryWindow* _tmp13_;
	GtkSearchEntry* _tmp14_;
	GtkSearchEntry* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_;
	gboolean _tmp22_;
	NoiseLibraryWindow* _tmp29_;
	NoiseLibraryWindow* _tmp30_;
	NoiseWidgetsViewSelector* _tmp31_;
	NoiseWidgetsViewSelector* _tmp32_;
	gboolean _tmp33_ = FALSE;
	NoiseListView* _tmp34_;
	NoiseColumnBrowser* _tmp35_;
	NoiseColumnBrowser* _tmp36_;
	NoiseLibraryWindow* _tmp42_;
	NoiseLibraryWindow* _tmp43_;
	NoiseWidgetsViewSelector* _tmp44_;
	NoiseWidgetsViewSelector* _tmp45_;
	NoiseLibraryWindow* _tmp46_;
	NoiseLibraryWindow* _tmp47_;
	NoiseWidgetsViewSelector* _tmp48_;
	NoiseWidgetsViewSelector* _tmp49_;
	g_return_if_fail (self != NULL);
	_tmp2_ = noise_view_wrapper_get_is_current_wrapper (self);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp4_ = noise_view_wrapper_get_has_list_view (self);
		_tmp5_ = _tmp4_;
		_tmp1_ = !_tmp5_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		NoiseLibraryWindow* _tmp6_;
		NoiseLibraryWindow* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		_tmp6_ = noise_app_get_main_window ();
		_tmp7_ = _tmp6_;
		_tmp8_ = noise_library_window_get_initialization_finished (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp0_ = !_tmp9_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp10_ = self->priv->_hint;
	_tmp11_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp10_);
	g_debug ("ViewWrapper.vala:227: update_library_window_widgets [%s]", (_tmp11_ != NULL) ? _tmp11_->value_name : NULL);
	_tmp12_ = noise_app_get_main_window ();
	_tmp13_ = _tmp12_;
	_tmp14_ = noise_library_window_get_search_entry (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = noise_view_wrapper_get_media_count (self);
	_tmp17_ = _tmp16_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, _tmp17_ > 0);
	_tmp21_ = noise_view_wrapper_get_has_grid_view (self);
	_tmp22_ = _tmp21_;
	if (_tmp22_) {
		gboolean _tmp23_;
		gboolean _tmp24_;
		_tmp23_ = noise_view_wrapper_get_has_list_view (self);
		_tmp24_ = _tmp23_;
		_tmp20_ = _tmp24_;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		NoiseViewWrapperViewType _tmp25_;
		NoiseViewWrapperViewType _tmp26_;
		_tmp25_ = noise_view_wrapper_get_current_view (self);
		_tmp26_ = _tmp25_;
		_tmp19_ = _tmp26_ != NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME;
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		NoiseViewWrapperViewType _tmp27_;
		NoiseViewWrapperViewType _tmp28_;
		_tmp27_ = noise_view_wrapper_get_current_view (self);
		_tmp28_ = _tmp27_;
		_tmp18_ = _tmp28_ != NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT;
	} else {
		_tmp18_ = FALSE;
	}
	_tmp29_ = noise_app_get_main_window ();
	_tmp30_ = _tmp29_;
	_tmp31_ = noise_library_window_get_view_selector (_tmp30_);
	_tmp32_ = _tmp31_;
	noise_widgets_view_selector_set_sensitive (_tmp32_, _tmp18_);
	_tmp34_ = self->priv->_list_view;
	_tmp35_ = noise_list_view_get_column_browser (_tmp34_);
	_tmp36_ = _tmp35_;
	if (_tmp36_ != NULL) {
		NoiseListView* _tmp37_;
		NoiseColumnBrowser* _tmp38_;
		NoiseColumnBrowser* _tmp39_;
		gboolean _tmp40_;
		gboolean _tmp41_;
		_tmp37_ = self->priv->_list_view;
		_tmp38_ = noise_list_view_get_column_browser (_tmp37_);
		_tmp39_ = _tmp38_;
		_tmp40_ = gtk_widget_get_visible ((GtkWidget*) _tmp39_);
		_tmp41_ = _tmp40_;
		_tmp33_ = _tmp41_;
	} else {
		_tmp33_ = FALSE;
	}
	_tmp42_ = noise_app_get_main_window ();
	_tmp43_ = _tmp42_;
	_tmp44_ = noise_library_window_get_view_selector (_tmp43_);
	_tmp45_ = _tmp44_;
	noise_widgets_view_selector_set_column_browser_toggle_active (_tmp45_, _tmp33_);
	_tmp46_ = noise_app_get_main_window ();
	_tmp47_ = _tmp46_;
	_tmp48_ = noise_library_window_get_view_selector (_tmp47_);
	_tmp49_ = _tmp48_;
	if (!noise_widgets_view_selector_get_column_browser_toggle_active (_tmp49_)) {
		gboolean _tmp50_ = FALSE;
		NoiseLibraryWindow* _tmp51_;
		NoiseLibraryWindow* _tmp52_;
		NoiseWidgetsViewSelector* _tmp53_;
		NoiseWidgetsViewSelector* _tmp54_;
		NoiseWidgetsViewSelectorMode _tmp55_;
		NoiseWidgetsViewSelectorMode _tmp56_;
		NoiseViewWrapperViewType _tmp57_;
		_tmp51_ = noise_app_get_main_window ();
		_tmp52_ = _tmp51_;
		_tmp53_ = noise_library_window_get_view_selector (_tmp52_);
		_tmp54_ = _tmp53_;
		_tmp55_ = noise_widgets_view_selector_get_selected (_tmp54_);
		_tmp56_ = _tmp55_;
		_tmp57_ = self->priv->last_used_view;
		if (_tmp56_ != ((gint) _tmp57_)) {
			NoiseViewWrapperViewType _tmp58_;
			_tmp58_ = self->priv->last_used_view;
			_tmp50_ = ((gint) _tmp58_) <= 1;
		} else {
			_tmp50_ = FALSE;
		}
		if (_tmp50_) {
			NoiseLibraryWindow* _tmp59_;
			NoiseLibraryWindow* _tmp60_;
			NoiseWidgetsViewSelector* _tmp61_;
			NoiseWidgetsViewSelector* _tmp62_;
			NoiseViewWrapperViewType _tmp63_;
			_tmp59_ = noise_app_get_main_window ();
			_tmp60_ = _tmp59_;
			_tmp61_ = noise_library_window_get_view_selector (_tmp60_);
			_tmp62_ = _tmp61_;
			_tmp63_ = self->priv->last_used_view;
			noise_widgets_view_selector_set_selected (_tmp62_, (NoiseWidgetsViewSelectorMode) _tmp63_);
		}
	}
}


void
noise_view_wrapper_view_selector_changed (NoiseViewWrapper* self)
{
	gboolean _tmp0_ = FALSE;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	NoiseViewWrapperViewType _tmp13_;
	NoiseViewWrapperViewType _tmp14_;
	NoiseViewWrapperHint _tmp19_;
	GEnumValue* _tmp20_;
	NoiseViewWrapperViewType selected_view = 0;
	NoiseLibraryWindow* _tmp21_;
	NoiseLibraryWindow* _tmp22_;
	NoiseWidgetsViewSelector* _tmp23_;
	NoiseWidgetsViewSelector* _tmp24_;
	NoiseWidgetsViewSelectorMode _tmp25_;
	NoiseWidgetsViewSelectorMode _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	g_return_if_fail (self != NULL);
	_tmp1_ = noise_app_get_main_window ();
	_tmp2_ = _tmp1_;
	_tmp3_ = noise_library_window_get_initialization_finished (_tmp2_);
	_tmp4_ = _tmp3_;
	if (!_tmp4_) {
		_tmp0_ = TRUE;
	} else {
		NoiseLibraryWindow* _tmp5_;
		NoiseLibraryWindow* _tmp6_;
		NoiseWidgetsViewSelector* _tmp7_;
		NoiseWidgetsViewSelector* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
		_tmp5_ = noise_app_get_main_window ();
		_tmp6_ = _tmp5_;
		_tmp7_ = noise_library_window_get_view_selector (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = noise_widgets_view_selector_get_sensitive (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp0_ = !_tmp10_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp13_ = noise_view_wrapper_get_current_view (self);
	_tmp14_ = _tmp13_;
	if (_tmp14_ == NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT) {
		gint _tmp15_;
		gint _tmp16_;
		_tmp15_ = noise_view_wrapper_get_media_count (self);
		_tmp16_ = _tmp15_;
		_tmp12_ = _tmp16_ < 1;
	} else {
		_tmp12_ = FALSE;
	}
	if (_tmp12_) {
		_tmp11_ = TRUE;
	} else {
		NoiseViewWrapperViewType _tmp17_;
		NoiseViewWrapperViewType _tmp18_;
		_tmp17_ = noise_view_wrapper_get_current_view (self);
		_tmp18_ = _tmp17_;
		_tmp11_ = _tmp18_ == NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME;
	}
	if (_tmp11_) {
		return;
	}
	_tmp19_ = self->priv->_hint;
	_tmp20_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp19_);
	g_debug ("ViewWrapper.vala:264: view_selector_changed [%s]", (_tmp20_ != NULL) ? _tmp20_->value_name : NULL);
	_tmp21_ = noise_app_get_main_window ();
	_tmp22_ = _tmp21_;
	_tmp23_ = noise_library_window_get_view_selector (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = noise_widgets_view_selector_get_selected (_tmp24_);
	_tmp26_ = _tmp25_;
	selected_view = (NoiseViewWrapperViewType) _tmp26_;
	_tmp27_ = noise_view_wrapper_get_is_current_wrapper (self);
	_tmp28_ = _tmp27_;
	if (_tmp28_) {
		NoiseViewWrapperViewType _tmp29_;
		_tmp29_ = selected_view;
		noise_view_wrapper_set_active_view (self, _tmp29_, NULL);
	} else {
		NoiseViewWrapperViewType _tmp30_;
		_tmp30_ = selected_view;
		self->priv->last_used_view = _tmp30_;
	}
}


void
noise_view_wrapper_play_first_media (NoiseViewWrapper* self,
                                     gboolean* force)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	NoiseViewWrapperHint _tmp2_;
	GEnumValue* _tmp3_;
	NoiseListView* _tmp4_;
	NoiseMedia* m = NULL;
	NoisePlaybackManager* _tmp5_;
	NoisePlaybackManager* _tmp6_;
	NoiseMedia* _tmp7_;
	NoiseMedia* _tmp8_;
	NoisePlaybackManager* _tmp9_;
	NoisePlaybackManager* _tmp10_;
	NoiseMedia* _tmp11_;
	NoisePlaybackManager* _tmp12_;
	NoisePlaybackManager* _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = noise_view_wrapper_get_has_list_view (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	_tmp2_ = self->priv->_hint;
	_tmp3_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp2_);
	g_debug ("ViewWrapper.vala:278: play_first_media [%s]", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL);
	_tmp4_ = self->priv->_list_view;
	noise_list_view_set_as_current_list (_tmp4_, 1);
	_tmp5_ = noise_app_get_player ();
	_tmp6_ = _tmp5_;
	_tmp7_ = noise_playback_manager_media_from_current_index (_tmp6_, 0);
	m = _tmp7_;
	_tmp8_ = m;
	if (_tmp8_ == NULL) {
		_g_object_unref0 (m);
		return;
	}
	_tmp9_ = noise_app_get_player ();
	_tmp10_ = _tmp9_;
	_tmp11_ = m;
	noise_playback_manager_play_media (_tmp10_, _tmp11_);
	_tmp12_ = noise_app_get_player ();
	_tmp13_ = _tmp12_;
	noise_playback_manager_start_playback (_tmp13_);
	_g_object_unref0 (m);
}


/**
     * This handles updating all the shared stuff outside the view area.
     *
     * You should only call this method on the respective ViewWrapper whenever the sidebar's
     * selected view changes.
     *
     * Note: The sidebar-item selection and other stuff is handled automatically by the LibraryWindow
     *       by request of SideTreeView. See LibraryWindow :: set_active_view() for more details.
     */
void
noise_view_wrapper_set_as_current_view (NoiseViewWrapper* self)
{
	NoiseLibraryWindow* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	NoiseViewWrapperHint _tmp4_;
	GEnumValue* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = noise_app_get_main_window ();
	_tmp1_ = _tmp0_;
	_tmp2_ = noise_library_window_get_initialization_finished (_tmp1_);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		return;
	}
	_tmp4_ = self->priv->_hint;
	_tmp5_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp4_);
	g_debug ("ViewWrapper.vala:301: SETTING AS CURRENT VIEW [%s]", (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
	noise_view_wrapper_update_visible_media (self);
	noise_view_wrapper_check_have_media (self);
	noise_view_wrapper_update_library_window_widgets (self);
}


static void
noise_view_wrapper_search_field_changed (NoiseViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = noise_view_wrapper_get_is_current_wrapper (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	noise_view_wrapper_update_visible_media (self);
}


static gboolean
noise_view_wrapper_real_check_have_media (NoiseViewWrapper* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean have_media = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_;
	_tmp0_ = self->priv->data_initialized;
	if (!_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp1_ = noise_view_wrapper_get_media_count (self);
	_tmp2_ = _tmp1_;
	have_media = _tmp2_ > 0;
	_tmp3_ = have_media;
	if (_tmp3_) {
		noise_view_wrapper_select_proper_content_view (self);
	} else {
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp4_ = noise_view_wrapper_get_has_welcome_screen (self);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			noise_view_wrapper_set_active_view (self, NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME, NULL);
		} else {
			gboolean _tmp6_;
			gboolean _tmp7_;
			_tmp6_ = noise_view_wrapper_get_has_embedded_alert (self);
			_tmp7_ = _tmp6_;
			if (_tmp7_) {
				noise_view_wrapper_set_no_media_alert (self);
				noise_view_wrapper_set_active_view (self, NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT, NULL);
			}
		}
	}
	result = have_media;
	return result;
}


gboolean
noise_view_wrapper_check_have_media (NoiseViewWrapper* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return NOISE_VIEW_WRAPPER_GET_CLASS (self)->check_have_media (self);
}


static void
noise_view_wrapper_real_select_proper_content_view (NoiseViewWrapper* self)
{
	NoiseViewWrapperViewType new_view = 0;
	NoiseLibraryWindow* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseWidgetsViewSelector* _tmp2_;
	NoiseWidgetsViewSelector* _tmp3_;
	NoiseWidgetsViewSelectorMode _tmp4_;
	NoiseWidgetsViewSelectorMode _tmp5_;
	static const gint N_VIEWS = 2;
	gboolean _tmp6_ = FALSE;
	NoiseViewWrapperViewType _tmp7_;
	gboolean _tmp9_ = FALSE;
	NoiseViewWrapperViewType _tmp10_;
	_tmp0_ = noise_app_get_main_window ();
	_tmp1_ = _tmp0_;
	_tmp2_ = noise_library_window_get_view_selector (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = noise_widgets_view_selector_get_selected (_tmp3_);
	_tmp5_ = _tmp4_;
	new_view = (NoiseViewWrapperViewType) _tmp5_;
	_tmp7_ = new_view;
	if (_tmp7_ < 0) {
		_tmp6_ = TRUE;
	} else {
		NoiseViewWrapperViewType _tmp8_;
		_tmp8_ = new_view;
		_tmp6_ = _tmp8_ > (N_VIEWS - 1);
	}
	if (_tmp6_) {
		new_view = NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST;
	}
	_tmp10_ = new_view;
	if (_tmp10_ == NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST) {
		gboolean _tmp11_;
		gboolean _tmp12_;
		_tmp11_ = noise_view_wrapper_get_has_list_view (self);
		_tmp12_ = _tmp11_;
		_tmp9_ = _tmp12_;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		noise_view_wrapper_set_active_view (self, NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST, NULL);
	} else {
		gboolean _tmp13_ = FALSE;
		NoiseViewWrapperViewType _tmp14_;
		_tmp14_ = new_view;
		if (_tmp14_ == NOISE_VIEW_WRAPPER_VIEW_TYPE_GRID) {
			gboolean _tmp15_;
			gboolean _tmp16_;
			_tmp15_ = noise_view_wrapper_get_has_grid_view (self);
			_tmp16_ = _tmp15_;
			_tmp13_ = _tmp16_;
		} else {
			_tmp13_ = FALSE;
		}
		if (_tmp13_) {
			noise_view_wrapper_set_active_view (self, NOISE_VIEW_WRAPPER_VIEW_TYPE_GRID, NULL);
		} else {
			gboolean _tmp17_;
			gboolean _tmp18_;
			_tmp17_ = noise_view_wrapper_get_has_list_view (self);
			_tmp18_ = _tmp17_;
			if (_tmp18_) {
				NoiseViewStack* _tmp19_;
				NoiseListView* _tmp20_;
				NoiseListView* _tmp21_;
				NoiseMusicListView* _tmp22_;
				NoiseMusicListView* _tmp23_;
				_tmp19_ = self->priv->view_stack;
				_tmp20_ = self->priv->_list_view;
				gtk_stack_set_visible_child ((GtkStack*) _tmp19_, (GtkWidget*) _tmp20_);
				_tmp21_ = self->priv->_list_view;
				_tmp22_ = noise_list_view_get_list_view (_tmp21_);
				_tmp23_ = _tmp22_;
				noise_generic_list_scroll_to_current_media ((NoiseGenericList*) _tmp23_, TRUE);
			} else {
				gboolean _tmp24_;
				gboolean _tmp25_;
				_tmp24_ = noise_view_wrapper_get_has_grid_view (self);
				_tmp25_ = _tmp24_;
				if (_tmp25_) {
					NoiseViewStack* _tmp26_;
					NoiseAlbumsView* _tmp27_;
					_tmp26_ = self->priv->view_stack;
					_tmp27_ = self->priv->_grid_view;
					gtk_stack_set_visible_child ((GtkStack*) _tmp26_, (GtkWidget*) _tmp27_);
				}
			}
		}
	}
}


void
noise_view_wrapper_select_proper_content_view (NoiseViewWrapper* self)
{
	g_return_if_fail (self != NULL);
	NOISE_VIEW_WRAPPER_GET_CLASS (self)->select_proper_content_view (self);
}


/**
     * @return A collection containing ALL the media associated to this view.
     */
GeeCollection*
noise_view_wrapper_get_media_list (NoiseViewWrapper* self)
{
	GeeCollection* result = NULL;
	NoiseListView* _tmp0_;
	GeeCollection* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_list_view;
	_tmp1_ = noise_view_interface_get_media ((NoiseViewInterface*) _tmp0_);
	result = _tmp1_;
	return result;
}


/**
     * Resets all the filters (external and internal) applied to a view inside
     * the view wrapper. It should only be called if the view is the current active
     * wrapper.
     */
void
noise_view_wrapper_clear_filters (NoiseViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = noise_view_wrapper_get_is_current_wrapper (self);
	_tmp1_ = _tmp0_;
	_vala_return_if_fail (_tmp1_, "is_current_wrapper");
	noise_view_wrapper_update_visible_media (self);
}


/**
     * Updates the data in visible_media and re-populates all the views.
     * Primarily used for searches
     */
void
noise_view_wrapper_update_visible_media (NoiseViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	NoiseViewWrapperHint _tmp2_;
	GEnumValue* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = noise_view_wrapper_get_is_current_wrapper (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	_tmp2_ = self->priv->_hint;
	_tmp3_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp2_);
	g_debug ("ViewWrapper.vala:402: UPDATING VISIBLE MEDIA [%s]", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL);
	_tmp4_ = noise_view_wrapper_get_has_list_view (self);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		{
			NoiseListView* _tmp6_;
			_tmp6_ = self->priv->_list_view;
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrapperlist_view);
			{
				NoiseListView* _tmp7_;
				_tmp7_ = self->priv->_list_view;
				noise_view_interface_refilter ((NoiseViewInterface*) _tmp7_);
			}
			__finally93:
			{
				NoiseListView* _tmp8_;
				_tmp8_ = self->priv->_list_view;
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrapperlist_view);
			}
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_tmp9_ = noise_view_wrapper_get_has_grid_view (self);
	_tmp10_ = _tmp9_;
	if (_tmp10_) {
		{
			NoiseAlbumsView* _tmp11_;
			_tmp11_ = self->priv->_grid_view;
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrappergrid_view);
			{
				NoiseAlbumsView* _tmp12_;
				_tmp12_ = self->priv->_grid_view;
				noise_view_interface_refilter ((NoiseViewInterface*) _tmp12_);
			}
			__finally94:
			{
				NoiseAlbumsView* _tmp13_;
				_tmp13_ = self->priv->_grid_view;
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrappergrid_view);
			}
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
}


static void
noise_view_wrapper_real_set_no_media_alert (NoiseViewWrapper* self)
{
	GraniteWidgetsAlertView* _tmp0_;
	GraniteWidgetsAlertView* _tmp1_;
	_tmp0_ = self->priv->_embedded_alert;
	granite_widgets_alert_view_set_icon_name (_tmp0_, "dialog-information");
	_tmp1_ = self->priv->_embedded_alert;
	granite_widgets_alert_view_set_title (_tmp1_, _ ("No media"));
}


void
noise_view_wrapper_set_no_media_alert (NoiseViewWrapper* self)
{
	g_return_if_fail (self != NULL);
	NOISE_VIEW_WRAPPER_GET_CLASS (self)->set_no_media_alert (self);
}


static void
noise_view_wrapper_set_media_async_data_free (gpointer _data)
{
	NoiseViewWrapperSetMediaAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->new_media);
	_g_object_unref0 (_data_->self);
	g_slice_free (NoiseViewWrapperSetMediaAsyncData, _data_);
}


static void
noise_view_wrapper_set_media_async_async_ready_wrapper (GObject *source_object,
                                                        GAsyncResult *res,
                                                        void *user_data)
{
	NoiseViewWrapperSetMediaAsyncData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void
noise_view_wrapper_set_media_async (NoiseViewWrapper* self,
                                    GeeCollection* new_media,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	NoiseViewWrapperSetMediaAsyncData* _data_;
	NoiseViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
	_data_ = g_slice_new0 (NoiseViewWrapperSetMediaAsyncData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, noise_view_wrapper_set_media_async_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, noise_view_wrapper_set_media_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (new_media);
	_g_object_unref0 (_data_->new_media);
	_data_->new_media = _tmp1_;
	noise_view_wrapper_set_media_async_co (_data_);
}


void
noise_view_wrapper_set_media_finish (NoiseViewWrapper* self,
                                     GAsyncResult* _res_)
{
	NoiseViewWrapperSetMediaAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


static gboolean
noise_view_wrapper_set_media_async_co (NoiseViewWrapperSetMediaAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->widgets_ready;
	if (!_data_->_tmp0_) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (_data_->_task_complete_ != TRUE) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	noise_view_wrapper_set_media (_data_->self, _data_->new_media);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (_data_->_task_complete_ != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void
noise_view_wrapper_add_media_async_data_free (gpointer _data)
{
	NoiseViewWrapperAddMediaAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->to_add);
	_g_object_unref0 (_data_->self);
	g_slice_free (NoiseViewWrapperAddMediaAsyncData, _data_);
}


static void
noise_view_wrapper_add_media_async_async_ready_wrapper (GObject *source_object,
                                                        GAsyncResult *res,
                                                        void *user_data)
{
	NoiseViewWrapperAddMediaAsyncData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}


void
noise_view_wrapper_add_media_async (NoiseViewWrapper* self,
                                    GeeCollection* to_add,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	NoiseViewWrapperAddMediaAsyncData* _data_;
	NoiseViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
	_data_ = g_slice_new0 (NoiseViewWrapperAddMediaAsyncData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, noise_view_wrapper_add_media_async_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, noise_view_wrapper_add_media_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (to_add);
	_g_object_unref0 (_data_->to_add);
	_data_->to_add = _tmp1_;
	noise_view_wrapper_add_media_async_co (_data_);
}


void
noise_view_wrapper_add_media_finish (NoiseViewWrapper* self,
                                     GAsyncResult* _res_)
{
	NoiseViewWrapperAddMediaAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


static gboolean
noise_view_wrapper_add_media_async_co (NoiseViewWrapperAddMediaAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->widgets_ready;
	if (!_data_->_tmp0_) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (_data_->_task_complete_ != TRUE) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	noise_view_wrapper_add_media (_data_->self, _data_->to_add);
	noise_view_wrapper_update_visible_media (_data_->self);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (_data_->_task_complete_ != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void
noise_view_wrapper_remove_media_async_data_free (gpointer _data)
{
	NoiseViewWrapperRemoveMediaAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->to_remove);
	_g_object_unref0 (_data_->self);
	g_slice_free (NoiseViewWrapperRemoveMediaAsyncData, _data_);
}


static void
noise_view_wrapper_remove_media_async_async_ready_wrapper (GObject *source_object,
                                                           GAsyncResult *res,
                                                           void *user_data)
{
	NoiseViewWrapperRemoveMediaAsyncData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}


void
noise_view_wrapper_remove_media_async (NoiseViewWrapper* self,
                                       GeeCollection* to_remove,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	NoiseViewWrapperRemoveMediaAsyncData* _data_;
	NoiseViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
	_data_ = g_slice_new0 (NoiseViewWrapperRemoveMediaAsyncData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, noise_view_wrapper_remove_media_async_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, noise_view_wrapper_remove_media_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (to_remove);
	_g_object_unref0 (_data_->to_remove);
	_data_->to_remove = _tmp1_;
	noise_view_wrapper_remove_media_async_co (_data_);
}


void
noise_view_wrapper_remove_media_finish (NoiseViewWrapper* self,
                                        GAsyncResult* _res_)
{
	NoiseViewWrapperRemoveMediaAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


static gboolean
noise_view_wrapper_remove_media_async_co (NoiseViewWrapperRemoveMediaAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->widgets_ready;
	if (!_data_->_tmp0_) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (_data_->_task_complete_ != TRUE) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	noise_view_wrapper_remove_media (_data_->self, _data_->to_remove);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (_data_->_task_complete_ != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void
noise_view_wrapper_update_media_async_data_free (gpointer _data)
{
	NoiseViewWrapperUpdateMediaAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->to_update);
	_g_object_unref0 (_data_->self);
	g_slice_free (NoiseViewWrapperUpdateMediaAsyncData, _data_);
}


static void
noise_view_wrapper_update_media_async_async_ready_wrapper (GObject *source_object,
                                                           GAsyncResult *res,
                                                           void *user_data)
{
	NoiseViewWrapperUpdateMediaAsyncData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}


void
noise_view_wrapper_update_media_async (NoiseViewWrapper* self,
                                       GeeCollection* to_update,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	NoiseViewWrapperUpdateMediaAsyncData* _data_;
	NoiseViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
	_data_ = g_slice_new0 (NoiseViewWrapperUpdateMediaAsyncData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, noise_view_wrapper_update_media_async_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, noise_view_wrapper_update_media_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (to_update);
	_g_object_unref0 (_data_->to_update);
	_data_->to_update = _tmp1_;
	noise_view_wrapper_update_media_async_co (_data_);
}


void
noise_view_wrapper_update_media_finish (NoiseViewWrapper* self,
                                        GAsyncResult* _res_)
{
	NoiseViewWrapperUpdateMediaAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


static gboolean
noise_view_wrapper_update_media_async_co (NoiseViewWrapperUpdateMediaAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->widgets_ready;
	if (!_data_->_tmp0_) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (_data_->_task_complete_ != TRUE) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	noise_view_wrapper_update_media (_data_->self, _data_->to_update);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (_data_->_task_complete_ != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void
noise_view_wrapper_set_media (NoiseViewWrapper* self,
                              GeeCollection* new_media)
{
	NoiseViewWrapperHint _tmp0_;
	GEnumValue* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (new_media != NULL);
	_tmp0_ = self->priv->_hint;
	_tmp1_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp0_);
	g_debug ("ViewWrapper.vala:448: SETTING MEDIA [%s]", (_tmp1_ != NULL) ? _tmp1_->value_name : NULL);
	_tmp2_ = noise_view_wrapper_get_has_list_view (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		{
			NoiseListView* _tmp4_;
			_tmp4_ = self->priv->_list_view;
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrapperlist_view);
			{
				NoiseListView* _tmp5_;
				_tmp5_ = self->priv->_list_view;
				noise_view_interface_set_media ((NoiseViewInterface*) _tmp5_, new_media);
			}
			__finally95:
			{
				NoiseListView* _tmp6_;
				_tmp6_ = self->priv->_list_view;
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrapperlist_view);
			}
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_tmp7_ = noise_view_wrapper_get_has_grid_view (self);
	_tmp8_ = _tmp7_;
	if (_tmp8_) {
		{
			NoiseAlbumsView* _tmp9_;
			_tmp9_ = self->priv->_grid_view;
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrappergrid_view);
			{
				NoiseAlbumsView* _tmp10_;
				_tmp10_ = self->priv->_grid_view;
				noise_view_interface_set_media ((NoiseViewInterface*) _tmp10_, new_media);
			}
			__finally96:
			{
				NoiseAlbumsView* _tmp11_;
				_tmp11_ = self->priv->_grid_view;
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrappergrid_view);
			}
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	self->priv->data_initialized = TRUE;
	noise_view_wrapper_update_visible_media (self);
	noise_view_wrapper_update_widget_state (self);
}


static void
noise_view_wrapper_update_media (NoiseViewWrapper* self,
                                 GeeCollection* media)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	NoiseViewWrapperHint _tmp3_;
	GEnumValue* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (media != NULL);
	_tmp0_ = self->priv->data_initialized;
	_vala_return_if_fail (_tmp0_, "data_initialized");
	_tmp1_ = gee_collection_get_is_empty (media);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		return;
	}
	_tmp3_ = self->priv->_hint;
	_tmp4_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp3_);
	g_debug ("ViewWrapper.vala:472: UPDATING MEDIA [%s]", (_tmp4_ != NULL) ? _tmp4_->value_name : NULL);
	_tmp5_ = noise_view_wrapper_get_has_list_view (self);
	_tmp6_ = _tmp5_;
	if (_tmp6_) {
		{
			NoiseListView* _tmp7_;
			_tmp7_ = self->priv->_list_view;
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrapperlist_view);
			{
				NoiseListView* _tmp8_;
				_tmp8_ = self->priv->_list_view;
				noise_view_interface_update_media ((NoiseViewInterface*) _tmp8_, media);
			}
			__finally97:
			{
				NoiseListView* _tmp9_;
				_tmp9_ = self->priv->_list_view;
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrapperlist_view);
			}
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_tmp10_ = noise_view_wrapper_get_has_grid_view (self);
	_tmp11_ = _tmp10_;
	if (_tmp11_) {
		{
			NoiseAlbumsView* _tmp12_;
			_tmp12_ = self->priv->_grid_view;
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrappergrid_view);
			{
				NoiseAlbumsView* _tmp13_;
				_tmp13_ = self->priv->_grid_view;
				noise_view_interface_update_media ((NoiseViewInterface*) _tmp13_, media);
			}
			__finally98:
			{
				NoiseAlbumsView* _tmp14_;
				_tmp14_ = self->priv->_grid_view;
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrappergrid_view);
			}
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	noise_view_wrapper_update_widget_state (self);
}


static void
noise_view_wrapper_add_media (NoiseViewWrapper* self,
                              GeeCollection* new_media)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (new_media != NULL);
	_tmp0_ = self->priv->data_initialized;
	_vala_return_if_fail (_tmp0_, "data_initialized");
	_tmp1_ = gee_collection_get_is_empty (new_media);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		return;
	}
	_tmp3_ = noise_view_wrapper_get_has_list_view (self);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		{
			NoiseListView* _tmp5_;
			_tmp5_ = self->priv->_list_view;
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrapperlist_view);
			{
				NoiseListView* _tmp6_;
				_tmp6_ = self->priv->_list_view;
				noise_view_interface_add_media ((NoiseViewInterface*) _tmp6_, new_media);
			}
			__finally99:
			{
				NoiseListView* _tmp7_;
				_tmp7_ = self->priv->_list_view;
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrapperlist_view);
			}
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_tmp8_ = noise_view_wrapper_get_has_grid_view (self);
	_tmp9_ = _tmp8_;
	if (_tmp9_) {
		{
			NoiseAlbumsView* _tmp10_;
			_tmp10_ = self->priv->_grid_view;
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrappergrid_view);
			{
				NoiseAlbumsView* _tmp11_;
				_tmp11_ = self->priv->_grid_view;
				noise_view_interface_add_media ((NoiseViewInterface*) _tmp11_, new_media);
			}
			__finally100:
			{
				NoiseAlbumsView* _tmp12_;
				_tmp12_ = self->priv->_grid_view;
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrappergrid_view);
			}
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	noise_view_wrapper_update_widget_state (self);
}


static void
noise_view_wrapper_remove_media (NoiseViewWrapper* self,
                                 GeeCollection* media)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	NoiseViewWrapperHint _tmp3_;
	GEnumValue* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (media != NULL);
	_tmp0_ = self->priv->data_initialized;
	_vala_return_if_fail (_tmp0_, "data_initialized");
	_tmp1_ = gee_collection_get_is_empty (media);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		return;
	}
	_tmp3_ = self->priv->_hint;
	_tmp4_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp3_);
	g_debug ("ViewWrapper.vala:512: REMOVING MEDIA [%s]", (_tmp4_ != NULL) ? _tmp4_->value_name : NULL);
	_tmp5_ = noise_view_wrapper_get_has_list_view (self);
	_tmp6_ = _tmp5_;
	if (_tmp6_) {
		{
			NoiseListView* _tmp7_;
			_tmp7_ = self->priv->_list_view;
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrapperlist_view);
			{
				NoiseListView* _tmp8_;
				_tmp8_ = self->priv->_list_view;
				noise_view_interface_remove_media ((NoiseViewInterface*) _tmp8_, media);
			}
			__finally101:
			{
				NoiseListView* _tmp9_;
				_tmp9_ = self->priv->_list_view;
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrapperlist_view);
			}
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_tmp10_ = noise_view_wrapper_get_has_grid_view (self);
	_tmp11_ = _tmp10_;
	if (_tmp11_) {
		{
			NoiseAlbumsView* _tmp12_;
			_tmp12_ = self->priv->_grid_view;
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrappergrid_view);
			{
				NoiseAlbumsView* _tmp13_;
				_tmp13_ = self->priv->_grid_view;
				noise_view_interface_remove_media ((NoiseViewInterface*) _tmp13_, media);
			}
			__finally102:
			{
				NoiseAlbumsView* _tmp14_;
				_tmp14_ = self->priv->_grid_view;
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrappergrid_view);
			}
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	noise_view_wrapper_update_widget_state (self);
}


static void
noise_view_wrapper_update_widget_state (NoiseViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	noise_view_wrapper_check_have_media (self);
	_tmp0_ = noise_view_wrapper_get_is_current_wrapper (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		noise_view_wrapper_update_library_window_widgets (self);
	}
}


NoiseListView*
noise_view_wrapper_get_list_view (NoiseViewWrapper* self)
{
	NoiseListView* result;
	NoiseListView* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_list_view;
	result = _tmp0_;
	return result;
}


void
noise_view_wrapper_set_list_view (NoiseViewWrapper* self,
                                  NoiseListView* value)
{
	g_return_if_fail (self != NULL);
	if (noise_view_wrapper_get_list_view (self) != value) {
		NoiseListView* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_list_view);
		self->priv->_list_view = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_LIST_VIEW_PROPERTY]);
	}
}


NoiseAlbumsView*
noise_view_wrapper_get_grid_view (NoiseViewWrapper* self)
{
	NoiseAlbumsView* result;
	NoiseAlbumsView* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_grid_view;
	result = _tmp0_;
	return result;
}


void
noise_view_wrapper_set_grid_view (NoiseViewWrapper* self,
                                  NoiseAlbumsView* value)
{
	g_return_if_fail (self != NULL);
	if (noise_view_wrapper_get_grid_view (self) != value) {
		NoiseAlbumsView* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_grid_view);
		self->priv->_grid_view = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_GRID_VIEW_PROPERTY]);
	}
}


GraniteWidgetsAlertView*
noise_view_wrapper_get_embedded_alert (NoiseViewWrapper* self)
{
	GraniteWidgetsAlertView* result;
	GraniteWidgetsAlertView* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_embedded_alert;
	result = _tmp0_;
	return result;
}


void
noise_view_wrapper_set_embedded_alert (NoiseViewWrapper* self,
                                       GraniteWidgetsAlertView* value)
{
	g_return_if_fail (self != NULL);
	if (noise_view_wrapper_get_embedded_alert (self) != value) {
		GraniteWidgetsAlertView* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_embedded_alert);
		self->priv->_embedded_alert = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY]);
	}
}


GraniteWidgetsWelcome*
noise_view_wrapper_get_welcome_screen (NoiseViewWrapper* self)
{
	GraniteWidgetsWelcome* result;
	GraniteWidgetsWelcome* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_welcome_screen;
	result = _tmp0_;
	return result;
}


void
noise_view_wrapper_set_welcome_screen (NoiseViewWrapper* self,
                                       GraniteWidgetsWelcome* value)
{
	g_return_if_fail (self != NULL);
	if (noise_view_wrapper_get_welcome_screen (self) != value) {
		GraniteWidgetsWelcome* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_welcome_screen);
		self->priv->_welcome_screen = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY]);
	}
}


gboolean
noise_view_wrapper_get_has_grid_view (NoiseViewWrapper* self)
{
	gboolean result;
	NoiseAlbumsView* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_grid_view;
	result = _tmp0_ != NULL;
	return result;
}


gboolean
noise_view_wrapper_get_has_list_view (NoiseViewWrapper* self)
{
	gboolean result;
	NoiseListView* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_list_view;
	result = _tmp0_ != NULL;
	return result;
}


gboolean
noise_view_wrapper_get_has_embedded_alert (NoiseViewWrapper* self)
{
	gboolean result;
	GraniteWidgetsAlertView* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_embedded_alert;
	result = _tmp0_ != NULL;
	return result;
}


gboolean
noise_view_wrapper_get_has_welcome_screen (NoiseViewWrapper* self)
{
	gboolean result;
	GraniteWidgetsWelcome* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_welcome_screen;
	result = _tmp0_ != NULL;
	return result;
}


NoiseViewWrapperViewType
noise_view_wrapper_get_current_view (NoiseViewWrapper* self)
{
	NoiseViewWrapperViewType result;
	GtkWidget* view = NULL;
	NoiseViewStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	NoiseAlbumsView* _tmp5_;
	GtkWidget* _tmp6_;
	NoiseListView* _tmp7_;
	GtkWidget* _tmp8_;
	GraniteWidgetsAlertView* _tmp9_;
	GtkWidget* _tmp10_;
	GraniteWidgetsWelcome* _tmp11_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->view_stack;
	_tmp1_ = gtk_stack_get_visible_child ((GtkStack*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	view = _tmp3_;
	_tmp4_ = view;
	_tmp5_ = self->priv->_grid_view;
	if (_tmp4_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget)) {
		result = NOISE_VIEW_WRAPPER_VIEW_TYPE_GRID;
		_g_object_unref0 (view);
		return result;
	}
	_tmp6_ = view;
	_tmp7_ = self->priv->_list_view;
	if (_tmp6_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget)) {
		result = NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST;
		_g_object_unref0 (view);
		return result;
	}
	_tmp8_ = view;
	_tmp9_ = self->priv->_embedded_alert;
	if (_tmp8_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget)) {
		result = NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT;
		_g_object_unref0 (view);
		return result;
	}
	_tmp10_ = view;
	_tmp11_ = self->priv->_welcome_screen;
	if (_tmp10_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget)) {
		result = NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME;
		_g_object_unref0 (view);
		return result;
	}
	result = NOISE_VIEW_WRAPPER_VIEW_TYPE_NONE;
	_g_object_unref0 (view);
	return result;
}


NoiseViewWrapperHint
noise_view_wrapper_get_hint (NoiseViewWrapper* self)
{
	NoiseViewWrapperHint result;
	NoiseViewWrapperHint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_hint;
	result = _tmp0_;
	return result;
}


void
noise_view_wrapper_set_hint (NoiseViewWrapper* self,
                             NoiseViewWrapperHint value)
{
	g_return_if_fail (self != NULL);
	if (noise_view_wrapper_get_hint (self) != value) {
		self->priv->_hint = value;
		g_object_notify_by_pspec ((GObject *) self, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_HINT_PROPERTY]);
	}
}


NoiseLibrary*
noise_view_wrapper_get_library (NoiseViewWrapper* self)
{
	NoiseLibrary* result;
	NoiseLibrary* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_library;
	result = _tmp0_;
	return result;
}


void
noise_view_wrapper_set_library (NoiseViewWrapper* self,
                                NoiseLibrary* value)
{
	g_return_if_fail (self != NULL);
	if (noise_view_wrapper_get_library (self) != value) {
		NoiseLibrary* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_library);
		self->priv->_library = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_LIBRARY_PROPERTY]);
	}
}


gboolean
noise_view_wrapper_get_is_current_wrapper (NoiseViewWrapper* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = noise_app_get_main_window ();
	_tmp2_ = _tmp1_;
	_tmp3_ = noise_library_window_get_initialization_finished (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		NoiseLibraryWindow* _tmp5_;
		NoiseLibraryWindow* _tmp6_;
		NoiseViewStack* _tmp7_;
		NoiseViewStack* _tmp8_;
		GtkWidget* _tmp9_;
		GtkWidget* _tmp10_;
		_tmp5_ = noise_app_get_main_window ();
		_tmp6_ = _tmp5_;
		_tmp7_ = noise_library_window_get_view_stack (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = gtk_stack_get_visible_child ((GtkStack*) _tmp8_);
		_tmp10_ = _tmp9_;
		_tmp0_ = _tmp10_ == G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


NoisePlaylist*
noise_view_wrapper_get_playlist (NoiseViewWrapper* self)
{
	NoisePlaylist* result;
	NoisePlaylist* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_playlist;
	result = _tmp0_;
	return result;
}


void
noise_view_wrapper_set_playlist (NoiseViewWrapper* self,
                                 NoisePlaylist* value)
{
	g_return_if_fail (self != NULL);
	if (noise_view_wrapper_get_playlist (self) != value) {
		NoisePlaylist* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_playlist);
		self->priv->_playlist = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_PLAYLIST_PROPERTY]);
	}
}


gint
noise_view_wrapper_get_media_count (NoiseViewWrapper* self)
{
	gint result;
	NoiseListView* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_list_view;
	_tmp1_ = noise_list_view_get_n_media (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) _tmp2_;
	return result;
}


static void
_noise_view_wrapper_view_selector_changed_noise_widgets_view_selector_mode_changed (NoiseWidgetsViewSelector* _sender,
                                                                                    NoiseWidgetsViewSelectorMode new_mode,
                                                                                    gpointer self)
{
	noise_view_wrapper_view_selector_changed ((NoiseViewWrapper*) self);
}


static void
_noise_view_wrapper_search_field_changed_noise_library_search_finished (NoiseLibrary* _sender,
                                                                        gpointer self)
{
	noise_view_wrapper_search_field_changed ((NoiseViewWrapper*) self);
}


static GObject *
noise_view_wrapper_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseViewWrapper * self;
	NoiseViewStack* _tmp0_;
	NoiseViewStack* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	NoiseLibraryWindow* _tmp3_;
	NoiseWidgetsViewSelector* _tmp4_;
	NoiseWidgetsViewSelector* _tmp5_;
	NoiseLibrary* _tmp6_;
	parent_class = G_OBJECT_CLASS (noise_view_wrapper_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	_tmp0_ = noise_view_stack_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->view_stack);
	self->priv->view_stack = _tmp0_;
	_tmp1_ = self->priv->view_stack;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
	_tmp2_ = noise_app_get_main_window ();
	_tmp3_ = _tmp2_;
	_tmp4_ = noise_library_window_get_view_selector (_tmp3_);
	_tmp5_ = _tmp4_;
	g_signal_connect_object (_tmp5_, "mode-changed", (GCallback) _noise_view_wrapper_view_selector_changed_noise_widgets_view_selector_mode_changed, self, 0);
	_tmp6_ = self->priv->_library;
	g_signal_connect_object (_tmp6_, "search-finished", (GCallback) _noise_view_wrapper_search_field_changed_noise_library_search_finished, self, 0);
	return obj;
}


static void
noise_view_wrapper_class_init (NoiseViewWrapperClass * klass)
{
	noise_view_wrapper_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseViewWrapper_private_offset);
	((NoiseViewWrapperClass *) klass)->check_have_media = (gboolean (*) (NoiseViewWrapper *)) noise_view_wrapper_real_check_have_media;
	((NoiseViewWrapperClass *) klass)->select_proper_content_view = (void (*) (NoiseViewWrapper *)) noise_view_wrapper_real_select_proper_content_view;
	((NoiseViewWrapperClass *) klass)->set_no_media_alert = (void (*) (NoiseViewWrapper *)) noise_view_wrapper_real_set_no_media_alert;
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_view_wrapper_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_view_wrapper_set_property;
	G_OBJECT_CLASS (klass)->constructor = noise_view_wrapper_constructor;
	G_OBJECT_CLASS (klass)->finalize = noise_view_wrapper_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_LIST_VIEW_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_LIST_VIEW_PROPERTY] = g_param_spec_object ("list-view", "list-view", "list-view", NOISE_TYPE_LIST_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_GRID_VIEW_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_GRID_VIEW_PROPERTY] = g_param_spec_object ("grid-view", "grid-view", "grid-view", NOISE_TYPE_ALBUMS_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY] = g_param_spec_object ("embedded-alert", "embedded-alert", "embedded-alert", GRANITE_WIDGETS_TYPE_ALERT_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY] = g_param_spec_object ("welcome-screen", "welcome-screen", "welcome-screen", GRANITE_WIDGETS_TYPE_WELCOME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY] = g_param_spec_boolean ("has-grid-view", "has-grid-view", "has-grid-view", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY] = g_param_spec_boolean ("has-list-view", "has-list-view", "has-list-view", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY] = g_param_spec_boolean ("has-embedded-alert", "has-embedded-alert", "has-embedded-alert", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY] = g_param_spec_boolean ("has-welcome-screen", "has-welcome-screen", "has-welcome-screen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY] = g_param_spec_enum ("current-view", "current-view", "current-view", NOISE_VIEW_WRAPPER_TYPE_VIEW_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	     * This is by far the most important property of this object.
	     * It defines how child widgets behave and some other properties.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_HINT_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", NOISE_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_LIBRARY_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_LIBRARY_PROPERTY] = g_param_spec_object ("library", "library", "library", NOISE_TYPE_LIBRARY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY] = g_param_spec_boolean ("is-current-wrapper", "is-current-wrapper", "is-current-wrapper", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_PLAYLIST_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_PLAYLIST_PROPERTY] = g_param_spec_object ("playlist", "playlist", "playlist", NOISE_TYPE_PLAYLIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY] = g_param_spec_int ("media-count", "media-count", "media-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
noise_view_wrapper_instance_init (NoiseViewWrapper * self)
{
	self->priv = noise_view_wrapper_get_instance_private (self);
	self->priv->_playlist = NULL;
	self->priv->widgets_ready = FALSE;
	self->priv->last_used_view = NOISE_VIEW_WRAPPER_VIEW_TYPE_NONE;
	self->priv->data_initialized = FALSE;
	g_rec_mutex_init (&self->priv->__lock_NoiseViewWrapperlist_view);
	g_rec_mutex_init (&self->priv->__lock_NoiseViewWrappergrid_view);
}


static void
noise_view_wrapper_finalize (GObject * obj)
{
	NoiseViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper);
	_g_object_unref0 (self->priv->_list_view);
	_g_object_unref0 (self->priv->_grid_view);
	_g_object_unref0 (self->priv->_embedded_alert);
	_g_object_unref0 (self->priv->_welcome_screen);
	_g_object_unref0 (self->priv->_library);
	_g_object_unref0 (self->priv->_playlist);
	_g_object_unref0 (self->priv->view_stack);
	g_rec_mutex_clear (&self->priv->__lock_NoiseViewWrapperlist_view);
	g_rec_mutex_clear (&self->priv->__lock_NoiseViewWrappergrid_view);
	G_OBJECT_CLASS (noise_view_wrapper_parent_class)->finalize (obj);
}


GType
noise_view_wrapper_get_type (void)
{
	static volatile gsize noise_view_wrapper_type_id__volatile = 0;
	if (g_once_init_enter (&noise_view_wrapper_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseViewWrapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_view_wrapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseViewWrapper), 0, (GInstanceInitFunc) noise_view_wrapper_instance_init, NULL };
		GType noise_view_wrapper_type_id;
		noise_view_wrapper_type_id = g_type_register_static (gtk_grid_get_type (), "NoiseViewWrapper", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		NoiseViewWrapper_private_offset = g_type_add_instance_private (noise_view_wrapper_type_id, sizeof (NoiseViewWrapperPrivate));
		g_once_init_leave (&noise_view_wrapper_type_id__volatile, noise_view_wrapper_type_id);
	}
	return noise_view_wrapper_type_id__volatile;
}


static void
_vala_noise_view_wrapper_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	NoiseViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper);
	switch (property_id) {
		case NOISE_VIEW_WRAPPER_LIST_VIEW_PROPERTY:
		g_value_set_object (value, noise_view_wrapper_get_list_view (self));
		break;
		case NOISE_VIEW_WRAPPER_GRID_VIEW_PROPERTY:
		g_value_set_object (value, noise_view_wrapper_get_grid_view (self));
		break;
		case NOISE_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY:
		g_value_set_object (value, noise_view_wrapper_get_embedded_alert (self));
		break;
		case NOISE_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY:
		g_value_set_object (value, noise_view_wrapper_get_welcome_screen (self));
		break;
		case NOISE_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY:
		g_value_set_boolean (value, noise_view_wrapper_get_has_grid_view (self));
		break;
		case NOISE_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY:
		g_value_set_boolean (value, noise_view_wrapper_get_has_list_view (self));
		break;
		case NOISE_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY:
		g_value_set_boolean (value, noise_view_wrapper_get_has_embedded_alert (self));
		break;
		case NOISE_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY:
		g_value_set_boolean (value, noise_view_wrapper_get_has_welcome_screen (self));
		break;
		case NOISE_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY:
		g_value_set_enum (value, noise_view_wrapper_get_current_view (self));
		break;
		case NOISE_VIEW_WRAPPER_HINT_PROPERTY:
		g_value_set_enum (value, noise_view_wrapper_get_hint (self));
		break;
		case NOISE_VIEW_WRAPPER_LIBRARY_PROPERTY:
		g_value_set_object (value, noise_view_wrapper_get_library (self));
		break;
		case NOISE_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY:
		g_value_set_boolean (value, noise_view_wrapper_get_is_current_wrapper (self));
		break;
		case NOISE_VIEW_WRAPPER_PLAYLIST_PROPERTY:
		g_value_set_object (value, noise_view_wrapper_get_playlist (self));
		break;
		case NOISE_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY:
		g_value_set_int (value, noise_view_wrapper_get_media_count (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_view_wrapper_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	NoiseViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper);
	switch (property_id) {
		case NOISE_VIEW_WRAPPER_LIST_VIEW_PROPERTY:
		noise_view_wrapper_set_list_view (self, g_value_get_object (value));
		break;
		case NOISE_VIEW_WRAPPER_GRID_VIEW_PROPERTY:
		noise_view_wrapper_set_grid_view (self, g_value_get_object (value));
		break;
		case NOISE_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY:
		noise_view_wrapper_set_embedded_alert (self, g_value_get_object (value));
		break;
		case NOISE_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY:
		noise_view_wrapper_set_welcome_screen (self, g_value_get_object (value));
		break;
		case NOISE_VIEW_WRAPPER_HINT_PROPERTY:
		noise_view_wrapper_set_hint (self, g_value_get_enum (value));
		break;
		case NOISE_VIEW_WRAPPER_LIBRARY_PROPERTY:
		noise_view_wrapper_set_library (self, g_value_get_object (value));
		break;
		case NOISE_VIEW_WRAPPER_PLAYLIST_PROPERTY:
		noise_view_wrapper_set_playlist (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



