/* ContractMenuItem.c generated by valac 0.41.91, the Vala compiler
 * generated from ContractMenuItem.vala, do not modify */

/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Corentin Noël <corentin@elementary.io>,
 *              Lucas Baudin <xapantu@gmail.com>,
 *              ammonkey <am.monkeyd@gmail.com>,
 *              Victor Martinez <victoreduardm@gmail.com>,
 *              Sergey Davidoff <shnatsel@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <granite.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <gio/gio.h>


#define NOISE_TYPE_CONTRACT_MENU_ITEM (noise_contract_menu_item_get_type ())
#define NOISE_CONTRACT_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_CONTRACT_MENU_ITEM, NoiseContractMenuItem))
#define NOISE_CONTRACT_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_CONTRACT_MENU_ITEM, NoiseContractMenuItemClass))
#define NOISE_IS_CONTRACT_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_CONTRACT_MENU_ITEM))
#define NOISE_IS_CONTRACT_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_CONTRACT_MENU_ITEM))
#define NOISE_CONTRACT_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_CONTRACT_MENU_ITEM, NoiseContractMenuItemClass))

typedef struct _NoiseContractMenuItem NoiseContractMenuItem;
typedef struct _NoiseContractMenuItemClass NoiseContractMenuItemClass;
typedef struct _NoiseContractMenuItemPrivate NoiseContractMenuItemPrivate;
enum  {
	NOISE_CONTRACT_MENU_ITEM_0_PROPERTY,
	NOISE_CONTRACT_MENU_ITEM_CONTRACT_PROPERTY,
	NOISE_CONTRACT_MENU_ITEM_MEDIAS_PROPERTY,
	NOISE_CONTRACT_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* noise_contract_menu_item_properties[NOISE_CONTRACT_MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NoiseContractMenuItem {
	GtkMenuItem parent_instance;
	NoiseContractMenuItemPrivate * priv;
};

struct _NoiseContractMenuItemClass {
	GtkMenuItemClass parent_class;
};

struct _NoiseContractMenuItemPrivate {
	GraniteServicesContract* _contract;
	GeeCollection* _medias;
};


static gint NoiseContractMenuItem_private_offset;
static gpointer noise_contract_menu_item_parent_class = NULL;

GType noise_contract_menu_item_get_type (void) G_GNUC_CONST;
NoiseContractMenuItem* noise_contract_menu_item_new (GraniteServicesContract* contract,
                                                     GeeCollection* medias);
NoiseContractMenuItem* noise_contract_menu_item_construct (GType object_type,
                                                           GraniteServicesContract* contract,
                                                           GeeCollection* medias);
static void noise_contract_menu_item_real_activate (GtkMenuItem* base);
GeeCollection* noise_contract_menu_item_get_medias (NoiseContractMenuItem* self);
static void _vala_array_add25 (GFile** * array,
                        int* length,
                        int* size,
                        GFile* value);
GraniteServicesContract* noise_contract_menu_item_get_contract (NoiseContractMenuItem* self);
void noise_contract_menu_item_set_contract (NoiseContractMenuItem* self,
                                            GraniteServicesContract* value);
void noise_contract_menu_item_set_medias (NoiseContractMenuItem* self,
                                          GeeCollection* value);
static void noise_contract_menu_item_finalize (GObject * obj);
static void _vala_noise_contract_menu_item_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_noise_contract_menu_item_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static inline gpointer
noise_contract_menu_item_get_instance_private (NoiseContractMenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseContractMenuItem_private_offset);
}


NoiseContractMenuItem*
noise_contract_menu_item_construct (GType object_type,
                                    GraniteServicesContract* contract,
                                    GeeCollection* medias)
{
	NoiseContractMenuItem * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (contract != NULL, NULL);
	g_return_val_if_fail (medias != NULL, NULL);
	_tmp0_ = granite_services_contract_get_display_name (contract);
	_tmp1_ = _tmp0_;
	self = (NoiseContractMenuItem*) g_object_new (object_type, "contract", contract, "medias", medias, "label", _tmp1_, NULL);
	_g_free0 (_tmp1_);
	return self;
}


NoiseContractMenuItem*
noise_contract_menu_item_new (GraniteServicesContract* contract,
                              GeeCollection* medias)
{
	return noise_contract_menu_item_construct (NOISE_TYPE_CONTRACT_MENU_ITEM, contract, medias);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
_vala_array_add25 (GFile** * array,
                   int* length,
                   int* size,
                   GFile* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GFile*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void
noise_contract_menu_item_real_activate (GtkMenuItem* base)
{
	NoiseContractMenuItem * self;
	GFile** files = NULL;
	GFile** _tmp0_;
	gint files_length1;
	gint _files_size_;
	GError * _inner_error_ = NULL;
	self = (NoiseContractMenuItem*) base;
	_tmp0_ = g_new0 (GFile*, 0 + 1);
	files = _tmp0_;
	files_length1 = 0;
	_files_size_ = files_length1;
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		_tmp1_ = self->priv->_medias;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_m_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GFile** _tmp6_;
			gint _tmp6__length1;
			NoiseMedia* _tmp7_;
			GFile* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			NoiseMedia* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			_tmp3_ = _m_it;
			if (!gee_iterator_next (_tmp3_)) {
				break;
			}
			_tmp4_ = _m_it;
			_tmp5_ = gee_iterator_get (_tmp4_);
			m = (NoiseMedia*) _tmp5_;
			_tmp6_ = files;
			_tmp6__length1 = files_length1;
			_tmp7_ = m;
			_tmp8_ = noise_media_get_file (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = _g_object_ref0 (_tmp9_);
			_vala_array_add25 (&files, &files_length1, &_files_size_, _tmp10_);
			_tmp11_ = m;
			_tmp12_ = noise_media_get_uri (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp14_ = _tmp13_;
			g_debug ("ContractMenuItem.vala:45: Added file to pass to Contractor: %s", _tmp14_);
			_g_free0 (_tmp14_);
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	{
		GraniteServicesContract* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GraniteServicesContract* _tmp18_;
		GFile** _tmp19_;
		gint _tmp19__length1;
		_tmp15_ = self->priv->_contract;
		_tmp16_ = granite_services_contract_get_display_name (_tmp15_);
		_tmp17_ = _tmp16_;
		g_debug ("ContractMenuItem.vala:49: Executing contract \"%s\"", _tmp17_);
		_g_free0 (_tmp17_);
		_tmp18_ = self->priv->_contract;
		_tmp19_ = files;
		_tmp19__length1 = files_length1;
		granite_services_contract_execute_with_files (_tmp18_, _tmp19_, _tmp19__length1, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch105_g_error;
		}
	}
	goto __finally105;
	__catch105_g_error:
	{
		GError* err = NULL;
		GraniteServicesContract* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		GError* _tmp23_;
		const gchar* _tmp24_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp20_ = self->priv->_contract;
		_tmp21_ = granite_services_contract_get_display_name (_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = err;
		_tmp24_ = _tmp23_->message;
		g_warning ("ContractMenuItem.vala:52: Error executing contract \"%s\": %s", _tmp22_, _tmp24_);
		_g_free0 (_tmp22_);
		_g_error_free0 (err);
	}
	__finally105:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_object_unref), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_object_unref), NULL);
}


GraniteServicesContract*
noise_contract_menu_item_get_contract (NoiseContractMenuItem* self)
{
	GraniteServicesContract* result;
	GraniteServicesContract* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_contract;
	result = _tmp0_;
	return result;
}


void
noise_contract_menu_item_set_contract (NoiseContractMenuItem* self,
                                       GraniteServicesContract* value)
{
	g_return_if_fail (self != NULL);
	if (noise_contract_menu_item_get_contract (self) != value) {
		GraniteServicesContract* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_contract);
		self->priv->_contract = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_contract_menu_item_properties[NOISE_CONTRACT_MENU_ITEM_CONTRACT_PROPERTY]);
	}
}


GeeCollection*
noise_contract_menu_item_get_medias (NoiseContractMenuItem* self)
{
	GeeCollection* result;
	GeeCollection* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_medias;
	result = _tmp0_;
	return result;
}


void
noise_contract_menu_item_set_medias (NoiseContractMenuItem* self,
                                     GeeCollection* value)
{
	g_return_if_fail (self != NULL);
	if (noise_contract_menu_item_get_medias (self) != value) {
		GeeCollection* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_medias);
		self->priv->_medias = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_contract_menu_item_properties[NOISE_CONTRACT_MENU_ITEM_MEDIAS_PROPERTY]);
	}
}


static void
noise_contract_menu_item_class_init (NoiseContractMenuItemClass * klass)
{
	noise_contract_menu_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseContractMenuItem_private_offset);
	((GtkMenuItemClass *) klass)->activate = (void (*) (GtkMenuItem *)) noise_contract_menu_item_real_activate;
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_contract_menu_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_contract_menu_item_set_property;
	G_OBJECT_CLASS (klass)->finalize = noise_contract_menu_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_CONTRACT_MENU_ITEM_CONTRACT_PROPERTY, noise_contract_menu_item_properties[NOISE_CONTRACT_MENU_ITEM_CONTRACT_PROPERTY] = g_param_spec_object ("contract", "contract", "contract", GRANITE_SERVICES_TYPE_CONTRACT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_CONTRACT_MENU_ITEM_MEDIAS_PROPERTY, noise_contract_menu_item_properties[NOISE_CONTRACT_MENU_ITEM_MEDIAS_PROPERTY] = g_param_spec_object ("medias", "medias", "medias", GEE_TYPE_COLLECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
}


static void
noise_contract_menu_item_instance_init (NoiseContractMenuItem * self)
{
	self->priv = noise_contract_menu_item_get_instance_private (self);
}


static void
noise_contract_menu_item_finalize (GObject * obj)
{
	NoiseContractMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_CONTRACT_MENU_ITEM, NoiseContractMenuItem);
	_g_object_unref0 (self->priv->_contract);
	_g_object_unref0 (self->priv->_medias);
	G_OBJECT_CLASS (noise_contract_menu_item_parent_class)->finalize (obj);
}


GType
noise_contract_menu_item_get_type (void)
{
	static volatile gsize noise_contract_menu_item_type_id__volatile = 0;
	if (g_once_init_enter (&noise_contract_menu_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseContractMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_contract_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseContractMenuItem), 0, (GInstanceInitFunc) noise_contract_menu_item_instance_init, NULL };
		GType noise_contract_menu_item_type_id;
		noise_contract_menu_item_type_id = g_type_register_static (gtk_menu_item_get_type (), "NoiseContractMenuItem", &g_define_type_info, 0);
		NoiseContractMenuItem_private_offset = g_type_add_instance_private (noise_contract_menu_item_type_id, sizeof (NoiseContractMenuItemPrivate));
		g_once_init_leave (&noise_contract_menu_item_type_id__volatile, noise_contract_menu_item_type_id);
	}
	return noise_contract_menu_item_type_id__volatile;
}


static void
_vala_noise_contract_menu_item_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	NoiseContractMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_CONTRACT_MENU_ITEM, NoiseContractMenuItem);
	switch (property_id) {
		case NOISE_CONTRACT_MENU_ITEM_CONTRACT_PROPERTY:
		g_value_set_object (value, noise_contract_menu_item_get_contract (self));
		break;
		case NOISE_CONTRACT_MENU_ITEM_MEDIAS_PROPERTY:
		g_value_set_object (value, noise_contract_menu_item_get_medias (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_contract_menu_item_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	NoiseContractMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_CONTRACT_MENU_ITEM, NoiseContractMenuItem);
	switch (property_id) {
		case NOISE_CONTRACT_MENU_ITEM_CONTRACT_PROPERTY:
		noise_contract_menu_item_set_contract (self, g_value_get_object (value));
		break;
		case NOISE_CONTRACT_MENU_ITEM_MEDIAS_PROPERTY:
		noise_contract_menu_item_set_medias (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



