/* FastGrid.c generated by valac 0.41.91, the Vala compiler
 * generated from FastGrid.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define NOISE_TYPE_FAST_GRID (noise_fast_grid_get_type ())
#define NOISE_FAST_GRID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_FAST_GRID, NoiseFastGrid))
#define NOISE_FAST_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_FAST_GRID, NoiseFastGridClass))
#define NOISE_IS_FAST_GRID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_FAST_GRID))
#define NOISE_IS_FAST_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_FAST_GRID))
#define NOISE_FAST_GRID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_FAST_GRID, NoiseFastGridClass))

typedef struct _NoiseFastGrid NoiseFastGrid;
typedef struct _NoiseFastGridClass NoiseFastGridClass;
typedef struct _NoiseFastGridPrivate NoiseFastGridPrivate;

#define NOISE_TYPE_FAST_GRID_MODEL (noise_fast_grid_model_get_type ())
#define NOISE_FAST_GRID_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_FAST_GRID_MODEL, NoiseFastGridModel))
#define NOISE_FAST_GRID_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_FAST_GRID_MODEL, NoiseFastGridModelClass))
#define NOISE_IS_FAST_GRID_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_FAST_GRID_MODEL))
#define NOISE_IS_FAST_GRID_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_FAST_GRID_MODEL))
#define NOISE_FAST_GRID_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_FAST_GRID_MODEL, NoiseFastGridModelClass))

typedef struct _NoiseFastGridModel NoiseFastGridModel;
typedef struct _NoiseFastGridModelClass NoiseFastGridModelClass;
enum  {
	NOISE_FAST_GRID_0_PROPERTY,
	NOISE_FAST_GRID_NUM_PROPERTIES
};
static GParamSpec* noise_fast_grid_properties[NOISE_FAST_GRID_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NOISE_WIDGETS_TYPE_TILE_RENDERER (noise_widgets_tile_renderer_get_type ())
#define NOISE_WIDGETS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRenderer))
#define NOISE_WIDGETS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRendererClass))
#define NOISE_WIDGETS_IS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_WIDGETS_TYPE_TILE_RENDERER))
#define NOISE_WIDGETS_IS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_WIDGETS_TYPE_TILE_RENDERER))
#define NOISE_WIDGETS_TILE_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRendererClass))

typedef struct _NoiseWidgetsTileRenderer NoiseWidgetsTileRenderer;
typedef struct _NoiseWidgetsTileRendererClass NoiseWidgetsTileRendererClass;

struct _NoiseFastGrid {
	GtkIconView parent_instance;
	NoiseFastGridPrivate * priv;
	gboolean research_needed;
};

struct _NoiseFastGridClass {
	GtkIconViewClass parent_class;
};

typedef void (*NoiseFastGridViewSearchFunc) (GeeHashMap* showing, gpointer user_data);
typedef gint (*NoiseFastGridSortCompareFunc) (GObject* a, GObject* b, gpointer user_data);
struct _NoiseFastGridPrivate {
	NoiseFastGridViewSearchFunc _search_func;
	gpointer _search_func_target;
	NoiseFastGridSortCompareFunc _compare_func;
	gpointer _compare_func_target;
	GtkCellRenderer* cell_renderer;
	NoiseFastGridModel* fm;
	GeeHashMap* table;
	GeeHashMap* showing;
};


static gint NoiseFastGrid_private_offset;
static gpointer noise_fast_grid_parent_class = NULL;

GType noise_fast_grid_get_type (void) G_GNUC_CONST;
GType noise_fast_grid_model_get_type (void) G_GNUC_CONST;
GeeMap* noise_fast_grid_get_table (NoiseFastGrid* self);
GeeMap* noise_fast_grid_get_visible_table (NoiseFastGrid* self);
GObject* noise_fast_grid_get_object_from_index (NoiseFastGrid* self,
                                                gint index);
void noise_fast_grid_set_table (NoiseFastGrid* self,
                                GeeHashMap* new_table,
                                gboolean do_resort);
static void noise_fast_grid_resort (NoiseFastGrid* self);
void noise_fast_grid_do_search (NoiseFastGrid* self);
void noise_fast_grid_remove_objects (NoiseFastGrid* self,
                                     GeeCollection* objects);
void noise_fast_grid_add_objects (NoiseFastGrid* self,
                                  GeeCollection* objects);
NoiseFastGridViewSearchFunc noise_fast_grid_get_search_func (NoiseFastGrid* self,
                                                             gpointer* result_target);
void noise_fast_grid_model_set_table (NoiseFastGridModel* self,
                                      GeeHashMap* table);
void noise_fast_grid_model_remove (NoiseFastGridModel* self,
                                   GtkTreeIter* iter);
void noise_fast_grid_model_append (NoiseFastGridModel* self,
                                   GtkTreeIter* iter);
static void noise_fast_grid_quicksort (NoiseFastGrid* self,
                                gint start,
                                gint end);
static void noise_fast_grid_swap (NoiseFastGrid* self,
                           gint a,
                           gint b);
NoiseFastGridSortCompareFunc noise_fast_grid_get_compare_func (NoiseFastGrid* self,
                                                               gpointer* result_target);
static void noise_fast_grid_real_size_allocate (GtkWidget* base,
                                         GtkAllocation* alloc);
NoiseFastGrid* noise_fast_grid_new (void);
NoiseFastGrid* noise_fast_grid_construct (GType object_type);
void noise_fast_grid_set_search_func (NoiseFastGrid* self,
                                      NoiseFastGridViewSearchFunc value,
                                      gpointer value_target);
void noise_fast_grid_set_compare_func (NoiseFastGrid* self,
                                       NoiseFastGridSortCompareFunc value,
                                       gpointer value_target);
static GObject * noise_fast_grid_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
NoiseFastGridModel* noise_fast_grid_model_new (void);
NoiseFastGridModel* noise_fast_grid_model_construct (GType object_type);
NoiseWidgetsTileRenderer* noise_widgets_tile_renderer_new (void);
NoiseWidgetsTileRenderer* noise_widgets_tile_renderer_construct (GType object_type);
GType noise_widgets_tile_renderer_get_type (void) G_GNUC_CONST;
static void noise_fast_grid_finalize (GObject * obj);
static void _vala_noise_fast_grid_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_noise_fast_grid_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);


static inline gpointer
noise_fast_grid_get_instance_private (NoiseFastGrid* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseFastGrid_private_offset);
}


/** Should not be manipulated by client */
GeeMap*
noise_fast_grid_get_table (NoiseFastGrid* self)
{
	GeeMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->table;
	_tmp1_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


/** Should not be manipulated by client */
GeeMap*
noise_fast_grid_get_visible_table (NoiseFastGrid* self)
{
	GeeMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->showing;
	_tmp1_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


GObject*
noise_fast_grid_get_object_from_index (NoiseFastGrid* self,
                                       gint index)
{
	GObject* result = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->showing;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) index));
	result = (GObject*) _tmp1_;
	return result;
}


void
noise_fast_grid_set_table (NoiseFastGrid* self,
                           GeeHashMap* new_table,
                           gboolean do_resort)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (new_table != NULL);
	_tmp0_ = self->priv->table;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
	_tmp1_ = self->priv->table;
	gee_map_set_all ((GeeMap*) _tmp1_, (GeeMap*) new_table);
	if (do_resort) {
		noise_fast_grid_resort (self);
	} else {
		noise_fast_grid_do_search (self);
	}
}


void
noise_fast_grid_remove_objects (NoiseFastGrid* self,
                                GeeCollection* objects)
{
	GeeHashMap* to_remove = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp20_;
	GeeHashMap* _tmp21_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (objects != NULL);
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	to_remove = _tmp0_;
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
		_tmp1_ = self->priv->table;
		_tmp2_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = _tmp3_;
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
		_tmp6_ = _tmp5_;
		_g_object_unref0 (_tmp4_);
		_entry_it = _tmp6_;
		while (TRUE) {
			GeeIterator* _tmp7_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GeeMapEntry* _tmp10_;
			gconstpointer _tmp11_;
			GObject* _tmp12_;
			_tmp7_ = _entry_it;
			if (!gee_iterator_next (_tmp7_)) {
				break;
			}
			_tmp8_ = _entry_it;
			_tmp9_ = gee_iterator_get (_tmp8_);
			entry = (GeeMapEntry*) _tmp9_;
			_tmp10_ = entry;
			_tmp11_ = gee_map_entry_get_value (_tmp10_);
			_tmp12_ = _tmp11_;
			if (gee_collection_contains (objects, (GObject*) _tmp12_)) {
				GeeHashMap* _tmp13_;
				GeeMapEntry* _tmp14_;
				gconstpointer _tmp15_;
				gint _tmp16_;
				GeeMapEntry* _tmp17_;
				gconstpointer _tmp18_;
				GObject* _tmp19_;
				_tmp13_ = to_remove;
				_tmp14_ = entry;
				_tmp15_ = gee_map_entry_get_key (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = entry;
				_tmp18_ = gee_map_entry_get_value (_tmp17_);
				_tmp19_ = _tmp18_;
				gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, (gpointer) ((gintptr) ((gint) ((gintptr) _tmp16_))), (GObject*) _tmp19_);
			}
			_g_object_unref0 (entry);
		}
		_g_object_unref0 (_entry_it);
	}
	_tmp20_ = self->priv->table;
	_tmp21_ = to_remove;
	gee_map_unset_all ((GeeMap*) _tmp20_, (GeeMap*) _tmp21_);
	noise_fast_grid_do_search (self);
	_g_object_unref0 (to_remove);
}


void
noise_fast_grid_add_objects (NoiseFastGrid* self,
                             GeeCollection* objects)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (objects != NULL);
	{
		GeeIterator* _o_it = NULL;
		GeeIterator* _tmp0_;
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) objects);
		_o_it = _tmp0_;
		while (TRUE) {
			GeeIterator* _tmp1_;
			GObject* o = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GeeHashMap* _tmp4_;
			GeeHashMap* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			GObject* _tmp8_;
			_tmp1_ = _o_it;
			if (!gee_iterator_next (_tmp1_)) {
				break;
			}
			_tmp2_ = _o_it;
			_tmp3_ = gee_iterator_get (_tmp2_);
			o = (GObject*) _tmp3_;
			_tmp4_ = self->priv->table;
			_tmp5_ = self->priv->table;
			_tmp6_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp5_);
			_tmp7_ = _tmp6_;
			_tmp8_ = o;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, (gpointer) ((gintptr) _tmp7_), _tmp8_);
			_g_object_unref0 (o);
		}
		_g_object_unref0 (_o_it);
	}
	noise_fast_grid_resort (self);
}


void
noise_fast_grid_do_search (NoiseFastGrid* self)
{
	gboolean _tmp0_ = FALSE;
	NoiseFastGridViewSearchFunc _tmp1_;
	void* _tmp1__target;
	NoiseFastGridViewSearchFunc _tmp2_;
	void* _tmp2__target;
	gint old_size = 0;
	GeeHashMap* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GeeHashMap* _tmp7_;
	NoiseFastGridViewSearchFunc _tmp8_;
	void* _tmp8__target;
	NoiseFastGridViewSearchFunc _tmp9_;
	void* _tmp9__target;
	GeeHashMap* _tmp10_;
	GeeHashMap* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	g_return_if_fail (self != NULL);
	_tmp1_ = noise_fast_grid_get_search_func (self, &_tmp1__target);
	_tmp2_ = _tmp1_;
	_tmp2__target = _tmp1__target;
	if (_tmp2_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp3_;
		_tmp3_ = self->research_needed;
		_tmp0_ = _tmp3_ == FALSE;
	}
	if (_tmp0_) {
		return;
	}
	self->research_needed = FALSE;
	_tmp4_ = self->priv->showing;
	_tmp5_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp4_);
	_tmp6_ = _tmp5_;
	old_size = _tmp6_;
	_tmp7_ = self->priv->showing;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp7_);
	_tmp8_ = noise_fast_grid_get_search_func (self, &_tmp8__target);
	_tmp9_ = _tmp8_;
	_tmp9__target = _tmp8__target;
	_tmp10_ = self->priv->showing;
	_tmp9_ (_tmp10_, _tmp9__target);
	_tmp11_ = self->priv->showing;
	_tmp12_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = old_size;
	if (_tmp13_ == _tmp14_) {
		NoiseFastGridModel* _tmp15_;
		GeeHashMap* _tmp16_;
		_tmp15_ = self->priv->fm;
		_tmp16_ = self->priv->showing;
		noise_fast_grid_model_set_table (_tmp15_, _tmp16_);
		gtk_widget_queue_draw ((GtkWidget*) self);
	} else {
		gint _tmp17_;
		_tmp17_ = old_size;
		if (_tmp17_ == 0) {
			NoiseFastGridModel* _tmp18_;
			GeeHashMap* _tmp19_;
			NoiseFastGridModel* _tmp20_;
			gtk_icon_view_set_model ((GtkIconView*) self, NULL);
			_tmp18_ = self->priv->fm;
			_tmp19_ = self->priv->showing;
			noise_fast_grid_model_set_table (_tmp18_, _tmp19_);
			_tmp20_ = self->priv->fm;
			gtk_icon_view_set_model ((GtkIconView*) self, (GtkTreeModel*) _tmp20_);
		} else {
			gint _tmp21_;
			GeeHashMap* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			_tmp21_ = old_size;
			_tmp22_ = self->priv->showing;
			_tmp23_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp22_);
			_tmp24_ = _tmp23_;
			if (_tmp21_ > _tmp24_) {
				NoiseFastGridModel* _tmp34_;
				GeeHashMap* _tmp35_;
				while (TRUE) {
					NoiseFastGridModel* _tmp25_;
					GeeHashMap* _tmp26_;
					gint _tmp27_;
					gint _tmp28_;
					GtkTreeIter iter = {0};
					NoiseFastGridModel* _tmp29_;
					NoiseFastGridModel* _tmp30_;
					GtkTreeIter _tmp31_ = {0};
					NoiseFastGridModel* _tmp32_;
					GtkTreeIter _tmp33_;
					_tmp25_ = self->priv->fm;
					_tmp26_ = self->priv->showing;
					_tmp27_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp26_);
					_tmp28_ = _tmp27_;
					if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp25_, NULL) > _tmp28_)) {
						break;
					}
					_tmp29_ = self->priv->fm;
					_tmp30_ = self->priv->fm;
					gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp29_, &_tmp31_, NULL, gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp30_, NULL) - 1);
					iter = _tmp31_;
					_tmp32_ = self->priv->fm;
					_tmp33_ = iter;
					noise_fast_grid_model_remove (_tmp32_, &_tmp33_);
				}
				_tmp34_ = self->priv->fm;
				_tmp35_ = self->priv->showing;
				noise_fast_grid_model_set_table (_tmp34_, _tmp35_);
				gtk_widget_queue_draw ((GtkWidget*) self);
			} else {
				GeeHashMap* _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				gint _tmp39_;
				_tmp36_ = self->priv->showing;
				_tmp37_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp36_);
				_tmp38_ = _tmp37_;
				_tmp39_ = old_size;
				if (_tmp38_ > _tmp39_) {
					GtkTreeIter iter = {0};
					NoiseFastGridModel* _tmp46_;
					GeeHashMap* _tmp47_;
					while (TRUE) {
						NoiseFastGridModel* _tmp40_;
						GeeHashMap* _tmp41_;
						gint _tmp42_;
						gint _tmp43_;
						NoiseFastGridModel* _tmp44_;
						GtkTreeIter _tmp45_ = {0};
						_tmp40_ = self->priv->fm;
						_tmp41_ = self->priv->showing;
						_tmp42_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp41_);
						_tmp43_ = _tmp42_;
						if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp40_, NULL) < _tmp43_)) {
							break;
						}
						_tmp44_ = self->priv->fm;
						noise_fast_grid_model_append (_tmp44_, &_tmp45_);
						iter = _tmp45_;
					}
					_tmp46_ = self->priv->fm;
					_tmp47_ = self->priv->showing;
					noise_fast_grid_model_set_table (_tmp46_, _tmp47_);
					gtk_widget_queue_draw ((GtkWidget*) self);
				}
			}
		}
	}
}


static void
noise_fast_grid_resort (NoiseFastGrid* self)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->table;
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	noise_fast_grid_quicksort (self, 0, _tmp2_ - 1);
	noise_fast_grid_do_search (self);
}


static void
noise_fast_grid_swap (NoiseFastGrid* self,
                      gint a,
                      gint b)
{
	GObject* temp = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	gpointer _tmp4_;
	GObject* _tmp5_;
	GeeHashMap* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->table;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) a));
	temp = (GObject*) _tmp1_;
	_tmp2_ = self->priv->table;
	_tmp3_ = self->priv->table;
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) b));
	_tmp5_ = (GObject*) _tmp4_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) a), _tmp5_);
	_g_object_unref0 (_tmp5_);
	_tmp6_ = self->priv->table;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, (gpointer) ((gintptr) b), temp);
	_g_object_unref0 (temp);
}


static void
noise_fast_grid_quicksort (NoiseFastGrid* self,
                           gint start,
                           gint end)
{
	GObject* pivot = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	gint i = 0;
	gint j = 0;
	gint _tmp30_;
	gint _tmp32_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->table;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) ((start + end) / 2)));
	pivot = (GObject*) _tmp1_;
	i = start;
	j = end;
	while (TRUE) {
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp24_;
		gint _tmp25_;
		_tmp2_ = i;
		_tmp3_ = j;
		if (!(_tmp2_ <= _tmp3_)) {
			break;
		}
		while (TRUE) {
			gboolean _tmp4_ = FALSE;
			gint _tmp5_;
			gint _tmp13_;
			_tmp5_ = i;
			if (_tmp5_ < end) {
				NoiseFastGridSortCompareFunc _tmp6_;
				void* _tmp6__target;
				NoiseFastGridSortCompareFunc _tmp7_;
				void* _tmp7__target;
				GeeHashMap* _tmp8_;
				gint _tmp9_;
				gpointer _tmp10_;
				GObject* _tmp11_;
				GObject* _tmp12_;
				_tmp6_ = noise_fast_grid_get_compare_func (self, &_tmp6__target);
				_tmp7_ = _tmp6_;
				_tmp7__target = _tmp6__target;
				_tmp8_ = self->priv->table;
				_tmp9_ = i;
				_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp8_, (gpointer) ((gintptr) _tmp9_));
				_tmp11_ = (GObject*) _tmp10_;
				_tmp12_ = pivot;
				_tmp4_ = _tmp7_ (_tmp11_, _tmp12_, _tmp7__target) < 0;
				_g_object_unref0 (_tmp11_);
			} else {
				_tmp4_ = FALSE;
			}
			if (!_tmp4_) {
				break;
			}
			_tmp13_ = i;
			i = _tmp13_ + 1;
		}
		while (TRUE) {
			gboolean _tmp14_ = FALSE;
			gint _tmp15_;
			gint _tmp23_;
			_tmp15_ = j;
			if (_tmp15_ > start) {
				NoiseFastGridSortCompareFunc _tmp16_;
				void* _tmp16__target;
				NoiseFastGridSortCompareFunc _tmp17_;
				void* _tmp17__target;
				GeeHashMap* _tmp18_;
				gint _tmp19_;
				gpointer _tmp20_;
				GObject* _tmp21_;
				GObject* _tmp22_;
				_tmp16_ = noise_fast_grid_get_compare_func (self, &_tmp16__target);
				_tmp17_ = _tmp16_;
				_tmp17__target = _tmp16__target;
				_tmp18_ = self->priv->table;
				_tmp19_ = j;
				_tmp20_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, (gpointer) ((gintptr) _tmp19_));
				_tmp21_ = (GObject*) _tmp20_;
				_tmp22_ = pivot;
				_tmp14_ = _tmp17_ (_tmp21_, _tmp22_, _tmp17__target) > 0;
				_g_object_unref0 (_tmp21_);
			} else {
				_tmp14_ = FALSE;
			}
			if (!_tmp14_) {
				break;
			}
			_tmp23_ = j;
			j = _tmp23_ - 1;
		}
		_tmp24_ = i;
		_tmp25_ = j;
		if (_tmp24_ <= _tmp25_) {
			gint _tmp26_;
			gint _tmp27_;
			gint _tmp28_;
			gint _tmp29_;
			_tmp26_ = i;
			_tmp27_ = j;
			noise_fast_grid_swap (self, _tmp26_, _tmp27_);
			_tmp28_ = i;
			i = _tmp28_ + 1;
			_tmp29_ = j;
			j = _tmp29_ - 1;
		}
	}
	_tmp30_ = j;
	if (start < _tmp30_) {
		gint _tmp31_;
		_tmp31_ = j;
		noise_fast_grid_quicksort (self, start, _tmp31_);
	}
	_tmp32_ = i;
	if (_tmp32_ < end) {
		gint _tmp33_;
		_tmp33_ = i;
		noise_fast_grid_quicksort (self, _tmp33_, end);
	}
	_g_object_unref0 (pivot);
}


static void
noise_fast_grid_real_size_allocate (GtkWidget* base,
                                    GtkAllocation* alloc)
{
	NoiseFastGrid * self;
	GtkRequisition minimum_size = {0};
	GtkRequisition natural_size = {0};
	GtkCellRenderer* _tmp0_;
	GtkRequisition _tmp1_ = {0};
	GtkRequisition _tmp2_ = {0};
	gint item_width = 0;
	GtkRequisition _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint total_width = 0;
	GtkAllocation _tmp7_;
	gint _tmp8_;
	gdouble num = 0.0;
	gint _tmp9_;
	gint _tmp10_;
	gdouble denom = 0.0;
	gint _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gdouble _tmp21_;
	gdouble _tmp22_;
	GtkAllocation _tmp23_;
	self = (NoiseFastGrid*) base;
	g_return_if_fail (alloc != NULL);
	_tmp0_ = self->priv->cell_renderer;
	gtk_cell_renderer_get_preferred_size (_tmp0_, (GtkWidget*) self, &_tmp1_, &_tmp2_);
	minimum_size = _tmp1_;
	natural_size = _tmp2_;
	_tmp3_ = minimum_size;
	_tmp4_ = _tmp3_.width;
	item_width = _tmp4_;
	_tmp5_ = item_width;
	if (_tmp5_ <= 0) {
		GtkAllocation _tmp6_;
		_tmp6_ = *alloc;
		GTK_WIDGET_CLASS (noise_fast_grid_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_icon_view_get_type (), GtkIconView), &_tmp6_);
	}
	_tmp7_ = *alloc;
	_tmp8_ = _tmp7_.width;
	total_width = _tmp8_;
	_tmp9_ = gtk_icon_view_get_margin ((GtkIconView*) self);
	_tmp10_ = _tmp9_;
	num = (gdouble) (total_width - (2 * _tmp10_));
	_tmp11_ = item_width;
	denom = (gdouble) _tmp11_;
	_tmp12_ = num;
	_tmp13_ = denom;
	gtk_icon_view_set_columns ((GtkIconView*) self, (gint) (_tmp12_ / _tmp13_));
	_tmp14_ = gtk_icon_view_get_columns ((GtkIconView*) self);
	_tmp15_ = _tmp14_;
	_tmp16_ = item_width;
	_tmp17_ = gtk_icon_view_get_margin ((GtkIconView*) self);
	_tmp18_ = _tmp17_;
	num = (gdouble) ((total_width - (_tmp15_ * _tmp16_)) - (2 * _tmp18_));
	_tmp19_ = gtk_icon_view_get_columns ((GtkIconView*) self);
	_tmp20_ = _tmp19_;
	denom = (gdouble) (_tmp20_ - 1);
	_tmp21_ = num;
	_tmp22_ = denom;
	gtk_icon_view_set_column_spacing ((GtkIconView*) self, (gint) (_tmp21_ / _tmp22_));
	_tmp23_ = *alloc;
	GTK_WIDGET_CLASS (noise_fast_grid_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_icon_view_get_type (), GtkIconView), &_tmp23_);
}


NoiseFastGrid*
noise_fast_grid_construct (GType object_type)
{
	NoiseFastGrid * self = NULL;
	self = (NoiseFastGrid*) g_object_new (object_type, NULL);
	return self;
}


NoiseFastGrid*
noise_fast_grid_new (void)
{
	return noise_fast_grid_construct (NOISE_TYPE_FAST_GRID);
}


NoiseFastGridViewSearchFunc
noise_fast_grid_get_search_func (NoiseFastGrid* self,
                                 gpointer* result_target)
{
	NoiseFastGridViewSearchFunc result;
	NoiseFastGridViewSearchFunc _tmp0_;
	void* _tmp0__target;
	NoiseFastGridViewSearchFunc _tmp1_;
	void* _tmp1__target;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_search_func;
	_tmp0__target = self->priv->_search_func_target;
	_tmp1_ = _tmp0_;
	_tmp1__target = _tmp0__target;
	*result_target = _tmp1__target;
	result = _tmp1_;
	return result;
}


void
noise_fast_grid_set_search_func (NoiseFastGrid* self,
                                 NoiseFastGridViewSearchFunc value,
                                 gpointer value_target)
{
	g_return_if_fail (self != NULL);
	self->priv->_search_func = value;
	self->priv->_search_func_target = value_target;
}


NoiseFastGridSortCompareFunc
noise_fast_grid_get_compare_func (NoiseFastGrid* self,
                                  gpointer* result_target)
{
	NoiseFastGridSortCompareFunc result;
	NoiseFastGridSortCompareFunc _tmp0_;
	void* _tmp0__target;
	NoiseFastGridSortCompareFunc _tmp1_;
	void* _tmp1__target;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_compare_func;
	_tmp0__target = self->priv->_compare_func_target;
	_tmp1_ = _tmp0_;
	_tmp1__target = _tmp0__target;
	*result_target = _tmp1__target;
	result = _tmp1_;
	return result;
}


void
noise_fast_grid_set_compare_func (NoiseFastGrid* self,
                                  NoiseFastGridSortCompareFunc value,
                                  gpointer value_target)
{
	g_return_if_fail (self != NULL);
	self->priv->_compare_func = value;
	self->priv->_compare_func_target = value_target;
}


static GObject *
noise_fast_grid_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseFastGrid * self;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	NoiseFastGridModel* _tmp2_;
	GeeHashMap* _tmp3_;
	NoiseFastGridModel* _tmp4_;
	NoiseWidgetsTileRenderer* _tmp5_;
	GtkCellRenderer* _tmp6_;
	GtkCellRenderer* _tmp7_;
	parent_class = G_OBJECT_CLASS (noise_fast_grid_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_FAST_GRID, NoiseFastGrid);
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->table);
	self->priv->table = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->showing);
	self->priv->showing = _tmp1_;
	_tmp2_ = noise_fast_grid_model_new ();
	_g_object_unref0 (self->priv->fm);
	self->priv->fm = _tmp2_;
	_tmp3_ = self->priv->table;
	noise_fast_grid_set_table (self, _tmp3_, TRUE);
	_tmp4_ = self->priv->fm;
	gtk_icon_view_set_model ((GtkIconView*) self, (GtkTreeModel*) _tmp4_);
	_tmp5_ = noise_widgets_tile_renderer_new ();
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->cell_renderer);
	self->priv->cell_renderer = (GtkCellRenderer*) _tmp5_;
	_tmp6_ = self->priv->cell_renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) self, _tmp6_, FALSE);
	gtk_icon_view_set_activate_on_single_click ((GtkIconView*) self, TRUE);
	_tmp7_ = self->priv->cell_renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) self, _tmp7_, "album", 0);
	gtk_icon_view_set_tooltip_column ((GtkIconView*) self, 1);
	gtk_icon_view_set_item_padding ((GtkIconView*) self, 0);
	gtk_icon_view_set_margin ((GtkIconView*) self, 24);
	return obj;
}


static void
noise_fast_grid_class_init (NoiseFastGridClass * klass)
{
	noise_fast_grid_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseFastGrid_private_offset);
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget *, GtkAllocation*)) noise_fast_grid_real_size_allocate;
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_fast_grid_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_fast_grid_set_property;
	G_OBJECT_CLASS (klass)->constructor = noise_fast_grid_constructor;
	G_OBJECT_CLASS (klass)->finalize = noise_fast_grid_finalize;
}


static void
noise_fast_grid_instance_init (NoiseFastGrid * self)
{
	self->priv = noise_fast_grid_get_instance_private (self);
	self->research_needed = FALSE;
}


static void
noise_fast_grid_finalize (GObject * obj)
{
	NoiseFastGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_FAST_GRID, NoiseFastGrid);
	_g_object_unref0 (self->priv->cell_renderer);
	_g_object_unref0 (self->priv->fm);
	_g_object_unref0 (self->priv->table);
	_g_object_unref0 (self->priv->showing);
	G_OBJECT_CLASS (noise_fast_grid_parent_class)->finalize (obj);
}


GType
noise_fast_grid_get_type (void)
{
	static volatile gsize noise_fast_grid_type_id__volatile = 0;
	if (g_once_init_enter (&noise_fast_grid_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseFastGridClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_fast_grid_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseFastGrid), 0, (GInstanceInitFunc) noise_fast_grid_instance_init, NULL };
		GType noise_fast_grid_type_id;
		noise_fast_grid_type_id = g_type_register_static (gtk_icon_view_get_type (), "NoiseFastGrid", &g_define_type_info, 0);
		NoiseFastGrid_private_offset = g_type_add_instance_private (noise_fast_grid_type_id, sizeof (NoiseFastGridPrivate));
		g_once_init_leave (&noise_fast_grid_type_id__volatile, noise_fast_grid_type_id);
	}
	return noise_fast_grid_type_id__volatile;
}


static void
_vala_noise_fast_grid_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	NoiseFastGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_FAST_GRID, NoiseFastGrid);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_fast_grid_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	NoiseFastGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_FAST_GRID, NoiseFastGrid);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



