/* TileRenderer.c generated by valac 0.41.91, the Vala compiler
 * generated from TileRenderer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "io.elementary.music-core.h"
#include <pango/pango.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <granite.h>
#include <float.h>
#include <math.h>


#define NOISE_WIDGETS_TYPE_TILE_RENDERER (noise_widgets_tile_renderer_get_type ())
#define NOISE_WIDGETS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRenderer))
#define NOISE_WIDGETS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRendererClass))
#define NOISE_WIDGETS_IS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_WIDGETS_TYPE_TILE_RENDERER))
#define NOISE_WIDGETS_IS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_WIDGETS_TYPE_TILE_RENDERER))
#define NOISE_WIDGETS_TILE_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRendererClass))

typedef struct _NoiseWidgetsTileRenderer NoiseWidgetsTileRenderer;
typedef struct _NoiseWidgetsTileRendererClass NoiseWidgetsTileRendererClass;
typedef struct _NoiseWidgetsTileRendererPrivate NoiseWidgetsTileRendererPrivate;
enum  {
	NOISE_WIDGETS_TILE_RENDERER_0_PROPERTY,
	NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY,
	NOISE_WIDGETS_TILE_RENDERER_NUM_PROPERTIES
};
static GParamSpec* noise_widgets_tile_renderer_properties[NOISE_WIDGETS_TILE_RENDERER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NoiseWidgetsTileRenderer {
	GtkCellRenderer parent_instance;
	NoiseWidgetsTileRendererPrivate * priv;
};

struct _NoiseWidgetsTileRendererClass {
	GtkCellRendererClass parent_class;
};

struct _NoiseWidgetsTileRendererPrivate {
	NoiseAlbum* _album;
	PangoLayout* title_text_layout;
	PangoLayout* subtitle_text_layout;
	GtkBorder margin;
	GtkBorder padding;
	GtkBorder border;
	GdkPixbuf* pixbuf;
};


static gint NoiseWidgetsTileRenderer_private_offset;
static gpointer noise_widgets_tile_renderer_parent_class = NULL;

GType noise_widgets_tile_renderer_get_type (void) G_GNUC_CONST;
NoiseWidgetsTileRenderer* noise_widgets_tile_renderer_new (void);
NoiseWidgetsTileRenderer* noise_widgets_tile_renderer_construct (GType object_type);
static void __lambda51_ (NoiseWidgetsTileRenderer* self);
static void ___lambda51__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void noise_widgets_tile_renderer_real_get_size (GtkCellRenderer* base,
                                                GtkWidget* widget,
                                                GdkRectangle* cell_area,
                                                gint* x_offset,
                                                gint* y_offset,
                                                gint* width,
                                                gint* height);
static GtkSizeRequestMode noise_widgets_tile_renderer_real_get_request_mode (GtkCellRenderer* base);
static void noise_widgets_tile_renderer_real_get_preferred_width (GtkCellRenderer* base,
                                                           GtkWidget* widget,
                                                           gint* minimum_size,
                                                           gint* natural_size);
static void noise_widgets_tile_renderer_update_layout_properties (NoiseWidgetsTileRenderer* self,
                                                           GtkWidget* widget);
static gint noise_widgets_tile_renderer_compute_total_image_width (NoiseWidgetsTileRenderer* self);
static void noise_widgets_tile_renderer_real_get_preferred_height_for_width (GtkCellRenderer* base,
                                                                      GtkWidget* widget,
                                                                      gint width,
                                                                      gint* minimum_height,
                                                                      gint* natural_height);
static gint noise_widgets_tile_renderer_compute_total_image_height (NoiseWidgetsTileRenderer* self);
static void noise_widgets_tile_renderer_real_render (GtkCellRenderer* base,
                                              cairo_t* cr,
                                              GtkWidget* widget,
                                              GdkRectangle* bg_area,
                                              GdkRectangle* cell_area,
                                              GtkCellRendererState flags);
static void noise_widgets_tile_renderer_render_image (NoiseWidgetsTileRenderer* self,
                                               GtkStyleContext* ctx,
                                               cairo_t* cr,
                                               gint* x,
                                               gint* y,
                                               gint width,
                                               GtkCellRendererState flags);
static void noise_widgets_tile_renderer_render_title (NoiseWidgetsTileRenderer* self,
                                               GtkStyleContext* ctx,
                                               cairo_t* cr,
                                               gint x,
                                               gint* y,
                                               gint width);
static void noise_widgets_tile_renderer_render_subtitle (NoiseWidgetsTileRenderer* self,
                                                  GtkStyleContext* ctx,
                                                  cairo_t* cr,
                                                  gint x,
                                                  gint y,
                                                  gint width);
NoiseAlbum* noise_widgets_tile_renderer_get_album (NoiseWidgetsTileRenderer* self);
void noise_widgets_tile_renderer_set_album (NoiseWidgetsTileRenderer* self,
                                            NoiseAlbum* value);
static void noise_widgets_tile_renderer_finalize (GObject * obj);
static void _vala_noise_widgets_tile_renderer_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_noise_widgets_tile_renderer_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);


static inline gpointer
noise_widgets_tile_renderer_get_instance_private (NoiseWidgetsTileRenderer* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseWidgetsTileRenderer_private_offset);
}


static void
__lambda51_ (NoiseWidgetsTileRenderer* self)
{
	_g_object_unref0 (self->priv->pixbuf);
	self->priv->pixbuf = NULL;
}


static void
___lambda51__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda51_ ((NoiseWidgetsTileRenderer*) self);
}


NoiseWidgetsTileRenderer*
noise_widgets_tile_renderer_construct (GType object_type)
{
	NoiseWidgetsTileRenderer * self = NULL;
	self = (NoiseWidgetsTileRenderer*) g_object_new (object_type, NULL);
	g_signal_connect_object ((GObject*) self, "notify::album", (GCallback) ___lambda51__g_object_notify, self, 0);
	return self;
}


NoiseWidgetsTileRenderer*
noise_widgets_tile_renderer_new (void)
{
	return noise_widgets_tile_renderer_construct (NOISE_WIDGETS_TYPE_TILE_RENDERER);
}


static void
noise_widgets_tile_renderer_real_get_size (GtkCellRenderer* base,
                                           GtkWidget* widget,
                                           GdkRectangle* cell_area,
                                           gint* x_offset,
                                           gint* y_offset,
                                           gint* width,
                                           gint* height)
{
	NoiseWidgetsTileRenderer * self;
	gint _vala_x_offset = 0;
	gint _vala_y_offset = 0;
	gint _vala_width = 0;
	gint _vala_height = 0;
	self = (NoiseWidgetsTileRenderer*) base;
	g_return_if_fail (widget != NULL);
	_vala_height = 0;
	_vala_width = _vala_height;
	_vala_y_offset = _vala_width;
	_vala_x_offset = _vala_y_offset;
	if (x_offset) {
		*x_offset = _vala_x_offset;
	}
	if (y_offset) {
		*y_offset = _vala_y_offset;
	}
	if (width) {
		*width = _vala_width;
	}
	if (height) {
		*height = _vala_height;
	}
}


static GtkSizeRequestMode
noise_widgets_tile_renderer_real_get_request_mode (GtkCellRenderer* base)
{
	NoiseWidgetsTileRenderer * self;
	GtkSizeRequestMode result = 0;
	self = (NoiseWidgetsTileRenderer*) base;
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
	return result;
}


static void
noise_widgets_tile_renderer_real_get_preferred_width (GtkCellRenderer* base,
                                                      GtkWidget* widget,
                                                      gint* minimum_size,
                                                      gint* natural_size)
{
	NoiseWidgetsTileRenderer * self;
	gint _vala_minimum_size = 0;
	gint _vala_natural_size = 0;
	gint x_padding = 0;
	gint _tmp0_ = 0;
	gint width = 0;
	GtkBorder _tmp1_;
	gint16 _tmp2_;
	GtkBorder _tmp3_;
	gint16 _tmp4_;
	GtkBorder _tmp5_;
	gint16 _tmp6_;
	GtkBorder _tmp7_;
	gint16 _tmp8_;
	GtkBorder _tmp9_;
	gint16 _tmp10_;
	GtkBorder _tmp11_;
	gint16 _tmp12_;
	self = (NoiseWidgetsTileRenderer*) base;
	g_return_if_fail (widget != NULL);
	noise_widgets_tile_renderer_update_layout_properties (self, widget);
	gtk_cell_renderer_get_padding ((GtkCellRenderer*) self, &_tmp0_, NULL);
	x_padding = _tmp0_;
	_tmp1_ = self->priv->margin;
	_tmp2_ = _tmp1_.left;
	_tmp3_ = self->priv->margin;
	_tmp4_ = _tmp3_.right;
	_tmp5_ = self->priv->padding;
	_tmp6_ = _tmp5_.left;
	_tmp7_ = self->priv->padding;
	_tmp8_ = _tmp7_.right;
	_tmp9_ = self->priv->border;
	_tmp10_ = _tmp9_.left;
	_tmp11_ = self->priv->border;
	_tmp12_ = _tmp11_.right;
	width = ((((((noise_widgets_tile_renderer_compute_total_image_width (self) + _tmp2_) + _tmp4_) + _tmp6_) + _tmp8_) + _tmp10_) + _tmp12_) + (2 * x_padding);
	_vala_natural_size = width;
	_vala_minimum_size = _vala_natural_size;
	if (minimum_size) {
		*minimum_size = _vala_minimum_size;
	}
	if (natural_size) {
		*natural_size = _vala_natural_size;
	}
}


static void
noise_widgets_tile_renderer_real_get_preferred_height_for_width (GtkCellRenderer* base,
                                                                 GtkWidget* widget,
                                                                 gint width,
                                                                 gint* minimum_height,
                                                                 gint* natural_height)
{
	NoiseWidgetsTileRenderer * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	gint y_padding = 0;
	gint _tmp0_ = 0;
	gint subtitle_height = 0;
	gint title_height = 0;
	PangoLayout* _tmp1_;
	gint _tmp2_ = 0;
	PangoLayout* _tmp3_;
	gint _tmp4_ = 0;
	gint height = 0;
	GtkBorder _tmp5_;
	gint16 _tmp6_;
	GtkBorder _tmp7_;
	gint16 _tmp8_;
	GtkBorder _tmp9_;
	gint16 _tmp10_;
	GtkBorder _tmp11_;
	gint16 _tmp12_;
	GtkBorder _tmp13_;
	gint16 _tmp14_;
	GtkBorder _tmp15_;
	gint16 _tmp16_;
	self = (NoiseWidgetsTileRenderer*) base;
	g_return_if_fail (widget != NULL);
	noise_widgets_tile_renderer_update_layout_properties (self, widget);
	gtk_cell_renderer_get_padding ((GtkCellRenderer*) self, NULL, &_tmp0_);
	y_padding = _tmp0_;
	_tmp1_ = self->priv->title_text_layout;
	pango_layout_get_pixel_size (_tmp1_, NULL, &_tmp2_);
	title_height = _tmp2_;
	_tmp3_ = self->priv->subtitle_text_layout;
	pango_layout_get_pixel_size (_tmp3_, NULL, &_tmp4_);
	subtitle_height = _tmp4_;
	_tmp5_ = self->priv->margin;
	_tmp6_ = _tmp5_.top;
	_tmp7_ = self->priv->margin;
	_tmp8_ = _tmp7_.bottom;
	_tmp9_ = self->priv->padding;
	_tmp10_ = _tmp9_.top;
	_tmp11_ = self->priv->padding;
	_tmp12_ = _tmp11_.bottom;
	_tmp13_ = self->priv->border;
	_tmp14_ = _tmp13_.top;
	_tmp15_ = self->priv->border;
	_tmp16_ = _tmp15_.bottom;
	height = ((((((((noise_widgets_tile_renderer_compute_total_image_height (self) + title_height) + subtitle_height) + _tmp6_) + (2 * _tmp8_)) + _tmp10_) + _tmp12_) + _tmp14_) + _tmp16_) + (2 * y_padding);
	_vala_natural_height = height;
	_vala_minimum_height = _vala_natural_height;
	if (minimum_height) {
		*minimum_height = _vala_minimum_height;
	}
	if (natural_height) {
		*natural_height = _vala_natural_height;
	}
}


static void
noise_widgets_tile_renderer_real_render (GtkCellRenderer* base,
                                         cairo_t* cr,
                                         GtkWidget* widget,
                                         GdkRectangle* bg_area,
                                         GdkRectangle* cell_area,
                                         GtkCellRendererState flags)
{
	NoiseWidgetsTileRenderer * self;
	GdkRectangle aligned_area = {0};
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_ = {0};
	gint x = 0;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	gint y = 0;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	gint width = 0;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	gint height = 0;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GtkBorder _tmp11_;
	gint16 _tmp12_;
	GtkBorder _tmp13_;
	gint16 _tmp14_;
	GtkBorder _tmp15_;
	gint16 _tmp16_;
	gint _tmp17_;
	GtkBorder _tmp18_;
	gint16 _tmp19_;
	GtkBorder _tmp20_;
	gint16 _tmp21_;
	GtkBorder _tmp22_;
	gint16 _tmp23_;
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp24_;
	gint _tmp25_;
	GtkBorder _tmp26_;
	gint16 _tmp27_;
	GtkBorder _tmp28_;
	gint16 _tmp29_;
	GtkBorder _tmp30_;
	gint16 _tmp31_;
	GtkBorder _tmp32_;
	gint16 _tmp33_;
	GtkBorder _tmp34_;
	gint16 _tmp35_;
	GtkBorder _tmp36_;
	gint16 _tmp37_;
	gint _tmp38_;
	GtkBorder _tmp39_;
	gint16 _tmp40_;
	GtkBorder _tmp41_;
	gint16 _tmp42_;
	GtkBorder _tmp43_;
	gint16 _tmp44_;
	GtkBorder _tmp45_;
	gint16 _tmp46_;
	GtkBorder _tmp47_;
	gint16 _tmp48_;
	GtkBorder _tmp49_;
	gint16 _tmp50_;
	gint _tmp51_;
	gint _tmp52_;
	gint _tmp53_;
	gint _tmp54_;
	gint _tmp55_;
	gint _tmp56_;
	self = (NoiseWidgetsTileRenderer*) base;
	g_return_if_fail (cr != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (bg_area != NULL);
	g_return_if_fail (cell_area != NULL);
	noise_widgets_tile_renderer_update_layout_properties (self, widget);
	_tmp0_ = *cell_area;
	gtk_cell_renderer_get_aligned_area ((GtkCellRenderer*) self, widget, flags, &_tmp0_, &_tmp1_);
	aligned_area = _tmp1_;
	_tmp2_ = aligned_area;
	_tmp3_ = _tmp2_.x;
	x = _tmp3_;
	_tmp4_ = aligned_area;
	_tmp5_ = _tmp4_.y;
	y = _tmp5_;
	_tmp6_ = aligned_area;
	_tmp7_ = _tmp6_.width;
	width = _tmp7_;
	_tmp8_ = aligned_area;
	_tmp9_ = _tmp8_.height;
	height = _tmp9_;
	_tmp10_ = x;
	_tmp11_ = self->priv->margin;
	_tmp12_ = _tmp11_.left;
	_tmp13_ = self->priv->border;
	_tmp14_ = _tmp13_.left;
	_tmp15_ = self->priv->padding;
	_tmp16_ = _tmp15_.left;
	x = _tmp10_ + ((_tmp12_ + _tmp14_) + _tmp16_);
	_tmp17_ = y;
	_tmp18_ = self->priv->margin;
	_tmp19_ = _tmp18_.top;
	_tmp20_ = self->priv->border;
	_tmp21_ = _tmp20_.top;
	_tmp22_ = self->priv->padding;
	_tmp23_ = _tmp22_.top;
	y = _tmp17_ + ((_tmp19_ + _tmp21_) + _tmp23_);
	_tmp24_ = gtk_widget_get_style_context (widget);
	ctx = _tmp24_;
	_tmp25_ = width;
	_tmp26_ = self->priv->margin;
	_tmp27_ = _tmp26_.left;
	_tmp28_ = self->priv->margin;
	_tmp29_ = _tmp28_.right;
	_tmp30_ = self->priv->border;
	_tmp31_ = _tmp30_.left;
	_tmp32_ = self->priv->border;
	_tmp33_ = _tmp32_.right;
	_tmp34_ = self->priv->padding;
	_tmp35_ = _tmp34_.left;
	_tmp36_ = self->priv->padding;
	_tmp37_ = _tmp36_.right;
	width = _tmp25_ - (((((_tmp27_ + _tmp29_) + _tmp31_) + _tmp33_) + _tmp35_) + _tmp37_);
	_tmp38_ = height;
	_tmp39_ = self->priv->margin;
	_tmp40_ = _tmp39_.top;
	_tmp41_ = self->priv->margin;
	_tmp42_ = _tmp41_.bottom;
	_tmp43_ = self->priv->border;
	_tmp44_ = _tmp43_.top;
	_tmp45_ = self->priv->border;
	_tmp46_ = _tmp45_.bottom;
	_tmp47_ = self->priv->padding;
	_tmp48_ = _tmp47_.top;
	_tmp49_ = self->priv->padding;
	_tmp50_ = _tmp49_.bottom;
	height = _tmp38_ - (((((_tmp40_ + _tmp42_) + _tmp44_) + _tmp46_) + _tmp48_) + _tmp50_);
	_tmp51_ = width;
	noise_widgets_tile_renderer_render_image (self, ctx, cr, &x, &y, _tmp51_, flags);
	_tmp52_ = x;
	_tmp53_ = width;
	noise_widgets_tile_renderer_render_title (self, ctx, cr, _tmp52_, &y, _tmp53_);
	_tmp54_ = x;
	_tmp55_ = y;
	_tmp56_ = width;
	noise_widgets_tile_renderer_render_subtitle (self, ctx, cr, _tmp54_, _tmp55_, _tmp56_);
}


static void
noise_widgets_tile_renderer_render_image (NoiseWidgetsTileRenderer* self,
                                          GtkStyleContext* ctx,
                                          cairo_t* cr,
                                          gint* x,
                                          gint* y,
                                          gint width,
                                          GtkCellRendererState flags)
{
	gint image_width = 0;
	gint image_height = 0;
	gint _tmp0_;
	GdkPixbuf* _tmp1_;
	GtkBorder _tmp3_;
	gint16 _tmp4_;
	GtkBorder _tmp5_;
	gint16 _tmp6_;
	GtkBorder _tmp7_;
	gint16 _tmp8_;
	GtkBorder _tmp9_;
	gint16 _tmp10_;
	GtkBorder _tmp11_;
	gint16 _tmp12_;
	GtkBorder _tmp13_;
	gint16 _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	GtkBorder _tmp17_;
	gint16 _tmp18_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (cr != NULL);
	image_width = noise_widgets_tile_renderer_compute_total_image_width (self);
	image_height = noise_widgets_tile_renderer_compute_total_image_height (self);
	_tmp0_ = image_width;
	*x = (*x) + ((width - _tmp0_) / 2);
	gtk_style_context_save (ctx);
	gtk_style_context_add_class (ctx, "album");
	gtk_style_context_add_class (ctx, GRANITE_STYLE_CLASS_CARD);
	gtk_render_background (ctx, cr, (gdouble) (*x), (gdouble) (*y), (gdouble) 128, (gdouble) 128);
	_tmp1_ = self->priv->pixbuf;
	if (_tmp1_ != NULL) {
		GdkPixbuf* _tmp2_;
		_tmp2_ = self->priv->pixbuf;
		gtk_render_icon (ctx, cr, _tmp2_, (gdouble) (*x), (gdouble) (*y));
	}
	cairo_fill_preserve (cr);
	_tmp3_ = self->priv->border;
	_tmp4_ = _tmp3_.left;
	_tmp5_ = self->priv->border;
	_tmp6_ = _tmp5_.top;
	_tmp7_ = self->priv->border;
	_tmp8_ = _tmp7_.left;
	_tmp9_ = self->priv->border;
	_tmp10_ = _tmp9_.right;
	_tmp11_ = self->priv->border;
	_tmp12_ = _tmp11_.top;
	_tmp13_ = self->priv->border;
	_tmp14_ = _tmp13_.bottom;
	gtk_render_frame (ctx, cr, (gdouble) ((*x) - _tmp4_), (gdouble) ((*y) - _tmp6_), (gdouble) ((128 + _tmp8_) + _tmp10_), (gdouble) ((128 + _tmp12_) + _tmp14_));
	gtk_style_context_restore (ctx);
	_tmp15_ = image_height;
	*y = (*y) + _tmp15_;
	_tmp16_ = image_width;
	_tmp17_ = self->priv->margin;
	_tmp18_ = _tmp17_.left;
	*x = (*x) + (((_tmp16_ - 128) / 2) - _tmp18_);
}


static void
noise_widgets_tile_renderer_render_title (NoiseWidgetsTileRenderer* self,
                                          GtkStyleContext* ctx,
                                          cairo_t* cr,
                                          gint x,
                                          gint* y,
                                          gint width)
{
	PangoLayout* _tmp0_;
	gint title_height = 0;
	PangoLayout* _tmp1_;
	gint _tmp2_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (cr != NULL);
	gtk_style_context_save (ctx);
	gtk_style_context_add_class (ctx, "h4");
	_tmp0_ = self->priv->title_text_layout;
	gtk_render_layout (ctx, cr, (gdouble) x, (gdouble) (*y), _tmp0_);
	gtk_style_context_restore (ctx);
	_tmp1_ = self->priv->title_text_layout;
	pango_layout_get_pixel_size (_tmp1_, NULL, &_tmp2_);
	title_height = _tmp2_;
	*y = (*y) + title_height;
}


static void
noise_widgets_tile_renderer_render_subtitle (NoiseWidgetsTileRenderer* self,
                                             GtkStyleContext* ctx,
                                             cairo_t* cr,
                                             gint x,
                                             gint y,
                                             gint width)
{
	PangoLayout* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (cr != NULL);
	_tmp0_ = self->priv->subtitle_text_layout;
	gtk_render_layout (ctx, cr, (gdouble) x, (gdouble) y, _tmp0_);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
noise_widgets_tile_renderer_update_layout_properties (NoiseWidgetsTileRenderer* self,
                                                      GtkWidget* widget)
{
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStateFlags state = 0;
	NoiseAlbum* _tmp2_;
	GdkPixbuf* _tmp3_;
	GtkBorder _tmp4_;
	GtkBorder _tmp5_ = {0};
	GtkBorder _tmp6_ = {0};
	NoiseAlbum* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	PangoLayout* _tmp10_;
	PangoFontDescription* font_description = NULL;
	PangoLayout* _tmp11_;
	PangoFontDescription* _tmp12_;
	PangoLayout* _tmp13_;
	PangoLayout* _tmp14_;
	gint text_width = 0;
	PangoLayout* _tmp15_;
	NoiseAlbum* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	PangoLayout* _tmp19_;
	PangoLayout* _tmp20_;
	PangoFontDescription* _tmp21_;
	PangoLayout* _tmp22_;
	PangoLayout* _tmp23_;
	PangoLayout* _tmp24_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = gtk_widget_get_style_context (widget);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	ctx = _tmp1_;
	state = gtk_style_context_get_state (ctx);
	_tmp2_ = self->priv->_album;
	_tmp3_ = noise_album_get_cached_cover_pixbuf (_tmp2_, 1);
	_g_object_unref0 (self->priv->pixbuf);
	self->priv->pixbuf = _tmp3_;
	self->priv->border.left = (gint16) 12;
	self->priv->border.right = (gint16) 12;
	self->priv->border.bottom = (gint16) 12;
	self->priv->border.top = (gint16) 12;
	gtk_style_context_save (ctx);
	gtk_style_context_add_class (ctx, "album");
	_tmp4_ = self->priv->border;
	self->priv->margin = _tmp4_;
	gtk_style_context_get_padding (ctx, state, &_tmp5_);
	self->priv->padding = _tmp5_;
	gtk_style_context_get_border (ctx, state, &_tmp6_);
	self->priv->border = _tmp6_;
	gtk_style_context_restore (ctx);
	_tmp7_ = self->priv->_album;
	_tmp8_ = noise_album_get_display_artist (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = gtk_widget_create_pango_layout (widget, _tmp9_);
	_g_object_unref0 (self->priv->subtitle_text_layout);
	self->priv->subtitle_text_layout = _tmp10_;
	_g_free0 (_tmp9_);
	gtk_style_context_get (ctx, state, GTK_STYLE_PROPERTY_FONT, &font_description, NULL);
	_tmp11_ = self->priv->subtitle_text_layout;
	_tmp12_ = font_description;
	pango_layout_set_font_description (_tmp11_, _tmp12_);
	_tmp13_ = self->priv->subtitle_text_layout;
	pango_layout_set_ellipsize (_tmp13_, PANGO_ELLIPSIZE_END);
	_tmp14_ = self->priv->subtitle_text_layout;
	pango_layout_set_alignment (_tmp14_, PANGO_ALIGN_LEFT);
	text_width = 128 * PANGO_SCALE;
	_tmp15_ = self->priv->subtitle_text_layout;
	pango_layout_set_width (_tmp15_, text_width);
	gtk_style_context_save (ctx);
	gtk_style_context_add_class (ctx, "h4");
	_tmp16_ = self->priv->_album;
	_tmp17_ = noise_album_get_display_name (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = gtk_widget_create_pango_layout (widget, _tmp18_);
	_g_object_unref0 (self->priv->title_text_layout);
	self->priv->title_text_layout = _tmp19_;
	_g_free0 (_tmp18_);
	gtk_style_context_get (ctx, state, GTK_STYLE_PROPERTY_FONT, &font_description, NULL);
	_tmp20_ = self->priv->title_text_layout;
	_tmp21_ = font_description;
	pango_layout_set_font_description (_tmp20_, _tmp21_);
	_tmp22_ = self->priv->title_text_layout;
	pango_layout_set_width (_tmp22_, text_width);
	_tmp23_ = self->priv->title_text_layout;
	pango_layout_set_ellipsize (_tmp23_, PANGO_ELLIPSIZE_END);
	_tmp24_ = self->priv->title_text_layout;
	pango_layout_set_alignment (_tmp24_, PANGO_ALIGN_LEFT);
	gtk_style_context_restore (ctx);
	_g_object_unref0 (ctx);
}


static gint
noise_widgets_tile_renderer_compute_total_image_width (NoiseWidgetsTileRenderer* self)
{
	gint result = 0;
	GtkBorder _tmp0_;
	gint16 _tmp1_;
	GtkBorder _tmp2_;
	gint16 _tmp3_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->margin;
	_tmp1_ = _tmp0_.left;
	_tmp2_ = self->priv->margin;
	_tmp3_ = _tmp2_.right;
	result = (128 + _tmp1_) + _tmp3_;
	return result;
}


static gint
noise_widgets_tile_renderer_compute_total_image_height (NoiseWidgetsTileRenderer* self)
{
	gint result = 0;
	GtkBorder _tmp0_;
	gint16 _tmp1_;
	GtkBorder _tmp2_;
	gint16 _tmp3_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->margin;
	_tmp1_ = _tmp0_.top;
	_tmp2_ = self->priv->margin;
	_tmp3_ = _tmp2_.bottom;
	result = (128 + _tmp1_) + _tmp3_;
	return result;
}


NoiseAlbum*
noise_widgets_tile_renderer_get_album (NoiseWidgetsTileRenderer* self)
{
	NoiseAlbum* result;
	NoiseAlbum* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_album;
	result = _tmp0_;
	return result;
}


void
noise_widgets_tile_renderer_set_album (NoiseWidgetsTileRenderer* self,
                                       NoiseAlbum* value)
{
	g_return_if_fail (self != NULL);
	if (noise_widgets_tile_renderer_get_album (self) != value) {
		NoiseAlbum* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_album);
		self->priv->_album = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_widgets_tile_renderer_properties[NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY]);
	}
}


static void
noise_widgets_tile_renderer_class_init (NoiseWidgetsTileRendererClass * klass)
{
	noise_widgets_tile_renderer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseWidgetsTileRenderer_private_offset);
	((GtkCellRendererClass *) klass)->get_size = (void (*) (GtkCellRenderer *, GtkWidget*, GdkRectangle*, gint*, gint*, gint*, gint*)) noise_widgets_tile_renderer_real_get_size;
	((GtkCellRendererClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkCellRenderer *)) noise_widgets_tile_renderer_real_get_request_mode;
	((GtkCellRendererClass *) klass)->get_preferred_width = (void (*) (GtkCellRenderer *, GtkWidget*, gint*, gint*)) noise_widgets_tile_renderer_real_get_preferred_width;
	((GtkCellRendererClass *) klass)->get_preferred_height_for_width = (void (*) (GtkCellRenderer *, GtkWidget*, gint, gint*, gint*)) noise_widgets_tile_renderer_real_get_preferred_height_for_width;
	((GtkCellRendererClass *) klass)->render = (void (*) (GtkCellRenderer *, cairo_t*, GtkWidget*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) noise_widgets_tile_renderer_real_render;
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_widgets_tile_renderer_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_widgets_tile_renderer_set_property;
	G_OBJECT_CLASS (klass)->finalize = noise_widgets_tile_renderer_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY, noise_widgets_tile_renderer_properties[NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY] = g_param_spec_object ("album", "album", "album", NOISE_TYPE_ALBUM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void
noise_widgets_tile_renderer_instance_init (NoiseWidgetsTileRenderer * self)
{
	self->priv = noise_widgets_tile_renderer_get_instance_private (self);
}


static void
noise_widgets_tile_renderer_finalize (GObject * obj)
{
	NoiseWidgetsTileRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRenderer);
	_g_object_unref0 (self->priv->_album);
	_g_object_unref0 (self->priv->title_text_layout);
	_g_object_unref0 (self->priv->subtitle_text_layout);
	_g_object_unref0 (self->priv->pixbuf);
	G_OBJECT_CLASS (noise_widgets_tile_renderer_parent_class)->finalize (obj);
}


GType
noise_widgets_tile_renderer_get_type (void)
{
	static volatile gsize noise_widgets_tile_renderer_type_id__volatile = 0;
	if (g_once_init_enter (&noise_widgets_tile_renderer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseWidgetsTileRendererClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_widgets_tile_renderer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseWidgetsTileRenderer), 0, (GInstanceInitFunc) noise_widgets_tile_renderer_instance_init, NULL };
		GType noise_widgets_tile_renderer_type_id;
		noise_widgets_tile_renderer_type_id = g_type_register_static (gtk_cell_renderer_get_type (), "NoiseWidgetsTileRenderer", &g_define_type_info, 0);
		NoiseWidgetsTileRenderer_private_offset = g_type_add_instance_private (noise_widgets_tile_renderer_type_id, sizeof (NoiseWidgetsTileRendererPrivate));
		g_once_init_leave (&noise_widgets_tile_renderer_type_id__volatile, noise_widgets_tile_renderer_type_id);
	}
	return noise_widgets_tile_renderer_type_id__volatile;
}


static void
_vala_noise_widgets_tile_renderer_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	NoiseWidgetsTileRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRenderer);
	switch (property_id) {
		case NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY:
		g_value_set_object (value, noise_widgets_tile_renderer_get_album (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_widgets_tile_renderer_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	NoiseWidgetsTileRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRenderer);
	switch (property_id) {
		case NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY:
		noise_widgets_tile_renderer_set_album (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



