/* SimpleOptionChooser.c generated by valac 0.41.91, the Vala compiler
 * generated from SimpleOptionChooser.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_TYPE_SIMPLE_OPTION_CHOOSER (noise_simple_option_chooser_get_type ())
#define NOISE_SIMPLE_OPTION_CHOOSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SIMPLE_OPTION_CHOOSER, NoiseSimpleOptionChooser))
#define NOISE_SIMPLE_OPTION_CHOOSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SIMPLE_OPTION_CHOOSER, NoiseSimpleOptionChooserClass))
#define NOISE_IS_SIMPLE_OPTION_CHOOSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SIMPLE_OPTION_CHOOSER))
#define NOISE_IS_SIMPLE_OPTION_CHOOSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SIMPLE_OPTION_CHOOSER))
#define NOISE_SIMPLE_OPTION_CHOOSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SIMPLE_OPTION_CHOOSER, NoiseSimpleOptionChooserClass))

typedef struct _NoiseSimpleOptionChooser NoiseSimpleOptionChooser;
typedef struct _NoiseSimpleOptionChooserClass NoiseSimpleOptionChooserClass;
typedef struct _NoiseSimpleOptionChooserPrivate NoiseSimpleOptionChooserPrivate;
enum  {
	NOISE_SIMPLE_OPTION_CHOOSER_0_PROPERTY,
	NOISE_SIMPLE_OPTION_CHOOSER_OPTIONS_PROPERTY,
	NOISE_SIMPLE_OPTION_CHOOSER_CURRENT_OPTION_PROPERTY,
	NOISE_SIMPLE_OPTION_CHOOSER_NUM_PROPERTIES
};
static GParamSpec* noise_simple_option_chooser_properties[NOISE_SIMPLE_OPTION_CHOOSER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	NOISE_SIMPLE_OPTION_CHOOSER_OPTION_CHANGED_SIGNAL,
	NOISE_SIMPLE_OPTION_CHOOSER_NUM_SIGNALS
};
static guint noise_simple_option_chooser_signals[NOISE_SIMPLE_OPTION_CHOOSER_NUM_SIGNALS] = {0};

struct _NoiseSimpleOptionChooser {
	GtkEventBox parent_instance;
	NoiseSimpleOptionChooserPrivate * priv;
};

struct _NoiseSimpleOptionChooserClass {
	GtkEventBoxClass parent_class;
};

struct _NoiseSimpleOptionChooserPrivate {
	GeeArrayList* _options;
	gint _current_option;
};


static gint NoiseSimpleOptionChooser_private_offset;
static gpointer noise_simple_option_chooser_parent_class = NULL;

GType noise_simple_option_chooser_get_type (void) G_GNUC_CONST;
void noise_simple_option_chooser_set_option (NoiseSimpleOptionChooser* self,
                                             gint index,
                                             gboolean by_user);
GeeArrayList* noise_simple_option_chooser_get_options (NoiseSimpleOptionChooser* self);
static void noise_simple_option_chooser_set_current_option (NoiseSimpleOptionChooser* self,
                                                     gint value);
gint noise_simple_option_chooser_append_item (NoiseSimpleOptionChooser* self,
                                              const gchar* icon_name,
                                              const gchar* tooltip);
static gboolean noise_simple_option_chooser_real_button_press_event (GtkWidget* base,
                                                              GdkEventButton* event);
gint noise_simple_option_chooser_get_current_option (NoiseSimpleOptionChooser* self);
NoiseSimpleOptionChooser* noise_simple_option_chooser_new (void);
NoiseSimpleOptionChooser* noise_simple_option_chooser_construct (GType object_type);
void noise_simple_option_chooser_set_options (NoiseSimpleOptionChooser* self,
                                              GeeArrayList* value);
static GObject * noise_simple_option_chooser_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void noise_simple_option_chooser_finalize (GObject * obj);
static void _vala_noise_simple_option_chooser_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_noise_simple_option_chooser_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);


static inline gpointer
noise_simple_option_chooser_get_instance_private (NoiseSimpleOptionChooser* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseSimpleOptionChooser_private_offset);
}


void
noise_simple_option_chooser_set_option (NoiseSimpleOptionChooser* self,
                                        gint index,
                                        gboolean by_user)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkWidget* _tmp3_;
	GeeArrayList* _tmp5_;
	gpointer _tmp6_;
	GtkImage* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_options;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (index >= _tmp2_) {
		return;
	}
	noise_simple_option_chooser_set_current_option (self, index);
	g_signal_emit (self, noise_simple_option_chooser_signals[NOISE_SIMPLE_OPTION_CHOOSER_OPTION_CHANGED_SIGNAL], 0, by_user);
	_tmp3_ = gtk_bin_get_child ((GtkBin*) self);
	if (_tmp3_ != NULL) {
		GtkWidget* _tmp4_;
		_tmp4_ = gtk_bin_get_child ((GtkBin*) self);
		gtk_container_remove ((GtkContainer*) self, _tmp4_);
	}
	_tmp5_ = self->priv->_options;
	_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, index);
	_tmp7_ = (GtkImage*) _tmp6_;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp7_);
	_g_object_unref0 (_tmp7_);
	gtk_widget_show_all ((GtkWidget*) self);
}


gint
noise_simple_option_chooser_append_item (NoiseSimpleOptionChooser* self,
                                         const gchar* icon_name,
                                         const gchar* tooltip)
{
	gint result = 0;
	GtkImage* image = NULL;
	GtkImage* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (icon_name != NULL, 0);
	g_return_val_if_fail (tooltip != NULL, 0);
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name (icon_name, (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp0_);
	image = _tmp0_;
	gtk_widget_set_tooltip_text ((GtkWidget*) image, tooltip);
	_tmp1_ = self->priv->_options;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, image);
	_tmp2_ = self->priv->_options;
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
	_tmp4_ = _tmp3_;
	result = _tmp4_ - 1;
	_g_object_unref0 (image);
	return result;
}


static gboolean
noise_simple_option_chooser_real_button_press_event (GtkWidget* base,
                                                     GdkEventButton* event)
{
	NoiseSimpleOptionChooser * self;
	gboolean result = FALSE;
	GdkEventType _tmp0_;
	self = (NoiseSimpleOptionChooser*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event->type;
	if (_tmp0_ == GDK_BUTTON_PRESS) {
		gint _tmp1_ = 0;
		gint _tmp2_;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint next = 0;
		gint _tmp7_;
		_tmp2_ = self->priv->_current_option;
		_tmp3_ = self->priv->_options;
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		if ((_tmp2_ + 1) < _tmp5_) {
			gint _tmp6_;
			_tmp6_ = self->priv->_current_option;
			_tmp1_ = _tmp6_ + 1;
		} else {
			_tmp1_ = 0;
		}
		next = _tmp1_;
		_tmp7_ = next;
		noise_simple_option_chooser_set_option (self, _tmp7_, TRUE);
	}
	result = TRUE;
	return result;
}


NoiseSimpleOptionChooser*
noise_simple_option_chooser_construct (GType object_type)
{
	NoiseSimpleOptionChooser * self = NULL;
	self = (NoiseSimpleOptionChooser*) g_object_new (object_type, NULL);
	return self;
}


NoiseSimpleOptionChooser*
noise_simple_option_chooser_new (void)
{
	return noise_simple_option_chooser_construct (NOISE_TYPE_SIMPLE_OPTION_CHOOSER);
}


GeeArrayList*
noise_simple_option_chooser_get_options (NoiseSimpleOptionChooser* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_options;
	result = _tmp0_;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void
noise_simple_option_chooser_set_options (NoiseSimpleOptionChooser* self,
                                         GeeArrayList* value)
{
	g_return_if_fail (self != NULL);
	if (noise_simple_option_chooser_get_options (self) != value) {
		GeeArrayList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_options);
		self->priv->_options = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_simple_option_chooser_properties[NOISE_SIMPLE_OPTION_CHOOSER_OPTIONS_PROPERTY]);
	}
}


gint
noise_simple_option_chooser_get_current_option (NoiseSimpleOptionChooser* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_current_option;
	result = _tmp0_;
	return result;
}


static void
noise_simple_option_chooser_set_current_option (NoiseSimpleOptionChooser* self,
                                                gint value)
{
	g_return_if_fail (self != NULL);
	if (noise_simple_option_chooser_get_current_option (self) != value) {
		self->priv->_current_option = value;
		g_object_notify_by_pspec ((GObject *) self, noise_simple_option_chooser_properties[NOISE_SIMPLE_OPTION_CHOOSER_CURRENT_OPTION_PROPERTY]);
	}
}


static GObject *
noise_simple_option_chooser_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseSimpleOptionChooser * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	parent_class = G_OBJECT_CLASS (noise_simple_option_chooser_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SIMPLE_OPTION_CHOOSER, NoiseSimpleOptionChooser);
	_tmp0_ = gee_array_list_new (gtk_image_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_tmp1_ = _tmp0_;
	noise_simple_option_chooser_set_options (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	noise_simple_option_chooser_set_current_option (self, 0);
	return obj;
}


static void
noise_simple_option_chooser_class_init (NoiseSimpleOptionChooserClass * klass)
{
	noise_simple_option_chooser_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseSimpleOptionChooser_private_offset);
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget *, GdkEventButton*)) noise_simple_option_chooser_real_button_press_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_simple_option_chooser_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_simple_option_chooser_set_property;
	G_OBJECT_CLASS (klass)->constructor = noise_simple_option_chooser_constructor;
	G_OBJECT_CLASS (klass)->finalize = noise_simple_option_chooser_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SIMPLE_OPTION_CHOOSER_OPTIONS_PROPERTY, noise_simple_option_chooser_properties[NOISE_SIMPLE_OPTION_CHOOSER_OPTIONS_PROPERTY] = g_param_spec_object ("options", "options", "options", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SIMPLE_OPTION_CHOOSER_CURRENT_OPTION_PROPERTY, noise_simple_option_chooser_properties[NOISE_SIMPLE_OPTION_CHOOSER_CURRENT_OPTION_PROPERTY] = g_param_spec_int ("current-option", "current-option", "current-option", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	noise_simple_option_chooser_signals[NOISE_SIMPLE_OPTION_CHOOSER_OPTION_CHANGED_SIGNAL] = g_signal_new ("option-changed", NOISE_TYPE_SIMPLE_OPTION_CHOOSER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
}


static void
noise_simple_option_chooser_instance_init (NoiseSimpleOptionChooser * self)
{
	self->priv = noise_simple_option_chooser_get_instance_private (self);
}


static void
noise_simple_option_chooser_finalize (GObject * obj)
{
	NoiseSimpleOptionChooser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SIMPLE_OPTION_CHOOSER, NoiseSimpleOptionChooser);
	_g_object_unref0 (self->priv->_options);
	G_OBJECT_CLASS (noise_simple_option_chooser_parent_class)->finalize (obj);
}


GType
noise_simple_option_chooser_get_type (void)
{
	static volatile gsize noise_simple_option_chooser_type_id__volatile = 0;
	if (g_once_init_enter (&noise_simple_option_chooser_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSimpleOptionChooserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_simple_option_chooser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSimpleOptionChooser), 0, (GInstanceInitFunc) noise_simple_option_chooser_instance_init, NULL };
		GType noise_simple_option_chooser_type_id;
		noise_simple_option_chooser_type_id = g_type_register_static (gtk_event_box_get_type (), "NoiseSimpleOptionChooser", &g_define_type_info, 0);
		NoiseSimpleOptionChooser_private_offset = g_type_add_instance_private (noise_simple_option_chooser_type_id, sizeof (NoiseSimpleOptionChooserPrivate));
		g_once_init_leave (&noise_simple_option_chooser_type_id__volatile, noise_simple_option_chooser_type_id);
	}
	return noise_simple_option_chooser_type_id__volatile;
}


static void
_vala_noise_simple_option_chooser_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	NoiseSimpleOptionChooser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SIMPLE_OPTION_CHOOSER, NoiseSimpleOptionChooser);
	switch (property_id) {
		case NOISE_SIMPLE_OPTION_CHOOSER_OPTIONS_PROPERTY:
		g_value_set_object (value, noise_simple_option_chooser_get_options (self));
		break;
		case NOISE_SIMPLE_OPTION_CHOOSER_CURRENT_OPTION_PROPERTY:
		g_value_set_int (value, noise_simple_option_chooser_get_current_option (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_noise_simple_option_chooser_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	NoiseSimpleOptionChooser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SIMPLE_OPTION_CHOOSER, NoiseSimpleOptionChooser);
	switch (property_id) {
		case NOISE_SIMPLE_OPTION_CHOOSER_OPTIONS_PROPERTY:
		noise_simple_option_chooser_set_options (self, g_value_get_object (value));
		break;
		case NOISE_SIMPLE_OPTION_CHOOSER_CURRENT_OPTION_PROPERTY:
		noise_simple_option_chooser_set_current_option (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



