/* AudioPlayerDevice.c generated by valac 0.41.91, the Vala compiler
 * generated from AudioPlayerDevice.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "music-lib.h"
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>


#define NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE (noise_plugins_audio_player_device_get_type ())
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDevice))
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDeviceClass))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE))
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDeviceClass))

typedef struct _NoisePluginsAudioPlayerDevice NoisePluginsAudioPlayerDevice;
typedef struct _NoisePluginsAudioPlayerDeviceClass NoisePluginsAudioPlayerDeviceClass;
typedef struct _NoisePluginsAudioPlayerDevicePrivate NoisePluginsAudioPlayerDevicePrivate;

#define NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY (noise_plugins_audio_player_library_get_type ())
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibrary))
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibraryClass))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY))
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibraryClass))

typedef struct _NoisePluginsAudioPlayerLibrary NoisePluginsAudioPlayerLibrary;
typedef struct _NoisePluginsAudioPlayerLibraryClass NoisePluginsAudioPlayerLibraryClass;
enum  {
	NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_0_PROPERTY,
	NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_NUM_PROPERTIES
};
static GParamSpec* noise_plugins_audio_player_device_properties[NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NoisePluginsAudioPlayerLibraryPrivate NoisePluginsAudioPlayerLibraryPrivate;
typedef struct _NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData;

struct _NoisePluginsAudioPlayerDevice {
	GObject parent_instance;
	NoisePluginsAudioPlayerDevicePrivate * priv;
};

struct _NoisePluginsAudioPlayerDeviceClass {
	GObjectClass parent_class;
};

struct _NoisePluginsAudioPlayerDevicePrivate {
	GMount* mount;
	GIcon* icon;
	gboolean is_androphone;
	GeeLinkedList* music_folders;
	NoisePluginsAudioPlayerLibrary* library;
};

struct _NoisePluginsAudioPlayerLibrary {
	NoiseLibrary parent_instance;
	NoisePluginsAudioPlayerLibraryPrivate * priv;
	gint medias_rowid;
	gint playlists_rowid;
	gint smartplaylists_rowid;
	NoiseGStreamerTagger* tagger;
};

struct _NoisePluginsAudioPlayerLibraryClass {
	NoiseLibraryClass parent_class;
};

struct _NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	NoisePluginsAudioPlayerDevice* self;
	gboolean _tmp0_;
	GeeLinkedList* _tmp1_;
	GMount* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* file;
	GMount* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GFile* _tmp16_;
	GFile* _tmp17_;
	GFile* _tmp18_;
	GFileInputStream* _tmp19_;
	GFile* _tmp20_;
	GFileInputStream* _tmp21_;
	GDataInputStream* dis;
	GDataInputStream* _tmp22_;
	gchar* line;
	gchar* _tmp23_;
	GDataInputStream* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* folders_unparsed;
	const gchar* _tmp29_;
	gchar** _tmp30_;
	gchar** _tmp31_;
	gchar** _tmp32_;
	gint _tmp32__length1;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	const gchar* _tmp36_;
	gchar** _tmp37_;
	gchar** _tmp38_;
	gchar** folder_collection;
	gint folder_collection_length1;
	gint _folder_collection_size_;
	gint folder_it;
	gchar* _tmp39_;
	gchar* folder;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	GeeLinkedList* _tmp42_;
	GMount* _tmp43_;
	GFile* _tmp44_;
	GFile* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	const gchar* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	GError* e;
	FILE* _tmp53_;
	GError* _tmp54_;
	const gchar* _tmp55_;
	GeeLinkedList* files;
	GeeLinkedList* _tmp56_;
	gint items;
	GeeLinkedList* _folder_list;
	GeeLinkedList* _tmp57_;
	GeeLinkedList* _tmp58_;
	gint _folder_size;
	GeeLinkedList* _tmp59_;
	gint _tmp60_;
	gint _tmp61_;
	gint _folder_index;
	gint _tmp62_;
	gint _tmp63_;
	gint _tmp64_;
	gchar* _vala1_folder;
	GeeLinkedList* _tmp65_;
	gint _tmp66_;
	gpointer _tmp67_;
	GFile* music_folder_file;
	const gchar* _tmp68_;
	GFile* _tmp69_;
	gint _tmp70_;
	GFile* _tmp71_;
	GeeLinkedList* _tmp72_;
	gint _tmp73_;
	NoisePluginsAudioPlayerLibrary* _tmp74_;
	NoiseGStreamerTagger* _tmp75_;
	GeeLinkedList* _tmp76_;
	GeeLinkedList* _tmp77_;
	gint _tmp78_;
	gint _tmp79_;
	NoisePluginsAudioPlayerLibrary* _tmp80_;
	GError * _inner_error_;
};


static gint NoisePluginsAudioPlayerDevice_private_offset;
static gpointer noise_plugins_audio_player_device_parent_class = NULL;
static NoiseDeviceIface * noise_plugins_audio_player_device_noise_device_parent_iface = NULL;
static GType noise_plugins_audio_player_device_type_id = 0;

GType noise_plugins_audio_player_device_get_type (void) G_GNUC_CONST;
GType noise_plugins_audio_player_library_get_type (void) G_GNUC_CONST;
NoisePluginsAudioPlayerDevice* noise_plugins_audio_player_device_new (GMount* mount,
                                                                      gboolean is_androphone);
NoisePluginsAudioPlayerDevice* noise_plugins_audio_player_device_construct (GType object_type,
                                                                            GMount* mount,
                                                                            gboolean is_androphone);
NoisePluginsAudioPlayerLibrary* noise_plugins_audio_player_library_new (NoisePluginsAudioPlayerDevice* device);
NoisePluginsAudioPlayerLibrary* noise_plugins_audio_player_library_construct (GType object_type,
                                                                              NoisePluginsAudioPlayerDevice* device);
static void noise_plugins_audio_player_device_real_finish_initialization (NoiseDevice* base);
static void __lambda8_ (NoisePluginsAudioPlayerDevice* self);
static void ___lambda8__noise_device_device_unmounted (NoiseDevice* _sender,
                                                gpointer self);
static void noise_plugins_audio_player_device_finish_initialization_async (NoisePluginsAudioPlayerDevice* self,
                                                                    GAsyncReadyCallback _callback_,
                                                                    gpointer _user_data_);
static void noise_plugins_audio_player_device_finish_initialization_finish (NoisePluginsAudioPlayerDevice* self,
                                                                     GAsyncResult* _res_);
static gboolean noise_plugins_audio_player_device_real_start_initialization (NoiseDevice* base);
static void noise_plugins_audio_player_device_finish_initialization_async_data_free (gpointer _data);
static void noise_plugins_audio_player_device_finish_initialization_async_async_ready_wrapper (GObject *source_object,
                                                                                        GAsyncResult *res,
                                                                                        void *user_data);
static gboolean noise_plugins_audio_player_device_finish_initialization_async_co (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_);
void noise_plugins_audio_player_library_queue_finished (NoisePluginsAudioPlayerLibrary* self);
static gboolean __lambda9_ (NoisePluginsAudioPlayerDevice* self);
static gboolean ___lambda9__gsource_func (gpointer self);
static NoiseLibrary* noise_plugins_audio_player_device_real_get_library (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_empty_device_title (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_empty_device_description (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_content_type (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_display_name (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_set_display_name (NoiseDevice* base,
                                                              const gchar* name);
static gchar* noise_plugins_audio_player_device_real_get_fancy_description (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_set_mount (NoiseDevice* base,
                                                       GMount* mount);
static GMount* noise_plugins_audio_player_device_real_get_mount (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_uri (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_set_icon (NoiseDevice* base,
                                                      GIcon* icon);
static GIcon* noise_plugins_audio_player_device_real_get_icon (NoiseDevice* base);
static guint64 noise_plugins_audio_player_device_real_get_capacity (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_fancy_capacity (NoiseDevice* base);
static guint64 noise_plugins_audio_player_device_real_get_used_space (NoiseDevice* base);
gchar* noise_plugins_audio_player_device_get_music_folder (NoisePluginsAudioPlayerDevice* self);
static guint64 noise_plugins_audio_player_device_real_get_free_space (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_unmount (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_eject (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_synchronize (NoiseDevice* base);
static gboolean noise_plugins_audio_player_device_real_only_use_custom_view (NoiseDevice* base);
static GtkWidget* noise_plugins_audio_player_device_real_get_custom_view (NoiseDevice* base);
static gboolean noise_plugins_audio_player_device_real_read_only (NoiseDevice* base);
static void noise_plugins_audio_player_device_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static inline gpointer
noise_plugins_audio_player_device_get_instance_private (NoisePluginsAudioPlayerDevice* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePluginsAudioPlayerDevice_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


NoisePluginsAudioPlayerDevice*
noise_plugins_audio_player_device_construct (GType object_type,
                                             GMount* mount,
                                             gboolean is_androphone)
{
	NoisePluginsAudioPlayerDevice * self = NULL;
	GMount* _tmp0_;
	GeeLinkedList* _tmp1_;
	NoisePluginsAudioPlayerLibrary* _tmp2_;
	NoiseLibrariesManager* _tmp3_;
	NoisePluginsAudioPlayerLibrary* _tmp4_;
	const gchar* _tmp5_ = NULL;
	GThemedIcon* _tmp6_;
	g_return_val_if_fail (mount != NULL, NULL);
	self = (NoisePluginsAudioPlayerDevice*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (mount);
	_g_object_unref0 (self->priv->mount);
	self->priv->mount = _tmp0_;
	self->priv->is_androphone = is_androphone;
	_tmp1_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->music_folders);
	self->priv->music_folders = _tmp1_;
	_tmp2_ = noise_plugins_audio_player_library_new (self);
	_g_object_unref0 (self->priv->library);
	self->priv->library = _tmp2_;
	_tmp3_ = noise_libraries_manager;
	_tmp4_ = self->priv->library;
	noise_libraries_manager_add_library (_tmp3_, (NoiseLibrary*) _tmp4_);
	if (is_androphone) {
		_tmp5_ = "phone";
	} else {
		_tmp5_ = "music-player";
	}
	_tmp6_ = (GThemedIcon*) g_themed_icon_new (_tmp5_);
	_g_object_unref0 (self->priv->icon);
	self->priv->icon = (GIcon*) _tmp6_;
	return self;
}


NoisePluginsAudioPlayerDevice*
noise_plugins_audio_player_device_new (GMount* mount,
                                       gboolean is_androphone)
{
	return noise_plugins_audio_player_device_construct (NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, mount, is_androphone);
}


static void
__lambda8_ (NoisePluginsAudioPlayerDevice* self)
{
}


static void
___lambda8__noise_device_device_unmounted (NoiseDevice* _sender,
                                           gpointer self)
{
	__lambda8_ ((NoisePluginsAudioPlayerDevice*) self);
}


static void
noise_plugins_audio_player_device_real_finish_initialization (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	self = (NoisePluginsAudioPlayerDevice*) base;
	g_signal_connect_object ((NoiseDevice*) self, "device-unmounted", (GCallback) ___lambda8__noise_device_device_unmounted, self, 0);
	noise_plugins_audio_player_device_finish_initialization_async (self, NULL, NULL);
}


static gboolean
noise_plugins_audio_player_device_real_start_initialization (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gboolean result = FALSE;
	self = (NoisePluginsAudioPlayerDevice*) base;
	result = TRUE;
	return result;
}


static void
noise_plugins_audio_player_device_finish_initialization_async_data_free (gpointer _data)
{
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData, _data_);
}


static void
noise_plugins_audio_player_device_finish_initialization_async_async_ready_wrapper (GObject *source_object,
                                                                                   GAsyncResult *res,
                                                                                   void *user_data)
{
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}


static void
noise_plugins_audio_player_device_finish_initialization_async (NoisePluginsAudioPlayerDevice* self,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_)
{
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
	NoisePluginsAudioPlayerDevice* _tmp0_;
	_data_ = g_slice_new0 (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, noise_plugins_audio_player_device_finish_initialization_async_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, noise_plugins_audio_player_device_finish_initialization_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	noise_plugins_audio_player_device_finish_initialization_async_co (_data_);
}


static void
noise_plugins_audio_player_device_finish_initialization_finish (NoisePluginsAudioPlayerDevice* self,
                                                                GAsyncResult* _res_)
{
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch1_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch1_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally1;
	__catch1_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static gboolean
__lambda9_ (NoisePluginsAudioPlayerDevice* self)
{
	gboolean result = FALSE;
	result = FALSE;
	return result;
}


static gboolean
___lambda9__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda9_ ((NoisePluginsAudioPlayerDevice*) self);
	return result;
}


static gboolean
noise_plugins_audio_player_device_finish_initialization_async_co (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->is_androphone;
	if (_data_->_tmp0_) {
		_data_->_tmp1_ = _data_->self->priv->music_folders;
		_data_->_tmp2_ = _data_->self->priv->mount;
		_data_->_tmp3_ = g_mount_get_root (_data_->_tmp2_);
		_data_->_tmp4_ = _data_->_tmp3_;
		_data_->_tmp5_ = g_file_get_uri (_data_->_tmp4_);
		_data_->_tmp6_ = _data_->_tmp5_;
		_data_->_tmp7_ = g_strconcat (_data_->_tmp6_, "/Music/", NULL);
		_data_->_tmp8_ = _data_->_tmp7_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp1_, _data_->_tmp8_);
		_g_free0 (_data_->_tmp8_);
		_g_free0 (_data_->_tmp6_);
		_g_object_unref0 (_data_->_tmp4_);
	} else {
		_data_->_tmp9_ = _data_->self->priv->mount;
		_data_->_tmp10_ = g_mount_get_root (_data_->_tmp9_);
		_data_->_tmp11_ = _data_->_tmp10_;
		_data_->_tmp12_ = g_file_get_uri (_data_->_tmp11_);
		_data_->_tmp13_ = _data_->_tmp12_;
		_data_->_tmp14_ = g_strconcat (_data_->_tmp13_, "/.is_audio_player", NULL);
		_data_->_tmp15_ = _data_->_tmp14_;
		_data_->_tmp16_ = g_file_new_for_uri (_data_->_tmp15_);
		_data_->_tmp17_ = _data_->_tmp16_;
		_g_free0 (_data_->_tmp15_);
		_g_free0 (_data_->_tmp13_);
		_g_object_unref0 (_data_->_tmp11_);
		_data_->file = _data_->_tmp17_;
		{
			_data_->_tmp18_ = _data_->file;
			if (g_file_query_exists (_data_->_tmp18_, NULL) == TRUE) {
				_data_->_tmp20_ = _data_->file;
				_data_->_tmp21_ = g_file_read (_data_->_tmp20_, NULL, &_data_->_inner_error_);
				_data_->_tmp19_ = _data_->_tmp21_;
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
					goto __catch0_g_error;
				}
				_data_->_tmp22_ = g_data_input_stream_new ((GInputStream*) _data_->_tmp19_);
				_data_->dis = _data_->_tmp22_;
				while (TRUE) {
					_data_->_tmp24_ = _data_->dis;
					_data_->_tmp25_ = g_data_input_stream_read_line (_data_->_tmp24_, NULL, NULL, &_data_->_inner_error_);
					_data_->_tmp23_ = _data_->_tmp25_;
					if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
						_g_free0 (_data_->line);
						_g_object_unref0 (_data_->dis);
						_g_object_unref0 (_data_->_tmp19_);
						goto __catch0_g_error;
					}
					_data_->_tmp26_ = _data_->_tmp23_;
					_data_->_tmp23_ = NULL;
					_g_free0 (_data_->line);
					_data_->line = _data_->_tmp26_;
					_data_->_tmp27_ = _data_->line;
					if (!(_data_->_tmp27_ != NULL)) {
						_g_free0 (_data_->_tmp23_);
						break;
					}
					_data_->_tmp28_ = _data_->line;
					if (string_contains (_data_->_tmp28_, "audio_folders=")) {
						_data_->_tmp29_ = _data_->line;
						_data_->_tmp31_ = _data_->_tmp30_ = g_strsplit (_data_->_tmp29_, "audio_folders=", 2);
						_data_->_tmp32_ = _data_->_tmp31_;
						_data_->_tmp32__length1 = _vala_array_length (_data_->_tmp30_);
						_data_->_tmp33_ = _data_->_tmp32_[1];
						_data_->_tmp34_ = g_strdup (_data_->_tmp33_);
						_data_->_tmp35_ = _data_->_tmp34_;
						_data_->_tmp32_ = (_vala_array_free (_data_->_tmp32_, _data_->_tmp32__length1, (GDestroyNotify) g_free), NULL);
						_data_->folders_unparsed = _data_->_tmp35_;
						_data_->_tmp36_ = _data_->folders_unparsed;
						_data_->_tmp38_ = _data_->_tmp37_ = g_strsplit (_data_->_tmp36_, ",", 0);
						{
							_data_->folder_collection_length1 = 0;
							_data_->_folder_collection_size_ = 0;
							_data_->folder_collection = _data_->_tmp38_;
							_data_->folder_collection_length1 = _vala_array_length (_data_->_tmp37_);
							for (_data_->folder_it = 0; _data_->folder_it < _vala_array_length (_data_->_tmp37_); _data_->folder_it = _data_->folder_it + 1) {
								_data_->_tmp39_ = g_strdup (_data_->folder_collection[_data_->folder_it]);
								_data_->folder = _data_->_tmp39_;
								{
									_data_->_tmp40_ = _data_->folder;
									_data_->_tmp41_ = string_replace (_data_->_tmp40_, " ", "");
									_g_free0 (_data_->folder);
									_data_->folder = _data_->_tmp41_;
									_data_->_tmp42_ = _data_->self->priv->music_folders;
									_data_->_tmp43_ = _data_->self->priv->mount;
									_data_->_tmp44_ = g_mount_get_root (_data_->_tmp43_);
									_data_->_tmp45_ = _data_->_tmp44_;
									_data_->_tmp46_ = g_file_get_uri (_data_->_tmp45_);
									_data_->_tmp47_ = _data_->_tmp46_;
									_data_->_tmp48_ = g_strconcat (_data_->_tmp47_, "/", NULL);
									_data_->_tmp49_ = _data_->_tmp48_;
									_data_->_tmp50_ = _data_->folder;
									_data_->_tmp51_ = g_strconcat (_data_->_tmp49_, _data_->_tmp50_, NULL);
									_data_->_tmp52_ = _data_->_tmp51_;
									gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp42_, _data_->_tmp52_);
									_g_free0 (_data_->_tmp52_);
									_g_free0 (_data_->_tmp49_);
									_g_free0 (_data_->_tmp47_);
									_g_object_unref0 (_data_->_tmp45_);
									_g_free0 (_data_->folder);
								}
							}
							_data_->folder_collection = (_vala_array_free (_data_->folder_collection, _data_->folder_collection_length1, (GDestroyNotify) g_free), NULL);
						}
						_g_free0 (_data_->folders_unparsed);
					}
					_g_free0 (_data_->_tmp23_);
				}
				_g_free0 (_data_->line);
				_g_object_unref0 (_data_->dis);
				_g_object_unref0 (_data_->_tmp19_);
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			_data_->e = _data_->_inner_error_;
			_data_->_inner_error_ = NULL;
			_data_->_tmp53_ = stderr;
			_data_->_tmp54_ = _data_->e;
			_data_->_tmp55_ = _data_->_tmp54_->message;
			fprintf (_data_->_tmp53_, "Error: %s\n", _data_->_tmp55_);
			_g_error_free0 (_data_->e);
		}
		__finally0:
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			_g_object_unref0 (_data_->file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_g_object_unref0 (_data_->file);
	}
	_data_->_tmp56_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	_data_->files = _data_->_tmp56_;
	_data_->items = 0;
	{
		_data_->_tmp57_ = _data_->self->priv->music_folders;
		_data_->_tmp58_ = _g_object_ref0 (_data_->_tmp57_);
		_data_->_folder_list = _data_->_tmp58_;
		_data_->_tmp59_ = _data_->_folder_list;
		_data_->_tmp60_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp59_);
		_data_->_tmp61_ = _data_->_tmp60_;
		_data_->_folder_size = _data_->_tmp61_;
		_data_->_folder_index = -1;
		while (TRUE) {
			_data_->_tmp62_ = _data_->_folder_index;
			_data_->_folder_index = _data_->_tmp62_ + 1;
			_data_->_tmp63_ = _data_->_folder_index;
			_data_->_tmp64_ = _data_->_folder_size;
			if (!(_data_->_tmp63_ < _data_->_tmp64_)) {
				break;
			}
			_data_->_tmp65_ = _data_->_folder_list;
			_data_->_tmp66_ = _data_->_folder_index;
			_data_->_tmp67_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp65_, _data_->_tmp66_);
			_data_->_vala1_folder = (gchar*) _data_->_tmp67_;
			_data_->_tmp68_ = _data_->_vala1_folder;
			_data_->_tmp69_ = g_file_new_for_uri (_data_->_tmp68_);
			_data_->music_folder_file = _data_->_tmp69_;
			_data_->_tmp70_ = _data_->items;
			_data_->_tmp71_ = _data_->music_folder_file;
			_data_->_tmp72_ = _data_->files;
			_data_->items = _data_->_tmp70_ + noise_file_utils_count_music_files (_data_->_tmp71_, (GeeCollection*) _data_->_tmp72_);
			_g_object_unref0 (_data_->music_folder_file);
			_g_free0 (_data_->_vala1_folder);
		}
		_g_object_unref0 (_data_->_folder_list);
	}
	_data_->_tmp73_ = _data_->items;
	g_debug ("AudioPlayerDevice.vala:89: found %d items to import\n", _data_->_tmp73_);
	_data_->_tmp74_ = _data_->self->priv->library;
	_data_->_tmp75_ = _data_->_tmp74_->tagger;
	_data_->_tmp76_ = _data_->files;
	noise_gstreamer_tagger_discoverer_import_media (_data_->_tmp75_, (GeeCollection*) _data_->_tmp76_);
	_data_->_tmp77_ = _data_->files;
	_data_->_tmp78_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp77_);
	_data_->_tmp79_ = _data_->_tmp78_;
	if (_data_->_tmp79_ == 0) {
		_data_->_tmp80_ = _data_->self->priv->library;
		noise_plugins_audio_player_library_queue_finished (_data_->_tmp80_);
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda9__gsource_func, g_object_ref (_data_->self), g_object_unref);
	_g_object_unref0 (_data_->files);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (_data_->_task_complete_ != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static NoiseLibrary*
noise_plugins_audio_player_device_real_get_library (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	NoiseLibrary* result = NULL;
	NoisePluginsAudioPlayerLibrary* _tmp0_;
	NoiseLibrary* _tmp1_;
	self = (NoisePluginsAudioPlayerDevice*) base;
	_tmp0_ = self->priv->library;
	_tmp1_ = _g_object_ref0 ((NoiseLibrary*) _tmp0_);
	result = _tmp1_;
	return result;
}


static gchar*
noise_plugins_audio_player_device_real_get_empty_device_title (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gchar* _tmp0_;
	self = (NoisePluginsAudioPlayerDevice*) base;
	_tmp0_ = g_strdup (_ ("Empty device!"));
	result = _tmp0_;
	return result;
}


static gchar*
noise_plugins_audio_player_device_real_get_empty_device_description (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gchar* _tmp0_;
	self = (NoisePluginsAudioPlayerDevice*) base;
	_tmp0_ = g_strdup (_ ("This device does not contain any music."));
	result = _tmp0_;
	return result;
}


static gchar*
noise_plugins_audio_player_device_real_get_content_type (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gboolean _tmp0_;
	self = (NoisePluginsAudioPlayerDevice*) base;
	_tmp0_ = self->priv->is_androphone;
	if (_tmp0_) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("android");
		result = _tmp1_;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = g_strdup ("audioplayer");
		result = _tmp2_;
		return result;
	}
}


static gchar*
noise_plugins_audio_player_device_real_get_display_name (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gboolean _tmp0_;
	GError * _inner_error_ = NULL;
	self = (NoisePluginsAudioPlayerDevice*) base;
	_tmp0_ = self->priv->is_androphone;
	if (_tmp0_) {
		GMount* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = self->priv->mount;
		_tmp2_ = g_mount_get_name (_tmp1_);
		result = _tmp2_;
		return result;
	} else {
		GFile* file = NULL;
		GMount* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		gchar* name = NULL;
		GMount* _tmp12_;
		gchar* _tmp13_;
		_tmp3_ = self->priv->mount;
		_tmp4_ = g_mount_get_root (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_file_get_path (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_strconcat (_tmp7_, "/.is_audio_player", NULL);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_file_new_for_path (_tmp9_);
		_tmp11_ = _tmp10_;
		_g_free0 (_tmp9_);
		_g_free0 (_tmp7_);
		_g_object_unref0 (_tmp5_);
		file = _tmp11_;
		_tmp12_ = self->priv->mount;
		_tmp13_ = g_mount_get_name (_tmp12_);
		name = _tmp13_;
		{
			GFile* _tmp14_;
			_tmp14_ = file;
			if (g_file_query_exists (_tmp14_, NULL) == TRUE) {
				GFileInputStream* _tmp15_ = NULL;
				GFile* _tmp16_;
				GFileInputStream* _tmp17_;
				GDataInputStream* dis = NULL;
				GDataInputStream* _tmp18_;
				gchar* line = NULL;
				_tmp16_ = file;
				_tmp17_ = g_file_read (_tmp16_, NULL, &_inner_error_);
				_tmp15_ = _tmp17_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					goto __catch2_g_error;
				}
				_tmp18_ = g_data_input_stream_new ((GInputStream*) _tmp15_);
				dis = _tmp18_;
				while (TRUE) {
					gchar* _tmp19_ = NULL;
					GDataInputStream* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					_tmp20_ = dis;
					_tmp21_ = g_data_input_stream_read_line (_tmp20_, NULL, NULL, &_inner_error_);
					_tmp19_ = _tmp21_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_free0 (line);
						_g_object_unref0 (dis);
						_g_object_unref0 (_tmp15_);
						goto __catch2_g_error;
					}
					_tmp22_ = _tmp19_;
					_tmp19_ = NULL;
					_g_free0 (line);
					line = _tmp22_;
					_tmp23_ = line;
					if (!(_tmp23_ != NULL)) {
						_g_free0 (_tmp19_);
						break;
					}
					_tmp24_ = line;
					if (string_contains (_tmp24_, "name=")) {
						gchar* names_unparsed = NULL;
						const gchar* _tmp25_;
						gchar** _tmp26_;
						gchar** _tmp27_;
						gchar** _tmp28_;
						gint _tmp28__length1;
						const gchar* _tmp29_;
						gchar* _tmp30_;
						gchar* _tmp31_;
						const gchar* _tmp32_;
						gchar** _tmp33_;
						gchar** _tmp34_;
						_tmp25_ = line;
						_tmp27_ = _tmp26_ = g_strsplit (_tmp25_, "name=", 2);
						_tmp28_ = _tmp27_;
						_tmp28__length1 = _vala_array_length (_tmp26_);
						_tmp29_ = _tmp28_[1];
						_tmp30_ = g_strdup (_tmp29_);
						_tmp31_ = _tmp30_;
						_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
						names_unparsed = _tmp31_;
						_tmp32_ = names_unparsed;
						_tmp34_ = _tmp33_ = g_strsplit (_tmp32_, "\"", 0);
						{
							gchar** names_collection = NULL;
							gint names_collection_length1 = 0;
							gint _names_collection_size_ = 0;
							gint names_it = 0;
							names_collection = _tmp34_;
							names_collection_length1 = _vala_array_length (_tmp33_);
							for (names_it = 0; names_it < _vala_array_length (_tmp33_); names_it = names_it + 1) {
								gchar* _tmp35_;
								gchar* names = NULL;
								_tmp35_ = g_strdup (names_collection[names_it]);
								names = _tmp35_;
								{
									gboolean _tmp36_ = FALSE;
									const gchar* _tmp37_;
									_tmp37_ = names;
									if (_tmp37_ != NULL) {
										const gchar* _tmp38_;
										_tmp38_ = names;
										_tmp36_ = g_strcmp0 (_tmp38_, "") != 0;
									} else {
										_tmp36_ = FALSE;
									}
									if (_tmp36_) {
										const gchar* _tmp39_;
										gchar* _tmp40_;
										_tmp39_ = names;
										_tmp40_ = g_strdup (_tmp39_);
										_g_free0 (name);
										name = _tmp40_;
									}
									_g_free0 (names);
								}
							}
							names_collection = (_vala_array_free (names_collection, names_collection_length1, (GDestroyNotify) g_free), NULL);
						}
						_g_free0 (names_unparsed);
					}
					_g_free0 (_tmp19_);
				}
				_g_free0 (line);
				_g_object_unref0 (dis);
				_g_object_unref0 (_tmp15_);
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			FILE* _tmp41_;
			GError* _tmp42_;
			const gchar* _tmp43_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp41_ = stderr;
			_tmp42_ = e;
			_tmp43_ = _tmp42_->message;
			fprintf (_tmp41_, "Error: %s\n", _tmp43_);
			_g_error_free0 (e);
		}
		__finally2:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (name);
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = name;
		_g_object_unref0 (file);
		return result;
	}
}


static void
noise_plugins_audio_player_device_real_set_display_name (NoiseDevice* base,
                                                         const gchar* name)
{
	NoisePluginsAudioPlayerDevice * self;
	self = (NoisePluginsAudioPlayerDevice*) base;
	g_return_if_fail (name != NULL);
}


static gchar*
noise_plugins_audio_player_device_real_get_fancy_description (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gboolean _tmp0_;
	self = (NoisePluginsAudioPlayerDevice*) base;
	_tmp0_ = self->priv->is_androphone;
	if (_tmp0_) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup (_ ("Android Phone"));
		result = _tmp1_;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (_ ("Audio Player"));
		result = _tmp2_;
		return result;
	}
}


static void
noise_plugins_audio_player_device_real_set_mount (NoiseDevice* base,
                                                  GMount* mount)
{
	NoisePluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
	self = (NoisePluginsAudioPlayerDevice*) base;
	g_return_if_fail (mount != NULL);
	_tmp0_ = _g_object_ref0 (mount);
	_g_object_unref0 (self->priv->mount);
	self->priv->mount = _tmp0_;
}


static GMount*
noise_plugins_audio_player_device_real_get_mount (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	GMount* result = NULL;
	GMount* _tmp0_;
	GMount* _tmp1_;
	self = (NoisePluginsAudioPlayerDevice*) base;
	_tmp0_ = self->priv->mount;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


static gchar*
noise_plugins_audio_player_device_real_get_uri (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	GMount* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	self = (NoisePluginsAudioPlayerDevice*) base;
	_tmp0_ = self->priv->mount;
	_tmp1_ = g_mount_get_default_location (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_file_get_uri (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp2_);
	result = _tmp4_;
	return result;
}


static void
noise_plugins_audio_player_device_real_set_icon (NoiseDevice* base,
                                                 GIcon* icon)
{
	NoisePluginsAudioPlayerDevice * self;
	GIcon* _tmp0_;
	self = (NoisePluginsAudioPlayerDevice*) base;
	g_return_if_fail (icon != NULL);
	_tmp0_ = _g_object_ref0 (icon);
	_g_object_unref0 (self->priv->icon);
	self->priv->icon = _tmp0_;
}


static GIcon*
noise_plugins_audio_player_device_real_get_icon (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	GIcon* result = NULL;
	GIcon* _tmp0_;
	GIcon* _tmp1_;
	self = (NoisePluginsAudioPlayerDevice*) base;
	_tmp0_ = self->priv->icon;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


static guint64
noise_plugins_audio_player_device_real_get_capacity (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	guint64 result = 0ULL;
	guint64 rv = 0ULL;
	guint64 _tmp10_;
	GError * _inner_error_ = NULL;
	self = (NoisePluginsAudioPlayerDevice*) base;
	rv = (guint64) 0;
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
		_tmp0_ = noise_device_get_uri ((NoiseDevice*) self);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_file_new_for_uri (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_g_free0 (_tmp1_);
		file_info = _tmp5_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch3_g_error;
		}
		rv = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_SIZE);
		_g_object_unref0 (file_info);
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* err = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = stdout;
		_tmp7_ = err;
		_tmp8_ = _tmp7_->message;
		fprintf (_tmp6_, "Error calculating capacity of iPod: %s\n", _tmp8_);
		_g_error_free0 (err);
	}
	__finally3:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		guint64 _tmp9_ = 0ULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp9_;
	}
	_tmp10_ = rv;
	result = (guint64) _tmp10_;
	return result;
}


static gchar*
noise_plugins_audio_player_device_real_get_fancy_capacity (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gchar* _tmp0_;
	self = (NoisePluginsAudioPlayerDevice*) base;
	_tmp0_ = g_format_size_full (noise_device_get_capacity ((NoiseDevice*) self), G_FORMAT_SIZE_DEFAULT);
	result = _tmp0_;
	return result;
}


static guint64
noise_plugins_audio_player_device_real_get_used_space (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	guint64 result = 0ULL;
	self = (NoisePluginsAudioPlayerDevice*) base;
	result = noise_device_get_capacity ((NoiseDevice*) self) - noise_device_get_free_space ((NoiseDevice*) self);
	return result;
}


gchar*
noise_plugins_audio_player_device_get_music_folder (NoisePluginsAudioPlayerDevice* self)
{
	gchar* result = NULL;
	GeeLinkedList* _tmp0_;
	gpointer _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->music_folders;
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
	result = (gchar*) _tmp1_;
	return result;
}


static guint64
noise_plugins_audio_player_device_real_get_free_space (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	guint64 result = 0ULL;
	guint64 rv = 0ULL;
	GError * _inner_error_ = NULL;
	self = (NoisePluginsAudioPlayerDevice*) base;
	rv = (guint64) 0;
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
		_tmp0_ = noise_device_get_uri ((NoiseDevice*) self);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_file_new_for_uri (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_g_free0 (_tmp1_);
		file_info = _tmp5_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch4_g_error;
		}
		rv = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_FREE);
		_g_object_unref0 (file_info);
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* err = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = stdout;
		_tmp7_ = err;
		_tmp8_ = _tmp7_->message;
		fprintf (_tmp6_, "Error calculating free space on iPod: %s\n", _tmp8_);
		_g_error_free0 (err);
	}
	__finally4:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		guint64 _tmp9_ = 0ULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp9_;
	}
	result = rv;
	return result;
}


static void
noise_plugins_audio_player_device_real_unmount (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
	self = (NoisePluginsAudioPlayerDevice*) base;
	_tmp0_ = self->priv->mount;
	g_mount_unmount_with_operation (_tmp0_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
}


static void
noise_plugins_audio_player_device_real_eject (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
	self = (NoisePluginsAudioPlayerDevice*) base;
	_tmp0_ = self->priv->mount;
	if (g_mount_can_eject (_tmp0_)) {
		GMount* _tmp1_;
		GVolume* _tmp2_;
		GVolume* _tmp3_;
		GDrive* _tmp4_;
		GDrive* _tmp5_;
		_tmp1_ = self->priv->mount;
		_tmp2_ = g_mount_get_volume (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_volume_get_drive (_tmp3_);
		_tmp5_ = _tmp4_;
		g_drive_eject_with_operation (_tmp5_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
		_g_object_unref0 (_tmp5_);
		_g_object_unref0 (_tmp3_);
	}
}


static void
noise_plugins_audio_player_device_real_synchronize (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	self = (NoisePluginsAudioPlayerDevice*) base;
}


static gboolean
noise_plugins_audio_player_device_real_only_use_custom_view (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gboolean result = FALSE;
	self = (NoisePluginsAudioPlayerDevice*) base;
	result = FALSE;
	return result;
}


static GtkWidget*
noise_plugins_audio_player_device_real_get_custom_view (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	GtkWidget* result = NULL;
	self = (NoisePluginsAudioPlayerDevice*) base;
	result = NULL;
	return result;
}


static gboolean
noise_plugins_audio_player_device_real_read_only (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gboolean result = FALSE;
	self = (NoisePluginsAudioPlayerDevice*) base;
	result = FALSE;
	return result;
}


static void
noise_plugins_audio_player_device_class_init (NoisePluginsAudioPlayerDeviceClass * klass)
{
	noise_plugins_audio_player_device_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoisePluginsAudioPlayerDevice_private_offset);
	G_OBJECT_CLASS (klass)->finalize = noise_plugins_audio_player_device_finalize;
}


static void
noise_plugins_audio_player_device_noise_device_interface_init (NoiseDeviceIface * iface)
{
	noise_plugins_audio_player_device_noise_device_parent_iface = g_type_interface_peek_parent (iface);
	iface->finish_initialization = (void (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_finish_initialization;
	iface->start_initialization = (gboolean (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_start_initialization;
	iface->get_library = (NoiseLibrary* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_library;
	iface->get_empty_device_title = (gchar* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_empty_device_title;
	iface->get_empty_device_description = (gchar* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_empty_device_description;
	iface->get_content_type = (gchar* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_content_type;
	iface->get_display_name = (gchar* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_display_name;
	iface->set_display_name = (void (*) (NoiseDevice *, const gchar*)) noise_plugins_audio_player_device_real_set_display_name;
	iface->get_fancy_description = (gchar* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_fancy_description;
	iface->set_mount = (void (*) (NoiseDevice *, GMount*)) noise_plugins_audio_player_device_real_set_mount;
	iface->get_mount = (GMount* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_mount;
	iface->get_uri = (gchar* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_uri;
	iface->set_icon = (void (*) (NoiseDevice *, GIcon*)) noise_plugins_audio_player_device_real_set_icon;
	iface->get_icon = (GIcon* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_icon;
	iface->get_capacity = (guint64 (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_capacity;
	iface->get_fancy_capacity = (gchar* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_fancy_capacity;
	iface->get_used_space = (guint64 (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_used_space;
	iface->get_free_space = (guint64 (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_free_space;
	iface->unmount = (void (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_unmount;
	iface->eject = (void (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_eject;
	iface->synchronize = (void (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_synchronize;
	iface->only_use_custom_view = (gboolean (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_only_use_custom_view;
	iface->get_custom_view = (GtkWidget* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_custom_view;
	iface->read_only = (gboolean (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_read_only;
}


static void
noise_plugins_audio_player_device_instance_init (NoisePluginsAudioPlayerDevice * self)
{
	self->priv = noise_plugins_audio_player_device_get_instance_private (self);
	self->priv->is_androphone = FALSE;
}


static void
noise_plugins_audio_player_device_finalize (GObject * obj)
{
	NoisePluginsAudioPlayerDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDevice);
	_g_object_unref0 (self->priv->mount);
	_g_object_unref0 (self->priv->icon);
	_g_object_unref0 (self->priv->music_folders);
	_g_object_unref0 (self->priv->library);
	G_OBJECT_CLASS (noise_plugins_audio_player_device_parent_class)->finalize (obj);
}


GType
noise_plugins_audio_player_device_get_type (void)
{
	return noise_plugins_audio_player_device_type_id;
}


GType
noise_plugins_audio_player_device_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NoisePluginsAudioPlayerDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_plugins_audio_player_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePluginsAudioPlayerDevice), 0, (GInstanceInitFunc) noise_plugins_audio_player_device_instance_init, NULL };
	static const GInterfaceInfo noise_device_info = { (GInterfaceInitFunc) noise_plugins_audio_player_device_noise_device_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	noise_plugins_audio_player_device_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "NoisePluginsAudioPlayerDevice", &g_define_type_info, 0);
	g_type_module_add_interface (module, noise_plugins_audio_player_device_type_id, NOISE_TYPE_DEVICE, &noise_device_info);
	NoisePluginsAudioPlayerDevice_private_offset = sizeof (NoisePluginsAudioPlayerDevicePrivate);
	return noise_plugins_audio_player_device_type_id;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



