/* AudioPlayerLibrary.c generated by valac 0.41.91, the Vala compiler
 * generated from AudioPlayerLibrary.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include "music-lib.h"
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY (noise_plugins_audio_player_library_get_type ())
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibrary))
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibraryClass))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY))
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibraryClass))

typedef struct _NoisePluginsAudioPlayerLibrary NoisePluginsAudioPlayerLibrary;
typedef struct _NoisePluginsAudioPlayerLibraryClass NoisePluginsAudioPlayerLibraryClass;
typedef struct _NoisePluginsAudioPlayerLibraryPrivate NoisePluginsAudioPlayerLibraryPrivate;

#define NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE (noise_plugins_audio_player_device_get_type ())
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDevice))
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDeviceClass))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE))
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDeviceClass))

typedef struct _NoisePluginsAudioPlayerDevice NoisePluginsAudioPlayerDevice;
typedef struct _NoisePluginsAudioPlayerDeviceClass NoisePluginsAudioPlayerDeviceClass;
enum  {
	NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_0_PROPERTY,
	NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_NUM_PROPERTIES
};
static GParamSpec* noise_plugins_audio_player_library_properties[NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block1Data Block1Data;

struct _NoisePluginsAudioPlayerLibrary {
	NoiseLibrary parent_instance;
	NoisePluginsAudioPlayerLibraryPrivate * priv;
	gint medias_rowid;
	gint playlists_rowid;
	gint smartplaylists_rowid;
	NoiseGStreamerTagger* tagger;
};

struct _NoisePluginsAudioPlayerLibraryClass {
	NoiseLibraryClass parent_class;
};

struct _NoisePluginsAudioPlayerLibraryPrivate {
	NoisePluginsAudioPlayerDevice* device;
	GeeLinkedList* medias;
	GRecMutex __lock_medias;
	GeeLinkedList* searched_medias;
	GRecMutex __lock_searched_medias;
	GeeLinkedList* playlists;
	gboolean operation_cancelled;
	gboolean is_doing_file_operations;
	gboolean queue_is_finished;
	GeeLinkedList* imported_files;
	gboolean is_initialized;
};

struct _Block1Data {
	int _ref_count_;
	NoisePluginsAudioPlayerLibrary* self;
	NoiseStaticPlaylist* p;
};


static gint NoisePluginsAudioPlayerLibrary_private_offset;
static gpointer noise_plugins_audio_player_library_parent_class = NULL;
static GType noise_plugins_audio_player_library_type_id = 0;

GType noise_plugins_audio_player_library_get_type (void) G_GNUC_CONST;
GType noise_plugins_audio_player_device_get_type (void) G_GNUC_CONST;
NoisePluginsAudioPlayerLibrary* noise_plugins_audio_player_library_new (NoisePluginsAudioPlayerDevice* device);
NoisePluginsAudioPlayerLibrary* noise_plugins_audio_player_library_construct (GType object_type,
                                                                              NoisePluginsAudioPlayerDevice* device);
static void noise_plugins_audio_player_library_media_imported_from_tagger (NoisePluginsAudioPlayerLibrary* self,
                                                                    NoiseMedia* m);
static void _noise_plugins_audio_player_library_media_imported_from_tagger_noise_gstreamer_tagger_media_imported (NoiseGStreamerTagger* _sender,
                                                                                                           NoiseMedia* m,
                                                                                                           gpointer self);
static void noise_plugins_audio_player_library_import_error (NoisePluginsAudioPlayerLibrary* self,
                                                      const gchar* file);
static void _noise_plugins_audio_player_library_import_error_noise_gstreamer_tagger_import_error (NoiseGStreamerTagger* _sender,
                                                                                           const gchar* file_uri,
                                                                                           GError* _error_,
                                                                                           gpointer self);
void noise_plugins_audio_player_library_queue_finished (NoisePluginsAudioPlayerLibrary* self);
static void _noise_plugins_audio_player_library_queue_finished_noise_gstreamer_tagger_queue_finished (NoiseGStreamerTagger* _sender,
                                                                                               gpointer self);
static void __lambda4_ (NoisePluginsAudioPlayerLibrary* self);
static void ___lambda4__noise_notification_manager_progress_canceled (NoiseNotificationManager* _sender,
                                                               gpointer self);
static void noise_plugins_audio_player_library_real_initialize_library (NoiseLibrary* base);
static void noise_plugins_audio_player_library_real_add_files_to_library (NoiseLibrary* base,
                                                                   GeeCollection* files);
static GeeCollection* noise_plugins_audio_player_library_real_get_medias (NoiseLibrary* base);
static GeeCollection* noise_plugins_audio_player_library_real_get_playlists (NoiseLibrary* base);
static GeeCollection* noise_plugins_audio_player_library_real_get_smart_playlists (NoiseLibrary* base);
static void noise_plugins_audio_player_library_real_search_medias (NoiseLibrary* base,
                                                            const gchar* search);
static GeeCollection* noise_plugins_audio_player_library_real_get_search_result (NoiseLibrary* base);
static void noise_plugins_audio_player_library_real_add_media (NoiseLibrary* base,
                                                        NoiseMedia* m);
gchar* noise_plugins_audio_player_device_get_music_folder (NoisePluginsAudioPlayerDevice* self);
static void noise_plugins_audio_player_library_real_add_medias (NoiseLibrary* base,
                                                         GeeCollection* list);
static gboolean _noise_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self);
static NoiseMedia* noise_plugins_audio_player_library_real_media_from_id (NoiseLibrary* base,
                                                                   gint64 id);
static GeeCollection* noise_plugins_audio_player_library_real_medias_from_ids (NoiseLibrary* base,
                                                                        GeeCollection* ids);
static GeeCollection* noise_plugins_audio_player_library_real_medias_from_uris (NoiseLibrary* base,
                                                                         GeeCollection* uris);
static NoiseMedia* noise_plugins_audio_player_library_real_find_media (NoiseLibrary* base,
                                                                NoiseMedia* to_find);
static NoiseMedia* noise_plugins_audio_player_library_real_media_from_file (NoiseLibrary* base,
                                                                     GFile* file);
static NoiseMedia* noise_plugins_audio_player_library_real_media_from_uri (NoiseLibrary* base,
                                                                    const gchar* uri);
static void noise_plugins_audio_player_library_real_update_media (NoiseLibrary* base,
                                                           NoiseMedia* s,
                                                           gboolean updateMeta,
                                                           gboolean record_time);
static void noise_plugins_audio_player_library_real_update_medias (NoiseLibrary* base,
                                                            GeeCollection* updates,
                                                            gboolean updateMeta,
                                                            gboolean record_time);
static void noise_plugins_audio_player_library_real_remove_media (NoiseLibrary* base,
                                                           NoiseMedia* m,
                                                           gboolean trash);
static void noise_plugins_audio_player_library_real_remove_medias (NoiseLibrary* base,
                                                            GeeCollection* list,
                                                            gboolean trash);
static gboolean noise_plugins_audio_player_library_real_support_smart_playlists (NoiseLibrary* base);
static void noise_plugins_audio_player_library_real_add_smart_playlist (NoiseLibrary* base,
                                                                 NoiseSmartPlaylist* p);
static void noise_plugins_audio_player_library_real_remove_smart_playlist (NoiseLibrary* base,
                                                                    gint64 id);
static NoiseSmartPlaylist* noise_plugins_audio_player_library_real_smart_playlist_from_id (NoiseLibrary* base,
                                                                                    gint64 id);
static NoiseSmartPlaylist* noise_plugins_audio_player_library_real_smart_playlist_from_name (NoiseLibrary* base,
                                                                                      const gchar* name);
static gboolean noise_plugins_audio_player_library_real_support_playlists (NoiseLibrary* base);
static void noise_plugins_audio_player_library_real_add_playlist (NoiseLibrary* base,
                                                           NoiseStaticPlaylist* p);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void noise_plugins_audio_player_library_keep_playlist_synchronized (NoisePluginsAudioPlayerLibrary* self,
                                                                    NoiseStaticPlaylist* p);
static void __lambda5_ (Block1Data* _data1_);
static void ___lambda5__noise_playlist_media_added (NoisePlaylist* _sender,
                                             GeeCollection* media,
                                             gpointer self);
static void __lambda6_ (Block1Data* _data1_);
static void ___lambda6__noise_playlist_media_removed (NoisePlaylist* _sender,
                                               GeeCollection* media,
                                               gpointer self);
static void __lambda7_ (Block1Data* _data1_,
                 const gchar* old_name);
static void noise_plugins_audio_player_library_remove_playlist_from_name (NoisePluginsAudioPlayerLibrary* self,
                                                                   const gchar* name);
static void ___lambda7__noise_playlist_updated (NoisePlaylist* _sender,
                                         const gchar* old_name,
                                         gpointer self);
static void noise_plugins_audio_player_library_real_remove_playlist (NoiseLibrary* base,
                                                              gint64 id);
static NoiseStaticPlaylist* noise_plugins_audio_player_library_real_playlist_from_id (NoiseLibrary* base,
                                                                               gint64 id);
static NoiseStaticPlaylist* noise_plugins_audio_player_library_real_playlist_from_name (NoiseLibrary* base,
                                                                                 const gchar* name);
static gboolean noise_plugins_audio_player_library_real_start_file_operations (NoiseLibrary* base,
                                                                        const gchar* message);
static gboolean noise_plugins_audio_player_library_real_doing_file_operations (NoiseLibrary* base);
static void noise_plugins_audio_player_library_real_finish_file_operations (NoiseLibrary* base);
static void noise_plugins_audio_player_library_finalize (GObject * obj);


static inline gpointer
noise_plugins_audio_player_library_get_instance_private (NoisePluginsAudioPlayerLibrary* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePluginsAudioPlayerLibrary_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
_noise_plugins_audio_player_library_media_imported_from_tagger_noise_gstreamer_tagger_media_imported (NoiseGStreamerTagger* _sender,
                                                                                                      NoiseMedia* m,
                                                                                                      gpointer self)
{
	noise_plugins_audio_player_library_media_imported_from_tagger ((NoisePluginsAudioPlayerLibrary*) self, m);
}


static void
_noise_plugins_audio_player_library_import_error_noise_gstreamer_tagger_import_error (NoiseGStreamerTagger* _sender,
                                                                                      const gchar* file_uri,
                                                                                      GError* _error_,
                                                                                      gpointer self)
{
	noise_plugins_audio_player_library_import_error ((NoisePluginsAudioPlayerLibrary*) self, file_uri);
}


static void
_noise_plugins_audio_player_library_queue_finished_noise_gstreamer_tagger_queue_finished (NoiseGStreamerTagger* _sender,
                                                                                          gpointer self)
{
	noise_plugins_audio_player_library_queue_finished ((NoisePluginsAudioPlayerLibrary*) self);
}


static void
__lambda4_ (NoisePluginsAudioPlayerLibrary* self)
{
	self->priv->operation_cancelled = TRUE;
}


static void
___lambda4__noise_notification_manager_progress_canceled (NoiseNotificationManager* _sender,
                                                          gpointer self)
{
	__lambda4_ ((NoisePluginsAudioPlayerLibrary*) self);
}


NoisePluginsAudioPlayerLibrary*
noise_plugins_audio_player_library_construct (GType object_type,
                                              NoisePluginsAudioPlayerDevice* device)
{
	NoisePluginsAudioPlayerLibrary * self = NULL;
	NoisePluginsAudioPlayerDevice* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
	GeeLinkedList* _tmp3_;
	GeeLinkedList* _tmp4_;
	NoiseGStreamerTagger* _tmp5_;
	NoiseGStreamerTagger* _tmp6_;
	NoiseGStreamerTagger* _tmp7_;
	NoiseGStreamerTagger* _tmp8_;
	NoiseNotificationManager* _tmp9_;
	NoiseNotificationManager* _tmp10_;
	g_return_val_if_fail (device != NULL, NULL);
	self = (NoisePluginsAudioPlayerLibrary*) noise_library_construct (object_type);
	_tmp0_ = _g_object_ref0 (device);
	_g_object_unref0 (self->priv->device);
	self->priv->device = _tmp0_;
	_tmp1_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->medias);
	self->priv->medias = _tmp1_;
	_tmp2_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->searched_medias);
	self->priv->searched_medias = _tmp2_;
	_tmp3_ = gee_linked_list_new (NOISE_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->playlists);
	self->priv->playlists = _tmp3_;
	_tmp4_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->imported_files);
	self->priv->imported_files = _tmp4_;
	_tmp5_ = noise_gstreamer_tagger_new (NULL);
	_g_object_unref0 (self->tagger);
	self->tagger = _tmp5_;
	_tmp6_ = self->tagger;
	g_signal_connect_object (_tmp6_, "media-imported", (GCallback) _noise_plugins_audio_player_library_media_imported_from_tagger_noise_gstreamer_tagger_media_imported, self, 0);
	_tmp7_ = self->tagger;
	g_signal_connect_object (_tmp7_, "import-error", (GCallback) _noise_plugins_audio_player_library_import_error_noise_gstreamer_tagger_import_error, self, 0);
	_tmp8_ = self->tagger;
	g_signal_connect_object (_tmp8_, "queue-finished", (GCallback) _noise_plugins_audio_player_library_queue_finished_noise_gstreamer_tagger_queue_finished, self, 0);
	_tmp9_ = noise_notification_manager_get_default ();
	_tmp10_ = _tmp9_;
	g_signal_connect_object (_tmp10_, "progress-canceled", (GCallback) ___lambda4__noise_notification_manager_progress_canceled, self, 0);
	_g_object_unref0 (_tmp10_);
	return self;
}


NoisePluginsAudioPlayerLibrary*
noise_plugins_audio_player_library_new (NoisePluginsAudioPlayerDevice* device)
{
	return noise_plugins_audio_player_library_construct (NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, device);
}


static void
noise_plugins_audio_player_library_media_imported_from_tagger (NoisePluginsAudioPlayerLibrary* self,
                                                               NoiseMedia* m)
{
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	noise_media_set_isTemporary (m, TRUE);
	_tmp0_ = self->priv->medias;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, m);
	_tmp1_ = self->medias_rowid;
	noise_media_set_rowid (m, (gint64) _tmp1_);
	_tmp2_ = self->medias_rowid;
	self->medias_rowid = _tmp2_ + 1;
	_tmp3_ = self->priv->queue_is_finished;
	if (_tmp3_) {
		g_signal_emit_by_name ((NoiseLibrary*) self, "file-operations-done");
	}
}


static void
noise_plugins_audio_player_library_import_error (NoisePluginsAudioPlayerLibrary* self,
                                                 const gchar* file)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
}


void
noise_plugins_audio_player_library_queue_finished (NoisePluginsAudioPlayerLibrary* self)
{
	NoiseLibrariesManager* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	self->priv->queue_is_finished = TRUE;
	_tmp0_ = noise_libraries_manager;
	_tmp0_->progress = (gdouble) 1;
	_tmp1_ = self->priv->is_initialized;
	if (_tmp1_ == FALSE) {
		NoisePluginsAudioPlayerDevice* _tmp2_;
		NoisePluginsAudioPlayerDevice* _tmp3_;
		self->priv->is_initialized = TRUE;
		_tmp2_ = self->priv->device;
		_tmp3_ = self->priv->device;
		g_signal_emit_by_name ((NoiseDevice*) _tmp2_, "initialized", (NoiseDevice*) _tmp3_);
		noise_library_search_medias ((NoiseLibrary*) self, "");
	}
}


static void
noise_plugins_audio_player_library_real_initialize_library (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	self = (NoisePluginsAudioPlayerLibrary*) base;
}


static void
noise_plugins_audio_player_library_real_add_files_to_library (NoiseLibrary* base,
                                                              GeeCollection* files)
{
	NoisePluginsAudioPlayerLibrary * self;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_if_fail (files != NULL);
}


static GeeCollection*
noise_plugins_audio_player_library_real_get_medias (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	GeeCollection* result = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* _tmp1_;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	_tmp0_ = self->priv->medias;
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
	result = _tmp1_;
	return result;
}


static GeeCollection*
noise_plugins_audio_player_library_real_get_playlists (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	GeeCollection* result = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* _tmp1_;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	_tmp0_ = self->priv->playlists;
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
	result = _tmp1_;
	return result;
}


static GeeCollection*
noise_plugins_audio_player_library_real_get_smart_playlists (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	GeeCollection* result = NULL;
	GeeLinkedList* _tmp0_;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_SMART_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	result = (GeeCollection*) _tmp0_;
	return result;
}


static void
noise_plugins_audio_player_library_real_search_medias (NoiseLibrary* base,
                                                       const gchar* search)
{
	NoisePluginsAudioPlayerLibrary * self;
	GError * _inner_error_ = NULL;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_if_fail (search != NULL);
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->searched_medias;
		g_rec_mutex_lock (&self->priv->__lock_searched_medias);
		{
			GeeLinkedList* _tmp1_;
			gboolean _tmp2_ = FALSE;
			guint parsed_rating = 0U;
			gchar* parsed_search_string = NULL;
			guint _tmp6_ = 0U;
			gchar* _tmp7_ = NULL;
			gboolean rating_search = FALSE;
			guint _tmp8_;
			_tmp1_ = self->priv->searched_medias;
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
			if (g_strcmp0 (search, "") == 0) {
				_tmp2_ = TRUE;
			} else {
				_tmp2_ = search == NULL;
			}
			if (_tmp2_) {
				GeeLinkedList* _tmp3_;
				GeeLinkedList* _tmp4_;
				_tmp3_ = self->priv->searched_medias;
				_tmp4_ = self->priv->medias;
				gee_collection_add_all ((GeeCollection*) _tmp3_, (GeeCollection*) _tmp4_);
				g_signal_emit_by_name ((NoiseLibrary*) self, "search-finished");
				{
					GeeLinkedList* _tmp5_;
					_tmp5_ = self->priv->searched_medias;
					g_rec_mutex_unlock (&self->priv->__lock_searched_medias);
				}
				return;
			}
			noise_string_base_search_method (search, &_tmp6_, &_tmp7_);
			parsed_rating = _tmp6_;
			_g_free0 (parsed_search_string);
			parsed_search_string = _tmp7_;
			_tmp8_ = parsed_rating;
			rating_search = _tmp8_ > ((guint) 0);
			{
				GeeLinkedList* _tmp9_;
				_tmp9_ = self->priv->medias;
				g_rec_mutex_lock (&self->priv->__lock_medias);
				{
					{
						GeeLinkedList* _m_list = NULL;
						GeeLinkedList* _tmp10_;
						GeeLinkedList* _tmp11_;
						gint _m_size = 0;
						GeeLinkedList* _tmp12_;
						gint _tmp13_;
						gint _tmp14_;
						gint _m_index = 0;
						_tmp10_ = self->priv->medias;
						_tmp11_ = _g_object_ref0 (_tmp10_);
						_m_list = _tmp11_;
						_tmp12_ = _m_list;
						_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
						_tmp14_ = _tmp13_;
						_m_size = _tmp14_;
						_m_index = -1;
						while (TRUE) {
							gint _tmp15_;
							gint _tmp16_;
							gint _tmp17_;
							NoiseMedia* m = NULL;
							GeeLinkedList* _tmp18_;
							gint _tmp19_;
							gpointer _tmp20_;
							gboolean _tmp21_;
							_tmp15_ = _m_index;
							_m_index = _tmp15_ + 1;
							_tmp16_ = _m_index;
							_tmp17_ = _m_size;
							if (!(_tmp16_ < _tmp17_)) {
								break;
							}
							_tmp18_ = _m_list;
							_tmp19_ = _m_index;
							_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _tmp19_);
							m = (NoiseMedia*) _tmp20_;
							_tmp21_ = rating_search;
							if (_tmp21_) {
								NoiseMedia* _tmp22_;
								guint _tmp23_;
								guint _tmp24_;
								guint _tmp25_;
								_tmp22_ = m;
								_tmp23_ = noise_media_get_rating (_tmp22_);
								_tmp24_ = _tmp23_;
								_tmp25_ = parsed_rating;
								if (_tmp24_ == _tmp25_) {
									GeeLinkedList* _tmp26_;
									NoiseMedia* _tmp27_;
									_tmp26_ = self->priv->searched_medias;
									_tmp27_ = m;
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _tmp27_);
								}
							} else {
								NoiseMedia* _tmp28_;
								const gchar* _tmp29_;
								_tmp28_ = m;
								_tmp29_ = parsed_search_string;
								if (noise_search_match_string_to_media (_tmp28_, _tmp29_)) {
									GeeLinkedList* _tmp30_;
									NoiseMedia* _tmp31_;
									_tmp30_ = self->priv->searched_medias;
									_tmp31_ = m;
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
								}
							}
							_g_object_unref0 (m);
						}
						_g_object_unref0 (_m_list);
					}
				}
				__finally6:
				{
					GeeLinkedList* _tmp32_;
					_tmp32_ = self->priv->medias;
					g_rec_mutex_unlock (&self->priv->__lock_medias);
				}
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_free0 (parsed_search_string);
					_g_free0 (parsed_search_string);
					{
						GeeLinkedList* _tmp33_;
						_tmp33_ = self->priv->searched_medias;
						g_rec_mutex_unlock (&self->priv->__lock_searched_medias);
					}
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
			_g_free0 (parsed_search_string);
		}
		__finally5:
		{
			GeeLinkedList* _tmp34_;
			_tmp34_ = self->priv->searched_medias;
			g_rec_mutex_unlock (&self->priv->__lock_searched_medias);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	g_signal_emit_by_name ((NoiseLibrary*) self, "search-finished");
}


static GeeCollection*
noise_plugins_audio_player_library_real_get_search_result (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	GeeCollection* result = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* _tmp1_;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	_tmp0_ = self->priv->searched_medias;
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
	result = _tmp1_;
	return result;
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch7_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch7_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally7;
	__catch7_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally7:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static void
noise_plugins_audio_player_library_real_add_media (NoiseLibrary* base,
                                                   NoiseMedia* m)
{
	NoisePluginsAudioPlayerLibrary * self;
	gchar* current_operation = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	NoisePluginsAudioPlayerDevice* _tmp12_;
	gchar* _tmp13_;
	NoiseLibrariesManager* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GFile* file = NULL;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GFile* destination_file = NULL;
	NoisePluginsAudioPlayerDevice* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GFile* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	GFile* _tmp35_;
	GFile* _tmp36_;
	GeeLinkedList* _tmp43_;
	GFile* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	GError * _inner_error_ = NULL;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_if_fail (m != NULL);
	if (m == NULL) {
		return;
	}
	_tmp0_ = g_strdup (_ ("Adding <b>$NAME</b> by <b>$ARTIST</b> to $DEVICE"));
	current_operation = _tmp0_;
	_tmp2_ = noise_media_get_title (m);
	_tmp3_ = _tmp2_;
	_tmp1_ = _tmp3_;
	if (_tmp1_ == NULL) {
		_tmp1_ = "";
	}
	_tmp4_ = current_operation;
	_tmp5_ = string_replace (_tmp4_, "$NAME", _tmp1_);
	_g_free0 (current_operation);
	current_operation = _tmp5_;
	_tmp7_ = noise_media_get_artist (m);
	_tmp8_ = _tmp7_;
	_tmp6_ = _tmp8_;
	if (_tmp6_ == NULL) {
		_tmp6_ = "";
	}
	_tmp9_ = current_operation;
	_tmp10_ = string_replace (_tmp9_, "$ARTIST", _tmp6_);
	_g_free0 (current_operation);
	current_operation = _tmp10_;
	_tmp12_ = self->priv->device;
	_tmp13_ = noise_device_get_display_name ((NoiseDevice*) _tmp12_);
	_tmp11_ = _tmp13_;
	if (_tmp11_ == NULL) {
		gchar* _tmp14_;
		_tmp14_ = g_strdup ("");
		_g_free0 (_tmp11_);
		_tmp11_ = _tmp14_;
	}
	_tmp15_ = noise_libraries_manager;
	_tmp16_ = current_operation;
	_tmp17_ = string_replace (_tmp16_, "$DEVICE", _tmp11_);
	_g_free0 (_tmp15_->current_operation);
	_tmp15_->current_operation = _tmp17_;
	_tmp18_ = noise_media_get_title (m);
	_tmp19_ = _tmp18_;
	_tmp20_ = noise_media_get_artist (m);
	_tmp21_ = _tmp20_;
	g_debug ("AudioPlayerLibrary.vala:141: Adding media %s by %s\n", _tmp19_, _tmp21_);
	_tmp22_ = noise_media_get_uri (m);
	_tmp23_ = _tmp22_;
	_tmp24_ = _tmp23_;
	_tmp25_ = g_file_new_for_uri (_tmp24_);
	_tmp26_ = _tmp25_;
	_g_free0 (_tmp24_);
	file = _tmp26_;
	_tmp27_ = self->priv->device;
	_tmp28_ = noise_plugins_audio_player_device_get_music_folder (_tmp27_);
	_tmp29_ = _tmp28_;
	_tmp30_ = file;
	_tmp31_ = g_file_get_basename (_tmp30_);
	_tmp32_ = _tmp31_;
	_tmp33_ = g_strconcat (_tmp29_, _tmp32_, NULL);
	_tmp34_ = _tmp33_;
	_tmp35_ = g_file_new_for_uri (_tmp34_);
	_tmp36_ = _tmp35_;
	_g_free0 (_tmp34_);
	_g_free0 (_tmp32_);
	_g_free0 (_tmp29_);
	destination_file = _tmp36_;
	{
		GFile* _tmp37_;
		GFile* _tmp38_;
		_tmp37_ = file;
		_tmp38_ = destination_file;
		g_file_copy (_tmp37_, _tmp38_, G_FILE_COPY_ALL_METADATA, NULL, NULL, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch8_g_error;
		}
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp39_;
		const gchar* _tmp40_;
		GError* _tmp41_;
		const gchar* _tmp42_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp39_ = noise_media_get_title (m);
		_tmp40_ = _tmp39_;
		_tmp41_ = err;
		_tmp42_ = _tmp41_->message;
		g_warning ("AudioPlayerLibrary.vala:149: Failed to copy track %s : %s\n", _tmp40_, _tmp42_);
		_g_error_free0 (err);
		_g_object_unref0 (destination_file);
		_g_object_unref0 (file);
		_g_free0 (_tmp11_);
		_g_free0 (current_operation);
		return;
	}
	__finally8:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (destination_file);
		_g_object_unref0 (file);
		_g_free0 (_tmp11_);
		_g_free0 (current_operation);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp43_ = self->priv->imported_files;
	_tmp44_ = destination_file;
	_tmp45_ = g_file_get_uri (_tmp44_);
	_tmp46_ = _tmp45_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp43_, _tmp46_);
	_g_free0 (_tmp46_);
	_g_object_unref0 (destination_file);
	_g_object_unref0 (file);
	_g_free0 (_tmp11_);
	_g_free0 (current_operation);
}


static gboolean
_noise_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = noise_libraries_manager_do_progress_notification_with_timeout ((NoiseLibrariesManager*) self);
	return result;
}


static void
noise_plugins_audio_player_library_real_add_medias (NoiseLibrary* base,
                                                    GeeCollection* list)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseLibrariesManager* _tmp0_;
	NoisePluginsAudioPlayerDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	NoiseLibrariesManager* _tmp5_;
	gint sub_index = 0;
	GeeLinkedList* medias_to_sync = NULL;
	GeeLinkedList* _tmp6_;
	GeeLinkedList* _tmp7_;
	NoisePluginsAudioPlayerDevice* _tmp8_;
	GeeLinkedList* _tmp9_;
	GeeCollection* _tmp10_;
	GeeCollection* _tmp11_;
	GeeLinkedList* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint total_medias = 0;
	GeeLinkedList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_if_fail (list != NULL);
	if (noise_library_doing_file_operations ((NoiseLibrary*) self)) {
		g_warning ("AudioPlayerLibrary.vala:157: Tried to add when already syncing\n");
		return;
	}
	_tmp0_ = noise_libraries_manager;
	_tmp1_ = self->priv->device;
	_tmp2_ = noise_device_get_display_name ((NoiseDevice*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup_printf (_ ("Syncing <b>%s</b>…"), _tmp3_);
	_g_free0 (_tmp0_->current_operation);
	_tmp0_->current_operation = _tmp4_;
	_g_free0 (_tmp3_);
	self->priv->is_doing_file_operations = TRUE;
	_tmp5_ = noise_libraries_manager;
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _noise_libraries_manager_do_progress_notification_with_timeout_gsource_func, g_object_ref (_tmp5_), g_object_unref);
	sub_index = 0;
	_tmp6_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	medias_to_sync = _tmp6_;
	_tmp7_ = medias_to_sync;
	_tmp8_ = self->priv->device;
	_tmp9_ = self->priv->medias;
	_tmp10_ = noise_device_delete_doubles ((NoiseDevice*) _tmp8_, list, (GeeCollection*) _tmp9_);
	_tmp11_ = _tmp10_;
	gee_collection_add_all ((GeeCollection*) _tmp7_, _tmp11_);
	_g_object_unref0 (_tmp11_);
	_tmp12_ = medias_to_sync;
	_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
	_tmp14_ = _tmp13_;
	g_message ("AudioPlayerLibrary.vala:169: Found %d medias to add.", _tmp14_);
	_tmp15_ = medias_to_sync;
	_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
	_tmp17_ = _tmp16_;
	total_medias = _tmp17_;
	_tmp18_ = total_medias;
	if (_tmp18_ > 0) {
		NoisePluginsAudioPlayerDevice* _tmp19_;
		GeeLinkedList* _tmp20_;
		_tmp19_ = self->priv->device;
		_tmp20_ = medias_to_sync;
		if (noise_device_will_fit ((NoiseDevice*) _tmp19_, (GeeCollection*) _tmp20_)) {
			GeeLinkedList* _tmp21_;
			NoiseGStreamerTagger* _tmp38_;
			GeeLinkedList* _tmp39_;
			_tmp21_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
			_g_object_unref0 (self->priv->imported_files);
			self->priv->imported_files = _tmp21_;
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp22_;
				GeeLinkedList* _tmp23_;
				gint _m_size = 0;
				GeeLinkedList* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gint _m_index = 0;
				_tmp22_ = medias_to_sync;
				_tmp23_ = _g_object_ref0 (_tmp22_);
				_m_list = _tmp23_;
				_tmp24_ = _m_list;
				_tmp25_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp24_);
				_tmp26_ = _tmp25_;
				_m_size = _tmp26_;
				_m_index = -1;
				while (TRUE) {
					gint _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
					NoiseMedia* m = NULL;
					GeeLinkedList* _tmp30_;
					gint _tmp31_;
					gpointer _tmp32_;
					NoiseMedia* _tmp33_;
					gint _tmp34_;
					NoiseLibrariesManager* _tmp35_;
					gint _tmp36_;
					gint _tmp37_;
					_tmp27_ = _m_index;
					_m_index = _tmp27_ + 1;
					_tmp28_ = _m_index;
					_tmp29_ = _m_size;
					if (!(_tmp28_ < _tmp29_)) {
						break;
					}
					_tmp30_ = _m_list;
					_tmp31_ = _m_index;
					_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, _tmp31_);
					m = (NoiseMedia*) _tmp32_;
					_tmp33_ = m;
					noise_library_add_media ((NoiseLibrary*) self, _tmp33_);
					_tmp34_ = sub_index;
					sub_index = _tmp34_ + 1;
					_tmp35_ = noise_libraries_manager;
					_tmp36_ = sub_index;
					_tmp37_ = total_medias;
					_tmp35_->progress = (gdouble) (_tmp36_ / _tmp37_);
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_list);
			}
			_tmp38_ = self->tagger;
			_tmp39_ = self->priv->imported_files;
			noise_gstreamer_tagger_discoverer_import_media (_tmp38_, (GeeCollection*) _tmp39_);
		}
	}
	_g_object_unref0 (medias_to_sync);
	return;
}


static NoiseMedia*
noise_plugins_audio_player_library_real_media_from_id (NoiseLibrary* base,
                                                       gint64 id)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseMedia* result = NULL;
	GError * _inner_error_ = NULL;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				GeeLinkedList* _tmp2_;
				gint _m_size = 0;
				GeeLinkedList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _m_index = 0;
				_tmp1_ = self->priv->medias;
				_tmp2_ = _g_object_ref0 (_tmp1_);
				_m_list = _tmp2_;
				_tmp3_ = _m_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_m_size = _tmp5_;
				_m_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
					NoiseMedia* m = NULL;
					GeeLinkedList* _tmp9_;
					gint _tmp10_;
					gpointer _tmp11_;
					NoiseMedia* _tmp12_;
					gint64 _tmp13_;
					gint64 _tmp14_;
					_tmp6_ = _m_index;
					_m_index = _tmp6_ + 1;
					_tmp7_ = _m_index;
					_tmp8_ = _m_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _m_list;
					_tmp10_ = _m_index;
					_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
					m = (NoiseMedia*) _tmp11_;
					_tmp12_ = m;
					_tmp13_ = noise_media_get_rowid (_tmp12_);
					_tmp14_ = _tmp13_;
					if (_tmp14_ == id) {
						result = m;
						_g_object_unref0 (_m_list);
						{
							GeeLinkedList* _tmp15_;
							_tmp15_ = self->priv->medias;
							g_rec_mutex_unlock (&self->priv->__lock_medias);
						}
						return result;
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_list);
			}
		}
		__finally9:
		{
			GeeLinkedList* _tmp16_;
			_tmp16_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = NULL;
	return result;
}


static GeeCollection*
noise_plugins_audio_player_library_real_medias_from_ids (NoiseLibrary* base,
                                                         GeeCollection* ids)
{
	NoisePluginsAudioPlayerLibrary * self;
	GeeCollection* result = NULL;
	GeeLinkedList* media_collection = NULL;
	GeeLinkedList* _tmp0_;
	GError * _inner_error_ = NULL;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_val_if_fail (ids != NULL, NULL);
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	media_collection = _tmp0_;
	{
		GeeLinkedList* _tmp1_;
		_tmp1_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp2_;
				GeeLinkedList* _tmp3_;
				gint _m_size = 0;
				GeeLinkedList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _m_index = 0;
				_tmp2_ = self->priv->medias;
				_tmp3_ = _g_object_ref0 (_tmp2_);
				_m_list = _tmp3_;
				_tmp4_ = _m_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_m_size = _tmp6_;
				_m_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
					NoiseMedia* m = NULL;
					GeeLinkedList* _tmp10_;
					gint _tmp11_;
					gpointer _tmp12_;
					NoiseMedia* _tmp13_;
					gint64 _tmp14_;
					gint64 _tmp15_;
					GeeLinkedList* _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
					_tmp7_ = _m_index;
					_m_index = _tmp7_ + 1;
					_tmp8_ = _m_index;
					_tmp9_ = _m_size;
					if (!(_tmp8_ < _tmp9_)) {
						break;
					}
					_tmp10_ = _m_list;
					_tmp11_ = _m_index;
					_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _tmp11_);
					m = (NoiseMedia*) _tmp12_;
					_tmp13_ = m;
					_tmp14_ = noise_media_get_rowid (_tmp13_);
					_tmp15_ = _tmp14_;
					if (gee_collection_contains (ids, &_tmp15_)) {
						GeeLinkedList* _tmp16_;
						NoiseMedia* _tmp17_;
						_tmp16_ = media_collection;
						_tmp17_ = m;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
					}
					_tmp18_ = media_collection;
					_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
					_tmp20_ = _tmp19_;
					_tmp21_ = gee_collection_get_size (ids);
					_tmp22_ = _tmp21_;
					if (_tmp20_ == _tmp22_) {
						_g_object_unref0 (m);
						break;
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_list);
			}
		}
		__finally10:
		{
			GeeLinkedList* _tmp23_;
			_tmp23_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (media_collection);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = (GeeCollection*) media_collection;
	return result;
}


static GeeCollection*
noise_plugins_audio_player_library_real_medias_from_uris (NoiseLibrary* base,
                                                          GeeCollection* uris)
{
	NoisePluginsAudioPlayerLibrary * self;
	GeeCollection* result = NULL;
	GeeLinkedList* media_collection = NULL;
	GeeLinkedList* _tmp0_;
	GError * _inner_error_ = NULL;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_val_if_fail (uris != NULL, NULL);
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	media_collection = _tmp0_;
	{
		GeeLinkedList* _tmp1_;
		_tmp1_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp2_;
				GeeLinkedList* _tmp3_;
				gint _m_size = 0;
				GeeLinkedList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _m_index = 0;
				_tmp2_ = self->priv->medias;
				_tmp3_ = _g_object_ref0 (_tmp2_);
				_m_list = _tmp3_;
				_tmp4_ = _m_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_m_size = _tmp6_;
				_m_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
					NoiseMedia* m = NULL;
					GeeLinkedList* _tmp10_;
					gint _tmp11_;
					gpointer _tmp12_;
					NoiseMedia* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gboolean _tmp17_;
					GeeLinkedList* _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
					gint _tmp23_;
					gint _tmp24_;
					_tmp7_ = _m_index;
					_m_index = _tmp7_ + 1;
					_tmp8_ = _m_index;
					_tmp9_ = _m_size;
					if (!(_tmp8_ < _tmp9_)) {
						break;
					}
					_tmp10_ = _m_list;
					_tmp11_ = _m_index;
					_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _tmp11_);
					m = (NoiseMedia*) _tmp12_;
					_tmp13_ = m;
					_tmp14_ = noise_media_get_uri (_tmp13_);
					_tmp15_ = _tmp14_;
					_tmp16_ = _tmp15_;
					_tmp17_ = gee_collection_contains (uris, _tmp16_);
					_g_free0 (_tmp16_);
					if (_tmp17_) {
						GeeLinkedList* _tmp18_;
						NoiseMedia* _tmp19_;
						_tmp18_ = media_collection;
						_tmp19_ = m;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
					}
					_tmp20_ = media_collection;
					_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
					_tmp22_ = _tmp21_;
					_tmp23_ = gee_collection_get_size (uris);
					_tmp24_ = _tmp23_;
					if (_tmp22_ == _tmp24_) {
						_g_object_unref0 (m);
						break;
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_list);
			}
		}
		__finally11:
		{
			GeeLinkedList* _tmp25_;
			_tmp25_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (media_collection);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = (GeeCollection*) media_collection;
	return result;
}


static NoiseMedia*
noise_plugins_audio_player_library_real_find_media (NoiseLibrary* base,
                                                    NoiseMedia* to_find)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseMedia* result = NULL;
	NoiseMedia* found = NULL;
	GError * _inner_error_ = NULL;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_val_if_fail (to_find != NULL, NULL);
	found = NULL;
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				GeeLinkedList* _tmp2_;
				gint _m_size = 0;
				GeeLinkedList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _m_index = 0;
				_tmp1_ = self->priv->medias;
				_tmp2_ = _g_object_ref0 (_tmp1_);
				_m_list = _tmp2_;
				_tmp3_ = _m_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_m_size = _tmp5_;
				_m_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
					NoiseMedia* m = NULL;
					GeeLinkedList* _tmp9_;
					gint _tmp10_;
					gpointer _tmp11_;
					gboolean _tmp12_ = FALSE;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					NoiseMedia* _tmp17_;
					const gchar* _tmp18_;
					const gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gboolean _tmp22_;
					_tmp6_ = _m_index;
					_m_index = _tmp6_ + 1;
					_tmp7_ = _m_index;
					_tmp8_ = _m_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _m_list;
					_tmp10_ = _m_index;
					_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
					m = (NoiseMedia*) _tmp11_;
					_tmp13_ = noise_media_get_title (to_find);
					_tmp14_ = _tmp13_;
					_tmp15_ = g_utf8_strdown (_tmp14_, (gssize) -1);
					_tmp16_ = _tmp15_;
					_tmp17_ = m;
					_tmp18_ = noise_media_get_title (_tmp17_);
					_tmp19_ = _tmp18_;
					_tmp20_ = g_utf8_strdown (_tmp19_, (gssize) -1);
					_tmp21_ = _tmp20_;
					_tmp22_ = g_strcmp0 (_tmp16_, _tmp21_) == 0;
					_g_free0 (_tmp21_);
					_g_free0 (_tmp16_);
					if (_tmp22_) {
						const gchar* _tmp23_;
						const gchar* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						NoiseMedia* _tmp27_;
						const gchar* _tmp28_;
						const gchar* _tmp29_;
						gchar* _tmp30_;
						gchar* _tmp31_;
						_tmp23_ = noise_media_get_artist (to_find);
						_tmp24_ = _tmp23_;
						_tmp25_ = g_utf8_strdown (_tmp24_, (gssize) -1);
						_tmp26_ = _tmp25_;
						_tmp27_ = m;
						_tmp28_ = noise_media_get_artist (_tmp27_);
						_tmp29_ = _tmp28_;
						_tmp30_ = g_utf8_strdown (_tmp29_, (gssize) -1);
						_tmp31_ = _tmp30_;
						_tmp12_ = g_strcmp0 (_tmp26_, _tmp31_) == 0;
						_g_free0 (_tmp31_);
						_g_free0 (_tmp26_);
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						NoiseMedia* _tmp32_;
						NoiseMedia* _tmp33_;
						_tmp32_ = m;
						_tmp33_ = _g_object_ref0 (_tmp32_);
						_g_object_unref0 (found);
						found = _tmp33_;
						_g_object_unref0 (m);
						break;
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_list);
			}
		}
		__finally12:
		{
			GeeLinkedList* _tmp34_;
			_tmp34_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (found);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = found;
	return result;
}


static NoiseMedia*
noise_plugins_audio_player_library_real_media_from_file (NoiseLibrary* base,
                                                         GFile* file)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseMedia* result = NULL;
	GError * _inner_error_ = NULL;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_val_if_fail (file != NULL, NULL);
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				GeeLinkedList* _tmp2_;
				gint _m_size = 0;
				GeeLinkedList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _m_index = 0;
				_tmp1_ = self->priv->medias;
				_tmp2_ = _g_object_ref0 (_tmp1_);
				_m_list = _tmp2_;
				_tmp3_ = _m_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_m_size = _tmp5_;
				_m_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
					NoiseMedia* m = NULL;
					GeeLinkedList* _tmp9_;
					gint _tmp10_;
					gpointer _tmp11_;
					gboolean _tmp12_ = FALSE;
					NoiseMedia* _tmp13_;
					_tmp6_ = _m_index;
					_m_index = _tmp6_ + 1;
					_tmp7_ = _m_index;
					_tmp8_ = _m_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _m_list;
					_tmp10_ = _m_index;
					_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
					m = (NoiseMedia*) _tmp11_;
					_tmp13_ = m;
					if (_tmp13_ != NULL) {
						NoiseMedia* _tmp14_;
						GFile* _tmp15_;
						GFile* _tmp16_;
						_tmp14_ = m;
						_tmp15_ = noise_media_get_file (_tmp14_);
						_tmp16_ = _tmp15_;
						_tmp12_ = g_file_equal (_tmp16_, file);
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						result = m;
						_g_object_unref0 (_m_list);
						{
							GeeLinkedList* _tmp17_;
							_tmp17_ = self->priv->medias;
							g_rec_mutex_unlock (&self->priv->__lock_medias);
						}
						return result;
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_list);
			}
		}
		__finally13:
		{
			GeeLinkedList* _tmp18_;
			_tmp18_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = NULL;
	return result;
}


static NoiseMedia*
noise_plugins_audio_player_library_real_media_from_uri (NoiseLibrary* base,
                                                        const gchar* uri)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseMedia* result = NULL;
	GError * _inner_error_ = NULL;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_val_if_fail (uri != NULL, NULL);
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				GeeLinkedList* _tmp2_;
				gint _m_size = 0;
				GeeLinkedList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _m_index = 0;
				_tmp1_ = self->priv->medias;
				_tmp2_ = _g_object_ref0 (_tmp1_);
				_m_list = _tmp2_;
				_tmp3_ = _m_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_m_size = _tmp5_;
				_m_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
					NoiseMedia* m = NULL;
					GeeLinkedList* _tmp9_;
					gint _tmp10_;
					gpointer _tmp11_;
					gboolean _tmp12_ = FALSE;
					NoiseMedia* _tmp13_;
					_tmp6_ = _m_index;
					_m_index = _tmp6_ + 1;
					_tmp7_ = _m_index;
					_tmp8_ = _m_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _m_list;
					_tmp10_ = _m_index;
					_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
					m = (NoiseMedia*) _tmp11_;
					_tmp13_ = m;
					if (_tmp13_ != NULL) {
						NoiseMedia* _tmp14_;
						gchar* _tmp15_;
						gchar* _tmp16_;
						gchar* _tmp17_;
						_tmp14_ = m;
						_tmp15_ = noise_media_get_uri (_tmp14_);
						_tmp16_ = _tmp15_;
						_tmp17_ = _tmp16_;
						_tmp12_ = g_strcmp0 (_tmp17_, uri) == 0;
						_g_free0 (_tmp17_);
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						result = m;
						_g_object_unref0 (_m_list);
						{
							GeeLinkedList* _tmp18_;
							_tmp18_ = self->priv->medias;
							g_rec_mutex_unlock (&self->priv->__lock_medias);
						}
						return result;
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_list);
			}
		}
		__finally14:
		{
			GeeLinkedList* _tmp19_;
			_tmp19_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = NULL;
	return result;
}


static void
noise_plugins_audio_player_library_real_update_media (NoiseLibrary* base,
                                                      NoiseMedia* s,
                                                      gboolean updateMeta,
                                                      gboolean record_time)
{
	NoisePluginsAudioPlayerLibrary * self;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_if_fail (s != NULL);
}


static void
noise_plugins_audio_player_library_real_update_medias (NoiseLibrary* base,
                                                       GeeCollection* updates,
                                                       gboolean updateMeta,
                                                       gboolean record_time)
{
	NoisePluginsAudioPlayerLibrary * self;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_if_fail (updates != NULL);
}


static void
noise_plugins_audio_player_library_real_remove_media (NoiseLibrary* base,
                                                      NoiseMedia* m,
                                                      gboolean trash)
{
	NoisePluginsAudioPlayerLibrary * self;
	gchar* current_operation = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	NoisePluginsAudioPlayerDevice* _tmp12_;
	gchar* _tmp13_;
	NoiseLibrariesManager* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean _tmp21_;
	GError * _inner_error_ = NULL;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_if_fail (m != NULL);
	_tmp0_ = g_strdup (_ ("Removing <b>$NAME</b> by <b>$ARTIST</b> from $DEVICE"));
	current_operation = _tmp0_;
	_tmp2_ = noise_media_get_title (m);
	_tmp3_ = _tmp2_;
	_tmp1_ = _tmp3_;
	if (_tmp1_ == NULL) {
		_tmp1_ = "";
	}
	_tmp4_ = current_operation;
	_tmp5_ = string_replace (_tmp4_, "$NAME", _tmp1_);
	_g_free0 (current_operation);
	current_operation = _tmp5_;
	_tmp7_ = noise_media_get_artist (m);
	_tmp8_ = _tmp7_;
	_tmp6_ = _tmp8_;
	if (_tmp6_ == NULL) {
		_tmp6_ = "";
	}
	_tmp9_ = current_operation;
	_tmp10_ = string_replace (_tmp9_, "$ARTIST", _tmp6_);
	_g_free0 (current_operation);
	current_operation = _tmp10_;
	_tmp12_ = self->priv->device;
	_tmp13_ = noise_device_get_display_name ((NoiseDevice*) _tmp12_);
	_tmp11_ = _tmp13_;
	if (_tmp11_ == NULL) {
		gchar* _tmp14_;
		_tmp14_ = g_strdup ("");
		_g_free0 (_tmp11_);
		_tmp11_ = _tmp14_;
	}
	_tmp15_ = noise_libraries_manager;
	_tmp16_ = current_operation;
	_tmp17_ = string_replace (_tmp16_, "$DEVICE", _tmp11_);
	_g_free0 (_tmp15_->current_operation);
	_tmp15_->current_operation = _tmp17_;
	_tmp18_ = noise_media_get_uri (m);
	_tmp19_ = _tmp18_;
	_tmp20_ = _tmp19_;
	_tmp21_ = _tmp20_ != NULL;
	_g_free0 (_tmp20_);
	if (_tmp21_) {
		GFile* file = NULL;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		GFile* _tmp25_;
		GFile* _tmp26_;
		GFile* _tmp27_;
		_tmp22_ = noise_media_get_uri (m);
		_tmp23_ = _tmp22_;
		_tmp24_ = _tmp23_;
		_tmp25_ = g_file_new_for_uri (_tmp24_);
		_tmp26_ = _tmp25_;
		_g_free0 (_tmp24_);
		file = _tmp26_;
		_tmp27_ = file;
		if (g_file_query_exists (_tmp27_, NULL)) {
			GeeArrayList* media_list = NULL;
			GeeArrayList* _tmp28_;
			GeeArrayList* _tmp29_;
			GeeArrayList* _tmp30_;
			GeeLinkedList* _tmp31_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			_tmp28_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
			media_list = _tmp28_;
			_tmp29_ = media_list;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, m);
			_tmp30_ = media_list;
			g_signal_emit_by_name ((NoiseLibrary*) self, "media-removed", (GeeCollection*) _tmp30_);
			_tmp31_ = self->priv->medias;
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp31_, m);
			{
				GFile* _tmp32_;
				_tmp32_ = file;
				g_file_delete (_tmp32_, NULL, &_inner_error_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					goto __catch15_g_error;
				}
			}
			goto __finally15;
			__catch15_g_error:
			{
				GError* err = NULL;
				gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				GError* _tmp36_;
				const gchar* _tmp37_;
				err = _inner_error_;
				_inner_error_ = NULL;
				_tmp33_ = noise_media_get_uri (m);
				_tmp34_ = _tmp33_;
				_tmp35_ = _tmp34_;
				_tmp36_ = err;
				_tmp37_ = _tmp36_->message;
				g_warning ("AudioPlayerLibrary.vala:282: Could not delete File at %s: %s", _tmp35_, _tmp37_);
				_g_free0 (_tmp35_);
				_g_error_free0 (err);
				_g_object_unref0 (media_list);
				_g_object_unref0 (file);
				_g_free0 (_tmp11_);
				_g_free0 (current_operation);
				return;
			}
			__finally15:
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (media_list);
				_g_object_unref0 (file);
				_g_free0 (_tmp11_);
				_g_free0 (current_operation);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_tmp38_ = noise_media_get_uri (m);
			_tmp39_ = _tmp38_;
			_tmp40_ = _tmp39_;
			g_debug ("AudioPlayerLibrary.vala:285: Successfully removed music file %s", _tmp40_);
			_g_free0 (_tmp40_);
			_g_object_unref0 (media_list);
		} else {
			gchar* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
			_tmp41_ = noise_media_get_uri (m);
			_tmp42_ = _tmp41_;
			_tmp43_ = _tmp42_;
			g_warning ("AudioPlayerLibrary.vala:287: File not found, could not delete File at " \
"%s. File may already be deleted", _tmp43_);
			_g_free0 (_tmp43_);
		}
		_g_object_unref0 (file);
	}
	_g_free0 (_tmp11_);
	_g_free0 (current_operation);
}


static void
noise_plugins_audio_player_library_real_remove_medias (NoiseLibrary* base,
                                                       GeeCollection* list,
                                                       gboolean trash)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseLibrariesManager* _tmp0_;
	NoisePluginsAudioPlayerDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gint total = 0;
	gint _tmp5_;
	gint _tmp6_;
	NoiseLibrariesManager* _tmp7_;
	gint sub_index = 0;
	NoiseLibrariesManager* _tmp17_;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_if_fail (list != NULL);
	if (noise_library_doing_file_operations ((NoiseLibrary*) self)) {
		g_warning ("AudioPlayerLibrary.vala:293: Tried to add when already syncing\n");
		return;
	}
	_tmp0_ = noise_libraries_manager;
	_tmp1_ = self->priv->device;
	_tmp2_ = noise_device_get_display_name ((NoiseDevice*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup_printf (_ ("Removing from <b>%s</b>…"), _tmp3_);
	_g_free0 (_tmp0_->current_operation);
	_tmp0_->current_operation = _tmp4_;
	_g_free0 (_tmp3_);
	_tmp5_ = gee_collection_get_size (list);
	_tmp6_ = _tmp5_;
	total = _tmp6_;
	_tmp7_ = noise_libraries_manager;
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _noise_libraries_manager_do_progress_notification_with_timeout_gsource_func, g_object_ref (_tmp7_), g_object_unref);
	sub_index = 0;
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp8_;
		_tmp8_ = gee_iterable_iterator ((GeeIterable*) list);
		_m_it = _tmp8_;
		while (TRUE) {
			GeeIterator* _tmp9_;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			NoiseMedia* _tmp12_;
			gint _tmp13_;
			NoiseLibrariesManager* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			_tmp9_ = _m_it;
			if (!gee_iterator_next (_tmp9_)) {
				break;
			}
			_tmp10_ = _m_it;
			_tmp11_ = gee_iterator_get (_tmp10_);
			m = (NoiseMedia*) _tmp11_;
			_tmp12_ = m;
			noise_library_remove_media ((NoiseLibrary*) self, _tmp12_, TRUE);
			_tmp13_ = sub_index;
			sub_index = _tmp13_ + 1;
			_tmp14_ = noise_libraries_manager;
			_tmp15_ = sub_index;
			_tmp16_ = total;
			_tmp14_->progress = (gdouble) (_tmp15_ / _tmp16_);
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	_tmp17_ = noise_libraries_manager;
	_tmp17_->progress = (gdouble) 1;
	g_signal_emit_by_name ((NoiseLibrary*) self, "file-operations-done");
}


static gboolean
noise_plugins_audio_player_library_real_support_smart_playlists (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	gboolean result = FALSE;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	result = FALSE;
	return result;
}


static void
noise_plugins_audio_player_library_real_add_smart_playlist (NoiseLibrary* base,
                                                            NoiseSmartPlaylist* p)
{
	NoisePluginsAudioPlayerLibrary * self;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_if_fail (p != NULL);
}


static void
noise_plugins_audio_player_library_real_remove_smart_playlist (NoiseLibrary* base,
                                                               gint64 id)
{
	NoisePluginsAudioPlayerLibrary * self;
	self = (NoisePluginsAudioPlayerLibrary*) base;
}


static NoiseSmartPlaylist*
noise_plugins_audio_player_library_real_smart_playlist_from_id (NoiseLibrary* base,
                                                                gint64 id)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseSmartPlaylist* result = NULL;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	result = NULL;
	return result;
}


static NoiseSmartPlaylist*
noise_plugins_audio_player_library_real_smart_playlist_from_name (NoiseLibrary* base,
                                                                  const gchar* name)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseSmartPlaylist* result = NULL;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_val_if_fail (name != NULL, NULL);
	result = NULL;
	return result;
}


static gboolean
noise_plugins_audio_player_library_real_support_playlists (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	gboolean result = FALSE;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	result = FALSE;
	return result;
}


static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		NoisePluginsAudioPlayerLibrary* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->p);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}


static void
__lambda5_ (Block1Data* _data1_)
{
	NoisePluginsAudioPlayerLibrary* self;
	self = _data1_->self;
	noise_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
}


static void
___lambda5__noise_playlist_media_added (NoisePlaylist* _sender,
                                        GeeCollection* media,
                                        gpointer self)
{
	__lambda5_ (self);
}


static void
__lambda6_ (Block1Data* _data1_)
{
	NoisePluginsAudioPlayerLibrary* self;
	self = _data1_->self;
	noise_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
}


static void
___lambda6__noise_playlist_media_removed (NoisePlaylist* _sender,
                                          GeeCollection* media,
                                          gpointer self)
{
	__lambda6_ (self);
}


static void
__lambda7_ (Block1Data* _data1_,
            const gchar* old_name)
{
	NoisePluginsAudioPlayerLibrary* self;
	self = _data1_->self;
	noise_plugins_audio_player_library_remove_playlist_from_name (self, old_name);
	noise_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
}


static void
___lambda7__noise_playlist_updated (NoisePlaylist* _sender,
                                    const gchar* old_name,
                                    gpointer self)
{
	__lambda7_ (self, old_name);
}


static void
noise_plugins_audio_player_library_real_add_playlist (NoiseLibrary* base,
                                                      NoiseStaticPlaylist* p)
{
	NoisePluginsAudioPlayerLibrary * self;
	Block1Data* _data1_;
	NoiseStaticPlaylist* _tmp0_;
	GeeLinkedList* _tmp1_;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_if_fail (p != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (p);
	_g_object_unref0 (_data1_->p);
	_data1_->p = _tmp0_;
	_tmp1_ = self->priv->playlists;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _data1_->p);
	g_signal_emit_by_name ((NoiseLibrary*) self, "playlist-added", _data1_->p);
	noise_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
	g_signal_connect_data ((NoisePlaylist*) _data1_->p, "media-added", (GCallback) ___lambda5__noise_playlist_media_added, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	g_signal_connect_data ((NoisePlaylist*) _data1_->p, "media-removed", (GCallback) ___lambda6__noise_playlist_media_removed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	g_signal_connect_data ((NoisePlaylist*) _data1_->p, "updated", (GCallback) ___lambda7__noise_playlist_updated, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


static void
noise_plugins_audio_player_library_real_remove_playlist (NoiseLibrary* base,
                                                         gint64 id)
{
	NoisePluginsAudioPlayerLibrary * self;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	_tmp0_ = noise_library_get_playlists ((NoiseLibrary*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gee_collection_get_size (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = id < ((gint64) _tmp3_);
	_g_object_unref0 (_tmp1_);
	if (_tmp4_) {
		GeeArrayList* array_v = NULL;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeLinkedList* _tmp7_;
		_tmp5_ = gee_array_list_new (NOISE_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
		array_v = _tmp5_;
		_tmp6_ = array_v;
		_tmp7_ = self->priv->playlists;
		gee_array_list_add_all (_tmp6_, (GeeCollection*) _tmp7_);
		{
			GeeArrayList* _p_list = NULL;
			GeeArrayList* _tmp8_;
			GeeArrayList* _tmp9_;
			gint _p_size = 0;
			GeeArrayList* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _p_index = 0;
			_tmp8_ = array_v;
			_tmp9_ = _g_object_ref0 (_tmp8_);
			_p_list = _tmp9_;
			_tmp10_ = _p_list;
			_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
			_tmp12_ = _tmp11_;
			_p_size = _tmp12_;
			_p_index = -1;
			while (TRUE) {
				gint _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				NoiseStaticPlaylist* p = NULL;
				GeeArrayList* _tmp16_;
				gint _tmp17_;
				gpointer _tmp18_;
				NoiseStaticPlaylist* _tmp19_;
				gint64 _tmp20_;
				gint64 _tmp21_;
				_tmp13_ = _p_index;
				_p_index = _tmp13_ + 1;
				_tmp14_ = _p_index;
				_tmp15_ = _p_size;
				if (!(_tmp14_ < _tmp15_)) {
					break;
				}
				_tmp16_ = _p_list;
				_tmp17_ = _p_index;
				_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _tmp17_);
				p = (NoiseStaticPlaylist*) _tmp18_;
				_tmp19_ = p;
				_tmp20_ = noise_playlist_get_rowid ((NoisePlaylist*) _tmp19_);
				_tmp21_ = _tmp20_;
				if (_tmp21_ == id) {
					NoiseStaticPlaylist* _tmp22_;
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					NoiseStaticPlaylist* _tmp25_;
					GeeLinkedList* _tmp26_;
					NoiseStaticPlaylist* _tmp27_;
					_tmp22_ = p;
					_tmp23_ = noise_playlist_get_name ((NoisePlaylist*) _tmp22_);
					_tmp24_ = _tmp23_;
					noise_plugins_audio_player_library_remove_playlist_from_name (self, _tmp24_);
					_tmp25_ = p;
					g_signal_emit_by_name ((NoiseLibrary*) self, "playlist-removed", _tmp25_);
					_tmp26_ = self->priv->playlists;
					_tmp27_ = p;
					gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp26_, _tmp27_);
					_g_object_unref0 (p);
					_g_object_unref0 (_p_list);
					_g_object_unref0 (array_v);
					return;
				}
				_g_object_unref0 (p);
			}
			_g_object_unref0 (_p_list);
		}
		_g_object_unref0 (array_v);
	}
}


static void
noise_plugins_audio_player_library_remove_playlist_from_name (NoisePluginsAudioPlayerLibrary* self,
                                                              const gchar* name)
{
	GFile* dest = NULL;
	NoisePluginsAudioPlayerDevice* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = self->priv->device;
	_tmp1_ = noise_plugins_audio_player_device_get_music_folder (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = string_replace (name, "/", "_");
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, ".m3u", NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_build_path ("/", _tmp2_, "Playlists", _tmp6_, NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_file_new_for_uri (_tmp8_);
	_tmp10_ = _tmp9_;
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	dest = _tmp10_;
	{
		GFile* _tmp11_;
		_tmp11_ = dest;
		if (g_file_query_exists (_tmp11_, NULL)) {
			GFile* _tmp12_;
			_tmp12_ = dest;
			g_file_delete (_tmp12_, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch16_g_error;
			}
		}
	}
	goto __finally16;
	__catch16_g_error:
	{
		GError* err = NULL;
		GFile* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GError* _tmp16_;
		const gchar* _tmp17_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp13_ = dest;
		_tmp14_ = g_file_get_path (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = err;
		_tmp17_ = _tmp16_->message;
		g_warning ("AudioPlayerLibrary.vala:366: Could not remove playlist %s to file %s: " \
"%s", name, _tmp15_, _tmp17_);
		_g_free0 (_tmp15_);
		_g_error_free0 (err);
	}
	__finally16:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (dest);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_object_unref0 (dest);
}


static void
noise_plugins_audio_player_library_keep_playlist_synchronized (NoisePluginsAudioPlayerLibrary* self,
                                                               NoiseStaticPlaylist* p)
{
	gchar* content = NULL;
	NoisePluginsAudioPlayerDevice* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	NoisePluginsAudioPlayerDevice* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GFile* dest = NULL;
	NoisePluginsAudioPlayerDevice* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = self->priv->device;
	_tmp1_ = noise_device_get_uri ((NoiseDevice*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = noise_playlists_utils_get_playlist_m3u_file ((NoisePlaylist*) p, _tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	content = _tmp4_;
	_tmp5_ = content;
	_tmp6_ = self->priv->device;
	_tmp7_ = noise_device_get_uri ((NoiseDevice*) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_file_new_for_uri (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_file_get_path (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = string_replace (_tmp5_, _tmp12_, "");
	_g_free0 (content);
	content = _tmp13_;
	_g_free0 (_tmp12_);
	_g_object_unref0 (_tmp10_);
	_g_free0 (_tmp8_);
	_tmp14_ = self->priv->device;
	_tmp15_ = noise_plugins_audio_player_device_get_music_folder (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = noise_playlist_get_name ((NoisePlaylist*) p);
	_tmp18_ = _tmp17_;
	_tmp19_ = string_replace (_tmp18_, "/", "_");
	_tmp20_ = _tmp19_;
	_tmp21_ = g_strconcat (_tmp20_, ".m3u", NULL);
	_tmp22_ = _tmp21_;
	_tmp23_ = g_build_path ("/", _tmp16_, "Playlists", _tmp22_, NULL);
	_tmp24_ = _tmp23_;
	_tmp25_ = g_file_new_for_uri (_tmp24_);
	_tmp26_ = _tmp25_;
	_g_free0 (_tmp24_);
	_g_free0 (_tmp22_);
	_g_free0 (_tmp20_);
	_g_free0 (_tmp16_);
	dest = _tmp26_;
	{
		GFile* _tmp27_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp29_;
		GFileOutputStream* _tmp30_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp31_;
		GDataOutputStream* _tmp32_;
		GDataOutputStream* _tmp33_;
		const gchar* _tmp34_;
		_tmp27_ = dest;
		if (g_file_query_exists (_tmp27_, NULL)) {
			GFile* _tmp28_;
			_tmp28_ = dest;
			g_file_delete (_tmp28_, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch17_g_error;
			}
		}
		_tmp29_ = dest;
		_tmp30_ = g_file_create (_tmp29_, G_FILE_CREATE_NONE, NULL, &_inner_error_);
		file_stream = _tmp30_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch17_g_error;
		}
		_tmp31_ = file_stream;
		_tmp32_ = g_data_output_stream_new ((GOutputStream*) _tmp31_);
		data_stream = _tmp32_;
		_tmp33_ = data_stream;
		_tmp34_ = content;
		g_data_output_stream_put_string (_tmp33_, _tmp34_, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (data_stream);
			_g_object_unref0 (file_stream);
			goto __catch17_g_error;
		}
		_g_object_unref0 (data_stream);
		_g_object_unref0 (file_stream);
	}
	goto __finally17;
	__catch17_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		GFile* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		GError* _tmp40_;
		const gchar* _tmp41_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp35_ = noise_playlist_get_name ((NoisePlaylist*) p);
		_tmp36_ = _tmp35_;
		_tmp37_ = dest;
		_tmp38_ = g_file_get_path (_tmp37_);
		_tmp39_ = _tmp38_;
		_tmp40_ = err;
		_tmp41_ = _tmp40_->message;
		g_warning ("AudioPlayerLibrary.vala:388: Could not save playlist %s to m3u file %s" \
": %s\n", _tmp36_, _tmp39_, _tmp41_);
		_g_free0 (_tmp39_);
		_g_error_free0 (err);
	}
	__finally17:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (dest);
		_g_free0 (content);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_object_unref0 (dest);
	_g_free0 (content);
}


static NoiseStaticPlaylist*
noise_plugins_audio_player_library_real_playlist_from_id (NoiseLibrary* base,
                                                          gint64 id)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseStaticPlaylist* result = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	_tmp0_ = noise_library_get_playlists ((NoiseLibrary*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gee_collection_get_size (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = id < ((gint64) _tmp3_);
	_g_object_unref0 (_tmp1_);
	if (_tmp4_) {
		GeeArrayList* array = NULL;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeCollection* _tmp7_;
		GeeCollection* _tmp8_;
		_tmp5_ = gee_array_list_new (NOISE_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
		array = _tmp5_;
		_tmp6_ = array;
		_tmp7_ = noise_library_get_playlists ((NoiseLibrary*) self);
		_tmp8_ = _tmp7_;
		gee_array_list_add_all (_tmp6_, _tmp8_);
		_g_object_unref0 (_tmp8_);
		{
			GeeArrayList* _playlist_list = NULL;
			GeeArrayList* _tmp9_;
			GeeArrayList* _tmp10_;
			gint _playlist_size = 0;
			GeeArrayList* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _playlist_index = 0;
			_tmp9_ = array;
			_tmp10_ = _g_object_ref0 (_tmp9_);
			_playlist_list = _tmp10_;
			_tmp11_ = _playlist_list;
			_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
			_tmp13_ = _tmp12_;
			_playlist_size = _tmp13_;
			_playlist_index = -1;
			while (TRUE) {
				gint _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				NoiseStaticPlaylist* playlist = NULL;
				GeeArrayList* _tmp17_;
				gint _tmp18_;
				gpointer _tmp19_;
				NoiseStaticPlaylist* _tmp20_;
				gint64 _tmp21_;
				gint64 _tmp22_;
				_tmp14_ = _playlist_index;
				_playlist_index = _tmp14_ + 1;
				_tmp15_ = _playlist_index;
				_tmp16_ = _playlist_size;
				if (!(_tmp15_ < _tmp16_)) {
					break;
				}
				_tmp17_ = _playlist_list;
				_tmp18_ = _playlist_index;
				_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _tmp18_);
				playlist = (NoiseStaticPlaylist*) _tmp19_;
				_tmp20_ = playlist;
				_tmp21_ = noise_playlist_get_rowid ((NoisePlaylist*) _tmp20_);
				_tmp22_ = _tmp21_;
				if (_tmp22_ == id) {
					result = playlist;
					_g_object_unref0 (_playlist_list);
					_g_object_unref0 (array);
					return result;
				}
				_g_object_unref0 (playlist);
			}
			_g_object_unref0 (_playlist_list);
		}
		_g_object_unref0 (array);
	}
	result = NULL;
	return result;
}


static NoiseStaticPlaylist*
noise_plugins_audio_player_library_real_playlist_from_name (NoiseLibrary* base,
                                                            const gchar* name)
{
	NoisePluginsAudioPlayerLibrary * self;
	NoiseStaticPlaylist* result = NULL;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	g_return_val_if_fail (name != NULL, NULL);
	{
		GeeIterator* _playlist_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
		_tmp0_ = noise_library_get_playlists ((NoiseLibrary*) self);
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_playlist_it = _tmp3_;
		while (TRUE) {
			GeeIterator* _tmp4_;
			NoiseStaticPlaylist* playlist = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			NoiseStaticPlaylist* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			_tmp4_ = _playlist_it;
			if (!gee_iterator_next (_tmp4_)) {
				break;
			}
			_tmp5_ = _playlist_it;
			_tmp6_ = gee_iterator_get (_tmp5_);
			playlist = (NoiseStaticPlaylist*) _tmp6_;
			_tmp7_ = playlist;
			_tmp8_ = noise_playlist_get_name ((NoisePlaylist*) _tmp7_);
			_tmp9_ = _tmp8_;
			if (g_strcmp0 (_tmp9_, name) == 0) {
				result = playlist;
				_g_object_unref0 (_playlist_it);
				return result;
			}
			_g_object_unref0 (playlist);
		}
		_g_object_unref0 (_playlist_it);
	}
	result = NULL;
	return result;
}


static gboolean
noise_plugins_audio_player_library_real_start_file_operations (NoiseLibrary* base,
                                                               const gchar* message)
{
	NoisePluginsAudioPlayerLibrary * self;
	gboolean result = FALSE;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	if (noise_library_doing_file_operations ((NoiseLibrary*) self)) {
		result = TRUE;
		return result;
	} else {
		result = FALSE;
		return result;
	}
}


static gboolean
noise_plugins_audio_player_library_real_doing_file_operations (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	self = (NoisePluginsAudioPlayerLibrary*) base;
	_tmp0_ = self->priv->is_doing_file_operations;
	result = _tmp0_;
	return result;
}


static void
noise_plugins_audio_player_library_real_finish_file_operations (NoiseLibrary* base)
{
	NoisePluginsAudioPlayerLibrary * self;
	self = (NoisePluginsAudioPlayerLibrary*) base;
}


static void
noise_plugins_audio_player_library_class_init (NoisePluginsAudioPlayerLibraryClass * klass)
{
	noise_plugins_audio_player_library_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoisePluginsAudioPlayerLibrary_private_offset);
	((NoiseLibraryClass *) klass)->initialize_library = (void (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_initialize_library;
	((NoiseLibraryClass *) klass)->add_files_to_library = (void (*) (NoiseLibrary *, GeeCollection*)) noise_plugins_audio_player_library_real_add_files_to_library;
	((NoiseLibraryClass *) klass)->get_medias = (GeeCollection* (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_get_medias;
	((NoiseLibraryClass *) klass)->get_playlists = (GeeCollection* (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_get_playlists;
	((NoiseLibraryClass *) klass)->get_smart_playlists = (GeeCollection* (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_get_smart_playlists;
	((NoiseLibraryClass *) klass)->search_medias = (void (*) (NoiseLibrary *, const gchar*)) noise_plugins_audio_player_library_real_search_medias;
	((NoiseLibraryClass *) klass)->get_search_result = (GeeCollection* (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_get_search_result;
	((NoiseLibraryClass *) klass)->add_media = (void (*) (NoiseLibrary *, NoiseMedia*)) noise_plugins_audio_player_library_real_add_media;
	((NoiseLibraryClass *) klass)->add_medias = (void (*) (NoiseLibrary *, GeeCollection*)) noise_plugins_audio_player_library_real_add_medias;
	((NoiseLibraryClass *) klass)->media_from_id = (NoiseMedia* (*) (NoiseLibrary *, gint64)) noise_plugins_audio_player_library_real_media_from_id;
	((NoiseLibraryClass *) klass)->medias_from_ids = (GeeCollection* (*) (NoiseLibrary *, GeeCollection*)) noise_plugins_audio_player_library_real_medias_from_ids;
	((NoiseLibraryClass *) klass)->medias_from_uris = (GeeCollection* (*) (NoiseLibrary *, GeeCollection*)) noise_plugins_audio_player_library_real_medias_from_uris;
	((NoiseLibraryClass *) klass)->find_media = (NoiseMedia* (*) (NoiseLibrary *, NoiseMedia*)) noise_plugins_audio_player_library_real_find_media;
	((NoiseLibraryClass *) klass)->media_from_file = (NoiseMedia* (*) (NoiseLibrary *, GFile*)) noise_plugins_audio_player_library_real_media_from_file;
	((NoiseLibraryClass *) klass)->media_from_uri = (NoiseMedia* (*) (NoiseLibrary *, const gchar*)) noise_plugins_audio_player_library_real_media_from_uri;
	((NoiseLibraryClass *) klass)->update_media = (void (*) (NoiseLibrary *, NoiseMedia*, gboolean, gboolean)) noise_plugins_audio_player_library_real_update_media;
	((NoiseLibraryClass *) klass)->update_medias = (void (*) (NoiseLibrary *, GeeCollection*, gboolean, gboolean)) noise_plugins_audio_player_library_real_update_medias;
	((NoiseLibraryClass *) klass)->remove_media = (void (*) (NoiseLibrary *, NoiseMedia*, gboolean)) noise_plugins_audio_player_library_real_remove_media;
	((NoiseLibraryClass *) klass)->remove_medias = (void (*) (NoiseLibrary *, GeeCollection*, gboolean)) noise_plugins_audio_player_library_real_remove_medias;
	((NoiseLibraryClass *) klass)->support_smart_playlists = (gboolean (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_support_smart_playlists;
	((NoiseLibraryClass *) klass)->add_smart_playlist = (void (*) (NoiseLibrary *, NoiseSmartPlaylist*)) noise_plugins_audio_player_library_real_add_smart_playlist;
	((NoiseLibraryClass *) klass)->remove_smart_playlist = (void (*) (NoiseLibrary *, gint64)) noise_plugins_audio_player_library_real_remove_smart_playlist;
	((NoiseLibraryClass *) klass)->smart_playlist_from_id = (NoiseSmartPlaylist* (*) (NoiseLibrary *, gint64)) noise_plugins_audio_player_library_real_smart_playlist_from_id;
	((NoiseLibraryClass *) klass)->smart_playlist_from_name = (NoiseSmartPlaylist* (*) (NoiseLibrary *, const gchar*)) noise_plugins_audio_player_library_real_smart_playlist_from_name;
	((NoiseLibraryClass *) klass)->support_playlists = (gboolean (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_support_playlists;
	((NoiseLibraryClass *) klass)->add_playlist = (void (*) (NoiseLibrary *, NoiseStaticPlaylist*)) noise_plugins_audio_player_library_real_add_playlist;
	((NoiseLibraryClass *) klass)->remove_playlist = (void (*) (NoiseLibrary *, gint64)) noise_plugins_audio_player_library_real_remove_playlist;
	((NoiseLibraryClass *) klass)->playlist_from_id = (NoiseStaticPlaylist* (*) (NoiseLibrary *, gint64)) noise_plugins_audio_player_library_real_playlist_from_id;
	((NoiseLibraryClass *) klass)->playlist_from_name = (NoiseStaticPlaylist* (*) (NoiseLibrary *, const gchar*)) noise_plugins_audio_player_library_real_playlist_from_name;
	((NoiseLibraryClass *) klass)->start_file_operations = (gboolean (*) (NoiseLibrary *, const gchar*)) noise_plugins_audio_player_library_real_start_file_operations;
	((NoiseLibraryClass *) klass)->doing_file_operations = (gboolean (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_doing_file_operations;
	((NoiseLibraryClass *) klass)->finish_file_operations = (void (*) (NoiseLibrary *)) noise_plugins_audio_player_library_real_finish_file_operations;
	G_OBJECT_CLASS (klass)->finalize = noise_plugins_audio_player_library_finalize;
}


static void
noise_plugins_audio_player_library_instance_init (NoisePluginsAudioPlayerLibrary * self)
{
	self->priv = noise_plugins_audio_player_library_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_medias);
	g_rec_mutex_init (&self->priv->__lock_searched_medias);
	self->priv->operation_cancelled = FALSE;
	self->priv->is_doing_file_operations = FALSE;
	self->priv->queue_is_finished = FALSE;
	self->priv->is_initialized = FALSE;
	self->medias_rowid = 0;
	self->playlists_rowid = 0;
	self->smartplaylists_rowid = 0;
}


static void
noise_plugins_audio_player_library_finalize (GObject * obj)
{
	NoisePluginsAudioPlayerLibrary * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibrary);
	_g_object_unref0 (self->priv->device);
	g_rec_mutex_clear (&self->priv->__lock_medias);
	_g_object_unref0 (self->priv->medias);
	g_rec_mutex_clear (&self->priv->__lock_searched_medias);
	_g_object_unref0 (self->priv->searched_medias);
	_g_object_unref0 (self->priv->playlists);
	_g_object_unref0 (self->priv->imported_files);
	_g_object_unref0 (self->tagger);
	G_OBJECT_CLASS (noise_plugins_audio_player_library_parent_class)->finalize (obj);
}


GType
noise_plugins_audio_player_library_get_type (void)
{
	return noise_plugins_audio_player_library_type_id;
}


GType
noise_plugins_audio_player_library_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NoisePluginsAudioPlayerLibraryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_plugins_audio_player_library_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePluginsAudioPlayerLibrary), 0, (GInstanceInitFunc) noise_plugins_audio_player_library_instance_init, NULL };
	noise_plugins_audio_player_library_type_id = g_type_module_register_type (module, NOISE_TYPE_LIBRARY, "NoisePluginsAudioPlayerLibrary", &g_define_type_info, 0);
	NoisePluginsAudioPlayerLibrary_private_offset = sizeof (NoisePluginsAudioPlayerLibraryPrivate);
	return noise_plugins_audio_player_library_type_id;
}



