/* CDPlayer.c generated by valac 0.41.91, the Vala compiler
 * generated from CDPlayer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gst/gst.h>
#include "music-lib.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <gee.h>
#include <gst/pbutils/pbutils.h>
#include <gtk/gtk.h>


#define NOISE_PLUGINS_TYPE_CD_PLAYER (noise_plugins_cd_player_get_type ())
#define NOISE_PLUGINS_CD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_CD_PLAYER, NoisePluginsCDPlayer))
#define NOISE_PLUGINS_CD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_CD_PLAYER, NoisePluginsCDPlayerClass))
#define NOISE_PLUGINS_IS_CD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_CD_PLAYER))
#define NOISE_PLUGINS_IS_CD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_CD_PLAYER))
#define NOISE_PLUGINS_CD_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_CD_PLAYER, NoisePluginsCDPlayerClass))

typedef struct _NoisePluginsCDPlayer NoisePluginsCDPlayer;
typedef struct _NoisePluginsCDPlayerClass NoisePluginsCDPlayerClass;
typedef struct _NoisePluginsCDPlayerPrivate NoisePluginsCDPlayerPrivate;
enum  {
	NOISE_PLUGINS_CD_PLAYER_0_PROPERTY,
	NOISE_PLUGINS_CD_PLAYER_NUM_PROPERTIES
};
static GParamSpec* noise_plugins_cd_player_properties[NOISE_PLUGINS_CD_PLAYER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))

struct _NoisePluginsCDPlayer {
	GObject parent_instance;
	NoisePluginsCDPlayerPrivate * priv;
	NoisePipeline* pipe;
	GstElement* playbin2;
	gboolean first_start;
};

struct _NoisePluginsCDPlayerClass {
	GObjectClass parent_class;
};

struct _NoisePluginsCDPlayerPrivate {
	NoiseInstallGstreamerPluginsDialog* dialog;
	gchar* device;
	gdouble volume;
};


static gint NoisePluginsCDPlayer_private_offset;
static gpointer noise_plugins_cd_player_parent_class = NULL;
static NoisePlaybackIface * noise_plugins_cd_player_noise_playback_parent_iface = NULL;
static GType noise_plugins_cd_player_type_id = 0;

GType noise_plugins_cd_player_get_type (void) G_GNUC_CONST;
NoisePluginsCDPlayer* noise_plugins_cd_player_new (GMount* mount);
NoisePluginsCDPlayer* noise_plugins_cd_player_construct (GType object_type,
                                                         GMount* mount);
gboolean noise_plugins_cd_player_initialize (NoisePluginsCDPlayer* self);
void noise_plugins_cd_player_pipe_source_setup (NoisePluginsCDPlayer* self,
                                                GstElement* playbin,
                                                GstElement* source);
static void _noise_plugins_cd_player_pipe_source_setup_dynamic_source_setup0_ (GstElement* _sender,
                                                                        GstElement* source,
                                                                        gpointer self);
gulong _dynamic_source_setup1_connect (gpointer obj,
                                       const char * signal_name,
                                       GCallback handler,
                                       gpointer data);
static gboolean noise_plugins_cd_player_bus_callback (NoisePluginsCDPlayer* self,
                                               GstBus* bus,
                                               GstMessage* message);
static gboolean _noise_plugins_cd_player_bus_callback_gst_bus_func (GstBus* bus,
                                                             GstMessage* message,
                                                             gpointer self);
static gboolean _noise_playback_update_position_gsource_func (gpointer self);
static GeeCollection* noise_plugins_cd_player_real_get_supported_uri (NoisePlayback* base);
static gboolean noise_plugins_cd_player_real_update_position (NoisePlayback* base);
static void noise_plugins_cd_player_real_play (NoisePlayback* base);
static void noise_plugins_cd_player_real_pause (NoisePlayback* base);
static void noise_plugins_cd_player_real_set_state (NoisePlayback* base,
                                             GstState s);
static void noise_plugins_cd_player_real_set_media (NoisePlayback* base,
                                             NoiseMedia* media);
static void noise_plugins_cd_player_real_set_position (NoisePlayback* base,
                                                gint64 pos);
static gint64 noise_plugins_cd_player_real_get_position (NoisePlayback* base);
static gint64 noise_plugins_cd_player_real_get_duration (NoisePlayback* base);
static void noise_plugins_cd_player_real_set_volume (NoisePlayback* base,
                                              gdouble val);
static gdouble noise_plugins_cd_player_real_get_volume (NoisePlayback* base);
static void noise_plugins_cd_player_real_enable_equalizer (NoisePlayback* base);
static void noise_plugins_cd_player_real_disable_equalizer (NoisePlayback* base);
static void noise_plugins_cd_player_real_set_equalizer_gain (NoisePlayback* base,
                                                      gint index,
                                                      gint val);
static void noise_plugins_cd_player_finalize (GObject * obj);


static inline gpointer
noise_plugins_cd_player_get_instance_private (NoisePluginsCDPlayer* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePluginsCDPlayer_private_offset);
}


NoisePluginsCDPlayer*
noise_plugins_cd_player_construct (GType object_type,
                                   GMount* mount)
{
	NoisePluginsCDPlayer * self = NULL;
	GVolume* _tmp0_;
	GVolume* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (mount != NULL, NULL);
	self = (NoisePluginsCDPlayer*) g_object_new (object_type, NULL);
	_tmp0_ = g_mount_get_volume (mount);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_volume_get_identifier (_tmp1_, G_VOLUME_IDENTIFIER_KIND_UNIX_DEVICE);
	_g_free0 (self->priv->device);
	self->priv->device = _tmp2_;
	_g_object_unref0 (_tmp1_);
	noise_plugins_cd_player_initialize (self);
	return self;
}


NoisePluginsCDPlayer*
noise_plugins_cd_player_new (GMount* mount)
{
	return noise_plugins_cd_player_construct (NOISE_PLUGINS_TYPE_CD_PLAYER, mount);
}


static void
_noise_plugins_cd_player_pipe_source_setup_dynamic_source_setup0_ (GstElement* _sender,
                                                                   GstElement* source,
                                                                   gpointer self)
{
	noise_plugins_cd_player_pipe_source_setup ((NoisePluginsCDPlayer*) self, _sender, source);
}


gulong
_dynamic_source_setup1_connect (gpointer obj,
                                const char * signal_name,
                                GCallback handler,
                                gpointer data)
{
	return g_signal_connect_object (obj, signal_name, handler, data, 0);
}


static gboolean
_noise_plugins_cd_player_bus_callback_gst_bus_func (GstBus* bus,
                                                    GstMessage* message,
                                                    gpointer self)
{
	gboolean result;
	result = noise_plugins_cd_player_bus_callback ((NoisePluginsCDPlayer*) self, bus, message);
	return result;
}


static gboolean
_noise_playback_update_position_gsource_func (gpointer self)
{
	gboolean result;
	result = noise_playback_update_position ((NoisePlayback*) self);
	return result;
}


gboolean
noise_plugins_cd_player_initialize (NoisePluginsCDPlayer* self)
{
	gboolean result = FALSE;
	NoisePipeline* _tmp0_;
	NoisePipeline* _tmp1_;
	GstElement* _tmp2_;
	GstElement* _tmp3_;
	NoisePipeline* _tmp4_;
	GstElement* _tmp5_;
	NoisePipeline* _tmp6_;
	GstBus* _tmp7_;
	NoisePipeline* _tmp8_;
	GstBus* _tmp9_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = noise_pipeline_new ();
	_g_object_unref0 (self->pipe);
	self->pipe = _tmp0_;
	_tmp1_ = self->pipe;
	_tmp2_ = _tmp1_->playbin;
	self->playbin2 = _tmp2_;
	_tmp3_ = self->playbin2;
	_dynamic_source_setup1_connect (_tmp3_, "source-setup", (GCallback) _noise_plugins_cd_player_pipe_source_setup_dynamic_source_setup0_, self);
	_tmp4_ = self->pipe;
	_tmp5_ = _tmp4_->playbin;
	g_object_set ((GObject*) _tmp5_, "uri", "cdda://1", NULL);
	_tmp6_ = self->pipe;
	_tmp7_ = _tmp6_->bus;
	gst_bus_add_signal_watch_full (_tmp7_, G_PRIORITY_DEFAULT);
	_tmp8_ = self->pipe;
	_tmp9_ = _tmp8_->bus;
	gst_bus_add_watch_full (_tmp9_, G_PRIORITY_DEFAULT, _noise_plugins_cd_player_bus_callback_gst_bus_func, g_object_ref (self), g_object_unref);
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _noise_playback_update_position_gsource_func, g_object_ref ((NoisePlayback*) self), g_object_unref);
	result = TRUE;
	return result;
}


void
noise_plugins_cd_player_pipe_source_setup (NoisePluginsCDPlayer* self,
                                           GstElement* playbin,
                                           GstElement* source)
{
	const gchar* _tmp0_;
	GObjectClass* _tmp1_;
	GParamSpec* _tmp2_;
	GObjectClass* _tmp3_;
	GParamSpec* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (playbin != NULL);
	g_return_if_fail (source != NULL);
	_tmp0_ = self->priv->device;
	g_object_set ((GObject*) source, "device", _tmp0_, NULL);
	_tmp1_ = G_OBJECT_GET_CLASS ((GObject*) source);
	_tmp2_ = g_object_class_find_property (_tmp1_, "paranoia-mode");
	if (_tmp2_ != NULL) {
		g_object_set ((GObject*) source, "paranoia-mode", 0, NULL);
	}
	_tmp3_ = G_OBJECT_GET_CLASS ((GObject*) source);
	_tmp4_ = g_object_class_find_property (_tmp3_, "read-speed");
	if (_tmp4_ != NULL) {
		g_object_set ((GObject*) source, "read-speed", 2, NULL);
	}
}


static GeeCollection*
noise_plugins_cd_player_real_get_supported_uri (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	GeeCollection* result = NULL;
	GeeLinkedList* uris = NULL;
	GeeLinkedList* _tmp0_;
	self = (NoisePluginsCDPlayer*) base;
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	uris = _tmp0_;
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "cdda://");
	result = (GeeCollection*) uris;
	return result;
}


static gboolean
noise_plugins_cd_player_real_update_position (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	self = (NoisePluginsCDPlayer*) base;
	_tmp1_ = self->first_start;
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_ = FALSE;
		NoisePlaybackManager* _tmp3_;
		NoisePlaybackManager* _tmp4_;
		NoiseMedia* _tmp5_;
		NoiseMedia* _tmp6_;
		_tmp3_ = noise_app_get_player ();
		_tmp4_ = _tmp3_;
		_tmp5_ = noise_playback_manager_get_current_media (_tmp4_);
		_tmp6_ = _tmp5_;
		if (_tmp6_ != NULL) {
			NoisePlaybackManager* _tmp7_;
			NoisePlaybackManager* _tmp8_;
			NoiseMedia* _tmp9_;
			NoiseMedia* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			_tmp7_ = noise_app_get_player ();
			_tmp8_ = _tmp7_;
			_tmp9_ = noise_playback_manager_get_current_media (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = noise_media_get_resume_pos (_tmp10_);
			_tmp12_ = _tmp11_;
			_tmp2_ = noise_playback_get_position ((NoisePlayback*) self) >= (((gint64) (_tmp12_ - 1)) * 1000000000);
		} else {
			_tmp2_ = FALSE;
		}
		_tmp0_ = _tmp2_;
	}
	if (_tmp0_) {
		self->first_start = FALSE;
		g_signal_emit_by_name ((NoisePlayback*) self, "current-position-update", noise_playback_get_position ((NoisePlayback*) self));
	} else {
		NoisePlaybackManager* _tmp13_;
		NoisePlaybackManager* _tmp14_;
		NoiseMedia* _tmp15_;
		NoiseMedia* _tmp16_;
		_tmp13_ = noise_app_get_player ();
		_tmp14_ = _tmp13_;
		_tmp15_ = noise_playback_manager_get_current_media (_tmp14_);
		_tmp16_ = _tmp15_;
		if (_tmp16_ != NULL) {
			NoisePipeline* _tmp17_;
			GstElement* _tmp18_;
			NoisePlaybackManager* _tmp19_;
			NoisePlaybackManager* _tmp20_;
			NoiseMedia* _tmp21_;
			NoiseMedia* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			_tmp17_ = self->pipe;
			_tmp18_ = _tmp17_->playbin;
			_tmp19_ = noise_app_get_player ();
			_tmp20_ = _tmp19_;
			_tmp21_ = noise_playback_manager_get_current_media (_tmp20_);
			_tmp22_ = _tmp21_;
			_tmp23_ = noise_media_get_resume_pos (_tmp22_);
			_tmp24_ = _tmp23_;
			gst_element_seek_simple (_tmp18_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp24_) * 1000000000);
		}
	}
	result = TRUE;
	return result;
}


static void
noise_plugins_cd_player_real_play (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	self = (NoisePluginsCDPlayer*) base;
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_PLAYING);
}


static void
noise_plugins_cd_player_real_pause (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	self = (NoisePluginsCDPlayer*) base;
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_PAUSED);
}


static void
noise_plugins_cd_player_real_set_state (NoisePlayback* base,
                                        GstState s)
{
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	self = (NoisePluginsCDPlayer*) base;
	_tmp0_ = self->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_set_state (_tmp1_, s);
}


static void
noise_plugins_cd_player_real_set_media (NoisePlayback* base,
                                        NoiseMedia* media)
{
	NoisePluginsCDPlayer * self;
	guint _tmp0_;
	guint _tmp1_;
	NoisePipeline* _tmp2_;
	GstElement* _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	NoisePlaybackManager* _tmp8_;
	NoisePlaybackManager* _tmp9_;
	NoiseMedia* _tmp10_;
	NoiseMedia* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	NoisePipeline* _tmp14_;
	GstElement* _tmp15_;
	NoisePlaybackManager* _tmp16_;
	NoisePlaybackManager* _tmp17_;
	NoiseMedia* _tmp18_;
	NoiseMedia* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	self = (NoisePluginsCDPlayer*) base;
	g_return_if_fail (media != NULL);
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_READY);
	_tmp0_ = noise_media_get_track (media);
	_tmp1_ = _tmp0_;
	g_debug ("CDPlayer.vala:103: set track number to %u\n", _tmp1_);
	_tmp2_ = self->pipe;
	_tmp3_ = _tmp2_->playbin;
	_tmp4_ = noise_media_get_track (media);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strdup_printf ("cdda://%u", _tmp5_);
	_tmp7_ = _tmp6_;
	g_object_set ((GObject*) _tmp3_, "uri", _tmp7_, NULL);
	_g_free0 (_tmp7_);
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_PLAYING);
	_tmp8_ = noise_app_get_player ();
	_tmp9_ = _tmp8_;
	_tmp10_ = noise_playback_manager_get_current_media (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = noise_media_get_resume_pos (_tmp11_);
	_tmp13_ = _tmp12_;
	g_debug ("CDPlayer.vala:108: setURI seeking to %d\n", _tmp13_);
	_tmp14_ = self->pipe;
	_tmp15_ = _tmp14_->playbin;
	_tmp16_ = noise_app_get_player ();
	_tmp17_ = _tmp16_;
	_tmp18_ = noise_playback_manager_get_current_media (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = noise_media_get_resume_pos (_tmp19_);
	_tmp21_ = _tmp20_;
	gst_element_seek_simple (_tmp15_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp21_) * 1000000000);
	noise_playback_play ((NoisePlayback*) self);
}


static void
noise_plugins_cd_player_real_set_position (NoisePlayback* base,
                                           gint64 pos)
{
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	self = (NoisePluginsCDPlayer*) base;
	_tmp0_ = self->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_seek (_tmp1_, 1.0, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, GST_SEEK_TYPE_SET, pos, GST_SEEK_TYPE_NONE, noise_playback_get_duration ((NoisePlayback*) self));
}


static gint64
noise_plugins_cd_player_real_get_position (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	gint64 result = 0LL;
	gint64 rv = 0LL;
	GstFormat f = 0;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
	self = (NoisePluginsCDPlayer*) base;
	rv = (gint64) 0;
	f = GST_FORMAT_TIME;
	_tmp0_ = self->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_query_position (_tmp1_, f, &_tmp2_);
	rv = _tmp2_;
	result = rv;
	return result;
}


static gint64
noise_plugins_cd_player_real_get_duration (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	gint64 result = 0LL;
	gint64 rv = 0LL;
	GstFormat f = 0;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
	self = (NoisePluginsCDPlayer*) base;
	rv = (gint64) 0;
	f = GST_FORMAT_TIME;
	_tmp0_ = self->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_query_duration (_tmp1_, f, &_tmp2_);
	rv = _tmp2_;
	result = rv;
	return result;
}


static void
noise_plugins_cd_player_real_set_volume (NoisePlayback* base,
                                         gdouble val)
{
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	self = (NoisePluginsCDPlayer*) base;
	_tmp0_ = self->pipe;
	_tmp1_ = _tmp0_->playbin;
	g_object_set ((GObject*) _tmp1_, "volume", val, NULL);
	self->priv->volume = val;
}


static gdouble
noise_plugins_cd_player_real_get_volume (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	gdouble result = 0.0;
	gdouble _tmp0_;
	self = (NoisePluginsCDPlayer*) base;
	_tmp0_ = self->priv->volume;
	result = _tmp0_;
	return result;
}


static void
noise_plugins_cd_player_real_enable_equalizer (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
	self = (NoisePluginsCDPlayer*) base;
	_tmp0_ = self->pipe;
	noise_pipeline_enableEqualizer (_tmp0_);
}


static void
noise_plugins_cd_player_real_disable_equalizer (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
	self = (NoisePluginsCDPlayer*) base;
	_tmp0_ = self->pipe;
	noise_pipeline_disableEqualizer (_tmp0_);
}


static void
noise_plugins_cd_player_real_set_equalizer_gain (NoisePlayback* base,
                                                 gint index,
                                                 gint val)
{
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
	NoiseEqualizer* _tmp1_;
	self = (NoisePluginsCDPlayer*) base;
	_tmp0_ = self->pipe;
	_tmp1_ = _tmp0_->eq;
	noise_equalizer_setGain (_tmp1_, index, (gdouble) val);
}


static gboolean
noise_plugins_cd_player_bus_callback (NoisePluginsCDPlayer* self,
                                      GstBus* bus,
                                      GstMessage* message)
{
	gboolean result = FALSE;
	GstMessageType _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (bus != NULL, FALSE);
	g_return_val_if_fail (message != NULL, FALSE);
	_tmp0_ = message->type;
	switch (_tmp0_) {
		case GST_MESSAGE_ERROR:
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GError* _tmp1_ = NULL;
			gchar* _tmp2_ = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
			gst_message_parse_error (message, &_tmp1_, &_tmp2_);
			_g_error_free0 (err);
			err = _tmp1_;
			_g_free0 (debug);
			debug = _tmp2_;
			_tmp3_ = err;
			_tmp4_ = _tmp3_->message;
			g_warning ("CDPlayer.vala:171: Error: %s\n", _tmp4_);
			g_signal_emit_by_name ((NoisePlayback*) self, "error-occured");
			_g_free0 (debug);
			_g_error_free0 (err);
			break;
		}
		case GST_MESSAGE_ELEMENT:
		{
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_ = FALSE;
			GstStructure* _tmp7_;
			_tmp7_ = gst_message_get_structure (message);
			if (_tmp7_ != NULL) {
				_tmp6_ = gst_is_missing_plugin_message (message);
			} else {
				_tmp6_ = FALSE;
			}
			if (_tmp6_) {
				gboolean _tmp8_ = FALSE;
				NoiseInstallGstreamerPluginsDialog* _tmp9_;
				_tmp9_ = self->priv->dialog;
				if (_tmp9_ == NULL) {
					_tmp8_ = TRUE;
				} else {
					NoiseInstallGstreamerPluginsDialog* _tmp10_;
					gboolean _tmp11_;
					gboolean _tmp12_;
					_tmp10_ = self->priv->dialog;
					_tmp11_ = gtk_widget_get_visible ((GtkWidget*) _tmp10_);
					_tmp12_ = _tmp11_;
					_tmp8_ = !_tmp12_;
				}
				_tmp5_ = _tmp8_;
			} else {
				_tmp5_ = FALSE;
			}
			if (_tmp5_) {
				NoiseInstallGstreamerPluginsDialog* _tmp13_;
				_tmp13_ = noise_install_gstreamer_plugins_dialog_new (message);
				g_object_ref_sink (_tmp13_);
				_g_object_unref0 (self->priv->dialog);
				self->priv->dialog = _tmp13_;
			}
			break;
		}
		case GST_MESSAGE_EOS:
		{
			g_signal_emit_by_name ((NoisePlayback*) self, "end-of-stream");
			break;
		}
		case GST_MESSAGE_STATE_CHANGED:
		{
			GstState oldstate = 0;
			GstState newstate = 0;
			GstState pending = 0;
			GstState _tmp14_ = 0;
			GstState _tmp15_ = 0;
			GstState _tmp16_ = 0;
			GstState _tmp17_;
			gst_message_parse_state_changed (message, &_tmp14_, &_tmp15_, &_tmp16_);
			oldstate = _tmp14_;
			newstate = _tmp15_;
			pending = _tmp16_;
			_tmp17_ = newstate;
			if (_tmp17_ != GST_STATE_PLAYING) {
				break;
			}
			break;
		}
		case GST_MESSAGE_TAG:
		{
			GstTagList* tag_list = NULL;
			GstTagList* _tmp18_ = NULL;
			GstTagList* _tmp19_;
			gst_message_parse_tag (message, &_tmp18_);
			_gst_tag_list_unref0 (tag_list);
			tag_list = _tmp18_;
			_tmp19_ = tag_list;
			if (_tmp19_ != NULL) {
				GstTagList* _tmp20_;
				_tmp20_ = tag_list;
				if (gst_tag_list_get_tag_size (_tmp20_, GST_TAG_TITLE) > ((guint) 0)) {
					gchar* title = NULL;
					gchar* _tmp21_;
					GstTagList* _tmp22_;
					gchar* _tmp23_ = NULL;
					NoiseNotificationManager* _tmp24_;
					NoiseNotificationManager* _tmp25_;
					NoisePlaybackManager* _tmp26_;
					NoisePlaybackManager* _tmp27_;
					NoiseMedia* _tmp28_;
					NoiseMedia* _tmp29_;
					const gchar* _tmp30_;
					const gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					const gchar* _tmp34_;
					gchar* _tmp35_;
					gchar* _tmp36_;
					_tmp21_ = g_strdup ("");
					title = _tmp21_;
					_tmp22_ = tag_list;
					gst_tag_list_get_string (_tmp22_, GST_TAG_TITLE, &_tmp23_);
					_g_free0 (title);
					title = _tmp23_;
					_tmp24_ = noise_notification_manager_get_default ();
					_tmp25_ = _tmp24_;
					_tmp26_ = noise_app_get_player ();
					_tmp27_ = _tmp26_;
					_tmp28_ = noise_playback_manager_get_current_media (_tmp27_);
					_tmp29_ = _tmp28_;
					_tmp30_ = noise_media_get_album_artist (_tmp29_);
					_tmp31_ = _tmp30_;
					_tmp32_ = g_strconcat (_tmp31_, "\n", NULL);
					_tmp33_ = _tmp32_;
					_tmp34_ = title;
					_tmp35_ = g_strconcat (_tmp33_, _tmp34_, NULL);
					_tmp36_ = _tmp35_;
					g_signal_emit_by_name (_tmp25_, "update-track", _tmp36_);
					_g_free0 (_tmp36_);
					_g_free0 (_tmp33_);
					_g_object_unref0 (_tmp25_);
					_g_free0 (title);
				}
			}
			_gst_tag_list_unref0 (tag_list);
			break;
		}
		default:
		{
			break;
		}
	}
	result = TRUE;
	return result;
}


static void
noise_plugins_cd_player_class_init (NoisePluginsCDPlayerClass * klass)
{
	noise_plugins_cd_player_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoisePluginsCDPlayer_private_offset);
	G_OBJECT_CLASS (klass)->finalize = noise_plugins_cd_player_finalize;
}


static void
noise_plugins_cd_player_noise_playback_interface_init (NoisePlaybackIface * iface)
{
	noise_plugins_cd_player_noise_playback_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_supported_uri = (GeeCollection* (*) (NoisePlayback *)) noise_plugins_cd_player_real_get_supported_uri;
	iface->update_position = (gboolean (*) (NoisePlayback *)) noise_plugins_cd_player_real_update_position;
	iface->play = (void (*) (NoisePlayback *)) noise_plugins_cd_player_real_play;
	iface->pause = (void (*) (NoisePlayback *)) noise_plugins_cd_player_real_pause;
	iface->set_state = (void (*) (NoisePlayback *, GstState)) noise_plugins_cd_player_real_set_state;
	iface->set_media = (void (*) (NoisePlayback *, NoiseMedia*)) noise_plugins_cd_player_real_set_media;
	iface->set_position = (void (*) (NoisePlayback *, gint64)) noise_plugins_cd_player_real_set_position;
	iface->get_position = (gint64 (*) (NoisePlayback *)) noise_plugins_cd_player_real_get_position;
	iface->get_duration = (gint64 (*) (NoisePlayback *)) noise_plugins_cd_player_real_get_duration;
	iface->set_volume = (void (*) (NoisePlayback *, gdouble)) noise_plugins_cd_player_real_set_volume;
	iface->get_volume = (gdouble (*) (NoisePlayback *)) noise_plugins_cd_player_real_get_volume;
	iface->enable_equalizer = (void (*) (NoisePlayback *)) noise_plugins_cd_player_real_enable_equalizer;
	iface->disable_equalizer = (void (*) (NoisePlayback *)) noise_plugins_cd_player_real_disable_equalizer;
	iface->set_equalizer_gain = (void (*) (NoisePlayback *, gint, gint)) noise_plugins_cd_player_real_set_equalizer_gain;
}


static void
noise_plugins_cd_player_instance_init (NoisePluginsCDPlayer * self)
{
	self->priv = noise_plugins_cd_player_get_instance_private (self);
	self->first_start = TRUE;
	self->priv->volume = (gdouble) 1;
}


static void
noise_plugins_cd_player_finalize (GObject * obj)
{
	NoisePluginsCDPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_PLUGINS_TYPE_CD_PLAYER, NoisePluginsCDPlayer);
	_g_object_unref0 (self->priv->dialog);
	_g_free0 (self->priv->device);
	_g_object_unref0 (self->pipe);
	G_OBJECT_CLASS (noise_plugins_cd_player_parent_class)->finalize (obj);
}


GType
noise_plugins_cd_player_get_type (void)
{
	return noise_plugins_cd_player_type_id;
}


GType
noise_plugins_cd_player_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NoisePluginsCDPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_plugins_cd_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePluginsCDPlayer), 0, (GInstanceInitFunc) noise_plugins_cd_player_instance_init, NULL };
	static const GInterfaceInfo noise_playback_info = { (GInterfaceInitFunc) noise_plugins_cd_player_noise_playback_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	noise_plugins_cd_player_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "NoisePluginsCDPlayer", &g_define_type_info, 0);
	g_type_module_add_interface (module, noise_plugins_cd_player_type_id, NOISE_TYPE_PLAYBACK, &noise_playback_info);
	NoisePluginsCDPlayer_private_offset = sizeof (NoisePluginsCDPlayerPrivate);
	return noise_plugins_cd_player_type_id;
}



