/* SimilarMediaView.c generated by valac 0.41.91, the Vala compiler
 * generated from SimilarMediaView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>,
 *              Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>


#define NOISE_TYPE_SIMILAR_MEDIAS_VIEW (noise_similar_medias_view_get_type ())
#define NOISE_SIMILAR_MEDIAS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SIMILAR_MEDIAS_VIEW, NoiseSimilarMediasView))
#define NOISE_SIMILAR_MEDIAS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SIMILAR_MEDIAS_VIEW, NoiseSimilarMediasViewClass))
#define NOISE_IS_SIMILAR_MEDIAS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SIMILAR_MEDIAS_VIEW))
#define NOISE_IS_SIMILAR_MEDIAS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SIMILAR_MEDIAS_VIEW))
#define NOISE_SIMILAR_MEDIAS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SIMILAR_MEDIAS_VIEW, NoiseSimilarMediasViewClass))

typedef struct _NoiseSimilarMediasView NoiseSimilarMediasView;
typedef struct _NoiseSimilarMediasViewClass NoiseSimilarMediasViewClass;
typedef struct _NoiseSimilarMediasViewPrivate NoiseSimilarMediasViewPrivate;
enum  {
	NOISE_SIMILAR_MEDIAS_VIEW_0_PROPERTY,
	NOISE_SIMILAR_MEDIAS_VIEW_NUM_PROPERTIES
};
static GParamSpec* noise_similar_medias_view_properties[NOISE_SIMILAR_MEDIAS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NoiseSimilarMediasView {
	GtkTreeView parent_instance;
	NoiseSimilarMediasViewPrivate * priv;
};

struct _NoiseSimilarMediasViewClass {
	GtkTreeViewClass parent_class;
	void (*viewDoubleClick) (NoiseSimilarMediasView* self, GtkTreePath* path, GtkTreeViewColumn* column);
};

struct _NoiseSimilarMediasViewPrivate {
	GtkListStore* model;
	GeeLinkedList* medias;
	GeeLinkedList* urlsToOpen;
};


static gint NoiseSimilarMediasView_private_offset;
static gpointer noise_similar_medias_view_parent_class = NULL;
static GType noise_similar_medias_view_type_id = 0;

GType noise_similar_medias_view_get_type (void) G_GNUC_CONST;
NoiseSimilarMediasView* noise_similar_medias_view_new (void);
NoiseSimilarMediasView* noise_similar_medias_view_construct (GType object_type);
void noise_similar_medias_view_viewDoubleClick (NoiseSimilarMediasView* self,
                                                GtkTreePath* path,
                                                GtkTreeViewColumn* column);
static void _noise_similar_medias_view_viewDoubleClick_gtk_tree_view_row_activated (GtkTreeView* _sender,
                                                                             GtkTreePath* path,
                                                                             GtkTreeViewColumn* column,
                                                                             gpointer self);
void noise_similar_medias_view_populateView (NoiseSimilarMediasView* self,
                                             GeeCollection* nMedias);
static void noise_similar_medias_view_real_viewDoubleClick (NoiseSimilarMediasView* self,
                                                     GtkTreePath* path,
                                                     GtkTreeViewColumn* column);
void* noise_similar_medias_view_take_action (NoiseSimilarMediasView* self);
static gpointer _noise_similar_medias_view_take_action_gthread_func (gpointer self);
static void noise_similar_medias_view_finalize (GObject * obj);


static inline gpointer
noise_similar_medias_view_get_instance_private (NoiseSimilarMediasView* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseSimilarMediasView_private_offset);
}


static void
_noise_similar_medias_view_viewDoubleClick_gtk_tree_view_row_activated (GtkTreeView* _sender,
                                                                        GtkTreePath* path,
                                                                        GtkTreeViewColumn* column,
                                                                        gpointer self)
{
	noise_similar_medias_view_viewDoubleClick ((NoiseSimilarMediasView*) self, path, column);
}


NoiseSimilarMediasView*
noise_similar_medias_view_construct (GType object_type)
{
	NoiseSimilarMediasView * self = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	GtkListStore* _tmp2_;
	GtkTreeViewColumn* col = NULL;
	GtkTreeViewColumn* _tmp3_;
	GtkCellRendererText* text_renderer = NULL;
	GtkCellRendererText* _tmp4_;
	GtkTreeViewColumn* _tmp5_;
	GtkListStore* _tmp6_;
	self = (NoiseSimilarMediasView*) g_object_new (object_type, NULL);
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->medias);
	self->priv->medias = _tmp0_;
	_tmp1_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->urlsToOpen);
	self->priv->urlsToOpen = _tmp1_;
	_tmp2_ = gtk_list_store_new (2, NOISE_TYPE_MEDIA, G_TYPE_STRING, -1);
	_g_object_unref0 (self->priv->model);
	self->priv->model = _tmp2_;
	_tmp3_ = gtk_tree_view_column_new ();
	g_object_ref_sink (_tmp3_);
	col = _tmp3_;
	gtk_tree_view_column_set_title (col, _ ("media"));
	gtk_tree_view_column_set_visible (col, FALSE);
	gtk_tree_view_insert_column ((GtkTreeView*) self, col, 0);
	_tmp4_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp4_);
	text_renderer = _tmp4_;
	g_object_set (text_renderer, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
	gtk_tree_view_insert_column_with_attributes ((GtkTreeView*) self, -1, _ ("Similar Media"), (GtkCellRenderer*) text_renderer, "markup", 1, NULL, NULL);
	_tmp5_ = gtk_tree_view_get_column ((GtkTreeView*) self, 1);
	gtk_tree_view_column_set_alignment (_tmp5_, (gfloat) 0.5);
	_tmp6_ = self->priv->model;
	gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp6_);
	g_signal_connect_object ((GtkTreeView*) self, "row-activated", (GCallback) _noise_similar_medias_view_viewDoubleClick_gtk_tree_view_row_activated, self, 0);
	_g_object_unref0 (text_renderer);
	_g_object_unref0 (col);
	return self;
}


NoiseSimilarMediasView*
noise_similar_medias_view_new (void)
{
	return noise_similar_medias_view_construct (NOISE_TYPE_SIMILAR_MEDIAS_VIEW);
}


void
noise_similar_medias_view_populateView (NoiseSimilarMediasView* self,
                                        GeeCollection* nMedias)
{
	GeeLinkedList* _tmp0_;
	GtkListStore* _tmp1_;
	gint count = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (nMedias != NULL);
	_tmp0_ = self->priv->medias;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	_tmp1_ = self->priv->model;
	gtk_list_store_clear (_tmp1_);
	count = 0;
	{
		GeeIterator* _s_it = NULL;
		GeeIterator* _tmp2_;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) nMedias);
		_s_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			NoiseMedia* s = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GeeLinkedList* _tmp6_;
			NoiseMedia* _tmp7_;
			GtkTreeIter iter = {0};
			GtkListStore* _tmp8_;
			GtkTreeIter _tmp9_ = {0};
			gchar* title_fixed = NULL;
			NoiseMedia* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* artist_fixed = NULL;
			NoiseMedia* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			GtkListStore* _tmp18_;
			GtkTreeIter _tmp19_;
			NoiseMedia* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
			_tmp3_ = _s_it;
			if (!gee_iterator_next (_tmp3_)) {
				break;
			}
			_tmp4_ = _s_it;
			_tmp5_ = gee_iterator_get (_tmp4_);
			s = (NoiseMedia*) _tmp5_;
			_tmp6_ = self->priv->medias;
			_tmp7_ = s;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp7_);
			_tmp8_ = self->priv->model;
			gtk_list_store_append (_tmp8_, &_tmp9_);
			iter = _tmp9_;
			_tmp10_ = s;
			_tmp11_ = noise_media_get_title (_tmp10_);
			_tmp12_ = _tmp11_;
			_tmp13_ = g_markup_escape_text (_tmp12_, (gssize) -1);
			title_fixed = _tmp13_;
			_tmp14_ = s;
			_tmp15_ = noise_media_get_artist (_tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = g_markup_escape_text (_tmp16_, (gssize) -1);
			artist_fixed = _tmp17_;
			_tmp18_ = self->priv->model;
			_tmp19_ = iter;
			_tmp20_ = s;
			_tmp21_ = title_fixed;
			_tmp22_ = artist_fixed;
			_tmp23_ = g_strdup_printf ("<b>%s</b>\n%s", _tmp21_, _tmp22_);
			_tmp24_ = _tmp23_;
			gtk_list_store_set (_tmp18_, &_tmp19_, 0, _tmp20_, 1, _tmp24_, -1);
			_g_free0 (_tmp24_);
			_tmp25_ = count;
			count = _tmp25_ + 1;
			_tmp26_ = count;
			if (_tmp26_ >= 16) {
				_g_free0 (artist_fixed);
				_g_free0 (title_fixed);
				_g_object_unref0 (s);
				_g_object_unref0 (_s_it);
				return;
			}
			_g_free0 (artist_fixed);
			_g_free0 (title_fixed);
			_g_object_unref0 (s);
		}
		_g_object_unref0 (_s_it);
	}
}


static gpointer
_noise_similar_medias_view_take_action_gthread_func (gpointer self)
{
	gpointer result;
	result = noise_similar_medias_view_take_action ((NoiseSimilarMediasView*) self);
	g_object_unref (self);
	return result;
}


static void
noise_similar_medias_view_real_viewDoubleClick (NoiseSimilarMediasView* self,
                                                GtkTreePath* path,
                                                GtkTreeViewColumn* column)
{
	GError * _inner_error_ = NULL;
	g_return_if_fail (path != NULL);
	g_return_if_fail (column != NULL);
	{
		GThread* _tmp0_;
		GThread* _tmp1_;
		_tmp0_ = g_thread_try_new (NULL, _noise_similar_medias_view_take_action_gthread_func, g_object_ref (self), &_inner_error_);
		_tmp1_ = _tmp0_;
		_g_thread_unref0 (_tmp1_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = err;
		_tmp3_ = _tmp2_->message;
		g_warning ("SimilarMediaView.vala:85: ERROR: Could not create thread to have fun: " \
"%s", _tmp3_);
		_g_error_free0 (err);
	}
	__finally4:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void
noise_similar_medias_view_viewDoubleClick (NoiseSimilarMediasView* self,
                                           GtkTreePath* path,
                                           GtkTreeViewColumn* column)
{
	g_return_if_fail (self != NULL);
	NOISE_SIMILAR_MEDIAS_VIEW_GET_CLASS (self)->viewDoubleClick (self, path, column);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void*
noise_similar_medias_view_take_action (NoiseSimilarMediasView* self)
{
	void* result = NULL;
	GtkTreeIter iter = {0};
	GtkTreeModel* mo = NULL;
	NoiseMedia* s = NULL;
	GtkTreeSelection* _tmp0_;
	GtkTreeModel* _tmp1_ = NULL;
	GtkTreeIter _tmp2_ = {0};
	GtkTreeModel* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeIter _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	NoiseMedia* _tmp8_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
	gtk_tree_selection_get_selected (_tmp0_, &_tmp1_, &_tmp2_);
	_g_object_unref0 (mo);
	_tmp3_ = _g_object_ref0 (_tmp1_);
	mo = _tmp3_;
	iter = _tmp2_;
	_tmp4_ = mo;
	_tmp5_ = iter;
	gtk_tree_model_get (_tmp4_, &_tmp5_, 0, &s, -1);
	_tmp8_ = s;
	if (_tmp8_ != NULL) {
		NoiseMedia* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		_tmp9_ = s;
		_tmp10_ = noise_media_get_comment (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp7_ = _tmp11_ != NULL;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		NoiseMedia* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		_tmp12_ = s;
		_tmp13_ = noise_media_get_comment (_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp6_ = g_strcmp0 (_tmp14_, "") != 0;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		{
			NoiseMedia* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			_tmp15_ = s;
			_tmp16_ = noise_media_get_comment (_tmp15_);
			_tmp17_ = _tmp16_;
			g_app_info_launch_default_for_uri (_tmp17_, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch5_g_error;
			}
		}
		goto __finally5;
		__catch5_g_error:
		{
			GError* err = NULL;
			GError* _tmp18_;
			const gchar* _tmp19_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp18_ = err;
			_tmp19_ = _tmp18_->message;
			g_message ("SimilarMediaView.vala:102: Couldn't open the similar media's last fm p" \
"age: %s", _tmp19_);
			_g_error_free0 (err);
		}
		__finally5:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (s);
			_g_object_unref0 (mo);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = NULL;
	_g_object_unref0 (s);
	_g_object_unref0 (mo);
	return result;
}


static void
noise_similar_medias_view_class_init (NoiseSimilarMediasViewClass * klass)
{
	noise_similar_medias_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseSimilarMediasView_private_offset);
	((NoiseSimilarMediasViewClass *) klass)->viewDoubleClick = (void (*) (NoiseSimilarMediasView *, GtkTreePath*, GtkTreeViewColumn*)) noise_similar_medias_view_real_viewDoubleClick;
	G_OBJECT_CLASS (klass)->finalize = noise_similar_medias_view_finalize;
}


static void
noise_similar_medias_view_instance_init (NoiseSimilarMediasView * self)
{
	self->priv = noise_similar_medias_view_get_instance_private (self);
}


static void
noise_similar_medias_view_finalize (GObject * obj)
{
	NoiseSimilarMediasView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SIMILAR_MEDIAS_VIEW, NoiseSimilarMediasView);
	_g_object_unref0 (self->priv->model);
	_g_object_unref0 (self->priv->medias);
	_g_object_unref0 (self->priv->urlsToOpen);
	G_OBJECT_CLASS (noise_similar_medias_view_parent_class)->finalize (obj);
}


GType
noise_similar_medias_view_get_type (void)
{
	return noise_similar_medias_view_type_id;
}


GType
noise_similar_medias_view_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NoiseSimilarMediasViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_similar_medias_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSimilarMediasView), 0, (GInstanceInitFunc) noise_similar_medias_view_instance_init, NULL };
	noise_similar_medias_view_type_id = g_type_module_register_type (module, gtk_tree_view_get_type (), "NoiseSimilarMediasView", &g_define_type_info, 0);
	NoiseSimilarMediasView_private_offset = sizeof (NoiseSimilarMediasViewPrivate);
	return noise_similar_medias_view_type_id;
}



